/**
 * @fileoverview gl-matrix - High performance matrix and vector operations
 * @author Brandon Jones
 * @author Colin MacKenzie IV
 * @version 2.2.1
 */
/* Copyright (c) 2013, Brandon Jones, Colin MacKenzie IV. All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

  * Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
  * Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */
(function(e){"use strict";var t={};typeof exports=="undefined"?typeof define=="function"&&typeof define.amd=="object"&&define.amd?(t.exports={},define(function(){return t.exports})):t.exports=typeof window!="undefined"?window:e:t.exports=exports,function(e){if(!t)var t=1e-6;if(!n)var n=typeof Float32Array!="undefined"?Float32Array:Array;if(!r)var r=Math.random;var i={};i.setMatrixArrayType=function(e){n=e},typeof e!="undefined"&&(e.glMatrix=i);var s=Math.PI/180;i.toRadian=function(e){return e*s};var o={};o.create=function(){var e=new n(2);return e[0]=0,e[1]=0,e},o.clone=function(e){var t=new n(2);return t[0]=e[0],t[1]=e[1],t},o.fromValues=function(e,t){var r=new n(2);return r[0]=e,r[1]=t,r},o.copy=function(e,t){return e[0]=t[0],e[1]=t[1],e},o.set=function(e,t,n){return e[0]=t,e[1]=n,e},o.add=function(e,t,n){return e[0]=t[0]+n[0],e[1]=t[1]+n[1],e},o.subtract=function(e,t,n){return e[0]=t[0]-n[0],e[1]=t[1]-n[1],e},o.sub=o.subtract,o.multiply=function(e,t,n){return e[0]=t[0]*n[0],e[1]=t[1]*n[1],e},o.mul=o.multiply,o.divide=function(e,t,n){return e[0]=t[0]/n[0],e[1]=t[1]/n[1],e},o.div=o.divide,o.min=function(e,t,n){return e[0]=Math.min(t[0],n[0]),e[1]=Math.min(t[1],n[1]),e},o.max=function(e,t,n){return e[0]=Math.max(t[0],n[0]),e[1]=Math.max(t[1],n[1]),e},o.scale=function(e,t,n){return e[0]=t[0]*n,e[1]=t[1]*n,e},o.scaleAndAdd=function(e,t,n,r){return e[0]=t[0]+n[0]*r,e[1]=t[1]+n[1]*r,e},o.distance=function(e,t){var n=t[0]-e[0],r=t[1]-e[1];return Math.sqrt(n*n+r*r)},o.dist=o.distance,o.squaredDistance=function(e,t){var n=t[0]-e[0],r=t[1]-e[1];return n*n+r*r},o.sqrDist=o.squaredDistance,o.length=function(e){var t=e[0],n=e[1];return Math.sqrt(t*t+n*n)},o.len=o.length,o.squaredLength=function(e){var t=e[0],n=e[1];return t*t+n*n},o.sqrLen=o.squaredLength,o.negate=function(e,t){return e[0]=-t[0],e[1]=-t[1],e},o.normalize=function(e,t){var n=t[0],r=t[1],i=n*n+r*r;return i>0&&(i=1/Math.sqrt(i),e[0]=t[0]*i,e[1]=t[1]*i),e},o.dot=function(e,t){return e[0]*t[0]+e[1]*t[1]},o.cross=function(e,t,n){var r=t[0]*n[1]-t[1]*n[0];return e[0]=e[1]=0,e[2]=r,e},o.lerp=function(e,t,n,r){var i=t[0],s=t[1];return e[0]=i+r*(n[0]-i),e[1]=s+r*(n[1]-s),e},o.random=function(e,t){t=t||1;var n=r()*2*Math.PI;return e[0]=Math.cos(n)*t,e[1]=Math.sin(n)*t,e},o.transformMat2=function(e,t,n){var r=t[0],i=t[1];return e[0]=n[0]*r+n[2]*i,e[1]=n[1]*r+n[3]*i,e},o.transformMat2d=function(e,t,n){var r=t[0],i=t[1];return e[0]=n[0]*r+n[2]*i+n[4],e[1]=n[1]*r+n[3]*i+n[5],e},o.transformMat3=function(e,t,n){var r=t[0],i=t[1];return e[0]=n[0]*r+n[3]*i+n[6],e[1]=n[1]*r+n[4]*i+n[7],e},o.transformMat4=function(e,t,n){var r=t[0],i=t[1];return e[0]=n[0]*r+n[4]*i+n[12],e[1]=n[1]*r+n[5]*i+n[13],e},o.forEach=function(){var e=o.create();return function(t,n,r,i,s,o){var u,a;n||(n=2),r||(r=0),i?a=Math.min(i*n+r,t.length):a=t.length;for(u=r;u<a;u+=n)e[0]=t[u],e[1]=t[u+1],s(e,e,o),t[u]=e[0],t[u+1]=e[1];return t}}(),o.str=function(e){return"vec2("+e[0]+", "+e[1]+")"},typeof e!="undefined"&&(e.vec2=o);var u={};u.create=function(){var e=new n(3);return e[0]=0,e[1]=0,e[2]=0,e},u.clone=function(e){var t=new n(3);return t[0]=e[0],t[1]=e[1],t[2]=e[2],t},u.fromValues=function(e,t,r){var i=new n(3);return i[0]=e,i[1]=t,i[2]=r,i},u.copy=function(e,t){return e[0]=t[0],e[1]=t[1],e[2]=t[2],e},u.set=function(e,t,n,r){return e[0]=t,e[1]=n,e[2]=r,e},u.add=function(e,t,n){return e[0]=t[0]+n[0],e[1]=t[1]+n[1],e[2]=t[2]+n[2],e},u.subtract=function(e,t,n){return e[0]=t[0]-n[0],e[1]=t[1]-n[1],e[2]=t[2]-n[2],e},u.sub=u.subtract,u.multiply=function(e,t,n){return e[0]=t[0]*n[0],e[1]=t[1]*n[1],e[2]=t[2]*n[2],e},u.mul=u.multiply,u.divide=function(e,t,n){return e[0]=t[0]/n[0],e[1]=t[1]/n[1],e[2]=t[2]/n[2],e},u.div=u.divide,u.min=function(e,t,n){return e[0]=Math.min(t[0],n[0]),e[1]=Math.min(t[1],n[1]),e[2]=Math.min(t[2],n[2]),e},u.max=function(e,t,n){return e[0]=Math.max(t[0],n[0]),e[1]=Math.max(t[1],n[1]),e[2]=Math.max(t[2],n[2]),e},u.scale=function(e,t,n){return e[0]=t[0]*n,e[1]=t[1]*n,e[2]=t[2]*n,e},u.scaleAndAdd=function(e,t,n,r){return e[0]=t[0]+n[0]*r,e[1]=t[1]+n[1]*r,e[2]=t[2]+n[2]*r,e},u.distance=function(e,t){var n=t[0]-e[0],r=t[1]-e[1],i=t[2]-e[2];return Math.sqrt(n*n+r*r+i*i)},u.dist=u.distance,u.squaredDistance=function(e,t){var n=t[0]-e[0],r=t[1]-e[1],i=t[2]-e[2];return n*n+r*r+i*i},u.sqrDist=u.squaredDistance,u.length=function(e){var t=e[0],n=e[1],r=e[2];return Math.sqrt(t*t+n*n+r*r)},u.len=u.length,u.squaredLength=function(e){var t=e[0],n=e[1],r=e[2];return t*t+n*n+r*r},u.sqrLen=u.squaredLength,u.negate=function(e,t){return e[0]=-t[0],e[1]=-t[1],e[2]=-t[2],e},u.normalize=function(e,t){var n=t[0],r=t[1],i=t[2],s=n*n+r*r+i*i;return s>0&&(s=1/Math.sqrt(s),e[0]=t[0]*s,e[1]=t[1]*s,e[2]=t[2]*s),e},u.dot=function(e,t){return e[0]*t[0]+e[1]*t[1]+e[2]*t[2]},u.cross=function(e,t,n){var r=t[0],i=t[1],s=t[2],o=n[0],u=n[1],a=n[2];return e[0]=i*a-s*u,e[1]=s*o-r*a,e[2]=r*u-i*o,e},u.lerp=function(e,t,n,r){var i=t[0],s=t[1],o=t[2];return e[0]=i+r*(n[0]-i),e[1]=s+r*(n[1]-s),e[2]=o+r*(n[2]-o),e},u.random=function(e,t){t=t||1;var n=r()*2*Math.PI,i=r()*2-1,s=Math.sqrt(1-i*i)*t;return e[0]=Math.cos(n)*s,e[1]=Math.sin(n)*s,e[2]=i*t,e},u.transformMat4=function(e,t,n){var r=t[0],i=t[1],s=t[2];return e[0]=n[0]*r+n[4]*i+n[8]*s+n[12],e[1]=n[1]*r+n[5]*i+n[9]*s+n[13],e[2]=n[2]*r+n[6]*i+n[10]*s+n[14],e},u.transformMat3=function(e,t,n){var r=t[0],i=t[1],s=t[2];return e[0]=r*n[0]+i*n[3]+s*n[6],e[1]=r*n[1]+i*n[4]+s*n[7],e[2]=r*n[2]+i*n[5]+s*n[8],e},u.transformQuat=function(e,t,n){var r=t[0],i=t[1],s=t[2],o=n[0],u=n[1],a=n[2],f=n[3],l=f*r+u*s-a*i,c=f*i+a*r-o*s,h=f*s+o*i-u*r,p=-o*r-u*i-a*s;return e[0]=l*f+p*-o+c*-a-h*-u,e[1]=c*f+p*-u+h*-o-l*-a,e[2]=h*f+p*-a+l*-u-c*-o,e},u.rotateX=function(e,t,n,r){var i=[],s=[];return i[0]=t[0]-n[0],i[1]=t[1]-n[1],i[2]=t[2]-n[2],s[0]=i[0],s[1]=i[1]*Math.cos(r)-i[2]*Math.sin(r),s[2]=i[1]*Math.sin(r)+i[2]*Math.cos(r),e[0]=s[0]+n[0],e[1]=s[1]+n[1],e[2]=s[2]+n[2],e},u.rotateY=function(e,t,n,r){var i=[],s=[];return i[0]=t[0]-n[0],i[1]=t[1]-n[1],i[2]=t[2]-n[2],s[0]=i[2]*Math.sin(r)+i[0]*Math.cos(r),s[1]=i[1],s[2]=i[2]*Math.cos(r)-i[0]*Math.sin(r),e[0]=s[0]+n[0],e[1]=s[1]+n[1],e[2]=s[2]+n[2],e},u.rotateZ=function(e,t,n,r){var i=[],s=[];return i[0]=t[0]-n[0],i[1]=t[1]-n[1],i[2]=t[2]-n[2],s[0]=i[0]*Math.cos(r)-i[1]*Math.sin(r),s[1]=i[0]*Math.sin(r)+i[1]*Math.cos(r),s[2]=i[2],e[0]=s[0]+n[0],e[1]=s[1]+n[1],e[2]=s[2]+n[2],e},u.forEach=function(){var e=u.create();return function(t,n,r,i,s,o){var u,a;n||(n=3),r||(r=0),i?a=Math.min(i*n+r,t.length):a=t.length;for(u=r;u<a;u+=n)e[0]=t[u],e[1]=t[u+1],e[2]=t[u+2],s(e,e,o),t[u]=e[0],t[u+1]=e[1],t[u+2]=e[2];return t}}(),u.str=function(e){return"vec3("+e[0]+", "+e[1]+", "+e[2]+")"},typeof e!="undefined"&&(e.vec3=u);var a={};a.create=function(){var e=new n(4);return e[0]=0,e[1]=0,e[2]=0,e[3]=0,e},a.clone=function(e){var t=new n(4);return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t},a.fromValues=function(e,t,r,i){var s=new n(4);return s[0]=e,s[1]=t,s[2]=r,s[3]=i,s},a.copy=function(e,t){return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e},a.set=function(e,t,n,r,i){return e[0]=t,e[1]=n,e[2]=r,e[3]=i,e},a.add=function(e,t,n){return e[0]=t[0]+n[0],e[1]=t[1]+n[1],e[2]=t[2]+n[2],e[3]=t[3]+n[3],e},a.subtract=function(e,t,n){return e[0]=t[0]-n[0],e[1]=t[1]-n[1],e[2]=t[2]-n[2],e[3]=t[3]-n[3],e},a.sub=a.subtract,a.multiply=function(e,t,n){return e[0]=t[0]*n[0],e[1]=t[1]*n[1],e[2]=t[2]*n[2],e[3]=t[3]*n[3],e},a.mul=a.multiply,a.divide=function(e,t,n){return e[0]=t[0]/n[0],e[1]=t[1]/n[1],e[2]=t[2]/n[2],e[3]=t[3]/n[3],e},a.div=a.divide,a.min=function(e,t,n){return e[0]=Math.min(t[0],n[0]),e[1]=Math.min(t[1],n[1]),e[2]=Math.min(t[2],n[2]),e[3]=Math.min(t[3],n[3]),e},a.max=function(e,t,n){return e[0]=Math.max(t[0],n[0]),e[1]=Math.max(t[1],n[1]),e[2]=Math.max(t[2],n[2]),e[3]=Math.max(t[3],n[3]),e},a.scale=function(e,t,n){return e[0]=t[0]*n,e[1]=t[1]*n,e[2]=t[2]*n,e[3]=t[3]*n,e},a.scaleAndAdd=function(e,t,n,r){return e[0]=t[0]+n[0]*r,e[1]=t[1]+n[1]*r,e[2]=t[2]+n[2]*r,e[3]=t[3]+n[3]*r,e},a.distance=function(e,t){var n=t[0]-e[0],r=t[1]-e[1],i=t[2]-e[2],s=t[3]-e[3];return Math.sqrt(n*n+r*r+i*i+s*s)},a.dist=a.distance,a.squaredDistance=function(e,t){var n=t[0]-e[0],r=t[1]-e[1],i=t[2]-e[2],s=t[3]-e[3];return n*n+r*r+i*i+s*s},a.sqrDist=a.squaredDistance,a.length=function(e){var t=e[0],n=e[1],r=e[2],i=e[3];return Math.sqrt(t*t+n*n+r*r+i*i)},a.len=a.length,a.squaredLength=function(e){var t=e[0],n=e[1],r=e[2],i=e[3];return t*t+n*n+r*r+i*i},a.sqrLen=a.squaredLength,a.negate=function(e,t){return e[0]=-t[0],e[1]=-t[1],e[2]=-t[2],e[3]=-t[3],e},a.normalize=function(e,t){var n=t[0],r=t[1],i=t[2],s=t[3],o=n*n+r*r+i*i+s*s;return o>0&&(o=1/Math.sqrt(o),e[0]=t[0]*o,e[1]=t[1]*o,e[2]=t[2]*o,e[3]=t[3]*o),e},a.dot=function(e,t){return e[0]*t[0]+e[1]*t[1]+e[2]*t[2]+e[3]*t[3]},a.lerp=function(e,t,n,r){var i=t[0],s=t[1],o=t[2],u=t[3];return e[0]=i+r*(n[0]-i),e[1]=s+r*(n[1]-s),e[2]=o+r*(n[2]-o),e[3]=u+r*(n[3]-u),e},a.random=function(e,t){return t=t||1,e[0]=r(),e[1]=r(),e[2]=r(),e[3]=r(),a.normalize(e,e),a.scale(e,e,t),e},a.transformMat4=function(e,t,n){var r=t[0],i=t[1],s=t[2],o=t[3];return e[0]=n[0]*r+n[4]*i+n[8]*s+n[12]*o,e[1]=n[1]*r+n[5]*i+n[9]*s+n[13]*o,e[2]=n[2]*r+n[6]*i+n[10]*s+n[14]*o,e[3]=n[3]*r+n[7]*i+n[11]*s+n[15]*o,e},a.transformQuat=function(e,t,n){var r=t[0],i=t[1],s=t[2],o=n[0],u=n[1],a=n[2],f=n[3],l=f*r+u*s-a*i,c=f*i+a*r-o*s,h=f*s+o*i-u*r,p=-o*r-u*i-a*s;return e[0]=l*f+p*-o+c*-a-h*-u,e[1]=c*f+p*-u+h*-o-l*-a,e[2]=h*f+p*-a+l*-u-c*-o,e},a.forEach=function(){var e=a.create();return function(t,n,r,i,s,o){var u,a;n||(n=4),r||(r=0),i?a=Math.min(i*n+r,t.length):a=t.length;for(u=r;u<a;u+=n)e[0]=t[u],e[1]=t[u+1],e[2]=t[u+2],e[3]=t[u+3],s(e,e,o),t[u]=e[0],t[u+1]=e[1],t[u+2]=e[2],t[u+3]=e[3];return t}}(),a.str=function(e){return"vec4("+e[0]+", "+e[1]+", "+e[2]+", "+e[3]+")"},typeof e!="undefined"&&(e.vec4=a);var f={};f.create=function(){var e=new n(4);return e[0]=1,e[1]=0,e[2]=0,e[3]=1,e},f.clone=function(e){var t=new n(4);return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t},f.copy=function(e,t){return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e},f.identity=function(e){return e[0]=1,e[1]=0,e[2]=0,e[3]=1,e},f.transpose=function(e,t){if(e===t){var n=t[1];e[1]=t[2],e[2]=n}else e[0]=t[0],e[1]=t[2],e[2]=t[1],e[3]=t[3];return e},f.invert=function(e,t){var n=t[0],r=t[1],i=t[2],s=t[3],o=n*s-i*r;return o?(o=1/o,e[0]=s*o,e[1]=-r*o,e[2]=-i*o,e[3]=n*o,e):null},f.adjoint=function(e,t){var n=t[0];return e[0]=t[3],e[1]=-t[1],e[2]=-t[2],e[3]=n,e},f.determinant=function(e){return e[0]*e[3]-e[2]*e[1]},f.multiply=function(e,t,n){var r=t[0],i=t[1],s=t[2],o=t[3],u=n[0],a=n[1],f=n[2],l=n[3];return e[0]=r*u+s*a,e[1]=i*u+o*a,e[2]=r*f+s*l,e[3]=i*f+o*l,e},f.mul=f.multiply,f.rotate=function(e,t,n){var r=t[0],i=t[1],s=t[2],o=t[3],u=Math.sin(n),a=Math.cos(n);return e[0]=r*a+s*u,e[1]=i*a+o*u,e[2]=r*-u+s*a,e[3]=i*-u+o*a,e},f.scale=function(e,t,n){var r=t[0],i=t[1],s=t[2],o=t[3],u=n[0],a=n[1];return e[0]=r*u,e[1]=i*u,e[2]=s*a,e[3]=o*a,e},f.str=function(e){return"mat2("+e[0]+", "+e[1]+", "+e[2]+", "+e[3]+")"},f.frob=function(e){return Math.sqrt(Math.pow(e[0],2)+Math.pow(e[1],2)+Math.pow(e[2],2)+Math.pow(e[3],2))},f.LDU=function(e,t,n,r){return e[2]=r[2]/r[0],n[0]=r[0],n[1]=r[1],n[3]=r[3]-e[2]*n[1],[e,t,n]},typeof e!="undefined"&&(e.mat2=f);var l={};l.create=function(){var e=new n(6);return e[0]=1,e[1]=0,e[2]=0,e[3]=1,e[4]=0,e[5]=0,e},l.clone=function(e){var t=new n(6);return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t},l.copy=function(e,t){return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e},l.identity=function(e){return e[0]=1,e[1]=0,e[2]=0,e[3]=1,e[4]=0,e[5]=0,e},l.invert=function(e,t){var n=t[0],r=t[1],i=t[2],s=t[3],o=t[4],u=t[5],a=n*s-r*i;return a?(a=1/a,e[0]=s*a,e[1]=-r*a,e[2]=-i*a,e[3]=n*a,e[4]=(i*u-s*o)*a,e[5]=(r*o-n*u)*a,e):null},l.determinant=function(e){return e[0]*e[3]-e[1]*e[2]},l.multiply=function(e,t,n){var r=t[0],i=t[1],s=t[2],o=t[3],u=t[4],a=t[5],f=n[0],l=n[1],c=n[2],h=n[3],p=n[4],d=n[5];return e[0]=r*f+s*l,e[1]=i*f+o*l,e[2]=r*c+s*h,e[3]=i*c+o*h,e[4]=r*p+s*d+u,e[5]=i*p+o*d+a,e},l.mul=l.multiply,l.rotate=function(e,t,n){var r=t[0],i=t[1],s=t[2],o=t[3],u=t[4],a=t[5],f=Math.sin(n),l=Math.cos(n);return e[0]=r*l+s*f,e[1]=i*l+o*f,e[2]=r*-f+s*l,e[3]=i*-f+o*l,e[4]=u,e[5]=a,e},l.scale=function(e,t,n){var r=t[0],i=t[1],s=t[2],o=t[3],u=t[4],a=t[5],f=n[0],l=n[1];return e[0]=r*f,e[1]=i*f,e[2]=s*l,e[3]=o*l,e[4]=u,e[5]=a,e},l.translate=function(e,t,n){var r=t[0],i=t[1],s=t[2],o=t[3],u=t[4],a=t[5],f=n[0],l=n[1];return e[0]=r,e[1]=i,e[2]=s,e[3]=o,e[4]=r*f+s*l+u,e[5]=i*f+o*l+a,e},l.str=function(e){return"mat2d("+e[0]+", "+e[1]+", "+e[2]+", "+e[3]+", "+e[4]+", "+e[5]+")"},l.frob=function(e){return Math.sqrt(Math.pow(e[0],2)+Math.pow(e[1],2)+Math.pow(e[2],2)+Math.pow(e[3],2)+Math.pow(e[4],2)+Math.pow(e[5],2)+1)},typeof e!="undefined"&&(e.mat2d=l);var c={};c.create=function(){var e=new n(9);return e[0]=1,e[1]=0,e[2]=0,e[3]=0,e[4]=1,e[5]=0,e[6]=0,e[7]=0,e[8]=1,e},c.fromMat4=function(e,t){return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[4],e[4]=t[5],e[5]=t[6],e[6]=t[8],e[7]=t[9],e[8]=t[10],e},c.clone=function(e){var t=new n(9);return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t},c.copy=function(e,t){return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e[8]=t[8],e},c.identity=function(e){return e[0]=1,e[1]=0,e[2]=0,e[3]=0,e[4]=1,e[5]=0,e[6]=0,e[7]=0,e[8]=1,e},c.transpose=function(e,t){if(e===t){var n=t[1],r=t[2],i=t[5];e[1]=t[3],e[2]=t[6],e[3]=n,e[5]=t[7],e[6]=r,e[7]=i}else e[0]=t[0],e[1]=t[3],e[2]=t[6],e[3]=t[1],e[4]=t[4],e[5]=t[7],e[6]=t[2],e[7]=t[5],e[8]=t[8];return e},c.invert=function(e,t){var n=t[0],r=t[1],i=t[2],s=t[3],o=t[4],u=t[5],a=t[6],f=t[7],l=t[8],c=l*o-u*f,h=-l*s+u*a,p=f*s-o*a,d=n*c+r*h+i*p;return d?(d=1/d,e[0]=c*d,e[1]=(-l*r+i*f)*d,e[2]=(u*r-i*o)*d,e[3]=h*d,e[4]=(l*n-i*a)*d,e[5]=(-u*n+i*s)*d,e[6]=p*d,e[7]=(-f*n+r*a)*d,e[8]=(o*n-r*s)*d,e):null},c.adjoint=function(e,t){var n=t[0],r=t[1],i=t[2],s=t[3],o=t[4],u=t[5],a=t[6],f=t[7],l=t[8];return e[0]=o*l-u*f,e[1]=i*f-r*l,e[2]=r*u-i*o,e[3]=u*a-s*l,e[4]=n*l-i*a,e[5]=i*s-n*u,e[6]=s*f-o*a,e[7]=r*a-n*f,e[8]=n*o-r*s,e},c.determinant=function(e){var t=e[0],n=e[1],r=e[2],i=e[3],s=e[4],o=e[5],u=e[6],a=e[7],f=e[8];return t*(f*s-o*a)+n*(-f*i+o*u)+r*(a*i-s*u)},c.multiply=function(e,t,n){var r=t[0],i=t[1],s=t[2],o=t[3],u=t[4],a=t[5],f=t[6],l=t[7],c=t[8],h=n[0],p=n[1],d=n[2],v=n[3],m=n[4],g=n[5],y=n[6],b=n[7],w=n[8];return e[0]=h*r+p*o+d*f,e[1]=h*i+p*u+d*l,e[2]=h*s+p*a+d*c,e[3]=v*r+m*o+g*f,e[4]=v*i+m*u+g*l,e[5]=v*s+m*a+g*c,e[6]=y*r+b*o+w*f,e[7]=y*i+b*u+w*l,e[8]=y*s+b*a+w*c,e},c.mul=c.multiply,c.translate=function(e,t,n){var r=t[0],i=t[1],s=t[2],o=t[3],u=t[4],a=t[5],f=t[6],l=t[7],c=t[8],h=n[0],p=n[1];return e[0]=r,e[1]=i,e[2]=s,e[3]=o,e[4]=u,e[5]=a,e[6]=h*r+p*o+f,e[7]=h*i+p*u+l,e[8]=h*s+p*a+c,e},c.rotate=function(e,t,n){var r=t[0],i=t[1],s=t[2],o=t[3],u=t[4],a=t[5],f=t[6],l=t[7],c=t[8],h=Math.sin(n),p=Math.cos(n);return e[0]=p*r+h*o,e[1]=p*i+h*u,e[2]=p*s+h*a,e[3]=p*o-h*r,e[4]=p*u-h*i,e[5]=p*a-h*s,e[6]=f,e[7]=l,e[8]=c,e},c.scale=function(e,t,n){var r=n[0],i=n[1];return e[0]=r*t[0],e[1]=r*t[1],e[2]=r*t[2],e[3]=i*t[3],e[4]=i*t[4],e[5]=i*t[5],e[6]=t[6],e[7]=t[7],e[8]=t[8],e},c.fromMat2d=function(e,t){return e[0]=t[0],e[1]=t[1],e[2]=0,e[3]=t[2],e[4]=t[3],e[5]=0,e[6]=t[4],e[7]=t[5],e[8]=1,e},c.fromQuat=function(e,t){var n=t[0],r=t[1],i=t[2],s=t[3],o=n+n,u=r+r,a=i+i,f=n*o,l=r*o,c=r*u,h=i*o,p=i*u,d=i*a,v=s*o,m=s*u,g=s*a;return e[0]=1-c-d,e[3]=l-g,e[6]=h+m,e[1]=l+g,e[4]=1-f-d,e[7]=p-v,e[2]=h-m,e[5]=p+v,e[8]=1-f-c,e},c.normalFromMat4=function(e,t){var n=t[0],r=t[1],i=t[2],s=t[3],o=t[4],u=t[5],a=t[6],f=t[7],l=t[8],c=t[9],h=t[10],p=t[11],d=t[12],v=t[13],m=t[14],g=t[15],y=n*u-r*o,b=n*a-i*o,w=n*f-s*o,E=r*a-i*u,S=r*f-s*u,x=i*f-s*a,T=l*v-c*d,N=l*m-h*d,C=l*g-p*d,k=c*m-h*v,L=c*g-p*v,A=h*g-p*m,O=y*A-b*L+w*k+E*C-S*N+x*T;return O?(O=1/O,e[0]=(u*A-a*L+f*k)*O,e[1]=(a*C-o*A-f*N)*O,e[2]=(o*L-u*C+f*T)*O,e[3]=(i*L-r*A-s*k)*O,e[4]=(n*A-i*C+s*N)*O,e[5]=(r*C-n*L-s*T)*O,e[6]=(v*x-m*S+g*E)*O,e[7]=(m*w-d*x-g*b)*O,e[8]=(d*S-v*w+g*y)*O,e):null},c.str=function(e){return"mat3("+e[0]+", "+e[1]+", "+e[2]+", "+e[3]+", "+e[4]+", "+e[5]+", "+e[6]+", "+e[7]+", "+e[8]+")"},c.frob=function(e){return Math.sqrt(Math.pow(e[0],2)+Math.pow(e[1],2)+Math.pow(e[2],2)+Math.pow(e[3],2)+Math.pow(e[4],2)+Math.pow(e[5],2)+Math.pow(e[6],2)+Math.pow(e[7],2)+Math.pow(e[8],2))},typeof e!="undefined"&&(e.mat3=c);var h={};h.create=function(){var e=new n(16);return e[0]=1,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=1,e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[10]=1,e[11]=0,e[12]=0,e[13]=0,e[14]=0,e[15]=1,e},h.clone=function(e){var t=new n(16);return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t[9]=e[9],t[10]=e[10],t[11]=e[11],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15],t},h.copy=function(e,t){return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e[8]=t[8],e[9]=t[9],e[10]=t[10],e[11]=t[11],e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15],e},h.identity=function(e){return e[0]=1,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=1,e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[10]=1,e[11]=0,e[12]=0,e[13]=0,e[14]=0,e[15]=1,e},h.transpose=function(e,t){if(e===t){var n=t[1],r=t[2],i=t[3],s=t[6],o=t[7],u=t[11];e[1]=t[4],e[2]=t[8],e[3]=t[12],e[4]=n,e[6]=t[9],e[7]=t[13],e[8]=r,e[9]=s,e[11]=t[14],e[12]=i,e[13]=o,e[14]=u}else e[0]=t[0],e[1]=t[4],e[2]=t[8],e[3]=t[12],e[4]=t[1],e[5]=t[5],e[6]=t[9],e[7]=t[13],e[8]=t[2],e[9]=t[6],e[10]=t[10],e[11]=t[14],e[12]=t[3],e[13]=t[7],e[14]=t[11],e[15]=t[15];return e},h.invert=function(e,t){var n=t[0],r=t[1],i=t[2],s=t[3],o=t[4],u=t[5],a=t[6],f=t[7],l=t[8],c=t[9],h=t[10],p=t[11],d=t[12],v=t[13],m=t[14],g=t[15],y=n*u-r*o,b=n*a-i*o,w=n*f-s*o,E=r*a-i*u,S=r*f-s*u,x=i*f-s*a,T=l*v-c*d,N=l*m-h*d,C=l*g-p*d,k=c*m-h*v,L=c*g-p*v,A=h*g-p*m,O=y*A-b*L+w*k+E*C-S*N+x*T;return O?(O=1/O,e[0]=(u*A-a*L+f*k)*O,e[1]=(i*L-r*A-s*k)*O,e[2]=(v*x-m*S+g*E)*O,e[3]=(h*S-c*x-p*E)*O,e[4]=(a*C-o*A-f*N)*O,e[5]=(n*A-i*C+s*N)*O,e[6]=(m*w-d*x-g*b)*O,e[7]=(l*x-h*w+p*b)*O,e[8]=(o*L-u*C+f*T)*O,e[9]=(r*C-n*L-s*T)*O,e[10]=(d*S-v*w+g*y)*O,e[11]=(c*w-l*S-p*y)*O,e[12]=(u*N-o*k-a*T)*O,e[13]=(n*k-r*N+i*T)*O,e[14]=(v*b-d*E-m*y)*O,e[15]=(l*E-c*b+h*y)*O,e):null},h.adjoint=function(e,t){var n=t[0],r=t[1],i=t[2],s=t[3],o=t[4],u=t[5],a=t[6],f=t[7],l=t[8],c=t[9],h=t[10],p=t[11],d=t[12],v=t[13],m=t[14],g=t[15];return e[0]=u*(h*g-p*m)-c*(a*g-f*m)+v*(a*p-f*h),e[1]=-(r*(h*g-p*m)-c*(i*g-s*m)+v*(i*p-s*h)),e[2]=r*(a*g-f*m)-u*(i*g-s*m)+v*(i*f-s*a),e[3]=-(r*(a*p-f*h)-u*(i*p-s*h)+c*(i*f-s*a)),e[4]=-(o*(h*g-p*m)-l*(a*g-f*m)+d*(a*p-f*h)),e[5]=n*(h*g-p*m)-l*(i*g-s*m)+d*(i*p-s*h),e[6]=-(n*(a*g-f*m)-o*(i*g-s*m)+d*(i*f-s*a)),e[7]=n*(a*p-f*h)-o*(i*p-s*h)+l*(i*f-s*a),e[8]=o*(c*g-p*v)-l*(u*g-f*v)+d*(u*p-f*c),e[9]=-(n*(c*g-p*v)-l*(r*g-s*v)+d*(r*p-s*c)),e[10]=n*(u*g-f*v)-o*(r*g-s*v)+d*(r*f-s*u),e[11]=-(n*(u*p-f*c)-o*(r*p-s*c)+l*(r*f-s*u)),e[12]=-(o*(c*m-h*v)-l*(u*m-a*v)+d*(u*h-a*c)),e[13]=n*(c*m-h*v)-l*(r*m-i*v)+d*(r*h-i*c),e[14]=-(n*(u*m-a*v)-o*(r*m-i*v)+d*(r*a-i*u)),e[15]=n*(u*h-a*c)-o*(r*h-i*c)+l*(r*a-i*u),e},h.determinant=function(e){var t=e[0],n=e[1],r=e[2],i=e[3],s=e[4],o=e[5],u=e[6],a=e[7],f=e[8],l=e[9],c=e[10],h=e[11],p=e[12],d=e[13],v=e[14],m=e[15],g=t*o-n*s,y=t*u-r*s,b=t*a-i*s,w=n*u-r*o,E=n*a-i*o,S=r*a-i*u,x=f*d-l*p,T=f*v-c*p,N=f*m-h*p,C=l*v-c*d,k=l*m-h*d,L=c*m-h*v;return g*L-y*k+b*C+w*N-E*T+S*x},h.multiply=function(e,t,n){var r=t[0],i=t[1],s=t[2],o=t[3],u=t[4],a=t[5],f=t[6],l=t[7],c=t[8],h=t[9],p=t[10],d=t[11],v=t[12],m=t[13],g=t[14],y=t[15],b=n[0],w=n[1],E=n[2],S=n[3];return e[0]=b*r+w*u+E*c+S*v,e[1]=b*i+w*a+E*h+S*m,e[2]=b*s+w*f+E*p+S*g,e[3]=b*o+w*l+E*d+S*y,b=n[4],w=n[5],E=n[6],S=n[7],e[4]=b*r+w*u+E*c+S*v,e[5]=b*i+w*a+E*h+S*m,e[6]=b*s+w*f+E*p+S*g,e[7]=b*o+w*l+E*d+S*y,b=n[8],w=n[9],E=n[10],S=n[11],e[8]=b*r+w*u+E*c+S*v,e[9]=b*i+w*a+E*h+S*m,e[10]=b*s+w*f+E*p+S*g,e[11]=b*o+w*l+E*d+S*y,b=n[12],w=n[13],E=n[14],S=n[15],e[12]=b*r+w*u+E*c+S*v,e[13]=b*i+w*a+E*h+S*m,e[14]=b*s+w*f+E*p+S*g,e[15]=b*o+w*l+E*d+S*y,e},h.mul=h.multiply,h.translate=function(e,t,n){var r=n[0],i=n[1],s=n[2],o,u,a,f,l,c,h,p,d,v,m,g;return t===e?(e[12]=t[0]*r+t[4]*i+t[8]*s+t[12],e[13]=t[1]*r+t[5]*i+t[9]*s+t[13],e[14]=t[2]*r+t[6]*i+t[10]*s+t[14],e[15]=t[3]*r+t[7]*i+t[11]*s+t[15]):(o=t[0],u=t[1],a=t[2],f=t[3],l=t[4],c=t[5],h=t[6],p=t[7],d=t[8],v=t[9],m=t[10],g=t[11],e[0]=o,e[1]=u,e[2]=a,e[3]=f,e[4]=l,e[5]=c,e[6]=h,e[7]=p,e[8]=d,e[9]=v,e[10]=m,e[11]=g,e[12]=o*r+l*i+d*s+t[12],e[13]=u*r+c*i+v*s+t[13],e[14]=a*r+h*i+m*s+t[14],e[15]=f*r+p*i+g*s+t[15]),e},h.scale=function(e,t,n){var r=n[0],i=n[1],s=n[2];return e[0]=t[0]*r,e[1]=t[1]*r,e[2]=t[2]*r,e[3]=t[3]*r,e[4]=t[4]*i,e[5]=t[5]*i,e[6]=t[6]*i,e[7]=t[7]*i,e[8]=t[8]*s,e[9]=t[9]*s,e[10]=t[10]*s,e[11]=t[11]*s,e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15],e},h.rotate=function(e,n,r,i){var s=i[0],o=i[1],u=i[2],a=Math.sqrt(s*s+o*o+u*u),f,l,c,h,p,d,v,m,g,y,b,w,E,S,x,T,N,C,k,L,A,O,M,_;return Math.abs(a)<t?null:(a=1/a,s*=a,o*=a,u*=a,f=Math.sin(r),l=Math.cos(r),c=1-l,h=n[0],p=n[1],d=n[2],v=n[3],m=n[4],g=n[5],y=n[6],b=n[7],w=n[8],E=n[9],S=n[10],x=n[11],T=s*s*c+l,N=o*s*c+u*f,C=u*s*c-o*f,k=s*o*c-u*f,L=o*o*c+l,A=u*o*c+s*f,O=s*u*c+o*f,M=o*u*c-s*f,_=u*u*c+l,e[0]=h*T+m*N+w*C,e[1]=p*T+g*N+E*C,e[2]=d*T+y*N+S*C,e[3]=v*T+b*N+x*C,e[4]=h*k+m*L+w*A,e[5]=p*k+g*L+E*A,e[6]=d*k+y*L+S*A,e[7]=v*k+b*L+x*A,e[8]=h*O+m*M+w*_,e[9]=p*O+g*M+E*_,e[10]=d*O+y*M+S*_,e[11]=v*O+b*M+x*_,n!==e&&(e[12]=n[12],e[13]=n[13],e[14]=n[14],e[15]=n[15]),e)},h.rotateX=function(e,t,n){var r=Math.sin(n),i=Math.cos(n),s=t[4],o=t[5],u=t[6],a=t[7],f=t[8],l=t[9],c=t[10],h=t[11];return t!==e&&(e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15]),e[4]=s*i+f*r,e[5]=o*i+l*r,e[6]=u*i+c*r,e[7]=a*i+h*r,e[8]=f*i-s*r,e[9]=l*i-o*r,e[10]=c*i-u*r,e[11]=h*i-a*r,e},h.rotateY=function(e,t,n){var r=Math.sin(n),i=Math.cos(n),s=t[0],o=t[1],u=t[2],a=t[3],f=t[8],l=t[9],c=t[10],h=t[11];return t!==e&&(e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15]),e[0]=s*i-f*r,e[1]=o*i-l*r,e[2]=u*i-c*r,e[3]=a*i-h*r,e[8]=s*r+f*i,e[9]=o*r+l*i,e[10]=u*r+c*i,e[11]=a*r+h*i,e},h.rotateZ=function(e,t,n){var r=Math.sin(n),i=Math.cos(n),s=t[0],o=t[1],u=t[2],a=t[3],f=t[4],l=t[5],c=t[6],h=t[7];return t!==e&&(e[8]=t[8],e[9]=t[9],e[10]=t[10],e[11]=t[11],e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15]),e[0]=s*i+f*r,e[1]=o*i+l*r,e[2]=u*i+c*r,e[3]=a*i+h*r,e[4]=f*i-s*r,e[5]=l*i-o*r,e[6]=c*i-u*r,e[7]=h*i-a*r,e},h.fromRotationTranslation=function(e,t,n){var r=t[0],i=t[1],s=t[2],o=t[3],u=r+r,a=i+i,f=s+s,l=r*u,c=r*a,h=r*f,p=i*a,d=i*f,v=s*f,m=o*u,g=o*a,y=o*f;return e[0]=1-(p+v),e[1]=c+y,e[2]=h-g,e[3]=0,e[4]=c-y,e[5]=1-(l+v),e[6]=d+m,e[7]=0,e[8]=h+g,e[9]=d-m,e[10]=1-(l+p),e[11]=0,e[12]=n[0],e[13]=n[1],e[14]=n[2],e[15]=1,e},h.fromQuat=function(e,t){var n=t[0],r=t[1],i=t[2],s=t[3],o=n+n,u=r+r,a=i+i,f=n*o,l=r*o,c=r*u,h=i*o,p=i*u,d=i*a,v=s*o,m=s*u,g=s*a;return e[0]=1-c-d,e[1]=l+g,e[2]=h-m,e[3]=0,e[4]=l-g,e[5]=1-f-d,e[6]=p+v,e[7]=0,e[8]=h+m,e[9]=p-v,e[10]=1-f-c,e[11]=0,e[12]=0,e[13]=0,e[14]=0,e[15]=1,e},h.frustum=function(e,t,n,r,i,s,o){var u=1/(n-t),a=1/(i-r),f=1/(s-o);return e[0]=s*2*u,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=s*2*a,e[6]=0,e[7]=0,e[8]=(n+t)*u,e[9]=(i+r)*a,e[10]=(o+s)*f,e[11]=-1,e[12]=0,e[13]=0,e[14]=o*s*2*f,e[15]=0,e},h.perspective=function(e,t,n,r,i){var s=1/Math.tan(t/2),o=1/(r-i);return e[0]=s/n,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=s,e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[10]=(i+r)*o,e[11]=-1,e[12]=0,e[13]=0,e[14]=2*i*r*o,e[15]=0,e},h.ortho=function(e,t,n,r,i,s,o){var u=1/(t-n),a=1/(r-i),f=1/(s-o);return e[0]=-2*u,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=-2*a,e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[10]=2*f,e[11]=0,e[12]=(t+n)*u,e[13]=(i+r)*a,e[14]=(o+s)*f,e[15]=1,e},h.lookAt=function(e,n,r,i){var s,o,u,a,f,l,c,p,d,v,m=n[0],g=n[1],y=n[2],b=i[0],w=i[1],E=i[2],S=r[0],x=r[1],T=r[2];return Math.abs(m-S)<t&&Math.abs(g-x)<t&&Math.abs(y-T)<t?h.identity(e):(c=m-S,p=g-x,d=y-T,v=1/Math.sqrt(c*c+p*p+d*d),c*=v,p*=v,d*=v,s=w*d-E*p,o=E*c-b*d,u=b*p-w*c,v=Math.sqrt(s*s+o*o+u*u),v?(v=1/v,s*=v,o*=v,u*=v):(s=0,o=0,u=0),a=p*u-d*o,f=d*s-c*u,l=c*o-p*s,v=Math.sqrt(a*a+f*f+l*l),v?(v=1/v,a*=v,f*=v,l*=v):(a=0,f=0,l=0),e[0]=s,e[1]=a,e[2]=c,e[3]=0,e[4]=o,e[5]=f,e[6]=p,e[7]=0,e[8]=u,e[9]=l,e[10]=d,e[11]=0,e[12]=-(s*m+o*g+u*y),e[13]=-(a*m+f*g+l*y),e[14]=-(c*m+p*g+d*y),e[15]=1,e)},h.str=function(e){return"mat4("+e[0]+", "+e[1]+", "+e[2]+", "+e[3]+", "+e[4]+", "+e[5]+", "+e[6]+", "+e[7]+", "+e[8]+", "+e[9]+", "+e[10]+", "+e[11]+", "+e[12]+", "+e[13]+", "+e[14]+", "+e[15]+")"},h.frob=function(e){return Math.sqrt(Math.pow(e[0],2)+Math.pow(e[1],2)+Math.pow(e[2],2)+Math.pow(e[3],2)+Math.pow(e[4],2)+Math.pow(e[5],2)+Math.pow(e[6],2)+Math.pow(e[6],2)+Math.pow(e[7],2)+Math.pow(e[8],2)+Math.pow(e[9],2)+Math.pow(e[10],2)+Math.pow(e[11],2)+Math.pow(e[12],2)+Math.pow(e[13],2)+Math.pow(e[14],2)+Math.pow(e[15],2))},typeof e!="undefined"&&(e.mat4=h);var p={};p.create=function(){var e=new n(4);return e[0]=0,e[1]=0,e[2]=0,e[3]=1,e},p.rotationTo=function(){var e=u.create(),t=u.fromValues(1,0,0),n=u.fromValues(0,1,0);return function(r,i,s){var o=u.dot(i,s);return o<-0.999999?(u.cross(e,t,i),u.length(e)<1e-6&&u.cross(e,n,i),u.normalize(e,e),p.setAxisAngle(r,e,Math.PI),r):o>.999999?(r[0]=0,r[1]=0,r[2]=0,r[3]=1,r):(u.cross(e,i,s),r[0]=e[0],r[1]=e[1],r[2]=e[2],r[3]=1+o,p.normalize(r,r))}}(),p.setAxes=function(){var e=c.create();return function(t,n,r,i){return e[0]=r[0],e[3]=r[1],e[6]=r[2],e[1]=i[0],e[4]=i[1],e[7]=i[2],e[2]=-n[0],e[5]=-n[1],e[8]=-n[2],p.normalize(t,p.fromMat3(t,e))}}(),p.clone=a.clone,p.fromValues=a.fromValues,p.copy=a.copy,p.set=a.set,p.identity=function(e){return e[0]=0,e[1]=0,e[2]=0,e[3]=1,e},p.setAxisAngle=function(e,t,n){n*=.5;var r=Math.sin(n);return e[0]=r*t[0],e[1]=r*t[1],e[2]=r*t[2],e[3]=Math.cos(n),e},p.add=a.add,p.multiply=function(e,t,n){var r=t[0],i=t[1],s=t[2],o=t[3],u=n[0],a=n[1],f=n[2],l=n[3];return e[0]=r*l+o*u+i*f-s*a,e[1]=i*l+o*a+s*u-r*f,e[2]=s*l+o*f+r*a-i*u,e[3]=o*l-r*u-i*a-s*f,e},p.mul=p.multiply,p.scale=a.scale,p.rotateX=function(e,t,n){n*=.5;var r=t[0],i=t[1],s=t[2],o=t[3],u=Math.sin(n),a=Math.cos(n);return e[0]=r*a+o*u,e[1]=i*a+s*u,e[2]=s*a-i*u,e[3]=o*a-r*u,e},p.rotateY=function(e,t,n){n*=.5;var r=t[0],i=t[1],s=t[2],o=t[3],u=Math.sin(n),a=Math.cos(n);return e[0]=r*a-s*u,e[1]=i*a+o*u,e[2]=s*a+r*u,e[3]=o*a-i*u,e},p.rotateZ=function(e,t,n){n*=.5;var r=t[0],i=t[1],s=t[2],o=t[3],u=Math.sin(n),a=Math.cos(n);return e[0]=r*a+i*u,e[1]=i*a-r*u,e[2]=s*a+o*u,e[3]=o*a-s*u,e},p.calculateW=function(e,t){var n=t[0],r=t[1],i=t[2];return e[0]=n,e[1]=r,e[2]=i,e[3]=-Math.sqrt(Math.abs(1-n*n-r*r-i*i)),e},p.dot=a.dot,p.lerp=a.lerp,p.slerp=function(e,t,n,r){var i=t[0],s=t[1],o=t[2],u=t[3],a=n[0],f=n[1],l=n[2],c=n[3],h,p,d,v,m;return p=i*a+s*f+o*l+u*c,p<0&&(p=-p,a=-a,f=-f,l=-l,c=-c),1-p>1e-6?(h=Math.acos(p),d=Math.sin(h),v=Math.sin((1-r)*h)/d,m=Math.sin(r*h)/d):(v=1-r,m=r),e[0]=v*i+m*a,e[1]=v*s+m*f,e[2]=v*o+m*l,e[3]=v*u+m*c,e},p.invert=function(e,t){var n=t[0],r=t[1],i=t[2],s=t[3],o=n*n+r*r+i*i+s*s,u=o?1/o:0;return e[0]=-n*u,e[1]=-r*u,e[2]=-i*u,e[3]=s*u,e},p.conjugate=function(e,t){return e[0]=-t[0],e[1]=-t[1],e[2]=-t[2],e[3]=t[3],e},p.length=a.length,p.len=p.length,p.squaredLength=a.squaredLength,p.sqrLen=p.squaredLength,p.normalize=a.normalize,p.fromMat3=function(e,t){var n=t[0]+t[4]+t[8],r;if(n>0)r=Math.sqrt(n+1),e[3]=.5*r,r=.5/r,e[0]=(t[7]-t[5])*r,e[1]=(t[2]-t[6])*r,e[2]=(t[3]-t[1])*r;else{var i=0;t[4]>t[0]&&(i=1),t[8]>t[i*3+i]&&(i=2);var s=(i+1)%3,o=(i+2)%3;r=Math.sqrt(t[i*3+i]-t[s*3+s]-t[o*3+o]+1),e[i]=.5*r,r=.5/r,e[3]=(t[o*3+s]-t[s*3+o])*r,e[s]=(t[s*3+i]+t[i*3+s])*r,e[o]=(t[o*3+i]+t[i*3+o])*r}return e},p.str=function(e){return"quat("+e[0]+", "+e[1]+", "+e[2]+", "+e[3]+")"},typeof e!="undefined"&&(e.quat=p)}(t.exports)})(this);
'use strict';(function(n){function U(){return Array.prototype.slice.call(this)}function P(g,e){if(g.constructor===e)return g;if(g.constructor!==Array)return e=e||Float32Array,new e(g);e=e||Float32Array;for(var a=g[0].length,b=new e(g.length*a),c=0;c<g.length;++c)for(var d=0;d<a;++d)b[c*a+d]=g[c][d];return b}function G(g,e,a,b,c){g=g||1024;h.debug&&console.log("GL.Mesh created");null!==c&&(this.gl=c=c||n.gl);this._context_id=c.context_id;this.vertexBuffers={};this.indexBuffers={};this.info={groups:[]};
this._bounding=BBox.create();this.resize(g)}function H(g,e,a,b){this.gl=b=b||n.gl;this._context_id=b.context_id;if(g&&g.constructor!==Array)throw"FBO textures must be an Array";this.handler=null;this.height=this.width=-1;this.color_textures=[];this.depth_texture=null;this.stencil=!!a;this._stencil_enabled=!1;this._num_binded_textures=0;(g&&g.length||e)&&this.setTextures(g,e);this._old_fbo_handler=null;this._old_viewport=new Float32Array(4)}var h=n.GL={};if("undefined"==typeof glMatrix)throw"litegl.js requires gl-matrix to work. It must be included before litegl.";
n.requestAnimationFrame=n.requestAnimationFrame||n.mozRequestAnimationFrame||n.webkitRequestAnimationFrame||function(g){setTimeout(g,1E3/60)};h.blockable_keys={Up:!0,Down:!0,Left:!0,Right:!0};h.LEFT_MOUSE_BUTTON=1;h.MIDDLE_MOUSE_BUTTON=2;h.RIGHT_MOUSE_BUTTON=3;h.last_context_id=0;h.COLOR_BUFFER_BIT=16384;h.DEPTH_BUFFER_BIT=256;h.STENCIL_BUFFER_BIT=1024;h.TEXTURE_2D=3553;h.TEXTURE_CUBE_MAP=34067;h.TEXTURE_3D=32879;h.TEXTURE_MAG_FILTER=10240;h.TEXTURE_MIN_FILTER=10241;h.TEXTURE_WRAP_S=10242;h.TEXTURE_WRAP_T=
10243;h.BYTE=5120;h.UNSIGNED_BYTE=5121;h.SHORT=5122;h.UNSIGNED_SHORT=5123;h.INT=5124;h.UNSIGNED_INT=5125;h.FLOAT=5126;h.HALF_FLOAT_OES=36193;h.HALF_FLOAT=5131;h.DEPTH_COMPONENT16=33189;h.DEPTH_COMPONENT24=33190;h.DEPTH_COMPONENT32F=36012;h.FLOAT_VEC2=35664;h.FLOAT_VEC3=35665;h.FLOAT_VEC4=35666;h.INT_VEC2=35667;h.INT_VEC3=35668;h.INT_VEC4=35669;h.BOOL=35670;h.BOOL_VEC2=35671;h.BOOL_VEC3=35672;h.BOOL_VEC4=35673;h.FLOAT_MAT2=35674;h.FLOAT_MAT3=35675;h.FLOAT_MAT4=35676;h.TYPE_LENGTH={};h.TYPE_LENGTH[h.FLOAT]=
h.TYPE_LENGTH[h.INT]=h.TYPE_LENGTH[h.BYTE]=h.TYPE_LENGTH[h.BOOL]=1;h.TYPE_LENGTH[h.FLOAT_VEC2]=h.TYPE_LENGTH[h.INT_VEC2]=h.TYPE_LENGTH[h.BOOL_VEC2]=2;h.TYPE_LENGTH[h.FLOAT_VEC3]=h.TYPE_LENGTH[h.INT_VEC3]=h.TYPE_LENGTH[h.BOOL_VEC3]=3;h.TYPE_LENGTH[h.FLOAT_VEC4]=h.TYPE_LENGTH[h.INT_VEC4]=h.TYPE_LENGTH[h.BOOL_VEC4]=4;h.TYPE_LENGTH[h.FLOAT_MAT3]=9;h.TYPE_LENGTH[h.FLOAT_MAT4]=16;h.SAMPLER_2D=35678;h.SAMPLER_3D=35679;h.SAMPLER_CUBE=35680;h.DEPTH_COMPONENT=6402;h.ALPHA=6406;h.RGB=6407;h.RGBA=6408;h.LUMINANCE=
6409;h.LUMINANCE_ALPHA=6410;h.DEPTH_STENCIL=34041;h.UNSIGNED_INT_24_8_WEBGL=34042;h.R8=33321;h.R16F=33325;h.R32F=33326;h.R8UI=33330;h.RG8=33323;h.RG16F=33327;h.RG32F=33328;h.RGB8=32849;h.SRGB8=35905;h.RGB565=36194;h.R11F_G11F_B10F=35898;h.RGB9_E5=35901;h.RGB16F=34843;h.RGB32F=34837;h.RGB8UI=36221;h.RGBA8=32856;h.RGB5_A1=32855;h.RGBA16F=34842;h.RGBA32F=34836;h.RGBA8UI=36220;h.RGBA16I=36232;h.RGBA16UI=36214;h.RGBA32I=36226;h.RGBA32UI=36208;h.NEAREST=9728;h.LINEAR=9729;h.NEAREST_MIPMAP_NEAREST=9984;
h.LINEAR_MIPMAP_NEAREST=9985;h.NEAREST_MIPMAP_LINEAR=9986;h.LINEAR_MIPMAP_LINEAR=9987;h.REPEAT=10497;h.CLAMP_TO_EDGE=33071;h.MIRRORED_REPEAT=33648;h.ZERO=0;h.ONE=1;h.SRC_COLOR=768;h.ONE_MINUS_SRC_COLOR=769;h.SRC_ALPHA=770;h.ONE_MINUS_SRC_ALPHA=771;h.DST_ALPHA=772;h.ONE_MINUS_DST_ALPHA=773;h.DST_COLOR=774;h.ONE_MINUS_DST_COLOR=775;h.SRC_ALPHA_SATURATE=776;h.CONSTANT_COLOR=32769;h.ONE_MINUS_CONSTANT_COLOR=32770;h.CONSTANT_ALPHA=32771;h.ONE_MINUS_CONSTANT_ALPHA=32772;h.VERTEX_SHADER=35633;h.FRAGMENT_SHADER=
35632;h.FRONT=1028;h.BACK=1029;h.FRONT_AND_BACK=1032;h.NEVER=512;h.LESS=513;h.EQUAL=514;h.LEQUAL=515;h.GREATER=516;h.NOTEQUAL=517;h.GEQUAL=518;h.ALWAYS=519;h.KEEP=7680;h.REPLACE=7681;h.INCR=7682;h.DECR=7683;h.INCR_WRAP=34055;h.DECR_WRAP=34056;h.INVERT=5386;h.STREAM_DRAW=35040;h.STATIC_DRAW=35044;h.DYNAMIC_DRAW=35048;h.ARRAY_BUFFER=34962;h.ELEMENT_ARRAY_BUFFER=34963;h.POINTS=0;h.LINES=1;h.LINE_LOOP=2;h.LINE_STRIP=3;h.TRIANGLES=4;h.TRIANGLE_STRIP=5;h.TRIANGLE_FAN=6;h.CW=2304;h.CCW=2305;h.CULL_FACE=
2884;h.DEPTH_TEST=2929;h.BLEND=3042;h.temp_vec3=vec3.create();h.temp2_vec3=vec3.create();h.temp_vec4=vec4.create();h.temp_quat=quat.create();h.temp_mat3=mat3.create();h.temp_mat4=mat4.create();n.DEG2RAD=0.0174532925;n.RAD2DEG=57.295779578552306;n.EPSILON=1E-6;n.isPowerOfTwo=h.isPowerOfTwo=function(g){return 0==Math.log(g)/Math.log(2)%1};[Uint8Array,Int8Array,Uint16Array,Int16Array,Uint32Array,Int32Array,Float32Array,Float64Array].forEach(function(g){g.prototype.toJSON||Object.defineProperty(g.prototype,
"toJSON",{value:U,enumerable:!1})});n.getTime="undefined"!=typeof performance?performance.now.bind(performance):Date.now.bind(Date);h.getTime=n.getTime;n.isFunction=function(g){return!!(g&&g.constructor&&g.call&&g.apply)};n.isArray=function(g){return g&&g.constructor===Array};n.isNumber=function(g){return null!=g&&g.constructor===Number};n.getClassName=function(g){if(g){if(g.name)return g.name;if(g.toString&&(g=g.toString().match(/function\s*(\w+)/))&&2==g.length)return g[1]}};n.cloneObject=h.cloneObject=
function(g,e){if(g.constructor!==Object)throw"cloneObject only can clone pure javascript objects, not classes";e=e||{};for(var a in g){var b=g[a];if(null===b)e[a]=null;else switch(b.constructor){case Int8Array:case Uint8Array:case Int16Array:case Uint16Array:case Int32Array:case Uint32Array:case Float32Array:case Float64Array:e[a]=new b.constructor(b);break;case Boolean:case Number:case String:e[a]=b;break;case Array:e[a]=b.concat();break;case Object:e[a]=h.cloneObject(b)}}return e};n.regexMap=function(g,
e,a){for(var b;null!=(b=g.exec(e));)a(b)};n.createCanvas=h.createCanvas=function(g,e){var a=document.createElement("canvas");a.width=g;a.height=e;return a};n.cloneCanvas=h.cloneCanvas=function(g){var e=document.createElement("canvas");e.width=g.width;e.height=g.height;e.getContext("2d").drawImage(g,0,0);return e};"undefined"!=typeof Image&&(Image.prototype.getPixels=function(){var g=document.createElement("canvas");g.width=this.width;g.height=this.height;g=g.getContext("2d");g.drawImage(this,0,0);
return g.getImageData(0,0,this.width,this.height).data});String.prototype.hasOwnProperty("replaceAll")||Object.defineProperty(String.prototype,"replaceAll",{value:function(g){var e=this,a;for(a in g)e=e.split(a).join(g[a]);return e},enumerable:!1});String.prototype.hasOwnProperty("hashCode")||Object.defineProperty(String.prototype,"hashCode",{value:function(){var g=0,e,a,b;if(0==this.length)return g;e=0;for(b=this.length;e<b;++e)a=this.charCodeAt(e),g=(g<<5)-g+a,g|=0;return g},enumerable:!1});Array.prototype.hasOwnProperty("clone")||
Object.defineProperty(Array.prototype,"clone",{value:Array.prototype.concat,enumerable:!1});Float32Array.prototype.hasOwnProperty("clone")||Object.defineProperty(Float32Array.prototype,"clone",{value:function(){return new Float32Array(this)},enumerable:!1});n.wipeObject=function(g){for(var e in g)g.hasOwnProperty(e)&&delete g[e]};n.extendClass=h.extendClass=function(g,e){for(var a in e)g.hasOwnProperty(a)||(g[a]=e[a]);if(e.prototype){var b=Object.getOwnPropertyNames(e.prototype);for(a=0;a<b.length;++a){var c=
b[a];g.prototype.hasOwnProperty(c)||(e.prototype.__lookupGetter__(c)?g.prototype.__defineGetter__(c,e.prototype.__lookupGetter__(c)):g.prototype[c]=e.prototype[c],e.prototype.__lookupSetter__(c)&&g.prototype.__defineSetter__(c,e.prototype.__lookupSetter__(c)))}}g.hasOwnProperty("superclass")||Object.defineProperty(g,"superclass",{get:function(){return e},enumerable:!1})};n.HttpRequest=h.request=function(g,e,a,b,c){var d=!0;c&&void 0!==c.async&&(d=c.async);if(e){var f=null,f=[],k;for(k in e)f.push(k+
"="+e[k]);f=f.join("&");g=g+"?"+f}var h=new XMLHttpRequest;h.open("GET",g,d);h.onload=function(c){this.getResponseHeader("Content-Type");200!=this.status?(u.trigger(h,"fail",this.status),b&&b(this.status)):(u.trigger(h,"done",this.response),a&&a(this.response))};h.onerror=function(a){u.trigger(h,"fail",a)};if(c){for(k in c)h[k]=c[k];c.binary&&(h.responseType="arraybuffer")}h.send();return h};n.XMLHttpRequest&&(XMLHttpRequest.prototype.hasOwnProperty("done")||Object.defineProperty(XMLHttpRequest.prototype,
"done",{enumerable:!1,value:function(g){u.bind(this,"done",function(e,a){g(a)});return this}}),XMLHttpRequest.prototype.hasOwnProperty("fail")||Object.defineProperty(XMLHttpRequest.prototype,"fail",{enumerable:!1,value:function(g){u.bind(this,"fail",function(e,a){g(a)});return this}}));n.getFileExtension=function(g){var e=g.indexOf("?");-1!=e&&(g=g.substr(0,e));e=g.lastIndexOf(".");return-1==e?"":g.substr(e+1).toLowerCase()};n.loadFileAtlas=h.loadFileAtlas=function(g,e,a){var b=null;HttpRequest(g,
null,function(a){a=h.processFileAtlas(a);e&&e(a);b&&b(a)},alert,a);return{done:function(a){b=a}}};n.processFileAtlas=h.processFileAtlas=function(g,e){for(var a=g.split("\n"),b={},c=[],d="",f=0,k=a.length;f<k;f++){var h=e?a[f]:a[f].trim();h.length&&("\\"!=h[0]?c.push(h):(c.length&&(b[d]=c.join("\n")),c.length=0,d=h.substr(1)))}c.length&&(b[d]=c.join("\n"));return b};n.typedArrayToArray=function(g){var e=[];e.length=g.length;for(var a=0;a<g.length;a++)e[a]=g[a];return e};n.RGBToHex=function(g,e,a){g=
Math.min(255,255*g)|0;e=Math.min(255,255*e)|0;a=Math.min(255,255*a)|0;return"#"+(16777216+(g<<16)+(e<<8)+a).toString(16).slice(1)};n.HUEToRGB=function(g,e,a){0>a&&(a+=1);1<a&&(a-=1);return a<1/6?g+6*(e-g)*a:0.5>a?e:a<2/3?g+(e-g)*(2/3-a)*6:g};n.HSLToRGB=function(g,e,a,b){b=b||vec3.create();if(0==e)a=e=g=a;else{var c=0.5>a?a*(1+e):a+e-a*e,d=2*a-c;a=HUEToRGB(d,c,g+1/3);e=HUEToRGB(d,c,g);g=HUEToRGB(d,c,g-1/3)}b[0]=a;b[1]=e;b[2]=g;return b};n.hexColorToRGBA=function(){var g={white:[1,1,1],black:[0,0,0],
gray:[0.501960813999176,0.501960813999176,0.501960813999176],red:[1,0,0],orange:[1,0.6470588445663452,0],pink:[1,0.7529411911964417,0.7960784435272217],green:[0,0.501960813999176,0],lime:[0,1,0],blue:[0,0,1],violet:[0.9333333373069763,0.5098039507865906,0.9333333373069763],magenta:[1,0,1],cyan:[0,1,1],yellow:[1,1,0],brown:[0.6470588445663452,0.16470588743686676,0.16470588743686676],silver:[0.7529411911964417,0.7529411911964417,0.7529411911964417],gold:[1,0.843137264251709,0],transparent:[0,0,0,0]};
return function(e,a,b){b=void 0===b?1:b;a=a||new Float32Array(4);a[3]=b;if("string"!=typeof e)return a;var c=g[e];if(void 0!==c)return a.set(c),a[3]=3==a.length?b:a[3]*b,a;c=e.indexOf("rgba(");if(-1!=c)return e=e.substr(5),e=e.split(","),a[0]=parseInt(e[0])/255,a[1]=parseInt(e[1])/255,a[2]=parseInt(e[2])/255,a[3]=parseFloat(e[3])*b,a;c=e.indexOf("hsla(");if(-1!=c)return e=e.substr(5),e=e.split(","),HSLToRGB(parseInt(e[0])/360,parseInt(e[1])/100,parseInt(e[2])/100,a),a[3]=parseFloat(e[3])*b,a;a[3]=
b;c=e.indexOf("rgb(");if(-1!=c)return e=e.substr(3),e=e.split(","),a[0]=parseInt(e[0])/255,a[1]=parseInt(e[1])/255,a[2]=parseInt(e[2])/255,a;c=e.indexOf("hsl(");if(-1!=c)return e=e.substr(5),e=e.split(","),HSLToRGB(parseInt(e[0])/360,parseInt(e[1])/100,parseInt(e[2])/100,a),a;e=e.replace(/^#?([a-f\d])([a-f\d])([a-f\d])$/i,function(a,b,c,e){return b+b+c+c+e+e});b=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(e);if(!b)return a;a[0]=parseInt(b[1],16)/255;a[1]=parseInt(b[2],16)/255;a[2]=parseInt(b[3],
16)/255;return a}}();var Q=function(){function g(a){return a.charCodeAt(0)+(a.charCodeAt(1)<<8)+(a.charCodeAt(2)<<16)+(a.charCodeAt(3)<<24)}function e(a,b,c,d){var e=new Uint16Array(4),f=new Uint16Array(c*d),g=0,k=0,l=0,h=k=g=0,s=0,m=0,t=0,p=c/4;d/=4;for(var q=0;q<d;q++)for(var r=0;r<p;r++)l=b+4*(q*p+r),e[0]=a[l],e[1]=a[l+1],g=e[0]&31,k=e[0]&2016,h=e[0]&63488,s=e[1]&31,m=e[1]&2016,t=e[1]&63488,e[2]=5*g+3*s>>3|5*k+3*m>>3&2016|5*h+3*t>>3&63488,e[3]=5*s+3*g>>3|5*m+3*k>>3&2016|5*t+3*h>>3&63488,g=a[l+
2],k=4*q*c+4*r,f[k]=e[g&3],f[k+1]=e[g>>2&3],f[k+2]=e[g>>4&3],f[k+3]=e[g>>6&3],k+=c,f[k]=e[g>>8&3],f[k+1]=e[g>>10&3],f[k+2]=e[g>>12&3],f[k+3]=e[g>>14],g=a[l+3],k+=c,f[k]=e[g&3],f[k+1]=e[g>>2&3],f[k+2]=e[g>>4&3],f[k+3]=e[g>>6&3],k+=c,f[k]=e[g>>8&3],f[k+1]=e[g>>10&3],f[k+2]=e[g>>12&3],f[k+3]=e[g>>14];return f}function a(a){for(var b=0,c=a.length,d=0;b<c;b+=4)d=a[b],a[b]=a[b+2],a[b+2]=d}function b(b,c,d,g){var L=new Int32Array(d,0,r),I,B,D,F,E,u,J,C,y;if(L[w]!=f)return console.error("Invalid magic number in DDS header"),
0;if(!L[A]&l)return console.error("Unsupported format, must contain a FourCC code"),0;I=L[K];switch(I){case m:B=8;D=c?c.COMPRESSED_RGB_S3TC_DXT1_EXT:null;break;case p:B=16;D=c?c.COMPRESSED_RGBA_S3TC_DXT3_EXT:null;break;case q:B=16;D=c?c.COMPRESSED_RGBA_S3TC_DXT5_EXT:null;break;default:B=4,I=null,D=b.RGBA}J=1;L[t]&k&&!1!==g&&(J=Math.max(1,L[M]));F=L[x];E=L[z];u=L[v]+4;if(L[n+1]&h)for(y=0;6>y;++y)for(F=L[x],E=L[z],C=0;C<J;++C)I?(g=Math.max(4,F)/4*Math.max(4,E)/4*B,c=new Uint8Array(d,u,g),b.compressedTexImage2D(b.TEXTURE_CUBE_MAP_POSITIVE_X+
y,C,D,F,E,0,c)):(b.pixelStorei(b.UNPACK_FLIP_Y_WEBGL,!1),g=F*E*B,c=new Uint8Array(d,u,g),a(c),b.texImage2D(b.TEXTURE_CUBE_MAP_POSITIVE_X+y,C,D,F,E,0,b.RGBA,b.UNSIGNED_BYTE,c)),u+=g,F*=0.5,E*=0.5;else if(c)for(b.pixelStorei(b.UNPACK_FLIP_Y_WEBGL,!0),C=0;C<J;++C)I?(g=Math.max(4,F)/4*Math.max(4,E)/4*B,c=new Uint8Array(d,u,g),b.compressedTexImage2D(b.TEXTURE_2D,C,D,F,E,0,c)):(g=F*E*B,c=new Uint8Array(d,u,g),a(c),b.texImage2D(b.TEXTURE_2D,C,D,F,E,0,D,b.UNSIGNED_BYTE,c)),u+=g,F*=0.5,E*=0.5;else if(I==m)Math.max(4,
F),Math.max(4,E),c=new Uint16Array(d),d=e(c,u/2,F,E),b.texImage2D(b.TEXTURE_2D,0,b.RGB,F,E,0,b.RGB,b.UNSIGNED_SHORT_5_6_5,d),g&&b.generateMipmap(b.TEXTURE_2D);else return console.error("No manual decoder for",String.fromCharCode(I&255,I>>8&255,I>>16&255,I>>24&255),"and no native support"),0;return J}function c(b,c){var d=new Int32Array(b,0,r),g,u,I,B,D,F,E,y,J,C,G;if(d[w]!=f)return console.error("Invalid magic number in DDS header"),0;if(!d[A]&l)return console.error("Unsupported format, must contain a FourCC code"),
0;g=d[K];switch(g){case m:u=8;I="COMPRESSED_RGB_S3TC_DXT1_EXT";break;case p:u=16;I="COMPRESSED_RGBA_S3TC_DXT3_EXT";break;case q:u=16;I="COMPRESSED_RGBA_S3TC_DXT5_EXT";break;default:u=4,I="RGBA"}J=1;d[t]&k&&!1!==loadMipmaps&&(J=Math.max(1,d[M]));B=d[x];D=d[z];E=d[v]+4;var H=[];if(d[n+1]&h)for(G=0;6>G;++G)for(B=d[x],D=d[z],C=0;C<J;++C)g?(F=Math.max(4,B)/4*Math.max(4,D)/4*u,new Uint8Array(b,E,F),H.push({tex:"TEXTURE_CUBE_MAP",face:G,mipmap:C,internalFormat:I,width:B,height:D,offset:0,dataOffset:E,dataLength:F})):
(F=B*D*u,y=new Uint8Array(b,E,F),a(y),H.push({tex:"TEXTURE_CUBE_MAP",face:G,mipmap:C,internalFormat:I,width:B,height:D,offset:0,type:"UNSIGNED_BYTE",dataOffset:E,dataLength:F})),E+=F,B*=0.5,D*=0.5;else if(c)if(g==m)Math.max(4,B),Math.max(4,D),y=new Uint16Array(b),d=e(y,E/2,B,D),H.push({tex:"TEXTURE_2D",mipmap:0,internalFormat:"RGB",width:B,height:D,offset:0,format:"RGB",type:"UNSIGNED_SHORT_5_6_5",data:d});else return console.error("No manual decoder for",String.fromCharCode(g&255,g>>8&255,g>>16&
255,g>>24&255),"and no native support"),0;else for(C=0;C<J;++C)F=Math.max(4,B)/4*Math.max(4,D)/4*u,new Uint8Array(b,E,F),H.push({tex:"TEXTURE_2D",mipmap:C,internalFormat:I,width:B,height:D,offset:0,type:"UNSIGNED_BYTE",dataOffset:E,dataLength:F}),E+=F,B*=0.5,D*=0.5;return H}function d(a,c,d,e,f,g){var k=new XMLHttpRequest;k.open("GET",d,!0);k.responseType="arraybuffer";k.onload=function(){if(200==this.status){var d=new Int32Array(this.response,0,r),k=d[n+1]&h?a.TEXTURE_CUBE_MAP:a.TEXTURE_2D;a.bindTexture(k,
e);var l=b(a,c,this.response,f);a.texParameteri(k,a.TEXTURE_MAG_FILTER,a.LINEAR);a.texParameteri(k,a.TEXTURE_MIN_FILTER,1<l?a.LINEAR_MIPMAP_LINEAR:a.LINEAR);a.bindTexture(k,null);e.texture_type=k;e.width=d[x];e.height=d[z]}g&&g(e)};k.send(null);return e}var f=542327876,k=131072,h=512,l=4,m=g("DXT1"),p=g("DXT3"),q=g("DXT5"),r=31,w=0,v=1,t=2,z=3,x=4,M=7,A=20,K=21,n=27;return{dxtToRgb565:e,uploadDDSLevels:b,loadDDSTextureEx:d,loadDDSTexture:function(a,b,c,e){var f=a.createTexture();b=a.getExtension("WEBGL_compressed_texture_s3tc");
d(a,b,c,f,!0,e);return f},loadDDSTextureFromMemoryEx:function(a,c,d,e,f){var g=new Int32Array(d,0,r),k=!!(g[n+1]&h),l=k?a.TEXTURE_CUBE_MAP:a.TEXTURE_2D;a.bindTexture(l,e.handler);c=b(a,c,d,f);a.texParameteri(l,a.TEXTURE_MAG_FILTER,a.LINEAR);a.texParameteri(l,a.TEXTURE_MIN_FILTER,1<c?a.LINEAR_MIPMAP_LINEAR:a.LINEAR);k&&(a.texParameteri(l,a.TEXTURE_WRAP_S,a.CLAMP_TO_EDGE),a.texParameteri(l,a.TEXTURE_WRAP_T,a.CLAMP_TO_EDGE));a.bindTexture(l,null);e.handler&&(e.texture_type=l,e.width=g[x],e.height=g[z]);
return e},getDDSTextureFromMemoryEx:function(a){var b=new Int32Array(a,0,r),d=b[n+1]&h?"TEXTURE_CUBE_MAP":"TEXTURE_2D",e=c(a);return{type:d,buffers:e,data:a,width:b[x],height:b[z]}}}}();"undefined"!=typeof n&&(n.DDS=Q);if("undefined"==typeof glMatrix)throw"You must include glMatrix on your project";Math.clamp=function(g,e,a){return e>g?e:a<g?a:g};vec3.ZERO=vec3.fromValues(0,0,0);vec3.FRONT=vec3.fromValues(0,0,-1);vec3.UP=vec3.fromValues(0,1,0);vec3.RIGHT=vec3.fromValues(1,0,0);vec2.rotate=function(g,
e,a){var b=e[0];e=e[1];var c=Math.cos(a);a=Math.sin(a);g[0]=b*c-e*a;g[1]=b*a+e*c;return g};vec3.zero=function(g){g[0]=g[1]=0;return g};vec2.perpdot=function(g,e){return g[1]*e[0]+-g[0]*e[1]};vec2.computeSignedAngle=function(g,e){return Math.atan2(vec2.perpdot(g,e),vec2.dot(g,e))};vec2.random=function(g,e){e=e||1;g[0]=Math.random()*e;g[1]=Math.random()*e;return g};vec3.zero=function(g){g[0]=g[1]=g[2]=0;return g};vec3.minValue=function(g){return g[0]<g[1]&&g[0]<g[2]?g[0]:g[1]<g[2]?g[1]:g[2]};vec3.maxValue=
function(g){return g[0]>g[1]&&g[0]>g[2]?g[0]:g[1]>g[2]?g[1]:g[2]};vec3.minValue=function(g){return g[0]<g[1]&&g[0]<g[2]?g[0]:g[1]<g[2]?g[1]:g[2]};vec3.addValue=function(g,e,a){g[0]=e[0]+a;g[1]=e[1]+a;g[2]=e[2]+a};vec3.subValue=function(g,e,a){g[0]=e[0]-a;g[1]=e[1]-a;g[2]=e[2]-a};vec3.toArray=function(g){return[g[0],g[1],g[2]]};vec3.rotateX=function(g,e,a){var b=e[1],c=e[2],d=Math.cos(a);a=Math.sin(a);g[0]=e[0];g[1]=b*d-c*a;g[2]=b*a+c*d;return g};vec3.rotateY=function(g,e,a){var b=e[0],c=e[2],d=Math.cos(a);
a=Math.sin(a);g[0]=b*d-c*a;g[1]=e[1];g[2]=b*a+c*d;return g};vec3.rotateZ=function(g,e,a){var b=e[0],c=e[1],d=Math.cos(a);a=Math.sin(a);g[0]=b*d-c*a;g[1]=b*a+c*d;g[2]=e[2];return g};vec3.angle=function(g,e){return Math.acos(vec3.dot(g,e))};vec3.random=function(g,e){e=e||1;g[0]=Math.random()*e;g[1]=Math.random()*e;g[2]=Math.random()*e;return g};vec3.polarToCartesian=function(g,e){var a=e[0],b=e[1],c=e[2];g[0]=a*Math.cos(b)*Math.sin(c);g[1]=a*Math.sin(b);g[2]=a*Math.cos(b)*Math.cos(c);return g};vec3.reflect=
function(g,e,a){var b=e[0],c=e[1],d=e[2];vec3.scale(g,a,-2*vec3.dot(e,a));g[0]+=b;g[1]+=c;g[2]+=d;return g};vec4.random=function(g,e){e=e||1;g[0]=Math.random()*e;g[1]=Math.random()*e;g[2]=Math.random()*e;g[3]=Math.random()*e;return g};vec4.toArray=function(g){return[g[0],g[1],g[2],g[3]]};mat3.IDENTITY=mat3.create();mat4.IDENTITY=mat4.create();mat4.toArray=function(g){return[g[0],g[1],g[2],g[3],g[4],g[5],g[6],g[7],g[8],g[9],g[10],g[11],g[12],g[13],g[14],g[15]]};mat4.setUpAndOrthonormalize=function(g,
e,a){e!=g&&mat4.copy(g,e);e=g.subarray(0,3);vec3.normalize(g.subarray(4,7),a);g=g.subarray(8,11);vec3.cross(e,a,g);vec3.normalize(e,e);vec3.cross(g,e,a);vec3.normalize(g,g)};mat4.multiplyVec3=function(g,e,a){var b=a[0],c=a[1];a=a[2];g[0]=e[0]*b+e[4]*c+e[8]*a+e[12];g[1]=e[1]*b+e[5]*c+e[9]*a+e[13];g[2]=e[2]*b+e[6]*c+e[10]*a+e[14];return g};mat4.projectVec3=function(g,e,a){var b=a[0],c=a[1];a=a[2];var d=e[1]*b+e[5]*c+e[9]*a+e[13],f=e[2]*b+e[6]*c+e[10]*a+e[14],k=e[3]*b+e[7]*c+e[11]*a+e[15];g[0]=((e[0]*
b+e[4]*c+e[8]*a+e[12])/k+1)/2;g[1]=(d/k+1)/2;g[2]=(f/k+1)/2;return g};vec3.project=function(g,e,a,b){b=b||gl.viewport_data;var c=e[0],d=e[1];e=e[2];var f=a[3]*c+a[7]*d+a[11]*e+a[15],k=1-((a[1]*c+a[5]*d+a[9]*e+a[13])/f+1)/2;g[0]=((a[0]*c+a[4]*d+a[8]*e+a[12])/f+1)/2*b[2]+b[0];g[1]=k*b[3]+b[1];g[2]=f;return g};var R=mat4.create(),y=vec4.create();vec3.unproject=function(g,e,a,b){y[0]=2*(e[0]-b[0])/b[2]-1;y[1]=2*(e[1]-b[1])/b[3]-1;y[2]=2*e[2]-1;y[3]=1;if(!mat4.invert(R,a))return null;vec4.transformMat4(y,
y,R);if(0===y[3])return null;g[0]=y[0]/y[3];g[1]=y[1]/y[3];g[2]=y[2]/y[3];return g};mat4.rotateVec3=function(g,e,a){var b=a[0],c=a[1];a=a[2];g[0]=e[0]*b+e[4]*c+e[8]*a;g[1]=e[1]*b+e[5]*c+e[9]*a;g[2]=e[2]*b+e[6]*c+e[10]*a;return g};mat4.fromTranslationFrontTop=function(g,e,a,b){vec3.cross(g.subarray(0,3),a,b);g.set(b,4);g.set(a,8);g.set(e,12);return g};mat4.translationMatrix=function(g){var e=mat4.create();e[12]=g[0];e[13]=g[1];e[14]=g[2];return e};mat4.setTranslation=function(g,e){g[12]=e[0];g[13]=
e[1];g[14]=e[2];return g};mat4.getTranslation=function(g,e){g[0]=e[12];g[1]=e[13];g[2]=e[14];return g};mat4.toRotationMat4=function(g,e){mat4.copy(g,e);g[12]=g[13]=g[14]=0;return g};mat4.swapRows=function(g,e,a,b){if(g!=e)return mat4.copy(g,e),g[4*a]=e[4*b],g[4*a+1]=e[4*b+1],g[4*a+2]=e[4*b+2],g[4*a+3]=e[4*b+3],g[4*b]=e[4*a],g[4*b+1]=e[4*a+1],g[4*b+2]=e[4*a+2],g[4*b+3]=e[4*a+3],g;e=new Float32Array(matrix.subarray(4*a,5*a));matrix.set(matrix.subarray(4*b,5*b),4*a);matrix.set(e,4*b);return g};mat4.scaleAndAdd=
function(g,e,a,b){g[0]=e[0]+a[0]*b;g[1]=e[1]+a[1]*b;g[2]=e[2]+a[2]*b;g[3]=e[3]+a[3]*b;g[4]=e[4]+a[4]*b;g[5]=e[5]+a[5]*b;g[6]=e[6]+a[6]*b;g[7]=e[7]+a[7]*b;g[8]=e[8]+a[8]*b;g[9]=e[9]+a[9]*b;g[10]=e[10]+a[10]*b;g[11]=e[11]+a[11]*b;g[12]=e[12]+a[12]*b;g[13]=e[13]+a[13]*b;g[14]=e[14]+a[14]*b;g[15]=e[15]+a[15]*b;return g};quat.fromAxisAngle=function(g,e){var a=quat.create();e*=0.5;var b=Math.sin(e);a[0]=b*g[0];a[1]=b*g[1];a[2]=b*g[2];a[3]=Math.cos(e);return a};quat.toEuler=function(g,e){var a=Math.atan2(2*
e[1]*e[3]-2*e[0]*e[2],1-2*e[1]*e[1]-2*e[2]*e[2]),b=Math.asin(2*e[0]*e[1]+2*e[2]*e[3]),c=Math.atan2(2*e[0]*e[3]-2*e[1]*e[2],1-2*e[0]*e[0]-2*e[2]*e[2]);g||(g=vec3.create());vec3.set(g,a,b,c);return g};quat.fromEuler=function(g,e){var a=e[0],b=e[1],c=e[2],d=Math.cos(a),f=Math.cos(b),k=Math.cos(c),a=Math.sin(a),b=Math.sin(b),c=Math.sin(c),h=0.5*Math.sqrt(1+d*f+d*k-a*b*c+f*k);0==h&&(h=1E-6);quat.set(g,(f*c+d*c+a*b*k)/(4*h),(a*f+a*k+d*b*c)/(4*h),(-a*c+d*b*k+b)/(4*h),h);quat.normalize(g,g);return g};quat.fromMat4=
function(g,e){var a=e[0]+e[5]+e[10];if(0<a){var b=Math.sqrt(a+1);g[3]=0.5*b;b=0.5/b;g[0]=(e[9]-e[6])*b;g[1]=(e[2]-e[8])*b;g[2]=(e[4]-e[1])*b}else{a=0;e[5]>e[0]&&(a=1);e[10]>e[4*a+a]&&(a=2);var c=(a+1)%3,d=(c+1)%3,b=Math.sqrt(e[4*a+a]-e[4*c+c]-e[4*d+d]+1);g[a]=0.5*b;b=0.5/b;g[3]=(e[4*d+c]-e[4*c+d])*b;g[c]=(e[4*c+a]+e[4*a+c])*b;g[d]=(e[4*d+a]+e[4*a+d])*b}quat.normalize(g,g)};quat.fromMat4.lookAt=function(){var g=vec3.create();return function(e,a,b){b=vec3.dot(vec3.FRONT,a);if(1E-6>Math.abs(b- -1))return e.set(vec3.UP),
e[3]=Math.PI,e;if(1E-6>Math.abs(b-1))return quat.identity(e);b=Math.acos(b);vec3.cross(g,vec3.FRONT,a);vec3.normalize(g,g);quat.setAxisAngle(e,g,b);return e}}();h.Indexer=function(){this.unique=[];this.indices=[];this.map={}};h.Indexer.prototype={add:function(g){var e=JSON.stringify(g);e in this.map||(this.map[e]=this.unique.length,this.unique.push(g));return this.map[e]}};h.Buffer=function(g,e,a,b,c){h.debug&&console.log("GL.Buffer created");null!==c&&(c=c||n.gl);this.gl=c;this.buffer=null;this.target=
g;this.attribute=null;this.data=e;this.spacing=a||3;this.data&&this.gl&&this.upload(b)};h.Buffer.prototype.bind=function(g,e){e=e||this.gl;e.bindBuffer(e.ARRAY_BUFFER,this.buffer);e.enableVertexAttribArray(g);e.vertexAttribPointer(g,this.spacing,this.buffer.gl_type,!1,0,0)};h.Buffer.prototype.unbind=function(g,e){e=e||this.gl;e.disableVertexAttribArray(g)};h.Buffer.prototype.forEach=function(g){for(var e=this.data,a=0,b=this.spacing,c=e.length;a<c;a+=b)g(e.subarray(a,a+b),a);return this};h.Buffer.prototype.applyTransform=
function(g){for(var e=this.data,a=0,b=this.spacing,c=e.length;a<c;a+=b){var d=e.subarray(a,a+b);vec3.transformMat4(d,d,g)}return this};h.Buffer.prototype.upload=function(g){var e=this.spacing||3,a=this.gl;if(a){if(!this.data)throw"No data supplied";var b=this.data;if(!b.buffer)throw"Buffers must be typed arrays";if(this.buffer=this.buffer||a.createBuffer()){this.buffer.length=b.length;this.buffer.spacing=e;switch(b.constructor){case Int8Array:this.buffer.gl_type=a.BYTE;break;case Uint8ClampedArray:case Uint8Array:this.buffer.gl_type=
a.UNSIGNED_BYTE;break;case Int16Array:this.buffer.gl_type=a.SHORT;break;case Uint16Array:this.buffer.gl_type=a.UNSIGNED_SHORT;break;case Int32Array:this.buffer.gl_type=a.INT;break;case Uint32Array:this.buffer.gl_type=a.UNSIGNED_INT;break;case Float32Array:this.buffer.gl_type=a.FLOAT;break;default:throw"unsupported buffer type";}this.target!=a.ARRAY_BUFFER||this.buffer.gl_type!=a.INT&&this.buffer.gl_type!=a.UNSIGNED_INT||(console.warn("WebGL does not support UINT32 or INT32 as vertex buffer types, converting to FLOAT"),
this.buffer.gl_type=a.FLOAT,b=new Float32Array(b));a.bindBuffer(this.target,this.buffer);a.bufferData(this.target,b,g||this.stream_type||a.STATIC_DRAW)}}};h.Buffer.prototype.compile=h.Buffer.prototype.upload;h.Buffer.prototype.setData=function(g,e){if(!g.buffer)throw"Data must be typed array";e=e||0;if(this.data){if(this.data.length<g.length)throw"buffer is not big enough, you cannot set data to a smaller buffer";if(this.data!=g)if(this.data.length==g.length)this.data.set(g),this.upload();else{var a=
new Uint8Array(g.buffer,g.buffer.byteOffset,g.buffer.byteLength);(new Uint8Array(this.data.buffer)).set(a,e);this.uploadRange(e,a.length)}}else this.data=g,this.upload()};h.Buffer.prototype.uploadRange=function(g,e){if(!this.data)throw"No data stored in this buffer";if(!this.data.buffer)throw"Buffers must be typed arrays";var a=new Uint8Array(this.data.buffer,g,e),b=this.gl;b.bindBuffer(this.target,this.buffer);b.bufferSubData(this.target,g,a)};h.Buffer.prototype.clone=function(g){var e=new h.Buffer;
if(g)for(var a in this)e[a]=this[a];else this.target&&(e.target=this.target),this.gl&&(e.gl=this.gl),this.spacing&&(e.spacing=this.spacing),this.data&&(e.data=new n[this.data.constructor](this.data),e.upload());return e};h.Buffer.prototype.toJSON=function(){return this.data?{data_type:getClassName(this.data),data:this.data.toJSON(),target:this.target,attribute:this.attribute,spacing:this.spacing}:(console.error("cannot serialize a mesh without data"),null)};h.Buffer.prototype.fromJSON=function(g){this.data=
new (n[g.data_type]||Float32Array)(g.data);this.target=g.target;this.spacing=g.spacing||3;this.attribute=g.attribute;this.upload(h.STATIC_DRAW)};h.Buffer.prototype.delete=function(){this.gl.deleteBuffer(this.buffer);this.buffer=null};n.Mesh=h.Mesh=function(g,e,a,b){h.debug&&console.log("GL.Mesh created");null!==b&&(this.gl=b=b||n.gl);this._context_id=b.context_id;this.vertexBuffers={};this.indexBuffers={};this.info={groups:[]};this._bounding=BBox.create();(g||e)&&this.addBuffers(g,e,a?a.stream_type:
null);if(a)for(var c in a)this[c]=a[c]};Mesh.common_buffers={vertices:{spacing:3,attribute:"a_vertex"},vertices2D:{spacing:2,attribute:"a_vertex2D"},normals:{spacing:3,attribute:"a_normal"},coords:{spacing:2,attribute:"a_coord"},coords1:{spacing:2,attribute:"a_coord1"},coords2:{spacing:2,attribute:"a_coord2"},colors:{spacing:4,attribute:"a_color"},tangents:{spacing:3,attribute:"a_tangent"},bone_indices:{spacing:4,attribute:"a_bone_indices",type:Uint8Array},weights:{spacing:4,attribute:"a_weights"},
extra:{spacing:1,attribute:"a_extra"},extra2:{spacing:2,attribute:"a_extra2"},extra3:{spacing:3,attribute:"a_extra3"},extra4:{spacing:4,attribute:"a_extra4"}};Mesh.default_datatype=Float32Array;Object.defineProperty(Mesh.prototype,"bounding",{set:function(g){if(g){if(13>g.length)throw"Bounding must use the BBox bounding format of 13 floats: center, halfsize, min, max, radius";this._bounding.set(g)}},get:function(){return this._bounding}});Mesh.prototype.addBuffer=function(g,e){e.target==gl.ARRAY_BUFFER?
this.vertexBuffers[g]=e:this.indexBuffers[g]=e;e.attribute||(e.attribute=h.Mesh.common_buffers[g].attribute)};Mesh.prototype.addBuffers=function(g,e,a){var b=0;this.vertexBuffers.vertices&&(b=this.vertexBuffers.vertices.data.length/3);for(var c in g){var d=g[c];if(d){if(d.constructor==h.Buffer)d=d.data;else if("number"!=typeof d[0]){for(var f=[],k=0,s=1E4;k<d.length;k+=s)f=Array.prototype.concat.apply(f,d.slice(k,k+s));d=f}f=h.Mesh.common_buffers[c];d.constructor===Array&&(k=h.Mesh.default_datatype,
f&&f.type&&(k=f.type),d=new k(d));"vertices"==c&&(b=d.length/3);k=d.length/b;f&&f.spacing&&(k=f.spacing);s="a_"+c;f&&f.attribute&&(s=f.attribute);this.vertexBuffers[c]?this.updateVertexBuffer(c,s,k,d,a):this.createVertexBuffer(c,s,k,d,a)}}if(e)for(c in e)if(d=e[c]){d.constructor==h.Buffer&&(d=d.data);if("number"!=typeof d[0]){f=[];c=0;for(s=1E4;c<d.length;c+=s)f=Array.prototype.concat.apply(f,d.slice(c,c+s));d=f}d.constructor===Array&&(k=Uint16Array,65536<b&&(k=Uint32Array),d=new k(d));this.createIndexBuffer(c,
d)}};Mesh.prototype.createVertexBuffer=function(g,e,a,b,c){var d=h.Mesh.common_buffers[g];!e&&d&&(e=d.attribute);if(!e)throw"Buffer added to mesh without attribute name";!a&&d&&(a=d&&d.spacing?d.spacing:3);if(!b){b=this.getNumVertices();if(!b)throw"Cannot create an empty buffer in a mesh without vertices (vertices are needed to know the size)";b=new h.Mesh.default_datatype(b*a)}if(!b.buffer)throw"Buffer data MUST be typed array";a=this.vertexBuffers[g]=new h.Buffer(gl.ARRAY_BUFFER,b,a,c,this.gl);
a.name=g;a.attribute=e;return a};Mesh.prototype.updateVertexBuffer=function(g,e,a,b,c){var d=this.vertexBuffers[g];d?b.length&&(d.attribute=e,d.spacing=a,d.data=b,d.upload(c)):console.log("buffer not found: ",g)};Mesh.prototype.removeVertexBuffer=function(g,e){var a=this.vertexBuffers[g];a&&(e&&a.delete(),delete this.vertexBuffers[g])};Mesh.prototype.getVertexBuffer=function(g){return this.vertexBuffers[g]};Mesh.prototype.createIndexBuffer=function(g,e,a){if(e.constructor===Array){var b=Uint16Array,
c=this.vertexBuffers.vertices;c&&(65536<c.data.length/3&&(b=Uint32Array),e=new b(e))}return this.indexBuffers[g]=new h.Buffer(gl.ELEMENT_ARRAY_BUFFER,e,0,a,this.gl)};Mesh.prototype.getBuffer=function(g){return this.vertexBuffers[g]};Mesh.prototype.getIndexBuffer=function(g){return this.indexBuffers[g]};Mesh.prototype.removeIndexBuffer=function(g,e){var a=this.indexBuffers[g];a&&(e&&a.delete(),delete this.indexBuffers[g])};Mesh.prototype.upload=function(g){for(var e in this.vertexBuffers){var a=this.vertexBuffers[e];
a.upload(g)}for(var b in this.indexBuffers)a=this.indexBuffers[b],a.upload()};Mesh.prototype.compile=Mesh.prototype.upload;Mesh.prototype.deleteBuffers=function(){for(var g in this.vertexBuffers){var e=this.vertexBuffers[g];e.delete()}this.vertexBuffers={};for(g in this.indexBuffers)e=this.indexBuffers[g],e.delete();this.indexBuffers={}};Mesh.prototype.delete=Mesh.prototype.deleteBuffers;Mesh.prototype.bindBuffers=function(g){for(var e in this.vertexBuffers){var a=this.vertexBuffers[e],b=g.attributes[a.attribute||
e];null!=b&&a.buffer&&(gl.bindBuffer(gl.ARRAY_BUFFER,a.buffer),gl.enableVertexAttribArray(b),gl.vertexAttribPointer(b,a.buffer.spacing,a.buffer.gl_type,!1,0,0))}};Mesh.prototype.unbindBuffers=function(g){for(var e in this.vertexBuffers){var a=this.vertexBuffers[e],b=a.attribute||e;null!=g.attributes[b]&&a.buffer&&gl.disableVertexAttribArray(g.attributes[b])}};Mesh.prototype.clone=function(g){g=g||n.gl;var e={},a={},b;for(b in this.vertexBuffers){var c=this.vertexBuffers[b];e[b]=new c.data.constructor(c.data)}for(b in this.indexBuffers)c=
this.indexBuffers[b],a[b]=new c.data.constructor(c.data);return new h.Mesh(e,a,void 0,g)};Mesh.prototype.cloneShared=function(g){g=g||n.gl;return new h.Mesh(this.vertexBuffers,this.indexBuffers,void 0,g)};Mesh.prototype.toObject=function(){var g={},e={},a;for(a in this.vertexBuffers){var b=this.vertexBuffers[a];g[a]={spacing:b.spacing,data:new b.data.constructor(b.data)}}for(a in this.indexBuffers)b=this.indexBuffers[a],e[a]={data:new b.data.constructor(b.data)};return{vertexBuffers:g,indexBuffers:e,
info:this.info?cloneObject(this.info):null,bounding:this._bounding.toJSON()}};Mesh.prototype.toJSON=function(){var g={vertexBuffers:{},indexBuffers:{},info:this.info?cloneObject(this.info):null,bounding:this._bounding.toJSON()},e;for(e in this.vertexBuffers)g.vertexBuffers[e]=this.vertexBuffers[e].toJSON();for(e in this.indexBuffers)g.indexBuffers[e]=this.indexBuffers[e].toJSON();return g};Mesh.prototype.fromJSON=function(g){this.vertexBuffers={};this.indexBuffers={};for(var e in g.vertexBuffers)if(g.vertexBuffers[e]){var a=
new h.Buffer;a.fromJSON(g.vertexBuffers[e]);!a.attribute&&h.Mesh.common_buffers[e]&&(a.attribute=h.Mesh.common_buffers[e].attribute);this.vertexBuffers[e]=a}for(e in g.indexBuffers)g.indexBuffers[e]&&(a=new h.Buffer,a.fromJSON(g.indexBuffers[e]),this.indexBuffers[e]=a);g.info&&(this.info=cloneObject(g.info));g.bounding&&(this.bounding=g.bounding)};Mesh.prototype.generateMetadata=function(){var g={},e=this.vertexBuffers.vertices.data,a=this.indexBuffers.triangles.data;g.vertices=e.length/3;g.faces=
a?a.length/3:e.length/9;g.indexed=!!this.metadata.faces;this.metadata=g};Mesh.prototype.computeWireframe=function(){var g=this.indexBuffers.triangles,e=this.vertexBuffers.vertices.data.length/3;if(g){for(var a=g.data,b=new h.Indexer,g=0;g<a.length;g+=3)for(var c=a.subarray(g,g+3),d=0;d<c.length;d++){var f=c[d],k=c[(d+1)%c.length];b.add([Math.min(f,k),Math.max(f,k)])}a=b.unique;b=65536<e?new Uint32Array(2*a.length):new Uint16Array(2*a.length);g=0;for(e=a.length;g<e;++g)b.set(a[g],2*g)}else for(g=e/
3,b=65536<e?new Uint32Array(6*g):new Uint16Array(6*g),g=0;g<e;g+=3)b[2*g]=g,b[2*g+1]=g+1,b[2*g+2]=g+1,b[2*g+3]=g+2,b[2*g+4]=g+2,b[2*g+5]=g;this.createIndexBuffer("wireframe",b);return this};Mesh.prototype.flipNormals=function(g){var e=this.vertexBuffers.normals;if(e){for(var a=e.data,b=a.length,c=0;c<b;++c)a[c]*=-1;e.upload(g);this.indexBuffers.triangles||this.computeIndices();e=this.indexBuffers.triangles;a=e.data;b=a.length;for(c=0;c<b;c+=3){var d=a[c];a[c]=a[c+1];a[c+1]=d}e.upload(g)}};Mesh.prototype.computeIndices=
function(){var g=[],e=[],a=[],b=[],c=this.vertexBuffers.normals,d=this.vertexBuffers.coords,f=this.vertexBuffers.vertices.data,k=null;c&&(k=c.data);c=null;d&&(c=d.data);for(var d={},s=f.length/3,l=0;l<s;++l){var m=f.subarray(3*l,3*(l+1)),p=1E3*m[0]|0,q=0,r=d[p];if(r)for(var w=r.length;q<w;q++)if(0.01>vec3.sqrDist(m,g[r[q]])){b.push(q);break}r&&q!=w||(g.push(m),d[p]?d[p].push(q):d[p]=[q],k&&e.push(k.subarray(3*l,3*(l+1))),c&&a.push(c.subarray(2*l,2*(l+1))),b.push(q))}this.vertexBuffers={};this.createVertexBuffer("vertices",
h.Mesh.common_buffers.vertices.attribute,3,P(g));k&&this.createVertexBuffer("normals",h.Mesh.common_buffers.normals.attribute,3,P(e));c&&this.createVertexBuffer("coords",h.Mesh.common_buffers.coords.attribute,2,P(a));this.createIndexBuffer("triangles",b)};Mesh.prototype.explodeIndices=function(g){g=g||"triangles";var e=this.getIndexBuffer(g);if(e){var e=e.data,a=new Float32Array(3*e.length),b=null,c=null,d=this.vertexBuffers.vertices.data,f=this.vertexBuffers.normals,k=null;f&&(k=f.data,b=new Float32Array(3*
e.length));var s=this.vertexBuffers.coords,f=null;s&&(f=s.data,c=new Float32Array(2*e.length));for(var s=0,l=e.length;s<l;++s){var m=e[s];a.set(d.subarray(3*m,3*m+3),3*s);k&&b.set(k.subarray(3*m,3*m+3),3*s);f&&c.set(f.subarray(2*m,2*m+2),2*s)}this.vertexBuffers={};this.createVertexBuffer("vertices",h.Mesh.common_buffers.vertices.attribute,3,a);b&&this.createVertexBuffer("normals",h.Mesh.common_buffers.normals.attribute,3,b);c&&this.createVertexBuffer("coords",h.Mesh.common_buffers.coords.attribute,
2,c);delete this.indexBuffers[g]}};Mesh.prototype.computeNormals=function(g){if(!this.vertexBuffers.vertices)return console.error("Cannot compute normals of a mesh without vertices");var e=this.vertexBuffers.vertices.data,a=new Float32Array(e.length),b=null;this.indexBuffers.triangles&&(b=this.indexBuffers.triangles.data);for(var c=h.temp_vec3,d=h.temp2_vec3,f,k,s,l,m,p,q=b?b.length:e.length,r=0;r<q;r+=3)b?(f=b[r],k=b[r+1],s=b[r+2],l=e.subarray(3*f,3*f+3),m=e.subarray(3*k,3*k+3),p=e.subarray(3*s,
3*s+3),f=a.subarray(3*f,3*f+3),k=a.subarray(3*k,3*k+3),s=a.subarray(3*s,3*s+3)):(l=e.subarray(3*r,3*r+3),m=e.subarray(3*r+3,3*r+6),p=e.subarray(3*r+6,3*r+9),f=a.subarray(3*r,3*r+3),k=a.subarray(3*r+3,3*r+6),s=a.subarray(3*r+6,3*r+9)),vec3.sub(c,m,l),vec3.sub(d,p,l),vec3.cross(c,c,d),vec3.normalize(c,c),vec3.add(f,f,c),vec3.add(k,k,c),vec3.add(s,s,c);if(b)for(r=0,q=a.length;r<q;r+=3)e=a.subarray(r,r+3),vec3.normalize(e,e);if(q=this.vertexBuffers.normals)q.data=a,q.upload(g);else return this.createVertexBuffer("normals",
h.Mesh.common_buffers.normals.attribute,3,a);return q};Mesh.prototype.computeTangents=function(){var g=this.vertexBuffers.vertices;if(!g)return console.error("Cannot compute tangents of a mesh without vertices");var e=this.vertexBuffers.normals;if(!e)return console.error("Cannot compute tangents of a mesh without normals");var a=this.vertexBuffers.coords;if(!a)return console.error("Cannot compute tangents of a mesh without uvs");var b=this.indexBuffers.triangles;if(!b)return console.error("Cannot compute tangents of a mesh without indices");
var g=g.data,e=e.data,c=a.data,d=b.data;if(g&&e&&c){var f=g.length/3,b=new Float32Array(4*f),a=new Float32Array(6*f),f=a.subarray(3*f),k,h,l=vec3.create(),m=vec3.create(),p=vec3.create(),q=vec3.create();k=0;for(h=d.length;k<h;k+=3){var r=d[k],w=d[k+1],n=d[k+2],t=g.subarray(3*r,3*r+3),z=g.subarray(3*w,3*w+3),x=g.subarray(3*n,3*n+3),M=c.subarray(2*r,2*r+2),A=c.subarray(2*w,2*w+2),K=c.subarray(2*n,2*n+2),S=z[0]-t[0],u=x[0]-t[0],y=z[1]-t[1],G=x[1]-t[1],z=z[2]-t[2],t=x[2]-t[2],x=A[0]-M[0],N=K[0]-M[0],
A=A[1]-M[1],M=K[1]-M[1],K=x*M-N*A,K=1E-9>Math.abs(K)?0:1/K;vec3.copy(l,[(M*S-A*u)*K,(M*y-A*G)*K,(M*z-A*t)*K]);vec3.copy(m,[(x*u-N*S)*K,(x*G-N*y)*K,(x*t-N*z)*K]);vec3.add(a.subarray(3*r,3*r+3),a.subarray(3*r,3*r+3),l);vec3.add(a.subarray(3*w,3*w+3),a.subarray(3*w,3*w+3),l);vec3.add(a.subarray(3*n,3*n+3),a.subarray(3*n,3*n+3),l);vec3.add(f.subarray(3*r,3*r+3),f.subarray(3*r,3*r+3),m);vec3.add(f.subarray(3*w,3*w+3),f.subarray(3*w,3*w+3),m);vec3.add(f.subarray(3*n,3*n+3),f.subarray(3*n,3*n+3),m)}k=0;
for(h=g.length;k<h;k+=3)g=e.subarray(k,k+3),c=a.subarray(k,k+3),vec3.subtract(p,c,vec3.scale(p,g,vec3.dot(g,c))),vec3.normalize(p,p),g=0>vec3.dot(vec3.cross(q,g,c),f.subarray(k,k+3))?-1:1,b.set([p[0],p[1],p[2],g],k/3*4);this.createVertexBuffer("tangents",Mesh.common_buffers.tangents.attribute,4,b)}};Mesh.prototype.computeTextureCoordinates=function(g){var e=this.vertexBuffers.vertices;if(!e)return console.error("Cannot compute uvs of a mesh without vertices");this.explodeIndices("triangles");var e=
e.data,a=this.vertexBuffers.coords,b=new Float32Array(e.length/3*2),c=this.indexBuffers.triangles,d=null;c&&(d=c.data);var c=vec3.create(),f=vec3.create(),k=vec3.create(),h=this.getBoundingBox(),l=BBox.getCenter(h),m=vec3.create();m.set(BBox.getHalfsize(h));vec3.scale(m,m,2);for(var h=d?d.length:e.length/3,p=0;p<h;p+=3){if(d)var q=d[p],r=d[p+1],w=d[p+2],n=e.subarray(3*q,3*q+3),t=e.subarray(3*r,3*r+3),z=e.subarray(3*w,3*w+3),q=b.subarray(2*q,2*q+2),r=b.subarray(2*r,2*r+2),w=b.subarray(2*w,2*w+2);else n=
e.subarray(3*p,3*p+3),t=e.subarray(3*(p+1),3*(p+1)+3),z=e.subarray(3*(p+2),3*(p+2)+3),q=b.subarray(2*p,2*p+2),r=b.subarray(2*(p+1),2*(p+1)+2),w=b.subarray(2*(p+2),2*(p+2)+2);vec3.sub(f,n,t);vec3.sub(k,n,z);vec3.cross(c,f,k);c[0]=Math.abs(c[0]);c[1]=Math.abs(c[1]);c[2]=Math.abs(c[2]);c[0]>c[1]&&c[0]>c[2]?(q[0]=(n[2]-l[2])/m[2],q[1]=(n[1]-l[1])/m[1],r[0]=(t[2]-l[2])/m[2],r[1]=(t[1]-l[1])/m[1],w[0]=(z[2]-l[2])/m[2],w[1]=(z[1]-l[1])/m[1]):c[1]>c[2]?(q[0]=(n[0]-l[0])/m[0],q[1]=(n[2]-l[2])/m[2],r[0]=(t[0]-
l[0])/m[0],r[1]=(t[2]-l[2])/m[2],w[0]=(z[0]-l[0])/m[0],w[1]=(z[2]-l[2])/m[2]):(q[0]=(n[0]-l[0])/m[0],q[1]=(n[1]-l[1])/m[1],r[0]=(t[0]-l[0])/m[0],r[1]=(t[1]-l[1])/m[1],w[0]=(z[0]-l[0])/m[0],w[1]=(z[1]-l[1])/m[1])}a?(a.data=b,a.upload(g)):this.createVertexBuffer("coords",Mesh.common_buffers.coords.attribute,2,b)};Mesh.prototype.getNumVertices=function(){var g=this.vertexBuffers.vertices;return g?g.data.length/g.spacing:0};Mesh.computeBoundingBox=function(g,e,a){if(g){var b=0;if(a){for(var c=0;c<a.length;++c)if(a[c]){b=
c;break}if(b==a.length){console.warn("mask contains only zeros, no vertices marked");return}}for(var d=vec3.clone(g.subarray(3*b,3*b+3)),f=vec3.clone(g.subarray(3*b,3*b+3)),c=3*b;c<g.length;c+=3)if(!a||a[c/3])b=g.subarray(c,c+3),vec3.min(d,b,d),vec3.max(f,b,f);if(isNaN(d[0])||isNaN(d[1])||isNaN(d[2])||isNaN(f[0])||isNaN(f[1])||isNaN(f[2]))d[0]=d[1]=d[2]=0,f[0]=f[1]=f[2]=0,console.warn("Warning: GL.Mesh has NaN values in vertices");g=vec3.add(vec3.create(),d,f);vec3.scale(g,g,0.5);f=vec3.subtract(vec3.create(),
f,g);return BBox.setCenterHalfsize(e||BBox.create(),g,f)}};Mesh.prototype.getBoundingBox=function(){if(this._bounding)return this._bounding;this.updateBoundingBox();return this._bounding};Mesh.prototype.updateBoundingBox=function(){var g=this.vertexBuffers.vertices;g&&(h.Mesh.computeBoundingBox(g.data,this._bounding),this.info&&this.info.groups&&this.info.groups.length&&this.computeGroupsBoundingBoxes())};Mesh.prototype.computeGroupsBoundingBoxes=function(){var g=null,e=this.getIndexBuffer("triangles");
e&&(g=e.data);e=this.getVertexBuffer("vertices");if(!e)return!1;e=e.data;if(!e.length)return!1;for(var a=this.info.groups,b=0;b<a.length;++b){var c=a[b];c.bounding=c.bounding||BBox.create();var d=null;if(g){for(var d=new Uint8Array(e.length/3),f=c.start,k=0,s=c.length;k<s;k+=3)d[g[f+k]]=1,d[g[f+k+1]]=1,d[g[f+k+2]]=1;h.Mesh.computeBoundingBox(e,c.bounding,d)}else d=e.subarray(3*c.start,3*(c.start+c.length)),h.Mesh.computeBoundingBox(d,c.bounding)}return!0};Mesh.prototype.setBoundingBox=function(g,
e){BBox.setCenterHalfsize(this._bounding,g,e)};Mesh.prototype.freeData=function(){for(var g in this.vertexBuffers)this.vertexBuffers[g].data=null,delete this[this.vertexBuffers[g].name];for(var e in this.indexBuffers)this.indexBuffers[e].data=null,delete this[this.indexBuffers[e].name]};Mesh.prototype.configure=function(g,e){var a={},b={};e=e||{};for(var c in g)if(g[c])if("vertexBuffers"==c||"vertex_buffers"==c)for(d in g[c])a[d]=g[c][d];else if("indexBuffers"==c||"index_buffers"==c)for(d in g[c])b[d]=
g[c][d];else"indices"==c||"lines"==c||"wireframe"==c||"triangles"==c?b[c]=g[c]:h.Mesh.common_buffers[c]?a[c]=g[c]:e[c]=g[c];this.addBuffers(a,b,e.stream_type);for(var d in e)this[d]=e[d];e.bounding||this.updateBoundingBox()};Mesh.prototype.totalMemory=function(){var g=0,e;for(e in this.vertexBuffers)g+=this.vertexBuffers[e].data.buffer.byteLength;for(e in this.indexBuffers)g+=this.indexBuffers[e].data.buffer.byteLength;return g};Mesh.prototype.simplify=function(){var g=this.getBoundingBox(),e=BBox.getMin(g),
g=BBox.getHalfsize(g),g=vec3.scale(vec3.create(),g,2),a=new h.Mesh,b=vec3.create(),c;for(c in this.vertexBuffers){var d=this.vertexBuffers[c].data,f=new Float32Array(d.length);if("vertices"==c)for(var k=0,s=d.length;k<s;k+=3){var l=d.subarray(k,k+3);vec3.sub(b,l,e);vec3.div(b,b,g);b[0]=Math.round(256*b[0])/256;b[1]=Math.round(256*b[1])/256;b[2]=Math.round(256*b[2])/256;vec3.mul(b,b,g);vec3.add(b,b,e);f.set(b,k)}a.addBuffer()}};Mesh.load=function(g,e,a,b){e=e||{};e.no_gl&&(b=null);a=a||new h.Mesh(null,
null,null,b);a.configure(g,e);return a};Mesh.mergeMeshes=function(g,e){function a(a,b,c,d){for(c=b+c;b<c;b+=3){var e=a.subarray(b,b+3);vec3.transformMat4(e,e,d)}}function b(a,b,c,d){for(c=b+c;b<c;b+=2){var e=a.subarray(b,b+2);vec2.transformMat3(e,e,d)}}function c(a,b,c,d){for(c=b+c;b<c;++b)a[b]+=d}e=e||{};for(var d={},f={},k={},s=[],l=0,m=[],p=0;p<g.length;++p){var q=g[p],r=q.mesh,w=l;s.push(w);var n=r.vertexBuffers.vertices.data.length/3,l=l+n,t;for(t in r.vertexBuffers)d[t]=d[t]?d[t]+r.vertexBuffers[t].data.length:
r.vertexBuffers[t].data.length;for(t in r.indexBuffers)f[t]=f[t]?f[t]+r.indexBuffers[t].data.length:r.indexBuffers[t].data.length;m.push({name:"mesh_"+p,start:w,length:n,material:""})}for(t in d)p=e[t],null===p?delete d[t]:(p||(p=Float32Array),d[t]=new p(d[t]),k[t]=0);for(t in f)f[t]=new Uint32Array(f[t]),k[t]=0;for(p=0;p<g.length;++p){q=g[p];r=q.mesh;n=w=0;for(t in r.vertexBuffers)d[t]&&("vertices"==t&&(n=r.vertexBuffers[t].data.length/3),d[t].set(r.vertexBuffers[t].data,k[t]),q[t+"_matrix"]&&(l=
q[t+"_matrix"],16==l.length?a(d[t],k[t],r.vertexBuffers[t].data.length,l):9==l.length&&b(d[t],k[t],r.vertexBuffers[t].data.length,l)),k[t]+=r.vertexBuffers[t].data.length);for(t in r.indexBuffers)f[t].set(r.indexBuffers[t].data,k[t]),c(f[t],k[t],r.indexBuffers[t].data.length,s[p]),k[t]+=r.indexBuffers[t].data.length}k={info:{groups:m}};return"undefined"!=typeof gl||e.only_data?new h.Mesh(d,f,k):{vertexBuffers:d,indexBuffers:f,info:{groups:m}}};Mesh.parsers={};Mesh.encoders={};Mesh.binary_file_formats=
{};Mesh.compressors={};Mesh.decompressors={};Mesh.fromURL=function(g,e,a,b){b=b||{};a=a||n.gl;var c=new h.Mesh(void 0,void 0,void 0,a);c.ready=!1;a=g.lastIndexOf(".");var d=g.substr(a+1).toLowerCase();b.binary=Mesh.binary_file_formats[d];HttpRequest(g,null,function(a){c.parse(a,d);delete c.ready;e&&e.call(c,c,g)},function(a){e&&e(null)},b);return c};Mesh.prototype.parse=function(g,e){e=e.toLowerCase();var a=h.Mesh.parsers[e];if(a)return a.call(null,g,{mesh:this});throw"GL.Mesh.parse: no parser found for format "+
e;};Mesh.prototype.encode=function(g,e){g=g.toLowerCase();var a=h.Mesh.encoders[g];if(a)return a.call(null,this,e);throw"GL.Mesh.encode: no encoder found for format "+g;};Mesh.getScreenQuad=function(g){g=g||n.gl;var e=g.meshes[":screen_quad"];if(e)return e;var e=new Float32Array([0,0,0,1,1,0,0,1,0,0,0,0,1,0,0,1,1,0]),a=new Float32Array([0,0,1,1,0,1,0,0,1,0,1,1]),e=new h.Mesh({vertices:e,coords:a},void 0,void 0,g);return g.meshes[":screen_quad"]=e};h.linearizeArray=P;h.Mesh.EXTENSION="wbin";h.Mesh.enable_wbin_compression=
!0;G.DEFAULT_NORMAL=vec3.fromValues(0,1,0);G.DEFAULT_COORD=vec2.fromValues(0.5,0.5);G.DEFAULT_COLOR=vec4.fromValues(1,1,1,1);G.prototype.resize=function(g){var e={};this._vertex_data=new Float32Array(3*g);e.vertices=this._vertex_data;normals&&(e.normals=this._normal_data=new Float32Array(3*g));coords&&(e.coords=this._coord_data=new Float32Array(2*g));colors&&(e.colors=this._color_data=new Float32Array(4*g));this.addBuffers(e);this.current_pos=0;this.max_size=g;this._must_update=!0};G.prototype.clear=
function(){this.current_pos=0};G.prototype.addPoint=function(g,e,a,b){if(c>=this.max_size)return console.warn("DynamicMesh: not enough space, reserve more"),!1;var c=this.current_pos++;this._vertex_data.set(g,3*c);this._normal_data&&this._normal_data.set(e||G.DEFAULT_NORMAL,3*c);this._coord_data&&this._coord_data.set(a||G.DEFAULT_COORD,2*c);this._color_data&&this._color_data.set(b||G.DEFAULT_COLOR,4*c);return this._must_update=!0};G.prototype.update=function(g){if(!this._must_update&&!g)return this.current_pos;
this._must_update=!1;this.getBuffer("vertices").upload(gl.STREAM_DRAW);this._normal_data&&this.getBuffer("normal").upload(gl.STREAM_DRAW);this._coord_data&&this.getBuffer("coord").upload(gl.STREAM_DRAW);this._color_data&&this.getBuffer("color").upload(gl.STREAM_DRAW);return this.current_pos};extendClass(G,Mesh);Mesh.plane=function(g,e){g=g||{};g.triangles=[];var a=g.detailX||g.detail||1,b=g.detailY||g.detail||1,c=g.width||g.size||1,d=g.height||g.size||1,f=g.xz,c=0.5*c,d=0.5*d,k=[],s=[],l=[],m=[],
p=vec3.fromValues(0,0,1);f&&p.set([0,1,0]);for(var q=0;q<=b;q++)for(var r=q/b,w=0;w<=a;w++){var n=w/a;f?s.push((2*n-1)*c,0,-(2*r-1)*d):s.push((2*n-1)*c,(2*r-1)*d,0);l.push(n,r);m.push(p[0],p[1],p[2]);w<a&&q<b&&(n=w+q*(a+1),f?(k.push(n+1,n+a+1,n),k.push(n+1,n+a+2,n+a+1)):(k.push(n,n+1,n+a+1),k.push(n+a+1,n+1,n+a+2)))}a=BBox.fromCenterHalfsize([0,0,0],f?[c,0,d]:[c,d,0]);return h.Mesh.load({vertices:s,normals:m,coords:l,triangles:k},{bounding:a},e)};Mesh.plane2D=function(g,e){var a=new Float32Array([-1,
1,1,-1,1,1,-1,1,-1,-1,1,-1]),b=new Float32Array([0,1,1,0,1,1,0,1,0,0,1,0]);if(g&&g.size)for(var c=0.5*g.size,d=0;d<a.length;++d)a[d]*=c;return new h.Mesh({vertices2D:a,coords:b},null,e)};Mesh.point=function(g){return new h.Mesh({vertices:[0,0,0]})};Mesh.cube=function(g,e){g=g||{};var a=0.5*(g.size||1),b={};b.vertices=new Float32Array([-1,1,-1,-1,-1,1,-1,1,1,-1,1,-1,-1,-1,-1,-1,-1,1,1,1,-1,1,1,1,1,-1,1,1,1,-1,1,-1,1,1,-1,-1,-1,1,1,1,-1,1,1,1,1,-1,1,1,-1,-1,1,1,-1,1,-1,1,-1,1,1,-1,1,-1,-1,-1,1,-1,1,
-1,-1,-1,-1,-1,-1,1,-1,1,1,1,1,1,-1,-1,1,-1,-1,1,1,1,1,1,-1,-1,-1,1,-1,-1,1,-1,1,-1,-1,-1,1,-1,1,-1,-1,1]);for(var c=0,d=b.vertices.length;c<d;++c)b.vertices[c]*=a;b.normals=new Float32Array([-1,0,0,-1,0,0,-1,0,0,-1,0,0,-1,0,0,-1,0,0,1,0,0,1,0,0,1,0,0,1,0,0,1,0,0,1,0,0,0,0,1,0,0,1,0,0,1,0,0,1,0,0,1,0,0,1,0,0,-1,0,0,-1,0,0,-1,0,0,-1,0,0,-1,0,0,-1,0,1,0,0,1,0,0,1,0,0,1,0,0,1,0,0,1,0,0,-1,0,0,-1,0,0,-1,0,0,-1,0,0,-1,0,0,-1,0]);b.coords=new Float32Array([0,1,1,0,1,1,0,1,0,0,1,0,1,1,0,1,0,0,1,1,0,0,1,
0,0,1,1,0,1,1,0,1,0,0,1,0,1,1,0,1,0,0,1,1,0,0,1,0,0,1,1,0,1,1,0,1,0,0,1,0,1,1,0,1,0,0,1,1,0,0,1,0]);g.wireframe&&(b.wireframe=new Uint16Array([0,2,2,5,5,4,4,0,6,7,7,10,10,11,11,6,0,6,2,7,5,10,4,11]));g.bounding=BBox.fromCenterHalfsize([0,0,0],[a,a,a]);return h.Mesh.load(b,g,e)};Mesh.box=function(g,e){g=g||{};var a=g.sizex||1,b=g.sizey||1,c=g.sizez||1,a=0.5*a,b=0.5*b,c=0.5*c,d={};d.vertices=new Float32Array([-1,1,-1,-1,-1,1,-1,1,1,-1,1,-1,-1,-1,-1,-1,-1,1,1,1,-1,1,1,1,1,-1,1,1,1,-1,1,-1,1,1,-1,-1,
-1,1,1,1,-1,1,1,1,1,-1,1,1,-1,-1,1,1,-1,1,-1,1,-1,1,1,-1,1,-1,-1,-1,1,-1,1,-1,-1,-1,-1,-1,-1,1,-1,1,1,1,1,1,-1,-1,1,-1,-1,1,1,1,1,1,-1,-1,-1,1,-1,-1,1,-1,1,-1,-1,-1,1,-1,1,-1,-1,1]);for(var f=0,k=d.vertices.length;f<k;f+=3)d.vertices[f]*=a,d.vertices[f+1]*=b,d.vertices[f+2]*=c;d.normals=new Float32Array([-1,0,0,-1,0,0,-1,0,0,-1,0,0,-1,0,0,-1,0,0,1,0,0,1,0,0,1,0,0,1,0,0,1,0,0,1,0,0,0,0,1,0,0,1,0,0,1,0,0,1,0,0,1,0,0,1,0,0,-1,0,0,-1,0,0,-1,0,0,-1,0,0,-1,0,0,-1,0,1,0,0,1,0,0,1,0,0,1,0,0,1,0,0,1,0,0,-1,
0,0,-1,0,0,-1,0,0,-1,0,0,-1,0,0,-1,0]);d.coords=new Float32Array([0,1,1,0,1,1,0,1,0,0,1,0,1,1,0,1,0,0,1,1,0,0,1,0,0,1,1,0,1,1,0,1,0,0,1,0,1,1,0,1,0,0,1,1,0,0,1,0,0,1,1,0,1,1,0,1,0,0,1,0,1,1,0,1,0,0,1,1,0,0,1,0]);g.wireframe&&(d.wireframe=new Uint16Array([0,2,2,5,5,4,4,0,6,7,7,10,10,11,11,6,0,6,2,7,5,10,4,11]));g.bounding=BBox.fromCenterHalfsize([0,0,0],[a,b,c]);return h.Mesh.load(d,g,e)};Mesh.circle=function(g,e){g=g||{};var a=g.size||g.radius||1,b=Math.ceil(g.slices||24),c=g.xz||!1,d=g.empty||!1;
3>b&&(b=3);var f=2*Math.PI/b,k=vec3.create(),s=vec3.create(),l=vec3.fromValues(0,0,1),m=vec2.fromValues(0.5,0.5),p=vec2.create();c&&l.set([0,1,0]);var q=c?2:1,r=new Float32Array(3*(b+1)),n=new Float32Array(3*(b+1)),v=new Float32Array(2*(b+1)),t=null;r.set(k,0);n.set(l,0);v.set(m,0);for(k=m=t=0;k<b;++k)t=Math.sin(f*k),m=Math.cos(f*k),s[0]=t*a,s[q]=m*a,p[0]=0.5*t+0.5,p[1]=0.5*m+0.5,r.set(s,3*k+3),n.set(l,3*k+3),v.set(p,2*k+2);if(d)r=r.subarray(3),n=r.subarray(3),v=r.subarray(2),t=null;else{t=new Uint16Array(3*
b);d=2;f=1;c&&(d=1,f=2);for(k=0;k<b-1;++k)t[3*k]=0,t[3*k+1]=k+d,t[3*k+2]=k+f;t[3*k]=0;c?(t[3*k+1]=k+1,t[3*k+2]=1):(t[3*k+1]=1,t[3*k+2]=k+1)}g.bounding=BBox.fromCenterHalfsize([0,0,0],c?[a,0,a]:[a,a,0]);a={vertices:r,normals:n,coords:v,triangles:t};if(g.wireframe){c=new Uint16Array(2*b);for(k=0;k<b;k++)c[2*k]=k,c[2*k+1]=k+1;c[0]=b;a.wireframe=c}return h.Mesh.load(a,g,e)};Mesh.cylinder=function(g,e){g=g||{};for(var a=g.radius||g.size||1,b=g.height||g.size||2,c=g.subdivisions||64,d=new Float32Array(36*
c),f=new Float32Array(36*c),k=new Float32Array(24*c),h=2*Math.PI/c,l=null,m=0;m<c;++m){var p=m*h,l=[Math.sin(p),0,Math.cos(p)];d.set([l[0]*a,0.5*b,l[2]*a],18*m);f.set(l,18*m);k.set([m/c,1],12*m);l=[Math.sin(p),0,Math.cos(p)];d.set([l[0]*a,-0.5*b,l[2]*a],18*m+3);f.set(l,18*m+3);k.set([m/c,0],12*m+2);l=[Math.sin(p+h),0,Math.cos(p+h)];d.set([l[0]*a,-0.5*b,l[2]*a],18*m+6);f.set(l,18*m+6);k.set([(m+1)/c,0],12*m+4);l=[Math.sin(p+h),0,Math.cos(p+h)];d.set([l[0]*a,0.5*b,l[2]*a],18*m+9);f.set(l,18*m+9);k.set([(m+
1)/c,1],12*m+6);l=[Math.sin(p),0,Math.cos(p)];d.set([l[0]*a,0.5*b,l[2]*a],18*m+12);f.set(l,18*m+12);k.set([m/c,1],12*m+8);l=[Math.sin(p+h),0,Math.cos(p+h)];d.set([l[0]*a,-0.5*b,l[2]*a],18*m+15);f.set(l,18*m+15);k.set([(m+1)/c,0],12*m+10)}var l=18*m,q=12*m;if(!1===g.caps)d=d.subarray(0,l),f=f.subarray(0,l),k=k.subarray(0,q);else for(var r=vec3.fromValues(0,0.5*b,0),n=vec3.fromValues(0,-0.5*b,0),v=vec3.fromValues(0,1,0),t=vec3.fromValues(0,-1,0),m=0;m<c;++m){var p=m*h,z=vec3.fromValues(Math.sin(p),
0,Math.cos(p)),p=vec3.fromValues(Math.sin(p+h),0,Math.cos(p+h));d.set([z[0]*a,0.5*b,z[2]*a],l+18*m);f.set(v,l+18*m);k.set([0.5*-z[0]+0.5,0.5*z[2]+0.5],q+12*m);d.set([p[0]*a,0.5*b,p[2]*a],l+18*m+3);f.set(v,l+18*m+3);k.set([0.5*-p[0]+0.5,0.5*p[2]+0.5],q+12*m+2);d.set(r,l+18*m+6);f.set(v,l+18*m+6);k.set([0.5,0.5],q+12*m+4);d.set([p[0]*a,-0.5*b,p[2]*a],l+18*m+9);f.set(t,l+18*m+9);k.set([0.5*p[0]+0.5,0.5*p[2]+0.5],q+12*m+6);d.set([z[0]*a,-0.5*b,z[2]*a],l+18*m+12);f.set(t,l+18*m+12);k.set([0.5*z[0]+0.5,
0.5*z[2]+0.5],q+12*m+8);d.set(n,l+18*m+15);f.set(t,l+18*m+15);k.set([0.5,0.5],q+12*m+10)}c={vertices:d,normals:f,coords:k};g.bounding=BBox.fromCenterHalfsize([0,0,0],[a,0.5*b,a]);g.info={groups:[]};!1!==g.caps&&(g.info.groups.push({name:"side",start:0,length:l/3}),g.info.groups.push({name:"caps",start:l/3,length:(d.length-l)/3}));return Mesh.load(c,g,e)};Mesh.cone=function(g,e){g=g||{};for(var a=g.radius||g.size||1,b=g.height||g.size||2,c=g.subdivisions||64,d=new Float32Array(18*c),f=new Float32Array(18*
c),k=new Float32Array(12*c),h=2*Math.PI/c,l=null,m=a/b,p=0;p<c;++p){var q=p*h,l=[Math.sin(q+0.5*h),m,Math.cos(q+0.5*h)];vec3.normalize(l,l);d.set([0,b,0],18*p);f.set(l,18*p);k.set([p/c,1],12*p);l=[Math.sin(q),m,Math.cos(q)];d.set([l[0]*a,0,l[2]*a],18*p+3);vec3.normalize(l,l);f.set(l,18*p+3);k.set([p/c,0],12*p+2);l=[Math.sin(q+h),m,Math.cos(q+h)];d.set([l[0]*a,0,l[2]*a],18*p+6);vec3.normalize(l,l);f.set(l,18*p+6);k.set([(p+1)/c,0],12*p+4)}l=vec3.fromValues(0,0,0);m=vec3.fromValues(0,-1,0);for(p=0;p<
c;++p){var q=p*h,r=vec3.fromValues(Math.sin(q),0,Math.cos(q)),q=vec3.fromValues(Math.sin(q+h),0,Math.cos(q+h));d.set([q[0]*a,0,q[2]*a],18*p+9);f.set(m,18*p+9);k.set([0.5*q[0]+0.5,0.5*q[2]+0.5],12*p+6);d.set([r[0]*a,0,r[2]*a],18*p+12);f.set(m,18*p+12);k.set([0.5*r[0]+0.5,0.5*r[2]+0.5],12*p+8);d.set(l,18*p+15);f.set(m,18*p+15);k.set([0.5,0.5],12*p+10)}c={vertices:d,normals:f,coords:k};g.bounding=BBox.fromCenterHalfsize([0,0.5*b,0],[a,0.5*b,a]);return Mesh.load(c,g,e)};Mesh.sphere=function(g,e){g=g||
{};for(var a=g.radius||g.size||1,b=g.lat||g.subdivisions||16,c=g["long"]||g.subdivisions||16,d=new Float32Array((b+1)*(c+1)*3),f=new Float32Array((b+1)*(c+1)*3),k=new Float32Array((b+1)*(c+1)*2),s=new Uint16Array(b*c*6),l=g.hemi?0.5*Math.PI:Math.PI,m=0,p=0,q=0;q<=b;q++)for(var r=q*l/b,n=Math.sin(r),v=Math.cos(r),r=0;r<=c;r++){var t=2*r*Math.PI/c,z=Math.sin(t),t=Math.cos(t)*n,x=v,z=z*n,M=1-r/c,A=1-q/b;d.set([a*t,a*x,a*z],m);f.set([t,x,z],m);k.set([M,A],p);m+=3;p+=2}for(q=m=0;q<b;q++)for(r=0;r<c;r++)l=
q*(c+1)+r,p=l+c+1,s.set([p,l,l+1],m),s.set([p+1,p,l+1],m+3),m+=6;d={vertices:d,normals:f,coords:k,triangles:s};if(g.wireframe){f=new Uint16Array(c*b*4);for(m=k=0;m<b;m++){for(s=0;s<c;s++)f[k]=m*(c+1)+s,f[k+1]=m*(c+1)+s+1,k+=2;f[k-2*c]=m*(c+1)+s}for(m=0;m<c;m++)for(s=0;s<b;s++)f[k]=s*(c+1)+m,f[k+1]=(s+1)*(c+1)+m,k+=2;d.wireframe=f}g.bounding=g.hemi?BBox.fromCenterHalfsize([0,0.5*a,0],[a,0.5*a,a],a):BBox.fromCenterHalfsize([0,0,0],[a,a,a],a);return h.Mesh.load(d,g,e)};Mesh.grid=function(g,e){g=g||{};
var a=g.lines||11;0>a&&(a=1);for(var b=g.size||10,c=new Float32Array(12*a),d=0.5*b,f=0,k=-d,b=b/(a-1),s=0;s<a;s++)c[f]=k,c[f+2]=-d,c[f+3]=k,c[f+5]=d,c[f+6]=d,c[f+8]=k,c[f+9]=-d,c[f+11]=k,k+=b,f+=12;return new h.Mesh({vertices:c},g,e)};Mesh.icosahedron=function(g,e){function a(a,c){var d=l[a]<l[c]?l[a]+":"+l[c]:l[c]+":"+l[a],e=v[d];if(e)return e;e=f.length/3;f.push(0.5*(f[3*l[a]]+f[3*l[c]]),0.5*(f[3*l[a]+1]+f[3*l[c]+1]),0.5*(f[3*l[a]+2]+f[3*l[c]+2]));var g=Math.sqrt(f[3*e]*f[3*e]+f[3*e+1]*f[3*e+1]+
f[3*e+2]*f[3*e+2]),h=f[3*e]/g,m=f[3*e+1]/g,t=f[3*e+2]/g;k.push(h,m,t);s.push(Math.atan2(h,t)/Math.PI*0.5,Math.acos(m)/Math.PI);f[3*e]*=b/g;f[3*e+1]*=b/g;f[3*e+2]*=b/g;return v[d]=e}g=g||{};var b=g.radius||g.size||1,c=void 0===g.subdivisions?0:g.subdivisions;6<c&&(c=6);for(var d=(1+Math.sqrt(5))/2,f=[-1,d,0,1,d,0,-1,-d,0,1,-d,0,0,-1,d,0,1,d,0,-1,-d,0,1,-d,d,0,-1,d,0,1,-d,0,-1,-d,0,1],k=[],s=[],l=[0,11,5,0,5,1,0,1,7,0,7,10,0,10,11,1,5,9,5,11,4,11,10,2,10,7,6,7,1,8,3,9,4,3,4,2,3,2,6,3,6,8,3,8,9,4,9,
5,2,4,11,6,2,10,8,6,7,9,8,1],d=f.length,m=0;m<d;m+=3){var p=Math.sqrt(f[m]*f[m]+f[m+1]*f[m+1]+f[m+2]*f[m+2]),q=f[m]/p,r=f[m+1]/p,n=f[m+2]/p;k.push(q,r,n);s.push(Math.atan2(q,n),Math.acos(r));f[m]*=b/p;f[m+1]*=b/p;f[m+2]*=b/p}for(var v={},p=0;p<c;++p){q=[];d=l.length;for(m=0;m<d;m+=3){var r=a(m,m+1),n=a(m+1,m+2),t=a(m+2,m);q.push(l[m],r,t);q.push(l[m+1],n,r);q.push(l[m+2],t,n);q.push(r,n,t)}l=q}g.bounding=BBox.fromCenterHalfsize([0,0,0],[b,b,b],b);return new h.Mesh.load({vertices:f,coords:s,normals:k,
triangles:l},g,e)};n.Texture=h.Texture=function e(a,b,c,d){c=c||{};this.gl=d=d||n.gl;this._context_id=d.context_id;a=parseInt(a);b=parseInt(b);h.debug&&console.log("GL.Texture created: ",a,b);this.handler=d.createTexture();this.width=a;this.height=b;c.depth&&(this.depth=c.depth);this.texture_type=c.texture_type||d.TEXTURE_2D;this.format=c.format||e.DEFAULT_FORMAT;this.internalFormat=c.internalFormat;this.type=c.type||e.DEFAULT_TYPE;this.magFilter=c.magFilter||c.filter||e.DEFAULT_MAG_FILTER;this.minFilter=
c.minFilter||c.filter||e.DEFAULT_MIN_FILTER;this.wrapS=c.wrap||c.wrapS||e.DEFAULT_WRAP_S;this.wrapT=c.wrap||c.wrapT||e.DEFAULT_WRAP_T;this.data=null;e.MAX_TEXTURE_IMAGE_UNITS||(e.MAX_TEXTURE_IMAGE_UNITS=d.getParameter(d.MAX_TEXTURE_IMAGE_UNITS));this.has_mipmaps=!1;if(this.format==d.DEPTH_COMPONENT&&1==d.webgl_version&&!d.extensions.WEBGL_depth_texture)throw"Depth Texture not supported";if(this.type==d.FLOAT&&!d.extensions.OES_texture_float&&1==d.webgl_version)throw"Float Texture not supported";if(this.type==
d.HALF_FLOAT_OES){if(!d.extensions.OES_texture_half_float&&1==d.webgl_version)throw"Half Float Texture extension not supported.";1<d.webgl_version&&(console.warn("using HALF_FLOAT_OES in WebGL2 is deprecated, suing HALF_FLOAT instead"),this.type=this.format==d.RGB?d.RGB16F:d.RGBA16F)}if(!(isPowerOfTwo(this.width)&&isPowerOfTwo(this.height)||(this.minFilter==d.NEAREST||this.minFilter==d.LINEAR)&&this.wrapS==d.CLAMP_TO_EDGE&&this.wrapT==d.CLAMP_TO_EDGE))if(c.ignore_pot)this.minFilter=this.magFilter=
d.LINEAR,this.wrapS=this.wrapT=d.CLAMP_TO_EDGE;else throw"Cannot use texture-wrap or mipmaps in Non-Power-of-Two textures";if(a&&b){this.internalFormat||this.computeInternalFormat();d.activeTexture(d.TEXTURE0+e.MAX_TEXTURE_IMAGE_UNITS-1);d.bindTexture(this.texture_type,this.handler);d.texParameteri(this.texture_type,d.TEXTURE_MAG_FILTER,this.magFilter);d.texParameteri(this.texture_type,d.TEXTURE_MIN_FILTER,this.minFilter);d.texParameteri(this.texture_type,d.TEXTURE_WRAP_S,this.wrapS);d.texParameteri(this.texture_type,
d.TEXTURE_WRAP_T,this.wrapT);c.anisotropic&&d.extensions.EXT_texture_filter_anisotropic&&d.texParameterf(h.TEXTURE_2D,d.extensions.EXT_texture_filter_anisotropic.TEXTURE_MAX_ANISOTROPY_EXT,c.anisotropic);var f=c.pixel_data;if(f&&!f.buffer){if(this.texture_type==h.TEXTURE_CUBE_MAP)for(var k=0;k<f.length;++k)f[k]=new (this.type==d.FLOAT?Float32Array:Uint8Array)(f[k]);else f=new (this.type==d.FLOAT?Float32Array:Uint8Array)(f);this.data=f}if(this.texture_type==h.TEXTURE_2D)d.texImage2D(h.TEXTURE_2D,0,
this.internalFormat,a,b,0,this.format,this.type,f||null),h.isPowerOfTwo(a)&&h.isPowerOfTwo(b)&&c.minFilter&&c.minFilter!=d.NEAREST&&c.minFilter!=d.LINEAR&&(d.generateMipmap(this.texture_type),this.has_mipmaps=!0);else if(this.texture_type==h.TEXTURE_CUBE_MAP)d.texImage2D(d.TEXTURE_CUBE_MAP_POSITIVE_X,0,this.internalFormat,this.width,this.height,0,this.format,this.type,f?f[0]:null),d.texImage2D(d.TEXTURE_CUBE_MAP_POSITIVE_Y,0,this.internalFormat,this.width,this.height,0,this.format,this.type,f?f[1]:
null),d.texImage2D(d.TEXTURE_CUBE_MAP_POSITIVE_Z,0,this.internalFormat,this.width,this.height,0,this.format,this.type,f?f[2]:null),d.texImage2D(d.TEXTURE_CUBE_MAP_NEGATIVE_X,0,this.internalFormat,this.width,this.height,0,this.format,this.type,f?f[3]:null),d.texImage2D(d.TEXTURE_CUBE_MAP_NEGATIVE_Y,0,this.internalFormat,this.width,this.height,0,this.format,this.type,f?f[4]:null),d.texImage2D(d.TEXTURE_CUBE_MAP_NEGATIVE_Z,0,this.internalFormat,this.width,this.height,0,this.format,this.type,f?f[5]:null);
else if(this.texture_type==h.TEXTURE_3D){if(1==this.gl.webgl_version)throw"TEXTURE_3D not supported in WebGL 1. Enable WebGL 2 in the context by pasing webgl2:true";if(!c.depth)throw"3d texture depth must be set in the options.depth";d.texImage3D(h.TEXTURE_3D,0,this.internalFormat,a,b,c.depth,0,this.format,this.type,f||null)}d.bindTexture(this.texture_type,null);d.activeTexture(d.TEXTURE0)}};Texture.DEFAULT_TYPE=h.UNSIGNED_BYTE;Texture.DEFAULT_FORMAT=h.RGBA;Texture.DEFAULT_MAG_FILTER=h.LINEAR;Texture.DEFAULT_MIN_FILTER=
h.LINEAR;Texture.DEFAULT_WRAP_S=h.CLAMP_TO_EDGE;Texture.DEFAULT_WRAP_T=h.CLAMP_TO_EDGE;Texture.EXTENSION="png";Texture.framebuffer=null;Texture.renderbuffer=null;Texture.loading_color=new Uint8Array([0,0,0,0]);Texture.use_renderbuffer_pool=!0;Texture.prototype.computeInternalFormat=function(){this.internalFormat=this.format;if(this.format==h.DEPTH_COMPONENT)if(this.minFilter=this.magFilter=h.NEAREST,2==gl.webgl_version)if(this.type==h.UNSIGNED_SHORT)this.internalFormat=h.DEPTH_COMPONENT16;else if(this.type==
h.UNSIGNED_INT)this.internalFormat=h.DEPTH_COMPONENT24;else if(this.type==h.FLOAT)this.internalFormat=h.DEPTH_COMPONENT32F;else throw"unsupported type for a depth texture";else{if(1==gl.webgl_version){if(this.type==h.FLOAT)throw"WebGL 1.0 does not support float depth textures";this.internalFormat=h.DEPTH_COMPONENT}}else this.format==gl.RGBA&&(2==gl.webgl_version?this.type==h.FLOAT?this.internalFormat=h.RGBA32F:this.type==h.HALF_FLOAT?this.internalFormat=h.RGBA16F:this.type==h.HALF_FLOAT_OES&&(console.warn("webgl 2 does not use HALF_FLOAT_OES, converting to HALF_FLOAT"),
this.type=h.HALF_FLOAT,this.internalFormat=h.RGBA16F):1==gl.webgl_version&&this.type==h.HALF_FLOAT&&(console.warn("webgl 1 does not use HALF_FLOAT, converting to HALF_FLOAT_OES"),this.type=h.HALF_FLOAT_OES))};Texture.prototype.delete=function(){gl.deleteTexture(this.handler);this.handler=null};Texture.prototype.getProperties=function(){return{width:this.width,height:this.height,type:this.type,format:this.format,texture_type:this.texture_type,magFilter:this.magFilter,minFilter:this.minFilter,wrapS:this.wrapS,
wrapT:this.wrapT}};Texture.prototype.hasSameProperties=function(e){return e?e.width==this.width&&e.height==this.height&&e.type==this.type&&e.format==this.format&&e.texture_type==this.texture_type:!1};Texture.prototype.hasSameSize=function(e){return e?e.width==this.width&&e.height==this.height:!1};Texture.prototype.toJSON=function(){return""};Texture.isDepthSupported=function(){return null!=gl.extensions.WEBGL_depth_texture};Texture.prototype.bind=function(e){void 0==e&&(e=0);var a=this.gl;a.activeTexture(a.TEXTURE0+
e);a.bindTexture(this.texture_type,this.handler);return e};Texture.prototype.unbind=function(e){void 0===e&&(e=0);var a=this.gl;a.activeTexture(a.TEXTURE0+e);a.bindTexture(this.texture_type,null)};Texture.prototype.setParameter=function(e,a){this.bind(0);this.gl.texParameteri(this.texture_type,e,a);switch(e){case this.gl.TEXTURE_MAG_FILTER:this.magFilter=a;break;case this.gl.TEXTURE_MIN_FILTER:this.minFilter=a;break;case this.gl.TEXTURE_WRAP_S:this.wrapS=a;break;case this.gl.TEXTURE_WRAP_T:this.wrapT=
a}};Texture.setUploadOptions=function(e,a){a=a||n.gl;e?(a.pixelStorei(a.UNPACK_PREMULTIPLY_ALPHA_WEBGL,!!e.premultiply_alpha),a.pixelStorei(a.UNPACK_FLIP_Y_WEBGL,!e.no_flip)):(a.pixelStorei(a.UNPACK_PREMULTIPLY_ALPHA_WEBGL,!1),a.pixelStorei(a.UNPACK_FLIP_Y_WEBGL,!0));a.pixelStorei(a.UNPACK_ALIGNMENT,1)};Texture.prototype.uploadImage=function(e,a){this.bind();var b=this.gl;if(!e)throw"uploadImage parameter must be Image";Texture.setUploadOptions(a,b);try{b.texImage2D(b.TEXTURE_2D,0,this.format,this.format,
this.type,e),this.width=e.videoWidth||e.width,this.height=e.videoHeight||e.height,this.data=e}catch(c){if("file:"==location.protocol)throw'image not loaded for security reasons (serve this page over "http://" instead)';throw"image not loaded for security reasons (image must originate from the same domain as this page or use Cross-Origin Resource Sharing)";}this.minFilter&&this.minFilter!=b.NEAREST&&this.minFilter!=b.LINEAR&&(b.generateMipmap(this.texture_type),this.has_mipmaps=!0);b.bindTexture(this.texture_type,
null)};Texture.prototype.uploadData=function(e,a,b){a=a||{};if(!e)throw"no data passed";var c=this.gl;this.bind();Texture.setUploadOptions(a,c);var d=a.mipmap_level||0,f=this.width,k=this.height,f=f>>d,k=k>>d;this.type==h.HALF_FLOAT_OES&&e.constructor===Float32Array&&console.warn("cannot uploadData to a HALF_FLOAT texture from a Float32Array, must be Uint16Array. To upload it we recomment to create a FLOAT texture, upload data there and copy to your HALF_FLOAT.");if(this.texture_type==h.TEXTURE_2D)e.buffer&&
e.buffer.constructor==ArrayBuffer?c.texImage2D(this.texture_type,d,this.format,f,k,0,this.format,this.type,e):c.texImage2D(this.texture_type,d,this.format,this.format,this.type,e);else if(this.texture_type==h.TEXTURE_3D)c.texImage3D(this.texture_type,d,this.format,f,k,this.depth>>d,0,this.format,this.type,e);else if(this.texture_type==h.TEXTURE_CUBE_MAP)c.texImage2D(c.TEXTURE_CUBE_MAP_POSITIVE_X+(a.cubemap_face||0),d,this.format,f,k,0,this.format,this.type,e);else throw"cannot uploadData for this texture type";
this.data=e;!b&&this.minFilter&&this.minFilter!=c.NEAREST&&this.minFilter!=c.LINEAR&&(c.generateMipmap(this.texture_type),this.has_mipmaps=!0);c.bindTexture(this.texture_type,null)};Texture.cubemap_camera_parameters=[{type:"posX",dir:vec3.fromValues(1,0,0),up:vec3.fromValues(0,1,0),right:vec3.fromValues(0,0,-1)},{type:"negX",dir:vec3.fromValues(-1,0,0),up:vec3.fromValues(0,1,0),right:vec3.fromValues(0,0,1)},{type:"posY",dir:vec3.fromValues(0,1,0),up:vec3.fromValues(0,0,-1),right:vec3.fromValues(1,
0,0)},{type:"negY",dir:vec3.fromValues(0,-1,0),up:vec3.fromValues(0,0,1),right:vec3.fromValues(1,0,0)},{type:"posZ",dir:vec3.fromValues(0,0,1),up:vec3.fromValues(0,1,0),right:vec3.fromValues(1,0,0)},{type:"negZ",dir:vec3.fromValues(0,0,-1),up:vec3.fromValues(0,1,0),right:vec3.fromValues(-1,0,0)}];Texture.prototype.drawTo=function(e,a){function b(){6E4<=h.getTime()-this.time?(c.deleteRenderbuffer(c._renderbuffers_pool[m]),delete c._renderbuffers_pool[m]):setTimeout(b.bind(this),6E4)}var c=this.gl,
d=c.getViewport(),f=h.getTime(),k=c.getParameter(c.FRAMEBUFFER_BINDING),s=c._framebuffer=c._framebuffer||c.createFramebuffer();c.bindFramebuffer(c.FRAMEBUFFER,s);var l=null;if(Texture.use_renderbuffer_pool){c._renderbuffers_pool||(c._renderbuffers_pool={});var m=this.width+":"+this.height;c._renderbuffers_pool[m]?(l=c._renderbuffers_pool[m],l.time=f,c.bindRenderbuffer(c.RENDERBUFFER,l)):(c._renderbuffers_pool[m]=l=c.createRenderbuffer(),l.time=f,l.width=this.width,l.height=this.height,c.bindRenderbuffer(c.RENDERBUFFER,
l),setTimeout(b.bind(l),6E4))}else l=c._renderbuffer=c._renderbuffer||c.createRenderbuffer(),l.width=this.width,l.height=this.height,c.bindRenderbuffer(c.RENDERBUFFER,l);this.format===c.DEPTH_COMPONENT?c.renderbufferStorage(c.RENDERBUFFER,c.RGBA4,this.width,this.height):c.renderbufferStorage(c.RENDERBUFFER,c.DEPTH_COMPONENT16,this.width,this.height);c.viewport(0,0,this.width,this.height);c._current_texture_drawto=this;c._current_fbo_color=s;c._current_fbo_depth=l;if(this.texture_type==c.TEXTURE_2D)this.format!==
c.DEPTH_COMPONENT?(c.framebufferTexture2D(c.FRAMEBUFFER,c.COLOR_ATTACHMENT0,c.TEXTURE_2D,this.handler,0),c.framebufferRenderbuffer(c.FRAMEBUFFER,c.DEPTH_ATTACHMENT,c.RENDERBUFFER,l)):(c.framebufferRenderbuffer(c.FRAMEBUFFER,c.COLOR_ATTACHMENT0,c.RENDERBUFFER,l),c.framebufferTexture2D(c.FRAMEBUFFER,c.DEPTH_ATTACHMENT,c.TEXTURE_2D,this.handler,0)),e(this,a);else if(this.texture_type==c.TEXTURE_CUBE_MAP)for(this.format!==c.DEPTH_COMPONENT?c.framebufferRenderbuffer(c.FRAMEBUFFER,c.DEPTH_ATTACHMENT,c.RENDERBUFFER,
l):c.framebufferRenderbuffer(c.FRAMEBUFFER,c.COLOR_ATTACHMENT0,c.RENDERBUFFER,l),f=0;6>f;f++)this.format!==c.DEPTH_COMPONENT?c.framebufferTexture2D(c.FRAMEBUFFER,c.COLOR_ATTACHMENT0,c.TEXTURE_CUBE_MAP_POSITIVE_X+f,this.handler,0):c.framebufferTexture2D(c.FRAMEBUFFER,c.DEPTH_ATTACHMENT,c.TEXTURE_CUBE_MAP_POSITIVE_X+f,this.handler,0),e(this,f,a);this.data=null;c._current_texture_drawto=null;c._current_fbo_color=null;c._current_fbo_depth=null;c.bindFramebuffer(c.FRAMEBUFFER,k);c.bindRenderbuffer(c.RENDERBUFFER,
null);c.viewport(d[0],d[1],d[2],d[3]);return this};Texture.drawTo=function(e,a,b){var c=-1,d=-1,f=null;if(!e&&!b)throw"Textures missing in drawTo";if(e&&e.length)for(var k=0;k<e.length;k++){var h=e[k];if(-1==c)c=h.width;else if(c!=h.width)throw"Cannot use Texture.drawTo if textures have different dimensions";if(-1==d)d=h.height;else if(d!=h.height)throw"Cannot use Texture.drawTo if textures have different dimensions";if(null==f)f=h.type;else if(f!=h.type)throw"Cannot use Texture.drawTo if textures have different data type, all must have the same type";
}else c=b.width,d=b.height;var l=gl.extensions.WEBGL_draw_buffers;if(!l&&e&&1<e.length)throw"Rendering to several textures not supported";f=gl.getViewport();gl._framebuffer=gl._framebuffer||gl.createFramebuffer();gl.bindFramebuffer(gl.FRAMEBUFFER,gl._framebuffer);gl.viewport(0,0,c,d);k=null;if(b&&b.format!==gl.DEPTH_COMPONENT||b.type!=gl.UNSIGNED_INT)throw"Depth texture must be of format: gl.DEPTH_COMPONENT and type: gl.UNSIGNED_INT";b?gl.framebufferTexture2D(gl.FRAMEBUFFER,gl.DEPTH_ATTACHMENT,gl.TEXTURE_2D,
b.handler,0):(k=gl._renderbuffer=gl._renderbuffer||gl.createRenderbuffer(),k.width=c,k.height=d,gl.bindRenderbuffer(gl.RENDERBUFFER,k),gl.renderbufferStorage(gl.RENDERBUFFER,gl.DEPTH_COMPONENT16,c,d),gl.framebufferRenderbuffer(gl.FRAMEBUFFER,gl.DEPTH_ATTACHMENT,gl.RENDERBUFFER,k));if(e){c=[];for(k=0;k<e.length;k++)h=e[k],gl.framebufferTexture2D(gl.FRAMEBUFFER,gl.COLOR_ATTACHMENT0+k,gl.TEXTURE_2D,h.handler,0),c.push(gl.COLOR_ATTACHMENT0+k);1<e.length&&l.drawBuffersWEBGL(c)}else b=this._color_renderbuffer=
this._color_renderbuffer||gl.createRenderbuffer(),b.width=c,b.height=d,gl.bindRenderbuffer(gl.RENDERBUFFER,b),gl.renderbufferStorage(gl.RENDERBUFFER,gl.RGBA4,c,d),gl.framebufferRenderbuffer(gl.FRAMEBUFFER,gl.COLOR_ATTACHMENT0,gl.RENDERBUFFER,b);c=gl.checkFramebufferStatus(gl.FRAMEBUFFER);if(c!==gl.FRAMEBUFFER_COMPLETE)throw"FBO not complete: "+c;a();if(e.length)for(k=0;k<e.length;++k)e[k].data=null;gl.bindFramebuffer(gl.FRAMEBUFFER,null);gl.viewport(f[0],f[1],f[2],f[3])};Texture.drawToColorAndDepth=
function(e,a,b){var c=e.gl;if(a.width!=e.width||a.height!=e.height)throw"Different size between color texture and depth texture";var d=c.getViewport();c._framebuffer=c._framebuffer||c.createFramebuffer();c.bindFramebuffer(c.FRAMEBUFFER,c._framebuffer);c.viewport(0,0,e.width,e.height);c.framebufferTexture2D(c.FRAMEBUFFER,c.COLOR_ATTACHMENT0,c.TEXTURE_2D,e.handler,0);c.framebufferTexture2D(c.FRAMEBUFFER,c.DEPTH_ATTACHMENT,c.TEXTURE_2D,a.handler,0);b();e.data=null;a.data=null;c.bindFramebuffer(c.FRAMEBUFFER,
null);c.viewport(d[0],d[1],d[2],d[3])};Texture.prototype.copyTo=function(e,a,b){var c=this.gl,d=c.getParameter(c.FRAMEBUFFER_BINDING),f=c.getViewport();a||(a=this.texture_type==c.TEXTURE_2D?h.Shader.getScreenShader():h.Shader.getCubemapCopyShader());c.disable(c.BLEND);c.disable(c.DEPTH_TEST);a&&b&&a.uniforms(b);b=c.__copy_fbo;b||(b=c.__copy_fbo=c.createFramebuffer());c.bindFramebuffer(c.FRAMEBUFFER,b);c.viewport(0,0,e.width,e.height);if(this.texture_type==c.TEXTURE_2D)if(this.format!==c.DEPTH_COMPONENT&&
this.format!==c.DEPTH_STENCIL)c.framebufferTexture2D(c.FRAMEBUFFER,c.COLOR_ATTACHMENT0,c.TEXTURE_2D,e.handler,0),this.toViewport(a);else{a=c._color_renderbuffer=c._color_renderbuffer||c.createRenderbuffer();b=a.width=e.width;var k=a.height=e.height;c.bindRenderbuffer(c.RENDERBUFFER,a);c.renderbufferStorage(c.RENDERBUFFER,c.RGBA4,b,k);c.framebufferRenderbuffer(c.FRAMEBUFFER,c.COLOR_ATTACHMENT0,c.RENDERBUFFER,a);b=e.format==c.DEPTH_STENCIL?c.DEPTH_STENCIL_ATTACHMENT:c.DEPTH_ATTACHMENT;c.framebufferTexture2D(c.FRAMEBUFFER,
b,c.TEXTURE_2D,e.handler,0);a=c.checkFramebufferStatus(c.FRAMEBUFFER);if(a!==c.FRAMEBUFFER_COMPLETE)throw"FBO not complete: "+a;c.enable(c.DEPTH_TEST);c.depthFunc(c.ALWAYS);c.colorMask(!1,!1,!1,!1);a=h.Shader.getCopyDepthShader();this.toViewport(a);c.colorMask(!0,!0,!0,!0);c.disable(c.DEPTH_TEST);c.depthFunc(c.LEQUAL);c.framebufferRenderbuffer(c.FRAMEBUFFER,c.COLOR_ATTACHMENT0,c.RENDERBUFFER,null);c.framebufferTexture2D(c.FRAMEBUFFER,b,c.TEXTURE_2D,null,0)}else if(this.texture_type==c.TEXTURE_CUBE_MAP)for(a.uniforms({u_texture:0}),
b=h.temp_mat3,k=0;6>k;k++){c.framebufferTexture2D(c.FRAMEBUFFER,c.COLOR_ATTACHMENT0,c.TEXTURE_CUBE_MAP_POSITIVE_X+k,e.handler,0);var s=h.Texture.cubemap_camera_parameters[k];mat3.identity(b);b.set(s.right,0);b.set(s.up,3);b.set(s.dir,6);this.toViewport(a,{u_rotation:b})}c.setViewport(f);c.bindFramebuffer(c.FRAMEBUFFER,d);e.minFilter&&e.minFilter!=c.NEAREST&&e.minFilter!=c.LINEAR&&(e.bind(),c.generateMipmap(e.texture_type),e.has_mipmaps=!0);e.data=null;c.bindTexture(e.texture_type,null);return this};
Texture.prototype.blit=function(){var e=new Float32Array(4);return function(a,b,c){var d=this.gl;if(this.texture_type!=d.TEXTURE_2D||this.format===d.DEPTH_COMPONENT||this.format===d.DEPTH_STENCIL)throw"blit only support TEXTURE_2D of RGB or RGBA. use copyTo instead";var f=d.getParameter(d.FRAMEBUFFER_BINDING);e.set(d.viewport_data);(b=b||h.Shader.getScreenShader())&&c&&b.uniforms(c);c=d.__copy_fbo;c||(c=d.__copy_fbo=d.createFramebuffer());d.bindFramebuffer(d.FRAMEBUFFER,c);d.viewport(0,0,a.width,
a.height);d.framebufferTexture2D(d.FRAMEBUFFER,d.COLOR_ATTACHMENT0,d.TEXTURE_2D,a.handler,0);this.bind(0);b.draw(h.Mesh.getScreenQuad(),d.TRIANGLES);d.setViewport(e);d.bindFramebuffer(d.FRAMEBUFFER,f);a.data=null;d.bindTexture(a.texture_type,null);return this}}();Texture.prototype.toViewport=function(e,a){e=e||Shader.getScreenShader();var b=Mesh.getScreenQuad();this.bind(0);a&&e.uniforms(a);e.draw(b,gl.TRIANGLES)};Texture.prototype.fill=function(e,a){var b=gl.getParameter(gl.COLOR_CLEAR_VALUE);gl.clearColor(e[0],
e[1],e[2],e[3]);this.drawTo(function(){gl.clear(gl.COLOR_BUFFER_BIT)});gl.clearColor(b[0],b[1],b[2],b[3]);!a&&this.minFilter&&this.minFilter!=gl.NEAREST&&this.minFilter!=gl.LINEAR&&(this.bind(),gl.generateMipmap(this.texture_type),this.has_mipmaps=!0)};Texture.prototype.renderQuad=function(){var e=mat3.create(),a=vec2.create(),b=vec2.create(),c=vec4.fromValues(1,1,1,1);return function(d,f,k,h,l,m){a[0]=d;a[1]=f;b[0]=k;b[1]=h;l=l||Shader.getQuadShader(this.gl);d=Mesh.getScreenQuad(this.gl);this.bind(0);
l.uniforms({u_texture:0,u_position:a,u_color:c,u_size:b,u_viewport:gl.viewport_data.subarray(2,4),u_transform:e});m&&l.uniforms(m);l.draw(d,gl.TRIANGLES)}}();Texture.prototype.applyBlur=function(e,a,b,c,d){var f=this.gl;void 0===e&&(e=1);void 0===a&&(a=1);f.disable(f.DEPTH_TEST);f.disable(f.BLEND);c=c||this;var k=!d;if(d===c)throw"cannot use applyBlur in a texture using as temporary itself";if(c&&this.texture_type!==c.texture_type)throw"cannot use applyBlur with textures of different texture_type";
var s=f.getParameter(f.FRAMEBUFFER_BINDING),l=f.getViewport(),m=f.__copy_fbo;m||(m=f.__copy_fbo=f.createFramebuffer());f.bindFramebuffer(f.FRAMEBUFFER,m);f.viewport(0,0,this.width,this.height);if(this.texture_type===f.TEXTURE_2D)m=h.Shader.getBlurShader(),d||(d=h.Texture.getTemporary(this.width,this.height,this)),f.framebufferTexture2D(f.FRAMEBUFFER,f.COLOR_ATTACHMENT0,f.TEXTURE_2D,d.handler,0),this.toViewport(m,{u_texture:0,u_intensity:b,u_offset:[0,a/this.height]}),f.framebufferTexture2D(f.FRAMEBUFFER,
f.COLOR_ATTACHMENT0,f.TEXTURE_2D,c.handler,0),f.viewport(0,0,c.width,c.height),d.toViewport(m,{u_intensity:b,u_offset:[e/d.width,0]}),k&&h.Texture.releaseTemporary(d);else if(this.texture_type===f.TEXTURE_CUBE_MAP){m=h.Shader.getCubemapBlurShader();m.uniforms({u_texture:0,u_intensity:b,u_offset:[e/this.width,a/this.height]});this.bind(0);e=Mesh.getScreenQuad();e.bindBuffers(m);m.bind();a=null;a=d||c!=this?c:d=h.Texture.getTemporary(c.width,c.height,c);b=h.temp_mat3;for(var p=0;6>p;++p){f.framebufferTexture2D(f.FRAMEBUFFER,
f.COLOR_ATTACHMENT0,f.TEXTURE_CUBE_MAP_POSITIVE_X+p,a.handler,0);var q=h.Texture.cubemap_camera_parameters[p];mat3.identity(b);b.set(q.right,0);b.set(q.up,3);b.set(q.dir,6);m._setUniform("u_rotation",b);f.drawArrays(f.TRIANGLES,0,6)}e.unbindBuffers(m);d&&d.copyTo(c);d&&k&&h.Texture.releaseTemporary(d)}f.setViewport(l);f.bindFramebuffer(f.FRAMEBUFFER,s);c.data=null;c.minFilter&&c.minFilter!=f.NEAREST&&c.minFilter!=f.LINEAR&&(c.bind(),f.generateMipmap(c.texture_type),c.has_mipmaps=!0);f.bindTexture(c.texture_type,
null)};Texture.fromURL=function(e,a,b,c){c=c||n.gl;a=a||{};a=Object.create(a);var d=a.texture||new h.Texture(1,1,a,c);64>e.length&&(d.url=e);d.bind();var f=a.temp_color||Texture.loading_color;c.pixelStorei(c.UNPACK_ALIGNMENT,4);f=a.type==c.FLOAT?new Float32Array(f):new Uint8Array(f);c.texImage2D(c.TEXTURE_2D,0,d.format,d.width,d.height,0,d.format,d.type,f);c.bindTexture(d.texture_type,null);d.ready=!1;f=null;a.extension&&(f=a.extension);if(!f&&512>e.length){var k=e,s=e.indexOf("?");-1!=s&&(k=e.substr(0,
s));s=k.lastIndexOf(".");-1!=s&&(f=k.substr(s+1).toLowerCase())}"dds"==f?(f=c.getExtension("WEBKIT_WEBGL_compressed_texture_s3tc")||c.getExtension("WEBGL_compressed_texture_s3tc"),k=new h.Texture(0,0,a,c),Q.loadDDSTextureEx(c,f,e,k.handler,!0,function(a){d.texture_type=a.texture_type;d.handler=a;delete d.ready;b&&b(d,e)})):"tga"==f?HttpRequest(e,null,function(f){if(f=h.Texture.parseTGA(f))a.texture=d,"RGB"==f.format&&(d.format=c.RGB),d=h.Texture.fromMemory(f.width,f.height,f.pixels,a),delete d.ready,
b&&b(d,e)},null,{binary:!0}):(f=new Image,f.src=e,f.onload=function(){a.texture=d;h.Texture.fromImage(this,a);delete d.ready;b&&b(d,e)},f.onerror=function(){b&&b(null)});return d};Texture.parseTGA=function(e){if(!e||e.constructor!==ArrayBuffer)throw"TGA: data must be ArrayBuffer";e=new Uint8Array(e);for(var a=new Uint8Array([0,0,2,0,0,0,0,0,0,0,0,0]),b=e.subarray(0,12),c=0;c<b.length;c++)if(a[c]!=b[c])return console.error("TGA header is not valid"),null;a=e.subarray(12,18);b={};b.width=256*a[1]+a[0];
b.height=256*a[3]+a[2];b.bpp=a[4];b.bytesPerPixel=b.bpp/8;b.imageSize=b.width*b.height*b.bytesPerPixel;b.pixels=e.subarray(18,18+b.imageSize);b.pixels=new Uint8Array(b.pixels);if(0==(a[5]&16)){for(c=0;c<b.imageSize;c+=b.bytesPerPixel)e=b.pixels[c],b.pixels[c]=b.pixels[c+2],b.pixels[c+2]=e;a[5]|=16}b.format=32==b.bpp?"RGBA":"RGB";b.flipY=!0;return b};Texture.fromImage=function(e,a){a=a||{};var b=a.texture||new h.Texture(e.width,e.height,a);b.uploadImage(e,a);b.bind();gl.texParameteri(b.texture_type,
gl.TEXTURE_MAG_FILTER,b.magFilter);gl.texParameteri(b.texture_type,gl.TEXTURE_MIN_FILTER,b.minFilter);gl.texParameteri(b.texture_type,gl.TEXTURE_WRAP_S,b.wrapS);gl.texParameteri(b.texture_type,gl.TEXTURE_WRAP_T,b.wrapT);h.isPowerOfTwo(b.width)&&h.isPowerOfTwo(b.height)?a.minFilter&&a.minFilter!=gl.NEAREST&&a.minFilter!=gl.LINEAR&&(b.bind(),gl.generateMipmap(b.texture_type),b.has_mipmaps=!0):(gl.texParameteri(b.texture_type,gl.TEXTURE_MIN_FILTER,h.LINEAR),gl.texParameteri(b.texture_type,gl.TEXTURE_WRAP_S,
h.CLAMP_TO_EDGE),gl.texParameteri(b.texture_type,gl.TEXTURE_WRAP_T,h.CLAMP_TO_EDGE),b.has_mipmaps=!1);gl.bindTexture(b.texture_type,null);b.data=e;a.keep_image&&(b.img=e);return b};Texture.fromVideo=function(e,a){a=a||{};var b=a.texture||new h.Texture(e.videoWidth,e.videoHeight,a);b.bind();b.uploadImage(e,a);a.minFilter&&a.minFilter!=gl.NEAREST&&a.minFilter!=gl.LINEAR&&(b.bind(),gl.generateMipmap(b.texture_type),b.has_mipmaps=!0,b.data=e);gl.bindTexture(b.texture_type,null);return b};Texture.fromTexture=
function(e,a){a=a||{};var b=new h.Texture(e.width,e.height,a);e.copyTo(b);return b};Texture.prototype.clone=function(e){var a=this.getProperties();if(e)for(var b in e)a[b]=e[b];return Texture.fromTexture(this,a)};Texture.fromMemory=function(e,a,b,c){c=c||{};var d=c.texture||new h.Texture(e,a,c);Texture.setUploadOptions(c);d.bind();try{gl.texImage2D(gl.TEXTURE_2D,0,d.format,e,a,0,d.format,d.type,b),d.width=e,d.height=a,d.data=b}catch(f){if("file:"==location.protocol)throw'image not loaded for security reasons (serve this page over "http://" instead)';
throw"image not loaded for security reasons (image must originate from the same domain as this page or use Cross-Origin Resource Sharing)";}c.minFilter&&c.minFilter!=gl.NEAREST&&c.minFilter!=gl.LINEAR&&(gl.generateMipmap(gl.TEXTURE_2D),d.has_mipmaps=!0);gl.bindTexture(d.texture_type,null);return d};Texture.fromDDSInMemory=function(e,a){a=a||{};var b=a.texture||new h.Texture(0,0,a);h.Texture.setUploadOptions(a);b.bind();var c=gl.getExtension("WEBKIT_WEBGL_compressed_texture_s3tc")||gl.getExtension("WEBGL_compressed_texture_s3tc");
Q.loadDDSTextureFromMemoryEx(gl,c,e,b,!0);gl.bindTexture(b.texture_type,null);return b};Texture.fromShader=function(e,a,b,c){c=c||{};e=new h.Texture(e,a,c);e.drawTo(function(){gl.disable(gl.BLEND);gl.disable(gl.DEPTH_TEST);gl.disable(gl.CULL_FACE);var a=Mesh.getScreenQuad();b.draw(a)});return e};Texture.cubemapFromImages=function(e,a){a=a||{};if(6!=e.length)throw"missing images to create cubemap";var b=e[0].width,c=e[0].height;a.texture_type=gl.TEXTURE_CUBE_MAP;var d=null;a.texture?(d=a.texture,d.width=
b,d.height=c):d=new h.Texture(b,c,a);Texture.setUploadOptions(a);d.bind();try{for(b=0;6>b;b++)gl.texImage2D(gl.TEXTURE_CUBE_MAP_POSITIVE_X+b,0,d.format,d.format,d.type,e[b]);d.data=e}catch(f){if("file:"==location.protocol)throw'image not loaded for security reasons (serve this page over "http://" instead)';throw"image not loaded for security reasons (image must originate from the same domain as this page or use Cross-Origin Resource Sharing)";}a.minFilter&&a.minFilter!=gl.NEAREST&&a.minFilter!=gl.LINEAR&&
(gl.generateMipmap(gl.TEXTURE_CUBE_MAP),d.has_mipmaps=!0);d.unbind();return d};Texture.cubemapFromImage=function(e,a){a=a||{};if(e.width!=e.height/6&&0!=e.height%6&&!a.faces)return console.error("Cubemap image not valid, only 1x6 (vertical) or 6x3 (cross) formats. Check size:",e.width,e.height),null;var b=e.width,c=e.height;void 0!==a.is_cross?(a.faces=Texture.generateCubemapCrossFacesInfo(e.width,a.is_cross),b=c=e.width/4):a.faces?(b=a.width||a.faces[0].width,c=a.height||a.faces[0].height):c/=6;
if(b!=c)return console.log("Texture not valid, width and height for every face must be square"),null;var d=b;a.no_flip=!0;for(var f=[],k=0;6>k;k++){var h=createCanvas(d,d),l=h.getContext("2d");a.faces?l.drawImage(e,a.faces[k].x,a.faces[k].y,a.faces[k].width||d,a.faces[k].height||d,0,0,d,d):l.drawImage(e,0,c*k,b,c,0,0,d,d);f.push(h)}b=Texture.cubemapFromImages(f,a);a.keep_image&&(b.img=e);return b};Texture.generateCubemapCrossFacesInfo=function(e,a){void 0===a&&(a=1);var b=e/4;return[{x:2*b,y:b,width:b,
height:b},{x:0,y:b,width:b,height:b},{x:a*b,y:0,width:b,height:b},{x:a*b,y:2*b,width:b,height:b},{x:b,y:b,width:b,height:b},{x:3*b,y:b,width:b,height:b}]};Texture.cubemapFromURL=function(e,a,b){a=a||{};a=Object.create(a);a.texture_type=gl.TEXTURE_CUBE_MAP;var c=a.texture||new h.Texture(1,1,a);c.bind();Texture.setUploadOptions(a);for(var d=a.temp_color||[0,0,0,255],d=a.type==gl.FLOAT?new Float32Array(d):new Uint8Array(d),f=0;6>f;f++)gl.texImage2D(gl.TEXTURE_CUBE_MAP_POSITIVE_X+f,0,c.format,1,1,0,c.format,
c.type,d);gl.bindTexture(c.texture_type,null);c.ready=!1;d=new Image;d.src=e;d.onload=function(){a.texture=c;(c=h.Texture.cubemapFromImage(this,a))&&delete c.ready;b&&b(c)};return c};Texture.prototype.getPixels=function(e,a){a=a||0;var b=this.gl,c=b.getViewport(),d=b.getParameter(b.FRAMEBUFFER_BINDING);if(this.format==b.DEPTH_COMPONENT)throw"cannot use getPixels in depth textures";b.disable(b.DEPTH_TEST);var f=b.__copy_fbo;f||(f=b.__copy_fbo=b.createFramebuffer());b.bindFramebuffer(b.FRAMEBUFFER,
f);var f=null,k=this.width>>a,s=this.height>>a;b.viewport(0,0,k,s);this.texture_type==b.TEXTURE_2D?b.framebufferTexture2D(b.FRAMEBUFFER,b.COLOR_ATTACHMENT0,b.TEXTURE_2D,this.handler,a):this.texture_type==b.TEXTURE_CUBE_MAP&&b.framebufferTexture2D(b.FRAMEBUFFER,b.COLOR_ATTACHMENT0,b.TEXTURE_CUBE_MAP_POSITIVE_X+(e||0),this.handler,a);var l=this.format==b.RGB?3:4,l=4,m=this.type,f=m==b.UNSIGNED_BYTE?new Uint8Array(k*s*l):m==h.HALF_FLOAT||m==h.HALF_FLOAT_OES?new Uint16Array(k*s*l):new Float32Array(k*
s*l);b.readPixels(0,0,k,s,3==l?b.RGB:b.RGBA,m,f);b.bindFramebuffer(b.FRAMEBUFFER,d);b.viewport(c[0],c[1],c[2],c[3]);return f};Texture.prototype.setPixels=function(e,a,b,c){a={no_flip:a};c&&(a.cubemap_face=c);this.uploadData(e,a,b)};Texture.prototype.toCanvas=function(e,a,b){b=b||8192;var c=this.gl,d=Math.min(this.width,b),f=Math.min(this.height,b);this.texture_type==c.TEXTURE_CUBE_MAP&&(d*=4,f*=3);e=e||createCanvas(d,f);e.width!=d&&(e.width=d);e.height!=f&&(e.height=f);b=null;if(this.texture_type==
c.TEXTURE_2D){this.width!=d||this.height!=f?(b=new h.Texture(d,f,{format:c.RGBA,filter:c.NEAREST}),this.copyTo(b),b=b.getPixels()):b=this.getPixels();var c=e.getContext("2d"),k=c.getImageData(0,0,d,f);k.data.set(b);c.putImageData(k,0,0);a&&(b=createCanvas(d,f),a=b.getContext("2d"),a.translate(0,b.height),a.scale(1,-1),a.drawImage(e,0,0,b.width,b.height),c.drawImage(b,0,0))}else if(this.texture_type==c.TEXTURE_CUBE_MAP){d=createCanvas(this.width,this.height);a=d.getContext("2d");f=h.Texture.generateCubemapCrossFacesInfo(e.width,
1);c=e.getContext("2d");c.fillStyle="black";c.fillRect(0,0,e.width,e.height);for(var s=0;6>s;s++)b=this.getPixels(s),k=a.getImageData(0,0,d.width,d.height),k.data.set(b),a.putImageData(k,0,0),c.drawImage(d,f[s].x,f[s].y,d.width,d.height)}return e};Texture.binary_extension="png";Texture.prototype.toBinary=function(e,a){for(var b=this.toCanvas(null,e).toDataURL(a),c=b.indexOf(","),b=b.substr(c+1),b=atob(b),c=b.length,d=new Uint8Array(c),f=0;f<c;++f)d[f]=b.charCodeAt(f);return d};Texture.prototype.toBlob=
function(e,a){var b=this.toBinary(e);return new Blob([b],{type:a||"image/png"})};Texture.prototype.toBlobAsync=function(e,a,b){var c=this.toCanvas(null,e);c.toBlob?c.toBlob(b,a):(e=this.toBlob(e,a),b&&b(e))};Texture.prototype.toBase64=function(e){var a=this.width,b=this.height,c=this.getPixels(),d=createCanvas(a,b),f=d.getContext("2d"),k=f.getImageData(0,0,a,b);k.data.set(c);f.putImageData(k,0,0);e&&(e=createCanvas(a,b),a=e.getContext("2d"),a.translate(0,b),a.scale(1,-1),a.drawImage(d,0,0),d=e);return d.toDataURL("image/png")};
Texture.prototype.generateMetadata=function(){var e={};e.width=this.width;e.height=this.height;this.metadata=e};Texture.compareFormats=function(e,a){return e&&a?e==a?!0:e.width!=a.width||e.height!=a.height||e.type!=a.type||e.format!=a.format||e.texture_type!=a.texture_type?!1:!0:!1};Texture.blend=function(e,a,b,c){if(!e||!a)return!1;if(e==a)return c?e.copyTo(c):e.toViewport(),!0;gl.disable(gl.BLEND);gl.disable(gl.DEPTH_TEST);gl.disable(gl.CULL_FACE);var d=h.Shader.getBlendShader(),f=h.Mesh.getScreenQuad();
a.bind(1);d.uniforms({u_texture:0,u_texture2:1,u_factor:b});if(c)return c.drawTo(function(){if(e==c||a==c)throw"Blend output cannot be the same as the input";e.bind(0);d.draw(f,gl.TRIANGLES)}),!0;e.bind(0);d.draw(f,gl.TRIANGLES);return!0};Texture.getWhiteTexture=function(e){e=e||n.gl;var a=e.textures[":white"];if(a)return a;a=new Uint8Array([255,255,255,255]);return e.textures[":white"]=new h.Texture(1,1,{pixel_data:a})};Texture.getBlackTexture=function(e){e=e||n.gl;var a=e.textures[":black"];if(a)return a;
a=new Uint8Array([0,0,0,255]);return e.textures[":black"]=new h.Texture(1,1,{pixel_data:a})};Texture.getTemporary=function(e,a,b,c){c=c||n.gl;c._texture_pool||(c._texture_pool=[]);var d=h.TEXTURE_2D,f=Texture.DEFAULT_TYPE,k=Texture.DEFAULT_FORMAT;b&&(b.texture_type&&(d=b.texture_type),b.type&&(f=b.type),b.format&&(k=b.format));b=d+":"+f+":"+e+"x"+a+":"+k;c=c._texture_pool;for(var s=0;s<c.length;++s){var l=c[s];if(l._key==b)return c.splice(s,1),l._pool=0,l}l=new h.Texture(e,a,{type:f,texture_type:d,
format:k});l._key=b;l._pool=0;return l};Texture.releaseTemporary=function(e,a){a=a||n.gl;a._texture_pool||(a._texture_pool=[]);0<e._pool&&console.warn("this texture is already in the textures pool");var b=a._texture_pool;b||(b=a._texture_pool=[]);e._pool=getTime();b.push(e);20<b.length&&(b.sort(function(a,b){return b._pool-a._pool}),e=b.pop(),e._pool=0,e.delete())};Texture.nextPOT=function(e){return Math.pow(2,Math.ceil(Math.log(e)/Math.log(2)))};h.FBO=H;H.prototype.setTextures=function(e,a,b){if(a&&
a.constructor===h.Texture){if(a.format!==h.DEPTH_COMPONENT&&a.format!==h.DEPTH_STENCIL&&a.format!==h.DEPTH_COMPONENT16&&a.format!==h.DEPTH_COMPONENT24&&a.format!==h.DEPTH_COMPONENT32F)throw"FBO Depth texture must be of format: gl.DEPTH_COMPONENT, gl.DEPTH_STENCIL or gl.DEPTH_COMPONENT16/24/32F (only in webgl2)";if(a.type!=h.UNSIGNED_SHORT&&a.type!=h.UNSIGNED_INT&&a.type!=h.UNSIGNED_INT_24_8_WEBGL&&a.type!=h.FLOAT)throw"FBO Depth texture must be of type: gl.UNSIGNED_SHORT, gl.UNSIGNED_INT, gl.UNSIGNED_INT_24_8_WEBGL";
}var c=this.depth_texture==a;if(c&&e){if(e.constructor!==Array)throw"FBO: color_textures parameter must be an array containing all the textures to be binded in the color";if(e.length==this.color_textures.length)for(var d=0;d<e.length;++d){if(e[d]!=this.color_textures[d]){c=!1;break}}else c=!1}this._stencil_enabled!==this.stencil&&(c=!1);if(!c){this.color_textures.length=e?e.length:0;if(e)for(d=0;d<e.length;++d)this.color_textures[d]=e[d];this.depth_texture=a;this.update(b)}};H.prototype.update=function(e){this._old_fbo_handler=
gl.getParameter(gl.FRAMEBUFFER_BINDING);this.handler||(this.handler=gl.createFramebuffer());var a=-1,b=-1,c=null,d=this.color_textures,f=this.depth_texture;if(d&&d.length)for(var k=0;k<d.length;k++){var s=d[k];if(s.constructor!==h.Texture)throw"FBO can only bind instances of GL.Texture";if(-1==a)a=s.width;else if(a!=s.width)throw"Cannot bind textures with different dimensions";if(-1==b)b=s.height;else if(b!=s.height)throw"Cannot bind textures with different dimensions";if(null==c)c=s.type;else if(c!=
s.type)throw"Cannot bind textures to a FBO with different pixel formats";if(s.texture_type!=gl.TEXTURE_2D)throw"Cannot bind a Cubemap to a FBO";}else a=f.width,b=f.height;this.width=a;this.height=b;gl.bindFramebuffer(gl.FRAMEBUFFER,this.handler);var l=gl.extensions.WEBGL_draw_buffers;if(1==gl.webgl_version&&!l&&d&&1<d.length)throw"Rendering to several textures not supported by your browser";c=1==gl.webgl_version?gl.FRAMEBUFFER:gl.DRAW_FRAMEBUFFER;gl.framebufferRenderbuffer(c,gl.DEPTH_ATTACHMENT,gl.RENDERBUFFER,
null);gl.framebufferRenderbuffer(c,gl.DEPTH_STENCIL_ATTACHMENT,gl.RENDERBUFFER,null);if(f&&f.constructor===h.Texture){if(1==gl.webgl_version&&!gl.extensions.WEBGL_depth_texture)throw"Rendering to depth texture not supported by your browser";this.stencil&&f.format!==gl.DEPTH_STENCIL&&console.warn("Stencil cannot be enabled if there is a depth texture with a DEPTH_STENCIL format");f.format==gl.DEPTH_STENCIL?gl.framebufferTexture2D(c,gl.DEPTH_STENCIL_ATTACHMENT,gl.TEXTURE_2D,f.handler,0):gl.framebufferTexture2D(c,
gl.DEPTH_ATTACHMENT,gl.TEXTURE_2D,f.handler,0)}else k=null,f&&f.constructor===WebGLRenderbuffer&&f.width==a&&f.height==b?k=this._depth_renderbuffer=f:(k=this._depth_renderbuffer=this._depth_renderbuffer||gl.createRenderbuffer(),k.width=a,k.height=b),gl.bindRenderbuffer(gl.RENDERBUFFER,k),this.stencil?(gl.renderbufferStorage(gl.RENDERBUFFER,gl.DEPTH_STENCIL,a,b),gl.framebufferRenderbuffer(c,gl.DEPTH_STENCIL_ATTACHMENT,gl.RENDERBUFFER,k)):(gl.renderbufferStorage(gl.RENDERBUFFER,gl.DEPTH_COMPONENT16,
a,b),gl.framebufferRenderbuffer(c,gl.DEPTH_ATTACHMENT,gl.RENDERBUFFER,k));if(d&&d.length)for(this.order=[],k=0;k<d.length;k++)s=d[k],gl.framebufferTexture2D(c,gl.COLOR_ATTACHMENT0+k,gl.TEXTURE_2D,s.handler,0),this.order.push(gl.COLOR_ATTACHMENT0+k);else f=this._color_renderbuffer=this._color_renderbuffer||gl.createRenderbuffer(),f.width=a,f.height=b,gl.bindRenderbuffer(gl.RENDERBUFFER,f),gl.renderbufferStorage(gl.RENDERBUFFER,gl.RGBA4,a,b),gl.framebufferRenderbuffer(c,gl.COLOR_ATTACHMENT0,gl.RENDERBUFFER,
f);for(k=a=d?d.length:0;k<this._num_binded_textures;++k)gl.framebufferTexture2D(c,gl.COLOR_ATTACHMENT0+k,gl.TEXTURE_2D,null,0);this._num_binded_textures=a;this._stencil_enabled=this.stencil;d&&1<d.length&&(l?l.drawBuffersWEBGL(this.order):gl.drawBuffers(this.order));d=gl.checkFramebufferStatus(c);if(d!==gl.FRAMEBUFFER_COMPLETE)throw"FBO not complete: "+d;gl.bindTexture(gl.TEXTURE_2D,null);gl.bindRenderbuffer(gl.RENDERBUFFER,null);e||gl.bindFramebuffer(c,this._old_fbo_handler)};H.prototype.bind=function(e){if(!this.color_textures.length&&
!this.depth_texture)throw"FBO: no textures attached to FBO";this._old_viewport.set(gl.viewport_data);this._old_fbo_handler=e?gl.getParameter(gl.FRAMEBUFFER_BINDING):null;this._old_fbo_handler!=this.handler&&gl.bindFramebuffer(gl.FRAMEBUFFER,this.handler);for(e=0;e<this.color_textures.length;++e)this.color_textures[e]._in_current_fbo=!0;this.depth_texture&&(this.depth_texture._in_current_fbo=!0);gl.viewport(0,0,this.width,this.height)};H.prototype.unbind=function(){gl.bindFramebuffer(gl.FRAMEBUFFER,
this._old_fbo_handler);this._old_fbo_handler=null;gl.setViewport(this._old_viewport);for(var e=0;e<this.color_textures.length;++e)this.color_textures[e]._in_current_fbo=!1;this.depth_texture&&(this.depth_texture._in_current_fbo=!1)};H.prototype.switchTo=function(e){e._old_fbo_handler=this._old_fbo_handler;e._old_viewport.set(this._old_viewport);gl.bindFramebuffer(gl.FRAMEBUFFER,e.handler);this._old_fbo_handler=null;gl.viewport(0,0,this.width,this.height);for(var a=0;a<this.color_textures.length;++a)this.color_textures[a]._in_current_fbo=
!1;this.depth_texture&&(this.depth_texture._in_current_fbo=!1);for(a=0;a<e.color_textures.length;++a)e.color_textures[a]._in_current_fbo=!0;e.depth_texture&&(e.depth_texture._in_current_fbo=!0)};H.prototype.delete=function(){gl.deleteFramebuffer(this.handler);this.handler=null};n.Shader=h.Shader=function a(b,c,d){h.debug&&console.log("GL.Shader created");if(!b||!c)throw"GL.Shader source code parameter missing";this._context_id=n.gl.context_id;var f=this.gl=n.gl,k=a.expandMacros(d);d=b.constructor===
String?a.injectCode(k,b,f):b;k=c.constructor===String?a.injectCode(k,c,f):c;this.program=f.createProgram();b=b.constructor===String?h.Shader.compileSource(f.VERTEX_SHADER,d):b;c=c.constructor===String?h.Shader.compileSource(f.FRAGMENT_SHADER,k):c;f.attachShader(this.program,b,f);f.attachShader(this.program,c,f);f.linkProgram(this.program);if(!f.getProgramParameter(this.program,f.LINK_STATUS))throw"link error: "+f.getProgramInfoLog(this.program);this.vs_shader=b;this.fs_shader=c;this.attributes={};
this.uniformInfo={};this.samplers={};this.extractShaderInfo()};Shader.expandMacros=function(a){var b="";if(a)for(var c in a)b+="#define "+c+" "+(a[c]?a[c]:"")+"\n";return b};Shader.injectCode=function(a,b,c){var d=b.indexOf("\n");c=c?"#define WEBGL"+c.webgl_version+"\n":"";var f=b.substr(0,d).trim();return-1==f.indexOf("#version")?c+a+b:f+"\n"+c+a+b.substr(d)};Shader.compileSource=function(a,b,c,d){c=c||n.gl;d=d||c.createShader(a);c.shaderSource(d,b);c.compileShader(d);if(!c.getShaderParameter(d,
c.COMPILE_STATUS))throw(a==c.VERTEX_SHADER?"Vertex":"Fragment")+" shader compile error: "+c.getShaderInfoLog(d);return d};Shader.parseError=function(a,b,c){if(!a)return null;var d=a.split(" "),f=d[5].split(":");return{type:d[0],line_number:parseInt(f[1]),line_pos:parseInt(f[0]),line_code:("Fragment"==d[0]?c:b).split("\n")[parseInt(f[1])],err:a}};Shader.prototype.updateShader=function(a,b,c){var d=this.gl||n.gl,f=Shader.expandMacros(c);this.program&&(this.program=d.createProgram());f=Shader.expandMacros(c);
c=a.constructor===String?Shader.injectCode(f,a,d):a;f=b.constructor===String?Shader.injectCode(f,b,d):b;a=a.constructor===String?h.Shader.compileSource(d.VERTEX_SHADER,c):a;b=b.constructor===String?h.Shader.compileSource(d.FRAGMENT_SHADER,f):b;d.attachShader(this.program,a,d);d.attachShader(this.program,b,d);d.linkProgram(this.program);if(!d.getProgramParameter(this.program,d.LINK_STATUS))throw"link error: "+d.getProgramInfoLog(this.program);this.vs_shader=a;this.fs_shader=b;this.attributes={};this.uniformInfo=
{};this.samplers={};this.extractShaderInfo()};Shader.prototype.extractShaderInfo=function(){for(var a=this.gl,b=a.getProgramParameter(this.program,a.ACTIVE_UNIFORMS),c=0;c<b;++c){var d=a.getActiveUniform(this.program,c);if(!d)break;var f=d.name,k=f.indexOf("[");-1!=k&&-1==f.indexOf("].")&&(f=f.substr(0,k));if(d.type==a.SAMPLER_2D||d.type==a.SAMPLER_CUBE)this.samplers[f]=d.type;var k=Shader.getUniformFunc(d),s=!1;if(d.type==a.FLOAT_MAT2||d.type==a.FLOAT_MAT3||d.type==a.FLOAT_MAT4)s=!0;var l=h.TYPE_LENGTH[d.type]||
1;this.uniformInfo[f]={type:d.type,func:k,size:d.size,type_length:l,is_matrix:s,loc:a.getUniformLocation(this.program,f),data:new Float32Array(l*d.size)}}c=0;for(b=a.getProgramParameter(this.program,a.ACTIVE_ATTRIBUTES);c<b;++c){d=a.getActiveAttrib(this.program,c);if(!d)break;k=Shader.getUniformFunc(d);l=h.TYPE_LENGTH[d.type]||1;this.uniformInfo[d.name]={type:d.type,func:k,type_length:l,size:d.size,loc:null};this.attributes[d.name]=a.getAttribLocation(this.program,d.name)}};Shader.prototype.hasUniform=
function(a){return this.uniformInfo[a]};Shader.prototype.hasAttribute=function(a){return this.attributes[a]};Shader.getUniformFunc=function(a){var b=null;switch(a.type){case h.FLOAT:b=1==a.size?gl.uniform1f:gl.uniform1fv;break;case h.FLOAT_MAT2:b=gl.uniformMatrix2fv;break;case h.FLOAT_MAT3:b=gl.uniformMatrix3fv;break;case h.FLOAT_MAT4:b=gl.uniformMatrix4fv;break;case h.FLOAT_VEC2:b=gl.uniform2fv;break;case h.FLOAT_VEC3:b=gl.uniform3fv;break;case h.FLOAT_VEC4:b=gl.uniform4fv;break;case h.UNSIGNED_INT:case h.INT:b=
1==a.size?gl.uniform1i:gl.uniform1iv;break;case h.INT_VEC2:b=gl.uniform2iv;break;case h.INT_VEC3:b=gl.uniform3iv;break;case h.INT_VEC4:b=gl.uniform4iv;break;case h.SAMPLER_2D:case h.SAMPLER_3D:case h.SAMPLER_CUBE:b=gl.uniform1i;break;default:b=gl.uniform1f}return b};Shader.fromURL=function(a,b,c){function d(){var a=new h.Shader(k,s),b;for(b in a)f[b]=a[b];f.ready=!0}var f=new h.Shader("\n\t\t\tprecision highp float;\n\t\t\tattribute vec3 a_vertex;\n\t\t\tattribute mat4 u_mvp;\n\t\t\tvoid main() { \n\t\t\t\tgl_Position = u_mvp * vec4(a_vertex,1.0); \n\t\t\t}\n\t\t",
"\n\t\t\tprecision highp float;\n\t\t\tvoid main() {\n\t\t\t\tgl_FragColor = vec4(0.0, 0.0, 0.0, 1.0);\n\t\t\t}\n\t\t\t");f.ready=!1;var k=null,s=null;HttpRequest(a,null,function(a){k=a;s&&d()});HttpRequest(b,null,function(a){s=a;k&&d()});return f};Shader.prototype.bind=function(){var a=this.gl;a.useProgram(this.program);a._current_shader=this};Shader.prototype.getLocation=function(a){return this.uniformInfo[a]?this.uniformInfo[a].loc:null};Shader._temp_uniform=new Float32Array(16);Shader.prototype.uniforms=
function(a){var b=this.gl;b.useProgram(this.program);b._current_shader=this;for(var c in a)this.uniformInfo[c]&&this._setUniform(c,a[c]);return this};Shader.prototype.uniformsArray=function(a){var b=this.gl;b.useProgram(this.program);b._current_shader=this;for(var b=0,c=a.length;b<c;++b){var d=a[b],f;for(f in d)this._setUniform(f,d[f])}return this};Shader.prototype.setUniform=function(){return function(a,b){this.gl._current_shader!=this&&this.bind();var c=this.uniformInfo[a];c&&null!==c.loc&&null!=
b&&(b.constructor===Array&&(c.data.set(b),b=c.data),c.is_matrix?c.func.call(this.gl,c.loc,!1,b):c.func.call(this.gl,c.loc,b))}}();Shader.prototype._setUniform=function(){return function(a,b){var c=this.uniformInfo[a];c&&null!==c.loc&&null!=b&&(b.constructor===Array&&(c.data.set(b),b=c.data),c.is_matrix?c.func.call(this.gl,c.loc,!1,b):c.func.call(this.gl,c.loc,b))}}();Shader.prototype.draw=function(a,b,c){c=void 0===c?b==gl.LINES?"lines":"triangles":c;this.drawBuffers(a.vertexBuffers,c?a.indexBuffers[c]:
null,2>arguments.length?gl.TRIANGLES:b)};Shader.prototype.drawRange=function(a,b,c,d,f){f=void 0===f?b==gl.LINES?"lines":"triangles":f;this.drawBuffers(a.vertexBuffers,f?a.indexBuffers[f]:null,b,c,d)};var O=new Uint8Array(16),T=new Uint8Array(16);Shader.prototype.drawBuffers=function(a,b,c,d,f){if(0!=f){var k=this.gl;k.useProgram(this.program);var h=0;O.set(T);for(var l in a){var m=a[l],p=m.attribute||l,q=this.attributes[p];null!=q&&m.buffer&&(O[q]=1,k.bindBuffer(k.ARRAY_BUFFER,m.buffer),k.enableVertexAttribArray(q),
k.vertexAttribPointer(q,m.buffer.spacing,m.buffer.gl_type,!1,0,0),h=m.buffer.length/m.buffer.spacing)}a=0;0<d&&(a=d);b&&(h=b.buffer.length-a);0<f&&f<h&&(h=f);a*=b&&b.data?b.data.constructor.BYTES_PER_ELEMENT:1;for(p in this.attributes)q=this.attributes[p],O[q]||k.disableVertexAttribArray(this.attributes[p]);!h||b&&!b.buffer||(b?(k.bindBuffer(k.ELEMENT_ARRAY_BUFFER,b.buffer),k.drawElements(c,h,b.buffer.gl_type,a),k.bindBuffer(k.ELEMENT_ARRAY_BUFFER,null)):k.drawArrays(c,a,h));return this}};Shader._instancing_arrays=
[];Shader.prototype.drawInstanced=function(a,b,c,d,f,k){if(0!=k){var h=this.gl;if(1==h.webgl_version&&!h.extensions.ANGLE_instanced_arrays)throw"instancing not supported";h.useProgram(this.program);var l=0;O.set(T);var m=a.vertexBuffers,p;for(p in m){var q=m[p],r=q.attribute||p,n=this.attributes[r];null!=n&&q.buffer&&(O[n]=1,h.bindBuffer(h.ARRAY_BUFFER,q.buffer),h.enableVertexAttribArray(n),h.vertexAttribPointer(n,q.buffer.spacing,q.buffer.gl_type,!1,0,0),l=q.buffer.length/q.buffer.spacing)}a=c?a.getIndexBuffer(c):
null;c=0;0<f&&(c=f);a&&(l=a.buffer.length-c);0<k&&k<l&&(l=k);c*=a&&a.data?a.data.constructor.BYTES_PER_ELEMENT:1;for(r in this.attributes)n=this.attributes[r],O[n]||h.disableVertexAttribArray(this.attributes[r]);f=h.extensions.ANGLE_instanced_arrays;k=n=0;for(var v in d){p=d[v];n=p.length;r=this.attributes[v];if(null==r)return;var t=m=0;p.constructor===Array?(m=p[0].constructor===Number?1:p[0].length,t=m*p.length):(m=this.uniformInfo[v].type_length,t=p.length,n=t/m);q=Shader._instancing_arrays[k];
if(!q||q.data.length<t)q=Shader._instancing_arrays[k]={data:new Float32Array(t),buffer:h.createBuffer()};q.uniform=v;q.element_size=m;if(p.constructor===Array)for(t=0;t<p.length;++t)q.data.set(p[t],t*m);else q.data.set(p);h.bindBuffer(h.ARRAY_BUFFER,q.buffer);h.bufferData(h.ARRAY_BUFFER,q.data,h.STREAM_DRAW);if(16==m)for(m=0;4>m;++m)h.enableVertexAttribArray(r+m),h.vertexAttribPointer(r+m,4,h.FLOAT,!1,64,16*m),f?f.vertexAttribDivisorANGLE(r+m,1):h.vertexAttribDivisor(r+m,1);else h.enableVertexAttribArray(r),
h.vertexAttribPointer(r,m,h.FLOAT,!1,4*m,0),f?f.vertexAttribDivisorANGLE(r,1):h.vertexAttribDivisor(r,1);k+=1}f?a?(h.bindBuffer(h.ELEMENT_ARRAY_BUFFER,a.buffer),f.drawElementsInstancedANGLE(b,l,a.buffer.gl_type,c,n),h.bindBuffer(h.ELEMENT_ARRAY_BUFFER,null)):f.drawArraysInstancedANGLE(b,c,l,n):a?(h.bindBuffer(h.ELEMENT_ARRAY_BUFFER,a.buffer),h.drawElementsInstanced(b,l,a.buffer.gl_type,c,n),h.bindBuffer(h.ELEMENT_ARRAY_BUFFER,null)):h.drawArraysInstanced(b,c,l,n);for(b=0;b<k;++b)if(d=Shader._instancing_arrays[b],
r=this.attributes[d.uniform],m=d.element_size,16==m)for(m=0;4>m;++m)h.disableVertexAttribArray(r+m),f?f.vertexAttribDivisorANGLE(r+m,0):h.vertexAttribDivisor(r+m,0);else h.enableVertexAttribArray(r),f?f.vertexAttribDivisorANGLE(r,0):h.vertexAttribDivisor(r,0);return this}};Shader.expandImports=function(a,b){b=b||Shader.files;var c={};if(!b)throw"Shader.files not initialized, assign files there";return a.replace(/#import\s+\"([a-zA-Z0-9_\.]+)\"\s*\n/g,function(a){a=a.split('"')[1];if(c[a])return"//already imported: "+
a+"\n";var f=b[a];c[a]=!0;return f?f+"\n":"//import code not found: "+a+"\n"})};Shader.dumpErrorToConsole=function(a,b,c){console.error(a);var d=null,d=-1!=a.indexOf("Fragment")?c:b;a=d.split("\n");for(var f in a)a[f]=f+"| "+a[f];console.groupCollapsed("Shader code");console.log(a.join("\n"));console.groupEnd()};Shader.convertTo100=function(a,b){};Shader.convertTo300=function(a,b){};Shader.validateValue=function(a,b){if(null===a||void 0===a)return!1;switch(b.type){case h.INT:case h.FLOAT:case h.SAMPLER_2D:case h.SAMPLER_CUBE:return isNumber(a);
case h.INT_VEC2:case h.FLOAT_VEC2:return 2===a.length;case h.INT_VEC3:case h.FLOAT_VEC3:return 3===a.length;case h.INT_VEC4:case h.FLOAT_VEC4:case h.FLOAT_MAT2:return 4===a.length;case h.FLOAT_MAT3:return 8===a.length;case h.FLOAT_MAT4:return 16===a.length}return!0};Shader.DEFAULT_VERTEX_SHADER="\n\t\t\tprecision highp float;\n\t\t\tattribute vec3 a_vertex;\n\t\t\tattribute vec3 a_normal;\n\t\t\tattribute vec2 a_coord;\n\t\t\tvarying vec3 v_position;\n\t\t\tvarying vec3 v_normal;\n\t\t\tvarying vec2 v_coord;\n\t\t\tuniform mat4 u_model;\n\t\t\tuniform mat4 u_mvp;\n\t\t\tvoid main() {\n\t\t\t\tv_position = (u_model * vec4(a_vertex,1.0)).xyz;\n\t\t\t\tv_normal = (u_model * vec4(a_normal,0.0)).xyz;\n\t\t\t\tv_coord = a_coord;\n\t\t\t\tgl_Position = u_mvp * vec4(a_vertex,1.0);\n\t\t\t}\n\t\t\t";
Shader.SCREEN_VERTEX_SHADER="\n\t\t\tprecision highp float;\n\t\t\tattribute vec3 a_vertex;\n\t\t\tattribute vec2 a_coord;\n\t\t\tvarying vec2 v_coord;\n\t\t\tvoid main() { \n\t\t\t\tv_coord = a_coord; \n\t\t\t\tgl_Position = vec4(a_coord * 2.0 - 1.0, 0.0, 1.0); \n\t\t\t}\n\t\t\t";Shader.SCREEN_FRAGMENT_SHADER="\n\t\t\tprecision highp float;\n\t\t\tuniform sampler2D u_texture;\n\t\t\tvarying vec2 v_coord;\n\t\t\tvoid main() {\n\t\t\t\tgl_FragColor = texture2D(u_texture, v_coord);\n\t\t\t}\n\t\t\t";
Shader.SCREEN_FRAGMENT_FX="\n\t\t\tprecision highp float;\n\t\t\tuniform sampler2D u_texture;\n\t\t\tvarying vec2 v_coord;\n\t\t\t#ifdef FX_UNIFORMS\n\t\t\t\tFX_UNIFORMS\n\t\t\t#endif\n\t\t\tvoid main() {\n\t\t\t\tvec2 uv = v_coord;\n\t\t\t\tvec4 color = texture2D(u_texture, uv);\n\t\t\t\t#ifdef FX_CODE\n\t\t\t\t\tFX_CODE ;\n\t\t\t\t#endif\n\t\t\t\tgl_FragColor = color;\n\t\t\t}\n\t\t\t";Shader.SCREEN_COLORED_FRAGMENT_SHADER="\n\t\t\tprecision highp float;\n\t\t\tuniform sampler2D u_texture;\n\t\t\tuniform vec4 u_color;\n\t\t\tvarying vec2 v_coord;\n\t\t\tvoid main() {\n\t\t\t\tgl_FragColor = u_color * texture2D(u_texture, v_coord);\n\t\t\t}\n\t\t\t";
Shader.BLEND_FRAGMENT_SHADER="\n\t\t\tprecision highp float;\n\t\t\tuniform sampler2D u_texture;\n\t\t\tuniform sampler2D u_texture2;\n\t\t\tuniform float u_factor;\n\t\t\tvarying vec2 v_coord;\n\t\t\tvoid main() {\n\t\t\t\tgl_FragColor = mix( texture2D(u_texture, v_coord), texture2D(u_texture2, v_coord), u_factor);\n\t\t\t}\n\t\t\t";Shader.QUAD_VERTEX_SHADER="\n\t\t\tprecision highp float;\n\t\t\tattribute vec3 a_vertex;\n\t\t\tattribute vec2 a_coord;\n\t\t\tvarying vec2 v_coord;\n\t\t\tuniform vec2 u_position;\n\t\t\tuniform vec2 u_size;\n\t\t\tuniform vec2 u_viewport;\n\t\t\tuniform mat3 u_transform;\n\t\t\tvoid main() { \n\t\t\t\tvec3 pos = vec3(u_position + vec2(a_coord.x,1.0 - a_coord.y)  * u_size, 1.0);\n\t\t\t\tv_coord = a_coord; \n\t\t\t\tpos = u_transform * pos;\n\t\t\t\tpos.z = 0.0;\n\t\t\t\t//normalize\n\t\t\t\tpos.x = (2.0 * pos.x / u_viewport.x) - 1.0;\n\t\t\t\tpos.y = -((2.0 * pos.y / u_viewport.y) - 1.0);\n\t\t\t\tgl_Position = vec4(pos, 1.0); \n\t\t\t}\n\t\t\t";
Shader.QUAD_FRAGMENT_SHADER="\n\t\t\tprecision highp float;\n\t\t\tuniform sampler2D u_texture;\n\t\t\tuniform vec4 u_color;\n\t\t\tvarying vec2 v_coord;\n\t\t\tvoid main() {\n\t\t\t\tgl_FragColor = u_color * texture2D(u_texture, v_coord);\n\t\t\t}\n\t\t\t";Shader.QUAD2_FRAGMENT_SHADER="\n\t\t\tprecision highp float;\n\t\t\tuniform sampler2D u_texture;\n\t\t\tuniform vec4 u_color;\n\t\t\tuniform vec4 u_texture_area;\n\t\t\tvarying vec2 v_coord;\n\t\t\tvoid main() {\n\t\t\t    vec2 uv = vec2( mix(u_texture_area.x, u_texture_area.z, v_coord.x), 1.0 - mix(u_texture_area.w, u_texture_area.y, v_coord.y) );\n\t\t\t\tgl_FragColor = u_color * texture2D(u_texture, uv);\n\t\t\t}\n\t\t\t";
Shader.PRIMITIVE2D_VERTEX_SHADER="\n\t\t\tprecision highp float;\n\t\t\tattribute vec3 a_vertex;\n\t\t\tuniform vec2 u_viewport;\n\t\t\tuniform mat3 u_transform;\n\t\t\tvoid main() { \n\t\t\t\tvec3 pos = a_vertex;\n\t\t\t\tpos = u_transform * pos;\n\t\t\t\tpos.z = 0.0;\n\t\t\t\t//normalize\n\t\t\t\tpos.x = (2.0 * pos.x / u_viewport.x) - 1.0;\n\t\t\t\tpos.y = -((2.0 * pos.y / u_viewport.y) - 1.0);\n\t\t\t\tgl_Position = vec4(pos, 1.0); \n\t\t\t}\n\t\t\t";Shader.FLAT_VERTEX_SHADER="\n\t\t\tprecision highp float;\n\t\t\tattribute vec3 a_vertex;\n\t\t\tuniform mat4 u_mvp;\n\t\t\tvoid main() { \n\t\t\t\tgl_Position = u_mvp * vec4(a_vertex,1.0); \n\t\t\t}\n\t\t\t";
Shader.FLAT_FRAGMENT_SHADER="\n\t\t\tprecision highp float;\n\t\t\tuniform vec4 u_color;\n\t\t\tvoid main() {\n\t\t\t\tgl_FragColor = u_color;\n\t\t\t}\n\t\t\t";Shader.SCREEN_FLAT_FRAGMENT_SHADER=Shader.FLAT_FRAGMENT_SHADER;Shader.createFX=function(a,b,c){a=h.Shader.removeComments(a,!0);a={FX_CODE:a,FX_UNIFORMS:b||""};if(!c)return new h.Shader(h.Shader.SCREEN_VERTEX_SHADER,h.Shader.SCREEN_FRAGMENT_FX,a);c.updateShader(h.Shader.SCREEN_VERTEX_SHADER,h.Shader.SCREEN_FRAGMENT_FX,a);return c};Shader.removeComments=
function(a,b){if(!a)return"";a=a.replace(/(\/\*([^*]|[\r\n]|(\*+([^*\/]|[\r\n])))*\*+\/)|(\/\/.*)/g,"");for(var c=a.split("\n"),d=[],f=0;f<c.length;++f){var k=c[f],h=k.indexOf("//");-1!=h&&(k=c[f].substr(0,h));k=k.trim();k.length&&d.push(k)}return d.join(b?"":"\n")};Shader.prototype.toViewport=function(a){var b=h.Mesh.getScreenQuad();a&&this.uniforms(a);this.draw(b)};Shader.getScreenShader=function(a){a=a||n.gl;var b=a.shaders[":screen"];if(b)return b;b=a.shaders[":screen"]=new h.Shader(Shader.SCREEN_VERTEX_SHADER,
Shader.SCREEN_FRAGMENT_SHADER);return b.uniforms({u_texture:0})};Shader.getFlatScreenShader=function(a){a=a||n.gl;var b=a.shaders[":flat_screen"];if(b)return b;b=a.shaders[":flat_screen"]=new h.Shader(Shader.SCREEN_VERTEX_SHADER,Shader.FLAT_FRAGMENT_SHADER);return b.uniforms({u_color:[1,1,1,1]})};Shader.getColoredScreenShader=function(a){a=a||n.gl;var b=a.shaders[":colored_screen"];if(b)return b;b=a.shaders[":colored_screen"]=new h.Shader(Shader.SCREEN_VERTEX_SHADER,Shader.SCREEN_COLORED_FRAGMENT_SHADER);
return b.uniforms({u_texture:0,u_color:vec4.fromValues(1,1,1,1)})};Shader.getQuadShader=function(a){a=a||n.gl;var b=a.shaders[":quad"];return b?b:a.shaders[":quad"]=new h.Shader(Shader.QUAD_VERTEX_SHADER,Shader.QUAD_FRAGMENT_SHADER)};Shader.getPartialQuadShader=function(a){a=a||n.gl;var b=a.shaders[":quad2"];return b?b:a.shaders[":quad2"]=new h.Shader(Shader.QUAD_VERTEX_SHADER,Shader.QUAD2_FRAGMENT_SHADER)};Shader.getBlendShader=function(a){a=a||n.gl;var b=a.shaders[":blend"];return b?b:a.shaders[":blend"]=
new h.Shader(Shader.SCREEN_VERTEX_SHADER,Shader.BLEND_FRAGMENT_SHADER)};Shader.getBlurShader=function(a){a=a||n.gl;var b=a.shaders[":blur"];if(b)return b;b=new h.Shader(Shader.SCREEN_VERTEX_SHADER,"\n\t\t\tprecision highp float;\n\t\t\tvarying vec2 v_coord;\n\t\t\tuniform sampler2D u_texture;\n\t\t\tuniform vec2 u_offset;\n\t\t\tuniform float u_intensity;\n\t\t\tvoid main() {\n\t\t\t   vec4 sum = vec4(0.0);\n\t\t\t   sum += texture2D(u_texture, v_coord + u_offset * -4.0) * 0.05/0.98;\n\t\t\t   sum += texture2D(u_texture, v_coord + u_offset * -3.0) * 0.09/0.98;\n\t\t\t   sum += texture2D(u_texture, v_coord + u_offset * -2.0) * 0.12/0.98;\n\t\t\t   sum += texture2D(u_texture, v_coord + u_offset * -1.0) * 0.15/0.98;\n\t\t\t   sum += texture2D(u_texture, v_coord) * 0.16/0.98;\n\t\t\t   sum += texture2D(u_texture, v_coord + u_offset * 4.0) * 0.05/0.98;\n\t\t\t   sum += texture2D(u_texture, v_coord + u_offset * 3.0) * 0.09/0.98;\n\t\t\t   sum += texture2D(u_texture, v_coord + u_offset * 2.0) * 0.12/0.98;\n\t\t\t   sum += texture2D(u_texture, v_coord + u_offset * 1.0) * 0.15/0.98;\n\t\t\t   gl_FragColor = u_intensity * sum;\n\t\t\t}\n\t\t\t");
return a.shaders[":blur"]=b};Shader.getCopyDepthShader=function(a){a=a||n.gl;var b=a.shaders[":copy_depth"];if(b)return b;b=new h.Shader(Shader.SCREEN_VERTEX_SHADER,"\n\t\t\t#extension GL_EXT_frag_depth : enable\n\t\t\tprecision highp float;\n\t\t\tvarying vec2 v_coord;\n\t\t\tuniform sampler2D u_texture;\n\t\t\tvoid main() {\n\t\t\t   gl_FragDepthEXT = texture2D( u_texture, v_coord ).x;\n\t\t\t   gl_FragColor = vec4(1.0);\n\t\t\t}\n\t\t\t");return a.shaders[":copy_depth"]=b};Shader.getCubemapShowShader=
function(a){a=a||n.gl;var b=a.shaders[":show_cubemap"];if(b)return b;b=new h.Shader(Shader.DEFAULT_VERTEX_SHADER,"\n\t\t\tprecision highp float;\n\t\t\tvarying vec3 v_normal;\n\t\t\tuniform samplerCube u_texture;\n\t\t\tvoid main() {\n\t\t\t   gl_FragColor = textureCube( u_texture, v_normal );\n\t\t\t}\n\t\t\t");b.uniforms({u_texture:0});return a.shaders[":show_cubemap"]=b};Shader.getCubemapCopyShader=function(a){a=a||n.gl;var b=a.shaders[":copy_cubemap"];if(b)return b;b=new h.Shader(Shader.SCREEN_VERTEX_SHADER,
"\n\t\t\tprecision highp float;\n\t\t\tvarying vec2 v_coord;\n\t\t\tuniform samplerCube u_texture;\n\t\t\tuniform mat3 u_rotation;\n\t\t\tvoid main() {\n\t\t\t\tvec2 uv = vec2( v_coord.x, 1.0 - v_coord.y );\n\t\t\t\tvec3 dir = vec3( uv - vec2(0.5), 0.5 );\n\t\t\t\tdir = u_rotation * dir;\n\t\t\t   gl_FragColor = textureCube( u_texture, dir );\n\t\t\t}\n\t\t\t");return a.shaders[":copy_cubemap"]=b};Shader.getCubemapBlurShader=function(a){a=a||n.gl;var b=a.shaders[":blur_cubemap"];if(b)return b;b=new h.Shader(Shader.SCREEN_VERTEX_SHADER,
"\n\t\t\t#ifndef NUM_SAMPLES\n\t\t\t\t#define NUM_SAMPLES 4\n\t\t\t#endif\n\t\t\t\n\t\t\tprecision highp float;\n\t\t\tvarying vec2 v_coord;\n\t\t\tuniform samplerCube u_texture;\n\t\t\tuniform mat3 u_rotation;\n\t\t\tuniform vec2 u_offset;\n\t\t\tuniform float u_intensity;\n\t\t\tvoid main() {\n\t\t\t\tvec4 sum = vec4(0.0);\n\t\t\t\tvec2 uv = vec2( v_coord.x, 1.0 - v_coord.y ) - vec2(0.5);\n\t\t\t\tvec3 dir = vec3(0.0);\n\t\t\t\tvec4 color = vec4(0.0);\n\t\t\t\tfor( int x = -2; x <= 2; x++ )\n\t\t\t\t{\n\t\t\t\t\tfor( int y = -2; y <= 2; y++ )\n\t\t\t\t\t{\n\t\t\t\t\t\tdir.xy = uv + vec2( u_offset.x * float(x), u_offset.y * float(y)) * 0.5;\n\t\t\t\t\t\tdir.z = 0.5;\n\t\t\t\t\t\tdir = u_rotation * dir;\n\t\t\t\t\t\tcolor = textureCube( u_texture, dir );\n\t\t\t\t\t\tcolor.xyz = color.xyz * color.xyz;/*linearize*/\n\t\t\t\t\t\tsum += color;\n\t\t\t\t\t}\n\t\t\t\t}\n\t\t\t\tsum /= 25.0;\n\t\t\t   gl_FragColor = vec4( sqrt( sum.xyz ), sum.w ) ;\n\t\t\t}\n\t\t\t");
return a.shaders[":blur_cubemap"]=b};Shader.FXAA_FUNC="\n\tuniform vec2 u_viewportSize;\n\tuniform vec2 u_iViewportSize;\n\t#define FXAA_REDUCE_MIN   (1.0/ 128.0)\n\t#define FXAA_REDUCE_MUL   (1.0 / 8.0)\n\t#define FXAA_SPAN_MAX     8.0\n\t\n\t/* from mitsuhiko/webgl-meincraft based on the code on geeks3d.com */\n\tvec4 applyFXAA(sampler2D tex, vec2 fragCoord)\n\t{\n\t\tvec4 color = vec4(0.0);\n\t\t/*vec2 u_iViewportSize = vec2(1.0 / u_viewportSize.x, 1.0 / u_viewportSize.y);*/\n\t\tvec3 rgbNW = texture2D(tex, (fragCoord + vec2(-1.0, -1.0)) * u_iViewportSize).xyz;\n\t\tvec3 rgbNE = texture2D(tex, (fragCoord + vec2(1.0, -1.0)) * u_iViewportSize).xyz;\n\t\tvec3 rgbSW = texture2D(tex, (fragCoord + vec2(-1.0, 1.0)) * u_iViewportSize).xyz;\n\t\tvec3 rgbSE = texture2D(tex, (fragCoord + vec2(1.0, 1.0)) * u_iViewportSize).xyz;\n\t\tvec3 rgbM  = texture2D(tex, fragCoord  * u_iViewportSize).xyz;\n\t\tvec3 luma = vec3(0.299, 0.587, 0.114);\n\t\tfloat lumaNW = dot(rgbNW, luma);\n\t\tfloat lumaNE = dot(rgbNE, luma);\n\t\tfloat lumaSW = dot(rgbSW, luma);\n\t\tfloat lumaSE = dot(rgbSE, luma);\n\t\tfloat lumaM  = dot(rgbM,  luma);\n\t\tfloat lumaMin = min(lumaM, min(min(lumaNW, lumaNE), min(lumaSW, lumaSE)));\n\t\tfloat lumaMax = max(lumaM, max(max(lumaNW, lumaNE), max(lumaSW, lumaSE)));\n\t\t\n\t\tvec2 dir;\n\t\tdir.x = -((lumaNW + lumaNE) - (lumaSW + lumaSE));\n\t\tdir.y =  ((lumaNW + lumaSW) - (lumaNE + lumaSE));\n\t\t\n\t\tfloat dirReduce = max((lumaNW + lumaNE + lumaSW + lumaSE) * (0.25 * FXAA_REDUCE_MUL), FXAA_REDUCE_MIN);\n\t\t\n\t\tfloat rcpDirMin = 1.0 / (min(abs(dir.x), abs(dir.y)) + dirReduce);\n\t\tdir = min(vec2(FXAA_SPAN_MAX, FXAA_SPAN_MAX), max(vec2(-FXAA_SPAN_MAX, -FXAA_SPAN_MAX), dir * rcpDirMin)) * u_iViewportSize;\n\t\t\n\t\tvec3 rgbA = 0.5 * (texture2D(tex, fragCoord * u_iViewportSize + dir * (1.0 / 3.0 - 0.5)).xyz + \n\t\t\ttexture2D(tex, fragCoord * u_iViewportSize + dir * (2.0 / 3.0 - 0.5)).xyz);\n\t\tvec3 rgbB = rgbA * 0.5 + 0.25 * (texture2D(tex, fragCoord * u_iViewportSize + dir * -0.5).xyz + \n\t\t\ttexture2D(tex, fragCoord * u_iViewportSize + dir * 0.5).xyz);\n\t\t\n\t\treturn vec4(rgbA,1.0);\n\t\tfloat lumaB = dot(rgbB, luma);\n\t\tif ((lumaB < lumaMin) || (lumaB > lumaMax))\n\t\t\tcolor = vec4(rgbA, 1.0);\n\t\telse\n\t\t\tcolor = vec4(rgbB, 1.0);\n\t\treturn color;\n\t}\n";
Shader.getFXAAShader=function(a){a=a||n.gl;var b=a.shaders[":fxaa"];if(b)return b;var b=new h.Shader(Shader.SCREEN_VERTEX_SHADER,"\n\t\t\tprecision highp float;\n\t\t\tvarying vec2 v_coord;\n\t\t\tuniform sampler2D u_texture;\n\t\t\t"+Shader.FXAA_FUNC+"\n\t\t\t\n\t\t\tvoid main() {\n\t\t\t   gl_FragColor = applyFXAA( u_texture, v_coord * u_viewportSize) ;\n\t\t\t}\n\t\t\t"),c=vec2.fromValues(a.viewport_data[2],a.viewport_data[3]),d=vec2.fromValues(1/a.viewport_data[2],1/a.viewport_data[3]);b.setup=
function(){c[0]=a.viewport_data[2];c[1]=a.viewport_data[3];d[0]=1/a.viewport_data[2];d[1]=1/a.viewport_data[3];this.uniforms({u_viewportSize:c,u_iViewportSize:d})};return a.shaders[":fxaa"]=b};Shader.getFlatShader=function(a){a=a||n.gl;var b=a.shaders[":flat"];if(b)return b;b=new h.Shader(Shader.FLAT_VERTEX_SHADER,Shader.FLAT_FRAGMENT_SHADER);b.uniforms({u_color:[1,1,1,1]});return a.shaders[":flat"]=b};h.create=function(a){function b(a){if(!l.ignore_events){var c=l.mouse.buttons;h.augmentEvent(a,
f);a.eventType=a.eventType||a.type;var d=getTime();q.dragging=a.dragging;q.position[0]=a.canvasx;q.position[1]=a.canvasy;q.x=a.canvasx;q.y=a.canvasy;q.mousex=a.mousex;q.mousey=a.mousey;q.canvasx=a.canvasx;q.canvasy=a.canvasy;q.clientx=a.mousex;q.clienty=a.mousey;q.left_button=!!(q.buttons&1<<h.LEFT_MOUSE_BUTTON);q.middle_button=!!(q.buttons&1<<h.MIDDLE_MOUSE_BUTTON);q.right_button=!!(q.buttons&1<<h.RIGHT_MOUSE_BUTTON);if("mousedown"==a.eventType){0==c&&(f.removeEventListener("mousemove",b),c=f.ownerDocument,
c.addEventListener("mousemove",b),c.addEventListener("mouseup",b));p=d;if(l.onmousedown)l.onmousedown(a);u.trigger(l,"mousedown")}else if("mousemove"==a.eventType){if(l.onmousemove)l.onmousemove(a);u.trigger(l,"mousemove",a)}else if("mouseup"==a.eventType){0==l.mouse.buttons&&(f.addEventListener("mousemove",b),c=f.ownerDocument,c.removeEventListener("mousemove",b),c.removeEventListener("mouseup",b));a.click_time=d-p;if(l.onmouseup)l.onmouseup(a);u.trigger(l,"mouseup",a)}else if("mousewheel"==a.eventType||
"wheel"==a.eventType||"DOMMouseScroll"==a.eventType){a.eventType="mousewheel";a.wheel="wheel"==a.type?-a.deltaY:null!=a.wheelDeltaY?a.wheelDeltaY:-60*a.detail;a.delta=void 0!==a.wheelDelta?a.wheelDelta/40:a.deltaY?-a.deltaY/3:0;if(l.onmousewheel)l.onmousewheel(a);u.trigger(l,"mousewheel",a)}else if("dragstart"==a.eventType){if(l.ondragstart)l.ondragstart(a);u.trigger(l,"dragstart",a)}if(l.onmouse)l.onmouse(a);if(!a.skip_preventDefault)return"mousemove"!=a.eventType&&a.stopPropagation(),a.preventDefault(),
!1}}function c(a){var b=a.changedTouches,c=b[0],d="";if(!(l.ontouch&&!0===l.ontouch(a)||!0===u.trigger(l,a.type,a)||!r||a.touches.length&&a.changedTouches[0].identifier!==a.touches[0].identifier||1<b)){switch(a.type){case "touchstart":d="mousedown";break;case "touchmove":d="mousemove";break;case "touchend":d="mouseup";break;default:return}b=document.createEvent("MouseEvent");b.initMouseEvent(d,!0,!0,window,1,c.screenX,c.screenY,c.clientX,c.clientY,!1,!1,!1,!1,0,null);b.originalEvent=b;b.is_touch=
!0;c.target.dispatchEvent(b);a.preventDefault()}}function d(a){a.eventType=a.type;l.ongesture&&!1===l.ongesture(a)||!1!==u.trigger(l,a.type,a)&&a.preventDefault()}a=a||{};var f=null;if(a.canvas)if("string"==typeof a.canvas){if(f=document.getElementById(a.canvas),!f)throw"Canvas element not found: "+a.canvas;}else f=a.canvas;else{var k=null;a.container&&(k=a.container.constructor===String?document.querySelector(a.container):a.container);if(k&&!a.width){var s=k.getBoundingClientRect();a.width=s.width;
a.height=s.height}f=createCanvas(a.width||800,a.height||600);k&&k.appendChild(f)}"alpha"in a||(a.alpha=!1);var l=null,k=null;2==a.version?k=["webgl2","experimental-webgl2"]:1==a.version||void 0===a.version?k=["webgl","experimental-webgl"]:0===a.version&&(k=["webgl2","experimental-webgl2","webgl","experimental-webgl"]);if(!k)throw"Incorrect WebGL version, must be 1 or 2";a={alpha:void 0===a.alpha?!0:a.alpha,depth:void 0===a.depth?!0:a.depth,stencil:void 0===a.stencil?!0:a.stencil,antialias:void 0===
a.antialias?!0:a.antialias,premultipliedAlpha:void 0===a.premultipliedAlpha?!0:a.premultipliedAlpha,preserveDrawingBuffer:void 0===a.preserveDrawingBuffer?!0:a.preserveDrawingBuffer};for(s=0;s<k.length;++s){try{l=f.getContext(k[s],a)}catch(m){}if(l)break}if(!l){if(f.getContext("webgl"))throw"WebGL supported but not with those parameters";throw"WebGL not supported";}l.webgl_version="WebGL2RenderingContext"===l.constructor.name?2:1;n.gl=l;f.is_webgl=!0;f.gl=l;l.context_id=this.last_context_id++;l.extensions=
{};l.extensions.OES_standard_derivatives=l.derivatives_supported=l.getExtension("OES_standard_derivatives")||!1;l.extensions.WEBGL_depth_texture=l.getExtension("WEBGL_depth_texture")||l.getExtension("WEBKIT_WEBGL_depth_texture")||l.getExtension("MOZ_WEBGL_depth_texture");l.extensions.OES_element_index_uint=l.getExtension("OES_element_index_uint");l.extensions.WEBGL_draw_buffers=l.getExtension("WEBGL_draw_buffers");l.extensions.EXT_shader_texture_lod=l.getExtension("EXT_shader_texture_lod");l.extensions.EXT_sRGB=
l.getExtension("EXT_sRGB");l.extensions.EXT_texture_filter_anisotropic=l.getExtension("EXT_texture_filter_anisotropic")||l.getExtension("WEBKIT_EXT_texture_filter_anisotropic")||l.getExtension("MOZ_EXT_texture_filter_anisotropic");l.extensions.EXT_frag_depth=l.getExtension("EXT_frag_depth")||l.getExtension("WEBKIT_EXT_frag_depth")||l.getExtension("MOZ_EXT_frag_depth");l.extensions.WEBGL_lose_context=l.getExtension("WEBGL_lose_context")||l.getExtension("WEBKIT_WEBGL_lose_context")||l.getExtension("MOZ_WEBGL_lose_context");
l.extensions.ANGLE_instanced_arrays=l.getExtension("ANGLE_instanced_arrays");l.extensions.OES_texture_float_linear=l.getExtension("OES_texture_float_linear");l.extensions.OES_texture_float_linear&&(l.extensions.OES_texture_float=l.getExtension("OES_texture_float"));l.extensions.EXT_color_buffer_float=l.getExtension("EXT_color_buffer_float");l.extensions.OES_texture_half_float_linear=l.getExtension("OES_texture_half_float_linear");l.extensions.OES_texture_half_float_linear&&(l.extensions.OES_texture_half_float=
l.getExtension("OES_texture_half_float"));l.HIGH_PRECISION_FORMAT=1==l.webgl_version?l.extensions.OES_texture_half_float?h.HALF_FLOAT_OES:l.extensions.OES_texture_float?h.FLOAT:h.UNSIGNED_BYTE:h.HALF_FLOAT_OES;l.max_texture_units=l.getParameter(l.MAX_TEXTURE_IMAGE_UNITS);l._viewport_func?console.warn("Creating LiteGL context over the same canvas twice"):(l._viewport_func=l.viewport,l.viewport_data=new Float32Array([0,0,l.canvas.width,l.canvas.height]),l.viewport=function(a,b,c,d){var f=this.viewport_data;
f[0]=a|0;f[1]=b|0;f[2]=c|0;f[3]=d|0;this._viewport_func(a,b,c,d)},l.getViewport=function(a){return a?(a[0]=l.viewport_data[0],a[1]=l.viewport_data[1],a[2]=l.viewport_data[2],a[3]=l.viewport_data[3],a):new Float32Array(l.viewport_data)},l.setViewport=function(a,b){l.viewport_data.set(a);b&&(l.viewport_data[1]=this.drawingBufferHeight-a[1]-a[3]);this._viewport_func(a[0],l.viewport_data[1],a[2],a[3])});if("undefined"==typeof glMatrix)throw"glMatrix not found, LiteGL requires glMatrix to be included";
var p=0;l.shaders={};l.textures={};l.meshes={};l.makeCurrent=function(){n.gl=this};l.execute=function(a){var b=n.gl;n.gl=this;a();n.gl=b};l.animate=function(a){function b(){if(!l.destroyed){f._requestFrame_id=c(b);var a=getTime(),k=0.001*(a-d);f.mouse&&(f.mouse.last_buttons=f.mouse.buttons);if(f.onupdate)f.onupdate(k);u.trigger(f,"update",k);f.ondraw&&(k=n.gl,n.gl=f,f.ondraw(),u.trigger(f,"draw"),n.gl=k);d=a}}if(!1===a)n.cancelAnimationFrame(this._requestFrame_id),this._requestFrame_id=null;else{var c=
n.requestAnimationFrame,d=getTime(),f=this;this._requestFrame_id=c(b)}};l.destroy=function(){w&&(document.removeEventListener("keydown",w),document.removeEventListener("keyup",w));this.canvas.parentNode&&this.canvas.parentNode.removeChild(this.canvas);this.destroyed=!0;n.gl==this&&(n.gl=null)};var q=l.mouse={buttons:0,last_buttons:0,left_button:!1,middle_button:!1,right_button:!1,position:new Float32Array(2),x:0,y:0,deltax:0,deltay:0,clientx:0,clienty:0,isInsideRect:function(a,b,c,d,f){var k=this.y;
f&&(k=l.canvas.height-k);return this.x>a&&this.x<a+c&&k>b&&k<b+d?!0:!1},isButtonPressed:function(a){return this.buttons&1<<a},wasButtonPressed:function(a){return this.buttons&1<<a&&!(this.last_buttons&1<<a)}};l.captureMouse=function(a,c){f.addEventListener("mousedown",b);f.addEventListener("mousemove",b);f.addEventListener("dragstart",b);a&&(f.addEventListener("mousewheel",b,!1),f.addEventListener("wheel",b,!1));f.addEventListener("contextmenu",function(a){a.preventDefault();return!1});c&&this.captureTouch(!0)};
var r=!1;l.captureTouch=function(a){r=a;f.addEventListener("touchstart",c,!0);f.addEventListener("touchmove",c,!0);f.addEventListener("touchend",c,!0);f.addEventListener("touchcancel",c,!0);f.addEventListener("gesturestart",d);f.addEventListener("gesturechange",d);f.addEventListener("gestureend",d)};l.keys={};var w=null;l.captureKeys=function(a,b){function c(b){var d=a;b.eventType=b.type;var f=b.target.nodeName.toLowerCase();if("input"!==f&&"textarea"!==f&&"select"!==f){b.character=String.fromCharCode(b.keyCode).toLowerCase();
var f=!1,k=h.mapKeyCode(b.keyCode);k||(k=b.character);b.altKey||b.ctrlKey||b.metaKey||(k&&(l.keys[k]="keydown"==b.type),f=l.keys[b.keyCode],l.keys[b.keyCode]="keydown"==b.type);if(f!=l.keys[b.keyCode]){if("keydown"==b.type&&l.onkeydown)l.onkeydown(b);else if("keyup"==b.type&&l.onkeyup)l.onkeyup(b);u.trigger(l,b.type,b)}if(l.onkey)l.onkey(b);d&&(b.isChar||h.blockable_keys[b.keyIdentifier||b.key])&&b.preventDefault()}}w||(l.keys={},document.addEventListener("keydown",c),document.addEventListener("keyup",
c),w=c)};l.gamepads=null;l.captureGamepads=function(){var a=navigator.getGamepads||navigator.webkitGetGamepads||navigator.mozGetGamepads;a&&(this.gamepads=a.call(navigator))};l.getGamepads=function(a){var b=navigator.getGamepads||navigator.webkitGetGamepads||navigator.mozGetGamepads;if(b){b=b.call(navigator);this.gamepads||(this.gamepads=[]);for(var c=0;4>c;c++){var d=b[c];if(d&&!a){var f=d,k=f.xbox||{axes:[],buttons:{},hat:""};k.axes.lx=f.axes[0];k.axes.ly=f.axes[1];k.axes.rx=f.axes[2];k.axes.ry=
f.axes[3];k.axes.triggers=f.axes[4];for(var h=0;h<f.buttons.length;h++)switch(h){case 0:k.buttons.a=f.buttons[h].pressed;break;case 1:k.buttons.b=f.buttons[h].pressed;break;case 2:k.buttons.x=f.buttons[h].pressed;break;case 3:k.buttons.y=f.buttons[h].pressed;break;case 4:k.buttons.lb=f.buttons[h].pressed;break;case 5:k.buttons.rb=f.buttons[h].pressed;break;case 6:k.buttons.lt=f.buttons[h].pressed;break;case 7:k.buttons.rt=f.buttons[h].pressed;break;case 8:k.buttons.back=f.buttons[h].pressed;break;
case 9:k.buttons.start=f.buttons[h].pressed;break;case 10:k.buttons.ls=f.buttons[h].pressed;break;case 11:k.buttons.rs=f.buttons[h].pressed;break;case 12:f.buttons[h].pressed&&(k.hat+="up");break;case 13:f.buttons[h].pressed&&(k.hat+="down");break;case 14:f.buttons[h].pressed&&(k.hat+="left");break;case 15:f.buttons[h].pressed&&(k.hat+="right");break;case 16:k.buttons.home=f.buttons[h].pressed}f.xbox=k}if(d&&!d.prev_buttons){d.prev_buttons=new Uint8Array(32);f=new CustomEvent("gamepadconnected");
f.eventType=f.type;f.gamepad=d;if(this.ongamepadconnected)this.ongamepadconnected(f);u.trigger(l,"gamepadconnected",f)}if(d)for(k=0;k<d.buttons.length;++k){h=d.buttons[k];h.was_pressed=!1;if(h.pressed&&!d.prev_buttons[k]){h.was_pressed=!0;f=new CustomEvent("gamepadButtonDown");f.eventType=f.type;f.button=h;f.which=k;f.gamepad=d;if(l.onbuttondown)l.onbuttondown(f);u.trigger(l,"buttondown",f)}else if(!h.pressed&&d.prev_buttons[k]){f=new CustomEvent("gamepadButtonUp");f.eventType=f.type;f.button=h;f.which=
k;f.gamepad=d;if(l.onbuttondown)l.onbuttondown(f);u.trigger(l,"buttonup",f)}d.prev_buttons[k]=h.pressed?1:0}}return this.gamepads=b}};l.fullscreen=function(){var a=this.canvas;a.requestFullScreen?a.requestFullScreen():a.webkitRequestFullScreen?a.webkitRequestFullScreen():a.mozRequestFullScreen?a.mozRequestFullScreen():console.error("Fullscreen not supported")};l.snapshot=function(a,b,c,d,f){var k=createCanvas(c,d),h=k.getContext("2d"),m=h.getImageData(0,0,k.width,k.height),s=new Uint8Array(c*d*4);
l.readPixels(a,b,k.width,k.height,l.RGBA,l.UNSIGNED_BYTE,s);m.data.set(s);h.putImageData(m,0,0);if(f)return k;a=createCanvas(c,d);h=a.getContext("2d");h.translate(0,d);h.scale(1,-1);h.drawImage(k,0,0);return a};var v={};l.loadTexture=function(a,b,c){if(this.textures[a])return this.textures[a];if(v[a])return null;var d=new Image;d.url=a;d.onload=function(){var a=h.Texture.fromImage(this,b);a.img=this;l.textures[this.url]=a;delete v[this.url];c&&c(a)};d.src=a;v[a]=!0;return null};l.drawTexture=function(){var a=
mat3.create(),b=vec2.create(),c=vec2.create(),d=vec4.create(),f=vec4.fromValues(1,1,1,1),k=vec2.create(),h={u_texture:0,u_position:b,u_color:f,u_size:c,u_texture_area:d,u_viewport:k,u_transform:a};return function(a,f,m,s,p,q,r,n,t,w,v){b[0]=f;b[1]=m;void 0===s&&(s=a.width);void 0===p&&(p=a.height);c[0]=s;c[1]=p;void 0===q&&(q=0);void 0===r&&(r=0);void 0===n&&(n=a.width);void 0===t&&(t=a.height);d[0]=q/a.width;d[1]=r/a.height;d[2]=(q+n)/a.width;d[3]=(r+t)/a.height;k[0]=this.viewport_data[2];k[1]=this.viewport_data[3];
w=w||Shader.getPartialQuadShader(this);f=Mesh.getScreenQuad(this);a.bind(0);w.uniforms(h);v&&w.uniforms(v);w.draw(f,l.TRIANGLES)}}();l.canvas.addEventListener("webglcontextlost",function(a){a.preventDefault();l.context_lost=!0;if(l.onlosecontext)l.onlosecontext(a)},!1);l.reset=function(){l.viewport(0,0,this.canvas.width,this.canvas.height);l.disable(l.BLEND);l.disable(l.CULL_FACE);l.disable(l.DEPTH_TEST);l.frontFace(l.CCW);l._current_texture_drawto=null;l._current_fbo_color=null;l._current_fbo_depth=
null};l.dump=function(){console.log("userAgent: ",navigator.userAgent);console.log("Supported extensions:");var a=l.getSupportedExtensions();console.log(a.join(","));a="VENDOR VERSION MAX_VERTEX_ATTRIBS MAX_VARYING_VECTORS MAX_VERTEX_UNIFORM_VECTORS MAX_VERTEX_TEXTURE_IMAGE_UNITS MAX_FRAGMENT_UNIFORM_VECTORS MAX_TEXTURE_SIZE MAX_TEXTURE_IMAGE_UNITS".split(" ");console.log("WebGL info:");for(var b in a)console.log(" * "+a[b]+": "+l.getParameter(l[a[b]]));console.log("*************************************************")};
l.reset();return l};h.mapKeyCode=function(a){return{8:"BACKSPACE",9:"TAB",13:"ENTER",16:"SHIFT",17:"CTRL",27:"ESCAPE",32:"SPACE",37:"LEFT",38:"UP",39:"RIGHT",40:"DOWN"}[a]||(65<=a&&90>=a?String.fromCharCode(a):null)};h.dragging=!1;h.last_pos=[0,0];h.augmentEvent=function(a,b){var c=null;b=b||a.target||gl.canvas;c=b.getBoundingClientRect();a.mousex=a.clientX-c.left;a.mousey=a.clientY-c.top;a.canvasx=a.mousex;a.canvasy=c.height-a.mousey;a.deltax=0;a.deltay=0;"mousedown"==a.type?(this.dragging=!0,gl.mouse.buttons|=
1<<a.which):"mousemove"!=a.type&&"mouseup"==a.type&&(gl.mouse.buttons&=~(1<<a.which),0==gl.mouse.buttons&&(this.dragging=!1));void 0===a.movementX||h.isMobile()?(a.deltax=a.mousex-this.last_pos[0],a.deltay=a.mousey-this.last_pos[1]):(a.deltax=a.movementX,a.deltay=a.movementY);this.last_pos[0]=a.mousex;this.last_pos[1]=a.mousey;a.dragging=this.dragging;a.buttons_mask=gl.mouse.buttons;a.leftButton=!!(gl.mouse.buttons&1<<h.LEFT_MOUSE_BUTTON);a.middleButton=!!(gl.mouse.buttons&1<<h.MIDDLE_MOUSE_BUTTON);
a.rightButton=!!(gl.mouse.buttons&1<<h.RIGHT_MOUSE_BUTTON);a.isButtonPressed=function(a){return this.buttons_mask&1<<a}};h.isMobile=function(){return void 0!==this.mobile?this.mobile:n.navigator?navigator.userAgent.match(/iPhone/i)||navigator.userAgent.match(/iPod/i)||navigator.userAgent.match(/iPad/i)||navigator.userAgent.match(/Android/i)?this.mobile=!0:this.mobile=!1:this.mobile=!1};var u=n.LEvent=h.LEvent={bind:function(a,b,c,d){if(!a)throw"cannot bind event to null";if(!c)throw"cannot bind to null callback";
if(a.constructor===String)throw"cannot bind event to a string";var f=a.__levents;f||(Object.defineProperty(a,"__levents",{value:{},enumerable:!1}),f=a.__levents);f.hasOwnProperty(b)?f[b].push([c,d]):f[b]=[[c,d]];if(a.onLEventBinded)a.onLEventBinded(b,c,d)},unbind:function(a,b,c,d){if(!a)throw"cannot unbind event to null";if(!c)throw"cannot unbind from null callback";if(a.constructor===String)throw"cannot bind event to a string";var f=a.__levents;if(f&&f.hasOwnProperty(b)){for(var k=0,h=f[b].length;k<
h;++k){var l=f[b][k];if(l[0]===c&&l[1]===d){f[b].splice(k,1);break}}0==f[b].length&&delete f[b];if(a.onLEventUnbinded)a.onLEventUnbinded(b,c,d)}},unbindAll:function(a,b,c){if(!a)throw"cannot unbind events in null";var d=a.__levents;if(d){if(a.onLEventUnbindAll)a.onLEventUnbindAll(b,c);if(b)for(var f in d){a=d[f];for(var k=a.length-1;0<=k;--k)a[k][1]!=b||c&&c!==a[k][0]||a.splice(k,1)}else delete a.__levents}},unbindAllEvent:function(a,b){if(!a)throw"cannot unbind events in null";var c=a.__levents;
if(c&&(delete c[b],a.onLEventUnbindAll))a.onLEventUnbindAll(b,target_instance,callback)},isBind:function(a,b,c,d){if(!a)throw"LEvent cannot have null as instance";if(a=a.__levents){if(!a.hasOwnProperty(b))return!1;for(var f=0,k=a[b].length;f<k;++f){var h=a[b][f];if(h[0]===c&&h[1]===d)return!0}return!1}},hasBind:function(a,b){if(!a)throw"LEvent cannot have null as instance";var c=a.__levents;return c&&c.hasOwnProperty(b)&&c[b].length?!0:!1},hasBindTo:function(a,b){if(!a)throw"LEvent cannot have null as instance";
var c=a.__levents;if(!c)return!1;for(var d in c)for(var f=c[d],k=0;k<f.length;++k)if(f[k][1]===b)return!0;return!1},trigger:function(a,b,c,d,f){if(!a)throw"cannot trigger event from null";if(a.constructor===String)throw"cannot bind event to a string";a=a.__levents;if(!a||!a.hasOwnProperty(b))return!1;a=a[b];if(d)for(d=a.length-1;0<=d;--d){var k=a[d];if(f){if(k&&!0===k[0].apply(k[1],c))return!0}else if(k&&!0===k[0].call(k[1],b,c))return!0}else{d=0;for(var h=a.length;d<h;++d)if(k=a[d],f){if(k&&!0===
k[0].apply(k[1],c))return!0}else if(k&&!0===k[0].call(k[1],b,c))return!0}return!1},triggerArray:function(a,b,c,d,f){for(var k=!1,h=0,l=a.length;h<l;++h){var m=a[h];if(!m)throw"cannot trigger event from null";if(m.constructor===String)throw"cannot bind event to a string";if((m=m.__levents)&&m.hasOwnProperty(b))if(d)for(var p=m[b].length-1;0<=p;--p){var q=m[b][p];if(f){if(!0===q[0].apply(q[1],c)){k=!0;break}}else if(!0===q[0].call(q[1],b,c)){k=!0;break}}else for(var p=0,r=m[b].length;p<r;++p)if(q=m[b][p],
f){if(!0===q[0].apply(q[1],c)){k=!0;break}}else if(!0===q[0].call(q[1],b,c)){k=!0;break}}return k},extendObject:function(a){a.bind=function(a,c,d){return u.bind(this,a,c,d)};a.trigger=function(a,c){return u.trigger(this,a,c)};a.unbind=function(a,c,d){return u.unbind(this,a,c,instance)};a.unbindAll=function(a,c){return u.unbindAll(this,a,c)}},extendClass:function(a){this.extendObject(a.prototype)}};n.CLIP_INSIDE=h.CLIP_INSIDE=0;n.CLIP_OUTSIDE=h.CLIP_OUTSIDE=1;n.CLIP_OVERLAP=h.CLIP_OVERLAP=2;n.geo=
{createPlane:function(a,b){return new Float32Array([b[0],b[1],b[2],-vec3.dot(a,b)])},distancePointToPlane:function(a,b){return(vec3.dot(a,b)+b[3])/Math.sqrt(b[0]*b[0]+b[1]*b[1]+b[2]*b[2])},distance2PointToPlane:function(a,b){return(vec3.dot(a,b)+b[3])/(b[0]*b[0]+b[1]*b[1]+b[2]*b[2])},projectPointOnLine:function(a,b,c,d){d=d||vec3.create();a=vec3.fromValues(a[0]-b[0],a[1]-b[1],a[2]-b[2]);c=vec3.fromValues(c[0]-b[0],c[1]-b[1],c[2]-b[2]);a=vec3.dot(a,c)/vec3.dot(c,c);d[0]=b[0]+a[0]*c[0];d[1]=b[1]+a[1]*
c[1];d[2]=b[2]+a[2]*c[2];return d},project2DPointOnLine:function(a,b,c,d){d=d||vec2.create();a=vec2.fromValues(a[0]-b[0],a[1]-b[1]);c=vec2.fromValues(c[0]-b[0],c[1]-b[1]);a=vec2.dot(a,c)/vec2.dot(c,c);d[0]=b[0]+a[0]*c[0];d[1]=b[1]+a[1]*c[1];return d},projectPointOnPlane:function(a,b,c,d){d=d||vec3.create();b=vec3.subtract(vec3.create(),a,b);b=vec3.dot(b,c);return vec3.subtract(d,a,vec3.scale(vec3.create(),c,b))},reflectPointInPlane:function(a,b,c){b=-(-1*(b[0]*c[0]+b[1]*c[1]+b[2]*c[2])+c[0]*a[0]+
c[1]*a[1]+c[2]*a[2])/(c[0]*c[0]+c[1]*c[1]+c[2]*c[2]);return vec3.fromValues(a[0]+b*c[0]*2,a[1]+b*c[1]*2,a[2]+b*c[2]*2)},testRayPlane:function(a,b,c,d,f){c=vec3.dot(c,d)-vec3.dot(d,a);d=vec3.dot(d,b);if(Math.abs(d)<EPSILON)return!1;d=c/d;if(0>d)return!1;f&&vec3.add(f,a,vec3.scale(f,b,d));return!0},testSegmentPlane:function(){var a=vec3.create();return function(b,c,d,f,k){d=vec3.dot(d,f)-vec3.dot(f,b);c=vec3.sub(a,c,b);f=vec3.dot(f,c);if(Math.abs(f)<EPSILON)return!1;f=d/f;if(0>f||1<f)return!1;k&&vec3.add(k,
b,vec3.scale(k,c,f));return!0}}(),testRaySphere:function(){var a=vec3.create();return function(b,c,d,f,k,h){var l=vec3.subtract(a,b,d),m=c[0]*c[0]+c[1]*c[1]+c[2]*c[2];d=2*l[0]*c[0]+2*l[1]*c[1]+2*l[2]*c[2];f=d*d-4*m*(l[0]*l[0]+l[1]*l[1]+l[2]*l[2]-f*f);if(0>f)return!1;if(k){f=Math.sqrt(f);l=1/(2*m);m=(-d+f)*l;d=(-d-f)*l;d=m<d?m:d;if(void 0!==h&&d>h)return!1;vec3.add(k,b,vec3.scale(k,c,d))}return!0}}(),testRayCylinder:function(a,b,c,d,f,k){var h=vec3.clone(a);a=vec3.add(vec3.create(),a,vec3.scale(vec3.create(),
b,1E5));var l=0;b=vec3.subtract(vec3.create(),d,c);var m=vec3.subtract(vec3.create(),h,c);c=vec3.subtract(vec3.create(),a,h);d=vec3.dot(m,b);a=vec3.dot(c,b);b=vec3.dot(b,b);if(0>d&&0>d+a||d>b&&d+a>b)return!1;var p=vec3.dot(c,c),q=vec3.dot(m,c),l=b*p-a*a;f=vec3.dot(m,m)-f*f;var r=b*f-d*d;if(Math.abs(l)<EPSILON){if(0<r)return!1;k&&vec3.add(k,h,vec3.scale(k,c,0>d?-q/p:d>b?(a-q)/p:0));return!0}m=b*q-a*d;r=m*m-l*r;if(0>r)return!1;l=(-m-Math.sqrt(r))/l;if(0>l||1<l)return!1;if(0>d+l*a){if(0>=a)return!1;
l=-d/a;k&&vec3.add(k,h,vec3.scale(k,c,l));return 0>=f+2*l*(q+l*p)}if(d+l*a>b){if(0<=a)return!1;l=(b-d)/a;k&&vec3.add(k,h,vec3.scale(k,c,l));return 0>=f+b-2*d+l*(2*(q-a)+l*p)}k&&vec3.add(k,h,vec3.scale(k,c,l));return!0},testRayBox:function(){var a=new Float32Array(3),b=new Float32Array(3),c=new Float32Array(3);return function(d,f,k,h,l,m){m=m||Number.MAX_VALUE;var p=!0,q=0;a.fill(0);c.fill(0);b.fill(0);for(q=0;3>q;++q)d[q]<k[q]?(a[q]=1,b[q]=k[q],p=!1):d[q]>h[q]?(a[q]=0,b[q]=h[q],p=!1):a[q]=2;if(p)return l&&
vec3.copy(l,d),!0;for(q=0;3>q;++q)c[q]=2!=a[q]&&0!=f[q]?(b[q]-d[q])/f[q]:-1;p=0;for(q=1;3>q;q++)c[p]<c[q]&&(p=q);if(0>c[p]||c[p]>m)return!1;for(q=0;3>q;++q)if(p!=q){m=d[q]+c[p]*f[q];if(m<k[q]||m>h[q])return!1;l&&(l[q]=m)}else l&&(l[q]=b[q]);return!0}}(),testRayBBox:function(){var a=mat4.create(),b=vec3.create(),c=vec3.create();return function(d,f,k,h,l,m,p){if(!d||!f||!k)throw"parameters missing";h&&(mat4.invert(a,h),vec3.add(b,d,f),d=vec3.transformMat4(c,d,a),vec3.transformMat4(b,b,a),vec3.sub(b,
b,d),f=vec3.normalize(b,b));d=this.testRayBox(d,f,k.subarray(6,9),k.subarray(9,12),l,m);!p&&h&&l&&vec3.transformMat4(l,l,h);return d}}(),testPointBBox:function(a,b){return a[0]<b[6]||a[0]>b[9]||a[1]<b[7]||a[0]>b[10]||a[2]<b[8]||a[0]>b[11]?!1:!0},testBBoxBBox:function(a,b){if(Math.abs(b[0]-a[0])>a[3]+b[3]||Math.abs(b[1]-a[1])>a[4]+b[4]||Math.abs(b[2]-a[2])>a[5]+b[5])return!1;var c=BBox.getMin(b);geo.testPointBBox(c,a)&&(c=BBox.getMax(b),geo.testPointBBox(c,a));return!0},testSphereBBox:function(a,b,
c){for(var d=0,f=BBox.getMin(c),k=BBox.getMax(c),h=0;3>h;++h)a[h]<f[h]?(c=a[h]-f[h],d+=c*c):a[h]>k[h]&&(c=a[h]-k[h],d+=c*c);return d<=b*b?!0:!1},closestPointBetweenLines:function(a,b,c,d,f,k){b=vec3.subtract(vec3.create(),b,a);d=vec3.subtract(vec3.create(),d,c);var h=vec3.subtract(vec3.create(),a,c),l=vec3.dot(b,b),m=vec3.dot(b,d),p=vec3.dot(d,d),q=vec3.dot(b,h),r=vec3.dot(d,h),n=l*p-m*m,v;n<EPSILON?(v=0,l=m>p?q/m:r/p):(v=(m*r-p*q)/n,l=(l*r-m*q)/n);f&&vec3.add(f,a,vec3.scale(vec3.create(),b,v));k&&
vec3.add(k,c,vec3.scale(vec3.create(),d,l));a=vec3.add(vec3.create(),h,vec3.subtract(vec3.create(),vec3.scale(vec3.create(),b,v),vec3.scale(vec3.create(),d,l)));return vec3.length(a)},extractPlanes:function(a,b){function c(a){var c=b.subarray(a,a+3),c=vec3.length(c);0!==c&&(c=1/c,b[a]*=c,b[a+1]*=c,b[a+2]*=c,b[a+3]*=c)}b=b||new Float32Array(24);b.set([a[3]-a[0],a[7]-a[4],a[11]-a[8],a[15]-a[12]],0);c(0);b.set([a[3]+a[0],a[7]+a[4],a[11]+a[8],a[15]+a[12]],4);c(4);b.set([a[3]+a[1],a[7]+a[5],a[11]+a[9],
a[15]+a[13]],8);c(8);b.set([a[3]-a[1],a[7]-a[5],a[11]-a[9],a[15]-a[13]],12);c(12);b.set([a[3]-a[2],a[7]-a[6],a[11]-a[10],a[15]-a[14]],16);c(16);b.set([a[3]+a[2],a[7]+a[6],a[11]+a[10],a[15]+a[14]],20);c(20);return b},frustumTestBox:function(a,b){var c=0,d=0,c=planeBoxOverlap(a.subarray(0,4),b);if(c==CLIP_OUTSIDE)return CLIP_OUTSIDE;d+=c;c=planeBoxOverlap(a.subarray(4,8),b);if(c==CLIP_OUTSIDE)return CLIP_OUTSIDE;d+=c;c=planeBoxOverlap(a.subarray(8,12),b);if(c==CLIP_OUTSIDE)return CLIP_OUTSIDE;d+=c;
c=planeBoxOverlap(a.subarray(12,16),b);if(c==CLIP_OUTSIDE)return CLIP_OUTSIDE;d+=c;c=planeBoxOverlap(a.subarray(16,20),b);if(c==CLIP_OUTSIDE)return CLIP_OUTSIDE;d+=c;c=planeBoxOverlap(a.subarray(20,24),b);return c==CLIP_OUTSIDE?CLIP_OUTSIDE:0==d+c?CLIP_INSIDE:CLIP_OVERLAP},frustumTestSphere:function(a,b,c){var d,f=!1;d=distanceToPlane(a.subarray(0,4),b);if(d<-c)return CLIP_OUTSIDE;d>=-c&&d<=c&&(f=!0);d=distanceToPlane(a.subarray(4,8),b);if(d<-c)return CLIP_OUTSIDE;d>=-c&&d<=c&&(f=!0);d=distanceToPlane(a.subarray(8,
12),b);if(d<-c)return CLIP_OUTSIDE;d>=-c&&d<=c&&(f=!0);d=distanceToPlane(a.subarray(12,16),b);if(d<-c)return CLIP_OUTSIDE;d>=-c&&d<=c&&(f=!0);d=distanceToPlane(a.subarray(16,20),b);if(d<-c)return CLIP_OUTSIDE;d>=-c&&d<=c&&(f=!0);d=distanceToPlane(a.subarray(20,24),b);if(d<-c)return CLIP_OUTSIDE;d>=-c&&d<=c&&(f=!0);return f?CLIP_OVERLAP:CLIP_INSIDE},testPoint2DInPolygon:function(a,b){for(var c=!1,d=-1,f=a.length,k=f-1;++d<f;k=d)(a[d][1]<=b[1]&&b[1]<a[k][1]||a[k][1]<=b[1]&&b[1]<a[d][1])&&b[0]<(a[k][0]-
a[d][0])*(b[1]-a[d][1])/(a[k][1]-a[d][1])+a[d][0]&&(c=!c);return c}};n.BBox=h.BBox={center:0,halfsize:3,min:6,max:9,radius:12,data_length:13,corners:[vec3.fromValues(1,1,1),vec3.fromValues(1,1,-1),vec3.fromValues(1,-1,1),vec3.fromValues(1,-1,-1),vec3.fromValues(-1,1,1),vec3.fromValues(-1,1,-1),vec3.fromValues(-1,-1,1),vec3.fromValues(-1,-1,-1)],create:function(){return new Float32Array(13)},clone:function(a){return new Float32Array(a)},copy:function(a,b){a.set(b);return a},fromPoint:function(a){var b=
this.create();b.set(a,0);b.set(a,6);b.set(a,9);return b},fromMinMax:function(a,b){var c=this.create();this.setMinMax(c,a,b);return c},fromCenterHalfsize:function(a,b){var c=this.create();this.setCenterHalfsize(c,a,b);return c},fromPoints:function(a){var b=this.create();this.setFromPoints(b,a);return b},setFromPoints:function(a,b){var c=a.subarray(6,9),d=a.subarray(9,12);c[0]=b[0];c[1]=b[1];c[2]=b[2];d.set(c);for(var f=3,k=b.length;f<k;f+=3){var h=b[f],l=b[f+1],m=b[f+2];h<c[0]?c[0]=h:h>d[0]&&(d[0]=
h);l<c[1]?c[1]=l:l>d[1]&&(d[1]=l);m<c[2]?c[2]=m:m>d[2]&&(d[2]=m)}a[0]=0.5*(c[0]+d[0]);a[1]=0.5*(c[1]+d[1]);a[2]=0.5*(c[2]+d[2]);a[3]=d[0]-a[0];a[4]=d[1]-a[1];a[5]=d[2]-a[2];a[12]=Math.sqrt(a[3]*a[3]+a[4]*a[4]+a[5]*a[5]);return a},setMinMax:function(a,b,c){a[6]=b[0];a[7]=b[1];a[8]=b[2];a[9]=c[0];a[10]=c[1];a[11]=c[2];var d=a.subarray(3,6);vec3.sub(d,c,b);vec3.scale(d,d,0.5);a[0]=c[0]-d[0];a[1]=c[1]-d[1];a[2]=c[2]-d[2];a[12]=vec3.length(a.subarray(3,6));return a},setCenterHalfsize:function(a,b,c,d){a[0]=
b[0];a[1]=b[1];a[2]=b[2];a[3]=c[0];a[4]=c[1];a[5]=c[2];vec3.sub(a.subarray(6,9),a.subarray(0,3),a.subarray(3,6));vec3.add(a.subarray(9,12),a.subarray(0,3),a.subarray(3,6));a[12]=d?d:vec3.length(c);return a},transformMat4:function(){for(var a=0,b=0,c=0,d=new Float32Array(24),f=[],k=0;24>k;k+=3)f.push(d.subarray(k,k+3));return function(k,h,m){var p=h[0],q=h[1],r=h[2];a=h[3];b=h[4];c=h[5];h=this.corners;for(var n=0;8>n;++n){var v=h[n],t=f[n];t[0]=a*v[0]+p;t[1]=b*v[1]+q;t[2]=c*v[2]+r;mat4.multiplyVec3(t,
m,t)}return this.setFromPoints(k,d)}}(),getCorners:function(a,b){var c=a.subarray(3,6),d=null;b?(b.set(this.corners),d=b):d=new Float32Array(this.corners);for(var f=0;8>f;++f){var k=d.subarray(3*f,3*f+3);vec3.multiply(k,c,k);vec3.add(k,k,a)}return d},merge:function(a,b,c){var d=a.subarray(6,9),f=a.subarray(9,12);vec3.min(d,b.subarray(6,9),c.subarray(6,9));vec3.max(f,b.subarray(9,12),c.subarray(9,12));return BBox.setMinMax(a,d,f)},extendToPoint:function(a,b){b[0]<a[6]?a[6]=b[0]:b[0]>a[9]&&(a[9]=b[0]);
b[1]<a[7]?a[7]=b[1]:b[1]>a[10]&&(a[10]=b[1]);b[2]<a[8]?a[8]=b[2]:b[2]>a[11]&&(a[11]=b[2]);var c=a.subarray(6,9),d=a.subarray(9,12),c=vec3.add(a.subarray(0,3),c,d);vec3.scale(c,c,0.5);vec3.subtract(a.subarray(3,6),d,c);a[12]=vec3.length(a.subarray(3,6));return a},getCenter:function(a){return a.subarray(0,3)},getHalfsize:function(a){return a.subarray(3,6)},getMin:function(a){return a.subarray(6,9)},getMax:function(a){return a.subarray(9,12)},getRadius:function(a){return a[12]}};n.distanceToPlane=h.distanceToPlane=
function(a,b){return vec3.dot(a,b)+a[3]};n.planeBoxOverlap=h.planeBoxOverlap=function(a,b){var c=a[3],d=Math.abs(b[3]*a[0])+Math.abs(b[4]*a[1])+Math.abs(b[5]*a[2]),c=vec3.dot(a,b)+c;return c<=-d?CLIP_OUTSIDE:c<=d?CLIP_OVERLAP:CLIP_INSIDE};n.Octree=h.Octree=function(a){this.root=null;this.total_nodes=this.total_depth=0;a&&(this.buildFromMesh(a),this.total_nodes=this.trim())};Octree.MAX_NODE_TRIANGLES_RATIO=0.1;Octree.MAX_OCTREE_DEPTH=8;Octree.OCTREE_MARGIN_RATIO=0.01;Octree.OCTREE_MIN_MARGIN=0.1;Octree.prototype.buildFromMesh=
function(a){this.total_nodes=this.total_depth=0;var b=a.getBuffer("vertices").data;if(a=a.getIndexBuffer("triangles"))a=a.data;var c=this.computeAABB(b);this.root=c;this.total_nodes=1;this.total_triangles=a?a.length/3:b.length/9;this.max_node_triangles=this.total_triangles*Octree.MAX_NODE_TRIANGLES_RATIO;var d=vec3.create();vec3.scale(d,c.size,Octree.OCTREE_MARGIN_RATIO);d[0]<Octree.OCTREE_MIN_MARGIN&&(d[0]=Octree.OCTREE_MIN_MARGIN);d[1]<Octree.OCTREE_MIN_MARGIN&&(d[1]=Octree.OCTREE_MIN_MARGIN);d[2]<
Octree.OCTREE_MIN_MARGIN&&(d[2]=Octree.OCTREE_MIN_MARGIN);vec3.sub(c.min,c.min,d);vec3.add(c.max,c.max,d);c.faces=[];c.inside=0;if(a)for(d=0;d<a.length;d+=3){var f=new Float32Array([b[3*a[d]],b[3*a[d]+1],b[3*a[d]+2],b[3*a[d+1]],b[3*a[d+1]+1],b[3*a[d+1]+2],b[3*a[d+2]],b[3*a[d+2]+1],b[3*a[d+2]+2]]);this.addToNode(f,c,0)}else for(d=0;d<b.length;d+=9)f=new Float32Array(b.subarray(d,d+9)),this.addToNode(f,c,0);return c};Octree.prototype.addToNode=function(a,b,c){b.inside+=1;if(b.c){var d=this.computeAABB(a),
f=!1,k;for(k in b.c){var h=b.c[k];if(Octree.isInsideAABB(d,h)){this.addToNode(a,h,c+1);f=!0;break}}f||(null==b.faces&&(b.faces=[]),b.faces.push(a))}else if(null==b.faces&&(b.faces=[]),b.faces.push(a),b.faces.length>this.max_node_triangles&&c<Octree.MAX_OCTREE_DEPTH){this.splitNode(b);this.total_depth<c+1&&(this.total_depth=c+1);var l=b.faces.concat();b.faces=null;for(k in l){a=l[k];var d=this.computeAABB(a),f=!1,m;for(m in b.c)if(h=b.c[m],Octree.isInsideAABB(d,h)){this.addToNode(a,h,c+1);f=!0;break}f||
(null==b.faces&&(b.faces=[]),b.faces.push(a))}}};Octree.prototype.octree_pos_ref=[[0,0,0],[0,0,1],[0,1,0],[0,1,1],[1,0,0],[1,0,1],[1,1,0],[1,1,1]];Octree.prototype.splitNode=function(a){a.c=[];var b=[0.5*(a.max[0]-a.min[0]),0.5*(a.max[1]-a.min[1]),0.5*(a.max[2]-a.min[2])],c;for(c in this.octree_pos_ref){var d=this.octree_pos_ref[c],f={};this.total_nodes+=1;f.min=[a.min[0]+b[0]*d[0],a.min[1]+b[1]*d[1],a.min[2]+b[2]*d[2]];f.max=[f.min[0]+b[0],f.min[1]+b[1],f.min[2]+b[2]];f.faces=null;f.inside=0;a.c.push(f)}};
Octree.prototype.computeAABB=function(a){for(var b=new Float32Array([a[0],a[1],a[2]]),c=new Float32Array([a[0],a[1],a[2]]),d=0;d<a.length;d+=3)for(var f=0;3>f;f++)b[f]>a[d+f]&&(b[f]=a[d+f]),c[f]<a[d+f]&&(c[f]=a[d+f]);return{min:b,max:c,size:vec3.sub(vec3.create(),c,b)}};Octree.prototype.trim=function(a){a=a||this.root;if(!a.c)return 1;for(var b=1,c=[],d=a.c,f=0;f<d.length;++f)d[f].inside&&(c.push(d[f]),b+=this.trim(d[f]));a.c=c;return b};Octree.prototype.testRay=function(){var a=vec3.create(),b=vec3.create(),
c=vec3.create(),d=vec3.create();return function(f,k,h,l,m){if(!this.root)throw"Error: octree not build";a.set(f);b.set(k);c.set(this.root.min);d.set(this.root.max);h=Octree.hitTestBox(a,b,c,d);if(!h)return null;h=Octree.testRayInNode(this.root,a,b,m);return null!=h?(k=vec3.scale(vec3.create(),k,h.t),vec3.add(k,k,f),h.pos=k,h):null}}();Octree.prototype.testSphere=function(a,b){a=vec3.clone(a);if(!this.root)throw"Error: octree not build";var c=b*b;return Octree.testSphereBox(a,c,vec3.clone(this.root.min),
vec3.clone(this.root.max))?Octree.testSphereInNode(this.root,a,c):!1};Octree.testRayInNode=function(a,b,c,d){var f=null,k=null;if(a.faces)for(var h=0,l=a.faces.length;h<l;++h){var m=a.faces[h],f=Octree.hitTestTriangle(b,c,m.subarray(0,3),m.subarray(3,6),m.subarray(6,9),d);null!=f&&(f.face=m,k?k.mergeWith(f):k=f)}var l=vec3.create(),m=vec3.create(),p;if(a.c)for(h=0;h<a.c.length;++h)p=a.c[h],l.set(p.min),m.set(p.max),f=Octree.hitTestBox(b,c,l,m),null==f||k&&f.t>k.t||(f=Octree.testRayInNode(p,b,c,d),
null!=f&&(k?k.mergeWith(f):k=f));return k};Octree.testSphereInNode=function(a,b,c){if(a.faces)for(var d=0,f=a.faces.length;d<f;++d){var h=a.faces[d];if(Octree.testSphereTriangle(b,c,h.subarray(0,3),h.subarray(3,6),h.subarray(6,9)))return!0}var f=vec3.create(),h=vec3.create(),s;if(a.c)for(d=0;d<a.c.length;++d)if(s=a.c[d],f.set(s.min),h.set(s.max),Octree.testSphereBox(b,c,f,h)&&Octree.testSphereInNode(s,b,c))return!0;return!1};Octree.isInsideAABB=function(a,b){return a.min[0]<b.min[0]||a.min[1]<b.min[1]||
a.min[2]<b.min[2]||a.max[0]>b.max[0]||a.max[1]>b.max[1]||a.max[2]>b.max[2]?!1:!0};Octree.hitTestBox=function(){var a=vec3.create(),b=vec3.create(),c=vec3.create(),d=vec3.create(),f=vec3.create(),h=vec3.create(),s=vec3.fromValues(1E-6,1E-6,1E-6);return function(l,m,p,q){vec3.subtract(a,p,l);vec3.subtract(b,q,l);if(0>vec3.maxValue(a)&&0<vec3.minValue(b))return new HitTest(0,l,m);c[0]=1/m[0];c[1]=1/m[1];c[2]=1/m[2];vec3.multiply(a,a,c);vec3.multiply(b,b,c);vec3.min(d,a,b);vec3.max(f,a,b);var r=vec3.maxValue(d),
n=vec3.minValue(f);return 0<r&&r<n?(l=vec3.add(vec3.create(),vec3.scale(h,m,r),l),vec3.add(p,p,s),vec3.subtract(p,p,s),new HitTest(r,l,vec3.fromValues((l[0]>q[0])-(l[0]<p[0]),(l[1]>q[1])-(l[1]<p[1]),(l[2]>q[2])-(l[2]<p[2])))):null}}();Octree.hitTestTriangle=function(){var a=vec3.create(),b=vec3.create(),c=vec3.create(),d=vec3.create();return function(f,h,s,l,m,p){vec3.subtract(a,l,s);vec3.subtract(b,m,s);l=vec3.cross(vec3.create(),a,b);vec3.normalize(l,l);if(!p&&0<vec3.dot(l,h))return null;p=vec3.dot(l,
vec3.subtract(d,s,f))/vec3.dot(l,h);if(0<p){h=vec3.scale(vec3.create(),h,p);vec3.add(h,h,f);vec3.subtract(c,h,s);f=vec3.dot(b,b);s=vec3.dot(b,a);m=vec3.dot(b,c);var q=vec3.dot(a,a),r=vec3.dot(a,c),n=f*q-s*s,q=(q*m-s*r)/n;f=(f*r-s*m)/n;if(0<=q&&0<=f&&1>=q+f)return new HitTest(p,h,l)}return null}}();Octree.testSphereTriangle=function(){var a=vec3.create(),b=vec3.create(),c=vec3.create(),d=vec3.create(),f=vec3.create(),h=vec3.create(),s=vec3.create(),l=vec3.create();return function(m,p,q,r,n){vec3.sub(a,
q,m);vec3.sub(b,r,m);vec3.sub(c,n,m);vec3.sub(d,b,a);vec3.sub(f,c,a);vec3.cross(l,d,f);m=vec3.dot(a,l);q=vec3.dot(l,l);m=m*m>p*q;var v=vec3.dot(a,a),t=vec3.dot(a,b),z=vec3.dot(a,c),x=vec3.dot(b,b),u=vec3.dot(b,c),A=vec3.dot(c,c);q=v>p&t>v&z>v;r=x>p&t>x&u>x;n=A>p&z>A&u>A;var v=t-v,t=u-x,y=z-A;vec3.sub(h,c,b);vec3.sub(s,a,c);x=vec3.dot(d,d);A=vec3.dot(h,h);z=vec3.dot(s,s);u=vec3.scale(vec3.create(),a,x);vec3.sub(u,u,vec3.scale(vec3.create(),d,v));v=vec3.scale(vec3.create(),b,A);vec3.sub(v,v,vec3.scale(vec3.create(),
h,t));t=vec3.scale(vec3.create(),c,z);vec3.sub(t,t,vec3.scale(vec3.create(),s,y));var G=vec3.scale(vec3.create(),c,x),G=vec3.sub(G,G,u),H=vec3.scale(vec3.create(),a,A),H=vec3.sub(H,H,v),y=vec3.scale(vec3.create(),b,z),y=vec3.sub(y,y,t),x=vec3.dot(u,u)>p*x*x&0<vec3.dot(u,G),A=vec3.dot(v,v)>p*A*A&0<vec3.dot(v,H);p=vec3.dot(t,t)>p*z*z&0<vec3.dot(t,y);return!(m|q|r|n|x|A|p)}}();Octree.testSphereBox=function(a,b,c,d){for(var f,h=0,s=0;3>s;++s)a[s]<c[s]?(f=a[s]-c[s],h+=f*f):a[s]>d[s]&&(f=a[s]-d[s],h+=f*
f);return h<=b?!0:!1};n.HitTest=h.HitTest=function(a,b,c){this.t=arguments.length?a:Number.MAX_VALUE;this.hit=b;this.normal=c;this.face=null};HitTest.prototype={mergeWith:function(a){0<a.t&&a.t<this.t&&(this.t=a.t,this.hit=a.hit,this.normal=a.normal,this.face=a.face)}};n.Ray=h.Ray=function(a,b){this.origin=vec3.create();this.direction=vec3.create();this.collision_point=vec3.create();a&&this.origin.set(a);b&&this.direction.set(b)};Ray.prototype.testPlane=function(a,b){return geo.testRayPlane(this.origin,
this.direction,a,b,this.collision_point)};Ray.prototype.testSphere=function(a,b,c){return geo.testRaySphere(this.origin,this.direction,a,b,this.collision_point,c)};n.Raytracer=h.Raytracer=function(a,b){this.viewport=vec4.create();this.ray00=vec3.create();this.ray10=vec3.create();this.ray01=vec3.create();this.ray11=vec3.create();this.eye=vec3.create();this.setup(a,b)};Raytracer.prototype.setup=function(a,b){b=b||gl.viewport_data;this.viewport.set(b);var c=b[0],d=c+b[2],f=b[1],h=f+b[3];vec3.set(this.ray00,
c,f,1);vec3.set(this.ray10,d,f,1);vec3.set(this.ray01,c,h,1);vec3.set(this.ray11,d,h,1);vec3.unproject(this.ray00,this.ray00,a,b);vec3.unproject(this.ray10,this.ray10,a,b);vec3.unproject(this.ray01,this.ray01,a,b);vec3.unproject(this.ray11,this.ray11,a,b);c=this.eye;vec3.unproject(c,c,a,b);vec3.subtract(this.ray00,this.ray00,c);vec3.subtract(this.ray10,this.ray10,c);vec3.subtract(this.ray01,this.ray01,c);vec3.subtract(this.ray11,this.ray11,c)};Raytracer.prototype.getRayForPixel=function(){var a=vec3.create(),
b=vec3.create();return function(c,d,f){f=f||vec3.create();c=(c-this.viewport[0])/this.viewport[2];d=1-(d-this.viewport[1])/this.viewport[3];vec3.lerp(a,this.ray00,this.ray10,c);vec3.lerp(b,this.ray01,this.ray11,c);vec3.lerp(f,a,b,d);return vec3.normalize(f,f)}}();var V=mat4.create();Raytracer.hitTestBox=function(a,b,c,d,f){var h=new Float32Array(30);f&&(f=mat4.invert(V,f),a=mat4.multiplyVec3(h.subarray(3,6),f,a),b=mat4.rotateVec3(h.subarray(6,9),f,b));var s=vec3.subtract(h.subarray(9,12),c,a);vec3.divide(s,
s,b);var l=vec3.subtract(h.subarray(12,15),d,a);vec3.divide(l,l,b);f=vec3.min(h.subarray(15,18),s,l);s=vec3.max(h.subarray(18,21),s,l);f=vec3.maxValue(f);s=vec3.minValue(s);return 0<f&&f<=s?(b=vec3.scale(h.subarray(21,24),b,f),vec3.add(b,a,b),vec3.addValue(h.subarray(24,27),c,1E-6),vec3.subValue(h.subarray(27,30),d,1E-6),new HitTest(f,b,vec3.fromValues((b[0]>d[0])-(b[0]<c[0]),(b[1]>d[1])-(b[1]<c[1]),(b[2]>d[2])-(b[2]<c[2])))):null};Raytracer.hitTestSphere=function(a,b,c,d){var f=vec3.subtract(vec3.create(),
a,c),h=vec3.dot(b,b),s=2*vec3.dot(b,f),f=vec3.dot(f,f)-d*d,f=s*s-4*h*f;return 0<f?(h=(-s-Math.sqrt(f))/(2*h),a=vec3.add(vec3.create(),a,vec3.scale(vec3.create(),b,h)),new HitTest(h,a,vec3.scale(vec3.create(),vec3.subtract(vec3.create(),a,c),1/d))):null};Raytracer.hitTestTriangle=function(a,b,c,d,f){var h=vec3.subtract(vec3.create(),d,c),s=vec3.subtract(vec3.create(),f,c);f=vec3.cross(vec3.create(),h,s);vec3.normalize(f,f);d=vec3.dot(f,vec3.subtract(vec3.create(),c,a))/vec3.dot(f,b);if(0<d){a=vec3.add(vec3.create(),
a,vec3.scale(vec3.create(),b,d));var l=vec3.subtract(vec3.create(),a,c);c=vec3.dot(s,s);b=vec3.dot(s,h);var s=vec3.dot(s,l),m=vec3.dot(h,h),h=vec3.dot(h,l),l=c*m-b*b,m=(m*s-b*h)/l,h=(c*h-b*s)/l;if(0<=m&&0<=h&&1>=m+h)return new HitTest(d,a,f)}return null};Mesh.parseOBJ=function(a,b){b=b||{};for(var c=[],d=[],f=[],h=[],s=[],l=[],m=[],p={},q=0,r=null,n=null,v=0,t=0,u=0,x=n=0,y=0,A=null,G=!1,H=!1,O=!1,P=!1,Q=0,N=b.noindex?b.noindex:1E7<a.length?!0:!1,L=b.flipAxis,I=L||b.flipNormals,B=null,D=[],F={v:1,
vt:2,vn:3,f:4,g:5,o:6},E=a.split("\n"),R=E.length,J=0;J<R;++J)if(r=E[J].replace(/[ \t]+/g," ").replace(/\s\s*$/,""),"#"!=r[0]&&""!=r){var A=r.split(" "),C=F[A[0]];P&&1==C&&(P=!1);3>=C&&(n=parseFloat(A[1]),x=parseFloat(A[2]),2!=C&&("\\"==A[3]?(++J,r=E[J].replace(/[ \t]+/g," ").replace(/\s\s*$/,""),y=parseFloat(r)):y=parseFloat(A[3])));if(1==C)L?s.push(-1*n,y,x):s.push(n,x,y);else if(2==C)l.push(n,x);else if(3==C)I?m.push(-x,-y,n):m.push(n,x,y);else if(4==C){if(P=!0,!(4>A.length)){C=[];for(r=1;r<A.length;++r){if(!(A[r]in
p)||N){n=A[r].split("/");if(1==n.length)u=t=v=parseInt(n[0])-1;else if(2==n.length)v=parseInt(n[0])-1,t=parseInt(n[1])-1,u=-1;else if(3==n.length)v=parseInt(n[0])-1,t=parseInt(n[1])-1,u=parseInt(n[2])-1;else return console.err("Problem parsing: unknown number of values per face"),!1;3<r&&N&&(n=c.length,c.push(c[n-9*(r-3)],c[n-9*(r-3)+1],c[n-9*(r-3)+2]),c.push(c[n-3],c[n-2],c[n-1]),n=d.length,d.push(d[n-6*(r-3)],d[n-6*(r-3)+1]),d.push(d[n-2],d[n-1]),n=f.length,f.push(f[n-9*(r-3)],f[n-9*(r-3)+1],f[n-
9*(r-3)+2]),f.push(f[n-3],f[n-2],f[n-1]));y=x=n=0;3*v+2<s.length&&(G=!0,n=s[3*v+0],x=s[3*v+1],y=s[3*v+2]);c.push(n,x,y);x=n=0;2*t+1<l.length&&(H=!0,n=l[2*t+0],x=l[2*t+1]);d.push(n,x);x=n=0;y=1;-1!=u&&(3*u+2<m.length&&(O=!0,n=m[3*u+0],x=m[3*u+1],y=m[3*u+2]),f.push(n,x,y));N||(p[A[r]]=q++)}N||(v=p[A[r]],C.push(v),Q<v&&(Q=v))}if(!N)for(r=2;r<C.length;r++)h.push(C[0],C[r-1],C[r])}}else 5==C||"usemtl"==A[0]?1<A.length&&(null!=B&&(B.length=h.length-B.start,0<B.length&&D.push(B)),B={name:A[1],start:h.length,
length:-1,material:""}):"usemtl"==A[0]&&B&&(B.material=A[1])}if(!s.length)return console.error("OBJ doesnt have vertices, maybe the file is not a OBJ"),null;B&&1<h.length-B.start&&(B.length=h.length-B.start,D.push(B));if((65536<Q||N)&&0<h.length){console.log("Deindexing mesh...");s=new Float32Array(3*h.length);l=f&&f.length?new Float32Array(3*h.length):null;m=d&&d.length?new Float32Array(2*h.length):null;for(r=0;r<h.length;r+=1)s.set(c.slice(3*h[r],3*h[r]+3),3*r),l&&l.set(f.slice(3*h[r],3*h[r]+3),
3*r),m&&m.set(d.slice(2*h[r],2*h[r]+2),2*r);c=s;l&&(f=l);m&&(d=m);h=null}s={};G&&(s.vertices=new Float32Array(c));O&&0<f.length&&(s.normals=new Float32Array(f));H&&0<d.length&&(s.coords=new Float32Array(d));h&&0<h.length&&(s.triangles=new Uint16Array(h));c={};1<D.length&&(c.groups=D);s.info=c;if(b.only_data)return s;D=null;D=Mesh.load(s,null,b.mesh);D.updateBoundingBox();return D};Mesh.parsers.obj=Mesh.parseOBJ;Mesh.encoders.obj=function(a,b){var c=a.getBuffer("vertices");if(!c)return null;for(var d=
"# Generated with liteGL.js by Javi Agenjo\n\n",c=c.data,f=0;f<c.length;f+=3)d+="v "+c[f].toFixed(4)+" "+c[f+1].toFixed(4)+" "+c[f+2].toFixed(4)+"\n";if(f=a.getBuffer("normals"))for(var d=d+"\n",h=f.data,f=0;f<h.length;f+=3)d+="vn "+h[f].toFixed(4)+" "+h[f+1].toFixed(4)+" "+h[f+2].toFixed(4)+"\n";if(f=a.getBuffer("coords"))for(d+="\n",h=f.data,f=0;f<h.length;f+=2)d+="vt "+h[f].toFixed(4)+" "+h[f+1].toFixed(4)+"  0.0000\n";d+="\ng mesh\n";if(f=a.getIndexBuffer("triangles"))for(c=f.data,f=0;f<c.length;f+=
3)d+="f "+(c[f]+1)+"/"+(c[f]+1)+"/"+(c[f]+1)+" "+(c[f+1]+1)+"/"+(c[f+1]+1)+"/"+(c[f+1]+1)+" "+(c[f+2]+1)+"/"+(c[f+2]+1)+"/"+(c[f+2]+1)+"\n";else for(f=0;f<c.length/3;f+=3)d+="f "+(f+1)+"/"+(f+1)+"/"+(f+1)+" "+(f+2)+"/"+(f+2)+"/"+(f+2)+" "+(f+3)+"/"+(f+3)+"/"+(f+3)+"\n";return d};n.WBin&&(n.WBin.classes.Mesh=Mesh);Mesh.binary_file_formats.wbin=!0;Mesh.parsers.wbin=Mesh.fromBinary=function(a,b){if(!n.WBin)throw"To use binary meshes you need to install WBin.js from https://github.com/jagenjo/litescene.js/blob/master/src/utils/wbin.js ";
b=b||{};var c=null,c=a.constructor==ArrayBuffer?WBin.load(a,!0):a;c.info||console.warn("This WBin doesn't seem to contain a mesh. Classname: ",c["@classname"]);c.format&&h.Mesh.decompress(c);var d={};if(c.vertex_buffers)for(var f in c.vertex_buffers)d[c.vertex_buffers[f]]=c[c.vertex_buffers[f]];else c.vertices&&(d.vertices=c.vertices),c.normals&&(d.normals=c.normals),c.coords&&(d.coords=c.coords),c.weights&&(d.weights=c.weights),c.bone_indices&&(d.bone_indices=c.bone_indices);var k={};if(c.index_buffers)for(f in c.index_buffers)k[c.index_buffers[f]]=
c[c.index_buffers[f]];else c.triangles&&(k.triangles=c.triangles),c.wireframe&&(k.wireframe=c.wireframe);d={vertex_buffers:d,index_buffers:k,bounding:c.bounding,info:c.info};if(c.bones){d.bones=c.bones;for(f=0;f<d.bones.length;++f)d.bones[f][1]=mat4.clone(d.bones[f][1]);c.bind_matrix&&(d.bind_matrix=mat4.clone(c.bind_matrix))}c.morph_targets&&(d.morph_targets=c.morph_targets);if(b.only_data)return d;c=b.mesh||new h.Mesh;c.configure(d);return c};Mesh.encoders.wbin=function(a,b){return a.toBinary(b)};
Mesh.prototype.toBinary=function(a){if(!n.WBin)throw"to use Mesh.toBinary you need to have WBin included. Check the repository for wbin.js";this.info||(this.info={});a={object_class:"Mesh",info:this.info,groups:this.groups};if(this.bones){for(var b=[],c=0;c<this.bones.length;++c)b.push([this.bones[c][0],mat4.toArray(this.bones[c][1])]);a.bones=b;this.bind_matrix&&(a.bind_matrix=this.bind_matrix)}this.bounding||this.updateBoundingBox();a.bounding=this.bounding;var b=[],d=[];for(c in this.vertexBuffers){var f=
this.vertexBuffers[c];a[f.name]=f.data;b.push(f.name);"vertices"==f.name&&(a.info.num_vertices=f.data.length/3)}for(c in this.indexBuffers)f=this.indexBuffers[c],a[c]=f.data,d.push(c);a.vertex_buffers=b;a.index_buffers=d;h.Mesh.enable_wbin_compression&&h.Mesh.compress(a);return WBin.create(a,"Mesh")};Mesh.compress=function(a,b){b=b||"bounding_compressed";a.format={type:b};var c=Mesh.compressors[b];if(!c)throw"compression format not supported:"+b;return c(a)};Mesh.decompress=function(a){if(a.format){var b=
Mesh.decompressors[a.format.type];if(!b)throw"decompression format not supported:"+a.format.type;return b(a)}};Mesh.compressors.bounding_compressed=function(a){if(!a.vertex_buffers)throw"buffers not found";for(var b=BBox.getMin(a.bounding),c=BBox.getMax(a.bounding),d=vec3.sub(vec3.create(),c,b),f=a.vertices,h=new Uint16Array(f.length),c=0;c<f.length;c+=3)h[c]=(f[c]-b[0])/d[0]*65535,h[c+1]=(f[c+1]-b[1])/d[1]*65535,h[c+2]=(f[c+2]-b[2])/d[2]*65535;a.vertices=h;if(a.normals){d=a.normals;b=new Uint8Array(d.length);
f=b.constructor==Uint8Array?255:65535;for(c=0;c<d.length;c+=3)b[c]=(0.5*d[c]+0.5)*f,b[c+1]=(0.5*d[c+1]+0.5)*f,b[c+2]=(0.5*d[c+2]+0.5)*f;a.normals=b}if(a.coords){b=a.coords;f=[1E4,1E4,-1E4,-1E4];for(c=0;c<b.length;c+=2)d=b[c],f[0]>d?f[0]=d:f[2]<d&&(f[2]=d),d=b[c+1],f[1]>d?f[1]=d:f[3]<d&&(f[3]=d);a.format.uvs_bounding=f;h=new Uint16Array(b.length);d=[f[2]-f[0],f[3]-f[1]];for(c=0;c<b.length;c+=2)h[c]=(b[c]-f[0])/d[0]*65535,h[c+1]=(b[c+1]-f[1])/d[1]*65535;a.coords=h}if(a.weights){d=a.weights;b=new Uint16Array(d.length);
f=b.constructor==Uint8Array?255:65535;for(c=0;c<d.length;c+=4)b[c]=d[c]*f,b[c+1]=d[c+1]*f,b[c+2]=d[c+2]*f,b[c+3]=d[c+3]*f;a.weights=b}};Mesh.decompressors.bounding_compressed=function(a){var b=a.bounding;if(!b)throw"error in mesh decompressing data: bounding not found, cannot use the bounding decompression.";for(var c=BBox.getMin(b),b=BBox.getMax(b),d=vec3.sub(vec3.create(),b,c),f=a.format,h=1/255,n=1/65535,l=a.vertices,m=new Float32Array(l.length),b=0,p=l.length;b<p;b+=3)m[b]=l[b]*n*d[0]+c[0],m[b+
1]=l[b+1]*n*d[1]+c[1],m[b+2]=l[b+2]*n*d[2]+c[2];a.vertices=m;if(a.normals&&a.normals.constructor!=Float32Array){d=a.normals;c=new Float32Array(d.length);l=d.constructor==Uint8Array?h:n;b=0;for(p=d.length;b<p;b+=3)c[b]=d[b]*l*2-1,c[b+1]=d[b+1]*l*2-1,c[b+2]=d[b+2]*l*2-1,m=c.subarray(b,b+3),vec3.normalize(m,m);a.normals=c}if(a.coords&&f.uvs_bounding&&a.coords.constructor!=Float32Array){c=a.coords;f=f.uvs_bounding;d=[f[2]-f[0],f[3]-f[1]];l=new Float32Array(c.length);b=0;for(p=c.length;b<p;b+=2)l[b]=c[b]*
n*d[0]+f[0],l[b+1]=c[b+1]*n*d[1]+f[1];a.coords=l}if(a.weights&&a.weights.constructor!=Float32Array){f=a.weights;d=new Float32Array(f.length);h=f.constructor==Uint8Array?h:n;b=0;for(p=f.length;b<p;b+=4)d[b]=f[b]*h,d[b+1]=f[b+1]*h,d[b+2]=f[b+2]*h,d[b+3]=f[b+3]*h;a.weights=d}}})("undefined"!=typeof window?window:"undefined"!=typeof self?self:global);
'use strict';(function(A){function f(a){if(this.constructor!==d.SceneNode)throw"You must use new to create RD.SceneNode";this._ctor();a&&this.configure(a)}function s(a){this._ctor();a&&this.configure(a)}function r(a){this._ctor();a&&this.configure(a)}function u(a){f.prototype._ctor.call(this,a);this._ctor();a&&this.configure(a)}function m(){this._root=new d.SceneNode;this._root.flags.no_transform=!0;this._root._scene=this;this._nodes_by_id={};this._nodes=[];this._to_destroy=[];this.frame=this.time=
0}function k(a,b){b=b||{};var c=this.gl=this.context=a;if(!c||!c.enable)throw"litegl GL context not found.";a!=A.gl&&c.makeCurrent();this.point_size=5;this.sort_by_priority=!0;this.reverse_normals=this.sort_by_distance=!1;this.assets_folder="";this._view_matrix=mat4.create();this._projection_matrix=mat4.create();this._viewprojection_matrix=mat4.create();this._mvp_matrix=mat4.create();this._model_matrix=mat4.create();this._texture_matrix=mat3.create();this._nodes=[];this._uniforms={u_view:this._view_matrix,
u_viewprojection:this._viewprojection_matrix,u_model:this._model_matrix,u_mvp:this._mvp_matrix,u_global_alpha_clip:0,u_texture_matrix:this._texture_matrix};A.gl=this.gl;this.canvas=c.canvas;this.assets_folder=b.assets_folder||"";this.autoload_assets=void 0!==b.autoload_assets?b.autoload_assets:!0;this.default_texture_settings={wrap:c.REPEAT,minFilter:c.LINEAR_MIPMAP_LINEAR,magFilter:c.LINEAR};this.default_cubemap_settings={minFilter:c.LINEAR_MIPMAP_LINEAR,magFilter:c.LINEAR,is_cross:1};this.meshes.plane=
GL.Mesh.plane({size:1});this.meshes.planeXZ=GL.Mesh.plane({size:1,xz:!0});this.meshes.cube=GL.Mesh.cube({size:1,wireframe:!0});this.meshes.sphere=GL.Mesh.sphere({size:1,subdivisions:32,wireframe:!0});this.meshes.grid=GL.Mesh.grid({size:10});this.textures.notfound=this.default_texture=new GL.Texture(1,1,{filter:c.NEAREST,pixel_data:new Uint8Array([0,0,0,255])});this.textures.white=this.default_texture=new GL.Texture(1,1,{filter:c.NEAREST,pixel_data:new Uint8Array([255,255,255,255])});this.num_assets_loading=
0;this.assets_loading={};this.assets_not_found={};this.draw_calls=this.frame=0;this.createShaders();b.shaders_file&&this.loadShaders(b.shaders_file,null,b.shaders_macros)}function l(a,b){this.origin=vec3.create();this.direction=vec3.create();this.collision_point=vec3.create();a&&this.origin.set(a);b&&this.direction.set(b)}function g(a){this.type=d.Camera.PERSPECTIVE;this._position=vec3.fromValues(0,100,100);this._target=vec3.fromValues(0,0,0);this._up=vec3.fromValues(0,1,0);this._near=0.1;this._far=
1E4;this._aspect=1;this._fov=45;this._frustum_size=50;this.flip_y=!1;this._view_matrix=mat4.create();this._projection_matrix=mat4.create();this._viewprojection_matrix=mat4.create();this._model_matrix=mat4.create();this._autoupdate_matrices=!0;this._must_update_matrix=!1;this._top=vec3.create();this._right=vec3.create();this._front=vec3.create();this.uniforms={u_view_matrix:this._view_matrix,u_projection_matrix:this._projection_matrix,u_viewprojection_matrix:this._viewprojection_matrix,u_camera_front:this._front,
u_camera_position:this._position};a&&(null!=a.type&&(this.type=a.type),a.position&&this._position.set(a.position),a.target&&this._target.set(a.target),a.up&&this._up.set(a.up),a.near&&(this.near=a.near),a.far&&(this.far=a.far),a.fov&&(this.fov=a.fov),a.aspect&&(this.aspect=a.aspect));this.updateMatrices()}function B(a,b){return vec3.dot(a,b)+a[3]}function t(a,b,c){var e=a[3],h=Math.abs(c[0]*a[0]),d=Math.abs(c[1]*a[1]);c=Math.abs(c[2]*a[2]);h=h+d+c;a=vec3.dot(a,b)+e;return a<=-h?v:a<=h?C:D}var d=A.RD=
{version:0.5};d.ZERO=vec3.fromValues(0,0,0);d.ONE=vec3.fromValues(1,1,1);d.RIGHT=vec3.fromValues(1,0,0);d.LEFT=vec3.fromValues(-1,0,0);d.UP=vec3.fromValues(0,1,0);d.DOWN=vec3.fromValues(0,-1,0);d.FRONT=vec3.fromValues(0,0,-1);d.BACK=vec3.fromValues(0,0,1);d.FRONT2D=vec2.fromValues(0,1);d.WHITE=vec3.fromValues(1,1,1);d.BLACK=vec3.fromValues(0,0,0);d.IDENTITY=mat4.create();d.CENTER=0;d.TOP_LEFT=1;d.TOP_RIGHT=2;d.BOTTOM_LEFT=3;d.BOTTOM_RIGHT=4;d.TOP_CENTER=5;d.BOTTOM_CENTER=6;d.PRIORITY_BACKGROUND=30;
d.PRIORITY_OPAQUE=20;d.PRIORITY_ALPHA=10;d.PRIORITY_HUD=0;d.BLEND_NONE=0;d.BLEND_ALPHA=1;d.BLEND_ADD=2;d.BLEND_MULTIPLY=3;d.NO_BILLBOARD=0;d.BILLBOARD_SPHERIC=1;d.BILLBOARD_PARALLEL_SPHERIC=2;d.BILLBOARD_CYLINDRIC=3;d.BILLBOARD_PARALLEL_CYLINDRIC=4;var p=d.DEG2RAD=0.0174532925;d.RAD2DEG=57.295779578552306;d.setup=function(a){a=a||{};if(d.configuration)throw"already called setup";d.configuration=a};var G=0;"undefined"==typeof extendClass&&(A.extendClass=function(a,b){for(var c in b)a.hasOwnProperty(c)||
(a[c]=b[c]);if(b.prototype){var e=Object.getOwnPropertyNames(b.prototype);for(c=0;c<e.length;++c){var h=e[c];a.prototype.hasOwnProperty(h)||(b.prototype.__lookupGetter__(h)?a.prototype.__defineGetter__(h,b.prototype.__lookupGetter__(h)):a.prototype[h]=b.prototype[h],b.prototype.__lookupSetter__(h)&&a.prototype.__defineSetter__(h,b.prototype.__lookupSetter__(h)))}}a.hasOwnProperty("superclass")||Object.defineProperty(a,"superclass",{get:function(){return b},enumerable:!1})});var w=mat4.create();mat3.create();
var x=mat4.create(),n=vec2.create(),q=vec3.create(),E=vec3.create();vec4.create();var y=quat.create();d.SceneNode=f;f.prototype._ctor=function(){this._uid=G++;this._id=null;this._transform=new Float32Array(10);this._position=this._transform.subarray(0,3);this._rotation=this._transform.subarray(3,7);this._scale=this._transform.subarray(7,10);quat.identity(this._rotation);this._scale.set(d.ONE);this._local_matrix=mat4.create();this._global_matrix=mat4.create();this._must_update_matrix=!1;this.bounding_box=
null;this.render_priority=d.PRIORITY_OPAQUE;this.blend_mode=d.BLEND_NONE;this.layers=3;this._color=vec4.fromValues(1,1,1,1);this._uniforms={u_color:this._color,u_color_texture:0};this.primitive=GL.TRIANGLES;this._instances=this.draw_range=null;this.onRender||(this.onRender=null);this.onShaderUniforms||(this.onShaderUniforms=null);this.mesh=this.shader=null;this.textures={};this.flags={visible:!0,collides:!0};this.children=[]};f.ctor=f.prototype._ctor;f.prototype.clone=function(){var a=new this.constructor,
b;for(b in this)if("_"!=b[0]&&!this.__lookupGetter__(b)&&"children"!=b){var c=this[b];void 0!==c&&(null===c?a[b]=null:c.constructor===Object?a[b]=GL.cloneObject(c):c.constructor===Array?a[b]=c.concat():a[b]!==c&&(a[b]=c))}return a};Object.defineProperty(f.prototype,"id",{get:function(){return this._id},set:function(a){this._scene?console.error("Cannot change id of a node already in a scene."):this._id=a},enumerable:!0});Object.defineProperty(f.prototype,"uniforms",{get:function(){return this._uniforms},
set:function(a){GL.cloneObject(a,this._uniforms);this._uniforms.u_color=this._color},enumerable:!0});Object.defineProperty(f.prototype,"position",{get:function(){return this._position},set:function(a){this._position.set(a);this._must_update_matrix=!0},enumerable:!0});Object.defineProperty(f.prototype,"x",{get:function(){return this._position[0]},set:function(a){this._position[0]=a;this._must_update_matrix=!0},enumerable:!0});Object.defineProperty(f.prototype,"y",{get:function(){return this._position[1]},
set:function(a){this._position[1]=a;this._must_update_matrix=!0},enumerable:!0});Object.defineProperty(f.prototype,"z",{get:function(){return this._position[2]},set:function(a){this._position[2]=a;this._must_update_matrix=!0},enumerable:!0});Object.defineProperty(f.prototype,"rotation",{get:function(){return this._rotation},set:function(a){this._rotation.set(a);this._must_update_matrix=!0},enumerable:!0});Object.defineProperty(f.prototype,"scaling",{get:function(){return this._scale},set:function(a){a.constructor===
Number?this._scale[0]=this._scale[1]=this._scale[2]=a:this._scale.set(a);this._must_update_matrix=!0},enumerable:!0});Object.defineProperty(f.prototype,"transform",{get:function(){return this._transform},set:function(a){this._transform.set(a);this._must_update_matrix=!0},enumerable:!0});Object.defineProperty(f.prototype,"pivot",{get:function(){return this._pivot},set:function(a){this._must_update_matrix=!0;a?(this._pivot||(this._pivot=vec3.create()),this._pivot.set(a),this.flags.pivot=!0):(this._pivot=
null,this.flags.pivot=!1)},enumerable:!0});Object.defineProperty(f.prototype,"color",{get:function(){return this._color},set:function(a){this._color.set(a)},enumerable:!0});Object.defineProperty(f.prototype,"opacity",{get:function(){return this._color[3]},set:function(a){this._color[3]=a},enumerable:!0});Object.defineProperty(f.prototype,"visible",{get:function(){return this.flags.visible},set:function(a){this.flags.visible=a},enumerable:!0});Object.defineProperty(f.prototype,"texture",{get:function(){return this.textures.color},
set:function(a){this.textures.color=a},enumerable:!1});Object.defineProperty(f.prototype,"scene",{get:function(){return this._scene},set:function(a){throw"cannot set scene, you must use addChild in its parent node";},enumerable:!1});Object.defineProperty(f.prototype,"parentNode",{get:function(){return this._parent},set:function(a){throw"Cannot set parentNode of SceneNode";},enumerable:!1});f.prototype.addChild=function(a,b){function c(a,b){if(a._scene&&a._scene!=b){var d=a._scene._nodes.indexOf(a);
-1!=d&&a._scene._nodes.splice(d,1);a.id&&a._scene._nodes_by_id[a.id]==a&&delete a._scene._nodes_by_id[a.id]}if(a._scene=b)b._nodes.push(a),a.id&&b&&(b._nodes_by_id[a.id]=a);if(a.children)for(var d=0,f=a.children.length;d<f;d++){var z=a.children[d];z._scene!=b&&c(z,b)}}if(a._parent)throw"addChild: Cannot add a child with a parent, remove from parent first";a._parent=this;b&&a.fromMatrix(a._global_matrix);this.children||(this.children=[]);this.children.push(a);this._scene!=a._scene&&c(a,this._scene)};
f.prototype.removeChild=function(a,b){function c(a){if(a._scene){a.id&&a._scene._nodes_by_id[a.id]==a&&delete a._scene._nodes_by_id[a.id];var b=a._scene._nodes.indexOf(a);-1!=b&&a._scene._nodes.splice(b,1)}a._scene=null;for(var b=0,e=a.children.length;b<e;b++)c(a.children[b])}if(a._parent!=this)throw"removeChild: Not its children";if(this.children){var e=this.children.indexOf(a);if(-1==e)throw"removeChild: impossible, should be children";this.children.splice(e,1);a._parent=null;b&&a.fromMatrix(a._global_matrix);
c(a)}};f.prototype.removeAllChildren=function(){if(this.children)for(;this.children.length;)this.removeChild(this.children[0])};f.prototype.clear=function(){if(this.children)for(;this.children.length;)this.removeChild(this.children[this.children.length-1])};f.prototype.setChildIndex=function(a,b){if(this.children){var c=this.children.indexOf(a);-1!=c&&(this.children.splice(c,1),this.children.splice(b,0,a))}};f.prototype.getAllChildren=function(a){a=a||[];if(!this.children)return a;for(var b=0,c=this.children.length;b<
c;b++){var e=this.children[b];a.push(e);e.getAllChildren(a)}return a};f.prototype.getVisibleChildren=function(a,b){a=a||[];void 0===b&&(b=255);if(!this.children||!1===this.flags.visible)return a;for(var c=0,e=this.children.length;c<e;c++){var h=this.children[c];h.layers&b&&a.push(h);h.getVisibleChildren(a,b)}return a};f.prototype.serialize=function(){var a={position:[this._position[0],this._position[1],this._position[2]],rotation:[this._rotation[0],this._rotation[1],this._rotation[2],this._rotation[3]],
scale:[this._scale[0],this._scale[1],this._scale[2]],children:[]};if(this.children)for(var b=0,c=this.children.length;b<c;b++)a.children.push(this.children[b].serialize());return a};f.prototype.configure=function(a){var b=null,c;for(c in a){switch(c){case "children":continue;case "uniforms":for(var e in a.uniforms)this.uniforms[e]=a.uniforms[e];continue;case "texture":this[c]=a[c];continue;case "flags":for(e in a.flags)this.flags[e]=a.flags[e];continue;case "scale":case "scaling":this.scale(a[c]);
continue;case "tiling":isNumber(a[c])?this.setTextureTiling(a[c],a[c]):this.setTextureTiling(a[c][0],a[c][1],a[c][2],a[c][3]);continue;case "parent":b=a[c];continue}var h=this[c];void 0!==h&&(h&&h.constructor===Float32Array?h.set(a[c]):this[c]=a[c])}this._must_update_matrix=!0;this.updateGlobalMatrix();if(a.children)for(c=0;c<a.children.length;++c)console.warn("configure children: feature not implemented");b&&(this.parentNode?console.error("This node already has a parent"):b.addChild(this))};f.prototype.setMesh=
function(a){a?"string"==typeof a?this.mesh=a:this._mesh=a:this.mesh=null};f.prototype.setTexture=function(a,b){b?"string"==typeof b&&(this.textures[a]=b):this.textures[a]=null};f.prototype.resetTransform=function(){this._position.set(d.ZERO);quat.identity(this._rotation);this._scale.set(d.ONE);this._must_update_matrix=!0};f.prototype.translate=function(a){vec3.add(this._position,this._position,a);this._must_update_matrix=!0};f.prototype.rotate=function(a,b,c){quat.setAxisAngle(y,b,a);c?quat.multiply(this._rotation,
y,this._rotation):quat.multiply(this._rotation,this._rotation,y);this._must_update_matrix=!0};f.prototype.rotateQuat=function(a,b){b?quat.multiply(this._rotation,a,this._rotation):quat.multiply(this._rotation,this._rotation,a);this._must_update_matrix=!0};f.prototype.scale=function(a){a.constructor===Number?(q[0]=q[1]=q[2]=a,vec3.mul(this._scale,this._scale,q)):vec3.mul(this._scale,this._scale,a);this._must_update_matrix=!0};f.prototype.setPivot=function(a){this.pivot=a};f.prototype.setTextureTiling=
function(a,b,c,e){this.texture_matrix||(this.texture_matrix=mat3.create(),this._uniforms.u_texture_matrix=this.texture_matrix);c=c||0;e=e||0;this.shader||(this.shader="texture_transform");mat3.identity(this.texture_matrix);mat3.translate(this.texture_matrix,this.texture_matrix,[c,e]);mat3.scale(this.texture_matrix,this.texture_matrix,[a,b])};f.prototype.getLocalMatrix=function(){this._must_update_matrix&&this.updateLocalMatrix();return this._local_matrix};f.prototype.getGlobalMatrix=function(){this.updateGlobalMatrix();
return this._global_matrix};f.prototype.getGlobalRotation=function(a){a=a||vec3.create();quat.identity(a);for(var b=this,c=this._scene?this._scene._root:null;b!=c;)quat.multiply(a,b._rotation,a),b=b._parent;return a};f.prototype.updateLocalMatrix=function(){var a=this._local_matrix;this._must_update_matrix=!1;mat4.identity(a);this.flags.no_transform||(this.flags.pivot&&this._pivot&&(a[12]=this._pivot[0],a[13]=this._pivot[1],a[14]=this._pivot[2]),mat4.translate(a,a,this._position),mat4.fromQuat(x,
this._rotation),mat4.multiply(a,a,x),mat4.scale(a,a,this._scale),this.flags.pivot&&this._pivot&&mat4.translate(a,a,[-this._pivot[0],-this._pivot[1],-this._pivot[2]]))};f.prototype.updateGlobalMatrix=function(a,b){var c=null;this._must_update_matrix&&!this.flags.no_transform&&this.updateLocalMatrix();this._parent&&this._scene&&this._parent!=this._scene._root?(c=a?this._parent._global_matrix:this._parent.getGlobalMatrix(),this.flags.no_transform?this._global_matrix.set(c):mat4.multiply(this._global_matrix,
c,this._local_matrix)):this._global_matrix.set(this._local_matrix);if(b)for(c=0;c<this.children.length;c++)this.children[c].updateGlobalMatrix(!0,b)};f.prototype.updateMatrices=function(a){this.updateLocalMatrix();this.updateGlobalMatrix(a)};f.prototype.fromMatrix=function(a,b){if(b&&this._parent){mat4.copy(this._global_matrix,a);var c=this._parent.getGlobalMatrix();mat4.invert(c,c);a=mat4.multiply(this._local_matrix,c,a)}c=mat4.clone(a);mat4.multiplyVec3(this._position,c,[0,0,0]);var e=vec3.create();
this._scale[0]=vec3.length(mat4.rotateVec3(e,c,d.RIGHT));this._scale[1]=vec3.length(mat4.rotateVec3(e,c,d.UP));this._scale[2]=vec3.length(mat4.rotateVec3(e,c,d.BACK));mat4.scale(mat4.create(),c,[1/this._scale[0],1/this._scale[1],1/this._scale[2]]);vec3.normalize(c.subarray(0,3),c.subarray(0,3));vec3.normalize(c.subarray(4,7),c.subarray(4,7));vec3.normalize(c.subarray(8,11),c.subarray(8,11));c=mat3.fromMat4(mat3.create(),c);mat3.transpose(c,c);quat.fromMat3(this._rotation,c);quat.normalize(this._rotation,
this._rotation);a!=this._local_matrix&&mat4.copy(this._local_matrix,a);this._must_update_matrix=!1};f.prototype.getLocalPoint=function(a,b){b=b||vec3.create();this._must_update_matrix&&this.updateLocalMatrix();return vec3.transformMat4(b,a,this._local_matrix)};f.prototype.getLocalVector=function(a,b){b=b||vec3.create();return vec3.transformQuat(b,a,this._rotation)};f.prototype.getGlobalPosition=function(a,b){a=a||vec3.create();if(b)return vec3.transformMat4(a,d.ZERO,this._global_matrix);if(this._parent==
this._scene._root)return a.set(this._position),a;var c=this.getGlobalMatrix();return vec3.transformMat4(a,d.ZERO,c)};f.prototype.getGlobalPoint=function(a,b){b=b||vec3.create();var c=this.getGlobalMatrix();return vec3.transformMat4(b,a,c)};f.prototype.localToGlobal=f.prototype.getGlobalPoint;f.prototype.getGlobalVector=function(a,b){b=b||vec3.create();var c=this.getGlobalRotation(y);return vec3.transformQuat(b,a,c)};f.prototype.getDistanceTo=function(a){var b=this.getGlobalMatrix();return vec3.distance(a,
b.subarray(12,15))};f.prototype.findNode=function(a){for(var b=0,c=this.children.length;b<c;b++){var e=this.children[b];if(e.id==a||(e=e.findNode(a)))return e}return null};f.prototype.findNodesByFilter=function(a,b,c){void 0===b&&(b=255);c=c||[];for(var e=0,h=this.children.length;e<h;e++){var d=this.children[e];d.layer&b&&(a&&!a(d)||c.push(d),d.findNodesByFilter(a,b,c))}return c};f.prototype.propagate=function(a,b){for(var c=0,e=this.children.length;c<e;c++){var h=this.children[c];h&&(h[a]&&h[a].apply(h,
b),h.children&&h.children.length&&h.propagate(a,b))}};f.prototype.loadTextConfig=function(a,b){GL.request(a,null,function(a){a=d.parseTextConfig(a);b&&b(a)},alert)};f.prototype.destroy=function(a){!this.scene||a?this._parent&&this._parent.removeChild(this):this.scene._to_destroy.push(this)};f.prototype.updateBoundingBox=function(a){var b=this._global_matrix,c=gl.meshes[this.mesh],e=null;c&&(e=c.getBoundingBox(),this.bounding_box||(this.bounding_box=BBox.create()),e=BBox.transformMat4(this.bounding_box,
e,b));if(a||!this.children||0==this.children.length)return e;for(a=0;a<this.children.length;++a)if(b=this.children[a].updateBoundingBox())e||(e=this.bounding_box=BBox.create()),BBox.merge(e,e,b);return e};f.prototype.testRay=function(){var a=vec3.create(),b=vec3.create();vec3.create();vec3.create();vec3.create();mat4.create();mat4.create();return function(c,e,h,d,f){h=void 0===h?Number.MAX_VALUE:h;void 0===d&&(d=255);e=e||vec3.create();void 0!==m._ray_tested_objects&&m._ray_tested_objects++;var z=
null,g=null;this.layers&d&&this.mesh&&!this.flags.ignore_collisions&&(g=this.testRayWithMesh(c,a,h,d,f));g&&(g=vec3.distance(c.origin,a),g<h&&(h=g,e.set(a),z=this));if(!this.children&&!this.children.length)return z;for(var k=0;k<this.children.length;++k){var l=this.children[k].testRay(c,b,h,d,f);l&&(g=vec3.distance(c.origin,b),g<h&&(h=g,e.set(a),z=l))}return z}}();f.prototype.testRayWithMesh=function(){var a=vec3.create(),b=vec3.create(),c=vec3.create(),e=vec3.create(),h=mat4.create();return function(d,
f,g,m,k){g=void 0===g?Number.MAX_VALUE:g;if(!this.mesh)return!1;var l=gl.meshes[this.mesh];if(!l)return!1;var n=l.getBoundingBox();if(!n)return!1;m=this._global_matrix;mat4.invert(h,m);vec3.transformMat4(b,d.origin,h);vec3.add(e,d.origin,d.direction);vec3.transformMat4(e,e,h);vec3.sub(c,e,b);vec3.normalize(c,c);if(!geo.testRayBBox(b,c,n,null,a))return!1;vec3.transformMat4(f,a,m);n=vec3.distance(d.origin,f);if(n>g)return!1;if(!k)return!0;l.octree||(l.octree=new GL.Octree(l));k=l.octree.testRay(b,c,
0,g,this.flags.two_sided);if(!k)return!1;f.set(k.hit);vec3.transformMat4(f,f,m);n=vec3.distance(d.origin,f);return n>g?!1:!0}}();f.prototype.setRangeFromSubmesh=function(a){if(void 0!==a&&this.mesh){var b=gl.meshes[this.mesh];if(b&&b.info&&b.info.groups){if(a.constructor===String){for(var c=0;c<b.info.groups.length;++c)if(b.info.groups[c].name==a){a=c;break}if(c===b.info.groups.length)return!1}if(a=b.info.groups[a])this.draw_range[0]=a.start,this.draw_range[1]=a.length}else console.warn("you cannot set the submesh_id while the mesh is not yet loaded")}else this.draw_range=
null};f.prototype.findNodesInSphere=function(a,b,c,e){void 0===c&&(c=255);e=e||[];for(var h=0;h<this.children.length;++h){var d=this.children[h];d.layers&c&&(d.getGlobalPosition(q,!0),vec3.distance(q,a)<=b&&e.push(d));d.children.length&&d.findNodesInSphere(a,b,c,e)}return e};s.prototype._ctor=function(){f.prototype._ctor.call(this);this.vertices=[];this.normals=[];this.coords=[];this.indices=[];this._vertices_data=new Float32Array(3072);this._indices_data=this._coords_data=this._normals_data=null;
this._total_indices=this._total=0;this._mesh=GL.Mesh.load({vertices:this._vertices_data})};s.prototype.updateVertices=function(a){a&&(this.vertices=a);this._total=this.vertices.length;this._vertices_data.length<this.vertices.length&&(this._vertices_data=new Float32Array(2*this.vertices.length),this._mesh.getBuffer("vertices").data=this._vertices_data);this._vertices_data.set(this.vertices);this._mesh.getBuffer("vertices").upload(GL.STREAM_DRAW)};s.prototype.updateNormals=function(a){a&&(this.normals=
a);if(!this._normals_data||this._normals_data.length<this.normals.length)this._normals_data=new Float32Array(2*this.normals.length),this._mesh.getBuffer("normals")||this._mesh.createVertexBuffer("normals",null,3,this._normals_data,GL.STREAM_DRAW);this._normals_data.set(this.normals);this._mesh.getBuffer("normals").upload(GL.STREAM_DRAW)};s.prototype.updateCoords=function(a){a&&(this.coords=a);if(!this._coords_data||this._coords_data.length<this.normals.length)this._coords_data=new Float32Array(2*
this.coords.length),this._mesh.getBuffer("coords")||this._mesh.createVertexBuffer("coords",null,2,this._coords_data,GL.STREAM_DRAW);this._coords_data.set(this.coords);this._mesh.getBuffer("coords").upload(GL.STREAM_DRAW)};s.prototype.updateIndices=function(a){a&&(this.indices=a);if(!this._indices_data||this._indices_data.length<this.indices.length)this._indices_data=new Float32Array(2*this.indices.length),this._mesh.getIndexBuffer("triangles")||this._mesh.createIndicesBuffer("triangles",this._indices_data,
GL.STREAM_DRAW);this._indices_data.set(this.indices);this._mesh.getIndexBuffer("triangles").upload(GL.STREAM_DRAW);this._total_indices=a.length};s.prototype.render=function(a,b){if(this._total){var c=a.shaders[this.shader||"flat"];if(c){a.setModelMatrix(this._global_matrix);var e=this._mesh,h=this._total_indices?this._total_indices:this._total/3;a.enableNodeFlags(this);c.uniforms(a._uniforms).uniforms(this._uniforms).drawRange(e,void 0===this.primitive?GL.TRIANGLES:this.primitive,0,h,this._total_indices?
"triangles":null);a.disableNodeFlags(this)}}};extendClass(s,f);d.DynamicMeshNode=s;r.prototype._ctor=function(){f.prototype._ctor.call(this);this.mesh="plane";this.size=vec2.fromValues(0,0);this.sprite_pivot=d.TOP_LEFT;this.blend_mode=d.BLEND_ALPHA;this.flags.two_sided=!0;this.flags.flipX=!1;this.flags.flipY=!1;this.flags.pixelated=!1;this.shader="texture_transform";this._angle=0;this.frame=null;this.frames={};this.texture_matrix=mat3.create();this._uniforms.u_texture_matrix=this.texture_matrix};
Object.defineProperty(r.prototype,"angle",{get:function(){return this._angle},set:function(a){this._angle=a;quat.setAxisAngle(this._rotation,d.FRONT,this._angle*p);this._must_update_matrix=!0},enumerable:!0});r.prototype.setSize=function(a,b){this.size[0]=a;this.size[1]=b};r.createFrames=function(a,b,c){c=c||{};var e;a.constructor!=Number?(num_columns=a[0],e=a[1]):e=num_columns=a;var h=a=0,d=1/num_columns,f=1/e;e*=num_columns;if(!b){b=[];for(var g=0;g<e;++g)b.push(String(g))}for(g=0;g<b.length&&!(c[b[g]]=
{pos:[a,h],size:[d,f],normalized:!0},a+=d,1<=a&&(a=0,h+=f),1<=h);++g);return c};r.prototype.createFrames=function(a,b){r.createFrames(a,b,this.frames)};r.prototype.addFrame=function(a,b,c,e,h,d){this.frames[a]={pos:vec2.fromValues(b,c),size:vec2.fromValues(e,h),normalized:!!d}};r.prototype.updateTextureMatrix=function(a){mat3.identity(this.texture_matrix);if(!this.texture)return!1;var b=a.textures[this.texture];if(!b&&a.autoload_assets){var c=this;-1!=this.texture.indexOf(".")&&a.loadTexture(this.texture,
a.default_texture_settings,function(a){a&&0==c.size[0]&&0==c.size[0]&&c.setSize(a.width,a.height)});b=gl.textures.white}if(!b)return!1;a=this.texture_matrix;var e=this.frames[this.frame];if(null!==this.frame&&!e)return!1;if(!e)return this.flags.flipX&&(n[0]=this.flags.flipX?1:0,n[1]=0,mat3.translate(a,a,n),n[0]=this.flags.flipX?-1:1,n[1]=1,mat3.scale(a,a,n)),!0;if(e.normalized)n[0]=this.flags.flipX?e.pos[0]+e.size[0]:e.pos[0],n[1]=1-e.pos[1]-e.size[1],mat3.translate(a,a,n),n[0]=e.size[0]*(this.flags.flipX?
-1:1),n[1]=e.size[1];else{var h=b.height;n[0]=(this.flags.flipX?e.pos[0]+e.size[0]:e.pos[0])/b.width;n[1]=(h-e.pos[1]-e.size[1])/h;mat3.translate(a,a,n);n[0]=e.size[0]*(this.flags.flipX?-1:1)/b.width;n[1]=e.size[1]/b.height}mat3.scale(a,a,n);return!0};r.prototype.render=function(a,b){if(this.texture){var c=a.textures[this.texture];c&&null!=this.flags.pixelated&&(c.bind(0),gl.texParameteri(gl.TEXTURE_2D,gl.TEXTURE_MAG_FILTER,this.flags.pixelated?gl.NEAREST:gl.LINEAR),gl.texParameteri(gl.TEXTURE_2D,
gl.TEXTURE_MIN_FILTER,this.flags.pixelated?gl.NEAREST_MIPMAP_NEAREST:gl.LINEAR_MIPMAP_LINEAR));if(this.updateTextureMatrix(a)){if(this.billboard_mode)d.orientNodeToCamera(node.billboard_mode,this,b,a);else{var e=c=0;x.set(this._global_matrix);if(this.sprite_pivot){switch(this.sprite_pivot){case d.TOP_LEFT:c=0.5;e=-0.5;break;case d.TOP_CENTER:e=-0.5;break;case d.TOP_RIGHT:c=-0.5;break;case d.BOTTOM_LEFT:e=c=0.5;break;case d.BOTTOM_CENTER:e=0.5;break;case d.BOTTOM_RIGHT:c=-0.5,e=0.5}mat4.translate(x,
x,[c*this.size[0],e*this.size[1],0])}mat4.scale(x,x,[this.size[0],this.size[1],1]);a.setModelMatrix(x)}a.renderNode(this,a,b)}}};extendClass(r,f);d.Sprite=r;u.prototype._ctor=function(){this.mesh="cube";this.shader="skybox";this.scaling=[10,10,10];this.flags.depth_test=!1;this.flags.two_sided=!0};u.prototype.render=function(a,b){this.position=b.position;this.updateGlobalMatrix(!0);a.setModelMatrix(this._global_matrix);a.renderNode(this,b)};extendClass(u,f);d.Skybox=u;d.Scene=m;m.prototype.clear=function(){this._root=
new d.SceneNode;this._root._scene=this;this._nodes.length=0;this._nodes_by_id={};this.time=0};m.prototype.getNodeById=function(a){return this._nodes_by_id[a]};m.prototype.findNodesInBBox=function(a,b,c){void 0===b&&(b=255);c=c||[];for(var e=0;e<this.nodes.length;++e){var h=this.nodes[e];h.bounding_box&&h.layers&b&&geo.testBBoxBBox(h.bounding_box,a)&&c.push(h)}return c};m.prototype.update=function(a){this.time+=a;this._root.propagate("update",[a]);this.destroyPendingNodes()};m.prototype.destroyPendingNodes=
function(a){if(this._to_destroy.length)for(a=null;a=this._to_destroy.pop();)a._parent&&a._parent.removeChild(a)};Object.defineProperty(m.prototype,"root",{get:function(){return this._root},set:function(a){throw"Cannot set root of scene";},enumerable:!1});m.prototype.testRay=function(a,b,c,e,h){m._ray_tested_objects=0;b||(b=q);return this.root.testRay(a,b,c,void 0===e?255:e,h)};d.Renderer=k;k.prototype.setDataFolder=function(a){a?(this.assets_folder=a,"/"!=this.assets_folder.substr(-1)&&(this.assets_folder+=
"/")):this.assets_folder=""};k.prototype.clear=function(a){a?this.gl.clearColor(a[0],a[1],a[2],3<=a.length?a[3]:1):this.gl.clearColor(0,0,0,0);this.gl.clear(gl.COLOR_BUFFER_BIT|gl.DEPTH_BUFFER_BIT)};k._sort_by_dist_func=function(a,b){return b._distance-a._distance};k._sort_by_priority_func=function(a,b){return b.render_priority-a.render_priority};k._sort_by_priority_and_dist_func=function(a,b){var c=b.render_priority-a.render_priority;return 0!=c?c:b._distance-a._distance};k.prototype.render=function(a,
b,c,e){void 0===e&&(e=255);if(!a)throw"Renderer.render: scene not provided";if(this._current_scene)throw this._current_scene=null,"Cannot render an scene while rendering an scene";this._current_scene=a;b=b||a.camera;if(!b)throw"Renderer.render: camera not provided";A.gl=this.gl;this._state=[];this._meshes_missing=0;this.enableCamera(b);this._nodes.length=0;c||a._root.getVisibleChildren(this._nodes,e);c=c||this._nodes;if(c.length){this._uniforms.u_time=a.time;this.sort_by_distance&&c.forEach(function(a){a._distance=
a.getDistanceTo(b._position)});var h=this;c=c.filter(function(a){return!a.mustRender||!1!=a.mustRender(h,b)});this.sort_by_distance&&this.sort_by_priority?c.sort(d.Renderer._sort_by_priority_and_dist_func):this.sort_by_priority?c.sort(d.Renderer._sort_by_priority_func):this.sort_by_distance&&c.sort(d.Renderer._sort_by_dist_func);a._root.preRender&&a._root.preRender(this,b);for(var f=0;f<c.length;++f){var g=c[f];g.updateGlobalMatrix(!0);g.preRender&&g.preRender(this,b)}for(f=0;f<c.length;++f)g=c[f],
!1!==g.flags.visible&&g.layers&e&&(!this.mustRenderNode||!1!==this.mustRenderNode(g,b))&&(this.setModelMatrix(g._global_matrix),g.render?g.render(this,b):this.renderNode(g,b),this.draw_calls+=1);a._root.postRender&&a._root.postRender(this,b);for(f=0;f<c.length;++f)g=c[f],g.postRender&&g.postRender(this,b)}a.frame++;this.frame++;this._current_scene=null};k.prototype.enableCamera=function(a){this._camera=a;a.updateMatrices();a.extractPlanes();this._view_matrix.set(a._view_matrix);this._projection_matrix.set(a._projection_matrix);
this._viewprojection_matrix.set(a._viewprojection_matrix);this._uniforms.u_camera_position=a.position};k.prototype.saveState=function(){this.state.push({camera:this._camera,nodes:this._nodes})};k.prototype.restoreState=function(){var a=this.state.pop(),b=this.camera=a.camera;this._view_matrix.set(b._view_matrix);this._projection_matrix.set(b._projection_matrix);this._viewprojection_matrix.set(b._viewprojection_matrix);this._uniforms.u_camera_position=b.position;this._nodes=a.nodes};k.prototype.setModelMatrix=
function(a){this._model_matrix.set(a);mat4.multiply(this._mvp_matrix,this._viewprojection_matrix,a)};k.prototype.setGlobalUniforms=function(a){for(var b in a)this._uniforms[b]&&this._uniforms[b].set?this._uniforms[b].set(a[b]):this._uniforms[b]=a[b]};var F={u_model:null};k.prototype.renderNode=function(a,b){var c=null;a._mesh?c=a._mesh:a.mesh&&(c=gl.meshes[a.mesh],c||(this._meshes_missing++,this.autoload_assets&&-1!=a.mesh.indexOf(".")&&this.loadMesh(a.mesh)));if(c){var e=!1;a._instances&&(1<gl.webgl_version||
gl.extensions.ANGLE_instanced_arrays)&&(e=!0);var h=null,d=a.shader;this.on_getShader&&(h=this.on_getShader(a,b));!h&&a.shader&&(h=gl.shaders[d]);this.shader_overwrite&&(h=gl.shaders[this.shader_overwrite]);h||(h=a.textures.color?this._texture_shader:this._flat_shader);e&&!h.attributes.u_model&&(e=!1);var d=0,g=null,f;for(f in a.textures){var m=a.textures[f];if(m){var k="u_"+f+"_texture";if(!h||h.samplers[k])g=gl.textures[m],g||(this.autoload_assets&&-1!=m.indexOf(".")&&this.loadTexture(m,this.default_texture_settings),
g=gl.textures.white),a._uniforms[k]=g.bind(d++)}}this.ignore_flags||this.enableNodeFlags(a);if(a.onRender)a.onRender(this,b,h);h.uniforms(this._uniforms);h.uniforms(a._uniforms);if(a.onShaderUniforms)a.onShaderUniforms(this,h);e?(F.u_model=a._instances,a.draw_range?h.drawInstanced(c,void 0===a.primitive?gl.TRIANGLES:a.primitive,a.indices,F,a.draw_range[0],a.draw_range[1]):h.drawInstanced(c,void 0===a.primitive?gl.TRIANGLES:a.primitive,a.indices,F)):a.draw_range?h.drawRange(c,void 0===a.primitive?
gl.TRIANGLES:a.primitive,a.draw_range[0],a.draw_range[1],a.indices):h.draw(c,void 0===a.primitive?gl.TRIANGLES:a.primitive,a.indices);this.ignore_flags||this.disableNodeFlags(a)}else if(a.onRender)a.onRender(this,b)};k.prototype.renderMesh=function(a,b,c,e,h){b&&(e&&this._uniforms.u_color.set(e),a||(a=d.IDENTITY),this._uniforms.u_model.set(a),h||(h=c?gl.shaders.texture:gl.shaders.flat),c&&(this._uniforms.u_texture=c.bind(0)),h.uniforms(this._uniforms),h.draw(b))};k.prototype.enableNodeFlags=function(a){var b=
a.flags.flip_normals;this.reverse_normals&&(b=!b);gl.frontFace(b?gl.CW:gl.CCW);gl[!1===a.flags.depth_test?"disable":"enable"](gl.DEPTH_TEST);!1===a.flags.depth_write&&gl.depthMask(!1);gl[!0===a.flags.two_sided?"disable":"enable"](gl.CULL_FACE);if(a.blend_mode!==d.BLEND_NONE)switch(gl.enable(gl.BLEND),a.blend_mode){case d.BLEND_ALPHA:gl.blendFunc(gl.SRC_ALPHA,gl.ONE_MINUS_SRC_ALPHA);break;case d.BLEND_ADD:gl.blendFunc(gl.SRC_ALPHA,gl.ONE);break;case d.BLEND_MULTIPLY:gl.blendFunc(gl.DST_COLOR,gl.ONE_MINUS_SRC_ALPHA)}else gl.disable(gl.BLEND)};
k.prototype.disableNodeFlags=function(a){a.flags.flip_normals&&gl.frontFace(gl.CCW);!1===a.flags.depth_test&&gl.enable(gl.DEPTH_TEST);a.blend_mode!==d.BLEND_NONE&&gl.disable(gl.BLEND);a.flags.two_sided&&gl.disable(gl.CULL_FACE);!1===a.flags.depth_write&&gl.depthMask(!0)};k.prototype.setPointSize=function(a){this.point_size=a;gl.shaders.point.uniforms({u_pointSize:this.point_size})};k.prototype.loadMesh=function(a,b){if(!a)return console.error("loadMesh: Cannot load null name");if(!this.assets_loading[a]&&
!this.assets_not_found[a]){var c=this.meshes[a];if(c)return b&&b(c),c;var e=this,c=a;-1==c.indexOf("://")&&(c=this.assets_folder+a);c=GL.Mesh.fromURL(c,function(c){c?e.meshes[a]=c:(e.assets_not_found[a]=!0,delete e.meshes[a]);e.num_assets_loading--;delete e.assets_loading[a];b&&b(c,a)});this.assets_loading[a]=c;this.num_assets_loading++;return this.meshes[a]=c}};k.prototype.loadTexture=function(a,b,c){function e(b){b?g.textures[h]=b:g.assets_not_found[a]=!0;c&&c(b,h);g.num_assets_loading--;delete g.assets_loading[a];
if(g.on_texture_load)g.on_texture_load(b,h)}if(!a)return console.error("loadTexture: Cannot load null name");if(!this.assets_loading[a]&&!this.assets_not_found[a]){var h=a;b&&(b.name&&(h=b.name),b.preview&&(h=b.preview));var d=this.textures[h];if(d&&!d.is_preview)return c&&c(d),d;var g=this,d=a;-1==d.indexOf("://")&&(d=this.assets_folder+a);var f=null,f=-1!=a.indexOf("CUBEMAP")?GL.Texture.cubemapFromURL(d,this.default_cubemap_settings,e):GL.Texture.fromURL(d,b,e);b&&b.preview&&(f.is_preview=!0);this.assets_loading[a]=
f;this.num_assets_loading++;return this.textures[h]=f}};k.prototype.loadTextureAtlas=function(a,b,c){"string"==typeof a&&(a=JSON.parse(a));var e=this;-1==b.indexOf("://")&&(b=this.assets_folder+b);GL.Texture.fromURL(b,null,function(b){var d=a.files;e.textures[":atlas"]=b;for(var g in d)if(!e.textures[g]||e.textures[g].is_preview){var f=d[g],m=new GL.Texture(a.size,a.size,{wrap:gl.REPEAT,filter:gl.LINEAR});m.drawTo(function(){b.gl.drawTexture(b,0,0,a.size,a.size,f.x,f.y,f.width||a.size,f.height||a.size)});
m.is_preview=!0;e.textures[g]=m}c&&c(d)})};k.prototype.loadShaders=function(a,b,c){var e=this;-1==a.indexOf("://")&&(a=this.assets_folder+a);this.loading_shaders=!0;GL.loadFileAtlas(a,function(a){e.compileShadersFromAtlas(a,c);e.loading_shaders=!1;b&&b(a)})};k.prototype.compileShadersFromAtlas=function(a,b){var c=a.shaders;if(c){for(var e in a)a[e]=GL.Shader.expandImports(a[e],a);c=c.split("\n");for(e=0;e<c.length;++e){var d=c[e].trim().split(" "),g=d[0].trim();if("//"!=g.substr(0,2)){var f=a[d[1]],
m=a[d[2]],k=null,l={};if(3<d.length)for(var n=3;n<d.length;++n)if("#"==d[n][0])l[d[n].substr(1)]=!0;else{k=d.slice(n).join(" ");break}if(!l.WEBGL1||1==gl.webgl_version)if(!l.WEBGL2||2==gl.webgl_version){d[1]&&"@"==d[1][0]&&(l=d[1].substr(1)+"_VERTEX_SHADER",GL.Shader[l]&&(f=GL.Shader[l]));d[2]&&"@"==d[2][0]&&(l=d[2].substr(1)+"_FRAGMENT_SHADER",GL.Shader[l]&&(m=GL.Shader[l]));if(k)try{k=JSON.parse(k)}catch(p){console.error("Error in shader macros: ",g,k,p)}if(k&&b){l={};for(e in k)l[e]=k[e];for(e in b)l[e]=
b[e];k=l}else b&&(k=b);try{f&&m?this.shaders[g]?this.shaders[g].updateShader(f,m,k):this.shaders[g]=new GL.Shader(f,m,k):console.warn("Shader subfile not found: ",d[1],d[2])}catch(q){GL.Shader.dumpErrorToConsole(q,f,m)}}}}}else console.warn("No 'shaders' found in shaders file atlas, check documentation")};k.prototype.setShadersFromFile=function(a){a=GL.processFileAtlas(a);this.compileShadersFromAtlas(a)};d.sortByDistance=function(a,b){a.forEach(function(a){a._distance=a.getDistanceTo(b)});a.sort(function(a,
b){return b._distance-a._distance})};d.noBlending=function(a){return a.blend_mode===d.BLEND_NONE};d.generateTextureAtlas=function(a,b,c,e,d){b=b||1024;c=c||1024;e=e||64;var g=0,f;for(f in a)g++;gl.disable(gl.DEPTH_TEST);gl.disable(gl.CULL_FACE);gl.disable(gl.BLEND);var g=new GL.Texture(b,c),m={width:b,height:c,size:e,files:{}},k=0,l=0,n={};g.drawTo(function(){for(var g in a)if(":"!=g[0]&&"white"!=g&&"black"!=g&&"notfound"!=g){var f=a[g];if(!f.is_preview&&f.texture_type==gl.TEXTURE_2D){if(d){var p=
f.toBase64().hashCode();if(n[p]){m.files[g]=m.files[n[p]];continue}n[p]=g}m.files[g]={x:k,y:l};f.renderQuad(k,l,e,e);k+=e;if(k==b&&(k=0,l+=e,l==c)){console.warn("Atlas too small, some textures wont be stored.");break}}}});g.info=m;console.log(m);return g};k.prototype.computeResourcesLoaded=function(a){var b=0,c;for(c in a){var e=a[c],d=this.textures[e];d&&!1===d.ready||(e=this.meshes[e])&&!1===e.ready||(d||e)&&b++}return b};Object.defineProperty(k.prototype,"meshes",{get:function(){return this.gl.meshes},
set:function(a){},enumerable:!0});Object.defineProperty(k.prototype,"textures",{get:function(){return this.gl.textures},set:function(a){},enumerable:!0});Object.defineProperty(k.prototype,"shaders",{get:function(){return this.gl.shaders},set:function(a){},enumerable:!0});k.prototype.addMesh=function(a,b){b.gl!=this.gl&&(b=b.cloneShared(this.gl));this.gl.meshes[a]=b};d.Renderer=k;d.Ray=l;l.prototype.testPlane=function(a,b){return geo.testRayPlane(this.origin,this.direction,a,b,this.collision_point)};
l.prototype.testSphere=function(a,b,c){return geo.testRaySphere(this.origin,this.direction,a,b,this.collision_point,c)};d.Camera=g;g.PERSPECTIVE=1;g.ORTHOGRAPHIC=2;Object.defineProperty(g.prototype,"position",{get:function(){return this._position},set:function(a){this._position.set(a);this._must_update_matrix=!0},enumerable:!1});Object.defineProperty(g.prototype,"target",{get:function(){return this._target},set:function(a){this._target.set(a);this._must_update_matrix=!0},enumerable:!1});Object.defineProperty(g.prototype,
"up",{get:function(){return this._up},set:function(a){this._up.set(a);this._must_update_matrix=!0},enumerable:!1});Object.defineProperty(g.prototype,"fov",{get:function(){return this._fov},set:function(a){this._fov=a;this._must_update_matrix=!0},enumerable:!1});Object.defineProperty(g.prototype,"aspect",{get:function(){return this._aspect},set:function(a){this._aspect=a;this._must_update_matrix=!0},enumerable:!1});Object.defineProperty(g.prototype,"frustum_size",{get:function(){return this._frustum_size},
set:function(a){this._frustum_size=a;this._must_update_matrix=!0},enumerable:!1});Object.defineProperty(g.prototype,"near",{get:function(){return this._near},set:function(a){this._near=a;this._must_update_matrix=!0},enumerable:!1});Object.defineProperty(g.prototype,"far",{get:function(){return this._far},set:function(a){this._far=a;this._must_update_matrix=!0},enumerable:!1});Object.defineProperty(g.prototype,"view_matrix",{get:function(){return this._view_matrix},set:function(a){this._view_matrix.set(a);
mat4.multiply(this._viewprojection_matrix,this._projection_matrix,this._view_matrix)},enumerable:!1});Object.defineProperty(g.prototype,"projection_matrix",{get:function(){return this._projection_matrix},set:function(a){this._projection_matrix.set(a);mat4.multiply(this._viewprojection_matrix,this._projection_matrix,this._view_matrix)},enumerable:!1});Object.defineProperty(g.prototype,"viewprojection_matrix",{get:function(){return this._viewprojection_matrix},set:function(a){this._viewprojection_matrix.set(a)},
enumerable:!1});g.prototype.perspective=function(a,b,c,e){this.type=g.PERSPECTIVE;this._fov=a;this._aspect=b;this._near=c;this._far=e;this._must_update_matrix=!0};g.prototype.orthographic=function(a,b,c,e){this.type=g.ORTHOGRAPHIC;this._frustum_size=a;this._near=b;this._far=c;this._aspect=e||1;this._must_update_matrix=!0};g.prototype.lookAt=function(a,b,c){vec3.copy(this._position,a);vec3.copy(this._target,b);vec3.copy(this._up,c);this._must_update_matrix=!0};g.prototype.updateMatrices=function(a){if(this._autoupdate_matrices||
a)this.type==g.ORTHOGRAPHIC?mat4.ortho(this._projection_matrix,-this.frustum_size*this._aspect,this.frustum_size*this._aspect,-this._frustum_size,this._frustum_size,this._near,this._far):mat4.perspective(this._projection_matrix,this._fov*p,this._aspect,this._near,this._far),this.flip_y&&mat4.scale(this._projection_matrix,this._projection_matrix,[1,-1,1]),mat4.lookAt(this._view_matrix,this._position,this._target,this._up);this.is_reflection&&mat4.scale(this._view_matrix,this._view_matrix,[1,-1,1]);
mat4.multiply(this._viewprojection_matrix,this._projection_matrix,this._view_matrix);mat4.invert(this._model_matrix,this._view_matrix);this._must_update_matrix=!1;mat4.rotateVec3(this._right,this._model_matrix,d.RIGHT);mat4.rotateVec3(this._top,this._model_matrix,d.UP);mat4.rotateVec3(this._front,this._model_matrix,d.FRONT);this.distance=vec3.distance(this._position,this._target)};g.prototype.getModel=function(a){a=a||mat4.create();mat4.invert(this._model_matrix,this._view_matrix);mat4.copy(a,this._model_matrix);
return a};g.prototype.updateVectors=function(a){var b=vec3.subtract(q,this._target,this._position),b=vec3.length(b);mat4.multiplyVec3(this._position,a,d.ZERO);mat4.multiplyVec3(this._target,a,[0,0,-b]);mat4.rotateVec3(this._up,a,d.UP)};g.prototype.getLocalVector=function(a,b){this._must_update_matrix&&this.updateMatrices();return mat4.rotateVec3(b||vec3.create(),this._model_matrix,a)};g.prototype.getLocalPoint=function(a,b){this._must_update_matrix&&this.updateMatrices();return vec3.transformMat4(b||
vec3.create(),a,this._model_matrix)};g.prototype.getFront=function(a){a=a||vec3.create();vec3.subtract(a,this._target,this._position);vec3.normalize(a,a);return a};g.prototype.move=function(a,b){void 0!==b&&(vec3.scale(q,a,b),a=q);vec3.add(this._target,this._target,a);vec3.add(this._position,this._position,a);this._must_update_matrix=!0};g.prototype.moveLocal=function(a,b){var c=mat4.rotateVec3(q,this._model_matrix,a);void 0!==b&&vec3.scale(c,c,b);vec3.add(this._target,this._target,c);vec3.add(this._position,
this._position,c);this._must_update_matrix=!0};g.prototype.rotate=function(a,b){var c=quat.setAxisAngle(y,b,a),e=vec3.subtract(q,this._target,this._position);vec3.transformQuat(e,e,c);vec3.add(this._target,this._position,e);this._must_update_matrix=!0};g.prototype.rotateLocal=function(a,b){var c=mat4.rotateVec3(E,this._model_matrix,b),c=quat.setAxisAngle(y,c,a),e=vec3.subtract(q,this._target,this._position);vec3.transformQuat(e,e,c);vec3.add(this._target,this._position,e);this._must_update_matrix=
!0};g.prototype.orbit=function(a,b,c,e){if(!b)throw"RD: orbit axis missing";c=c||this._target;e&&(b=mat4.rotateVec3(E,this._model_matrix,b));a=quat.setAxisAngle(y,b,a);b=vec3.subtract(q,this._position,this._target);vec3.transformQuat(b,b,a);vec3.add(this._position,c,b);this._must_update_matrix=!0};g.prototype.orbitDistanceFactor=function(a,b){b=b||this._target;var c=vec3.subtract(q,this._position,b);vec3.scale(c,c,a);vec3.add(this._position,b,c);this._must_update_matrix=!0};g.prototype.project=function(a,
b,c){c=c||vec3.create();b=b||gl.viewport_data;this._must_update_matrix&&this.updateMatrices();mat4.projectVec3(c,this._viewprojection_matrix,a);c[0]=c[0]*b[2]+b[0];c[1]=c[1]*b[3]+b[1];return c};g.prototype.unproject=function(a,b,c){b=b||gl.viewport_data;this._must_update_matrix&&this.updateMatrices();return vec3.unproject(c||vec3.create(),a,this._viewprojection_matrix,b)};g.prototype.getRay=function(a,b,c,e){if(void 0===a||void 0===b)throw"RD.Camera.getRay requires x and y parameters";c=c||gl.viewport_data;
e||(e=new d.Ray);this._must_update_matrix&&this.updateMatrices();var h=e.origin;vec3.set(h,a,b,0);this.type==d.Camera.ORTHOGRAPHIC?vec3.unproject(h,h,this._viewprojection_matrix,c):vec3.copy(h,this.position);var g=e.direction;vec3.set(g,a,b,1);vec3.unproject(g,g,this._viewprojection_matrix,c);vec3.sub(g,g,h);vec3.normalize(g,g);return e};g.prototype.getRayPlaneCollision=function(a,b,c,e,d,g){d=d||vec3.create();a=this.getRay(a,b,g);return geo.testRayPlane(a.origin,a.direction,c,e,d)?d:null};g.controller_keys=
{forward:"UP",back:"DOWN",left:"LEFT",right:"RIGHT"};g.prototype.applyController=function(a,b,c){c=c||10;a&&(gl.keys[g.controller_keys.forward]?this.moveLocal(vec3.scale(q,d.FRONT,a*c)):gl.keys[g.controller_keys.back]&&this.moveLocal(vec3.scale(q,d.BACK,a*c)),gl.keys[g.controller_keys.left]?this.moveLocal(vec3.scale(q,d.LEFT,a*c)):gl.keys[g.controller_keys.right]&&this.moveLocal(vec3.scale(q,d.RIGHT,a*c)));b&&(b.deltax&&this.rotate(-0.005*b.deltax,d.UP),b.deltay&&this.rotateLocal(-0.005*b.deltay,
d.RIGHT))};g.prototype.lerp=function(a,b){vec3.lerp(this._position,this._position,a._position,b);vec3.lerp(this._target,this._target,a._target,b);vec3.lerp(this._up,this._up,a._up,b);this._fov=this._fov*(1-b)+a._fov*b;this._near=this._near*(1-b)+a._near*b;this._far=this._far*(1-b)+a._far*b;this._frustum_size=this._frustum_size*(1-b)+a._frustum_sizer*b;this._must_update_matrix=!0};g.prototype.extractPlanes=function(){function a(a){var b=c.subarray(a,a+3),b=vec3.length(b);0!==!b&&(b=1/b,c[a]*=b,c[a+
1]*=b,c[a+2]*=b,c[a+3]*=b)}var b=this._viewprojection_matrix,c=this._planes_data||new Float32Array(24);c.set([b[3]-b[0],b[7]-b[4],b[11]-b[8],b[15]-b[12]],0);a(0);c.set([b[3]+b[0],b[7]+b[4],b[11]+b[8],b[15]+b[12]],4);a(4);c.set([b[3]+b[1],b[7]+b[5],b[11]+b[9],b[15]+b[13]],8);a(8);c.set([b[3]-b[1],b[7]-b[5],b[11]-b[9],b[15]-b[13]],12);a(12);c.set([b[3]-b[2],b[7]-b[6],b[11]-b[10],b[15]-b[14]],16);a(16);c.set([b[3]+b[2],b[7]+b[6],b[11]+b[10],b[15]+b[14]],20);a(20);this._planes_data=c;this._frustrum_planes||
(this._frustrum_planes=[c.subarray(0,4),c.subarray(4,8),c.subarray(8,12),c.subarray(12,16),c.subarray(16,20),c.subarray(20,24)])};var D=d.CLIP_INSIDE=0,v=d.CLIP_OUTSIDE=1,C=d.CLIP_OVERLAP=2;g.prototype.testBox=function(a,b){this._frustrum_planes||this.extractPlanes();var c=this._frustrum_planes,e=0,d=0,e=t(c[0],a,b);if(e==v)return v;d+=e;e=t(c[1],a,b);if(e==v)return v;d+=e;e=t(c[2],a,b);if(e==v)return v;d+=e;e=t(c[3],a,b);if(e==v)return v;d+=e;e=t(c[4],a,b);if(e==v)return v;d+=e;e=t(c[5],a,b);return e==
v?v:0==d+e?D:C};g.prototype.testSphere=function(a,b){this._frustrum_planes||this.extractPlanes();var c=this._frustrum_planes,e,d=!1;e=B(c[0],a);if(e<-b)return v;e>=-b&&e<=b&&(d=!0);e=B(c[1],a);if(e<-b)return v;e>=-b&&e<=b&&(d=!0);e=B(c[2],a);if(e<-b)return v;e>=-b&&e<=b&&(d=!0);e=B(c[3],a);if(e<-b)return v;e>=-b&&e<=b&&(d=!0);e=B(c[4],a);if(e<-b)return v;e>=-b&&e<=b&&(d=!0);e=B(c[5],a);if(e<-b)return v;e>=-b&&e<=b&&(d=!0);return d?C:D};d.Factory=function(a,b,c){a=d.Factory.templates[a];var e=new d.SceneNode;
a&&e.configure(a);b&&(b.constructor===d.Scene?b.root:b).addChild(e);c&&e.configure(c);return e};d.Factory.templates={grid:{mesh:"grid",primitive:1,color:[0.5,0.5,0.5,0.5],blend_mode:d.BLEND_ALPHA},mesh:{shader:"phong"},sphere:{mesh:"sphere",shader:"phong"},floor:{mesh:"planeXZ",scaling:10,shader:"phong"}};d.parseTextConfig=function(a){function b(a,d){for(var g=c.shift();g;)if(0==g.trim().length)g=c.shift();else{for(var f=0;"\t"==g[f]&&f<g.length;)f++;if(f<d)break;var m={children:[]};try{var k=g.trim();
-1!=k.indexOf(":")&&(k="{"+k+"}");var l=new Function("return "+k);m.data=l()}catch(n){console.error(n)}f>=d&&(a&&a.children.push(m),g=b(m,f+1))}return g}var c=a.split("\n");a={data:"",children:[]};b(a,0);return a};k.prototype.createShaders=function(){var a="\t\t\t\tprecision highp float;\t\t\t\tuniform vec4 u_color;\t\t\t\tvoid main() {\t\t\t\t  gl_FragColor = u_color;\t\t\t\t}\t";gl.shaders.flat=this._flat_shader=new GL.Shader("\t\t\t\tprecision highp float;\n\t\t\t\tattribute vec3 a_vertex;\n\t\t\t\tattribute vec3 a_normal;\n\t\t\t\tattribute vec2 a_coord;\n\t\t\t\tvarying vec3 v_pos;\n\t\t\t\tvarying vec3 v_normal;\n\t\t\t\tvarying vec2 v_coord;\n\t\t\t\t#ifdef INSTANCING\n\t\t\t\t\tattribute mat4 u_model;\n\t\t\t\t#else\n\t\t\t\t\tuniform mat4 u_model;\n\t\t\t\t#endif\n\t\t\t\tuniform mat4 u_viewprojection;\n\t\t\t\tvoid main() {\n\t\t\t\t\tv_pos = (u_model * vec4(a_vertex,1.0)).xyz;\n\t\t\t\t\tv_normal = (u_model * vec4(a_normal,0.0)).xyz;\n\t\t\t\t\tv_coord = a_coord;\n\t\t\t\t\tgl_Position = u_viewprojection * vec4( v_pos , 1.0 );\n\t\t\t\t\tgl_PointSize = 2.0;\n\t\t\t\t}\t\t\t\t",
a);gl.shaders.flat_instancing=this._flat_instancing_shader=new GL.Shader("\t\t\t\tprecision highp float;\n\t\t\t\tattribute vec3 a_vertex;\n\t\t\t\tattribute vec3 a_normal;\n\t\t\t\tattribute vec2 a_coord;\n\t\t\t\tvarying vec3 v_pos;\n\t\t\t\tvarying vec3 v_normal;\n\t\t\t\tvarying vec2 v_coord;\n\t\t\t\t#ifdef INSTANCING\n\t\t\t\t\tattribute mat4 u_model;\n\t\t\t\t#else\n\t\t\t\t\tuniform mat4 u_model;\n\t\t\t\t#endif\n\t\t\t\tuniform mat4 u_viewprojection;\n\t\t\t\tvoid main() {\n\t\t\t\t\tv_pos = (u_model * vec4(a_vertex,1.0)).xyz;\n\t\t\t\t\tv_normal = (u_model * vec4(a_normal,0.0)).xyz;\n\t\t\t\t\tv_coord = a_coord;\n\t\t\t\t\tgl_Position = u_viewprojection * vec4( v_pos , 1.0 );\n\t\t\t\t\tgl_PointSize = 2.0;\n\t\t\t\t}\t\t\t\t",
a,{INSTANCING:""});this._point_shader=new GL.Shader("\t\t\t\tprecision highp float;\t\t\t\tattribute vec3 a_vertex;\t\t\t\tuniform mat4 u_mvp;\t\t\t\tuniform float u_pointSize;\t\t\t\tvoid main() {\t\t\t\t\tgl_PointSize = u_pointSize;\t\t\t\t\tgl_Position = u_mvp * vec4(a_vertex,1.0);\t\t\t\t}\t\t\t\t","\t\t\t\tprecision highp float;\t\t\t\tuniform vec4 u_color;\t\t\t\tvoid main() {\t\t\t\t  if( distance( gl_PointCoord, vec2(0.5)) > 0.5)\t\t\t\t     discard;\t\t\t\t  gl_FragColor = u_color;\t\t\t\t}\t\t\t");
gl.shaders.point=this._point_shader;this._color_shader=new GL.Shader("\t\tprecision highp float;\t\tattribute vec3 a_vertex;\t\tattribute vec4 a_color;\t\tvarying vec4 v_color;\t\tuniform vec4 u_color;\t\tuniform mat4 u_mvp;\t\tvoid main() {\t\t\tv_color = a_color * u_color;\t\t\tgl_Position = u_mvp * vec4(a_vertex,1.0);\t\t\tgl_PointSize = 5.0;\t\t}\t\t","\t\tprecision highp float;\t\tvarying vec4 v_color;\t\tvoid main() {\t\t  gl_FragColor = v_color;\t\t}\t");gl.shaders.color=this._color_shader;
a="\t\tprecision highp float;\t\tvarying vec2 v_coord;\t\tuniform vec4 u_color;\t\tuniform sampler2D u_color_texture;\t\tuniform float u_global_alpha_clip;\t\tvoid main() {\t\t\tvec4 color = u_color * texture2D(u_color_texture, v_coord);\n\t\t\tif(color.w < u_global_alpha_clip)\n\t\t\t\tdiscard;\n\t\t\tgl_FragColor = color;\t\t}\t";gl.shaders.texture=this._texture_shader=new GL.Shader("\t\t\t\tprecision highp float;\n\t\t\t\tattribute vec3 a_vertex;\n\t\t\t\tattribute vec3 a_normal;\n\t\t\t\tattribute vec2 a_coord;\n\t\t\t\tvarying vec3 v_pos;\n\t\t\t\tvarying vec3 v_normal;\n\t\t\t\tvarying vec2 v_coord;\n\t\t\t\t#ifdef INSTANCING\n\t\t\t\t\tattribute mat4 u_model;\n\t\t\t\t#else\n\t\t\t\t\tuniform mat4 u_model;\n\t\t\t\t#endif\n\t\t\t\tuniform mat4 u_viewprojection;\n\t\t\t\tvoid main() {\n\t\t\t\t\tv_pos = (u_model * vec4(a_vertex,1.0)).xyz;\n\t\t\t\t\tv_normal = (u_model * vec4(a_normal,0.0)).xyz;\n\t\t\t\t\tv_coord = a_coord;\n\t\t\t\t\tgl_Position = u_viewprojection * vec4( v_pos , 1.0 );\n\t\t\t\t\tgl_PointSize = 2.0;\n\t\t\t\t}\t\t\t\t",
a);gl.shaders.texture_instancing=this._texture_instancing_shader=new GL.Shader("\t\t\t\tprecision highp float;\n\t\t\t\tattribute vec3 a_vertex;\n\t\t\t\tattribute vec3 a_normal;\n\t\t\t\tattribute vec2 a_coord;\n\t\t\t\tvarying vec3 v_pos;\n\t\t\t\tvarying vec3 v_normal;\n\t\t\t\tvarying vec2 v_coord;\n\t\t\t\t#ifdef INSTANCING\n\t\t\t\t\tattribute mat4 u_model;\n\t\t\t\t#else\n\t\t\t\t\tuniform mat4 u_model;\n\t\t\t\t#endif\n\t\t\t\tuniform mat4 u_viewprojection;\n\t\t\t\tvoid main() {\n\t\t\t\t\tv_pos = (u_model * vec4(a_vertex,1.0)).xyz;\n\t\t\t\t\tv_normal = (u_model * vec4(a_normal,0.0)).xyz;\n\t\t\t\t\tv_coord = a_coord;\n\t\t\t\t\tgl_Position = u_viewprojection * vec4( v_pos , 1.0 );\n\t\t\t\t\tgl_PointSize = 2.0;\n\t\t\t\t}\t\t\t\t",
a,{INSTANCING:""});this._texture_transform_shader=new GL.Shader("\t\tprecision highp float;\n\t\tattribute vec3 a_vertex;\n\t\tattribute vec2 a_coord;\n\t\tvarying vec2 v_coord;\n\t\tuniform mat4 u_mvp;\n\t\tuniform mat3 u_texture_matrix;\n\t\tvoid main() {\n\t\t\tv_coord = (u_texture_matrix * vec3(a_coord,1.0)).xy;\n\t\t\tgl_Position = u_mvp * vec4(a_vertex,1.0);\n\t\t\tgl_PointSize = 5.0;\n\t\t}\n\t\t","\n\t\tprecision highp float;\n\t\tvarying vec2 v_coord;\n\t\tuniform vec4 u_color;\n\t\tuniform float u_global_alpha_clip;\n\t\tuniform sampler2D u_color_texture;\n\t\tvoid main() {\n\t\t\tvec4 color = u_color * texture2D(u_color_texture, v_coord);\n\t\t\tif(color.w < u_global_alpha_clip)\n\t\t\t\tdiscard;\n\t\t\tgl_FragColor = color;\n\t\t}\t");
gl.shaders.texture_transform=this._texture_transform_shader;var b={u_ambient:vec3.create(),u_light_vector:vec3.fromValues(0.577,0.577,0.577),u_light_color:d.WHITE},a="\t\t\tprecision highp float;\n\t\t\tvarying vec3 v_normal;\n\t\t\tvarying vec2 v_coord;\n\t\t\tuniform vec3 u_ambient;\n\t\t\tuniform vec3 u_light_color;\n\t\t\tuniform vec3 u_light_vector;\n\t\t\tuniform vec4 u_color;\n\t\t\t#ifdef TEXTURED\n\t\t\t\tuniform sampler2D u_color_texture;\n\t\t\t#endif\n\t\t\tvoid main() {\n\t\t\t\tvec4 color = u_color;\n\t\t\t\t#ifdef TEXTURED\n\t\t\t\t\tcolor *= texture2D( u_color_texture, v_coord );\n\t\t\t\t#endif\n\t\t\t\tvec3 N = normalize(v_normal);\n\t\t\t\tgl_FragColor = color * (vec4(u_ambient,1.0) + max(0.0, dot(u_light_vector,N)) * vec4(u_light_color,1.0));\n\t\t\t}\t";
gl.shaders.phong=this._phong_shader=new GL.Shader("\t\t\t\tprecision highp float;\n\t\t\t\tattribute vec3 a_vertex;\n\t\t\t\tattribute vec3 a_normal;\n\t\t\t\tattribute vec2 a_coord;\n\t\t\t\tvarying vec3 v_pos;\n\t\t\t\tvarying vec3 v_normal;\n\t\t\t\tvarying vec2 v_coord;\n\t\t\t\t#ifdef INSTANCING\n\t\t\t\t\tattribute mat4 u_model;\n\t\t\t\t#else\n\t\t\t\t\tuniform mat4 u_model;\n\t\t\t\t#endif\n\t\t\t\tuniform mat4 u_viewprojection;\n\t\t\t\tvoid main() {\n\t\t\t\t\tv_pos = (u_model * vec4(a_vertex,1.0)).xyz;\n\t\t\t\t\tv_normal = (u_model * vec4(a_normal,0.0)).xyz;\n\t\t\t\t\tv_coord = a_coord;\n\t\t\t\t\tgl_Position = u_viewprojection * vec4( v_pos , 1.0 );\n\t\t\t\t\tgl_PointSize = 2.0;\n\t\t\t\t}\t\t\t\t",
a);this._phong_shader._uniforms=b;this._phong_shader.uniforms(b);gl.shaders.phong_instancing=this._phong_instancing_shader=new GL.Shader("\t\t\t\tprecision highp float;\n\t\t\t\tattribute vec3 a_vertex;\n\t\t\t\tattribute vec3 a_normal;\n\t\t\t\tattribute vec2 a_coord;\n\t\t\t\tvarying vec3 v_pos;\n\t\t\t\tvarying vec3 v_normal;\n\t\t\t\tvarying vec2 v_coord;\n\t\t\t\t#ifdef INSTANCING\n\t\t\t\t\tattribute mat4 u_model;\n\t\t\t\t#else\n\t\t\t\t\tuniform mat4 u_model;\n\t\t\t\t#endif\n\t\t\t\tuniform mat4 u_viewprojection;\n\t\t\t\tvoid main() {\n\t\t\t\t\tv_pos = (u_model * vec4(a_vertex,1.0)).xyz;\n\t\t\t\t\tv_normal = (u_model * vec4(a_normal,0.0)).xyz;\n\t\t\t\t\tv_coord = a_coord;\n\t\t\t\t\tgl_Position = u_viewprojection * vec4( v_pos , 1.0 );\n\t\t\t\t\tgl_PointSize = 2.0;\n\t\t\t\t}\t\t\t\t",
a,{INSTANCING:""});this._phong_instancing_shader._uniforms=b;this._phong_instancing_shader.uniforms(b);gl.shaders.textured_phong=this._textured_phong_shader=new GL.Shader("\t\t\t\tprecision highp float;\n\t\t\t\tattribute vec3 a_vertex;\n\t\t\t\tattribute vec3 a_normal;\n\t\t\t\tattribute vec2 a_coord;\n\t\t\t\tvarying vec3 v_pos;\n\t\t\t\tvarying vec3 v_normal;\n\t\t\t\tvarying vec2 v_coord;\n\t\t\t\t#ifdef INSTANCING\n\t\t\t\t\tattribute mat4 u_model;\n\t\t\t\t#else\n\t\t\t\t\tuniform mat4 u_model;\n\t\t\t\t#endif\n\t\t\t\tuniform mat4 u_viewprojection;\n\t\t\t\tvoid main() {\n\t\t\t\t\tv_pos = (u_model * vec4(a_vertex,1.0)).xyz;\n\t\t\t\t\tv_normal = (u_model * vec4(a_normal,0.0)).xyz;\n\t\t\t\t\tv_coord = a_coord;\n\t\t\t\t\tgl_Position = u_viewprojection * vec4( v_pos , 1.0 );\n\t\t\t\t\tgl_PointSize = 2.0;\n\t\t\t\t}\t\t\t\t",
a,{TEXTURED:""});this._textured_phong_shader.uniforms(b);gl.shaders.textured_phong_instancing=this._textured_phong_instancing_shader=new GL.Shader("\t\t\t\tprecision highp float;\n\t\t\t\tattribute vec3 a_vertex;\n\t\t\t\tattribute vec3 a_normal;\n\t\t\t\tattribute vec2 a_coord;\n\t\t\t\tvarying vec3 v_pos;\n\t\t\t\tvarying vec3 v_normal;\n\t\t\t\tvarying vec2 v_coord;\n\t\t\t\t#ifdef INSTANCING\n\t\t\t\t\tattribute mat4 u_model;\n\t\t\t\t#else\n\t\t\t\t\tuniform mat4 u_model;\n\t\t\t\t#endif\n\t\t\t\tuniform mat4 u_viewprojection;\n\t\t\t\tvoid main() {\n\t\t\t\t\tv_pos = (u_model * vec4(a_vertex,1.0)).xyz;\n\t\t\t\t\tv_normal = (u_model * vec4(a_normal,0.0)).xyz;\n\t\t\t\t\tv_coord = a_coord;\n\t\t\t\t\tgl_Position = u_viewprojection * vec4( v_pos , 1.0 );\n\t\t\t\t\tgl_PointSize = 2.0;\n\t\t\t\t}\t\t\t\t",
a,{INSTANCING:"",TEXTURED:""});this._textured_phong_instancing_shader.uniforms(b)};d.orientNodeToCamera=function(a,b,c,e){if(a){if(a==d.BILLBOARD_CYLINDRIC||a==d.BILLBOARD_PARALLEL_CYLINDRIC){var g=null;a==d.BILLBOARD_CYLINDRIC?(g=b.getGlobalPosition(E),vec3.sub(q,c._position,g),n[0]=q[0],n[1]=q[2]):(n[0]=c._front[0],n[1]=c._front[2]);a=vec2.computeSignedAngle(n,d.FRONT2D);isNaN(a)||(mat4.rotateY(x,w,-a),b._global_matrix.set(x),mat4.setTranslation(b._global_matrix,b._position),mat4.scale(b._global_matrix,
b._global_matrix,b._scale))}else a==d.BILLBOARD_PARALLEL_SPHERIC?(b._global_matrix.set(c._model_matrix),mat4.setTranslation(b._global_matrix,b._position)):(mat4.lookAt(b._global_matrix,b._position,c.position,d.UP),mat4.invert(b._global_matrix,b._global_matrix)),mat4.scale(b._global_matrix,b._global_matrix,b._scale);e.setModelMatrix(b._global_matrix)}};d.readPixels=function(a,b){var c=new Image;c.src=a;c.onload=function(){var a=document.createElement("canvas");a.width=this.width;a.height=this.height;
var c=a.getContext("2d");c.drawImage(this,0,0);a=c.getImageData(0,0,a.width,a.height);b(a,this)}};d.renderPoints=function(a,b,c,e,g){if(!a||a.constructor!==Float32Array)throw"RD.renderPoints only accepts Float32Array";g||(g=gl.shaders._points,g||(g=gl.shaders._points=new GL.Shader(d.renderPoints.vs_shader,d.renderPoints.fs_shader),g.uniforms({u_texture:0,u_atlas:1,u_pointSize:1})));var f=1024;e=e||a.length/3;var k=null,m=null,l=this._points_mesh;e>a.length/3&&(e=a.length/3);!l||a.length>3*f?(e>f&&
(f=GL.Texture.nextPOT(e)),k=new Float32Array(3*f),m=new Float32Array(4*f),l=this._points_mesh=GL.Mesh.load({vertices:k,extra4:m})):(k=this._points_mesh.getBuffer("vertices").data,m=this._points_mesh.getBuffer("extra4").data);k.set(k.length>a.length?a:a.subarray(0,k.length));b?m.set(m.length>b.length?b:b.subarray(0,m.length)):m.fill&&m.fill(0);l.upload(GL.DYNAMIC_STREAM);g.setUniform("u_camera_perspective",c._projection_matrix[5]);g.setUniform("u_viewport",gl.viewport_data);g.setUniform("u_model",
d.IDENTITY);g.setUniform("u_mvp",c._viewprojection_matrix);g.drawRange(l,GL.POINTS,0,e)};d.renderPoints.vs_shader="\nprecision highp float;\nattribute vec3 a_vertex;\nattribute vec4 a_extra4;\nvarying vec3 v_pos;\nvarying vec3 v_wPos;\nvarying vec4 v_extra4;\nuniform mat4 u_model;\nuniform mat4 u_mvp;\nuniform vec4 u_viewport;\nuniform float u_camera_perspective;\nuniform float u_pointSize;\n\nfloat computePointSize( float radius, float w )\n{\n\tif(radius < 0.0)\n\t\treturn -radius;\n\treturn u_viewport.w * u_camera_perspective * radius / w;\n}\n\nvoid main() {\n\tvec3 vertex = a_vertex;\t\n\t\n\tv_pos = vertex;\n\tv_wPos = (u_model * vec4(vertex,1.0)).xyz;\n\tv_extra4 = a_extra4;\n\tgl_Position = u_mvp * vec4(vertex,1.0);\n\tgl_Position.x = floor(gl_Position.x * u_viewport.z) / u_viewport.z;\n\tgl_Position.y = floor(gl_Position.y * u_viewport.w) / u_viewport.w;\n\tgl_PointSize = computePointSize( u_pointSize, gl_Position.w );\n}\n";
d.renderPoints.fs_shader="\nprecision highp float;\nvarying vec3 v_pos;\nvarying vec3 v_wPos;\nvarying vec4 v_extra4; //id,flip \nuniform float u_atlas;\n\nuniform sampler2D u_texture;\n\nvoid main() {\n\tfloat i_atlas = 1.0 / u_atlas;\n\tfloat frame = v_extra4.x;\n\tfloat x = frame * i_atlas;\n\tfloat y = floor(x);\n\tx = (x - y);\n\ty = y / u_atlas;\n\tif( v_extra4.y > 0.0 ) //must flip in x\n\t\tx -= gl_PointCoord.x * i_atlas - i_atlas;\n\telse\n\t\tx += gl_PointCoord.x * i_atlas;\n\t\n\tvec2 uv = vec2( x, 1.0 - (y + gl_PointCoord.y / u_atlas) );\n\tvec4 color = texture2D( u_texture, uv );\n\tif(color.a < 0.1)\n\t\tdiscard;\n\tgl_FragColor = color;\n}\n";
"undefined"==typeof GL&&(mat4.rotateVec3=function(a,b,c){var d=c[0],g=c[1];c=c[2];a[0]=b[0]*d+b[4]*g+b[8]*c;a[1]=b[1]*d+b[5]*g+b[9]*c;a[2]=b[2]*d+b[6]*g+b[10]*c;return a},mat4.projectVec3=function(a,b,c){var d=c[0],g=c[1];c=c[2];var f=b[1]*d+b[5]*g+b[9]*c+b[13],m=b[2]*d+b[6]*g+b[10]*c+b[14],k=b[3]*d+b[7]*g+b[11]*c+b[15];a[0]=((b[0]*d+b[4]*g+b[8]*c+b[12])/k+1)/2;a[1]=(f/k+1)/2;a[2]=(m/k+1)/2;return a})})("undefined"!=typeof window?window:"undefined"!=typeof self?self:global);
(function(A){function f(){this._ctor();this.points=[];this.max_points=1E3;this.draw_range=[0,3*this.max_points];this.shader="pointcloud";this.textures={color:"white"};this.blend_mode=RD.BLEND_ALPHA;this.flags.depth_write=!1;this.render_priority=RD.PRIORITY_ALPHA;this.num_textures=1;this.points_size=100;this._uniforms={u_pointSize:this.points_size,u_texture_info:vec2.fromValues(1,1)};this.primitive=gl.POINTS;this._vertices=new Float32Array(3*this.max_points);this._extra=new Float32Array(3*this.max_points);
this._meshes={};this._last_point_id=this._accumulated_time=0}function s(){this._ctor();this.particles=[];this.max_particles=1E3;this.draw_range=[0,3*this.max_particles];this.shader="particles";this.textures={color:"white"};this.blend_mode=RD.BLEND_ALPHA;this.flags.depth_write=!1;this.render_priority=RD.PRIORITY_ALPHA;this.num_textures=1;this.particles_size=100;this.particles_life=this.particles_per_second=5;this.particles_damping=0.5;this.particles_acceleration=vec3.create();this.velocity_variation=
this.particles_end_scale=this.particles_start_scale=1;this.emissor_direction=vec3.fromValues(0,1,0);this._uniforms={u_pointSize:this.particle_size,u_scaleStartEnd:vec2.fromValues(1,1),u_texture_info:vec2.fromValues(1,1)};this.primitive=gl.POINTS;this._vertices=new Float32Array(3*this.max_particles);this._extra=new Float32Array(3*this.max_particles);this._meshes={};this._last_particle_id=this._accumulated_time=0}function r(){this._ctor()}function u(f,k){this.max_sprites=f=f||1024;this.positions=new Float32Array(3*
f);this.sprite_info=new Float32Array(4*f);this.index=0;this.shader=k?"point_sprites":"quad_sprites";this.use_points=k;this.must_update_buffers=!0}extendClass(f,RD.SceneNode);RD.PointCloud=f;f.prototype.render=function(m,k){if(0!=this.points.length){this.updateVertices();var l=this._meshes[m.gl.context_id];l||(l=new GL.Mesh(void 0,void 0,m.gl),this._vertices_buffer=l.createVertexBuffer("vertices",null,3,this._vertices,gl.DYNAMIC_DRAW),this._extra_buffer=l.createVertexBuffer("extra3",null,3,this._extra,
gl.DYNAMIC_DRAW));this._mesh=l;this._vertices_buffer.uploadRange(0,12*this.points.length);this._extra_buffer.uploadRange(0,12*this.points.length);l=gl.shaders[this.shader];l||(l=gl.shaders.pointcloud)||(gl.shaders.pointcloud=new GL.Shader(f._vertex_shader,f._pixel_shader));this.draw_range[1]=this.points.length;l=gl.getViewport();this._uniforms.u_pointSize=this.points_size/(gl.canvas.width/l[2]);this._uniforms.u_color=this.color;this._uniforms.u_texture_info[0]=1/this.num_textures;this._uniforms.u_texture_info[1]=
this.num_textures*this.num_textures;this.ignore_transform&&(mat4.identity(m._model_matrix),m._mvp_matrix.set(m._viewprojection_matrix));m.renderNode(this,m,k)}};f.prototype.updateVertices=function(f){if(f=this.points.length)for(var k=this._vertices,l=this._extra,g=0,r=this.num_textures*this.num_textures,t=0;t<f;t++){var d=this.points[t];k.set(d.pos,g);l[g]=1;l[g+1]=1;1<r&&(l[g+2]=d.tex);g+=3}};f._vertex_shader="\t\t\tprecision highp float;\t\t\tattribute vec3 a_vertex;\t\t\tattribute vec3 a_extra3;\t\t\tvarying vec2 v_coord;\t\t\tvarying vec4 v_color;\t\t\tvarying vec3 v_position;\t\t\tuniform vec3 u_camera_position;\t\t\tuniform mat4 u_mvp;\t\t\tuniform mat4 u_model;\t\t\tuniform vec4 u_color;\t\t\tuniform float u_pointSize;\t\t\tuniform vec2 u_texture_info;\t\t\tvoid main() {\n\t\t\t\tv_color = u_color;\n\t\t\t\tv_color.a *= a_extra3.y;\n\t\t\t\tv_coord.x = (a_extra3.z * u_texture_info.y) * u_texture_info.x;\n\t\t\t\tv_coord.y = abs(floor(v_coord.x) * u_texture_info.x);\n\t\t\t\tv_coord.x = fract(v_coord.x);\n\t\t\t\tgl_Position = u_mvp * vec4(a_vertex,1.0);\n\t\t\t\tv_position = (u_model * vec4(a_vertex,1.0)).xyz;\n\t\t\t\tfloat dist = distance( u_camera_position, v_position );\n\t\t\t\tgl_PointSize = 10.0 * u_pointSize / dist;\n\t\t\t}\t\t\t";
f._pixel_shader="\t\t\tprecision highp float;\t\t\tvarying vec4 v_color;\t\t\tvarying vec2 v_coord;\t\t\tvarying vec3 v_position;\t\t\tuniform sampler2D u_color_texture;\t\t\tuniform vec2 u_texture_info;\t\t\tvoid main() {\t\t\t  vec2 uv = vec2(v_coord.x + gl_PointCoord.x * u_texture_info.x, v_coord.y + (1.0 - gl_PointCoord.y) * u_texture_info.x );\n\t\t\t  vec4 color = texture2D( u_color_texture, uv );\n\t\t\t  color.xyz *= v_color.xyz;\n\t\t\t  #ifdef USE_PROCESS_COLOR\n\t\t\t\tUSE_PROCESS_COLOR\n\t\t\t  #endif\n\t\t\t  gl_FragColor = vec4( color.xyz, color.a * v_color.a );\n\t\t\t}\t\t";
extendClass(s,RD.SceneNode);RD.ParticlesEmissor=s;s.prototype.update=function(f){var k=this.particles.length,l=this.particles_damping,g=this.particles_acceleration,r=vec3.length(g);if(k){for(var t=[],d=0;d<k;d++){var p=this.particles[d];vec3.scaleAndAdd(p.pos,p.pos,p.vel,f);r&&vec3.scaleAndAdd(p.vel,p.vel,g,f);l&&vec3.scaleAndAdd(p.vel,p.vel,p.vel,-f*l);p.ttl-=f;0<p.ttl&&t.push(p)}this.particles=t}k=this.getGlobalPosition();l=this.emissor_direction;g=this.particles_life;r=this.num_textures*this.num_textures;
t=this.velocity_variation;if(0<this.particles_per_second)for(f=this.particles_per_second*(f+this._accumulated_time),this._accumulated_time=(f-Math.floor(f))/this.particles_per_second,f=Math.floor(f),d=0;d<f&&!(this.particles.length>=this.max_particles);d++)l=vec3.clone(l),l[0]+=0.5*Math.random()*t,l[2]+=0.5*Math.random()*t,this.particles.push({id:this._last_particle_id++,tex:Math.floor(Math.random()*r)/r,pos:vec3.clone(k),vel:l,ttl:g})};s.prototype.render=function(f,k){if(0!=this.particles.length){this.updateVertices();
var l=this._meshes[f.gl.context_id];l||(l=new GL.Mesh(void 0,void 0,f.gl),this._vertices_buffer=l.createVertexBuffer("vertices",null,3,this._vertices,gl.DYNAMIC_DRAW),this._extra_buffer=l.createVertexBuffer("extra3",null,3,this._extra,gl.DYNAMIC_DRAW));this._mesh=l;this._vertices_buffer.uploadRange(0,12*this.particles.length);this._extra_buffer.uploadRange(0,12*this.particles.length);l=gl.shaders[this.shader];l||(l=gl.shaders.particles)||(gl.shaders.particles=new GL.Shader(s._vertex_shader,s._pixel_shader));
this.draw_range[1]=this.particles.length;l=gl.getViewport();this._uniforms.u_pointSize=this.particles_size/(gl.canvas.width/l[2]);this._uniforms.u_color=this.color;this._uniforms.u_texture_info[0]=1/this.num_textures;this._uniforms.u_texture_info[1]=this.num_textures*this.num_textures;this._uniforms.u_scaleStartEnd[0]=this.particles_start_scale;this._uniforms.u_scaleStartEnd[1]=this.particles_end_scale;mat4.identity(f._model_matrix);f._mvp_matrix.set(f._viewprojection_matrix);f.renderNode(this,f,
k)}};s.prototype.updateVertices=function(f){if(f=this.particles.length)for(var k=this._vertices,l=this._extra,g=0,r=this.particles_life,t=this.num_textures*this.num_textures,d=0;d<f;d++){var p=this.particles[d];k.set(p.pos,g);l[g]=1;l[g+1]=p.ttl/r;1<t&&(l[g+2]=p.tex);g+=3}};s._vertex_shader="\t\t\tprecision highp float;\t\t\tattribute vec3 a_vertex;\t\t\tattribute vec3 a_extra3;\t\t\tvarying vec2 v_coord;\t\t\tvarying vec4 v_color;\t\t\tvarying vec3 v_position;\t\t\tuniform vec3 u_camera_position;\t\t\tuniform mat4 u_mvp;\t\t\tuniform mat4 u_model;\t\t\tuniform vec4 u_color;\t\t\tuniform float u_pointSize;\t\t\tuniform vec2 u_texture_info;\t\t\tuniform vec2 u_scaleStartEnd;\t\t\tvoid main() {\n\t\t\t\tv_color = u_color;\n\t\t\t\tv_color.a *= a_extra3.y;\n\t\t\t\tv_coord.x = (a_extra3.z * u_texture_info.y) * u_texture_info.x;\n\t\t\t\tv_coord.y = floor(v_coord.x) * u_texture_info.x;\n\t\t\t\tv_coord.x = fract(v_coord.x);\n\t\t\t\tgl_Position = u_mvp * vec4(a_vertex,1.0);\n\t\t\t\tv_position = (u_model * vec4(a_vertex,1.0)).xyz;\n\t\t\t\tfloat dist = distance( u_camera_position, v_position );\n\t\t\t\tgl_PointSize = mix(u_scaleStartEnd.y, u_scaleStartEnd.x, a_extra3.y) * 10.0 * u_pointSize / dist;\n\t\t\t}\t\t\t";
s._pixel_shader="\t\t\tprecision highp float;\t\t\tvarying vec4 v_color;\t\t\tvarying vec2 v_coord;\t\t\tvarying vec3 v_position;\t\t\tuniform sampler2D u_color_texture;\t\t\tuniform vec2 u_texture_info;\t\t\tvoid main() {\t\t\t  vec4 color = texture2D( u_color_texture, v_coord + vec2(gl_PointCoord.x,1.0 - gl_PointCoord.y) * u_texture_info.x );\n\t\t\t  color.xyz *= v_color.xyz;\n\t\t\t  #ifdef USE_PROCESS_COLOR\n\t\t\t\tUSE_PROCESS_COLOR\n\t\t\t  #endif\n\t\t\t  gl_FragColor = vec4( color.xyz, color.a * v_color.a );\n\t\t\t}\t\t";
extendClass(r,RD.SceneNode);RD.Billboard=r;r.SPHERIC=1;r.PARALLEL_SPHERIC=2;r.CYLINDRIC=3;r.PARALLEL_CYLINDRIC=4;r.prototype._ctor=function(){this.billboard_mode=r.SPHERIC;this.auto_orient=!0;RD.SceneNode.prototype._ctor.call(this)};r.prototype.render=function(f,k){!1!==this.flags.visible&&(this.auto_orient&&RD.orientNodeToCamera(this.billboard_mode,this,k,f),f.renderNode(this,f,k))};RD.SpritesBatch=u;u.XY=0;u.XZ=1;u.CYLINDRICAL=2;u.SPHERICAL=3;u.FLAT=4;u.u_colors=new Float32Array([1,1,1,0.75,0.75,
0.75,0.5,0.5,0.5,0.25,0.25,0.25,0.1,0.1,0.1]);u.prototype.reset=function(){this.index=0};u.prototype.add=function(f,k){if(this.max_sprites<=this.index)console.warn("too many sprites in batch, increase size");else{var l=this.index;this.index+=1;this.positions.set(f,3*l);this.sprite_info.set(k,4*l);this.must_update_buffers=!0}};u.prototype.render=function(f,k,l,g,r,t){if(this.index){var d=gl.shaders[this.shader];if(d)if(t=t||0,this.use_points)d.uniforms(GFX.scene_renderer._uniforms),d.setUniform("u_pointSize",
l),d.setUniform("u_atlas",g),d.setUniform("u_texture",f.bind(0)),RD.renderPoints(this.positions,this.sprite_info,k,this.index,d);else{if(!this.vertex_buffer_data){this.vertex_buffer_data=new Float32Array(12*this.max_sprites);this.extra4_buffer_data=new Float32Array(16*this.max_sprites);for(var p=new Int8Array(8*this.max_sprites),s=new Int8Array([-1,1,1,1,-1,-1,1,-1]),w=0;w<p.length;w+=8)p.set(s,w);for(var s=new Int16Array([0,1,2,1,3,2]),x=new Uint16Array(6*this.max_sprites),w=0;w<x.length;++w)x[w]=
s[w%6]+4*Math.floor(w/6);this.vertex_buffer=new GL.Buffer(gl.ARRAY_BUFFER,this.vertex_buffer_data,3,gl.DYNAMIC_DRAW);this.extra4_buffer=new GL.Buffer(gl.ARRAY_BUFFER,this.extra4_buffer_data,4,gl.DYNAMIC_DRAW);this.extra2_buffer=new GL.Buffer(gl.ARRAY_BUFFER,p,2,gl.STATIC_DRAW);this.indices_buffer=new GL.Buffer(gl.ELEMENT_ARRAY_BUFFER,x,1,gl.STATIC_DRAW)}if(this.must_update_buffers){p=this.vertex_buffer_data;s=this.extra4_buffer_data;x=Math.min(this.index,this.positions.length/3);for(w=0;w<x;++w){var n=
3*w,q=this.positions.subarray(n,n+3);p.set(q,4*n);p.set(q,4*n+3);p.set(q,4*n+6);p.set(q,4*n+9);n=4*w;q=this.sprite_info.subarray(n,n+4);s.set(q,4*n);s.set(q,4*n+4);s.set(q,4*n+8);s.set(q,4*n+12)}this.vertex_buffer.uploadRange(0,48*this.index);this.extra4_buffer.uploadRange(0,64*this.index);this.must_update_buffers=!1}w=f.width/g[0]/(f.height/g[1]);p=RD.UP;s=RD.RIGHT;switch(t){case u.SPHERICAL:p=k.getLocalVector(RD.UP);case u.CYLINDRICAL:s=k.getLocalVector(RD.RIGHT);break;case u.FLAT:p=k.getLocalVector(RD.FRONT);
s=k.getLocalVector(RD.RIGHT);break;case u.XZ:p=RD.FRONT}d.bind();d.uniforms(GFX.scene_renderer._uniforms);d.setUniform("u_color",r||[1,1,1,1]);d.setUniform("u_size",[l,l/w]);d.setUniform("u_colors",u.u_colors);d.setUniform("u_top",p);d.setUniform("u_right",s);d.setUniform("u_atlas",g);d.setUniform("u_texture",f.bind(0));d.setUniform("u_itexsize",[1/f.width,1/f.height]);d.setUniform("u_viewport",gl.viewport_data);f=d.attributes.a_vertex;k=d.attributes.a_extra4;d=d.attributes.a_extra2;this.vertex_buffer.bind(f);
this.extra4_buffer.bind(k);this.extra2_buffer.bind(d);gl.bindBuffer(gl.ELEMENT_ARRAY_BUFFER,this.indices_buffer.buffer);gl.drawElements(gl.TRIANGLES,6*this.index,gl.UNSIGNED_SHORT,0);gl.bindBuffer(gl.ELEMENT_ARRAY_BUFFER,null);this.vertex_buffer.unbind(f);this.extra4_buffer.unbind(k);this.extra2_buffer.unbind(d)}}}})("undefined"!=typeof window?window:"undefined"!=typeof self?self:global);
