/*!
@fileoverview gl-matrix - High performance matrix and vector operations
@author Brandon Jones
@author Colin MacKenzie IV
@version 2.7.0

Copyright (c) 2015-2018, Brandon Jones, Colin MacKenzie IV.

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

*/
!function(t,n){if("object"==typeof exports&&"object"==typeof module)module.exports=n();else if("function"==typeof define&&define.amd)define([],n);else{var r=n();for(var a in r)("object"==typeof exports?exports:t)[a]=r[a]}}("undefined"!=typeof self?self:this,function(){return function(t){var n={};function r(a){if(n[a])return n[a].exports;var e=n[a]={i:a,l:!1,exports:{}};return t[a].call(e.exports,e,e.exports,r),e.l=!0,e.exports}return r.m=t,r.c=n,r.d=function(t,n,a){r.o(t,n)||Object.defineProperty(t,n,{enumerable:!0,get:a})},r.r=function(t){"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},r.t=function(t,n){if(1&n&&(t=r(t)),8&n)return t;if(4&n&&"object"==typeof t&&t&&t.__esModule)return t;var a=Object.create(null);if(r.r(a),Object.defineProperty(a,"default",{enumerable:!0,value:t}),2&n&&"string"!=typeof t)for(var e in t)r.d(a,e,function(n){return t[n]}.bind(null,e));return a},r.n=function(t){var n=t&&t.__esModule?function(){return t.default}:function(){return t};return r.d(n,"a",n),n},r.o=function(t,n){return Object.prototype.hasOwnProperty.call(t,n)},r.p="",r(r.s=10)}([function(t,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.setMatrixArrayType=function(t){n.ARRAY_TYPE=t},n.toRadian=function(t){return t*e},n.equals=function(t,n){return Math.abs(t-n)<=a*Math.max(1,Math.abs(t),Math.abs(n))};var a=n.EPSILON=1e-6;n.ARRAY_TYPE="undefined"!=typeof Float32Array?Float32Array:Array,n.RANDOM=Math.random;var e=Math.PI/180},function(t,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.forEach=n.sqrLen=n.len=n.sqrDist=n.dist=n.div=n.mul=n.sub=void 0,n.create=e,n.clone=function(t){var n=new a.ARRAY_TYPE(4);return n[0]=t[0],n[1]=t[1],n[2]=t[2],n[3]=t[3],n},n.fromValues=function(t,n,r,e){var u=new a.ARRAY_TYPE(4);return u[0]=t,u[1]=n,u[2]=r,u[3]=e,u},n.copy=function(t,n){return t[0]=n[0],t[1]=n[1],t[2]=n[2],t[3]=n[3],t},n.set=function(t,n,r,a,e){return t[0]=n,t[1]=r,t[2]=a,t[3]=e,t},n.add=function(t,n,r){return t[0]=n[0]+r[0],t[1]=n[1]+r[1],t[2]=n[2]+r[2],t[3]=n[3]+r[3],t},n.subtract=u,n.multiply=o,n.divide=i,n.ceil=function(t,n){return t[0]=Math.ceil(n[0]),t[1]=Math.ceil(n[1]),t[2]=Math.ceil(n[2]),t[3]=Math.ceil(n[3]),t},n.floor=function(t,n){return t[0]=Math.floor(n[0]),t[1]=Math.floor(n[1]),t[2]=Math.floor(n[2]),t[3]=Math.floor(n[3]),t},n.min=function(t,n,r){return t[0]=Math.min(n[0],r[0]),t[1]=Math.min(n[1],r[1]),t[2]=Math.min(n[2],r[2]),t[3]=Math.min(n[3],r[3]),t},n.max=function(t,n,r){return t[0]=Math.max(n[0],r[0]),t[1]=Math.max(n[1],r[1]),t[2]=Math.max(n[2],r[2]),t[3]=Math.max(n[3],r[3]),t},n.round=function(t,n){return t[0]=Math.round(n[0]),t[1]=Math.round(n[1]),t[2]=Math.round(n[2]),t[3]=Math.round(n[3]),t},n.scale=function(t,n,r){return t[0]=n[0]*r,t[1]=n[1]*r,t[2]=n[2]*r,t[3]=n[3]*r,t},n.scaleAndAdd=function(t,n,r,a){return t[0]=n[0]+r[0]*a,t[1]=n[1]+r[1]*a,t[2]=n[2]+r[2]*a,t[3]=n[3]+r[3]*a,t},n.distance=s,n.squaredDistance=c,n.length=f,n.squaredLength=M,n.negate=function(t,n){return t[0]=-n[0],t[1]=-n[1],t[2]=-n[2],t[3]=-n[3],t},n.inverse=function(t,n){return t[0]=1/n[0],t[1]=1/n[1],t[2]=1/n[2],t[3]=1/n[3],t},n.normalize=function(t,n){var r=n[0],a=n[1],e=n[2],u=n[3],o=r*r+a*a+e*e+u*u;o>0&&(o=1/Math.sqrt(o),t[0]=r*o,t[1]=a*o,t[2]=e*o,t[3]=u*o);return t},n.dot=function(t,n){return t[0]*n[0]+t[1]*n[1]+t[2]*n[2]+t[3]*n[3]},n.lerp=function(t,n,r,a){var e=n[0],u=n[1],o=n[2],i=n[3];return t[0]=e+a*(r[0]-e),t[1]=u+a*(r[1]-u),t[2]=o+a*(r[2]-o),t[3]=i+a*(r[3]-i),t},n.random=function(t,n){var r,e,u,o,i,s;n=n||1;do{r=2*a.RANDOM()-1,e=2*a.RANDOM()-1,i=r*r+e*e}while(i>=1);do{u=2*a.RANDOM()-1,o=2*a.RANDOM()-1,s=u*u+o*o}while(s>=1);var c=Math.sqrt((1-i)/s);return t[0]=n*r,t[1]=n*e,t[2]=n*u*c,t[3]=n*o*c,t},n.transformMat4=function(t,n,r){var a=n[0],e=n[1],u=n[2],o=n[3];return t[0]=r[0]*a+r[4]*e+r[8]*u+r[12]*o,t[1]=r[1]*a+r[5]*e+r[9]*u+r[13]*o,t[2]=r[2]*a+r[6]*e+r[10]*u+r[14]*o,t[3]=r[3]*a+r[7]*e+r[11]*u+r[15]*o,t},n.transformQuat=function(t,n,r){var a=n[0],e=n[1],u=n[2],o=r[0],i=r[1],s=r[2],c=r[3],f=c*a+i*u-s*e,M=c*e+s*a-o*u,h=c*u+o*e-i*a,l=-o*a-i*e-s*u;return t[0]=f*c+l*-o+M*-s-h*-i,t[1]=M*c+l*-i+h*-o-f*-s,t[2]=h*c+l*-s+f*-i-M*-o,t[3]=n[3],t},n.str=function(t){return"vec4("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+")"},n.exactEquals=function(t,n){return t[0]===n[0]&&t[1]===n[1]&&t[2]===n[2]&&t[3]===n[3]},n.equals=function(t,n){var r=t[0],e=t[1],u=t[2],o=t[3],i=n[0],s=n[1],c=n[2],f=n[3];return Math.abs(r-i)<=a.EPSILON*Math.max(1,Math.abs(r),Math.abs(i))&&Math.abs(e-s)<=a.EPSILON*Math.max(1,Math.abs(e),Math.abs(s))&&Math.abs(u-c)<=a.EPSILON*Math.max(1,Math.abs(u),Math.abs(c))&&Math.abs(o-f)<=a.EPSILON*Math.max(1,Math.abs(o),Math.abs(f))};var a=function(t){if(t&&t.__esModule)return t;var n={};if(null!=t)for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(n[r]=t[r]);return n.default=t,n}(r(0));function e(){var t=new a.ARRAY_TYPE(4);return a.ARRAY_TYPE!=Float32Array&&(t[0]=0,t[1]=0,t[2]=0,t[3]=0),t}function u(t,n,r){return t[0]=n[0]-r[0],t[1]=n[1]-r[1],t[2]=n[2]-r[2],t[3]=n[3]-r[3],t}function o(t,n,r){return t[0]=n[0]*r[0],t[1]=n[1]*r[1],t[2]=n[2]*r[2],t[3]=n[3]*r[3],t}function i(t,n,r){return t[0]=n[0]/r[0],t[1]=n[1]/r[1],t[2]=n[2]/r[2],t[3]=n[3]/r[3],t}function s(t,n){var r=n[0]-t[0],a=n[1]-t[1],e=n[2]-t[2],u=n[3]-t[3];return Math.sqrt(r*r+a*a+e*e+u*u)}function c(t,n){var r=n[0]-t[0],a=n[1]-t[1],e=n[2]-t[2],u=n[3]-t[3];return r*r+a*a+e*e+u*u}function f(t){var n=t[0],r=t[1],a=t[2],e=t[3];return Math.sqrt(n*n+r*r+a*a+e*e)}function M(t){var n=t[0],r=t[1],a=t[2],e=t[3];return n*n+r*r+a*a+e*e}n.sub=u,n.mul=o,n.div=i,n.dist=s,n.sqrDist=c,n.len=f,n.sqrLen=M,n.forEach=function(){var t=e();return function(n,r,a,e,u,o){var i=void 0,s=void 0;for(r||(r=4),a||(a=0),s=e?Math.min(e*r+a,n.length):n.length,i=a;i<s;i+=r)t[0]=n[i],t[1]=n[i+1],t[2]=n[i+2],t[3]=n[i+3],u(t,t,o),n[i]=t[0],n[i+1]=t[1],n[i+2]=t[2],n[i+3]=t[3];return n}}()},function(t,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.forEach=n.sqrLen=n.len=n.sqrDist=n.dist=n.div=n.mul=n.sub=void 0,n.create=e,n.clone=function(t){var n=new a.ARRAY_TYPE(3);return n[0]=t[0],n[1]=t[1],n[2]=t[2],n},n.length=u,n.fromValues=o,n.copy=function(t,n){return t[0]=n[0],t[1]=n[1],t[2]=n[2],t},n.set=function(t,n,r,a){return t[0]=n,t[1]=r,t[2]=a,t},n.add=function(t,n,r){return t[0]=n[0]+r[0],t[1]=n[1]+r[1],t[2]=n[2]+r[2],t},n.subtract=i,n.multiply=s,n.divide=c,n.ceil=function(t,n){return t[0]=Math.ceil(n[0]),t[1]=Math.ceil(n[1]),t[2]=Math.ceil(n[2]),t},n.floor=function(t,n){return t[0]=Math.floor(n[0]),t[1]=Math.floor(n[1]),t[2]=Math.floor(n[2]),t},n.min=function(t,n,r){return t[0]=Math.min(n[0],r[0]),t[1]=Math.min(n[1],r[1]),t[2]=Math.min(n[2],r[2]),t},n.max=function(t,n,r){return t[0]=Math.max(n[0],r[0]),t[1]=Math.max(n[1],r[1]),t[2]=Math.max(n[2],r[2]),t},n.round=function(t,n){return t[0]=Math.round(n[0]),t[1]=Math.round(n[1]),t[2]=Math.round(n[2]),t},n.scale=function(t,n,r){return t[0]=n[0]*r,t[1]=n[1]*r,t[2]=n[2]*r,t},n.scaleAndAdd=function(t,n,r,a){return t[0]=n[0]+r[0]*a,t[1]=n[1]+r[1]*a,t[2]=n[2]+r[2]*a,t},n.distance=f,n.squaredDistance=M,n.squaredLength=h,n.negate=function(t,n){return t[0]=-n[0],t[1]=-n[1],t[2]=-n[2],t},n.inverse=function(t,n){return t[0]=1/n[0],t[1]=1/n[1],t[2]=1/n[2],t},n.normalize=l,n.dot=v,n.cross=function(t,n,r){var a=n[0],e=n[1],u=n[2],o=r[0],i=r[1],s=r[2];return t[0]=e*s-u*i,t[1]=u*o-a*s,t[2]=a*i-e*o,t},n.lerp=function(t,n,r,a){var e=n[0],u=n[1],o=n[2];return t[0]=e+a*(r[0]-e),t[1]=u+a*(r[1]-u),t[2]=o+a*(r[2]-o),t},n.hermite=function(t,n,r,a,e,u){var o=u*u,i=o*(2*u-3)+1,s=o*(u-2)+u,c=o*(u-1),f=o*(3-2*u);return t[0]=n[0]*i+r[0]*s+a[0]*c+e[0]*f,t[1]=n[1]*i+r[1]*s+a[1]*c+e[1]*f,t[2]=n[2]*i+r[2]*s+a[2]*c+e[2]*f,t},n.bezier=function(t,n,r,a,e,u){var o=1-u,i=o*o,s=u*u,c=i*o,f=3*u*i,M=3*s*o,h=s*u;return t[0]=n[0]*c+r[0]*f+a[0]*M+e[0]*h,t[1]=n[1]*c+r[1]*f+a[1]*M+e[1]*h,t[2]=n[2]*c+r[2]*f+a[2]*M+e[2]*h,t},n.random=function(t,n){n=n||1;var r=2*a.RANDOM()*Math.PI,e=2*a.RANDOM()-1,u=Math.sqrt(1-e*e)*n;return t[0]=Math.cos(r)*u,t[1]=Math.sin(r)*u,t[2]=e*n,t},n.transformMat4=function(t,n,r){var a=n[0],e=n[1],u=n[2],o=r[3]*a+r[7]*e+r[11]*u+r[15];return o=o||1,t[0]=(r[0]*a+r[4]*e+r[8]*u+r[12])/o,t[1]=(r[1]*a+r[5]*e+r[9]*u+r[13])/o,t[2]=(r[2]*a+r[6]*e+r[10]*u+r[14])/o,t},n.transformMat3=function(t,n,r){var a=n[0],e=n[1],u=n[2];return t[0]=a*r[0]+e*r[3]+u*r[6],t[1]=a*r[1]+e*r[4]+u*r[7],t[2]=a*r[2]+e*r[5]+u*r[8],t},n.transformQuat=function(t,n,r){var a=r[0],e=r[1],u=r[2],o=r[3],i=n[0],s=n[1],c=n[2],f=e*c-u*s,M=u*i-a*c,h=a*s-e*i,l=e*h-u*M,v=u*f-a*h,d=a*M-e*f,b=2*o;return f*=b,M*=b,h*=b,l*=2,v*=2,d*=2,t[0]=i+f+l,t[1]=s+M+v,t[2]=c+h+d,t},n.rotateX=function(t,n,r,a){var e=[],u=[];return e[0]=n[0]-r[0],e[1]=n[1]-r[1],e[2]=n[2]-r[2],u[0]=e[0],u[1]=e[1]*Math.cos(a)-e[2]*Math.sin(a),u[2]=e[1]*Math.sin(a)+e[2]*Math.cos(a),t[0]=u[0]+r[0],t[1]=u[1]+r[1],t[2]=u[2]+r[2],t},n.rotateY=function(t,n,r,a){var e=[],u=[];return e[0]=n[0]-r[0],e[1]=n[1]-r[1],e[2]=n[2]-r[2],u[0]=e[2]*Math.sin(a)+e[0]*Math.cos(a),u[1]=e[1],u[2]=e[2]*Math.cos(a)-e[0]*Math.sin(a),t[0]=u[0]+r[0],t[1]=u[1]+r[1],t[2]=u[2]+r[2],t},n.rotateZ=function(t,n,r,a){var e=[],u=[];return e[0]=n[0]-r[0],e[1]=n[1]-r[1],e[2]=n[2]-r[2],u[0]=e[0]*Math.cos(a)-e[1]*Math.sin(a),u[1]=e[0]*Math.sin(a)+e[1]*Math.cos(a),u[2]=e[2],t[0]=u[0]+r[0],t[1]=u[1]+r[1],t[2]=u[2]+r[2],t},n.angle=function(t,n){var r=o(t[0],t[1],t[2]),a=o(n[0],n[1],n[2]);l(r,r),l(a,a);var e=v(r,a);return e>1?0:e<-1?Math.PI:Math.acos(e)},n.str=function(t){return"vec3("+t[0]+", "+t[1]+", "+t[2]+")"},n.exactEquals=function(t,n){return t[0]===n[0]&&t[1]===n[1]&&t[2]===n[2]},n.equals=function(t,n){var r=t[0],e=t[1],u=t[2],o=n[0],i=n[1],s=n[2];return Math.abs(r-o)<=a.EPSILON*Math.max(1,Math.abs(r),Math.abs(o))&&Math.abs(e-i)<=a.EPSILON*Math.max(1,Math.abs(e),Math.abs(i))&&Math.abs(u-s)<=a.EPSILON*Math.max(1,Math.abs(u),Math.abs(s))};var a=function(t){if(t&&t.__esModule)return t;var n={};if(null!=t)for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(n[r]=t[r]);return n.default=t,n}(r(0));function e(){var t=new a.ARRAY_TYPE(3);return a.ARRAY_TYPE!=Float32Array&&(t[0]=0,t[1]=0,t[2]=0),t}function u(t){var n=t[0],r=t[1],a=t[2];return Math.sqrt(n*n+r*r+a*a)}function o(t,n,r){var e=new a.ARRAY_TYPE(3);return e[0]=t,e[1]=n,e[2]=r,e}function i(t,n,r){return t[0]=n[0]-r[0],t[1]=n[1]-r[1],t[2]=n[2]-r[2],t}function s(t,n,r){return t[0]=n[0]*r[0],t[1]=n[1]*r[1],t[2]=n[2]*r[2],t}function c(t,n,r){return t[0]=n[0]/r[0],t[1]=n[1]/r[1],t[2]=n[2]/r[2],t}function f(t,n){var r=n[0]-t[0],a=n[1]-t[1],e=n[2]-t[2];return Math.sqrt(r*r+a*a+e*e)}function M(t,n){var r=n[0]-t[0],a=n[1]-t[1],e=n[2]-t[2];return r*r+a*a+e*e}function h(t){var n=t[0],r=t[1],a=t[2];return n*n+r*r+a*a}function l(t,n){var r=n[0],a=n[1],e=n[2],u=r*r+a*a+e*e;return u>0&&(u=1/Math.sqrt(u),t[0]=n[0]*u,t[1]=n[1]*u,t[2]=n[2]*u),t}function v(t,n){return t[0]*n[0]+t[1]*n[1]+t[2]*n[2]}n.sub=i,n.mul=s,n.div=c,n.dist=f,n.sqrDist=M,n.len=u,n.sqrLen=h,n.forEach=function(){var t=e();return function(n,r,a,e,u,o){var i=void 0,s=void 0;for(r||(r=3),a||(a=0),s=e?Math.min(e*r+a,n.length):n.length,i=a;i<s;i+=r)t[0]=n[i],t[1]=n[i+1],t[2]=n[i+2],u(t,t,o),n[i]=t[0],n[i+1]=t[1],n[i+2]=t[2];return n}}()},function(t,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.setAxes=n.sqlerp=n.rotationTo=n.equals=n.exactEquals=n.normalize=n.sqrLen=n.squaredLength=n.len=n.length=n.lerp=n.dot=n.scale=n.mul=n.add=n.set=n.copy=n.fromValues=n.clone=void 0,n.create=s,n.identity=function(t){return t[0]=0,t[1]=0,t[2]=0,t[3]=1,t},n.setAxisAngle=c,n.getAxisAngle=function(t,n){var r=2*Math.acos(n[3]),e=Math.sin(r/2);e>a.EPSILON?(t[0]=n[0]/e,t[1]=n[1]/e,t[2]=n[2]/e):(t[0]=1,t[1]=0,t[2]=0);return r},n.multiply=f,n.rotateX=function(t,n,r){r*=.5;var a=n[0],e=n[1],u=n[2],o=n[3],i=Math.sin(r),s=Math.cos(r);return t[0]=a*s+o*i,t[1]=e*s+u*i,t[2]=u*s-e*i,t[3]=o*s-a*i,t},n.rotateY=function(t,n,r){r*=.5;var a=n[0],e=n[1],u=n[2],o=n[3],i=Math.sin(r),s=Math.cos(r);return t[0]=a*s-u*i,t[1]=e*s+o*i,t[2]=u*s+a*i,t[3]=o*s-e*i,t},n.rotateZ=function(t,n,r){r*=.5;var a=n[0],e=n[1],u=n[2],o=n[3],i=Math.sin(r),s=Math.cos(r);return t[0]=a*s+e*i,t[1]=e*s-a*i,t[2]=u*s+o*i,t[3]=o*s-u*i,t},n.calculateW=function(t,n){var r=n[0],a=n[1],e=n[2];return t[0]=r,t[1]=a,t[2]=e,t[3]=Math.sqrt(Math.abs(1-r*r-a*a-e*e)),t},n.slerp=M,n.random=function(t){var n=a.RANDOM(),r=a.RANDOM(),e=a.RANDOM(),u=Math.sqrt(1-n),o=Math.sqrt(n);return t[0]=u*Math.sin(2*Math.PI*r),t[1]=u*Math.cos(2*Math.PI*r),t[2]=o*Math.sin(2*Math.PI*e),t[3]=o*Math.cos(2*Math.PI*e),t},n.invert=function(t,n){var r=n[0],a=n[1],e=n[2],u=n[3],o=r*r+a*a+e*e+u*u,i=o?1/o:0;return t[0]=-r*i,t[1]=-a*i,t[2]=-e*i,t[3]=u*i,t},n.conjugate=function(t,n){return t[0]=-n[0],t[1]=-n[1],t[2]=-n[2],t[3]=n[3],t},n.fromMat3=h,n.fromEuler=function(t,n,r,a){var e=.5*Math.PI/180;n*=e,r*=e,a*=e;var u=Math.sin(n),o=Math.cos(n),i=Math.sin(r),s=Math.cos(r),c=Math.sin(a),f=Math.cos(a);return t[0]=u*s*f-o*i*c,t[1]=o*i*f+u*s*c,t[2]=o*s*c-u*i*f,t[3]=o*s*f+u*i*c,t},n.str=function(t){return"quat("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+")"};var a=i(r(0)),e=i(r(5)),u=i(r(2)),o=i(r(1));function i(t){if(t&&t.__esModule)return t;var n={};if(null!=t)for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(n[r]=t[r]);return n.default=t,n}function s(){var t=new a.ARRAY_TYPE(4);return a.ARRAY_TYPE!=Float32Array&&(t[0]=0,t[1]=0,t[2]=0),t[3]=1,t}function c(t,n,r){r*=.5;var a=Math.sin(r);return t[0]=a*n[0],t[1]=a*n[1],t[2]=a*n[2],t[3]=Math.cos(r),t}function f(t,n,r){var a=n[0],e=n[1],u=n[2],o=n[3],i=r[0],s=r[1],c=r[2],f=r[3];return t[0]=a*f+o*i+e*c-u*s,t[1]=e*f+o*s+u*i-a*c,t[2]=u*f+o*c+a*s-e*i,t[3]=o*f-a*i-e*s-u*c,t}function M(t,n,r,e){var u=n[0],o=n[1],i=n[2],s=n[3],c=r[0],f=r[1],M=r[2],h=r[3],l=void 0,v=void 0,d=void 0,b=void 0,m=void 0;return(v=u*c+o*f+i*M+s*h)<0&&(v=-v,c=-c,f=-f,M=-M,h=-h),1-v>a.EPSILON?(l=Math.acos(v),d=Math.sin(l),b=Math.sin((1-e)*l)/d,m=Math.sin(e*l)/d):(b=1-e,m=e),t[0]=b*u+m*c,t[1]=b*o+m*f,t[2]=b*i+m*M,t[3]=b*s+m*h,t}function h(t,n){var r=n[0]+n[4]+n[8],a=void 0;if(r>0)a=Math.sqrt(r+1),t[3]=.5*a,a=.5/a,t[0]=(n[5]-n[7])*a,t[1]=(n[6]-n[2])*a,t[2]=(n[1]-n[3])*a;else{var e=0;n[4]>n[0]&&(e=1),n[8]>n[3*e+e]&&(e=2);var u=(e+1)%3,o=(e+2)%3;a=Math.sqrt(n[3*e+e]-n[3*u+u]-n[3*o+o]+1),t[e]=.5*a,a=.5/a,t[3]=(n[3*u+o]-n[3*o+u])*a,t[u]=(n[3*u+e]+n[3*e+u])*a,t[o]=(n[3*o+e]+n[3*e+o])*a}return t}n.clone=o.clone,n.fromValues=o.fromValues,n.copy=o.copy,n.set=o.set,n.add=o.add,n.mul=f,n.scale=o.scale,n.dot=o.dot,n.lerp=o.lerp;var l=n.length=o.length,v=(n.len=l,n.squaredLength=o.squaredLength),d=(n.sqrLen=v,n.normalize=o.normalize);n.exactEquals=o.exactEquals,n.equals=o.equals,n.rotationTo=function(){var t=u.create(),n=u.fromValues(1,0,0),r=u.fromValues(0,1,0);return function(a,e,o){var i=u.dot(e,o);return i<-.999999?(u.cross(t,n,e),u.len(t)<1e-6&&u.cross(t,r,e),u.normalize(t,t),c(a,t,Math.PI),a):i>.999999?(a[0]=0,a[1]=0,a[2]=0,a[3]=1,a):(u.cross(t,e,o),a[0]=t[0],a[1]=t[1],a[2]=t[2],a[3]=1+i,d(a,a))}}(),n.sqlerp=function(){var t=s(),n=s();return function(r,a,e,u,o,i){return M(t,a,o,i),M(n,e,u,i),M(r,t,n,2*i*(1-i)),r}}(),n.setAxes=function(){var t=e.create();return function(n,r,a,e){return t[0]=a[0],t[3]=a[1],t[6]=a[2],t[1]=e[0],t[4]=e[1],t[7]=e[2],t[2]=-r[0],t[5]=-r[1],t[8]=-r[2],d(n,h(n,t))}}()},function(t,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.sub=n.mul=void 0,n.create=function(){var t=new a.ARRAY_TYPE(16);a.ARRAY_TYPE!=Float32Array&&(t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[11]=0,t[12]=0,t[13]=0,t[14]=0);return t[0]=1,t[5]=1,t[10]=1,t[15]=1,t},n.clone=function(t){var n=new a.ARRAY_TYPE(16);return n[0]=t[0],n[1]=t[1],n[2]=t[2],n[3]=t[3],n[4]=t[4],n[5]=t[5],n[6]=t[6],n[7]=t[7],n[8]=t[8],n[9]=t[9],n[10]=t[10],n[11]=t[11],n[12]=t[12],n[13]=t[13],n[14]=t[14],n[15]=t[15],n},n.copy=function(t,n){return t[0]=n[0],t[1]=n[1],t[2]=n[2],t[3]=n[3],t[4]=n[4],t[5]=n[5],t[6]=n[6],t[7]=n[7],t[8]=n[8],t[9]=n[9],t[10]=n[10],t[11]=n[11],t[12]=n[12],t[13]=n[13],t[14]=n[14],t[15]=n[15],t},n.fromValues=function(t,n,r,e,u,o,i,s,c,f,M,h,l,v,d,b){var m=new a.ARRAY_TYPE(16);return m[0]=t,m[1]=n,m[2]=r,m[3]=e,m[4]=u,m[5]=o,m[6]=i,m[7]=s,m[8]=c,m[9]=f,m[10]=M,m[11]=h,m[12]=l,m[13]=v,m[14]=d,m[15]=b,m},n.set=function(t,n,r,a,e,u,o,i,s,c,f,M,h,l,v,d,b){return t[0]=n,t[1]=r,t[2]=a,t[3]=e,t[4]=u,t[5]=o,t[6]=i,t[7]=s,t[8]=c,t[9]=f,t[10]=M,t[11]=h,t[12]=l,t[13]=v,t[14]=d,t[15]=b,t},n.identity=e,n.transpose=function(t,n){if(t===n){var r=n[1],a=n[2],e=n[3],u=n[6],o=n[7],i=n[11];t[1]=n[4],t[2]=n[8],t[3]=n[12],t[4]=r,t[6]=n[9],t[7]=n[13],t[8]=a,t[9]=u,t[11]=n[14],t[12]=e,t[13]=o,t[14]=i}else t[0]=n[0],t[1]=n[4],t[2]=n[8],t[3]=n[12],t[4]=n[1],t[5]=n[5],t[6]=n[9],t[7]=n[13],t[8]=n[2],t[9]=n[6],t[10]=n[10],t[11]=n[14],t[12]=n[3],t[13]=n[7],t[14]=n[11],t[15]=n[15];return t},n.invert=function(t,n){var r=n[0],a=n[1],e=n[2],u=n[3],o=n[4],i=n[5],s=n[6],c=n[7],f=n[8],M=n[9],h=n[10],l=n[11],v=n[12],d=n[13],b=n[14],m=n[15],p=r*i-a*o,P=r*s-e*o,A=r*c-u*o,E=a*s-e*i,O=a*c-u*i,R=e*c-u*s,y=f*d-M*v,q=f*b-h*v,x=f*m-l*v,_=M*b-h*d,Y=M*m-l*d,L=h*m-l*b,S=p*L-P*Y+A*_+E*x-O*q+R*y;if(!S)return null;return S=1/S,t[0]=(i*L-s*Y+c*_)*S,t[1]=(e*Y-a*L-u*_)*S,t[2]=(d*R-b*O+m*E)*S,t[3]=(h*O-M*R-l*E)*S,t[4]=(s*x-o*L-c*q)*S,t[5]=(r*L-e*x+u*q)*S,t[6]=(b*A-v*R-m*P)*S,t[7]=(f*R-h*A+l*P)*S,t[8]=(o*Y-i*x+c*y)*S,t[9]=(a*x-r*Y-u*y)*S,t[10]=(v*O-d*A+m*p)*S,t[11]=(M*A-f*O-l*p)*S,t[12]=(i*q-o*_-s*y)*S,t[13]=(r*_-a*q+e*y)*S,t[14]=(d*P-v*E-b*p)*S,t[15]=(f*E-M*P+h*p)*S,t},n.adjoint=function(t,n){var r=n[0],a=n[1],e=n[2],u=n[3],o=n[4],i=n[5],s=n[6],c=n[7],f=n[8],M=n[9],h=n[10],l=n[11],v=n[12],d=n[13],b=n[14],m=n[15];return t[0]=i*(h*m-l*b)-M*(s*m-c*b)+d*(s*l-c*h),t[1]=-(a*(h*m-l*b)-M*(e*m-u*b)+d*(e*l-u*h)),t[2]=a*(s*m-c*b)-i*(e*m-u*b)+d*(e*c-u*s),t[3]=-(a*(s*l-c*h)-i*(e*l-u*h)+M*(e*c-u*s)),t[4]=-(o*(h*m-l*b)-f*(s*m-c*b)+v*(s*l-c*h)),t[5]=r*(h*m-l*b)-f*(e*m-u*b)+v*(e*l-u*h),t[6]=-(r*(s*m-c*b)-o*(e*m-u*b)+v*(e*c-u*s)),t[7]=r*(s*l-c*h)-o*(e*l-u*h)+f*(e*c-u*s),t[8]=o*(M*m-l*d)-f*(i*m-c*d)+v*(i*l-c*M),t[9]=-(r*(M*m-l*d)-f*(a*m-u*d)+v*(a*l-u*M)),t[10]=r*(i*m-c*d)-o*(a*m-u*d)+v*(a*c-u*i),t[11]=-(r*(i*l-c*M)-o*(a*l-u*M)+f*(a*c-u*i)),t[12]=-(o*(M*b-h*d)-f*(i*b-s*d)+v*(i*h-s*M)),t[13]=r*(M*b-h*d)-f*(a*b-e*d)+v*(a*h-e*M),t[14]=-(r*(i*b-s*d)-o*(a*b-e*d)+v*(a*s-e*i)),t[15]=r*(i*h-s*M)-o*(a*h-e*M)+f*(a*s-e*i),t},n.determinant=function(t){var n=t[0],r=t[1],a=t[2],e=t[3],u=t[4],o=t[5],i=t[6],s=t[7],c=t[8],f=t[9],M=t[10],h=t[11],l=t[12],v=t[13],d=t[14],b=t[15];return(n*o-r*u)*(M*b-h*d)-(n*i-a*u)*(f*b-h*v)+(n*s-e*u)*(f*d-M*v)+(r*i-a*o)*(c*b-h*l)-(r*s-e*o)*(c*d-M*l)+(a*s-e*i)*(c*v-f*l)},n.multiply=u,n.translate=function(t,n,r){var a=r[0],e=r[1],u=r[2],o=void 0,i=void 0,s=void 0,c=void 0,f=void 0,M=void 0,h=void 0,l=void 0,v=void 0,d=void 0,b=void 0,m=void 0;n===t?(t[12]=n[0]*a+n[4]*e+n[8]*u+n[12],t[13]=n[1]*a+n[5]*e+n[9]*u+n[13],t[14]=n[2]*a+n[6]*e+n[10]*u+n[14],t[15]=n[3]*a+n[7]*e+n[11]*u+n[15]):(o=n[0],i=n[1],s=n[2],c=n[3],f=n[4],M=n[5],h=n[6],l=n[7],v=n[8],d=n[9],b=n[10],m=n[11],t[0]=o,t[1]=i,t[2]=s,t[3]=c,t[4]=f,t[5]=M,t[6]=h,t[7]=l,t[8]=v,t[9]=d,t[10]=b,t[11]=m,t[12]=o*a+f*e+v*u+n[12],t[13]=i*a+M*e+d*u+n[13],t[14]=s*a+h*e+b*u+n[14],t[15]=c*a+l*e+m*u+n[15]);return t},n.scale=function(t,n,r){var a=r[0],e=r[1],u=r[2];return t[0]=n[0]*a,t[1]=n[1]*a,t[2]=n[2]*a,t[3]=n[3]*a,t[4]=n[4]*e,t[5]=n[5]*e,t[6]=n[6]*e,t[7]=n[7]*e,t[8]=n[8]*u,t[9]=n[9]*u,t[10]=n[10]*u,t[11]=n[11]*u,t[12]=n[12],t[13]=n[13],t[14]=n[14],t[15]=n[15],t},n.rotate=function(t,n,r,e){var u=e[0],o=e[1],i=e[2],s=Math.sqrt(u*u+o*o+i*i),c=void 0,f=void 0,M=void 0,h=void 0,l=void 0,v=void 0,d=void 0,b=void 0,m=void 0,p=void 0,P=void 0,A=void 0,E=void 0,O=void 0,R=void 0,y=void 0,q=void 0,x=void 0,_=void 0,Y=void 0,L=void 0,S=void 0,w=void 0,I=void 0;if(s<a.EPSILON)return null;u*=s=1/s,o*=s,i*=s,c=Math.sin(r),f=Math.cos(r),M=1-f,h=n[0],l=n[1],v=n[2],d=n[3],b=n[4],m=n[5],p=n[6],P=n[7],A=n[8],E=n[9],O=n[10],R=n[11],y=u*u*M+f,q=o*u*M+i*c,x=i*u*M-o*c,_=u*o*M-i*c,Y=o*o*M+f,L=i*o*M+u*c,S=u*i*M+o*c,w=o*i*M-u*c,I=i*i*M+f,t[0]=h*y+b*q+A*x,t[1]=l*y+m*q+E*x,t[2]=v*y+p*q+O*x,t[3]=d*y+P*q+R*x,t[4]=h*_+b*Y+A*L,t[5]=l*_+m*Y+E*L,t[6]=v*_+p*Y+O*L,t[7]=d*_+P*Y+R*L,t[8]=h*S+b*w+A*I,t[9]=l*S+m*w+E*I,t[10]=v*S+p*w+O*I,t[11]=d*S+P*w+R*I,n!==t&&(t[12]=n[12],t[13]=n[13],t[14]=n[14],t[15]=n[15]);return t},n.rotateX=function(t,n,r){var a=Math.sin(r),e=Math.cos(r),u=n[4],o=n[5],i=n[6],s=n[7],c=n[8],f=n[9],M=n[10],h=n[11];n!==t&&(t[0]=n[0],t[1]=n[1],t[2]=n[2],t[3]=n[3],t[12]=n[12],t[13]=n[13],t[14]=n[14],t[15]=n[15]);return t[4]=u*e+c*a,t[5]=o*e+f*a,t[6]=i*e+M*a,t[7]=s*e+h*a,t[8]=c*e-u*a,t[9]=f*e-o*a,t[10]=M*e-i*a,t[11]=h*e-s*a,t},n.rotateY=function(t,n,r){var a=Math.sin(r),e=Math.cos(r),u=n[0],o=n[1],i=n[2],s=n[3],c=n[8],f=n[9],M=n[10],h=n[11];n!==t&&(t[4]=n[4],t[5]=n[5],t[6]=n[6],t[7]=n[7],t[12]=n[12],t[13]=n[13],t[14]=n[14],t[15]=n[15]);return t[0]=u*e-c*a,t[1]=o*e-f*a,t[2]=i*e-M*a,t[3]=s*e-h*a,t[8]=u*a+c*e,t[9]=o*a+f*e,t[10]=i*a+M*e,t[11]=s*a+h*e,t},n.rotateZ=function(t,n,r){var a=Math.sin(r),e=Math.cos(r),u=n[0],o=n[1],i=n[2],s=n[3],c=n[4],f=n[5],M=n[6],h=n[7];n!==t&&(t[8]=n[8],t[9]=n[9],t[10]=n[10],t[11]=n[11],t[12]=n[12],t[13]=n[13],t[14]=n[14],t[15]=n[15]);return t[0]=u*e+c*a,t[1]=o*e+f*a,t[2]=i*e+M*a,t[3]=s*e+h*a,t[4]=c*e-u*a,t[5]=f*e-o*a,t[6]=M*e-i*a,t[7]=h*e-s*a,t},n.fromTranslation=function(t,n){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=1,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=1,t[11]=0,t[12]=n[0],t[13]=n[1],t[14]=n[2],t[15]=1,t},n.fromScaling=function(t,n){return t[0]=n[0],t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=n[1],t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=n[2],t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},n.fromRotation=function(t,n,r){var e=r[0],u=r[1],o=r[2],i=Math.sqrt(e*e+u*u+o*o),s=void 0,c=void 0,f=void 0;if(i<a.EPSILON)return null;return e*=i=1/i,u*=i,o*=i,s=Math.sin(n),c=Math.cos(n),f=1-c,t[0]=e*e*f+c,t[1]=u*e*f+o*s,t[2]=o*e*f-u*s,t[3]=0,t[4]=e*u*f-o*s,t[5]=u*u*f+c,t[6]=o*u*f+e*s,t[7]=0,t[8]=e*o*f+u*s,t[9]=u*o*f-e*s,t[10]=o*o*f+c,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},n.fromXRotation=function(t,n){var r=Math.sin(n),a=Math.cos(n);return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=a,t[6]=r,t[7]=0,t[8]=0,t[9]=-r,t[10]=a,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},n.fromYRotation=function(t,n){var r=Math.sin(n),a=Math.cos(n);return t[0]=a,t[1]=0,t[2]=-r,t[3]=0,t[4]=0,t[5]=1,t[6]=0,t[7]=0,t[8]=r,t[9]=0,t[10]=a,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},n.fromZRotation=function(t,n){var r=Math.sin(n),a=Math.cos(n);return t[0]=a,t[1]=r,t[2]=0,t[3]=0,t[4]=-r,t[5]=a,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=1,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},n.fromRotationTranslation=o,n.fromQuat2=function(t,n){var r=new a.ARRAY_TYPE(3),e=-n[0],u=-n[1],i=-n[2],s=n[3],c=n[4],f=n[5],M=n[6],h=n[7],l=e*e+u*u+i*i+s*s;l>0?(r[0]=2*(c*s+h*e+f*i-M*u)/l,r[1]=2*(f*s+h*u+M*e-c*i)/l,r[2]=2*(M*s+h*i+c*u-f*e)/l):(r[0]=2*(c*s+h*e+f*i-M*u),r[1]=2*(f*s+h*u+M*e-c*i),r[2]=2*(M*s+h*i+c*u-f*e));return o(t,n,r),t},n.getTranslation=function(t,n){return t[0]=n[12],t[1]=n[13],t[2]=n[14],t},n.getScaling=function(t,n){var r=n[0],a=n[1],e=n[2],u=n[4],o=n[5],i=n[6],s=n[8],c=n[9],f=n[10];return t[0]=Math.sqrt(r*r+a*a+e*e),t[1]=Math.sqrt(u*u+o*o+i*i),t[2]=Math.sqrt(s*s+c*c+f*f),t},n.getRotation=function(t,n){var r=n[0]+n[5]+n[10],a=0;r>0?(a=2*Math.sqrt(r+1),t[3]=.25*a,t[0]=(n[6]-n[9])/a,t[1]=(n[8]-n[2])/a,t[2]=(n[1]-n[4])/a):n[0]>n[5]&&n[0]>n[10]?(a=2*Math.sqrt(1+n[0]-n[5]-n[10]),t[3]=(n[6]-n[9])/a,t[0]=.25*a,t[1]=(n[1]+n[4])/a,t[2]=(n[8]+n[2])/a):n[5]>n[10]?(a=2*Math.sqrt(1+n[5]-n[0]-n[10]),t[3]=(n[8]-n[2])/a,t[0]=(n[1]+n[4])/a,t[1]=.25*a,t[2]=(n[6]+n[9])/a):(a=2*Math.sqrt(1+n[10]-n[0]-n[5]),t[3]=(n[1]-n[4])/a,t[0]=(n[8]+n[2])/a,t[1]=(n[6]+n[9])/a,t[2]=.25*a);return t},n.fromRotationTranslationScale=function(t,n,r,a){var e=n[0],u=n[1],o=n[2],i=n[3],s=e+e,c=u+u,f=o+o,M=e*s,h=e*c,l=e*f,v=u*c,d=u*f,b=o*f,m=i*s,p=i*c,P=i*f,A=a[0],E=a[1],O=a[2];return t[0]=(1-(v+b))*A,t[1]=(h+P)*A,t[2]=(l-p)*A,t[3]=0,t[4]=(h-P)*E,t[5]=(1-(M+b))*E,t[6]=(d+m)*E,t[7]=0,t[8]=(l+p)*O,t[9]=(d-m)*O,t[10]=(1-(M+v))*O,t[11]=0,t[12]=r[0],t[13]=r[1],t[14]=r[2],t[15]=1,t},n.fromRotationTranslationScaleOrigin=function(t,n,r,a,e){var u=n[0],o=n[1],i=n[2],s=n[3],c=u+u,f=o+o,M=i+i,h=u*c,l=u*f,v=u*M,d=o*f,b=o*M,m=i*M,p=s*c,P=s*f,A=s*M,E=a[0],O=a[1],R=a[2],y=e[0],q=e[1],x=e[2],_=(1-(d+m))*E,Y=(l+A)*E,L=(v-P)*E,S=(l-A)*O,w=(1-(h+m))*O,I=(b+p)*O,N=(v+P)*R,g=(b-p)*R,T=(1-(h+d))*R;return t[0]=_,t[1]=Y,t[2]=L,t[3]=0,t[4]=S,t[5]=w,t[6]=I,t[7]=0,t[8]=N,t[9]=g,t[10]=T,t[11]=0,t[12]=r[0]+y-(_*y+S*q+N*x),t[13]=r[1]+q-(Y*y+w*q+g*x),t[14]=r[2]+x-(L*y+I*q+T*x),t[15]=1,t},n.fromQuat=function(t,n){var r=n[0],a=n[1],e=n[2],u=n[3],o=r+r,i=a+a,s=e+e,c=r*o,f=a*o,M=a*i,h=e*o,l=e*i,v=e*s,d=u*o,b=u*i,m=u*s;return t[0]=1-M-v,t[1]=f+m,t[2]=h-b,t[3]=0,t[4]=f-m,t[5]=1-c-v,t[6]=l+d,t[7]=0,t[8]=h+b,t[9]=l-d,t[10]=1-c-M,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},n.frustum=function(t,n,r,a,e,u,o){var i=1/(r-n),s=1/(e-a),c=1/(u-o);return t[0]=2*u*i,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=2*u*s,t[6]=0,t[7]=0,t[8]=(r+n)*i,t[9]=(e+a)*s,t[10]=(o+u)*c,t[11]=-1,t[12]=0,t[13]=0,t[14]=o*u*2*c,t[15]=0,t},n.perspective=function(t,n,r,a,e){var u=1/Math.tan(n/2),o=void 0;t[0]=u/r,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=u,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[11]=-1,t[12]=0,t[13]=0,t[15]=0,null!=e&&e!==1/0?(o=1/(a-e),t[10]=(e+a)*o,t[14]=2*e*a*o):(t[10]=-1,t[14]=-2*a);return t},n.perspectiveFromFieldOfView=function(t,n,r,a){var e=Math.tan(n.upDegrees*Math.PI/180),u=Math.tan(n.downDegrees*Math.PI/180),o=Math.tan(n.leftDegrees*Math.PI/180),i=Math.tan(n.rightDegrees*Math.PI/180),s=2/(o+i),c=2/(e+u);return t[0]=s,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=c,t[6]=0,t[7]=0,t[8]=-(o-i)*s*.5,t[9]=(e-u)*c*.5,t[10]=a/(r-a),t[11]=-1,t[12]=0,t[13]=0,t[14]=a*r/(r-a),t[15]=0,t},n.ortho=function(t,n,r,a,e,u,o){var i=1/(n-r),s=1/(a-e),c=1/(u-o);return t[0]=-2*i,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=-2*s,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=2*c,t[11]=0,t[12]=(n+r)*i,t[13]=(e+a)*s,t[14]=(o+u)*c,t[15]=1,t},n.lookAt=function(t,n,r,u){var o=void 0,i=void 0,s=void 0,c=void 0,f=void 0,M=void 0,h=void 0,l=void 0,v=void 0,d=void 0,b=n[0],m=n[1],p=n[2],P=u[0],A=u[1],E=u[2],O=r[0],R=r[1],y=r[2];if(Math.abs(b-O)<a.EPSILON&&Math.abs(m-R)<a.EPSILON&&Math.abs(p-y)<a.EPSILON)return e(t);h=b-O,l=m-R,v=p-y,d=1/Math.sqrt(h*h+l*l+v*v),o=A*(v*=d)-E*(l*=d),i=E*(h*=d)-P*v,s=P*l-A*h,(d=Math.sqrt(o*o+i*i+s*s))?(o*=d=1/d,i*=d,s*=d):(o=0,i=0,s=0);c=l*s-v*i,f=v*o-h*s,M=h*i-l*o,(d=Math.sqrt(c*c+f*f+M*M))?(c*=d=1/d,f*=d,M*=d):(c=0,f=0,M=0);return t[0]=o,t[1]=c,t[2]=h,t[3]=0,t[4]=i,t[5]=f,t[6]=l,t[7]=0,t[8]=s,t[9]=M,t[10]=v,t[11]=0,t[12]=-(o*b+i*m+s*p),t[13]=-(c*b+f*m+M*p),t[14]=-(h*b+l*m+v*p),t[15]=1,t},n.targetTo=function(t,n,r,a){var e=n[0],u=n[1],o=n[2],i=a[0],s=a[1],c=a[2],f=e-r[0],M=u-r[1],h=o-r[2],l=f*f+M*M+h*h;l>0&&(l=1/Math.sqrt(l),f*=l,M*=l,h*=l);var v=s*h-c*M,d=c*f-i*h,b=i*M-s*f;(l=v*v+d*d+b*b)>0&&(l=1/Math.sqrt(l),v*=l,d*=l,b*=l);return t[0]=v,t[1]=d,t[2]=b,t[3]=0,t[4]=M*b-h*d,t[5]=h*v-f*b,t[6]=f*d-M*v,t[7]=0,t[8]=f,t[9]=M,t[10]=h,t[11]=0,t[12]=e,t[13]=u,t[14]=o,t[15]=1,t},n.str=function(t){return"mat4("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+", "+t[4]+", "+t[5]+", "+t[6]+", "+t[7]+", "+t[8]+", "+t[9]+", "+t[10]+", "+t[11]+", "+t[12]+", "+t[13]+", "+t[14]+", "+t[15]+")"},n.frob=function(t){return Math.sqrt(Math.pow(t[0],2)+Math.pow(t[1],2)+Math.pow(t[2],2)+Math.pow(t[3],2)+Math.pow(t[4],2)+Math.pow(t[5],2)+Math.pow(t[6],2)+Math.pow(t[7],2)+Math.pow(t[8],2)+Math.pow(t[9],2)+Math.pow(t[10],2)+Math.pow(t[11],2)+Math.pow(t[12],2)+Math.pow(t[13],2)+Math.pow(t[14],2)+Math.pow(t[15],2))},n.add=function(t,n,r){return t[0]=n[0]+r[0],t[1]=n[1]+r[1],t[2]=n[2]+r[2],t[3]=n[3]+r[3],t[4]=n[4]+r[4],t[5]=n[5]+r[5],t[6]=n[6]+r[6],t[7]=n[7]+r[7],t[8]=n[8]+r[8],t[9]=n[9]+r[9],t[10]=n[10]+r[10],t[11]=n[11]+r[11],t[12]=n[12]+r[12],t[13]=n[13]+r[13],t[14]=n[14]+r[14],t[15]=n[15]+r[15],t},n.subtract=i,n.multiplyScalar=function(t,n,r){return t[0]=n[0]*r,t[1]=n[1]*r,t[2]=n[2]*r,t[3]=n[3]*r,t[4]=n[4]*r,t[5]=n[5]*r,t[6]=n[6]*r,t[7]=n[7]*r,t[8]=n[8]*r,t[9]=n[9]*r,t[10]=n[10]*r,t[11]=n[11]*r,t[12]=n[12]*r,t[13]=n[13]*r,t[14]=n[14]*r,t[15]=n[15]*r,t},n.multiplyScalarAndAdd=function(t,n,r,a){return t[0]=n[0]+r[0]*a,t[1]=n[1]+r[1]*a,t[2]=n[2]+r[2]*a,t[3]=n[3]+r[3]*a,t[4]=n[4]+r[4]*a,t[5]=n[5]+r[5]*a,t[6]=n[6]+r[6]*a,t[7]=n[7]+r[7]*a,t[8]=n[8]+r[8]*a,t[9]=n[9]+r[9]*a,t[10]=n[10]+r[10]*a,t[11]=n[11]+r[11]*a,t[12]=n[12]+r[12]*a,t[13]=n[13]+r[13]*a,t[14]=n[14]+r[14]*a,t[15]=n[15]+r[15]*a,t},n.exactEquals=function(t,n){return t[0]===n[0]&&t[1]===n[1]&&t[2]===n[2]&&t[3]===n[3]&&t[4]===n[4]&&t[5]===n[5]&&t[6]===n[6]&&t[7]===n[7]&&t[8]===n[8]&&t[9]===n[9]&&t[10]===n[10]&&t[11]===n[11]&&t[12]===n[12]&&t[13]===n[13]&&t[14]===n[14]&&t[15]===n[15]},n.equals=function(t,n){var r=t[0],e=t[1],u=t[2],o=t[3],i=t[4],s=t[5],c=t[6],f=t[7],M=t[8],h=t[9],l=t[10],v=t[11],d=t[12],b=t[13],m=t[14],p=t[15],P=n[0],A=n[1],E=n[2],O=n[3],R=n[4],y=n[5],q=n[6],x=n[7],_=n[8],Y=n[9],L=n[10],S=n[11],w=n[12],I=n[13],N=n[14],g=n[15];return Math.abs(r-P)<=a.EPSILON*Math.max(1,Math.abs(r),Math.abs(P))&&Math.abs(e-A)<=a.EPSILON*Math.max(1,Math.abs(e),Math.abs(A))&&Math.abs(u-E)<=a.EPSILON*Math.max(1,Math.abs(u),Math.abs(E))&&Math.abs(o-O)<=a.EPSILON*Math.max(1,Math.abs(o),Math.abs(O))&&Math.abs(i-R)<=a.EPSILON*Math.max(1,Math.abs(i),Math.abs(R))&&Math.abs(s-y)<=a.EPSILON*Math.max(1,Math.abs(s),Math.abs(y))&&Math.abs(c-q)<=a.EPSILON*Math.max(1,Math.abs(c),Math.abs(q))&&Math.abs(f-x)<=a.EPSILON*Math.max(1,Math.abs(f),Math.abs(x))&&Math.abs(M-_)<=a.EPSILON*Math.max(1,Math.abs(M),Math.abs(_))&&Math.abs(h-Y)<=a.EPSILON*Math.max(1,Math.abs(h),Math.abs(Y))&&Math.abs(l-L)<=a.EPSILON*Math.max(1,Math.abs(l),Math.abs(L))&&Math.abs(v-S)<=a.EPSILON*Math.max(1,Math.abs(v),Math.abs(S))&&Math.abs(d-w)<=a.EPSILON*Math.max(1,Math.abs(d),Math.abs(w))&&Math.abs(b-I)<=a.EPSILON*Math.max(1,Math.abs(b),Math.abs(I))&&Math.abs(m-N)<=a.EPSILON*Math.max(1,Math.abs(m),Math.abs(N))&&Math.abs(p-g)<=a.EPSILON*Math.max(1,Math.abs(p),Math.abs(g))};var a=function(t){if(t&&t.__esModule)return t;var n={};if(null!=t)for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(n[r]=t[r]);return n.default=t,n}(r(0));function e(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=1,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=1,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t}function u(t,n,r){var a=n[0],e=n[1],u=n[2],o=n[3],i=n[4],s=n[5],c=n[6],f=n[7],M=n[8],h=n[9],l=n[10],v=n[11],d=n[12],b=n[13],m=n[14],p=n[15],P=r[0],A=r[1],E=r[2],O=r[3];return t[0]=P*a+A*i+E*M+O*d,t[1]=P*e+A*s+E*h+O*b,t[2]=P*u+A*c+E*l+O*m,t[3]=P*o+A*f+E*v+O*p,P=r[4],A=r[5],E=r[6],O=r[7],t[4]=P*a+A*i+E*M+O*d,t[5]=P*e+A*s+E*h+O*b,t[6]=P*u+A*c+E*l+O*m,t[7]=P*o+A*f+E*v+O*p,P=r[8],A=r[9],E=r[10],O=r[11],t[8]=P*a+A*i+E*M+O*d,t[9]=P*e+A*s+E*h+O*b,t[10]=P*u+A*c+E*l+O*m,t[11]=P*o+A*f+E*v+O*p,P=r[12],A=r[13],E=r[14],O=r[15],t[12]=P*a+A*i+E*M+O*d,t[13]=P*e+A*s+E*h+O*b,t[14]=P*u+A*c+E*l+O*m,t[15]=P*o+A*f+E*v+O*p,t}function o(t,n,r){var a=n[0],e=n[1],u=n[2],o=n[3],i=a+a,s=e+e,c=u+u,f=a*i,M=a*s,h=a*c,l=e*s,v=e*c,d=u*c,b=o*i,m=o*s,p=o*c;return t[0]=1-(l+d),t[1]=M+p,t[2]=h-m,t[3]=0,t[4]=M-p,t[5]=1-(f+d),t[6]=v+b,t[7]=0,t[8]=h+m,t[9]=v-b,t[10]=1-(f+l),t[11]=0,t[12]=r[0],t[13]=r[1],t[14]=r[2],t[15]=1,t}function i(t,n,r){return t[0]=n[0]-r[0],t[1]=n[1]-r[1],t[2]=n[2]-r[2],t[3]=n[3]-r[3],t[4]=n[4]-r[4],t[5]=n[5]-r[5],t[6]=n[6]-r[6],t[7]=n[7]-r[7],t[8]=n[8]-r[8],t[9]=n[9]-r[9],t[10]=n[10]-r[10],t[11]=n[11]-r[11],t[12]=n[12]-r[12],t[13]=n[13]-r[13],t[14]=n[14]-r[14],t[15]=n[15]-r[15],t}n.mul=u,n.sub=i},function(t,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.sub=n.mul=void 0,n.create=function(){var t=new a.ARRAY_TYPE(9);a.ARRAY_TYPE!=Float32Array&&(t[1]=0,t[2]=0,t[3]=0,t[5]=0,t[6]=0,t[7]=0);return t[0]=1,t[4]=1,t[8]=1,t},n.fromMat4=function(t,n){return t[0]=n[0],t[1]=n[1],t[2]=n[2],t[3]=n[4],t[4]=n[5],t[5]=n[6],t[6]=n[8],t[7]=n[9],t[8]=n[10],t},n.clone=function(t){var n=new a.ARRAY_TYPE(9);return n[0]=t[0],n[1]=t[1],n[2]=t[2],n[3]=t[3],n[4]=t[4],n[5]=t[5],n[6]=t[6],n[7]=t[7],n[8]=t[8],n},n.copy=function(t,n){return t[0]=n[0],t[1]=n[1],t[2]=n[2],t[3]=n[3],t[4]=n[4],t[5]=n[5],t[6]=n[6],t[7]=n[7],t[8]=n[8],t},n.fromValues=function(t,n,r,e,u,o,i,s,c){var f=new a.ARRAY_TYPE(9);return f[0]=t,f[1]=n,f[2]=r,f[3]=e,f[4]=u,f[5]=o,f[6]=i,f[7]=s,f[8]=c,f},n.set=function(t,n,r,a,e,u,o,i,s,c){return t[0]=n,t[1]=r,t[2]=a,t[3]=e,t[4]=u,t[5]=o,t[6]=i,t[7]=s,t[8]=c,t},n.identity=function(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=1,t[5]=0,t[6]=0,t[7]=0,t[8]=1,t},n.transpose=function(t,n){if(t===n){var r=n[1],a=n[2],e=n[5];t[1]=n[3],t[2]=n[6],t[3]=r,t[5]=n[7],t[6]=a,t[7]=e}else t[0]=n[0],t[1]=n[3],t[2]=n[6],t[3]=n[1],t[4]=n[4],t[5]=n[7],t[6]=n[2],t[7]=n[5],t[8]=n[8];return t},n.invert=function(t,n){var r=n[0],a=n[1],e=n[2],u=n[3],o=n[4],i=n[5],s=n[6],c=n[7],f=n[8],M=f*o-i*c,h=-f*u+i*s,l=c*u-o*s,v=r*M+a*h+e*l;if(!v)return null;return v=1/v,t[0]=M*v,t[1]=(-f*a+e*c)*v,t[2]=(i*a-e*o)*v,t[3]=h*v,t[4]=(f*r-e*s)*v,t[5]=(-i*r+e*u)*v,t[6]=l*v,t[7]=(-c*r+a*s)*v,t[8]=(o*r-a*u)*v,t},n.adjoint=function(t,n){var r=n[0],a=n[1],e=n[2],u=n[3],o=n[4],i=n[5],s=n[6],c=n[7],f=n[8];return t[0]=o*f-i*c,t[1]=e*c-a*f,t[2]=a*i-e*o,t[3]=i*s-u*f,t[4]=r*f-e*s,t[5]=e*u-r*i,t[6]=u*c-o*s,t[7]=a*s-r*c,t[8]=r*o-a*u,t},n.determinant=function(t){var n=t[0],r=t[1],a=t[2],e=t[3],u=t[4],o=t[5],i=t[6],s=t[7],c=t[8];return n*(c*u-o*s)+r*(-c*e+o*i)+a*(s*e-u*i)},n.multiply=e,n.translate=function(t,n,r){var a=n[0],e=n[1],u=n[2],o=n[3],i=n[4],s=n[5],c=n[6],f=n[7],M=n[8],h=r[0],l=r[1];return t[0]=a,t[1]=e,t[2]=u,t[3]=o,t[4]=i,t[5]=s,t[6]=h*a+l*o+c,t[7]=h*e+l*i+f,t[8]=h*u+l*s+M,t},n.rotate=function(t,n,r){var a=n[0],e=n[1],u=n[2],o=n[3],i=n[4],s=n[5],c=n[6],f=n[7],M=n[8],h=Math.sin(r),l=Math.cos(r);return t[0]=l*a+h*o,t[1]=l*e+h*i,t[2]=l*u+h*s,t[3]=l*o-h*a,t[4]=l*i-h*e,t[5]=l*s-h*u,t[6]=c,t[7]=f,t[8]=M,t},n.scale=function(t,n,r){var a=r[0],e=r[1];return t[0]=a*n[0],t[1]=a*n[1],t[2]=a*n[2],t[3]=e*n[3],t[4]=e*n[4],t[5]=e*n[5],t[6]=n[6],t[7]=n[7],t[8]=n[8],t},n.fromTranslation=function(t,n){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=1,t[5]=0,t[6]=n[0],t[7]=n[1],t[8]=1,t},n.fromRotation=function(t,n){var r=Math.sin(n),a=Math.cos(n);return t[0]=a,t[1]=r,t[2]=0,t[3]=-r,t[4]=a,t[5]=0,t[6]=0,t[7]=0,t[8]=1,t},n.fromScaling=function(t,n){return t[0]=n[0],t[1]=0,t[2]=0,t[3]=0,t[4]=n[1],t[5]=0,t[6]=0,t[7]=0,t[8]=1,t},n.fromMat2d=function(t,n){return t[0]=n[0],t[1]=n[1],t[2]=0,t[3]=n[2],t[4]=n[3],t[5]=0,t[6]=n[4],t[7]=n[5],t[8]=1,t},n.fromQuat=function(t,n){var r=n[0],a=n[1],e=n[2],u=n[3],o=r+r,i=a+a,s=e+e,c=r*o,f=a*o,M=a*i,h=e*o,l=e*i,v=e*s,d=u*o,b=u*i,m=u*s;return t[0]=1-M-v,t[3]=f-m,t[6]=h+b,t[1]=f+m,t[4]=1-c-v,t[7]=l-d,t[2]=h-b,t[5]=l+d,t[8]=1-c-M,t},n.normalFromMat4=function(t,n){var r=n[0],a=n[1],e=n[2],u=n[3],o=n[4],i=n[5],s=n[6],c=n[7],f=n[8],M=n[9],h=n[10],l=n[11],v=n[12],d=n[13],b=n[14],m=n[15],p=r*i-a*o,P=r*s-e*o,A=r*c-u*o,E=a*s-e*i,O=a*c-u*i,R=e*c-u*s,y=f*d-M*v,q=f*b-h*v,x=f*m-l*v,_=M*b-h*d,Y=M*m-l*d,L=h*m-l*b,S=p*L-P*Y+A*_+E*x-O*q+R*y;if(!S)return null;return S=1/S,t[0]=(i*L-s*Y+c*_)*S,t[1]=(s*x-o*L-c*q)*S,t[2]=(o*Y-i*x+c*y)*S,t[3]=(e*Y-a*L-u*_)*S,t[4]=(r*L-e*x+u*q)*S,t[5]=(a*x-r*Y-u*y)*S,t[6]=(d*R-b*O+m*E)*S,t[7]=(b*A-v*R-m*P)*S,t[8]=(v*O-d*A+m*p)*S,t},n.projection=function(t,n,r){return t[0]=2/n,t[1]=0,t[2]=0,t[3]=0,t[4]=-2/r,t[5]=0,t[6]=-1,t[7]=1,t[8]=1,t},n.str=function(t){return"mat3("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+", "+t[4]+", "+t[5]+", "+t[6]+", "+t[7]+", "+t[8]+")"},n.frob=function(t){return Math.sqrt(Math.pow(t[0],2)+Math.pow(t[1],2)+Math.pow(t[2],2)+Math.pow(t[3],2)+Math.pow(t[4],2)+Math.pow(t[5],2)+Math.pow(t[6],2)+Math.pow(t[7],2)+Math.pow(t[8],2))},n.add=function(t,n,r){return t[0]=n[0]+r[0],t[1]=n[1]+r[1],t[2]=n[2]+r[2],t[3]=n[3]+r[3],t[4]=n[4]+r[4],t[5]=n[5]+r[5],t[6]=n[6]+r[6],t[7]=n[7]+r[7],t[8]=n[8]+r[8],t},n.subtract=u,n.multiplyScalar=function(t,n,r){return t[0]=n[0]*r,t[1]=n[1]*r,t[2]=n[2]*r,t[3]=n[3]*r,t[4]=n[4]*r,t[5]=n[5]*r,t[6]=n[6]*r,t[7]=n[7]*r,t[8]=n[8]*r,t},n.multiplyScalarAndAdd=function(t,n,r,a){return t[0]=n[0]+r[0]*a,t[1]=n[1]+r[1]*a,t[2]=n[2]+r[2]*a,t[3]=n[3]+r[3]*a,t[4]=n[4]+r[4]*a,t[5]=n[5]+r[5]*a,t[6]=n[6]+r[6]*a,t[7]=n[7]+r[7]*a,t[8]=n[8]+r[8]*a,t},n.exactEquals=function(t,n){return t[0]===n[0]&&t[1]===n[1]&&t[2]===n[2]&&t[3]===n[3]&&t[4]===n[4]&&t[5]===n[5]&&t[6]===n[6]&&t[7]===n[7]&&t[8]===n[8]},n.equals=function(t,n){var r=t[0],e=t[1],u=t[2],o=t[3],i=t[4],s=t[5],c=t[6],f=t[7],M=t[8],h=n[0],l=n[1],v=n[2],d=n[3],b=n[4],m=n[5],p=n[6],P=n[7],A=n[8];return Math.abs(r-h)<=a.EPSILON*Math.max(1,Math.abs(r),Math.abs(h))&&Math.abs(e-l)<=a.EPSILON*Math.max(1,Math.abs(e),Math.abs(l))&&Math.abs(u-v)<=a.EPSILON*Math.max(1,Math.abs(u),Math.abs(v))&&Math.abs(o-d)<=a.EPSILON*Math.max(1,Math.abs(o),Math.abs(d))&&Math.abs(i-b)<=a.EPSILON*Math.max(1,Math.abs(i),Math.abs(b))&&Math.abs(s-m)<=a.EPSILON*Math.max(1,Math.abs(s),Math.abs(m))&&Math.abs(c-p)<=a.EPSILON*Math.max(1,Math.abs(c),Math.abs(p))&&Math.abs(f-P)<=a.EPSILON*Math.max(1,Math.abs(f),Math.abs(P))&&Math.abs(M-A)<=a.EPSILON*Math.max(1,Math.abs(M),Math.abs(A))};var a=function(t){if(t&&t.__esModule)return t;var n={};if(null!=t)for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(n[r]=t[r]);return n.default=t,n}(r(0));function e(t,n,r){var a=n[0],e=n[1],u=n[2],o=n[3],i=n[4],s=n[5],c=n[6],f=n[7],M=n[8],h=r[0],l=r[1],v=r[2],d=r[3],b=r[4],m=r[5],p=r[6],P=r[7],A=r[8];return t[0]=h*a+l*o+v*c,t[1]=h*e+l*i+v*f,t[2]=h*u+l*s+v*M,t[3]=d*a+b*o+m*c,t[4]=d*e+b*i+m*f,t[5]=d*u+b*s+m*M,t[6]=p*a+P*o+A*c,t[7]=p*e+P*i+A*f,t[8]=p*u+P*s+A*M,t}function u(t,n,r){return t[0]=n[0]-r[0],t[1]=n[1]-r[1],t[2]=n[2]-r[2],t[3]=n[3]-r[3],t[4]=n[4]-r[4],t[5]=n[5]-r[5],t[6]=n[6]-r[6],t[7]=n[7]-r[7],t[8]=n[8]-r[8],t}n.mul=e,n.sub=u},function(t,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.forEach=n.sqrLen=n.sqrDist=n.dist=n.div=n.mul=n.sub=n.len=void 0,n.create=e,n.clone=function(t){var n=new a.ARRAY_TYPE(2);return n[0]=t[0],n[1]=t[1],n},n.fromValues=function(t,n){var r=new a.ARRAY_TYPE(2);return r[0]=t,r[1]=n,r},n.copy=function(t,n){return t[0]=n[0],t[1]=n[1],t},n.set=function(t,n,r){return t[0]=n,t[1]=r,t},n.add=function(t,n,r){return t[0]=n[0]+r[0],t[1]=n[1]+r[1],t},n.subtract=u,n.multiply=o,n.divide=i,n.ceil=function(t,n){return t[0]=Math.ceil(n[0]),t[1]=Math.ceil(n[1]),t},n.floor=function(t,n){return t[0]=Math.floor(n[0]),t[1]=Math.floor(n[1]),t},n.min=function(t,n,r){return t[0]=Math.min(n[0],r[0]),t[1]=Math.min(n[1],r[1]),t},n.max=function(t,n,r){return t[0]=Math.max(n[0],r[0]),t[1]=Math.max(n[1],r[1]),t},n.round=function(t,n){return t[0]=Math.round(n[0]),t[1]=Math.round(n[1]),t},n.scale=function(t,n,r){return t[0]=n[0]*r,t[1]=n[1]*r,t},n.scaleAndAdd=function(t,n,r,a){return t[0]=n[0]+r[0]*a,t[1]=n[1]+r[1]*a,t},n.distance=s,n.squaredDistance=c,n.length=f,n.squaredLength=M,n.negate=function(t,n){return t[0]=-n[0],t[1]=-n[1],t},n.inverse=function(t,n){return t[0]=1/n[0],t[1]=1/n[1],t},n.normalize=function(t,n){var r=n[0],a=n[1],e=r*r+a*a;e>0&&(e=1/Math.sqrt(e),t[0]=n[0]*e,t[1]=n[1]*e);return t},n.dot=function(t,n){return t[0]*n[0]+t[1]*n[1]},n.cross=function(t,n,r){var a=n[0]*r[1]-n[1]*r[0];return t[0]=t[1]=0,t[2]=a,t},n.lerp=function(t,n,r,a){var e=n[0],u=n[1];return t[0]=e+a*(r[0]-e),t[1]=u+a*(r[1]-u),t},n.random=function(t,n){n=n||1;var r=2*a.RANDOM()*Math.PI;return t[0]=Math.cos(r)*n,t[1]=Math.sin(r)*n,t},n.transformMat2=function(t,n,r){var a=n[0],e=n[1];return t[0]=r[0]*a+r[2]*e,t[1]=r[1]*a+r[3]*e,t},n.transformMat2d=function(t,n,r){var a=n[0],e=n[1];return t[0]=r[0]*a+r[2]*e+r[4],t[1]=r[1]*a+r[3]*e+r[5],t},n.transformMat3=function(t,n,r){var a=n[0],e=n[1];return t[0]=r[0]*a+r[3]*e+r[6],t[1]=r[1]*a+r[4]*e+r[7],t},n.transformMat4=function(t,n,r){var a=n[0],e=n[1];return t[0]=r[0]*a+r[4]*e+r[12],t[1]=r[1]*a+r[5]*e+r[13],t},n.rotate=function(t,n,r,a){var e=n[0]-r[0],u=n[1]-r[1],o=Math.sin(a),i=Math.cos(a);return t[0]=e*i-u*o+r[0],t[1]=e*o+u*i+r[1],t},n.angle=function(t,n){var r=t[0],a=t[1],e=n[0],u=n[1],o=r*r+a*a;o>0&&(o=1/Math.sqrt(o));var i=e*e+u*u;i>0&&(i=1/Math.sqrt(i));var s=(r*e+a*u)*o*i;return s>1?0:s<-1?Math.PI:Math.acos(s)},n.str=function(t){return"vec2("+t[0]+", "+t[1]+")"},n.exactEquals=function(t,n){return t[0]===n[0]&&t[1]===n[1]},n.equals=function(t,n){var r=t[0],e=t[1],u=n[0],o=n[1];return Math.abs(r-u)<=a.EPSILON*Math.max(1,Math.abs(r),Math.abs(u))&&Math.abs(e-o)<=a.EPSILON*Math.max(1,Math.abs(e),Math.abs(o))};var a=function(t){if(t&&t.__esModule)return t;var n={};if(null!=t)for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(n[r]=t[r]);return n.default=t,n}(r(0));function e(){var t=new a.ARRAY_TYPE(2);return a.ARRAY_TYPE!=Float32Array&&(t[0]=0,t[1]=0),t}function u(t,n,r){return t[0]=n[0]-r[0],t[1]=n[1]-r[1],t}function o(t,n,r){return t[0]=n[0]*r[0],t[1]=n[1]*r[1],t}function i(t,n,r){return t[0]=n[0]/r[0],t[1]=n[1]/r[1],t}function s(t,n){var r=n[0]-t[0],a=n[1]-t[1];return Math.sqrt(r*r+a*a)}function c(t,n){var r=n[0]-t[0],a=n[1]-t[1];return r*r+a*a}function f(t){var n=t[0],r=t[1];return Math.sqrt(n*n+r*r)}function M(t){var n=t[0],r=t[1];return n*n+r*r}n.len=f,n.sub=u,n.mul=o,n.div=i,n.dist=s,n.sqrDist=c,n.sqrLen=M,n.forEach=function(){var t=e();return function(n,r,a,e,u,o){var i=void 0,s=void 0;for(r||(r=2),a||(a=0),s=e?Math.min(e*r+a,n.length):n.length,i=a;i<s;i+=r)t[0]=n[i],t[1]=n[i+1],u(t,t,o),n[i]=t[0],n[i+1]=t[1];return n}}()},function(t,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.sqrLen=n.squaredLength=n.len=n.length=n.dot=n.mul=n.setReal=n.getReal=void 0,n.create=function(){var t=new a.ARRAY_TYPE(8);a.ARRAY_TYPE!=Float32Array&&(t[0]=0,t[1]=0,t[2]=0,t[4]=0,t[5]=0,t[6]=0,t[7]=0);return t[3]=1,t},n.clone=function(t){var n=new a.ARRAY_TYPE(8);return n[0]=t[0],n[1]=t[1],n[2]=t[2],n[3]=t[3],n[4]=t[4],n[5]=t[5],n[6]=t[6],n[7]=t[7],n},n.fromValues=function(t,n,r,e,u,o,i,s){var c=new a.ARRAY_TYPE(8);return c[0]=t,c[1]=n,c[2]=r,c[3]=e,c[4]=u,c[5]=o,c[6]=i,c[7]=s,c},n.fromRotationTranslationValues=function(t,n,r,e,u,o,i){var s=new a.ARRAY_TYPE(8);s[0]=t,s[1]=n,s[2]=r,s[3]=e;var c=.5*u,f=.5*o,M=.5*i;return s[4]=c*e+f*r-M*n,s[5]=f*e+M*t-c*r,s[6]=M*e+c*n-f*t,s[7]=-c*t-f*n-M*r,s},n.fromRotationTranslation=i,n.fromTranslation=function(t,n){return t[0]=0,t[1]=0,t[2]=0,t[3]=1,t[4]=.5*n[0],t[5]=.5*n[1],t[6]=.5*n[2],t[7]=0,t},n.fromRotation=function(t,n){return t[0]=n[0],t[1]=n[1],t[2]=n[2],t[3]=n[3],t[4]=0,t[5]=0,t[6]=0,t[7]=0,t},n.fromMat4=function(t,n){var r=e.create();u.getRotation(r,n);var o=new a.ARRAY_TYPE(3);return u.getTranslation(o,n),i(t,r,o),t},n.copy=s,n.identity=function(t){return t[0]=0,t[1]=0,t[2]=0,t[3]=1,t[4]=0,t[5]=0,t[6]=0,t[7]=0,t},n.set=function(t,n,r,a,e,u,o,i,s){return t[0]=n,t[1]=r,t[2]=a,t[3]=e,t[4]=u,t[5]=o,t[6]=i,t[7]=s,t},n.getDual=function(t,n){return t[0]=n[4],t[1]=n[5],t[2]=n[6],t[3]=n[7],t},n.setDual=function(t,n){return t[4]=n[0],t[5]=n[1],t[6]=n[2],t[7]=n[3],t},n.getTranslation=function(t,n){var r=n[4],a=n[5],e=n[6],u=n[7],o=-n[0],i=-n[1],s=-n[2],c=n[3];return t[0]=2*(r*c+u*o+a*s-e*i),t[1]=2*(a*c+u*i+e*o-r*s),t[2]=2*(e*c+u*s+r*i-a*o),t},n.translate=function(t,n,r){var a=n[0],e=n[1],u=n[2],o=n[3],i=.5*r[0],s=.5*r[1],c=.5*r[2],f=n[4],M=n[5],h=n[6],l=n[7];return t[0]=a,t[1]=e,t[2]=u,t[3]=o,t[4]=o*i+e*c-u*s+f,t[5]=o*s+u*i-a*c+M,t[6]=o*c+a*s-e*i+h,t[7]=-a*i-e*s-u*c+l,t},n.rotateX=function(t,n,r){var a=-n[0],u=-n[1],o=-n[2],i=n[3],s=n[4],c=n[5],f=n[6],M=n[7],h=s*i+M*a+c*o-f*u,l=c*i+M*u+f*a-s*o,v=f*i+M*o+s*u-c*a,d=M*i-s*a-c*u-f*o;return e.rotateX(t,n,r),a=t[0],u=t[1],o=t[2],i=t[3],t[4]=h*i+d*a+l*o-v*u,t[5]=l*i+d*u+v*a-h*o,t[6]=v*i+d*o+h*u-l*a,t[7]=d*i-h*a-l*u-v*o,t},n.rotateY=function(t,n,r){var a=-n[0],u=-n[1],o=-n[2],i=n[3],s=n[4],c=n[5],f=n[6],M=n[7],h=s*i+M*a+c*o-f*u,l=c*i+M*u+f*a-s*o,v=f*i+M*o+s*u-c*a,d=M*i-s*a-c*u-f*o;return e.rotateY(t,n,r),a=t[0],u=t[1],o=t[2],i=t[3],t[4]=h*i+d*a+l*o-v*u,t[5]=l*i+d*u+v*a-h*o,t[6]=v*i+d*o+h*u-l*a,t[7]=d*i-h*a-l*u-v*o,t},n.rotateZ=function(t,n,r){var a=-n[0],u=-n[1],o=-n[2],i=n[3],s=n[4],c=n[5],f=n[6],M=n[7],h=s*i+M*a+c*o-f*u,l=c*i+M*u+f*a-s*o,v=f*i+M*o+s*u-c*a,d=M*i-s*a-c*u-f*o;return e.rotateZ(t,n,r),a=t[0],u=t[1],o=t[2],i=t[3],t[4]=h*i+d*a+l*o-v*u,t[5]=l*i+d*u+v*a-h*o,t[6]=v*i+d*o+h*u-l*a,t[7]=d*i-h*a-l*u-v*o,t},n.rotateByQuatAppend=function(t,n,r){var a=r[0],e=r[1],u=r[2],o=r[3],i=n[0],s=n[1],c=n[2],f=n[3];return t[0]=i*o+f*a+s*u-c*e,t[1]=s*o+f*e+c*a-i*u,t[2]=c*o+f*u+i*e-s*a,t[3]=f*o-i*a-s*e-c*u,i=n[4],s=n[5],c=n[6],f=n[7],t[4]=i*o+f*a+s*u-c*e,t[5]=s*o+f*e+c*a-i*u,t[6]=c*o+f*u+i*e-s*a,t[7]=f*o-i*a-s*e-c*u,t},n.rotateByQuatPrepend=function(t,n,r){var a=n[0],e=n[1],u=n[2],o=n[3],i=r[0],s=r[1],c=r[2],f=r[3];return t[0]=a*f+o*i+e*c-u*s,t[1]=e*f+o*s+u*i-a*c,t[2]=u*f+o*c+a*s-e*i,t[3]=o*f-a*i-e*s-u*c,i=r[4],s=r[5],c=r[6],f=r[7],t[4]=a*f+o*i+e*c-u*s,t[5]=e*f+o*s+u*i-a*c,t[6]=u*f+o*c+a*s-e*i,t[7]=o*f-a*i-e*s-u*c,t},n.rotateAroundAxis=function(t,n,r,e){if(Math.abs(e)<a.EPSILON)return s(t,n);var u=Math.sqrt(r[0]*r[0]+r[1]*r[1]+r[2]*r[2]);e*=.5;var o=Math.sin(e),i=o*r[0]/u,c=o*r[1]/u,f=o*r[2]/u,M=Math.cos(e),h=n[0],l=n[1],v=n[2],d=n[3];t[0]=h*M+d*i+l*f-v*c,t[1]=l*M+d*c+v*i-h*f,t[2]=v*M+d*f+h*c-l*i,t[3]=d*M-h*i-l*c-v*f;var b=n[4],m=n[5],p=n[6],P=n[7];return t[4]=b*M+P*i+m*f-p*c,t[5]=m*M+P*c+p*i-b*f,t[6]=p*M+P*f+b*c-m*i,t[7]=P*M-b*i-m*c-p*f,t},n.add=function(t,n,r){return t[0]=n[0]+r[0],t[1]=n[1]+r[1],t[2]=n[2]+r[2],t[3]=n[3]+r[3],t[4]=n[4]+r[4],t[5]=n[5]+r[5],t[6]=n[6]+r[6],t[7]=n[7]+r[7],t},n.multiply=c,n.scale=function(t,n,r){return t[0]=n[0]*r,t[1]=n[1]*r,t[2]=n[2]*r,t[3]=n[3]*r,t[4]=n[4]*r,t[5]=n[5]*r,t[6]=n[6]*r,t[7]=n[7]*r,t},n.lerp=function(t,n,r,a){var e=1-a;f(n,r)<0&&(a=-a);return t[0]=n[0]*e+r[0]*a,t[1]=n[1]*e+r[1]*a,t[2]=n[2]*e+r[2]*a,t[3]=n[3]*e+r[3]*a,t[4]=n[4]*e+r[4]*a,t[5]=n[5]*e+r[5]*a,t[6]=n[6]*e+r[6]*a,t[7]=n[7]*e+r[7]*a,t},n.invert=function(t,n){var r=h(n);return t[0]=-n[0]/r,t[1]=-n[1]/r,t[2]=-n[2]/r,t[3]=n[3]/r,t[4]=-n[4]/r,t[5]=-n[5]/r,t[6]=-n[6]/r,t[7]=n[7]/r,t},n.conjugate=function(t,n){return t[0]=-n[0],t[1]=-n[1],t[2]=-n[2],t[3]=n[3],t[4]=-n[4],t[5]=-n[5],t[6]=-n[6],t[7]=n[7],t},n.normalize=function(t,n){var r=h(n);if(r>0){r=Math.sqrt(r);var a=n[0]/r,e=n[1]/r,u=n[2]/r,o=n[3]/r,i=n[4],s=n[5],c=n[6],f=n[7],M=a*i+e*s+u*c+o*f;t[0]=a,t[1]=e,t[2]=u,t[3]=o,t[4]=(i-a*M)/r,t[5]=(s-e*M)/r,t[6]=(c-u*M)/r,t[7]=(f-o*M)/r}return t},n.str=function(t){return"quat2("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+", "+t[4]+", "+t[5]+", "+t[6]+", "+t[7]+")"},n.exactEquals=function(t,n){return t[0]===n[0]&&t[1]===n[1]&&t[2]===n[2]&&t[3]===n[3]&&t[4]===n[4]&&t[5]===n[5]&&t[6]===n[6]&&t[7]===n[7]},n.equals=function(t,n){var r=t[0],e=t[1],u=t[2],o=t[3],i=t[4],s=t[5],c=t[6],f=t[7],M=n[0],h=n[1],l=n[2],v=n[3],d=n[4],b=n[5],m=n[6],p=n[7];return Math.abs(r-M)<=a.EPSILON*Math.max(1,Math.abs(r),Math.abs(M))&&Math.abs(e-h)<=a.EPSILON*Math.max(1,Math.abs(e),Math.abs(h))&&Math.abs(u-l)<=a.EPSILON*Math.max(1,Math.abs(u),Math.abs(l))&&Math.abs(o-v)<=a.EPSILON*Math.max(1,Math.abs(o),Math.abs(v))&&Math.abs(i-d)<=a.EPSILON*Math.max(1,Math.abs(i),Math.abs(d))&&Math.abs(s-b)<=a.EPSILON*Math.max(1,Math.abs(s),Math.abs(b))&&Math.abs(c-m)<=a.EPSILON*Math.max(1,Math.abs(c),Math.abs(m))&&Math.abs(f-p)<=a.EPSILON*Math.max(1,Math.abs(f),Math.abs(p))};var a=o(r(0)),e=o(r(3)),u=o(r(4));function o(t){if(t&&t.__esModule)return t;var n={};if(null!=t)for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(n[r]=t[r]);return n.default=t,n}function i(t,n,r){var a=.5*r[0],e=.5*r[1],u=.5*r[2],o=n[0],i=n[1],s=n[2],c=n[3];return t[0]=o,t[1]=i,t[2]=s,t[3]=c,t[4]=a*c+e*s-u*i,t[5]=e*c+u*o-a*s,t[6]=u*c+a*i-e*o,t[7]=-a*o-e*i-u*s,t}function s(t,n){return t[0]=n[0],t[1]=n[1],t[2]=n[2],t[3]=n[3],t[4]=n[4],t[5]=n[5],t[6]=n[6],t[7]=n[7],t}n.getReal=e.copy;n.setReal=e.copy;function c(t,n,r){var a=n[0],e=n[1],u=n[2],o=n[3],i=r[4],s=r[5],c=r[6],f=r[7],M=n[4],h=n[5],l=n[6],v=n[7],d=r[0],b=r[1],m=r[2],p=r[3];return t[0]=a*p+o*d+e*m-u*b,t[1]=e*p+o*b+u*d-a*m,t[2]=u*p+o*m+a*b-e*d,t[3]=o*p-a*d-e*b-u*m,t[4]=a*f+o*i+e*c-u*s+M*p+v*d+h*m-l*b,t[5]=e*f+o*s+u*i-a*c+h*p+v*b+l*d-M*m,t[6]=u*f+o*c+a*s-e*i+l*p+v*m+M*b-h*d,t[7]=o*f-a*i-e*s-u*c+v*p-M*d-h*b-l*m,t}n.mul=c;var f=n.dot=e.dot;var M=n.length=e.length,h=(n.len=M,n.squaredLength=e.squaredLength);n.sqrLen=h},function(t,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.sub=n.mul=void 0,n.create=function(){var t=new a.ARRAY_TYPE(6);a.ARRAY_TYPE!=Float32Array&&(t[1]=0,t[2]=0,t[4]=0,t[5]=0);return t[0]=1,t[3]=1,t},n.clone=function(t){var n=new a.ARRAY_TYPE(6);return n[0]=t[0],n[1]=t[1],n[2]=t[2],n[3]=t[3],n[4]=t[4],n[5]=t[5],n},n.copy=function(t,n){return t[0]=n[0],t[1]=n[1],t[2]=n[2],t[3]=n[3],t[4]=n[4],t[5]=n[5],t},n.identity=function(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=1,t[4]=0,t[5]=0,t},n.fromValues=function(t,n,r,e,u,o){var i=new a.ARRAY_TYPE(6);return i[0]=t,i[1]=n,i[2]=r,i[3]=e,i[4]=u,i[5]=o,i},n.set=function(t,n,r,a,e,u,o){return t[0]=n,t[1]=r,t[2]=a,t[3]=e,t[4]=u,t[5]=o,t},n.invert=function(t,n){var r=n[0],a=n[1],e=n[2],u=n[3],o=n[4],i=n[5],s=r*u-a*e;if(!s)return null;return s=1/s,t[0]=u*s,t[1]=-a*s,t[2]=-e*s,t[3]=r*s,t[4]=(e*i-u*o)*s,t[5]=(a*o-r*i)*s,t},n.determinant=function(t){return t[0]*t[3]-t[1]*t[2]},n.multiply=e,n.rotate=function(t,n,r){var a=n[0],e=n[1],u=n[2],o=n[3],i=n[4],s=n[5],c=Math.sin(r),f=Math.cos(r);return t[0]=a*f+u*c,t[1]=e*f+o*c,t[2]=a*-c+u*f,t[3]=e*-c+o*f,t[4]=i,t[5]=s,t},n.scale=function(t,n,r){var a=n[0],e=n[1],u=n[2],o=n[3],i=n[4],s=n[5],c=r[0],f=r[1];return t[0]=a*c,t[1]=e*c,t[2]=u*f,t[3]=o*f,t[4]=i,t[5]=s,t},n.translate=function(t,n,r){var a=n[0],e=n[1],u=n[2],o=n[3],i=n[4],s=n[5],c=r[0],f=r[1];return t[0]=a,t[1]=e,t[2]=u,t[3]=o,t[4]=a*c+u*f+i,t[5]=e*c+o*f+s,t},n.fromRotation=function(t,n){var r=Math.sin(n),a=Math.cos(n);return t[0]=a,t[1]=r,t[2]=-r,t[3]=a,t[4]=0,t[5]=0,t},n.fromScaling=function(t,n){return t[0]=n[0],t[1]=0,t[2]=0,t[3]=n[1],t[4]=0,t[5]=0,t},n.fromTranslation=function(t,n){return t[0]=1,t[1]=0,t[2]=0,t[3]=1,t[4]=n[0],t[5]=n[1],t},n.str=function(t){return"mat2d("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+", "+t[4]+", "+t[5]+")"},n.frob=function(t){return Math.sqrt(Math.pow(t[0],2)+Math.pow(t[1],2)+Math.pow(t[2],2)+Math.pow(t[3],2)+Math.pow(t[4],2)+Math.pow(t[5],2)+1)},n.add=function(t,n,r){return t[0]=n[0]+r[0],t[1]=n[1]+r[1],t[2]=n[2]+r[2],t[3]=n[3]+r[3],t[4]=n[4]+r[4],t[5]=n[5]+r[5],t},n.subtract=u,n.multiplyScalar=function(t,n,r){return t[0]=n[0]*r,t[1]=n[1]*r,t[2]=n[2]*r,t[3]=n[3]*r,t[4]=n[4]*r,t[5]=n[5]*r,t},n.multiplyScalarAndAdd=function(t,n,r,a){return t[0]=n[0]+r[0]*a,t[1]=n[1]+r[1]*a,t[2]=n[2]+r[2]*a,t[3]=n[3]+r[3]*a,t[4]=n[4]+r[4]*a,t[5]=n[5]+r[5]*a,t},n.exactEquals=function(t,n){return t[0]===n[0]&&t[1]===n[1]&&t[2]===n[2]&&t[3]===n[3]&&t[4]===n[4]&&t[5]===n[5]},n.equals=function(t,n){var r=t[0],e=t[1],u=t[2],o=t[3],i=t[4],s=t[5],c=n[0],f=n[1],M=n[2],h=n[3],l=n[4],v=n[5];return Math.abs(r-c)<=a.EPSILON*Math.max(1,Math.abs(r),Math.abs(c))&&Math.abs(e-f)<=a.EPSILON*Math.max(1,Math.abs(e),Math.abs(f))&&Math.abs(u-M)<=a.EPSILON*Math.max(1,Math.abs(u),Math.abs(M))&&Math.abs(o-h)<=a.EPSILON*Math.max(1,Math.abs(o),Math.abs(h))&&Math.abs(i-l)<=a.EPSILON*Math.max(1,Math.abs(i),Math.abs(l))&&Math.abs(s-v)<=a.EPSILON*Math.max(1,Math.abs(s),Math.abs(v))};var a=function(t){if(t&&t.__esModule)return t;var n={};if(null!=t)for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(n[r]=t[r]);return n.default=t,n}(r(0));function e(t,n,r){var a=n[0],e=n[1],u=n[2],o=n[3],i=n[4],s=n[5],c=r[0],f=r[1],M=r[2],h=r[3],l=r[4],v=r[5];return t[0]=a*c+u*f,t[1]=e*c+o*f,t[2]=a*M+u*h,t[3]=e*M+o*h,t[4]=a*l+u*v+i,t[5]=e*l+o*v+s,t}function u(t,n,r){return t[0]=n[0]-r[0],t[1]=n[1]-r[1],t[2]=n[2]-r[2],t[3]=n[3]-r[3],t[4]=n[4]-r[4],t[5]=n[5]-r[5],t}n.mul=e,n.sub=u},function(t,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.sub=n.mul=void 0,n.create=function(){var t=new a.ARRAY_TYPE(4);a.ARRAY_TYPE!=Float32Array&&(t[1]=0,t[2]=0);return t[0]=1,t[3]=1,t},n.clone=function(t){var n=new a.ARRAY_TYPE(4);return n[0]=t[0],n[1]=t[1],n[2]=t[2],n[3]=t[3],n},n.copy=function(t,n){return t[0]=n[0],t[1]=n[1],t[2]=n[2],t[3]=n[3],t},n.identity=function(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=1,t},n.fromValues=function(t,n,r,e){var u=new a.ARRAY_TYPE(4);return u[0]=t,u[1]=n,u[2]=r,u[3]=e,u},n.set=function(t,n,r,a,e){return t[0]=n,t[1]=r,t[2]=a,t[3]=e,t},n.transpose=function(t,n){if(t===n){var r=n[1];t[1]=n[2],t[2]=r}else t[0]=n[0],t[1]=n[2],t[2]=n[1],t[3]=n[3];return t},n.invert=function(t,n){var r=n[0],a=n[1],e=n[2],u=n[3],o=r*u-e*a;if(!o)return null;return o=1/o,t[0]=u*o,t[1]=-a*o,t[2]=-e*o,t[3]=r*o,t},n.adjoint=function(t,n){var r=n[0];return t[0]=n[3],t[1]=-n[1],t[2]=-n[2],t[3]=r,t},n.determinant=function(t){return t[0]*t[3]-t[2]*t[1]},n.multiply=e,n.rotate=function(t,n,r){var a=n[0],e=n[1],u=n[2],o=n[3],i=Math.sin(r),s=Math.cos(r);return t[0]=a*s+u*i,t[1]=e*s+o*i,t[2]=a*-i+u*s,t[3]=e*-i+o*s,t},n.scale=function(t,n,r){var a=n[0],e=n[1],u=n[2],o=n[3],i=r[0],s=r[1];return t[0]=a*i,t[1]=e*i,t[2]=u*s,t[3]=o*s,t},n.fromRotation=function(t,n){var r=Math.sin(n),a=Math.cos(n);return t[0]=a,t[1]=r,t[2]=-r,t[3]=a,t},n.fromScaling=function(t,n){return t[0]=n[0],t[1]=0,t[2]=0,t[3]=n[1],t},n.str=function(t){return"mat2("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+")"},n.frob=function(t){return Math.sqrt(Math.pow(t[0],2)+Math.pow(t[1],2)+Math.pow(t[2],2)+Math.pow(t[3],2))},n.LDU=function(t,n,r,a){return t[2]=a[2]/a[0],r[0]=a[0],r[1]=a[1],r[3]=a[3]-t[2]*r[1],[t,n,r]},n.add=function(t,n,r){return t[0]=n[0]+r[0],t[1]=n[1]+r[1],t[2]=n[2]+r[2],t[3]=n[3]+r[3],t},n.subtract=u,n.exactEquals=function(t,n){return t[0]===n[0]&&t[1]===n[1]&&t[2]===n[2]&&t[3]===n[3]},n.equals=function(t,n){var r=t[0],e=t[1],u=t[2],o=t[3],i=n[0],s=n[1],c=n[2],f=n[3];return Math.abs(r-i)<=a.EPSILON*Math.max(1,Math.abs(r),Math.abs(i))&&Math.abs(e-s)<=a.EPSILON*Math.max(1,Math.abs(e),Math.abs(s))&&Math.abs(u-c)<=a.EPSILON*Math.max(1,Math.abs(u),Math.abs(c))&&Math.abs(o-f)<=a.EPSILON*Math.max(1,Math.abs(o),Math.abs(f))},n.multiplyScalar=function(t,n,r){return t[0]=n[0]*r,t[1]=n[1]*r,t[2]=n[2]*r,t[3]=n[3]*r,t},n.multiplyScalarAndAdd=function(t,n,r,a){return t[0]=n[0]+r[0]*a,t[1]=n[1]+r[1]*a,t[2]=n[2]+r[2]*a,t[3]=n[3]+r[3]*a,t};var a=function(t){if(t&&t.__esModule)return t;var n={};if(null!=t)for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(n[r]=t[r]);return n.default=t,n}(r(0));function e(t,n,r){var a=n[0],e=n[1],u=n[2],o=n[3],i=r[0],s=r[1],c=r[2],f=r[3];return t[0]=a*i+u*s,t[1]=e*i+o*s,t[2]=a*c+u*f,t[3]=e*c+o*f,t}function u(t,n,r){return t[0]=n[0]-r[0],t[1]=n[1]-r[1],t[2]=n[2]-r[2],t[3]=n[3]-r[3],t}n.mul=e,n.sub=u},function(t,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.vec4=n.vec3=n.vec2=n.quat2=n.quat=n.mat4=n.mat3=n.mat2d=n.mat2=n.glMatrix=void 0;var a=l(r(0)),e=l(r(9)),u=l(r(8)),o=l(r(5)),i=l(r(4)),s=l(r(3)),c=l(r(7)),f=l(r(6)),M=l(r(2)),h=l(r(1));function l(t){if(t&&t.__esModule)return t;var n={};if(null!=t)for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(n[r]=t[r]);return n.default=t,n}n.glMatrix=a,n.mat2=e,n.mat2d=u,n.mat3=o,n.mat4=i,n.quat=s,n.quat2=c,n.vec2=f,n.vec3=M,n.vec4=h}])});'use strict';(function(t){function V(){return Array.prototype.slice.call(this)}function R(h,e){if(h.constructor===e)return h;if(h.constructor!==Array)return e=e||Float32Array,new e(h);e=e||Float32Array;for(var a=h[0].length,b=new e(h.length*a),c=0;c<h.length;++c)for(var d=0;d<a;++d)b[c*a+d]=h[c][d];return b}function K(h,e,a,b,c){h=h||1024;g.debug&&console.log("GL.Mesh created");null!==c&&(this.gl=c=c||t.gl);this._context_id=c.context_id;this.vertexBuffers={};this.indexBuffers={};this.info={groups:[]};
this._bounding=BBox.create();this.resize(h)}function B(h,e,a,b){this.gl=b=b||t.gl;this._context_id=b.context_id;if(h&&h.constructor!==Array)throw"FBO textures must be an Array";this.handler=null;this.height=this.width=-1;this.color_textures=[];this.depth_texture=null;this.stencil=!!a;this._stencil_enabled=!1;this._num_binded_textures=0;this.order=null;(h&&h.length||e)&&this.setTextures(h,e);this._old_fbo_handler=null;this._old_viewport=new Float32Array(4)}var g=t.GL={};if("undefined"==typeof glMatrix)throw"litegl.js requires gl-matrix to work. It must be included before litegl.";
if(!t.vec2)throw"litegl.js does not support gl-matrix 3.0, download 2.8 https://github.com/toji/gl-matrix/releases/tag/v2.8.1";t.requestAnimationFrame=t.requestAnimationFrame||t.mozRequestAnimationFrame||t.webkitRequestAnimationFrame||function(h){setTimeout(h,1E3/60)};g.blockable_keys={Up:!0,Down:!0,Left:!0,Right:!0};g.reverse=null;g.LEFT_MOUSE_BUTTON=0;g.MIDDLE_MOUSE_BUTTON=1;g.RIGHT_MOUSE_BUTTON=2;g.LEFT_MOUSE_BUTTON_MASK=1;g.RIGHT_MOUSE_BUTTON_MASK=2;g.MIDDLE_MOUSE_BUTTON_MASK=4;g.last_context_id=
0;g.COLOR_BUFFER_BIT=16384;g.DEPTH_BUFFER_BIT=256;g.STENCIL_BUFFER_BIT=1024;g.TEXTURE_2D=3553;g.TEXTURE_CUBE_MAP=34067;g.TEXTURE_3D=32879;g.TEXTURE_MAG_FILTER=10240;g.TEXTURE_MIN_FILTER=10241;g.TEXTURE_WRAP_S=10242;g.TEXTURE_WRAP_T=10243;g.BYTE=5120;g.UNSIGNED_BYTE=5121;g.SHORT=5122;g.UNSIGNED_SHORT=5123;g.INT=5124;g.UNSIGNED_INT=5125;g.FLOAT=5126;g.HALF_FLOAT_OES=36193;g.HALF_FLOAT=5131;g.DEPTH_COMPONENT16=33189;g.DEPTH_COMPONENT24=33190;g.DEPTH_COMPONENT32F=36012;g.FLOAT_VEC2=35664;g.FLOAT_VEC3=
35665;g.FLOAT_VEC4=35666;g.INT_VEC2=35667;g.INT_VEC3=35668;g.INT_VEC4=35669;g.BOOL=35670;g.BOOL_VEC2=35671;g.BOOL_VEC3=35672;g.BOOL_VEC4=35673;g.FLOAT_MAT2=35674;g.FLOAT_MAT3=35675;g.FLOAT_MAT4=35676;g.TYPE_LENGTH={};g.TYPE_LENGTH[g.FLOAT]=g.TYPE_LENGTH[g.INT]=g.TYPE_LENGTH[g.BYTE]=g.TYPE_LENGTH[g.BOOL]=1;g.TYPE_LENGTH[g.FLOAT_VEC2]=g.TYPE_LENGTH[g.INT_VEC2]=g.TYPE_LENGTH[g.BOOL_VEC2]=2;g.TYPE_LENGTH[g.FLOAT_VEC3]=g.TYPE_LENGTH[g.INT_VEC3]=g.TYPE_LENGTH[g.BOOL_VEC3]=3;g.TYPE_LENGTH[g.FLOAT_VEC4]=
g.TYPE_LENGTH[g.INT_VEC4]=g.TYPE_LENGTH[g.BOOL_VEC4]=4;g.TYPE_LENGTH[g.FLOAT_MAT3]=9;g.TYPE_LENGTH[g.FLOAT_MAT4]=16;g.SAMPLER_2D=35678;g.SAMPLER_3D=35679;g.SAMPLER_CUBE=35680;g.INT_SAMPLER_2D=36298;g.INT_SAMPLER_3D=36299;g.INT_SAMPLER_CUBE=36300;g.UNSIGNED_INT_SAMPLER_2D=36306;g.UNSIGNED_INT_SAMPLER_3D=36307;g.UNSIGNED_INT_SAMPLER_CUBE=36308;g.DEPTH_COMPONENT=6402;g.ALPHA=6406;g.RGB=6407;g.RGBA=6408;g.LUMINANCE=6409;g.LUMINANCE_ALPHA=6410;g.DEPTH_STENCIL=34041;g.UNSIGNED_INT_24_8_WEBGL=34042;g.R8=
33321;g.R16F=33325;g.R32F=33326;g.R8UI=33330;g.RG8=33323;g.RG16F=33327;g.RG32F=33328;g.RGB8=32849;g.SRGB8=35905;g.RGB565=36194;g.R11F_G11F_B10F=35898;g.RGB9_E5=35901;g.RGB16F=34843;g.RGB32F=34837;g.RGB8UI=36221;g.RGBA8=32856;g.RGB5_A1=32855;g.RGBA16F=34842;g.RGBA32F=34836;g.RGBA8UI=36220;g.RGBA16I=36232;g.RGBA16UI=36214;g.RGBA32I=36226;g.RGBA32UI=36208;g.NEAREST=9728;g.LINEAR=9729;g.NEAREST_MIPMAP_NEAREST=9984;g.LINEAR_MIPMAP_NEAREST=9985;g.NEAREST_MIPMAP_LINEAR=9986;g.LINEAR_MIPMAP_LINEAR=9987;g.REPEAT=
10497;g.CLAMP_TO_EDGE=33071;g.MIRRORED_REPEAT=33648;g.ZERO=0;g.ONE=1;g.SRC_COLOR=768;g.ONE_MINUS_SRC_COLOR=769;g.SRC_ALPHA=770;g.ONE_MINUS_SRC_ALPHA=771;g.DST_ALPHA=772;g.ONE_MINUS_DST_ALPHA=773;g.DST_COLOR=774;g.ONE_MINUS_DST_COLOR=775;g.SRC_ALPHA_SATURATE=776;g.CONSTANT_COLOR=32769;g.ONE_MINUS_CONSTANT_COLOR=32770;g.CONSTANT_ALPHA=32771;g.ONE_MINUS_CONSTANT_ALPHA=32772;g.VERTEX_SHADER=35633;g.FRAGMENT_SHADER=35632;g.FRONT=1028;g.BACK=1029;g.FRONT_AND_BACK=1032;g.NEVER=512;g.LESS=513;g.EQUAL=514;
g.LEQUAL=515;g.GREATER=516;g.NOTEQUAL=517;g.GEQUAL=518;g.ALWAYS=519;g.KEEP=7680;g.REPLACE=7681;g.INCR=7682;g.DECR=7683;g.INCR_WRAP=34055;g.DECR_WRAP=34056;g.INVERT=5386;g.STREAM_DRAW=35040;g.STATIC_DRAW=35044;g.DYNAMIC_DRAW=35048;g.ARRAY_BUFFER=34962;g.ELEMENT_ARRAY_BUFFER=34963;g.POINTS=0;g.LINES=1;g.LINE_LOOP=2;g.LINE_STRIP=3;g.TRIANGLES=4;g.TRIANGLE_STRIP=5;g.TRIANGLE_FAN=6;g.CW=2304;g.CCW=2305;g.CULL_FACE=2884;g.DEPTH_TEST=2929;g.BLEND=3042;g.temp_vec3=vec3.create();g.temp2_vec3=vec3.create();
g.temp_vec4=vec4.create();g.temp_quat=quat.create();g.temp_mat3=mat3.create();g.temp_mat4=mat4.create();t.DEG2RAD=0.0174532925;t.RAD2DEG=57.295779578552306;t.EPSILON=1E-6;t.isPowerOfTwo=g.isPowerOfTwo=function(h){return 0==Math.log(h)/Math.log(2)%1};t.nearestPowerOfTwo=g.nearestPowerOfTwo=function(h){return Math.pow(2,Math.round(Math.log(h)/Math.log(2)))};t.polarToCartesian=function(h,e,a,b){h=h||vec3.create();h[0]=b*Math.sin(a)*Math.cos(e);h[1]=b*Math.cos(a);h[2]=b*Math.sin(a)*Math.sin(e);return h};
t.cartesianToPolar=function(h,e,a,b){h=h||vec3.create();h[2]=Math.sqrt(e*e+a*a+b*b);h[0]=Math.atan2(e,b);h[1]=Math.acos(b/h[2]);return h};[Uint8Array,Int8Array,Uint16Array,Int16Array,Uint32Array,Int32Array,Float32Array,Float64Array].forEach(function(h){h.prototype.toJSON||Object.defineProperty(h.prototype,"toJSON",{value:V,enumerable:!1,configurable:!0,writable:!0})});t.getTime="undefined"!=typeof performance?performance.now.bind(performance):Date.now.bind(Date);g.getTime=t.getTime;t.isFunction=function(h){return!!(h&&
h.constructor&&h.call&&h.apply)};t.isArray=function(h){return h&&h.constructor===Array};t.isNumber=function(h){return null!=h&&h.constructor===Number};t.getClassName=function(h){if(h){if(h.name)return h.name;if(h.toString&&(h=h.toString().match(/function\s*(\w+)/))&&2==h.length)return h[1]}};t.cloneObject=g.cloneObject=function(h,e){if(h.constructor!==Object)throw"cloneObject only can clone pure javascript objects, not classes";e=e||{};for(var a in h){var b=h[a];if(null===b)e[a]=null;else switch(b.constructor){case Int8Array:case Uint8Array:case Int16Array:case Uint16Array:case Int32Array:case Uint32Array:case Float32Array:case Float64Array:e[a]=
new b.constructor(b);break;case Boolean:case Number:case String:e[a]=b;break;case Array:e[a]=b.concat();break;case Object:e[a]=g.cloneObject(b)}}return e};t.regexMap=function(h,e,a){for(var b;null!=(b=h.exec(e));)a(b)};t.createCanvas=g.createCanvas=function(h,e){var a=document.createElement("canvas");a.width=h;a.height=e;return a};t.cloneCanvas=g.cloneCanvas=function(h){var e=document.createElement("canvas");e.width=h.width;e.height=h.height;e.getContext("2d").drawImage(h,0,0);return e};"undefined"!=
typeof Image&&(Image.prototype.getPixels=function(){var h=document.createElement("canvas");h.width=this.width;h.height=this.height;h=h.getContext("2d");h.drawImage(this,0,0);return h.getImageData(0,0,this.width,this.height).data});String.prototype.hasOwnProperty("replaceAll")||Object.defineProperty(String.prototype,"replaceAll",{value:function(h){var e=this,a;for(a in h)e=e.split(a).join(h[a]);return e},enumerable:!1});String.prototype.hasOwnProperty("hashCode")||Object.defineProperty(String.prototype,
"hashCode",{value:function(){var h=0,e,a,b;if(0==this.length)return h;e=0;for(b=this.length;e<b;++e)a=this.charCodeAt(e),h=(h<<5)-h+a,h|=0;return h},enumerable:!1});Array.prototype.hasOwnProperty("clone")||Object.defineProperty(Array.prototype,"clone",{value:Array.prototype.concat,enumerable:!1});Float32Array.prototype.hasOwnProperty("clone")||Object.defineProperty(Float32Array.prototype,"clone",{value:function(){return new Float32Array(this)},enumerable:!1});t.wipeObject=function(h){for(var e in h)h.hasOwnProperty(e)&&
delete h[e]};t.extendClass=g.extendClass=function(h,e){for(var a in e)h.hasOwnProperty(a)||(h[a]=e[a]);if(e.prototype){var b=Object.getOwnPropertyNames(e.prototype);for(a=0;a<b.length;++a){var c=b[a];h.prototype.hasOwnProperty(c)||(e.prototype.__lookupGetter__(c)?h.prototype.__defineGetter__(c,e.prototype.__lookupGetter__(c)):h.prototype[c]=e.prototype[c],e.prototype.__lookupSetter__(c)&&h.prototype.__defineSetter__(c,e.prototype.__lookupSetter__(c)))}}h.hasOwnProperty("superclass")||Object.defineProperty(h,
"superclass",{get:function(){return e},enumerable:!1})};t.HttpRequest=g.request=function(h,e,a,b,c){var d=!0;c=c||{};void 0!==c.async&&(d=c.async);if(e){var f=null,f=[],k;for(k in e)f.push(k+"="+e[k]);f=f.join("&");h=h+"?"+f}var g=new XMLHttpRequest;g.open("GET",h,d);g.responseType=c.responseType||"text";g.onload=function(c){this.getResponseHeader("Content-Type");200!=this.status?(y.trigger(g,"fail",this.status),b&&b(this.status)):(y.trigger(g,"done",this.response),a&&a(this.response))};g.onerror=
function(a){y.trigger(g,"fail",a)};if(c){for(k in c)g[k]=c[k];c.binary&&(g.responseType="arraybuffer")}g.send();return g};t.XMLHttpRequest&&(XMLHttpRequest.prototype.hasOwnProperty("done")||Object.defineProperty(XMLHttpRequest.prototype,"done",{enumerable:!1,value:function(h){y.bind(this,"done",function(e,a){h(a)});return this}}),XMLHttpRequest.prototype.hasOwnProperty("fail")||Object.defineProperty(XMLHttpRequest.prototype,"fail",{enumerable:!1,value:function(h){y.bind(this,"fail",function(e,a){h(a)});
return this}}));t.getFileExtension=function(h){var e=h.indexOf("?");-1!=e&&(h=h.substr(0,e));e=h.lastIndexOf(".");return-1==e?"":h.substr(e+1).toLowerCase()};t.loadFileAtlas=g.loadFileAtlas=function(h,e,a){var b=null;HttpRequest(h,null,function(a){a=g.processFileAtlas(a);e&&e(a);b&&b(a)},alert,a);return{done:function(a){b=a}}};t.processFileAtlas=g.processFileAtlas=function(h,e){for(var a=h.split("\n"),b={},c=[],d="",f=0,k=a.length;f<k;f++){var g=e?a[f]:a[f].trim();g.length&&("\\"!=g[0]?c.push(g):
(c.length&&(b[d]=c.join("\n")),c.length=0,d=g.substr(1)))}c.length&&(b[d]=c.join("\n"));return b};t.typedArrayToArray=function(h){var e=[];e.length=h.length;for(var a=0;a<h.length;a++)e[a]=h[a];return e};t.RGBToHex=function(h,e,a){h=Math.min(255,255*h)|0;e=Math.min(255,255*e)|0;a=Math.min(255,255*a)|0;return"#"+(16777216+(h<<16)+(e<<8)+a).toString(16).slice(1)};t.HUEToRGB=function(h,e,a){0>a&&(a+=1);1<a&&(a-=1);return a<1/6?h+6*(e-h)*a:0.5>a?e:a<2/3?h+(e-h)*(2/3-a)*6:h};t.HSLToRGB=function(h,e,a,
b){b=b||vec3.create();if(0==e)a=e=h=a;else{var c=0.5>a?a*(1+e):a+e-a*e,d=2*a-c;a=HUEToRGB(d,c,h+1/3);e=HUEToRGB(d,c,h);h=HUEToRGB(d,c,h-1/3)}b[0]=a;b[1]=e;b[2]=h;return b};t.hexColorToRGBA=function(){var h={white:[1,1,1],black:[0,0,0],gray:[0.501960813999176,0.501960813999176,0.501960813999176],red:[1,0,0],orange:[1,0.6470588445663452,0],pink:[1,0.7529411911964417,0.7960784435272217],green:[0,0.501960813999176,0],lime:[0,1,0],blue:[0,0,1],violet:[0.9333333373069763,0.5098039507865906,0.9333333373069763],
magenta:[1,0,1],cyan:[0,1,1],yellow:[1,1,0],brown:[0.6470588445663452,0.16470588743686676,0.16470588743686676],silver:[0.7529411911964417,0.7529411911964417,0.7529411911964417],gold:[1,0.843137264251709,0],transparent:[0,0,0,0]};return function(e,a,b){b=void 0===b?1:b;a=a||new Float32Array(4);a[3]=b;if("string"!=typeof e)return a;var c=h[e];if(void 0!==c)return a.set(c),a[3]=3==a.length?b:a[3]*b,a;c=e.indexOf("rgba(");if(-1!=c)return e=e.substr(5,e.length-2),e=e.split(","),a[0]=parseInt(e[0])/255,
a[1]=parseInt(e[1])/255,a[2]=parseInt(e[2])/255,a[3]=parseFloat(e[3])*b,a;c=e.indexOf("hsla(");if(-1!=c)return e=e.substr(5,e.length-2),e=e.split(","),HSLToRGB(parseInt(e[0])/360,parseInt(e[1])/100,parseInt(e[2])/100,a),a[3]=parseFloat(e[3])*b,a;a[3]=b;c=e.indexOf("rgb(");if(-1!=c)return e=e.substr(4,e.length-2),e=e.split(","),a[0]=parseInt(e[0])/255,a[1]=parseInt(e[1])/255,a[2]=parseInt(e[2])/255,a;c=e.indexOf("hsl(");if(-1!=c)return e=e.substr(4,e.length-2),e=e.split(","),HSLToRGB(parseInt(e[0])/
360,parseInt(e[1])/100,parseInt(e[2])/100,a),a;e=e.replace(/^#?([a-f\d])([a-f\d])([a-f\d])$/i,function(a,b,c,e){return b+b+c+c+e+e});b=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(e);if(!b)return a;a[0]=parseInt(b[1],16)/255;a[1]=parseInt(b[2],16)/255;a[2]=parseInt(b[3],16)/255;return a}}();t.toHalfFloat=function(){var h=new Float32Array(1),e=new Int32Array(h.buffer);return function(a){h[0]=a;a=e[0];var b=a>>16&32768,c=(a&2147483647)+4096;if(1199570944<=c)return 1199570944<=(a&2147483647)?2139095040>
c?b|31744:b|31744|(a&8388607)>>13:b|31743;if(947912704<=c)return b|c-939524096>>13;if(855638016>c)return b;c=(a&2147483647)>>23;return b|(a&8388607|8388608)+(8388608>>>c-102)>>126-c}}();var S=function(){function h(a){return a.charCodeAt(0)+(a.charCodeAt(1)<<8)+(a.charCodeAt(2)<<16)+(a.charCodeAt(3)<<24)}function e(a,b,c,d){var e=new Uint16Array(4),f=new Uint16Array(c*d),h=0,k=0,l=0,g=k=h=0,q=0,m=0,n=0,s=c/4;d/=4;for(var p=0;p<d;p++)for(var r=0;r<s;r++)l=b+4*(p*s+r),e[0]=a[l],e[1]=a[l+1],h=e[0]&31,
k=e[0]&2016,g=e[0]&63488,q=e[1]&31,m=e[1]&2016,n=e[1]&63488,e[2]=5*h+3*q>>3|5*k+3*m>>3&2016|5*g+3*n>>3&63488,e[3]=5*q+3*h>>3|5*m+3*k>>3&2016|5*n+3*g>>3&63488,h=a[l+2],k=4*p*c+4*r,f[k]=e[h&3],f[k+1]=e[h>>2&3],f[k+2]=e[h>>4&3],f[k+3]=e[h>>6&3],k+=c,f[k]=e[h>>8&3],f[k+1]=e[h>>10&3],f[k+2]=e[h>>12&3],f[k+3]=e[h>>14],h=a[l+3],k+=c,f[k]=e[h&3],f[k+1]=e[h>>2&3],f[k+2]=e[h>>4&3],f[k+3]=e[h>>6&3],k+=c,f[k]=e[h>>8&3],f[k+1]=e[h>>10&3],f[k+2]=e[h>>12&3],f[k+3]=e[h>>14];return f}function a(a){for(var b=0,c=a.length,
d=0;b<c;b+=4)d=a[b],a[b]=a[b+2],a[b+2]=d}function b(b,c,d,h){var I=new Int32Array(d,0,r),A,D,E,H,G,L,N,O,y;if(I[v]!=f)return console.error("Invalid magic number in DDS header"),0;if(!I[z]&l)return console.error("Unsupported format, must contain a FourCC code"),0;A=I[C];switch(A){case m:D=8;E=c?c.COMPRESSED_RGB_S3TC_DXT1_EXT:null;break;case n:D=16;E=c?c.COMPRESSED_RGBA_S3TC_DXT3_EXT:null;break;case p:D=16;E=c?c.COMPRESSED_RGBA_S3TC_DXT5_EXT:null;break;default:D=4,A=null,E=b.RGBA}N=1;I[s]&k&&!1!==h&&
(N=Math.max(1,I[M]));H=I[w];G=I[x];L=I[u]+4;if(I[t+1]&g)for(y=0;6>y;++y)for(H=I[w],G=I[x],O=0;O<N;++O)A?(h=Math.max(4,H)/4*Math.max(4,G)/4*D,c=new Uint8Array(d,L,h),b.compressedTexImage2D(b.TEXTURE_CUBE_MAP_POSITIVE_X+y,O,E,H,G,0,c)):(b.pixelStorei(b.UNPACK_FLIP_Y_WEBGL,!1),h=H*G*D,c=new Uint8Array(d,L,h),a(c),b.texImage2D(b.TEXTURE_CUBE_MAP_POSITIVE_X+y,O,E,H,G,0,b.RGBA,b.UNSIGNED_BYTE,c)),L+=h,H*=0.5,G*=0.5;else if(c)for(b.pixelStorei(b.UNPACK_FLIP_Y_WEBGL,!0),O=0;O<N;++O)A?(h=Math.max(4,H)/4*Math.max(4,
G)/4*D,c=new Uint8Array(d,L,h),b.compressedTexImage2D(b.TEXTURE_2D,O,E,H,G,0,c)):(h=H*G*D,c=new Uint8Array(d,L,h),a(c),b.texImage2D(b.TEXTURE_2D,O,E,H,G,0,E,b.UNSIGNED_BYTE,c)),L+=h,H*=0.5,G*=0.5;else if(A==m)Math.max(4,H),Math.max(4,G),c=new Uint16Array(d),d=e(c,L/2,H,G),b.texImage2D(b.TEXTURE_2D,0,b.RGB,H,G,0,b.RGB,b.UNSIGNED_SHORT_5_6_5,d),h&&b.generateMipmap(b.TEXTURE_2D);else return console.error("No manual decoder for",String.fromCharCode(A&255,A>>8&255,A>>16&255,A>>24&255),"and no native support"),
0;return N}function c(b,c){var d=new Int32Array(b,0,r),h,I,A,D,E,H,G,L,N,y,B;if(d[v]!=f)return console.error("Invalid magic number in DDS header"),0;if(!d[z]&l)return console.error("Unsupported format, must contain a FourCC code"),0;h=d[C];switch(h){case m:I=8;A="COMPRESSED_RGB_S3TC_DXT1_EXT";break;case n:I=16;A="COMPRESSED_RGBA_S3TC_DXT3_EXT";break;case p:I=16;A="COMPRESSED_RGBA_S3TC_DXT5_EXT";break;default:I=4,A="RGBA"}N=1;d[s]&k&&!1!==loadMipmaps&&(N=Math.max(1,d[M]));D=d[w];E=d[x];G=d[u]+4;var F=
[];if(d[t+1]&g)for(B=0;6>B;++B)for(D=d[w],E=d[x],y=0;y<N;++y)h?(H=Math.max(4,D)/4*Math.max(4,E)/4*I,new Uint8Array(b,G,H),F.push({tex:"TEXTURE_CUBE_MAP",face:B,mipmap:y,internalFormat:A,width:D,height:E,offset:0,dataOffset:G,dataLength:H})):(H=D*E*I,L=new Uint8Array(b,G,H),a(L),F.push({tex:"TEXTURE_CUBE_MAP",face:B,mipmap:y,internalFormat:A,width:D,height:E,offset:0,type:"UNSIGNED_BYTE",dataOffset:G,dataLength:H})),G+=H,D*=0.5,E*=0.5;else if(c)if(h==m)Math.max(4,D),Math.max(4,E),L=new Uint16Array(b),
d=e(L,G/2,D,E),F.push({tex:"TEXTURE_2D",mipmap:0,internalFormat:"RGB",width:D,height:E,offset:0,format:"RGB",type:"UNSIGNED_SHORT_5_6_5",data:d});else return console.error("No manual decoder for",String.fromCharCode(h&255,h>>8&255,h>>16&255,h>>24&255),"and no native support"),0;else for(y=0;y<N;++y)H=Math.max(4,D)/4*Math.max(4,E)/4*I,new Uint8Array(b,G,H),F.push({tex:"TEXTURE_2D",mipmap:y,internalFormat:A,width:D,height:E,offset:0,type:"UNSIGNED_BYTE",dataOffset:G,dataLength:H}),G+=H,D*=0.5,E*=0.5;
return F}function d(a,c,d,e,h,f){var k=new XMLHttpRequest;k.open("GET",d,!0);k.responseType="arraybuffer";k.onload=function(){if(200==this.status){var d=new Int32Array(this.response,0,r),k=d[t+1]&g?a.TEXTURE_CUBE_MAP:a.TEXTURE_2D;a.bindTexture(k,e);var l=b(a,c,this.response,h);a.texParameteri(k,a.TEXTURE_MAG_FILTER,a.LINEAR);a.texParameteri(k,a.TEXTURE_MIN_FILTER,1<l?a.LINEAR_MIPMAP_LINEAR:a.LINEAR);a.bindTexture(k,null);e.texture_type=k;e.width=d[w];e.height=d[x]}f&&f(e)};k.send(null);return e}var f=
542327876,k=131072,g=512,l=4,m=h("DXT1"),n=h("DXT3"),p=h("DXT5"),r=31,v=0,u=1,s=2,x=3,w=4,M=7,z=20,C=21,t=27;return{dxtToRgb565:e,uploadDDSLevels:b,loadDDSTextureEx:d,loadDDSTexture:function(a,b,c,e){var h=a.createTexture();b=a.getExtension("WEBGL_compressed_texture_s3tc");d(a,b,c,h,!0,e);return h},loadDDSTextureFromMemoryEx:function(a,c,d,e,h){var f=new Int32Array(d,0,r),k=!!(f[t+1]&g),l=k?a.TEXTURE_CUBE_MAP:a.TEXTURE_2D;a.bindTexture(l,e.handler);c=b(a,c,d,h);a.texParameteri(l,a.TEXTURE_MAG_FILTER,
a.LINEAR);a.texParameteri(l,a.TEXTURE_MIN_FILTER,1<c?a.LINEAR_MIPMAP_LINEAR:a.LINEAR);k&&(a.texParameteri(l,a.TEXTURE_WRAP_S,a.CLAMP_TO_EDGE),a.texParameteri(l,a.TEXTURE_WRAP_T,a.CLAMP_TO_EDGE));a.bindTexture(l,null);e.handler&&(e.texture_type=l,e.width=f[w],e.height=f[x]);return e},getDDSTextureFromMemoryEx:function(a){var b=new Int32Array(a,0,r),d=b[t+1]&g?"TEXTURE_CUBE_MAP":"TEXTURE_2D",e=c(a);return{type:d,buffers:e,data:a,width:b[w],height:b[x]}}}}();"undefined"!=typeof t&&(t.DDS=S);if("undefined"==
typeof glMatrix)throw"You must include glMatrix on your project";Math.clamp=function(h,e,a){return e>h?e:a<h?a:h};vec3.ZERO=vec3.fromValues(0,0,0);vec3.FRONT=vec3.fromValues(0,0,-1);vec3.UP=vec3.fromValues(0,1,0);vec3.RIGHT=vec3.fromValues(1,0,0);vec2.rotate=function(h,e,a){var b=e[0];e=e[1];var c=Math.cos(a);a=Math.sin(a);h[0]=b*c-e*a;h[1]=b*a+e*c;return h};vec3.zero=function(h){h[0]=h[1]=0;return h};vec2.perpdot=function(h,e){return h[1]*e[0]+-h[0]*e[1]};vec2.computeSignedAngle=function(h,e){return Math.atan2(vec2.perpdot(h,
e),vec2.dot(h,e))};vec2.random=function(h,e){e=e||1;h[0]=Math.random()*e;h[1]=Math.random()*e;return h};vec3.zero=function(h){h[0]=h[1]=h[2]=0;return h};vec3.minValue=function(h){return h[0]<h[1]&&h[0]<h[2]?h[0]:h[1]<h[2]?h[1]:h[2]};vec3.maxValue=function(h){return h[0]>h[1]&&h[0]>h[2]?h[0]:h[1]>h[2]?h[1]:h[2]};vec3.minValue=function(h){return h[0]<h[1]&&h[0]<h[2]?h[0]:h[1]<h[2]?h[1]:h[2]};vec3.addValue=function(h,e,a){h[0]=e[0]+a;h[1]=e[1]+a;h[2]=e[2]+a};vec3.subValue=function(h,e,a){h[0]=e[0]-a;
h[1]=e[1]-a;h[2]=e[2]-a};vec3.toArray=function(h){return[h[0],h[1],h[2]]};vec3.rotateX=function(h,e,a){var b=e[1],c=e[2],d=Math.cos(a);a=Math.sin(a);h[0]=e[0];h[1]=b*d-c*a;h[2]=b*a+c*d;return h};vec3.rotateY=function(h,e,a){var b=e[0],c=e[2],d=Math.cos(a);a=Math.sin(a);h[0]=b*d-c*a;h[1]=e[1];h[2]=b*a+c*d;return h};vec3.rotateZ=function(h,e,a){var b=e[0],c=e[1],d=Math.cos(a);a=Math.sin(a);h[0]=b*d-c*a;h[1]=b*a+c*d;h[2]=e[2];return h};vec3.angle=function(h,e){return Math.acos(vec3.dot(h,e))};vec3.signedAngle=
function(h,e,a){var b=vec3.angle(h,e);h=Math.sign(a[0]*(h[1]*e[2]-h[2]*e[1])+a[1]*(h[2]*e[0]-h[0]*e[2])+a[2]*(h[0]*e[1]-h[1]*e[0]));return b*h};vec3.random=function(h,e){e=e||1;h[0]=Math.random()*e;h[1]=Math.random()*e;h[2]=Math.random()*e;return h};vec3.polarToCartesian=function(h,e){var a=e[0],b=e[1],c=e[2];h[0]=a*Math.cos(b)*Math.sin(c);h[1]=a*Math.sin(b);h[2]=a*Math.cos(b)*Math.cos(c);return h};vec3.reflect=function(h,e,a){var b=e[0],c=e[1],d=e[2];vec3.scale(h,a,-2*vec3.dot(e,a));h[0]+=b;h[1]+=
c;h[2]+=d;return h};vec4.random=function(h,e){e=e||1;h[0]=Math.random()*e;h[1]=Math.random()*e;h[2]=Math.random()*e;h[3]=Math.random()*e;return h};vec4.toArray=function(h){return[h[0],h[1],h[2],h[3]]};mat3.IDENTITY=mat3.create();mat4.IDENTITY=mat4.create();mat4.toArray=function(h){return[h[0],h[1],h[2],h[3],h[4],h[5],h[6],h[7],h[8],h[9],h[10],h[11],h[12],h[13],h[14],h[15]]};mat4.setUpAndOrthonormalize=function(h,e,a){e!=h&&mat4.copy(h,e);e=h.subarray(0,3);vec3.normalize(h.subarray(4,7),a);h=h.subarray(8,
11);vec3.cross(e,a,h);vec3.normalize(e,e);vec3.cross(h,e,a);vec3.normalize(h,h)};mat4.multiplyVec3=function(h,e,a){var b=a[0],c=a[1];a=a[2];h[0]=e[0]*b+e[4]*c+e[8]*a+e[12];h[1]=e[1]*b+e[5]*c+e[9]*a+e[13];h[2]=e[2]*b+e[6]*c+e[10]*a+e[14];return h};mat4.projectVec3=function(h,e,a){var b=a[0],c=a[1];a=a[2];var d=e[1]*b+e[5]*c+e[9]*a+e[13],f=e[2]*b+e[6]*c+e[10]*a+e[14],k=e[3]*b+e[7]*c+e[11]*a+e[15];h[0]=((e[0]*b+e[4]*c+e[8]*a+e[12])/k+1)/2;h[1]=(d/k+1)/2;h[2]=(f/k+1)/2;return h};vec3.project=function(h,
e,a,b){b=b||gl.viewport_data;var c=e[0],d=e[1];e=e[2];var f=a[3]*c+a[7]*d+a[11]*e+a[15],k=1-((a[1]*c+a[5]*d+a[9]*e+a[13])/f+1)/2,g=((a[2]*c+a[6]*d+a[10]*e+a[14])/f+1)/2;h[0]=((a[0]*c+a[4]*d+a[8]*e+a[12])/f+1)/2*b[2]+b[0];h[1]=k*b[3]+b[1];h[2]=g;return h};var T=mat4.create(),F=vec4.create();vec3.unproject=function(h,e,a,b){F[0]=2*(e[0]-b[0])/b[2]-1;F[1]=2*(e[1]-b[1])/b[3]-1;F[2]=2*e[2]-1;F[3]=1;if(!mat4.invert(T,a))return null;vec4.transformMat4(F,F,T);if(0===F[3])return null;h[0]=F[0]/F[3];h[1]=F[1]/
F[3];h[2]=F[2]/F[3];return h};mat4.rotateVec3=function(h,e,a){var b=a[0],c=a[1];a=a[2];h[0]=e[0]*b+e[4]*c+e[8]*a;h[1]=e[1]*b+e[5]*c+e[9]*a;h[2]=e[2]*b+e[6]*c+e[10]*a;return h};mat4.fromTranslationFrontTop=function(h,e,a,b){vec3.cross(h.subarray(0,3),a,b);h.set(b,4);h.set(a,8);h.set(e,12);return h};mat4.translationMatrix=function(h){var e=mat4.create();e[12]=h[0];e[13]=h[1];e[14]=h[2];return e};mat4.setTranslation=function(h,e){h[12]=e[0];h[13]=e[1];h[14]=e[2];return h};mat4.getTranslation=function(h,
e){h[0]=e[12];h[1]=e[13];h[2]=e[14];return h};mat4.toRotationMat4=function(h,e){mat4.copy(h,e);h[12]=h[13]=h[14]=0;return h};mat4.swapRows=function(h,e,a,b){if(h!=e)return mat4.copy(h,e),h[4*a]=e[4*b],h[4*a+1]=e[4*b+1],h[4*a+2]=e[4*b+2],h[4*a+3]=e[4*b+3],h[4*b]=e[4*a],h[4*b+1]=e[4*a+1],h[4*b+2]=e[4*a+2],h[4*b+3]=e[4*a+3],h;e=new Float32Array(matrix.subarray(4*a,5*a));matrix.set(matrix.subarray(4*b,5*b),4*a);matrix.set(e,4*b);return h};mat4.scaleAndAdd=function(h,e,a,b){h[0]=e[0]+a[0]*b;h[1]=e[1]+
a[1]*b;h[2]=e[2]+a[2]*b;h[3]=e[3]+a[3]*b;h[4]=e[4]+a[4]*b;h[5]=e[5]+a[5]*b;h[6]=e[6]+a[6]*b;h[7]=e[7]+a[7]*b;h[8]=e[8]+a[8]*b;h[9]=e[9]+a[9]*b;h[10]=e[10]+a[10]*b;h[11]=e[11]+a[11]*b;h[12]=e[12]+a[12]*b;h[13]=e[13]+a[13]*b;h[14]=e[14]+a[14]*b;h[15]=e[15]+a[15]*b;return h};quat.fromAxisAngle=function(h,e){var a=quat.create();e*=0.5;var b=Math.sin(e);a[0]=b*h[0];a[1]=b*h[1];a[2]=b*h[2];a[3]=Math.cos(e);return a};quat.lookRotation=function(){var h=vec3.create(),e=vec3.create(),a=vec3.create();return function(b,
c,d){vec3.normalize(h,c);vec3.cross(e,d,h);vec3.normalize(e,e);vec3.cross(a,h,e);var f=e[0];c=e[1];d=e[2];var k=a[0],g=a[1],l=a[2],m=h[0],n=h[1],p=h[2],r=f+g+p;if(0<r)return f=Math.sqrt(r+1),b[3]=0.5*f,f=0.5/f,b[0]=(l-n)*f,b[1]=(m-d)*f,b[2]=(c-k)*f,b;if(f>=g&&f>=p)return f=Math.sqrt(1+f-g-p),g=0.5/f,b[0]=0.5*f,b[1]=(c+k)*g,b[2]=(d+m)*g,b[3]=(l-n)*g,b;if(g>p)return f=Math.sqrt(1+g-f-p),g=0.5/f,b[0]=(k+c)*g,b[1]=0.5*f,b[2]=(n+l)*g,b[3]=(m-d)*g,b;f=Math.sqrt(1+p-f-g);g=0.5/f;b[0]=(m+d)*g;b[1]=(n+l)*
g;b[2]=0.5*f;b[3]=(c-k)*g;return b}}();quat.toEuler=function(h,e){var a=Math.atan2(2*e[1]*e[3]-2*e[0]*e[2],1-2*e[1]*e[1]-2*e[2]*e[2]),b=Math.asin(2*e[0]*e[1]+2*e[2]*e[3]),c=Math.atan2(2*e[0]*e[3]-2*e[1]*e[2],1-2*e[0]*e[0]-2*e[2]*e[2]);h||(h=vec3.create());vec3.set(h,a,b,c);return h};quat.fromEuler=function(h,e){var a=e[0],b=e[1],c=e[2],d=Math.cos(a),f=Math.cos(b),k=Math.cos(c),a=Math.sin(a),b=Math.sin(b),c=Math.sin(c),g=0.5*Math.sqrt(1+d*f+d*k-a*b*c+f*k);0==g&&(g=1E-6);quat.set(h,(f*c+d*c+a*b*k)/
(4*g),(a*f+a*k+d*b*c)/(4*g),(-a*c+d*b*k+b)/(4*g),g);quat.normalize(h,h);return h};quat.fromMat4=function(h,e){var a=e[0]+e[5]+e[10];if(0<a){var b=Math.sqrt(a+1);h[3]=0.5*b;b=0.5/b;h[0]=(e[9]-e[6])*b;h[1]=(e[8]-e[2])*b;h[2]=(e[4]-e[1])*b}else{a=0;e[5]>e[0]&&(a=1);e[10]>e[4*a+a]&&(a=2);var c=(a+1)%3,d=(c+1)%3,b=Math.sqrt(e[4*a+a]-e[4*c+c]-e[4*d+d]+1);h[a]=0.5*b;b=0.5/b;h[3]=(e[4*d+c]-e[4*c+d])*b;h[c]=(e[4*c+a]+e[4*a+c])*b;h[d]=(e[4*d+a]+e[4*a+d])*b}quat.normalize(h,h)};vec3.getMat3Column=function(h,
e,a){h[0]=e[3*a];h[1]=e[3*a+1];h[2]=e[3*a+2];return h};mat3.setColumn=function(h,e,a){h[3*a]=e[0];h[3*a+1]=e[1];h[3*a+2]=e[2];return h};quat.fromMat3AndQuat=function(){var h=mat3.create(),e=quat.create(),a=vec3.create(),b=vec3.create(),c=vec3.create(),d=vec3.create(),f=vec3.create(),k=vec3.create(),g=vec3.create(),l=vec3.create(),m=vec3.create(),n=vec3.create();mat3.create();return function(p,r,v){v=v||25;for(var u=0;u<v;++u){var s=mat3.fromQuat(h,p);vec3.getMat3Column(a,s,0);vec3.getMat3Column(b,
s,1);vec3.getMat3Column(c,s,2);vec3.getMat3Column(d,r,0);vec3.getMat3Column(f,r,1);vec3.getMat3Column(k,r,2);vec3.cross(g,a,d);vec3.cross(l,b,f);vec3.cross(m,c,k);vec3.add(n,g,l);vec3.add(n,n,m);s=1/Math.abs(vec3.dot(a,d)+vec3.dot(b,f)+vec3.dot(c,k))+1E-9;vec3.scale(n,n,s);s=vec3.length(n);if(1E-9>s)break;vec3.scale(n,n,1/s);quat.setAxisAngle(e,n,s);quat.mul(p,e,p);quat.normalize(p,p)}return p}}();quat.rotateToFrom=function(){var h=vec3.create();return function(e,a,b){e=e||quat.create();var c=vec3.cross(h,
a,b);a=vec3.dot(a,b);if(-0.99>a)return e[0]=0,e[1]=1,e[2]=0,e[3]=0,e;e[0]=0.5*c[0];e[1]=0.5*c[1];e[2]=0.5*c[2];e[3]=0.5*(1+a);quat.normalize(e,e);return e}}();quat.lookAt=function(){var h=vec3.create();return function(e,a,b){b=vec3.dot(vec3.FRONT,a);if(1E-6>Math.abs(b- -1))return e.set(vec3.UP),e[3]=Math.PI,e;if(1E-6>Math.abs(b-1))return quat.identity(e);b=Math.acos(b);vec3.cross(h,vec3.FRONT,a);vec3.normalize(h,h);quat.setAxisAngle(e,h,b);return e}}();g.Indexer=function(){this.unique=[];this.indices=
[];this.map={}};g.Indexer.prototype={add:function(h){var e=JSON.stringify(h);e in this.map||(this.map[e]=this.unique.length,this.unique.push(h));return this.map[e]}};g.Buffer=function(h,e,a,b,c){g.debug&&console.log("GL.Buffer created");null!==c&&(c=c||t.gl);this.gl=c;this.buffer=null;this.target=h;this.attribute=null;this.data=e;this.spacing=a||3;this.data&&this.gl&&this.upload(b)};g.Buffer.prototype.bind=function(h,e){e=e||this.gl;e.bindBuffer(e.ARRAY_BUFFER,this.buffer);e.enableVertexAttribArray(h);
e.vertexAttribPointer(h,this.spacing,this.buffer.gl_type,!1,0,0)};g.Buffer.prototype.unbind=function(h,e){e=e||this.gl;e.disableVertexAttribArray(h)};g.Buffer.prototype.forEach=function(h){for(var e=this.data,a=0,b=this.spacing,c=e.length;a<c;a+=b)h(e.subarray(a,a+b),a);return this};g.Buffer.prototype.applyTransform=function(h){for(var e=this.data,a=0,b=this.spacing,c=e.length;a<c;a+=b){var d=e.subarray(a,a+b);vec3.transformMat4(d,d,h)}return this};g.Buffer.prototype.upload=function(h){var e=this.spacing||
3,a=this.gl;if(a){if(!this.data)throw"No data supplied";var b=this.data;if(!b.buffer)throw"Buffers must be typed arrays";if(this.buffer=this.buffer||a.createBuffer()){this.buffer.length=b.length;this.buffer.spacing=e;switch(b.constructor){case Int8Array:this.buffer.gl_type=a.BYTE;break;case Uint8ClampedArray:case Uint8Array:this.buffer.gl_type=a.UNSIGNED_BYTE;break;case Int16Array:this.buffer.gl_type=a.SHORT;break;case Uint16Array:this.buffer.gl_type=a.UNSIGNED_SHORT;break;case Int32Array:this.buffer.gl_type=
a.INT;break;case Uint32Array:this.buffer.gl_type=a.UNSIGNED_INT;break;case Float32Array:this.buffer.gl_type=a.FLOAT;break;default:throw"unsupported buffer type";}this.target!=a.ARRAY_BUFFER||this.buffer.gl_type!=a.INT&&this.buffer.gl_type!=a.UNSIGNED_INT||(console.warn("WebGL does not support UINT32 or INT32 as vertex buffer types, converting to FLOAT"),this.buffer.gl_type=a.FLOAT,b=new Float32Array(b));a.bindBuffer(this.target,this.buffer);a.bufferData(this.target,b,h||this.stream_type||a.STATIC_DRAW)}}};
g.Buffer.prototype.compile=g.Buffer.prototype.upload;g.Buffer.prototype.setData=function(h,e){if(!h.buffer)throw"Data must be typed array";e=e||0;if(this.data){if(this.data.length<h.length)throw"buffer is not big enough, you cannot set data to a smaller buffer";if(this.data!=h)if(this.data.length==h.length)this.data.set(h),this.upload();else{var a=new Uint8Array(h.buffer,h.buffer.byteOffset,h.buffer.byteLength);(new Uint8Array(this.data.buffer)).set(a,e);this.uploadRange(e,a.length)}}else this.data=
h,this.upload()};g.Buffer.prototype.uploadRange=function(h,e){if(!this.data)throw"No data stored in this buffer";if(!this.data.buffer)throw"Buffers must be typed arrays";var a=new Uint8Array(this.data.buffer,h,e),b=this.gl;b.bindBuffer(this.target,this.buffer);b.bufferSubData(this.target,h,a)};g.Buffer.prototype.clone=function(h){var e=new g.Buffer;if(h)for(var a in this)e[a]=this[a];else this.target&&(e.target=this.target),this.gl&&(e.gl=this.gl),this.spacing&&(e.spacing=this.spacing),this.data&&
(e.data=new t[this.data.constructor](this.data),e.upload());return e};g.Buffer.prototype.toJSON=function(){return this.data?{data_type:getClassName(this.data),data:this.data.toJSON(),target:this.target,attribute:this.attribute,spacing:this.spacing}:(console.error("cannot serialize a mesh without data"),null)};g.Buffer.prototype.fromJSON=function(h){this.data=new (t[h.data_type]||Float32Array)(h.data);this.target=h.target;this.spacing=h.spacing||3;this.attribute=h.attribute;this.upload(g.STATIC_DRAW)};
g.Buffer.prototype.delete=function(){this.gl.deleteBuffer(this.buffer);this.buffer=null};t.Mesh=g.Mesh=function(h,e,a,b){g.debug&&console.log("GL.Mesh created");null!==b&&(this.gl=b=b||t.gl);this._context_id=b.context_id;this.vertexBuffers={};this.indexBuffers={};this.info={groups:[]};this._bounding=BBox.create();(h||e)&&this.addBuffers(h,e,a?a.stream_type:null);if(a)for(var c in a)this[c]=a[c]};Mesh.common_buffers={vertices:{spacing:3,attribute:"a_vertex"},vertices2D:{spacing:2,attribute:"a_vertex2D"},
normals:{spacing:3,attribute:"a_normal"},coords:{spacing:2,attribute:"a_coord"},coords1:{spacing:2,attribute:"a_coord1"},coords2:{spacing:2,attribute:"a_coord2"},colors:{spacing:4,attribute:"a_color"},tangents:{spacing:3,attribute:"a_tangent"},bone_indices:{spacing:4,attribute:"a_bone_indices",type:Uint8Array},weights:{spacing:4,attribute:"a_weights"},extra:{spacing:1,attribute:"a_extra"},extra2:{spacing:2,attribute:"a_extra2"},extra3:{spacing:3,attribute:"a_extra3"},extra4:{spacing:4,attribute:"a_extra4"}};
Mesh.default_datatype=Float32Array;Object.defineProperty(Mesh.prototype,"bounding",{set:function(h){if(h){if(13>h.length)throw"Bounding must use the BBox bounding format of 13 floats: center, halfsize, min, max, radius";this._bounding.set(h)}},get:function(){return this._bounding}});Mesh.prototype.addBuffer=function(h,e){e.target==gl.ARRAY_BUFFER?this.vertexBuffers[h]=e:this.indexBuffers[h]=e;if(!e.attribute){var a=g.Mesh.common_buffers[h];a&&(e.attribute=a.attribute)}};Mesh.prototype.addBuffers=
function(h,e,a){var b=0;this.vertexBuffers.vertices&&(b=this.vertexBuffers.vertices.data.length/3);for(var c in h){var d=h[c];if(d){if(d.constructor==g.Buffer||d.data)d=d.data;else if("number"!=typeof d[0]){for(var f=[],k=0,q=1E4;k<d.length;k+=q)f=Array.prototype.concat.apply(f,d.slice(k,k+q));d=f}f=g.Mesh.common_buffers[c];d.constructor===Array&&(k=g.Mesh.default_datatype,f&&f.type&&(k=f.type),d=new k(d));"vertices"==c&&(b=d.length/3);k=d.length/b;f&&f.spacing&&(k=f.spacing);q="a_"+c;f&&f.attribute&&
(q=f.attribute);this.vertexBuffers[c]?this.updateVertexBuffer(c,q,k,d,a):this.createVertexBuffer(c,q,k,d,a)}}if(e)for(c in e)if(d=e[c]){if(d.constructor==g.Buffer||d.data)d=d.data;if("number"!=typeof d[0]){f=[];c=0;for(q=1E4;c<d.length;c+=q)f=Array.prototype.concat.apply(f,d.slice(c,c+q));d=f}d.constructor===Array&&(k=Uint16Array,65536<b&&(k=Uint32Array),d=new k(d));this.createIndexBuffer(c,d)}};Mesh.prototype.createVertexBuffer=function(h,e,a,b,c){var d=g.Mesh.common_buffers[h];!e&&d&&(e=d.attribute);
if(!e)throw"Buffer added to mesh without attribute name";!a&&d&&(a=d&&d.spacing?d.spacing:3);if(!b){b=this.getNumVertices();if(!b)throw"Cannot create an empty buffer in a mesh without vertices (vertices are needed to know the size)";b=new g.Mesh.default_datatype(b*a)}if(!b.buffer)throw"Buffer data MUST be typed array";a=this.vertexBuffers[h]=new g.Buffer(gl.ARRAY_BUFFER,b,a,c,this.gl);a.name=h;a.attribute=e;return a};Mesh.prototype.updateVertexBuffer=function(h,e,a,b,c){var d=this.vertexBuffers[h];
d?b.length&&(d.attribute=e,d.spacing=a,d.data=b,d.upload(c)):console.log("buffer not found: ",h)};Mesh.prototype.removeVertexBuffer=function(h,e){var a=this.vertexBuffers[h];a&&(e&&a.delete(),delete this.vertexBuffers[h])};Mesh.prototype.getVertexBuffer=function(h){return this.vertexBuffers[h]};Mesh.prototype.createIndexBuffer=function(h,e,a){if(e.constructor===Array){var b=Uint16Array,c=this.vertexBuffers.vertices;c&&(65536<c.data.length/3&&(b=Uint32Array),e=new b(e))}return this.indexBuffers[h]=
new g.Buffer(gl.ELEMENT_ARRAY_BUFFER,e,0,a,this.gl)};Mesh.prototype.getBuffer=function(h){return this.vertexBuffers[h]};Mesh.prototype.getIndexBuffer=function(h){return this.indexBuffers[h]};Mesh.prototype.removeIndexBuffer=function(h,e){var a=this.indexBuffers[h];a&&(e&&a.delete(),delete this.indexBuffers[h])};Mesh.prototype.upload=function(h){for(var e in this.vertexBuffers){var a=this.vertexBuffers[e];a.upload(h)}for(var b in this.indexBuffers)a=this.indexBuffers[b],a.upload()};Mesh.prototype.compile=
Mesh.prototype.upload;Mesh.prototype.deleteBuffers=function(){for(var h in this.vertexBuffers){var e=this.vertexBuffers[h];e.delete()}this.vertexBuffers={};for(h in this.indexBuffers)e=this.indexBuffers[h],e.delete();this.indexBuffers={}};Mesh.prototype.delete=Mesh.prototype.deleteBuffers;Mesh.prototype.bindBuffers=function(h){for(var e in this.vertexBuffers){var a=this.vertexBuffers[e],b=h.attributes[a.attribute||e];null!=b&&a.buffer&&(gl.bindBuffer(gl.ARRAY_BUFFER,a.buffer),gl.enableVertexAttribArray(b),
gl.vertexAttribPointer(b,a.buffer.spacing,a.buffer.gl_type,!1,0,0))}};Mesh.prototype.unbindBuffers=function(h){for(var e in this.vertexBuffers){var a=this.vertexBuffers[e],b=a.attribute||e;null!=h.attributes[b]&&a.buffer&&gl.disableVertexAttribArray(h.attributes[b])}};Mesh.prototype.clone=function(h){h=h||t.gl;var e={},a={},b;for(b in this.vertexBuffers){var c=this.vertexBuffers[b];e[b]=new c.data.constructor(c.data)}for(b in this.indexBuffers)c=this.indexBuffers[b],a[b]=new c.data.constructor(c.data);
return new g.Mesh(e,a,void 0,h)};Mesh.prototype.cloneShared=function(h){h=h||t.gl;return new g.Mesh(this.vertexBuffers,this.indexBuffers,void 0,h)};Mesh.prototype.toObject=function(){var h={},e={},a;for(a in this.vertexBuffers){var b=this.vertexBuffers[a];h[a]={spacing:b.spacing,data:new b.data.constructor(b.data)}}for(a in this.indexBuffers)b=this.indexBuffers[a],e[a]={data:new b.data.constructor(b.data)};return{vertexBuffers:h,indexBuffers:e,info:this.info?cloneObject(this.info):null,bounding:this._bounding.toJSON()}};
Mesh.prototype.toJSON=function(){var h={vertexBuffers:{},indexBuffers:{},info:this.info?cloneObject(this.info):null,bounding:this._bounding.toJSON()},e;for(e in this.vertexBuffers)h.vertexBuffers[e]=this.vertexBuffers[e].toJSON();for(e in this.indexBuffers)h.indexBuffers[e]=this.indexBuffers[e].toJSON();return h};Mesh.prototype.fromJSON=function(h){this.vertexBuffers={};this.indexBuffers={};for(var e in h.vertexBuffers)if(h.vertexBuffers[e]){var a=new g.Buffer;a.fromJSON(h.vertexBuffers[e]);!a.attribute&&
g.Mesh.common_buffers[e]&&(a.attribute=g.Mesh.common_buffers[e].attribute);this.vertexBuffers[e]=a}for(e in h.indexBuffers)h.indexBuffers[e]&&(a=new g.Buffer,a.fromJSON(h.indexBuffers[e]),this.indexBuffers[e]=a);h.info&&(this.info=cloneObject(h.info));h.bounding&&(this.bounding=h.bounding)};Mesh.prototype.generateMetadata=function(){var h={},e=this.vertexBuffers.vertices.data,a=this.indexBuffers.triangles.data;h.vertices=e.length/3;h.faces=a?a.length/3:e.length/9;h.indexed=!!this.metadata.faces;this.metadata=
h};Mesh.prototype.computeWireframe=function(){var h=this.indexBuffers.triangles,e=this.vertexBuffers.vertices.data.length/3;if(h){for(var a=h.data,b=new g.Indexer,h=0;h<a.length;h+=3)for(var c=a.subarray(h,h+3),d=0;d<c.length;d++){var f=c[d],k=c[(d+1)%c.length];b.add([Math.min(f,k),Math.max(f,k)])}a=b.unique;b=65536<e?new Uint32Array(2*a.length):new Uint16Array(2*a.length);h=0;for(e=a.length;h<e;++h)b.set(a[h],2*h)}else for(h=e/3,b=65536<e?new Uint32Array(6*h):new Uint16Array(6*h),h=0;h<e;h+=3)b[2*
h]=h,b[2*h+1]=h+1,b[2*h+2]=h+1,b[2*h+3]=h+2,b[2*h+4]=h+2,b[2*h+5]=h;this.createIndexBuffer("wireframe",b);return this};Mesh.prototype.flipNormals=function(h){var e=this.vertexBuffers.normals;if(e){for(var a=e.data,b=a.length,c=0;c<b;++c)a[c]*=-1;e.upload(h);this.indexBuffers.triangles||this.computeIndices();e=this.indexBuffers.triangles;a=e.data;b=a.length;for(c=0;c<b;c+=3){var d=a[c];a[c]=a[c+1];a[c+1]=d}e.upload(h)}};Mesh.prototype.computeIndices=function(){var h=[],e=[],a=[],b=[],c=this.vertexBuffers.normals,
d=this.vertexBuffers.coords,f=this.vertexBuffers.vertices.data,k=null;c&&(k=c.data);c=null;d&&(c=d.data);for(var d={},q=f.length/3,l=0;l<q;++l){var m=f.subarray(3*l,3*(l+1)),n=1E3*m[0]|0,p=0,r=d[n];if(r)for(var v=r.length;p<v;p++)if(0.01>vec3.sqrDist(m,h[r[p]])){b.push(p);break}r&&p!=v||(h.push(m),d[n]?d[n].push(p):d[n]=[p],k&&e.push(k.subarray(3*l,3*(l+1))),c&&a.push(c.subarray(2*l,2*(l+1))),b.push(p))}this.vertexBuffers={};this.createVertexBuffer("vertices",g.Mesh.common_buffers.vertices.attribute,
3,R(h));k&&this.createVertexBuffer("normals",g.Mesh.common_buffers.normals.attribute,3,R(e));c&&this.createVertexBuffer("coords",g.Mesh.common_buffers.coords.attribute,2,R(a));this.createIndexBuffer("triangles",b)};Mesh.prototype.explodeIndices=function(h){h=h||"triangles";var e=this.getIndexBuffer(h);if(e){var a=e.data,e={},b;for(b in this.vertexBuffers){var c=g.Mesh.common_buffers[b];e[b]=new (c.type||Float32Array)(c.spacing*a.length)}b=0;for(var d=a.length;b<d;++b){var f=a[b],k;for(k in this.vertexBuffers){var q=
this.vertexBuffers[k],c=g.Mesh.common_buffers[k],c=q.spacing||c.spacing;e[k].set(q.data.subarray(f*c,f*c+c),b*c)}}for(b in e)k=this.vertexBuffers[b],this.createVertexBuffer(b,k.attribute,k.spacing,e[b]);delete this.indexBuffers[h]}};Mesh.prototype.computeNormals=function(h){if(!this.vertexBuffers.vertices)return console.error("Cannot compute normals of a mesh without vertices");var e=this.vertexBuffers.vertices.data,a=new Float32Array(e.length),b=null;this.indexBuffers.triangles&&(b=this.indexBuffers.triangles.data);
for(var c=g.temp_vec3,d=g.temp2_vec3,f,k,q,l,m,n,p=b?b.length:e.length,r=0;r<p;r+=3)b?(f=b[r],k=b[r+1],q=b[r+2],l=e.subarray(3*f,3*f+3),m=e.subarray(3*k,3*k+3),n=e.subarray(3*q,3*q+3),f=a.subarray(3*f,3*f+3),k=a.subarray(3*k,3*k+3),q=a.subarray(3*q,3*q+3)):(l=e.subarray(3*r,3*r+3),m=e.subarray(3*r+3,3*r+6),n=e.subarray(3*r+6,3*r+9),f=a.subarray(3*r,3*r+3),k=a.subarray(3*r+3,3*r+6),q=a.subarray(3*r+6,3*r+9)),vec3.sub(c,m,l),vec3.sub(d,n,l),vec3.cross(c,c,d),vec3.normalize(c,c),vec3.add(f,f,c),vec3.add(k,
k,c),vec3.add(q,q,c);if(b)for(r=0,p=a.length;r<p;r+=3)e=a.subarray(r,r+3),vec3.normalize(e,e);if(p=this.vertexBuffers.normals)p.data=a,p.upload(h);else return this.createVertexBuffer("normals",g.Mesh.common_buffers.normals.attribute,3,a);return p};Mesh.prototype.computeTangents=function(){var h=this.vertexBuffers.vertices;if(!h)return console.error("Cannot compute tangents of a mesh without vertices");var e=this.vertexBuffers.normals;if(!e)return console.error("Cannot compute tangents of a mesh without normals");
var a=this.vertexBuffers.coords;if(!a)return console.error("Cannot compute tangents of a mesh without uvs");var b=this.indexBuffers.triangles;if(!b)return console.error("Cannot compute tangents of a mesh without indices");var h=h.data,e=e.data,c=a.data,d=b.data;if(h&&e&&c){var f=h.length/3,b=new Float32Array(4*f),a=new Float32Array(6*f),f=a.subarray(3*f),k,g,l=vec3.create(),m=vec3.create(),n=vec3.create(),p=vec3.create();k=0;for(g=d.length;k<g;k+=3){var r=d[k],v=d[k+1],u=d[k+2],s=h.subarray(3*r,3*
r+3),x=h.subarray(3*v,3*v+3),w=h.subarray(3*u,3*u+3),M=c.subarray(2*r,2*r+2),z=c.subarray(2*v,2*v+2),C=c.subarray(2*u,2*u+2),t=x[0]-s[0],Q=w[0]-s[0],y=x[1]-s[1],B=w[1]-s[1],x=x[2]-s[2],s=w[2]-s[2],w=z[0]-M[0],F=C[0]-M[0],z=z[1]-M[1],M=C[1]-M[1],C=w*M-F*z,C=1E-9>Math.abs(C)?0:1/C;vec3.copy(l,[(M*t-z*Q)*C,(M*y-z*B)*C,(M*x-z*s)*C]);vec3.copy(m,[(w*Q-F*t)*C,(w*B-F*y)*C,(w*s-F*x)*C]);vec3.add(a.subarray(3*r,3*r+3),a.subarray(3*r,3*r+3),l);vec3.add(a.subarray(3*v,3*v+3),a.subarray(3*v,3*v+3),l);vec3.add(a.subarray(3*
u,3*u+3),a.subarray(3*u,3*u+3),l);vec3.add(f.subarray(3*r,3*r+3),f.subarray(3*r,3*r+3),m);vec3.add(f.subarray(3*v,3*v+3),f.subarray(3*v,3*v+3),m);vec3.add(f.subarray(3*u,3*u+3),f.subarray(3*u,3*u+3),m)}k=0;for(g=h.length;k<g;k+=3)h=e.subarray(k,k+3),c=a.subarray(k,k+3),vec3.subtract(n,c,vec3.scale(n,h,vec3.dot(h,c))),vec3.normalize(n,n),h=0>vec3.dot(vec3.cross(p,h,c),f.subarray(k,k+3))?-1:1,b.set([n[0],n[1],n[2],h],k/3*4);this.createVertexBuffer("tangents",Mesh.common_buffers.tangents.attribute,4,
b)}};Mesh.prototype.computeTextureCoordinates=function(h){var e=this.vertexBuffers.vertices;if(!e)return console.error("Cannot compute uvs of a mesh without vertices");this.explodeIndices("triangles");var e=e.data,a=this.vertexBuffers.coords,b=new Float32Array(e.length/3*2),c=this.indexBuffers.triangles,d=null;c&&(d=c.data);var c=vec3.create(),f=vec3.create(),k=vec3.create(),g=this.getBoundingBox(),l=BBox.getCenter(g),m=vec3.create();m.set(BBox.getHalfsize(g));vec3.scale(m,m,2);for(var g=d?d.length:
e.length/3,n=0;n<g;n+=3){if(d)var p=d[n],r=d[n+1],v=d[n+2],u=e.subarray(3*p,3*p+3),s=e.subarray(3*r,3*r+3),x=e.subarray(3*v,3*v+3),p=b.subarray(2*p,2*p+2),r=b.subarray(2*r,2*r+2),v=b.subarray(2*v,2*v+2);else u=e.subarray(3*n,3*n+3),s=e.subarray(3*(n+1),3*(n+1)+3),x=e.subarray(3*(n+2),3*(n+2)+3),p=b.subarray(2*n,2*n+2),r=b.subarray(2*(n+1),2*(n+1)+2),v=b.subarray(2*(n+2),2*(n+2)+2);vec3.sub(f,u,s);vec3.sub(k,u,x);vec3.cross(c,f,k);c[0]=Math.abs(c[0]);c[1]=Math.abs(c[1]);c[2]=Math.abs(c[2]);c[0]>c[1]&&
c[0]>c[2]?(p[0]=(u[2]-l[2])/m[2],p[1]=(u[1]-l[1])/m[1],r[0]=(s[2]-l[2])/m[2],r[1]=(s[1]-l[1])/m[1],v[0]=(x[2]-l[2])/m[2],v[1]=(x[1]-l[1])/m[1]):c[1]>c[2]?(p[0]=(u[0]-l[0])/m[0],p[1]=(u[2]-l[2])/m[2],r[0]=(s[0]-l[0])/m[0],r[1]=(s[2]-l[2])/m[2],v[0]=(x[0]-l[0])/m[0],v[1]=(x[2]-l[2])/m[2]):(p[0]=(u[0]-l[0])/m[0],p[1]=(u[1]-l[1])/m[1],r[0]=(s[0]-l[0])/m[0],r[1]=(s[1]-l[1])/m[1],v[0]=(x[0]-l[0])/m[0],v[1]=(x[1]-l[1])/m[1])}a?(a.data=b,a.upload(h)):this.createVertexBuffer("coords",Mesh.common_buffers.coords.attribute,
2,b)};Mesh.prototype.getNumVertices=function(){var h=this.vertexBuffers.vertices;return h?h.data.length/h.spacing:0};Mesh.prototype.getNumTriangles=function(){var h=this.getIndexBuffer("triangles");return h?h.data.length/3:this.getNumVertices()/3};Mesh.computeBoundingBox=function(h,e,a){if(h){var b=0;if(a){for(var c=0;c<a.length;++c)if(a[c]){b=c;break}if(b==a.length){console.warn("mask contains only zeros, no vertices marked");return}}for(var d=vec3.clone(h.subarray(3*b,3*b+3)),f=vec3.clone(h.subarray(3*
b,3*b+3)),c=3*b;c<h.length;c+=3)if(!a||a[c/3])b=h.subarray(c,c+3),vec3.min(d,b,d),vec3.max(f,b,f);if(isNaN(d[0])||isNaN(d[1])||isNaN(d[2])||isNaN(f[0])||isNaN(f[1])||isNaN(f[2]))d[0]=d[1]=d[2]=0,f[0]=f[1]=f[2]=0,console.warn("Warning: GL.Mesh has NaN values in vertices");h=vec3.add(vec3.create(),d,f);vec3.scale(h,h,0.5);f=vec3.subtract(vec3.create(),f,h);return BBox.setCenterHalfsize(e||BBox.create(),h,f)}};Mesh.prototype.getBoundingBox=function(){if(this._bounding)return this._bounding;this.updateBoundingBox();
return this._bounding};Mesh.prototype.updateBoundingBox=function(){var h=this.vertexBuffers.vertices;h&&(g.Mesh.computeBoundingBox(h.data,this._bounding),this.info&&this.info.groups&&this.info.groups.length&&this.computeGroupsBoundingBoxes())};Mesh.prototype.computeGroupsBoundingBoxes=function(){var h=null,e=this.getIndexBuffer("triangles");e&&(h=e.data);e=this.getVertexBuffer("vertices");if(!e)return!1;e=e.data;if(!e.length)return!1;var a=this.info.groups;if(a){for(var b=0;b<a.length;++b){var c=
a[b];c.bounding=c.bounding||BBox.create();var d=null;if(h){for(var d=new Uint8Array(e.length/3),f=c.start,k=0,q=c.length;k<q;k+=3)d[h[f+k]]=1,d[h[f+k+1]]=1,d[h[f+k+2]]=1;g.Mesh.computeBoundingBox(e,c.bounding,d)}else d=e.subarray(3*c.start,3*(c.start+c.length)),g.Mesh.computeBoundingBox(d,c.bounding)}return!0}};Mesh.prototype.setBoundingBox=function(h,e){BBox.setCenterHalfsize(this._bounding,h,e)};Mesh.prototype.freeData=function(){for(var h in this.vertexBuffers)this.vertexBuffers[h].data=null,delete this[this.vertexBuffers[h].name];
for(var e in this.indexBuffers)this.indexBuffers[e].data=null,delete this[this.indexBuffers[e].name]};Mesh.prototype.configure=function(h,e){var a={},b={};e=e||{};for(var c in h)if(h[c])if("vertexBuffers"==c||"vertex_buffers"==c)for(d in h[c])a[d]=h[c][d];else if("indexBuffers"==c||"index_buffers"==c)for(d in h[c])b[d]=h[c][d];else"indices"==c||"lines"==c||"wireframe"==c||"triangles"==c?b[c]=h[c]:g.Mesh.common_buffers[c]?a[c]=h[c]:e[c]=h[c];this.addBuffers(a,b,e.stream_type);for(var d in e)this[d]=
e[d];e.bounding||this.updateBoundingBox()};Mesh.prototype.totalMemory=function(){var h=0,e;for(e in this.vertexBuffers)h+=this.vertexBuffers[e].data.buffer.byteLength;for(e in this.indexBuffers)h+=this.indexBuffers[e].data.buffer.byteLength;return h};Mesh.prototype.slice=function(h,e){var a={},b=this.indexBuffers.triangles;if(!b)return console.warn("splice in not indexed not supported yet"),null;var b=b.data,c=[],d=new Int32Array(b.length);d.fill(-1);var f=h+e;f>=b.length&&(f=b.length);for(var k=
0,q=h;q<f;++q){var l=b[q];if(-1!=d[l])c.push(d[l]);else{var m=k++;d[l]=m;c.push(m);for(var n in this.vertexBuffers){var p=this.vertexBuffers[n],m=p.data,p=p.spacing;a[n]||(a[n]=[]);for(var r=a[n],v=0;v<p;++v)r.push(m[v+l*p])}}}a=new g.Mesh(a,{triangles:c},null,gl);a.updateBoundingBox();return a};Mesh.prototype.simplify=function(){var h=this.getBoundingBox(),e=BBox.getMin(h),h=BBox.getHalfsize(h),h=vec3.scale(vec3.create(),h,2),a=new g.Mesh,b=vec3.create(),c;for(c in this.vertexBuffers){var d=this.vertexBuffers[c].data,
f=new Float32Array(d.length);if("vertices"==c)for(var k=0,q=d.length;k<q;k+=3){var l=d.subarray(k,k+3);vec3.sub(b,l,e);vec3.div(b,b,h);b[0]=Math.round(256*b[0])/256;b[1]=Math.round(256*b[1])/256;b[2]=Math.round(256*b[2])/256;vec3.mul(b,b,h);vec3.add(b,b,e);f.set(b,k)}a.addBuffer()}};Mesh.load=function(h,e,a,b){e=e||{};e.no_gl&&(b=null);a=a||new g.Mesh(null,null,null,b);a.configure(h,e);return a};Mesh.mergeMeshes=function(h,e){function a(a,b,c,d){for(c=b+c;b<c;b+=3){var e=a.subarray(b,b+3);vec3.transformMat4(e,
e,d)}}function b(a,b,c,d){for(c=b+c;b<c;b+=2){var e=a.subarray(b,b+2);vec2.transformMat3(e,e,d)}}function c(a,b,c,d){if(d)for(c=b+c;b<c;++b)a[b]+=d}e=e||{};for(var d={},f={},k={},q=[],l=0,m=[],n=0;n<h.length;++n){var p=h[n],r=p.mesh,v=l;q.push(v);var u=r.vertexBuffers.vertices.data.length/3,l=l+u,s;for(s in r.vertexBuffers)d[s]=d[s]?d[s]+r.vertexBuffers[s].data.length:r.vertexBuffers[s].data.length;for(s in r.indexBuffers)f[s]=f[s]?f[s]+r.indexBuffers[s].data.length:r.indexBuffers[s].data.length;
m.push({name:"mesh_"+n,start:v,length:u,material:""})}for(s in d)n=e[s],null===n?delete d[s]:(n||(n=Float32Array),d[s]=new n(d[s]),k[s]=0);for(s in f)n=65536>l?Uint16Array:Uint32Array,f[s]=new n(f[s]),k[s]=0;for(n=0;n<h.length;++n){p=h[n];r=p.mesh;u=v=0;for(s in r.vertexBuffers)d[s]&&("vertices"==s&&(u=r.vertexBuffers[s].data.length/3),d[s].set(r.vertexBuffers[s].data,k[s]),p[s+"_matrix"]&&(l=p[s+"_matrix"],16==l.length?a(d[s],k[s],r.vertexBuffers[s].data.length,l):9==l.length&&b(d[s],k[s],r.vertexBuffers[s].data.length,
l)),k[s]+=r.vertexBuffers[s].data.length);for(s in r.indexBuffers)f[s].set(r.indexBuffers[s].data,k[s]),c(f[s],k[s],r.indexBuffers[s].data.length,q[n]),k[s]+=r.indexBuffers[s].data.length}k={info:{groups:m}};return"undefined"!=typeof gl||e.only_data?new g.Mesh(d,f,k):{vertexBuffers:d,indexBuffers:f,info:{groups:m}}};Mesh.parsers={};Mesh.encoders={};Mesh.binary_file_formats={};Mesh.compressors={};Mesh.decompressors={};Mesh.fromURL=function(h,e,a,b){b=b||{};a=a||t.gl;var c=new g.Mesh(void 0,void 0,
void 0,a);c.ready=!1;a=h.lastIndexOf(".");var d=h.substr(a+1).toLowerCase();b.extension&&(d=b.extension);b.binary=Mesh.binary_file_formats[d];HttpRequest(h,null,function(a){c.parse(a,d,b);delete c.ready;e&&e.call(c,c,h,b)},function(a){e&&e(null)},b);return c};Mesh.prototype.parse=function(h,e,a){a=a||{};a.mesh=this;e=e.toLowerCase();var b=g.Mesh.parsers[e];if(b)return b.call(null,h,a);throw"GL.Mesh.parse: no parser found for format "+e;};Mesh.prototype.encode=function(h,e){h=h.toLowerCase();var a=
g.Mesh.encoders[h];if(a)return a.call(null,this,e);throw"GL.Mesh.encode: no encoder found for format "+h;};Mesh.getScreenQuad=function(h){h=h||t.gl;var e=h.meshes[":screen_quad"];if(e)return e;var e=new Float32Array([0,0,0,1,1,0,0,1,0,0,0,0,1,0,0,1,1,0]),a=new Float32Array([0,0,1,1,0,1,0,0,1,0,1,1]),e=new g.Mesh({vertices:e,coords:a},void 0,void 0,h);return h.meshes[":screen_quad"]=e};g.linearizeArray=R;g.Mesh.EXTENSION="wbin";g.Mesh.enable_wbin_compression=!0;K.DEFAULT_NORMAL=vec3.fromValues(0,1,
0);K.DEFAULT_COORD=vec2.fromValues(0.5,0.5);K.DEFAULT_COLOR=vec4.fromValues(1,1,1,1);K.prototype.resize=function(h){var e={};this._vertex_data=new Float32Array(3*h);e.vertices=this._vertex_data;normals&&(e.normals=this._normal_data=new Float32Array(3*h));coords&&(e.coords=this._coord_data=new Float32Array(2*h));colors&&(e.colors=this._color_data=new Float32Array(4*h));this.addBuffers(e);this.current_pos=0;this.max_size=h;this._must_update=!0};K.prototype.clear=function(){this.current_pos=0};K.prototype.addPoint=
function(h,e,a,b){if(c>=this.max_size)return console.warn("DynamicMesh: not enough space, reserve more"),!1;var c=this.current_pos++;this._vertex_data.set(h,3*c);this._normal_data&&this._normal_data.set(e||K.DEFAULT_NORMAL,3*c);this._coord_data&&this._coord_data.set(a||K.DEFAULT_COORD,2*c);this._color_data&&this._color_data.set(b||K.DEFAULT_COLOR,4*c);return this._must_update=!0};K.prototype.update=function(h){if(!this._must_update&&!h)return this.current_pos;this._must_update=!1;this.getBuffer("vertices").upload(gl.STREAM_DRAW);
this._normal_data&&this.getBuffer("normal").upload(gl.STREAM_DRAW);this._coord_data&&this.getBuffer("coord").upload(gl.STREAM_DRAW);this._color_data&&this.getBuffer("color").upload(gl.STREAM_DRAW);return this.current_pos};extendClass(K,Mesh);Mesh.plane=function(h,e){h=h||{};h.triangles=[];var a=h.detailX||h.detail||1,b=h.detailY||h.detail||1,c=h.width||h.size||1,d=h.height||h.size||1,f=h.xz,c=0.5*c,d=0.5*d,k=[],q=[],l=[],m=[],n=vec3.fromValues(0,0,1);f&&n.set([0,1,0]);for(var p=0;p<=b;p++)for(var r=
p/b,v=0;v<=a;v++){var u=v/a;f?q.push((2*u-1)*c,0,-(2*r-1)*d):q.push((2*u-1)*c,(2*r-1)*d,0);l.push(u,r);m.push(n[0],n[1],n[2]);v<a&&p<b&&(u=v+p*(a+1),f?(k.push(u+1,u+a+1,u),k.push(u+1,u+a+2,u+a+1)):(k.push(u,u+1,u+a+1),k.push(u+a+1,u+1,u+a+2)))}a=BBox.fromCenterHalfsize([0,0,0],f?[c,0,d]:[c,d,0]);return g.Mesh.load({vertices:q,normals:m,coords:l,triangles:k},{bounding:a},e)};Mesh.plane2D=function(h,e){var a=new Float32Array([-1,1,1,-1,1,1,-1,1,-1,-1,1,-1]),b=new Float32Array([0,1,1,0,1,1,0,1,0,0,1,
0]);if(h&&h.size)for(var c=0.5*h.size,d=0;d<a.length;++d)a[d]*=c;return new g.Mesh({vertices2D:a,coords:b},null,e)};Mesh.point=function(h){return new g.Mesh({vertices:[0,0,0]})};Mesh.cube=function(h,e){h=h||{};var a=0.5*(h.size||1),b={};b.vertices=new Float32Array([-1,1,-1,-1,-1,1,-1,1,1,-1,1,-1,-1,-1,-1,-1,-1,1,1,1,-1,1,1,1,1,-1,1,1,1,-1,1,-1,1,1,-1,-1,-1,1,1,1,-1,1,1,1,1,-1,1,1,-1,-1,1,1,-1,1,-1,1,-1,1,1,-1,1,-1,-1,-1,1,-1,1,-1,-1,-1,-1,-1,-1,1,-1,1,1,1,1,1,-1,-1,1,-1,-1,1,1,1,1,1,-1,-1,-1,1,-1,
-1,1,-1,1,-1,-1,-1,1,-1,1,-1,-1,1]);for(var c=0,d=b.vertices.length;c<d;++c)b.vertices[c]*=a;b.normals=new Float32Array([-1,0,0,-1,0,0,-1,0,0,-1,0,0,-1,0,0,-1,0,0,1,0,0,1,0,0,1,0,0,1,0,0,1,0,0,1,0,0,0,0,1,0,0,1,0,0,1,0,0,1,0,0,1,0,0,1,0,0,-1,0,0,-1,0,0,-1,0,0,-1,0,0,-1,0,0,-1,0,1,0,0,1,0,0,1,0,0,1,0,0,1,0,0,1,0,0,-1,0,0,-1,0,0,-1,0,0,-1,0,0,-1,0,0,-1,0]);b.coords=new Float32Array([0,1,1,0,1,1,0,1,0,0,1,0,1,1,0,1,0,0,1,1,0,0,1,0,0,1,1,0,1,1,0,1,0,0,1,0,1,1,0,1,0,0,1,1,0,0,1,0,0,1,1,0,1,1,0,1,0,0,1,
0,1,1,0,1,0,0,1,1,0,0,1,0]);h.wireframe&&(b.wireframe=new Uint16Array([0,2,2,5,5,4,4,0,6,7,7,10,10,11,11,6,0,6,2,7,5,10,4,11]));h.bounding=BBox.fromCenterHalfsize([0,0,0],[a,a,a]);return g.Mesh.load(b,h,e)};Mesh.box=function(h,e){h=h||{};var a=h.sizex||1,b=h.sizey||1,c=h.sizez||1,a=0.5*a,b=0.5*b,c=0.5*c,d={};d.vertices=new Float32Array([-1,1,-1,-1,-1,1,-1,1,1,-1,1,-1,-1,-1,-1,-1,-1,1,1,1,-1,1,1,1,1,-1,1,1,1,-1,1,-1,1,1,-1,-1,-1,1,1,1,-1,1,1,1,1,-1,1,1,-1,-1,1,1,-1,1,-1,1,-1,1,1,-1,1,-1,-1,-1,1,-1,
1,-1,-1,-1,-1,-1,-1,1,-1,1,1,1,1,1,-1,-1,1,-1,-1,1,1,1,1,1,-1,-1,-1,1,-1,-1,1,-1,1,-1,-1,-1,1,-1,1,-1,-1,1]);for(var f=0,k=d.vertices.length;f<k;f+=3)d.vertices[f]*=a,d.vertices[f+1]*=b,d.vertices[f+2]*=c;d.normals=new Float32Array([-1,0,0,-1,0,0,-1,0,0,-1,0,0,-1,0,0,-1,0,0,1,0,0,1,0,0,1,0,0,1,0,0,1,0,0,1,0,0,0,0,1,0,0,1,0,0,1,0,0,1,0,0,1,0,0,1,0,0,-1,0,0,-1,0,0,-1,0,0,-1,0,0,-1,0,0,-1,0,1,0,0,1,0,0,1,0,0,1,0,0,1,0,0,1,0,0,-1,0,0,-1,0,0,-1,0,0,-1,0,0,-1,0,0,-1,0]);d.coords=new Float32Array([0,1,1,
0,1,1,0,1,0,0,1,0,1,1,0,1,0,0,1,1,0,0,1,0,0,1,1,0,1,1,0,1,0,0,1,0,1,1,0,1,0,0,1,1,0,0,1,0,0,1,1,0,1,1,0,1,0,0,1,0,1,1,0,1,0,0,1,1,0,0,1,0]);h.wireframe&&(d.wireframe=new Uint16Array([0,2,2,5,5,4,4,0,6,7,7,10,10,11,11,6,0,6,2,7,5,10,4,11]));h.bounding=BBox.fromCenterHalfsize([0,0,0],[a,b,c]);return g.Mesh.load(d,h,e)};Mesh.circle=function(h,e){h=h||{};var a=h.size||h.radius||1,b=Math.ceil(h.slices||24),c=h.xz||!1,d=h.empty||!1;3>b&&(b=3);var f=2*Math.PI/b,k=vec3.create(),q=vec3.create(),l=vec3.fromValues(0,
0,1),m=vec2.fromValues(0.5,0.5),n=vec2.create();c&&l.set([0,1,0]);var p=c?2:1,r=new Float32Array(3*(b+1)),v=new Float32Array(3*(b+1)),u=new Float32Array(2*(b+1)),s=null;r.set(k,0);v.set(l,0);u.set(m,0);for(k=m=s=0;k<b;++k)s=Math.sin(f*k),m=Math.cos(f*k),q[0]=s*a,q[p]=m*a,n[0]=0.5*s+0.5,n[1]=0.5*m+0.5,r.set(q,3*k+3),v.set(l,3*k+3),u.set(n,2*k+2);if(d)r=r.subarray(3),v=r.subarray(3),u=r.subarray(2),s=null;else{s=new Uint16Array(3*b);d=2;f=1;c&&(d=1,f=2);for(k=0;k<b-1;++k)s[3*k]=0,s[3*k+1]=k+d,s[3*k+
2]=k+f;s[3*k]=0;c?(s[3*k+1]=k+1,s[3*k+2]=1):(s[3*k+1]=1,s[3*k+2]=k+1)}h.bounding=BBox.fromCenterHalfsize([0,0,0],c?[a,0,a]:[a,a,0]);a={vertices:r,normals:v,coords:u,triangles:s};if(h.wireframe){c=new Uint16Array(2*b);for(k=0;k<b;k++)c[2*k]=k,c[2*k+1]=k+1;c[0]=b;a.wireframe=c}return g.Mesh.load(a,h,e)};Mesh.ring=function(h,e){h=h||{};var a=h.size||h.radius||1,b=h.thickness||0.1*a,c=Math.ceil(h.slices||24),d=h.xz||!1,f=h.empty||!1;3>c&&(c=3);var k=2*Math.PI/c;vec3.create();var q=vec3.create(),l=vec3.create(),
m=vec3.fromValues(0,0,1);vec2.fromValues(0.5,0.5);var n=vec2.create();d&&m.set([0,1,0]);for(var p=d?2:1,r=new Float32Array(3*(2*c+2)),v=new Float32Array(3*(2*c+2)),u=new Float32Array(2*(2*c+2)),s=null,x=s=0,w=0;w<=c;++w)s=Math.sin(k*w),x=Math.cos(k*w),q[0]=s*(a-b),q[p]=x*(a-b),n[0]=w/c,n[1]=0,r.set(q,6*w),v.set(m,6*w),u.set(n,4*w),l[0]=s*(a+b),l[p]=x*(a+b),n[1]=1,r.set(l,6*w+3),v.set(m,6*w+3),u.set(n,4*w+2);if(f)r=r.subarray(3),v=r.subarray(3),u=r.subarray(2),s=null;else for(s=new Uint16Array(6*c),
f=2,k=1,d&&(f=1,k=2),w=0;w<c;++w)s[6*w]=2*w,s[6*w+1]=2*w+f,s[6*w+2]=2*w+k,s[6*w+3]=2*w+k,s[6*w+4]=2*w+f,s[6*w+5]=2*w+3;h.bounding=BBox.fromCenterHalfsize([0,0,0],d?[a+b,0,a+b]:[a+b,a+b,0]);a={vertices:r,normals:v,coords:u,triangles:s};if(h.wireframe){b=new Uint16Array(4*c);for(w=0;w<c;w++)b[4*w]=2*w,b[4*w+1]=2*w+2,b[4*w+2]=2*w+1,b[4*w+3]=2*w+3;a.wireframe=b}return g.Mesh.load(a,h,e)};Mesh.cylinder=function(h,e){h=h||{};for(var a=h.radius||h.size||1,b=h.height||h.size||2,c=h.subdivisions||64,d=new Float32Array(36*
c),f=new Float32Array(36*c),k=new Float32Array(24*c),g=2*Math.PI/c,l=null,m=0;m<c;++m){var n=m*g,l=[Math.sin(n),0,Math.cos(n)];d.set([l[0]*a,0.5*b,l[2]*a],18*m);f.set(l,18*m);k.set([m/c,1],12*m);l=[Math.sin(n),0,Math.cos(n)];d.set([l[0]*a,-0.5*b,l[2]*a],18*m+3);f.set(l,18*m+3);k.set([m/c,0],12*m+2);l=[Math.sin(n+g),0,Math.cos(n+g)];d.set([l[0]*a,-0.5*b,l[2]*a],18*m+6);f.set(l,18*m+6);k.set([(m+1)/c,0],12*m+4);l=[Math.sin(n+g),0,Math.cos(n+g)];d.set([l[0]*a,0.5*b,l[2]*a],18*m+9);f.set(l,18*m+9);k.set([(m+
1)/c,1],12*m+6);l=[Math.sin(n),0,Math.cos(n)];d.set([l[0]*a,0.5*b,l[2]*a],18*m+12);f.set(l,18*m+12);k.set([m/c,1],12*m+8);l=[Math.sin(n+g),0,Math.cos(n+g)];d.set([l[0]*a,-0.5*b,l[2]*a],18*m+15);f.set(l,18*m+15);k.set([(m+1)/c,0],12*m+10)}var l=18*m,p=12*m;if(!1===h.caps)d=d.subarray(0,l),f=f.subarray(0,l),k=k.subarray(0,p);else for(var r=vec3.fromValues(0,0.5*b,0),v=vec3.fromValues(0,-0.5*b,0),u=vec3.fromValues(0,1,0),s=vec3.fromValues(0,-1,0),m=0;m<c;++m){var n=m*g,x=vec3.fromValues(Math.sin(n),
0,Math.cos(n)),n=vec3.fromValues(Math.sin(n+g),0,Math.cos(n+g));d.set([x[0]*a,0.5*b,x[2]*a],l+18*m);f.set(u,l+18*m);k.set([0.5*-x[0]+0.5,0.5*x[2]+0.5],p+12*m);d.set([n[0]*a,0.5*b,n[2]*a],l+18*m+3);f.set(u,l+18*m+3);k.set([0.5*-n[0]+0.5,0.5*n[2]+0.5],p+12*m+2);d.set(r,l+18*m+6);f.set(u,l+18*m+6);k.set([0.5,0.5],p+12*m+4);d.set([n[0]*a,-0.5*b,n[2]*a],l+18*m+9);f.set(s,l+18*m+9);k.set([0.5*n[0]+0.5,0.5*n[2]+0.5],p+12*m+6);d.set([x[0]*a,-0.5*b,x[2]*a],l+18*m+12);f.set(s,l+18*m+12);k.set([0.5*x[0]+0.5,
0.5*x[2]+0.5],p+12*m+8);d.set(v,l+18*m+15);f.set(s,l+18*m+15);k.set([0.5,0.5],p+12*m+10)}c={vertices:d,normals:f,coords:k};h.bounding=BBox.fromCenterHalfsize([0,0,0],[a,0.5*b,a]);h.info={groups:[]};!1!==h.caps&&(h.info.groups.push({name:"side",start:0,length:l/3}),h.info.groups.push({name:"caps",start:l/3,length:(d.length-l)/3}));return Mesh.load(c,h,e)};Mesh.cone=function(h,e){h=h||{};for(var a=h.radius||h.size||1,b=h.height||h.size||2,c=h.subdivisions||64,d=new Float32Array(18*c),f=new Float32Array(18*
c),k=new Float32Array(12*c),g=2*Math.PI/c,l=null,m=a/b,n=0;n<c;++n){var p=n*g,l=[Math.sin(p+0.5*g),m,Math.cos(p+0.5*g)];vec3.normalize(l,l);d.set([0,b,0],18*n);f.set(l,18*n);k.set([n/c,1],12*n);l=[Math.sin(p),m,Math.cos(p)];d.set([l[0]*a,0,l[2]*a],18*n+3);vec3.normalize(l,l);f.set(l,18*n+3);k.set([n/c,0],12*n+2);l=[Math.sin(p+g),m,Math.cos(p+g)];d.set([l[0]*a,0,l[2]*a],18*n+6);vec3.normalize(l,l);f.set(l,18*n+6);k.set([(n+1)/c,0],12*n+4)}l=vec3.fromValues(0,0,0);m=vec3.fromValues(0,-1,0);for(n=0;n<
c;++n){var p=n*g,r=vec3.fromValues(Math.sin(p),0,Math.cos(p)),p=vec3.fromValues(Math.sin(p+g),0,Math.cos(p+g));d.set([p[0]*a,0,p[2]*a],18*n+9);f.set(m,18*n+9);k.set([0.5*p[0]+0.5,0.5*p[2]+0.5],12*n+6);d.set([r[0]*a,0,r[2]*a],18*n+12);f.set(m,18*n+12);k.set([0.5*r[0]+0.5,0.5*r[2]+0.5],12*n+8);d.set(l,18*n+15);f.set(m,18*n+15);k.set([0.5,0.5],12*n+10)}c={vertices:d,normals:f,coords:k};h.bounding=BBox.fromCenterHalfsize([0,0.5*b,0],[a,0.5*b,a]);return Mesh.load(c,h,e)};Mesh.torus=function(h,e){h=h||
{};var a=h.outerradius||h.radius||1,b=Math.ceil(h.outerslices||h.slices||24),c=h.innerradius||0.1*a,d=Math.ceil(h.innerslices||b),f=h.angle||2*Math.PI,k=2*Math.PI/d,q=f/b;vec3.create();var l=vec3.create(),m=vec3.fromValues(0,0,1);vec2.fromValues(0.5,0.5);for(var n=vec2.create(),f=f==2*Math.PI,p=new Float32Array(3*d),r=new Float32Array(3*d),v=0,u=0,s=0;s<d;++s)v=Math.sin(k*s),u=Math.cos(k*s),l[0]=v*c,l[1]=u*c,n[0]=0.5*v+0.5,n[1]=0.5*u+0.5,p.set(l,3*s),vec3.normalize(m,l),r.set(m,3*s);var k=new Float32Array(3*
b*d),n=new Float32Array(3*b*d),v=new Float32Array(2*b*d),u=null,x=mat4.create(),w=vec3.fromValues(-a,0,0),M=vec3.fromValues(0,1,0);vec3.create();for(var u=[],z=d,s=0;s<b;++s){mat4.identity(x);mat4.rotate(x,x,s*q,M);mat4.translate(x,x,w);var t=s*d,z=d;s>=b-1&&(z=(b-1)*-d,f||(z=0));for(var J=0;J<d;++J){var Q=p.subarray(3*J,3*J+3),y=r.subarray(3*J,3*J+3);mat4.multiplyVec3(l,x,Q);mat4.rotateVec3(m,x,y);k.set(l,3*J+3*s*d);n.set(m,3*J+3*s*d);v.set([s/b,J/d],2*J+2*s*d);Q=t+J;y=t+(J+1)%d;u.push(y,Q,Q+z,y,
Q+z,y+z)}}a=c+a;h.bounding=BBox.fromCenterHalfsize([0,0,0],[a,a,c]);return g.Mesh.load({vertices:k,normals:n,coords:v,triangles:u},h,e)};Mesh.sphere=function(h,e){h=h||{};for(var a=h.radius||h.size||1,b=h.lat||h.subdivisions||16,c=h["long"]||h.subdivisions||16,d=new Float32Array((b+1)*(c+1)*3),f=new Float32Array((b+1)*(c+1)*3),k=new Float32Array((b+1)*(c+1)*2),q=new Uint16Array(b*c*6),l=h.hemi?0.5*Math.PI:Math.PI,m=0,n=0,p=0;p<=b;p++)for(var r=p*l/b,v=Math.sin(r),u=Math.cos(r),r=0;r<=c;r++){var s=
2*r*Math.PI/c,x=Math.sin(s),s=Math.cos(s)*v,w=u,x=x*v,t=1-r/c,z=1-p/b;d.set([a*s,a*w,a*x],m);f.set([s,w,x],m);k.set([t,z],n);m+=3;n+=2}for(p=m=0;p<b;p++)for(r=0;r<c;r++)l=p*(c+1)+r,n=l+c+1,q.set([n,l,l+1],m),q.set([n+1,n,l+1],m+3),m+=6;d={vertices:d,normals:f,coords:k,triangles:q};if(h.wireframe){f=new Uint16Array(c*b*4);for(m=k=0;m<b;m++){for(q=0;q<c;q++)f[k]=m*(c+1)+q,f[k+1]=m*(c+1)+q+1,k+=2;f[k-2*c]=m*(c+1)+q}for(m=0;m<c;m++)for(q=0;q<b;q++)f[k]=q*(c+1)+m,f[k+1]=(q+1)*(c+1)+m,k+=2;d.wireframe=
f}h.bounding=h.hemi?BBox.fromCenterHalfsize([0,0.5*a,0],[a,0.5*a,a],a):BBox.fromCenterHalfsize([0,0,0],[a,a,a],a);return g.Mesh.load(d,h,e)};Mesh.grid=function(h,e){h=h||{};var a=h.lines||11;0>a&&(a=1);for(var b=h.size||10,c=new Float32Array(12*a),d=0.5*b,f=0,k=-d,b=b/(a-1),q=0;q<a;q++)c[f]=k,c[f+2]=-d,c[f+3]=k,c[f+5]=d,c[f+6]=d,c[f+8]=k,c[f+9]=-d,c[f+11]=k,k+=b,f+=12;return new g.Mesh({vertices:c},h,e)};Mesh.icosahedron=function(h,e){function a(a,c){var d=l[a]<l[c]?l[a]+":"+l[c]:l[c]+":"+l[a],e=
u[d];if(e)return e;e=f.length/3;f.push(0.5*(f[3*l[a]]+f[3*l[c]]),0.5*(f[3*l[a]+1]+f[3*l[c]+1]),0.5*(f[3*l[a]+2]+f[3*l[c]+2]));var h=Math.sqrt(f[3*e]*f[3*e]+f[3*e+1]*f[3*e+1]+f[3*e+2]*f[3*e+2]),g=f[3*e]/h,m=f[3*e+1]/h,n=f[3*e+2]/h;k.push(g,m,n);q.push(Math.atan2(g,n)/Math.PI*0.5,Math.acos(m)/Math.PI);f[3*e]*=b/h;f[3*e+1]*=b/h;f[3*e+2]*=b/h;return u[d]=e}h=h||{};var b=h.radius||h.size||1,c=void 0===h.subdivisions?0:h.subdivisions;6<c&&(c=6);for(var d=(1+Math.sqrt(5))/2,f=[-1,d,0,1,d,0,-1,-d,0,1,-d,
0,0,-1,d,0,1,d,0,-1,-d,0,1,-d,d,0,-1,d,0,1,-d,0,-1,-d,0,1],k=[],q=[],l=[0,11,5,0,5,1,0,1,7,0,7,10,0,10,11,1,5,9,5,11,4,11,10,2,10,7,6,7,1,8,3,9,4,3,4,2,3,2,6,3,6,8,3,8,9,4,9,5,2,4,11,6,2,10,8,6,7,9,8,1],d=f.length,m=0;m<d;m+=3){var n=Math.sqrt(f[m]*f[m]+f[m+1]*f[m+1]+f[m+2]*f[m+2]),p=f[m]/n,r=f[m+1]/n,v=f[m+2]/n;k.push(p,r,v);q.push(Math.atan2(p,v),Math.acos(r));f[m]*=b/n;f[m+1]*=b/n;f[m+2]*=b/n}for(var u={},n=0;n<c;++n){p=[];d=l.length;for(m=0;m<d;m+=3){var r=a(m,m+1),v=a(m+1,m+2),s=a(m+2,m);p.push(l[m],
r,s);p.push(l[m+1],v,r);p.push(l[m+2],s,v);p.push(r,v,s)}l=p}h.bounding=BBox.fromCenterHalfsize([0,0,0],[b,b,b],b);return new g.Mesh.load({vertices:f,coords:q,normals:k,triangles:l},h,e)};Mesh.shape=function(h,e,a){function b(a,b){var c=a[b+1];a[b+1]=a[b+2];a[b+2]=-c}e=e||{};if("undefined"===typeof earcut)throw"To use GL.Mesh.shape you must download and include earcut.js (do not link it directly!): https://raw.githubusercontent.com/mapbox/earcut/master/src/earcut.js";if(!h||!h.length||1==h.length%
2)throw"GL.Mesh.shape line missing, must be an array of 2D vertices";var c=e.extrude||0;h[0].constructor===Array&&(h=earcut.flatten(h));var d=earcut(h).reverse();console.log(d);for(var f=[],k=[],q=[],l=[h[0],h[1]],m=[h[0],h[1]],n=0;n<h.length;n+=2)l[0]=Math.min(l[0],h[n]),l[1]=Math.max(l[1],h[n]),m[0]=Math.min(m[0],h[n+1]),m[1]=Math.max(m[1],h[n+1]);var p=l[1]-l[0],r=m[1]-m[0],v=[],u=null;if(c){for(var u=[],s=vec3.create(),x=h.length,n=0;n<h.length;n+=2){var w=h[n],t=h[n+1],z=h[(n+2)%x],C=h[(n+3)%
x],J=f.length/3;f.push(w,0.5*c,t);f.push(w,-0.5*c,t);f.push(z,0.5*c,C);f.push(z,-0.5*c,C);vec3.normalize(s,vec3.cross(s,[0,1,0],[z-w,0,C-t]));k.push(s[0],s[1],s[2],s[0],s[1],s[2],s[0],s[1],s[2],s[0],s[1],s[2]);var y=(w-l[0])/p,B=(t-m[0])/r,w=(z-l[0])/p,t=(C-m[0])/r;q.push(y,B,y,B,w,t,w,t);u.push(J,J+2,J+1,J+2,J+3,J+1)}v.push({name:"side",start:0,length:u.length});s=f.length/3;x=u.length;for(n=0;n<h.length;n+=2)w=h[n],t=h[n+1],y=(w-l[0])/p,B=(t-m[0])/r,f.push(w,0.5*c,t),f.push(w,-0.5*c,t),k.push(0,
1,0,0,-1,0),q.push(y,B,y,B);for(n=0;n<d.length;n+=3)u.push(s+2*d[n],s+2*d[n+1],s+2*d[n+2]),u.push(s+2*d[n]+1,s+2*d[n+2]+1,s+2*d[n+1]+1);v.push({name:"caps",start:x,length:u.length});e.bounding=BBox.fromCenterHalfsize([0.5*(l[0]+l[1]),0,0.5*(m[0]+m[1])],[0.5*p,0.5*c,0.5*r],vec2.len([0.5*p,0.5*c,0.5*r]))}else{for(n=0;n<h.length;n+=2)f.push(h[n],0,h[n+1]),k.push(0,1,0),q.push((h[n]-l[0])/p,(h[n+1]-m[0])/r);u=d;v.push({name:"side",start:0,length:u.length});e.bounding=BBox.fromCenterHalfsize([0.5*(l[0]+
l[1]),0,0.5*(m[0]+m[1])],[0.5*p,0,0.5*r],vec2.len([0.5*p,0,0.5*r]))}if(e.xy){for(n=0;n<f.length;n+=3)b(f,n),b(k,n);e.bounding=c?BBox.fromCenterHalfsize([0.5*(l[0]+l[1]),0.5*(m[0]+m[1]),0],[0.5*p,0.5*r,0.5*c],vec2.len([0.5*p,0.5*r,0.5*c])):BBox.fromCenterHalfsize([0.5*(l[0]+l[1]),0.5*(m[0]+m[1]),0],[0.5*p,0.5*r,0],vec2.len([0.5*p,0.5*r,0]))}e.info={groups:v};return new g.Mesh.load({vertices:f,coords:q,normals:k,triangles:u},e,a)};t.Texture=g.Texture=function e(a,b,c,d){function f(a){return a.constructor!==
Array?a:k==g.FLOAT?new Float32Array(a):k==g.HALF_FLOAT_OES?new Uint16Array(a):new Uint8Array(a)}c=c||{};this.gl=d=d||t.gl;this._context_id=d.context_id;a=parseInt(a);b=parseInt(b);g.debug&&console.log("GL.Texture created: ",a,b);this.handler=d.createTexture();this.width=a;this.height=b;c.depth&&(this.depth=c.depth);this.texture_type=c.texture_type||d.TEXTURE_2D;this.format=c.format||e.DEFAULT_FORMAT;this.internalFormat=c.internalFormat;this.type=c.type||e.DEFAULT_TYPE;this.magFilter=c.magFilter||
c.filter||e.DEFAULT_MAG_FILTER;this.minFilter=c.minFilter||c.filter||e.DEFAULT_MIN_FILTER;this.wrapS=c.wrap||c.wrapS||e.DEFAULT_WRAP_S;this.wrapT=c.wrap||c.wrapT||e.DEFAULT_WRAP_T;this.data=null;e.MAX_TEXTURE_IMAGE_UNITS||(e.MAX_TEXTURE_IMAGE_UNITS=d.getParameter(d.MAX_TEXTURE_IMAGE_UNITS));this.has_mipmaps=!1;if(this.format==d.DEPTH_COMPONENT&&1==d.webgl_version&&!d.extensions.WEBGL_depth_texture)throw"Depth Texture not supported";if(this.type==d.FLOAT&&!d.extensions.OES_texture_float&&1==d.webgl_version)throw"Float Texture not supported";
if(this.type==d.HALF_FLOAT_OES){if(!d.extensions.OES_texture_half_float&&1==d.webgl_version)throw"Half Float Texture extension not supported.";1<d.webgl_version&&(console.warn("using HALF_FLOAT_OES in WebGL2 is deprecated, suing HALF_FLOAT instead"),this.type=this.format==d.RGB?d.RGB16F:d.RGBA16F)}if(!(isPowerOfTwo(this.width)&&isPowerOfTwo(this.height)||(this.minFilter==d.NEAREST||this.minFilter==d.LINEAR)&&this.wrapS==d.CLAMP_TO_EDGE&&this.wrapT==d.CLAMP_TO_EDGE))if(c.ignore_pot)this.minFilter=
this.magFilter=d.LINEAR,this.wrapS=this.wrapT=d.CLAMP_TO_EDGE;else throw"Cannot use texture-wrap or mipmaps in Non-Power-of-Two textures";if(a&&b){this.internalFormat||this.computeInternalFormat();d.activeTexture(d.TEXTURE0+e.MAX_TEXTURE_IMAGE_UNITS-1);d.bindTexture(this.texture_type,this.handler);d.texParameteri(this.texture_type,d.TEXTURE_MAG_FILTER,this.magFilter);d.texParameteri(this.texture_type,d.TEXTURE_MIN_FILTER,this.minFilter);d.texParameteri(this.texture_type,d.TEXTURE_WRAP_S,this.wrapS);
d.texParameteri(this.texture_type,d.TEXTURE_WRAP_T,this.wrapT);c.anisotropic&&d.extensions.EXT_texture_filter_anisotropic&&d.texParameterf(g.TEXTURE_2D,d.extensions.EXT_texture_filter_anisotropic.TEXTURE_MAX_ANISOTROPY_EXT,c.anisotropic);var k=this.type,q=c.pixel_data;if(q&&!q.buffer){if(this.texture_type==g.TEXTURE_CUBE_MAP)if(q[0].constructor===Number)q=f(q),q=[q,q,q,q,q,q];else for(var l=0;l<q.length;++l)q[l]=f(q[l]);else q=f(q);this.data=q}e.setUploadOptions(c);if(this.texture_type==g.TEXTURE_2D)d.texImage2D(g.TEXTURE_2D,
0,this.internalFormat,a,b,0,this.format,this.type,q||null),g.isPowerOfTwo(a)&&g.isPowerOfTwo(b)&&c.minFilter&&c.minFilter!=d.NEAREST&&c.minFilter!=d.LINEAR&&(d.generateMipmap(this.texture_type),this.has_mipmaps=!0);else if(this.texture_type==g.TEXTURE_CUBE_MAP)for(a=a*a*(this.format==g.RGBA?4:3),l=0;6>l;++l)(b=q)&&(b.constructor===Array?b=b[l]:b.subarray(a*l,a*(l+1))),d.texImage2D(d.TEXTURE_CUBE_MAP_POSITIVE_X+l,0,this.internalFormat,this.width,this.height,0,this.format,this.type,b||null);else if(this.texture_type==
g.TEXTURE_3D){if(1==this.gl.webgl_version)throw"TEXTURE_3D not supported in WebGL 1. Enable WebGL 2 in the context by passing webgl2:true to the context";if(!c.depth)throw"3d texture depth must be set in the options.depth";d.pixelStorei(d.UNPACK_PREMULTIPLY_ALPHA_WEBGL,!1);d.pixelStorei(d.UNPACK_FLIP_Y_WEBGL,!1);d.texImage3D(g.TEXTURE_3D,0,this.internalFormat,a,b,c.depth,0,this.format,this.type,q||null)}d.bindTexture(this.texture_type,null);d.activeTexture(d.TEXTURE0)}};Texture.DEFAULT_TYPE=g.UNSIGNED_BYTE;
Texture.DEFAULT_FORMAT=g.RGBA;Texture.DEFAULT_MAG_FILTER=g.LINEAR;Texture.DEFAULT_MIN_FILTER=g.LINEAR;Texture.DEFAULT_WRAP_S=g.CLAMP_TO_EDGE;Texture.DEFAULT_WRAP_T=g.CLAMP_TO_EDGE;Texture.EXTENSION="png";Texture.framebuffer=null;Texture.renderbuffer=null;Texture.loading_color=new Uint8Array([0,0,0,0]);Texture.use_renderbuffer_pool=!0;Texture.prototype.computeInternalFormat=function(){this.internalFormat=this.format;if(this.format==g.DEPTH_COMPONENT)if(this.minFilter=g.NEAREST,2==gl.webgl_version)if(this.type==
g.UNSIGNED_SHORT)this.internalFormat=g.DEPTH_COMPONENT16;else if(this.type==g.UNSIGNED_INT)this.internalFormat=g.DEPTH_COMPONENT24;else if(this.type==g.FLOAT)this.internalFormat=g.DEPTH_COMPONENT32F;else throw"unsupported type for a depth texture";else{if(1==gl.webgl_version){if(this.type==g.FLOAT)throw"WebGL 1.0 does not support float depth textures";this.internalFormat=g.DEPTH_COMPONENT}}else this.format==gl.RGBA&&(2==gl.webgl_version?this.type==g.FLOAT?this.internalFormat=g.RGBA32F:this.type==
g.HALF_FLOAT?this.internalFormat=g.RGBA16F:this.type==g.HALF_FLOAT_OES&&(console.warn("webgl 2 does not use HALF_FLOAT_OES, converting to HALF_FLOAT"),this.type=g.HALF_FLOAT,this.internalFormat=g.RGBA16F):1==gl.webgl_version&&this.type==g.HALF_FLOAT&&(console.warn("webgl 1 does not use HALF_FLOAT, converting to HALF_FLOAT_OES"),this.type=g.HALF_FLOAT_OES))};Texture.prototype.delete=function(){gl.deleteTexture(this.handler);this.handler=null};Texture.prototype.getProperties=function(){return{width:this.width,
height:this.height,type:this.type,format:this.format,texture_type:this.texture_type,magFilter:this.magFilter,minFilter:this.minFilter,wrapS:this.wrapS,wrapT:this.wrapT}};Texture.prototype.hasSameProperties=function(e){return e?e.width==this.width&&e.height==this.height&&e.type==this.type&&e.format==this.format&&e.texture_type==this.texture_type:!1};Texture.prototype.hasSameSize=function(e){return e?e.width==this.width&&e.height==this.height:!1};Texture.prototype.toJSON=function(){return""};Texture.isDepthSupported=
function(){return null!=gl.extensions.WEBGL_depth_texture};Texture.prototype.bind=function(e){void 0==e&&(e=0);var a=this.gl;a.activeTexture(a.TEXTURE0+e);a.bindTexture(this.texture_type,this.handler);return e};Texture.prototype.unbind=function(e){void 0===e&&(e=0);var a=this.gl;a.activeTexture(a.TEXTURE0+e);a.bindTexture(this.texture_type,null)};Texture.prototype.setParameter=function(e,a){this.bind(0);this.gl.texParameteri(this.texture_type,e,a);switch(e){case this.gl.TEXTURE_MAG_FILTER:this.magFilter=
a;break;case this.gl.TEXTURE_MIN_FILTER:this.minFilter=a;break;case this.gl.TEXTURE_WRAP_S:this.wrapS=a;break;case this.gl.TEXTURE_WRAP_T:this.wrapT=a}};Texture.setUploadOptions=function(e,a){a=a||t.gl;e?(a.pixelStorei(a.UNPACK_PREMULTIPLY_ALPHA_WEBGL,!!e.premultiply_alpha),a.pixelStorei(a.UNPACK_FLIP_Y_WEBGL,!e.no_flip)):(a.pixelStorei(a.UNPACK_PREMULTIPLY_ALPHA_WEBGL,!1),a.pixelStorei(a.UNPACK_FLIP_Y_WEBGL,!0));a.pixelStorei(a.UNPACK_ALIGNMENT,1)};Texture.prototype.uploadImage=function(e,a){this.bind();
var b=this.gl;if(!e)throw"uploadImage parameter must be Image";Texture.setUploadOptions(a,b);try{b.texImage2D(b.TEXTURE_2D,0,this.format,this.format,this.type,e),this.width=e.videoWidth||e.width,this.height=e.videoHeight||e.height,this.data=e}catch(c){if("file:"==location.protocol)throw'image not loaded for security reasons (serve this page over "http://" instead)';throw"image not loaded for security reasons (image must originate from the same domain as this page or use Cross-Origin Resource Sharing)";
}this.minFilter&&this.minFilter!=b.NEAREST&&this.minFilter!=b.LINEAR&&(b.generateMipmap(this.texture_type),this.has_mipmaps=!0);b.bindTexture(this.texture_type,null)};Texture.prototype.uploadData=function(e,a,b){a=a||{};if(!e)throw"no data passed";var c=this.gl;this.bind();Texture.setUploadOptions(a,c);var d=a.mipmap_level||0,f=this.width,k=this.height,f=f>>d,k=k>>d,q=this.internalFormat||this.format;this.type==g.HALF_FLOAT_OES&&e.constructor===Float32Array&&console.warn("cannot uploadData to a HALF_FLOAT texture from a Float32Array, must be Uint16Array. To upload it we recomment to create a FLOAT texture, upload data there and copy to your HALF_FLOAT.");
if(this.texture_type==g.TEXTURE_2D)1==c.webgl_version?e.buffer&&e.buffer.constructor==ArrayBuffer?c.texImage2D(this.texture_type,d,q,f,k,0,this.format,this.type,e):c.texImage2D(this.texture_type,d,q,this.format,this.type,e):2==c.webgl_version&&c.texImage2D(this.texture_type,d,q,f,k,0,this.format,this.type,e);else if(this.texture_type==g.TEXTURE_3D)c.pixelStorei(c.UNPACK_PREMULTIPLY_ALPHA_WEBGL,!1),c.pixelStorei(c.UNPACK_FLIP_Y_WEBGL,!1),c.texImage3D(this.texture_type,d,q,f,k,this.depth>>d,0,this.format,
this.type,e);else if(this.texture_type==g.TEXTURE_CUBE_MAP)c.texImage2D(c.TEXTURE_CUBE_MAP_POSITIVE_X+(a.cubemap_face||0),d,q,f,k,0,this.format,this.type,e);else throw"cannot uploadData for this texture type";this.data=e;!b&&this.minFilter&&this.minFilter!=c.NEAREST&&this.minFilter!=c.LINEAR&&(c.generateMipmap(this.texture_type),this.has_mipmaps=!0);c.bindTexture(this.texture_type,null)};Texture.cubemap_camera_parameters=[{type:"posX",dir:vec3.fromValues(1,0,0),up:vec3.fromValues(0,1,0),right:vec3.fromValues(0,
0,-1)},{type:"negX",dir:vec3.fromValues(-1,0,0),up:vec3.fromValues(0,1,0),right:vec3.fromValues(0,0,1)},{type:"posY",dir:vec3.fromValues(0,1,0),up:vec3.fromValues(0,0,-1),right:vec3.fromValues(1,0,0)},{type:"negY",dir:vec3.fromValues(0,-1,0),up:vec3.fromValues(0,0,1),right:vec3.fromValues(1,0,0)},{type:"posZ",dir:vec3.fromValues(0,0,1),up:vec3.fromValues(0,1,0),right:vec3.fromValues(1,0,0)},{type:"negZ",dir:vec3.fromValues(0,0,-1),up:vec3.fromValues(0,1,0),right:vec3.fromValues(-1,0,0)}];Texture.prototype.drawTo=
function(e,a){function b(){6E4<=g.getTime()-this.time?(c.deleteRenderbuffer(c._renderbuffers_pool[m]),delete c._renderbuffers_pool[m]):setTimeout(b.bind(this),6E4)}var c=this.gl,d=c.getViewport(),f=g.getTime(),k=c.getParameter(c.FRAMEBUFFER_BINDING),q=c._framebuffer=c._framebuffer||c.createFramebuffer();c.bindFramebuffer(c.FRAMEBUFFER,q);var l=null;if(Texture.use_renderbuffer_pool){c._renderbuffers_pool||(c._renderbuffers_pool={});var m=this.width+":"+this.height;c._renderbuffers_pool[m]?(l=c._renderbuffers_pool[m],
l.time=f,c.bindRenderbuffer(c.RENDERBUFFER,l)):(c._renderbuffers_pool[m]=l=c.createRenderbuffer(),l.time=f,l.width=this.width,l.height=this.height,c.bindRenderbuffer(c.RENDERBUFFER,l),setTimeout(b.bind(l),6E4))}else l=c._renderbuffer=c._renderbuffer||c.createRenderbuffer(),l.width=this.width,l.height=this.height,c.bindRenderbuffer(c.RENDERBUFFER,l);this.format===c.DEPTH_COMPONENT?c.renderbufferStorage(c.RENDERBUFFER,c.RGBA4,this.width,this.height):c.renderbufferStorage(c.RENDERBUFFER,c.DEPTH_COMPONENT16,
this.width,this.height);c.viewport(0,0,this.width,this.height);c._current_texture_drawto=this;c._current_fbo_color=q;c._current_fbo_depth=l;if(this.texture_type==c.TEXTURE_2D)this.format!==c.DEPTH_COMPONENT?(c.framebufferTexture2D(c.FRAMEBUFFER,c.COLOR_ATTACHMENT0,c.TEXTURE_2D,this.handler,0),c.framebufferRenderbuffer(c.FRAMEBUFFER,c.DEPTH_ATTACHMENT,c.RENDERBUFFER,l)):(c.framebufferRenderbuffer(c.FRAMEBUFFER,c.COLOR_ATTACHMENT0,c.RENDERBUFFER,l),c.framebufferTexture2D(c.FRAMEBUFFER,c.DEPTH_ATTACHMENT,
c.TEXTURE_2D,this.handler,0)),e(this,a);else if(this.texture_type==c.TEXTURE_CUBE_MAP)for(this.format!==c.DEPTH_COMPONENT?c.framebufferRenderbuffer(c.FRAMEBUFFER,c.DEPTH_ATTACHMENT,c.RENDERBUFFER,l):c.framebufferRenderbuffer(c.FRAMEBUFFER,c.COLOR_ATTACHMENT0,c.RENDERBUFFER,l),f=0;6>f;f++)this.format!==c.DEPTH_COMPONENT?c.framebufferTexture2D(c.FRAMEBUFFER,c.COLOR_ATTACHMENT0,c.TEXTURE_CUBE_MAP_POSITIVE_X+f,this.handler,0):c.framebufferTexture2D(c.FRAMEBUFFER,c.DEPTH_ATTACHMENT,c.TEXTURE_CUBE_MAP_POSITIVE_X+
f,this.handler,0),e(this,f,a);this.data=null;c._current_texture_drawto=null;c._current_fbo_color=null;c._current_fbo_depth=null;c.bindFramebuffer(c.FRAMEBUFFER,k);c.bindRenderbuffer(c.RENDERBUFFER,null);c.viewport(d[0],d[1],d[2],d[3]);return this};Texture.prototype.copyTo=function(e,a,b){var c=this.gl;if(!e)throw"target_texture required";var d=c.getParameter(c.FRAMEBUFFER_BINDING),f=c.getViewport();a||(a=this.texture_type==c.TEXTURE_2D?g.Shader.getScreenShader():g.Shader.getCubemapCopyShader());c.disable(c.BLEND);
c.disable(c.DEPTH_TEST);a&&b&&a.uniforms(b);b=c.__copy_fbo;b||(b=c.__copy_fbo=c.createFramebuffer());c.bindFramebuffer(c.FRAMEBUFFER,b);c.viewport(0,0,e.width,e.height);if(this.texture_type==c.TEXTURE_2D)if(this.format!==c.DEPTH_COMPONENT&&this.format!==c.DEPTH_STENCIL)c.framebufferTexture2D(c.FRAMEBUFFER,c.COLOR_ATTACHMENT0,c.TEXTURE_2D,e.handler,0),this.toViewport(a);else{a=c._color_renderbuffer=c._color_renderbuffer||c.createRenderbuffer();b=a.width=e.width;var k=a.height=e.height;c.bindRenderbuffer(c.RENDERBUFFER,
a);c.renderbufferStorage(c.RENDERBUFFER,c.RGBA4,b,k);c.framebufferRenderbuffer(c.FRAMEBUFFER,c.COLOR_ATTACHMENT0,c.RENDERBUFFER,a);b=e.format==c.DEPTH_STENCIL?c.DEPTH_STENCIL_ATTACHMENT:c.DEPTH_ATTACHMENT;c.framebufferTexture2D(c.FRAMEBUFFER,b,c.TEXTURE_2D,e.handler,0);a=c.checkFramebufferStatus(c.FRAMEBUFFER);if(a!==c.FRAMEBUFFER_COMPLETE)throw"FBO not complete: "+a;c.enable(c.DEPTH_TEST);c.depthFunc(c.ALWAYS);c.colorMask(!1,!1,!1,!1);a=g.Shader.getCopyDepthShader();this.toViewport(a);c.colorMask(!0,
!0,!0,!0);c.disable(c.DEPTH_TEST);c.depthFunc(c.LEQUAL);c.framebufferRenderbuffer(c.FRAMEBUFFER,c.COLOR_ATTACHMENT0,c.RENDERBUFFER,null);c.framebufferTexture2D(c.FRAMEBUFFER,b,c.TEXTURE_2D,null,0)}else if(this.texture_type==c.TEXTURE_CUBE_MAP)for(a.uniforms({u_texture:0}),b=g.temp_mat3,k=0;6>k;k++){c.framebufferTexture2D(c.FRAMEBUFFER,c.COLOR_ATTACHMENT0,c.TEXTURE_CUBE_MAP_POSITIVE_X+k,e.handler,0);var q=g.Texture.cubemap_camera_parameters[k];mat3.identity(b);b.set(q.right,0);b.set(q.up,3);b.set(q.dir,
6);this.toViewport(a,{u_rotation:b})}c.setViewport(f);c.bindFramebuffer(c.FRAMEBUFFER,d);e.minFilter&&e.minFilter!=c.NEAREST&&e.minFilter!=c.LINEAR&&(e.bind(),c.generateMipmap(e.texture_type),e.has_mipmaps=!0);e.data=null;c.bindTexture(e.texture_type,null);return this};Texture.prototype.blit=function(){var e=new Float32Array(4);return function(a,b,c){var d=this.gl;if(this.texture_type!=d.TEXTURE_2D||this.format===d.DEPTH_COMPONENT||this.format===d.DEPTH_STENCIL)throw"blit only support TEXTURE_2D of RGB or RGBA. use copyTo instead";
var f=d.getParameter(d.FRAMEBUFFER_BINDING);e.set(d.viewport_data);(b=b||g.Shader.getScreenShader())&&c&&b.uniforms(c);c=d.__copy_fbo;c||(c=d.__copy_fbo=d.createFramebuffer());d.bindFramebuffer(d.FRAMEBUFFER,c);d.viewport(0,0,a.width,a.height);d.framebufferTexture2D(d.FRAMEBUFFER,d.COLOR_ATTACHMENT0,d.TEXTURE_2D,a.handler,0);this.bind(0);b.draw(g.Mesh.getScreenQuad(),d.TRIANGLES);d.setViewport(e);d.bindFramebuffer(d.FRAMEBUFFER,f);a.data=null;d.bindTexture(a.texture_type,null);return this}}();Texture.prototype.toViewport=
function(e,a){e=e||Shader.getScreenShader();var b=Mesh.getScreenQuad();this.bind(0);a&&e.uniforms(a);e.draw(b,gl.TRIANGLES)};Texture.prototype.fill=function(e,a){if(e.constructor===g.Shader)this.drawTo(function(){e.toViewport()});else{var b=gl.getParameter(gl.COLOR_CLEAR_VALUE);gl.clearColor(e[0],e[1],e[2],e[3]);this.drawTo(function(){gl.clear(gl.COLOR_BUFFER_BIT)});gl.clearColor(b[0],b[1],b[2],b[3])}!a&&this.minFilter&&this.minFilter!=gl.NEAREST&&this.minFilter!=gl.LINEAR&&(this.bind(),gl.generateMipmap(this.texture_type),
this.has_mipmaps=!0)};Texture.prototype.renderQuad=function(){var e=mat3.create(),a=vec2.create(),b=vec2.create(),c=vec4.fromValues(1,1,1,1);return function(d,f,k,g,l,m){a[0]=d;a[1]=f;b[0]=k;b[1]=g;l=l||Shader.getQuadShader(this.gl);d=Mesh.getScreenQuad(this.gl);this.bind(0);l.uniforms({u_texture:0,u_position:a,u_color:c,u_size:b,u_viewport:gl.viewport_data.subarray(2,4),u_transform:e});m&&l.uniforms(m);l.draw(d,gl.TRIANGLES)}}();Texture.prototype.applyBlur=function(e,a,b,c,d){var f=this.gl;void 0===
e&&(e=1);void 0===a&&(a=1);f.disable(f.DEPTH_TEST);f.disable(f.BLEND);c=c||this;var k=!d;if(d===c)throw"cannot use applyBlur in a texture using as temporary itself";if(c&&this.texture_type!==c.texture_type)throw"cannot use applyBlur with textures of different texture_type";var q=f.getParameter(f.FRAMEBUFFER_BINDING),l=f.getViewport(),m=f.__copy_fbo;m||(m=f.__copy_fbo=f.createFramebuffer());f.bindFramebuffer(f.FRAMEBUFFER,m);f.viewport(0,0,this.width,this.height);if(this.texture_type===f.TEXTURE_2D)m=
g.Shader.getBlurShader(),d||(d=g.Texture.getTemporary(this.width,this.height,this)),f.framebufferTexture2D(f.FRAMEBUFFER,f.COLOR_ATTACHMENT0,f.TEXTURE_2D,d.handler,0),this.toViewport(m,{u_texture:0,u_intensity:b,u_offset:[0,a/this.height]}),f.framebufferTexture2D(f.FRAMEBUFFER,f.COLOR_ATTACHMENT0,f.TEXTURE_2D,c.handler,0),f.viewport(0,0,c.width,c.height),d.toViewport(m,{u_intensity:b,u_offset:[e/d.width,0]}),k&&g.Texture.releaseTemporary(d);else if(this.texture_type===f.TEXTURE_CUBE_MAP){m=g.Shader.getCubemapBlurShader();
m.uniforms({u_texture:0,u_intensity:b,u_offset:[e/this.width,a/this.height]});this.bind(0);e=Mesh.getScreenQuad();e.bindBuffers(m);m.bind();a=null;a=d||c!=this?c:d=g.Texture.getTemporary(c.width,c.height,c);b=g.temp_mat3;for(var n=0;6>n;++n){f.framebufferTexture2D(f.FRAMEBUFFER,f.COLOR_ATTACHMENT0,f.TEXTURE_CUBE_MAP_POSITIVE_X+n,a.handler,0);var p=g.Texture.cubemap_camera_parameters[n];mat3.identity(b);b.set(p.right,0);b.set(p.up,3);b.set(p.dir,6);m._setUniform("u_rotation",b);f.drawArrays(f.TRIANGLES,
0,6)}e.unbindBuffers(m);d&&d.copyTo(c);d&&k&&g.Texture.releaseTemporary(d)}f.setViewport(l);f.bindFramebuffer(f.FRAMEBUFFER,q);c.data=null;c.minFilter&&c.minFilter!=f.NEAREST&&c.minFilter!=f.LINEAR&&(c.bind(),f.generateMipmap(c.texture_type),c.has_mipmaps=!0);f.bindTexture(c.texture_type,null)};Texture.fromURL=function(e,a,b,c){c=c||t.gl;a=a||{};a=Object.create(a);var d=a.texture||new g.Texture(1,1,a,c);64>e.length&&(d.url=e);d.bind();var f=a.temp_color||Texture.loading_color;c.pixelStorei(c.UNPACK_ALIGNMENT,
4);f=a.type==c.FLOAT?new Float32Array(f):new Uint8Array(f);c.texImage2D(c.TEXTURE_2D,0,d.format,d.width,d.height,0,d.format,d.type,f);c.bindTexture(d.texture_type,null);d.ready=!1;f=null;a.extension&&(f=a.extension);if(!f&&512>e.length){var k=e,q=e.indexOf("?");-1!=q&&(k=e.substr(0,q));q=k.lastIndexOf(".");-1!=q&&(f=k.substr(q+1).toLowerCase())}"dds"==f?(f=c.getExtension("WEBKIT_WEBGL_compressed_texture_s3tc")||c.getExtension("WEBGL_compressed_texture_s3tc"),k=new g.Texture(0,0,a,c),S.loadDDSTextureEx(c,
f,e,k.handler,!0,function(a){d.texture_type=a.texture_type;d.handler=a;delete d.ready;b&&b(d,e)})):"tga"==f?HttpRequest(e,null,function(f){if(f=g.Texture.parseTGA(f))a.texture=d,f.flipY&&(a.no_flip=!0),"RGB"==f.format&&(d.format=c.RGB),d=g.Texture.fromMemory(f.width,f.height,f.pixels,a),delete d.ready,b&&b(d,e)},null,{binary:!0}):(f=new Image,f.src=e,f.onload=function(){a.texture=d;g.Texture.fromImage(this,a);delete d.ready;b&&b(d,e)},f.onerror=function(){b&&b(null)});return d};Texture.parseTGA=function(e){if(!e||
e.constructor!==ArrayBuffer)throw"TGA: data must be ArrayBuffer";e=new Uint8Array(e);for(var a=new Uint8Array([0,0,2,0,0,0,0,0,0,0,0,0]),b=e.subarray(0,12),c=0;c<b.length;c++)if(a[c]!=b[c])return console.error("TGA header is not valid"),null;c=e.subarray(12,18);a={};a.width=256*c[1]+c[0];a.height=256*c[3]+c[2];a.bpp=c[4];a.bytesPerPixel=a.bpp/8;a.imageSize=a.width*a.height*a.bytesPerPixel;a.pixels=e.subarray(18,18+a.imageSize);a.pixels=new Uint8Array(a.pixels);a.flipY=0==(c[5]&32);for(c=0;c<a.imageSize;c+=
a.bytesPerPixel)e=a.pixels[c],a.pixels[c]=a.pixels[c+2],a.pixels[c+2]=e;a.format=32==a.bpp?"RGBA":"RGB";return a};Texture.fromImage=function(e,a){a=a||{};var b=a.texture||new g.Texture(e.width,e.height,a);b.uploadImage(e,a);b.bind();gl.texParameteri(b.texture_type,gl.TEXTURE_MAG_FILTER,b.magFilter);gl.texParameteri(b.texture_type,gl.TEXTURE_MIN_FILTER,b.minFilter);gl.texParameteri(b.texture_type,gl.TEXTURE_WRAP_S,b.wrapS);gl.texParameteri(b.texture_type,gl.TEXTURE_WRAP_T,b.wrapT);g.isPowerOfTwo(b.width)&&
g.isPowerOfTwo(b.height)?a.minFilter&&a.minFilter!=gl.NEAREST&&a.minFilter!=gl.LINEAR&&(b.bind(),gl.generateMipmap(b.texture_type),b.has_mipmaps=!0):(gl.texParameteri(b.texture_type,gl.TEXTURE_MIN_FILTER,g.LINEAR),gl.texParameteri(b.texture_type,gl.TEXTURE_WRAP_S,g.CLAMP_TO_EDGE),gl.texParameteri(b.texture_type,gl.TEXTURE_WRAP_T,g.CLAMP_TO_EDGE),b.has_mipmaps=!1);gl.bindTexture(b.texture_type,null);b.data=e;a.keep_image&&(b.img=e);return b};Texture.fromVideo=function(e,a){a=a||{};var b=a.texture||
new g.Texture(e.videoWidth,e.videoHeight,a);b.bind();b.uploadImage(e,a);a.minFilter&&a.minFilter!=gl.NEAREST&&a.minFilter!=gl.LINEAR&&(b.bind(),gl.generateMipmap(b.texture_type),b.has_mipmaps=!0,b.data=e);gl.bindTexture(b.texture_type,null);return b};Texture.fromTexture=function(e,a){a=a||{};var b=new g.Texture(e.width,e.height,a);e.copyTo(b);return b};Texture.prototype.clone=function(e){var a=this.getProperties();if(e)for(var b in e)a[b]=e[b];return Texture.fromTexture(this,a)};Texture.fromMemory=
function(e,a,b,c){c=c||{};var d=c.texture||new g.Texture(e,a,c);Texture.setUploadOptions(c);d.bind();b.constructor===Array&&(b=c.type==gl.FLOAT?new Float32Array(b):c.type==g.HALF_FLOAT||c.type==g.HALF_FLOAT_OES?new Uint16Array(b):new Uint8Array(b));gl.texImage2D(gl.TEXTURE_2D,0,d.format,e,a,0,d.format,d.type,b);d.width=e;d.height=a;d.data=b;c.minFilter&&c.minFilter!=gl.NEAREST&&c.minFilter!=gl.LINEAR&&(gl.generateMipmap(gl.TEXTURE_2D),d.has_mipmaps=!0);gl.bindTexture(d.texture_type,null);return d};
Texture.fromDDSInMemory=function(e,a){a=a||{};var b=a.texture||new g.Texture(0,0,a);g.Texture.setUploadOptions(a);b.bind();var c=gl.getExtension("WEBKIT_WEBGL_compressed_texture_s3tc")||gl.getExtension("WEBGL_compressed_texture_s3tc");S.loadDDSTextureFromMemoryEx(gl,c,e,b,!0);gl.bindTexture(b.texture_type,null);return b};Texture.fromShader=function(e,a,b,c){c=c||{};e=new g.Texture(e,a,c);e.drawTo(function(){gl.disable(gl.BLEND);gl.disable(gl.DEPTH_TEST);gl.disable(gl.CULL_FACE);var a=Mesh.getScreenQuad();
b.draw(a)});return e};Texture.cubemapFromImages=function(e,a){a=a||{};if(6!=e.length)throw"missing images to create cubemap";var b=e[0].width,c=e[0].height;a.texture_type=gl.TEXTURE_CUBE_MAP;var d=null;a.texture?(d=a.texture,d.width=b,d.height=c):d=new g.Texture(b,c,a);Texture.setUploadOptions(a);d.bind();try{for(b=0;6>b;b++)gl.texImage2D(gl.TEXTURE_CUBE_MAP_POSITIVE_X+b,0,d.format,d.format,d.type,e[b]);d.data=e}catch(f){if("file:"==location.protocol)throw'image not loaded for security reasons (serve this page over "http://" instead)';
throw"image not loaded for security reasons (image must originate from the same domain as this page or use Cross-Origin Resource Sharing)";}a.minFilter&&a.minFilter!=gl.NEAREST&&a.minFilter!=gl.LINEAR&&(gl.generateMipmap(gl.TEXTURE_CUBE_MAP),d.has_mipmaps=!0);d.unbind();return d};Texture.cubemapFromImage=function(e,a){a=a||{};if(e.width!=e.height/6&&0!=e.height%6&&!a.faces&&!a.is_polar)return console.error("Cubemap image not valid, only 1x6 (vertical) or 6x3 (cross) formats. Check size:",e.width,
e.height),null;var b=e.width,c=e.height;if(a.is_polar){var d=a.size||g.nearestPowerOfTwo(e.height),f=g.Texture.fromImage(e,{ignore_pot:!0,wrap:gl.REPEAT,filter:gl.LINEAR}),b=new g.Texture(d,d,{texture_type:gl.TEXTURE_CUBE_MAP,format:gl.RGBA});if(a.texture){var c=a.texture,k;for(k in b)c[k]=b[k];b=c}var q=mat3.create(),l={u_texture:0,u_rotation:q};gl.disable(gl.DEPTH_TEST);gl.disable(gl.BLEND);var m=g.Shader.getPolarToCubemapShader();b.drawTo(function(a,b){var c=g.Texture.cubemap_camera_parameters[b];
mat3.identity(q);q.set(c.right,0);q.set(c.up,3);q.set(c.dir,6);f.toViewport(m,l)});a.keep_image&&(b.img=e);return b}void 0!==a.is_cross?(a.faces=Texture.generateCubemapCrossFacesInfo(e.width,a.is_cross),b=c=e.width/4):a.faces?(b=a.width||a.faces[0].width,c=a.height||a.faces[0].height):c/=6;if(b!=c)return console.log("Texture not valid, width and height for every face must be square"),null;d=b;a.no_flip=!0;var n=[];for(k=0;6>k;k++){var p=createCanvas(d,d),r=p.getContext("2d");a.faces?r.drawImage(e,
a.faces[k].x,a.faces[k].y,a.faces[k].width||d,a.faces[k].height||d,0,0,d,d):r.drawImage(e,0,c*k,b,c,0,0,d,d);n.push(p)}k=Texture.cubemapFromImages(n,a);a.keep_image&&(k.img=e);return k};Texture.generateCubemapCrossFacesInfo=function(e,a){void 0===a&&(a=1);var b=e/4;return[{x:2*b,y:b,width:b,height:b},{x:0,y:b,width:b,height:b},{x:a*b,y:0,width:b,height:b},{x:a*b,y:2*b,width:b,height:b},{x:b,y:b,width:b,height:b},{x:3*b,y:b,width:b,height:b}]};Texture.cubemapFromURL=function(e,a,b){a=a||{};a=Object.create(a);
a.texture_type=gl.TEXTURE_CUBE_MAP;var c=a.texture||new g.Texture(1,1,a);c.bind();Texture.setUploadOptions(a);for(var d=a.temp_color||[0,0,0,255],d=a.type==gl.FLOAT?new Float32Array(d):new Uint8Array(d),f=0;6>f;f++)gl.texImage2D(gl.TEXTURE_CUBE_MAP_POSITIVE_X+f,0,c.format,1,1,0,c.format,c.type,d);gl.bindTexture(c.texture_type,null);c.ready=!1;d=new Image;d.src=e;d.onload=function(){a.texture=c;(c=g.Texture.cubemapFromImage(this,a))&&delete c.ready;b&&b(c)};return c};Texture.prototype.getPixels=function(e,
a){a=a||0;var b=this.gl,c=b.getViewport(),d=b.getParameter(b.FRAMEBUFFER_BINDING);if(this.format==b.DEPTH_COMPONENT)throw"cannot use getPixels in depth textures";b.disable(b.DEPTH_TEST);var f=b.__copy_fbo;f||(f=b.__copy_fbo=b.createFramebuffer());b.bindFramebuffer(b.FRAMEBUFFER,f);var f=null,k=this.width>>a,q=this.height>>a;b.viewport(0,0,k,q);this.texture_type==b.TEXTURE_2D?b.framebufferTexture2D(b.FRAMEBUFFER,b.COLOR_ATTACHMENT0,b.TEXTURE_2D,this.handler,a):this.texture_type==b.TEXTURE_CUBE_MAP&&
b.framebufferTexture2D(b.FRAMEBUFFER,b.COLOR_ATTACHMENT0,b.TEXTURE_CUBE_MAP_POSITIVE_X+(e||0),this.handler,a);var l=this.format==b.RGB?3:4,l=4,m=this.type,f=m==b.UNSIGNED_BYTE?new Uint8Array(k*q*l):m==g.HALF_FLOAT||m==g.HALF_FLOAT_OES?new Uint16Array(k*q*l):new Float32Array(k*q*l);b.readPixels(0,0,k,q,3==l?b.RGB:b.RGBA,m,f);b.bindFramebuffer(b.FRAMEBUFFER,d);b.viewport(c[0],c[1],c[2],c[3]);return f};Texture.prototype.setPixels=function(e,a,b,c){a={no_flip:a};c&&(a.cubemap_face=c);this.uploadData(e,
a,b)};Texture.prototype.getCubemapPixels=function(){if(this.texture_type!==gl.TEXTURE_CUBE_MAP)throw"this texture is not a cubemap";return[this.getPixels(0),this.getPixels(1),this.getPixels(2),this.getPixels(3),this.getPixels(4),this.getPixels(5)]};Texture.prototype.setCubemapPixels=function(e,a){if(this.texture_type!==gl.TEXTURE_CUBE_MAP)throw"this texture is not a cubemap, it should be created with { texture_type: gl.TEXTURE_CUBE_MAP }";for(var b=0;6>b;++b)this.setPixels(e[b],a,5!=b,b)};Texture.prototype.toCanvas=
function(e,a,b){b=b||8192;var c=this.gl,d=Math.min(this.width,b),f=Math.min(this.height,b);this.texture_type==c.TEXTURE_CUBE_MAP&&(d*=4,f*=3);e=e||createCanvas(d,f);e.width!=d&&(e.width=d);e.height!=f&&(e.height=f);var k=null;if(this.texture_type==c.TEXTURE_2D)this.width!=d||this.height!=f||this.type!=c.UNSIGNED_BYTE?(k=new g.Texture(d,f,{format:c.RGBA,filter:c.NEAREST}),this.copyTo(k),k=k.getPixels()):k=this.getPixels(),b=e.getContext("2d"),c=b.getImageData(0,0,d,f),c.data.set(k),b.putImageData(c,
0,0),a&&(k=createCanvas(d,f),a=k.getContext("2d"),a.translate(0,k.height),a.scale(1,-1),a.drawImage(e,0,0,k.width,k.height),b.clearRect(0,0,b.canvas.width,b.canvas.height),b.drawImage(k,0,0));else if(this.texture_type==c.TEXTURE_CUBE_MAP){d=createCanvas(this.width,this.height);a=d.getContext("2d");f=g.Texture.generateCubemapCrossFacesInfo(e.width,1);b=e.getContext("2d");b.fillStyle="black";b.fillRect(0,0,e.width,e.height);var q=this;this.type!=c.UNSIGNED_BYTE&&(q=new g.Texture(this.width,this.height,
{format:c.RGBA,texture_type:c.TEXTURE_CUBE_MAP,filter:c.NEAREST,type:c.UNSIGNED_BYTE}),this.copyTo(q));for(var l=0;6>l;l++)c=a.getImageData(0,0,d.width,d.height),k=q.getPixels(l),c.data.set(k),a.putImageData(c,0,0),b.drawImage(d,f[l].x,f[l].y,d.width,d.height)}return e};Texture.binary_extension="png";Texture.prototype.toBinary=function(e,a){for(var b=this.toCanvas(null,e).toDataURL(a),c=b.indexOf(","),b=b.substr(c+1),b=atob(b),c=b.length,d=new Uint8Array(c),f=0;f<c;++f)d[f]=b.charCodeAt(f);return d};
Texture.prototype.toBlob=function(e,a){var b=this.toBinary(e);return new Blob([b],{type:a||"image/png"})};Texture.prototype.toBlobAsync=function(e,a,b){var c=this.toCanvas(null,e);c.toBlob?c.toBlob(b,a):(e=this.toBlob(e,a),b&&b(e))};Texture.prototype.toBase64=function(e){var a=this.width,b=this.height,c=this.getPixels(),d=createCanvas(a,b),f=d.getContext("2d"),k=f.getImageData(0,0,a,b);k.data.set(c);f.putImageData(k,0,0);e&&(e=createCanvas(a,b),a=e.getContext("2d"),a.translate(0,b),a.scale(1,-1),
a.drawImage(d,0,0),d=e);return d.toDataURL("image/png")};Texture.prototype.generateMetadata=function(){var e={};e.width=this.width;e.height=this.height;this.metadata=e};Texture.compareFormats=function(e,a){return e&&a?e==a?!0:e.width!=a.width||e.height!=a.height||e.type!=a.type||e.format!=a.format||e.texture_type!=a.texture_type?!1:!0:!1};Texture.blend=function(e,a,b,c){if(!e||!a)return!1;if(e==a)return c?e.copyTo(c):e.toViewport(),!0;gl.disable(gl.BLEND);gl.disable(gl.DEPTH_TEST);gl.disable(gl.CULL_FACE);
var d=g.Shader.getBlendShader(),f=g.Mesh.getScreenQuad();a.bind(1);d.uniforms({u_texture:0,u_texture2:1,u_factor:b});if(c)return c.drawTo(function(){if(e==c||a==c)throw"Blend output cannot be the same as the input";e.bind(0);d.draw(f,gl.TRIANGLES)}),!0;e.bind(0);d.draw(f,gl.TRIANGLES);return!0};Texture.cubemapToTexture2D=function(e,a,b,c,d){if(!e||e.texture_type!=gl.TEXTURE_CUBE_MAP)throw"No cubemap in convert";a=a||e.width;c=c?e.type:gl.UNSIGNED_BYTE;d=d||0;b||(b=new g.Texture(2*a,a,{minFilter:gl.NEAREST,
type:c}));var f=gl.shaders.cubemap_to_texture2D;f||(f=gl.shaders.cubemap_to_texture2D=new g.Shader(g.Shader.SCREEN_VERTEX_SHADER,"\t\tprecision mediump float;\n\t\t#define PI 3.14159265358979323846264\n\t\tuniform samplerCube texture;\t\tvarying vec2 v_coord;\t\tuniform float u_yaw;\n\t\tvoid main() {\t\t\tfloat alpha = ((1.0 - v_coord.x) * 2.0) * PI + u_yaw;\t\t\tfloat beta = (v_coord.y * 2.0 - 1.0) * PI * 0.5;\t\t\tvec3 N = vec3( -cos(alpha) * cos(beta), sin(beta), sin(alpha) * cos(beta) );\t\t\tgl_FragColor = textureCube(texture,N);\t\t}"));
f.setUniform("u_yaw",d);b.drawTo(function(){gl.disable(gl.DEPTH_TEST);gl.disable(gl.CULL_FACE);gl.disable(gl.BLEND);e.toViewport(f)});return b};Texture.getWhiteTexture=function(e){e=e||t.gl;var a=e.textures[":white"];if(a)return a;a=new Uint8Array([255,255,255,255]);return e.textures[":white"]=new g.Texture(1,1,{pixel_data:a})};Texture.getBlackTexture=function(e){e=e||t.gl;var a=e.textures[":black"];if(a)return a;a=new Uint8Array([0,0,0,255]);return e.textures[":black"]=new g.Texture(1,1,{pixel_data:a})};
Texture.getTemporary=function(e,a,b,c){c=c||t.gl;c._texture_pool||(c._texture_pool=[]);var d=g.TEXTURE_2D,f=Texture.DEFAULT_TYPE,k=Texture.DEFAULT_FORMAT;b&&(b.texture_type&&(d=b.texture_type),b.type&&(f=b.type),b.format&&(k=b.format));b=d+":"+f+":"+e+"x"+a+":"+k;c=c._texture_pool;for(var q=0;q<c.length;++q){var l=c[q];if(l._key==b)return c.splice(q,1),l._pool=0,l}l=new g.Texture(e,a,{type:f,texture_type:d,format:k});l._key=b;l._pool=0;return l};Texture.releaseTemporary=function(e,a){a=a||t.gl;a._texture_pool||
(a._texture_pool=[]);0<e._pool&&console.warn("this texture is already in the textures pool");var b=a._texture_pool;b||(b=a._texture_pool=[]);e._pool=getTime();b.push(e);20<b.length&&(b.sort(function(a,b){return b._pool-a._pool}),e=b.pop(),e._pool=0,e.delete())};Texture.nextPOT=function(e){return Math.pow(2,Math.ceil(Math.log(e)/Math.log(2)))};g.FBO=B;B.prototype.setTextures=function(e,a,b){if(a&&a.constructor===g.Texture){if(a.format!==g.DEPTH_COMPONENT&&a.format!==g.DEPTH_STENCIL&&a.format!==g.DEPTH_COMPONENT16&&
a.format!==g.DEPTH_COMPONENT24&&a.format!==g.DEPTH_COMPONENT32F)throw"FBO Depth texture must be of format: gl.DEPTH_COMPONENT, gl.DEPTH_STENCIL or gl.DEPTH_COMPONENT16/24/32F (only in webgl2)";if(a.type!=g.UNSIGNED_SHORT&&a.type!=g.UNSIGNED_INT&&a.type!=g.UNSIGNED_INT_24_8_WEBGL&&a.type!=g.FLOAT)throw"FBO Depth texture must be of type: gl.UNSIGNED_SHORT, gl.UNSIGNED_INT, gl.UNSIGNED_INT_24_8_WEBGL";}var c=this.depth_texture==a;if(c&&e){if(e.constructor!==Array)throw"FBO: color_textures parameter must be an array containing all the textures to be binded in the color";
if(e.length==this.color_textures.length)for(var d=0;d<e.length;++d){if(e[d]!=this.color_textures[d]){c=!1;break}}else c=!1}this._stencil_enabled!==this.stencil&&(c=!1);if(!c){this.color_textures.length=e?e.length:0;if(e)for(d=0;d<e.length;++d)this.color_textures[d]=e[d];this.depth_texture=a;this.update(b)}};B.prototype.update=function(e){this._old_fbo_handler=gl.getParameter(gl.FRAMEBUFFER_BINDING);this.handler||(this.handler=gl.createFramebuffer());var a=-1,b=-1,c=null,d=null,f=this.color_textures,
k=this.depth_texture;if(f&&f.length)for(var q=0;q<f.length;q++){var l=f[q];if(l.constructor!==g.Texture)throw"FBO can only bind instances of GL.Texture";if(-1==a)a=l.width;else if(a!=l.width)throw"Cannot bind textures with different dimensions";if(-1==b)b=l.height;else if(b!=l.height)throw"Cannot bind textures with different dimensions";if(null==c)c=l.type,d=l.format;else if(c!=l.type)throw"Cannot bind textures to a FBO with different pixel formats";if(l.texture_type!=gl.TEXTURE_2D)throw"Cannot bind a Cubemap to a FBO";
}else a=k.width,b=k.height;this.width=a;this.height=b;gl.bindFramebuffer(gl.FRAMEBUFFER,this.handler);var m=gl.extensions.WEBGL_draw_buffers;if(1==gl.webgl_version&&!m&&f&&1<f.length)throw"Rendering to several textures not supported by your browser";var n=1==gl.webgl_version?gl.FRAMEBUFFER:gl.DRAW_FRAMEBUFFER;gl.framebufferRenderbuffer(n,gl.DEPTH_ATTACHMENT,gl.RENDERBUFFER,null);gl.framebufferRenderbuffer(n,gl.DEPTH_STENCIL_ATTACHMENT,gl.RENDERBUFFER,null);if(k&&k.constructor===g.Texture){if(1==gl.webgl_version&&
!gl.extensions.WEBGL_depth_texture)throw"Rendering to depth texture not supported by your browser";this.stencil&&k.format!==gl.DEPTH_STENCIL&&console.warn("Stencil cannot be enabled if there is a depth texture with a DEPTH_STENCIL format");k.format==gl.DEPTH_STENCIL?gl.framebufferTexture2D(n,gl.DEPTH_STENCIL_ATTACHMENT,gl.TEXTURE_2D,k.handler,0):gl.framebufferTexture2D(n,gl.DEPTH_ATTACHMENT,gl.TEXTURE_2D,k.handler,0)}else q=null,k&&k.constructor===WebGLRenderbuffer&&k.width==a&&k.height==b?q=this._depth_renderbuffer=
k:(q=this._depth_renderbuffer=this._depth_renderbuffer||gl.createRenderbuffer(),q.width=a,q.height=b),gl.bindRenderbuffer(gl.RENDERBUFFER,q),this.stencil?(gl.renderbufferStorage(gl.RENDERBUFFER,gl.DEPTH_STENCIL,a,b),gl.framebufferRenderbuffer(n,gl.DEPTH_STENCIL_ATTACHMENT,gl.RENDERBUFFER,q)):(gl.renderbufferStorage(gl.RENDERBUFFER,gl.DEPTH_COMPONENT16,a,b),gl.framebufferRenderbuffer(n,gl.DEPTH_ATTACHMENT,gl.RENDERBUFFER,q));if(f&&f.length)for(this.order=[],q=0;q<f.length;q++)l=f[q],gl.framebufferTexture2D(n,
gl.COLOR_ATTACHMENT0+q,gl.TEXTURE_2D,l.handler,0),this.order.push(gl.COLOR_ATTACHMENT0+q);else k=this._color_renderbuffer=this._color_renderbuffer||gl.createRenderbuffer(),k.width=a,k.height=b,gl.bindRenderbuffer(gl.RENDERBUFFER,k),gl.renderbufferStorage(gl.RENDERBUFFER,gl.RGBA4,a,b),gl.framebufferRenderbuffer(n,gl.COLOR_ATTACHMENT0,gl.RENDERBUFFER,k);for(q=a=f?f.length:0;q<this._num_binded_textures;++q)gl.framebufferTexture2D(n,gl.COLOR_ATTACHMENT0+q,gl.TEXTURE_2D,null,0);this._num_binded_textures=
a;this._stencil_enabled=this.stencil;f&&1<f.length&&(m?m.drawBuffersWEBGL(this.order):gl.drawBuffers(this.order));f=gl.checkFramebufferStatus(n);if(f!==gl.FRAMEBUFFER_COMPLETE)throw d!=g.RGB||c!=g.FLOAT&&c!=g.HALF_FLOAT_OES||console.error("Tip: Firefox does not support RGB channel float/half_float textures, you must use RGBA"),"FBO not complete: "+f;gl.bindTexture(gl.TEXTURE_2D,null);gl.bindRenderbuffer(gl.RENDERBUFFER,null);e||gl.bindFramebuffer(n,this._old_fbo_handler)};B.prototype.bind=function(e){if(!this.color_textures.length&&
!this.depth_texture)throw"FBO: no textures attached to FBO";this._old_viewport.set(gl.viewport_data);this._old_fbo_handler=e?gl.getParameter(gl.FRAMEBUFFER_BINDING):null;this._old_fbo_handler!=this.handler&&gl.bindFramebuffer(gl.FRAMEBUFFER,this.handler);for(e=0;e<this.color_textures.length;++e)this.color_textures[e]._in_current_fbo=!0;this.depth_texture&&(this.depth_texture._in_current_fbo=!0);gl.viewport(0,0,this.width,this.height);B.current=this};B.prototype.unbind=function(){gl.bindFramebuffer(gl.FRAMEBUFFER,
this._old_fbo_handler);this._old_fbo_handler=null;gl.setViewport(this._old_viewport);for(var e=0;e<this.color_textures.length;++e)this.color_textures[e]._in_current_fbo=!1;this.depth_texture&&(this.depth_texture._in_current_fbo=!1);B.current=null};B.prototype.switchTo=function(e){e._old_fbo_handler=this._old_fbo_handler;e._old_viewport.set(this._old_viewport);gl.bindFramebuffer(gl.FRAMEBUFFER,e.handler);this._old_fbo_handler=null;gl.viewport(0,0,this.width,this.height);for(var a=0;a<this.color_textures.length;++a)this.color_textures[a]._in_current_fbo=
!1;this.depth_texture&&(this.depth_texture._in_current_fbo=!1);for(a=0;a<e.color_textures.length;++a)e.color_textures[a]._in_current_fbo=!0;e.depth_texture&&(e.depth_texture._in_current_fbo=!0);B.current=e};B.prototype.delete=function(){gl.deleteFramebuffer(this.handler);this.handler=null};B.supported={};B.testSupport=function(e,a){var b=e+":"+a;if(null!=B.supported[b])return B.supported[b];var c=new g.Texture(1,1,{format:a,type:e});try{new g.FBO([c])}catch(d){return console.warn("This browser WEBGL implementation doesn't support this FBO format: "+
g.reverse[e]+" "+g.reverse[a]),B.supported[b]=!1}return B.supported[b]=!0};B.prototype.toSingle=function(e){e=e||0;if(!(2>this.color_textures.length)){var a=gl.extensions.WEBGL_draw_buffers;a?a.drawBuffersWEBGL([this.order[e]]):gl.drawBuffers([this.order[e]])}};B.prototype.toMulti=function(){if(!(2>this.color_textures.length)){var e=gl.extensions.WEBGL_draw_buffers;e?e.drawBuffersWEBGL(this.order):gl.drawBuffers(this.order)}};B.prototype.clearSecondary=function(e){if(this.order&&!(2>this.order.length)){for(var a=
gl.extensions.WEBGL_draw_buffers,b=[gl.NONE],c=1;c<this.order.length;++c)b.push(this.order[c]);a?a.drawBuffersWEBGL(b):gl.drawBuffers(b);gl.clearColor(e[0],e[1],e[2],e[3]);gl.clear(gl.COLOR_BUFFER_BIT);a?a.drawBuffersWEBGL(this.order):gl.drawBuffers(this.order)}};t.Shader=g.Shader=function a(b,c,d){g.debug&&console.log("GL.Shader created");if(!b||!c)throw"GL.Shader source code parameter missing";this._context_id=t.gl.context_id;var f=this.gl=t.gl,k=a.expandMacros(d);d=b.constructor===String?a.injectCode(k,
b,f):b;k=c.constructor===String?a.injectCode(k,c,f):c;this.program=f.createProgram();b=b.constructor===String?g.Shader.compileSource(f.VERTEX_SHADER,d):b;c=c.constructor===String?g.Shader.compileSource(f.FRAGMENT_SHADER,k):c;f.attachShader(this.program,b,f);f.attachShader(this.program,c,f);f.linkProgram(this.program);if(!f.getProgramParameter(this.program,f.LINK_STATUS))throw"link error: "+f.getProgramInfoLog(this.program);this.vs_shader=b;this.fs_shader=c;this.attributes={};this.uniformInfo={};this.samplers=
{};this.extractShaderInfo()};Shader.expandMacros=function(a){var b="";if(a)for(var c in a)b+="#define "+c+" "+(a[c]?a[c]:"")+"\n";return b};Shader.injectCode=function(a,b,c){var d=b.indexOf("\n");c=c?"#define WEBGL"+c.webgl_version+"\n":"";var f=b.substr(0,d).trim();return-1==f.indexOf("#version")?c+a+b:f+"\n"+c+a+b.substr(d)};Shader.compileSource=function(a,b,c,d){c=c||t.gl;d=d||c.createShader(a);c.shaderSource(d,b);c.compileShader(d);if(!c.getShaderParameter(d,c.COMPILE_STATUS))throw(a==c.VERTEX_SHADER?
"Vertex":"Fragment")+" shader compile error: "+c.getShaderInfoLog(d);return d};Shader.parseError=function(a,b,c){if(!a)return null;var d=a.split(" "),f=d[5].split(":");return{type:d[0],line_number:parseInt(f[1]),line_pos:parseInt(f[0]),line_code:("Fragment"==d[0]?c:b).split("\n")[parseInt(f[1])],err:a}};Shader.prototype.updateShader=function(a,b,c){var d=this.gl||t.gl,f=Shader.expandMacros(c);this.program?(d.detachShader(this.program,this.vs_shader),d.detachShader(this.program,this.fs_shader)):this.program=
d.createProgram();f=Shader.expandMacros(c);c=a.constructor===String?Shader.injectCode(f,a,d):a;f=b.constructor===String?Shader.injectCode(f,b,d):b;a=a.constructor===String?g.Shader.compileSource(d.VERTEX_SHADER,c):a;b=b.constructor===String?g.Shader.compileSource(d.FRAGMENT_SHADER,f):b;d.attachShader(this.program,a,d);d.attachShader(this.program,b,d);d.linkProgram(this.program);if(!d.getProgramParameter(this.program,d.LINK_STATUS))throw"link error: "+d.getProgramInfoLog(this.program);this.vs_shader=
a;this.fs_shader=b;this.attributes={};this.uniformInfo={};this.samplers={};this.extractShaderInfo()};Shader.prototype.extractShaderInfo=function(){for(var a=this.gl,b=a.getProgramParameter(this.program,a.ACTIVE_UNIFORMS),c=0;c<b;++c){var d=a.getActiveUniform(this.program,c);if(!d)break;var f=d.name,k=f.indexOf("[");-1!=k&&-1==f.indexOf("].")&&(f=f.substr(0,k));if(d.type==g.SAMPLER_2D||d.type==g.SAMPLER_CUBE||d.type==g.SAMPLER_3D||d.type==g.INT_SAMPLER_2D||d.type==g.INT_SAMPLER_CUBE||d.type==g.INT_SAMPLER_3D||
d.type==g.UNSIGNED_INT_SAMPLER_2D||d.type==g.UNSIGNED_INT_SAMPLER_CUBE||d.type==g.UNSIGNED_INT_SAMPLER_3D)this.samplers[f]=d.type;var k=Shader.getUniformFunc(d),q=!1;if(d.type==a.FLOAT_MAT2||d.type==a.FLOAT_MAT3||d.type==a.FLOAT_MAT4)q=!0;var l=g.TYPE_LENGTH[d.type]||1;this.uniformInfo[f]={type:d.type,func:k,size:d.size,type_length:l,is_matrix:q,loc:a.getUniformLocation(this.program,f),data:new Float32Array(l*d.size)}}c=0;for(b=a.getProgramParameter(this.program,a.ACTIVE_ATTRIBUTES);c<b;++c){d=a.getActiveAttrib(this.program,
c);if(!d)break;k=Shader.getUniformFunc(d);l=g.TYPE_LENGTH[d.type]||1;this.uniformInfo[d.name]={type:d.type,func:k,type_length:l,size:d.size,loc:null};this.attributes[d.name]=a.getAttribLocation(this.program,d.name)}};Shader.prototype.hasUniform=function(a){return this.uniformInfo[a]};Shader.prototype.hasAttribute=function(a){return this.attributes[a]};Shader.getUniformFunc=function(a){var b=null;switch(a.type){case g.FLOAT:b=1==a.size?gl.uniform1f:gl.uniform1fv;break;case g.FLOAT_MAT2:b=gl.uniformMatrix2fv;
break;case g.FLOAT_MAT3:b=gl.uniformMatrix3fv;break;case g.FLOAT_MAT4:b=gl.uniformMatrix4fv;break;case g.FLOAT_VEC2:b=gl.uniform2fv;break;case g.FLOAT_VEC3:b=gl.uniform3fv;break;case g.FLOAT_VEC4:b=gl.uniform4fv;break;case g.UNSIGNED_INT:case g.INT:b=1==a.size?gl.uniform1i:gl.uniform1iv;break;case g.INT_VEC2:b=gl.uniform2iv;break;case g.INT_VEC3:b=gl.uniform3iv;break;case g.INT_VEC4:b=gl.uniform4iv;break;case g.SAMPLER_2D:case g.SAMPLER_3D:case g.SAMPLER_CUBE:case g.INT_SAMPLER_2D:case g.INT_SAMPLER_3D:case g.INT_SAMPLER_CUBE:case g.UNSIGNED_INT_SAMPLER_2D:case g.UNSIGNED_INT_SAMPLER_3D:case g.UNSIGNED_INT_SAMPLER_CUBE:b=
gl.uniform1i;break;default:b=gl.uniform1f}return b};Shader.fromURL=function(a,b,c){function d(){var a=new g.Shader(k,q),b;for(b in a)f[b]=a[b];f.ready=!0}var f=new g.Shader("\n\t\t\tprecision highp float;\n\t\t\tattribute vec3 a_vertex;\n\t\t\tattribute mat4 u_mvp;\n\t\t\tvoid main() { \n\t\t\t\tgl_Position = u_mvp * vec4(a_vertex,1.0); \n\t\t\t}\n\t\t","\n\t\t\tprecision highp float;\n\t\t\tvoid main() {\n\t\t\t\tgl_FragColor = vec4(0.0, 0.0, 0.0, 1.0);\n\t\t\t}\n\t\t\t");f.ready=!1;var k=null,q=
null;HttpRequest(a,null,function(a){k=a;q&&d()});HttpRequest(b,null,function(a){q=a;k&&d()});return f};Shader.prototype.bind=function(){var a=this.gl;a.useProgram(this.program);a._current_shader=this};Shader.prototype.getLocation=function(a){return this.uniformInfo[a]?this.uniformInfo[a].loc:null};Shader._temp_uniform=new Float32Array(16);Shader.prototype.uniforms=function(a){var b=this.gl;b.useProgram(this.program);b._current_shader=this;for(var c in a)this.uniformInfo[c]&&this._setUniform(c,a[c]);
return this};Shader.prototype.uniformsArray=function(a){var b=this.gl;b.useProgram(this.program);b._current_shader=this;for(var b=0,c=a.length;b<c;++b){var d=a[b],f;for(f in d)this._setUniform(f,d[f])}return this};Shader.prototype.setUniform=function(){return function(a,b){this.gl._current_shader!=this&&this.bind();var c=this.uniformInfo[a];c&&null!==c.loc&&null!=b&&(b.constructor===Array&&(c.data.set(b),b=c.data),c.is_matrix?c.func.call(this.gl,c.loc,!1,b):c.func.call(this.gl,c.loc,b))}}();Shader.prototype._setUniform=
function(){return function(a,b){var c=this.uniformInfo[a];c&&null!==c.loc&&null!=b&&(b.constructor===Array&&(c.data.set(b),b=c.data),c.is_matrix?c.func.call(this.gl,c.loc,!1,b):c.func.call(this.gl,c.loc,b))}}();Shader.prototype.draw=function(a,b,c){c=void 0===c?b==gl.LINES?"lines":"triangles":c;this.drawBuffers(a.vertexBuffers,c?a.indexBuffers[c]:null,2>arguments.length?gl.TRIANGLES:b)};Shader.prototype.drawRange=function(a,b,c,d,f){f=void 0===f?b==gl.LINES?"lines":"triangles":f;this.drawBuffers(a.vertexBuffers,
f?a.indexBuffers[f]:null,b,c,d)};var P=new Uint8Array(16),U=new Uint8Array(16);Shader.prototype.drawBuffers=function(a,b,c,d,f){if(0!=f){var k=this.gl;k.useProgram(this.program);var g=0;P.set(U);for(var l in a){var m=a[l],n=m.attribute||l,p=this.attributes[n];null!=p&&m.buffer&&(P[p]=1,k.bindBuffer(k.ARRAY_BUFFER,m.buffer),k.enableVertexAttribArray(p),k.vertexAttribPointer(p,m.buffer.spacing,m.buffer.gl_type,!1,0,0),g=m.buffer.length/m.buffer.spacing)}a=0;0<d&&(a=d);b&&(g=b.buffer.length-a);0<f&&
f<g&&(g=f);a*=b&&b.data?b.data.constructor.BYTES_PER_ELEMENT:1;for(n in this.attributes)p=this.attributes[n],P[p]||k.disableVertexAttribArray(this.attributes[n]);!g||b&&!b.buffer||(b?(k.bindBuffer(k.ELEMENT_ARRAY_BUFFER,b.buffer),k.drawElements(c,g,b.buffer.gl_type,a),k.bindBuffer(k.ELEMENT_ARRAY_BUFFER,null)):k.drawArrays(c,a,g),k.draw_calls++);return this}};Shader._instancing_arrays=[];Shader.prototype.drawInstanced=function(a,b,c,d,f,k,q){if(0!==k){var l=this.gl;if(1==l.webgl_version&&!l.extensions.ANGLE_instanced_arrays)throw"instancing not supported";
l.useProgram(this.program);var m=0;P.set(U);var n=a.vertexBuffers,p;for(p in n){var r=n[p],v=r.attribute||p,u=this.attributes[v];null!=u&&r.buffer&&(P[u]=1,l.bindBuffer(l.ARRAY_BUFFER,r.buffer),l.enableVertexAttribArray(u),l.vertexAttribPointer(u,r.buffer.spacing,r.buffer.gl_type,!1,0,0),m=r.buffer.length/r.buffer.spacing)}n=null;c&&(c.constructor===String?n=a.getIndexBuffer(c):c.constructor===g.Buffer&&(n=c));a=0;0<f&&(a=f);n&&(m=n.buffer.length-a);0<k&&k<m&&(m=k);a*=n&&n.data?n.data.constructor.BYTES_PER_ELEMENT:
1;for(v in this.attributes)u=this.attributes[v],P[u]||l.disableVertexAttribArray(this.attributes[v]);f=l.extensions.ANGLE_instanced_arrays;k=u=0;for(var s in d){p=d[s];u=p.length;v=this.attributes[s];if(null==v)return;var x=c=0;p.constructor===Array?(c=p[0].constructor===Number?1:p[0].length,x=c*p.length):(c=this.uniformInfo[s].type_length,x=p.length,u=x/c);r=Shader._instancing_arrays[k];if(!r||r.data.length<x)r=Shader._instancing_arrays[k]={data:new Float32Array(x),buffer:l.createBuffer()};r.uniform=
s;r.element_size=c;if(p.constructor===Array)for(x=0;x<p.length;++x)r.data.set(p[x],x*c);else r.data.set(p);l.bindBuffer(l.ARRAY_BUFFER,r.buffer);l.bufferData(l.ARRAY_BUFFER,r.data,l.STREAM_DRAW);if(16==c)for(c=0;4>c;++c)l.enableVertexAttribArray(v+c),l.vertexAttribPointer(v+c,4,l.FLOAT,!1,64,16*c),f?f.vertexAttribDivisorANGLE(v+c,1):l.vertexAttribDivisor(v+c,1);else l.enableVertexAttribArray(v),l.vertexAttribPointer(v,c,l.FLOAT,!1,4*c,0),f?f.vertexAttribDivisorANGLE(v,1):l.vertexAttribDivisor(v,1);
k+=1}q&&(u=q);f?n?(l.bindBuffer(l.ELEMENT_ARRAY_BUFFER,n.buffer),f.drawElementsInstancedANGLE(b,m,n.buffer.gl_type,a,u),l.bindBuffer(l.ELEMENT_ARRAY_BUFFER,null)):f.drawArraysInstancedANGLE(b,a,m,u):n?(l.bindBuffer(l.ELEMENT_ARRAY_BUFFER,n.buffer),l.drawElementsInstanced(b,m,n.buffer.gl_type,a,u),l.bindBuffer(l.ELEMENT_ARRAY_BUFFER,null)):l.drawArraysInstanced(b,a,m,u);for(b=0;b<k;++b)if(d=Shader._instancing_arrays[b],v=this.attributes[d.uniform],c=d.element_size,16==c)for(c=0;4>c;++c)l.disableVertexAttribArray(v+
c),f?f.vertexAttribDivisorANGLE(v+c,0):l.vertexAttribDivisor(v+c,0);else l.enableVertexAttribArray(v),f?f.vertexAttribDivisorANGLE(v,0):l.vertexAttribDivisor(v,0);return this}};Shader.expandImports=function(a,b){b=b||Shader.files;var c={};if(!b)throw"Shader.files not initialized, assign files there";return a.replace(/#import\s+\"([a-zA-Z0-9_\.]+)\"\s*\n/g,function(a){a=a.split('"')[1];if(c[a])return"//already imported: "+a+"\n";var f=b[a];c[a]=!0;return f?f+"\n":"//import code not found: "+a+"\n"})};
Shader.dumpErrorToConsole=function(a,b,c){console.error(a);var d=null,d=-1!=a.indexOf("Fragment")?c:b;a=d.split("\n");for(var f in a)a[f]=f+"| "+a[f];console.groupCollapsed("Shader code");console.log(a.join("\n"));console.groupEnd()};Shader.convertTo100=function(a,b){};Shader.convertTo300=function(a,b){};Shader.validateValue=function(a,b){if(null===a||void 0===a)return!1;switch(b.type){case g.INT:case g.FLOAT:case g.SAMPLER_2D:case g.SAMPLER_3D:case g.SAMPLER_CUBE:case g.INT_SAMPLER_2D:case g.INT_SAMPLER_3D:case g.INT_SAMPLER_CUBE:case g.UNSIGNED_INT_SAMPLER_2D:case g.UNSIGNED_INT_SAMPLER_3D:case g.UNSIGNED_INT_SAMPLER_CUBE:return isNumber(a);
case g.INT_VEC2:case g.FLOAT_VEC2:return 2===a.length;case g.INT_VEC3:case g.FLOAT_VEC3:return 3===a.length;case g.INT_VEC4:case g.FLOAT_VEC4:case g.FLOAT_MAT2:return 4===a.length;case g.FLOAT_MAT3:return 8===a.length;case g.FLOAT_MAT4:return 16===a.length}return!0};Shader.DEFAULT_VERTEX_SHADER="\n\t\t\tprecision highp float;\n\t\t\tattribute vec3 a_vertex;\n\t\t\tattribute vec3 a_normal;\n\t\t\tattribute vec2 a_coord;\n\t\t\tvarying vec3 v_position;\n\t\t\tvarying vec3 v_normal;\n\t\t\tvarying vec2 v_coord;\n\t\t\tuniform mat4 u_model;\n\t\t\tuniform mat4 u_mvp;\n\t\t\tvoid main() {\n\t\t\t\tv_position = (u_model * vec4(a_vertex,1.0)).xyz;\n\t\t\t\tv_normal = (u_model * vec4(a_normal,0.0)).xyz;\n\t\t\t\tv_coord = a_coord;\n\t\t\t\tgl_Position = u_mvp * vec4(a_vertex,1.0);\n\t\t\t}\n\t\t\t";
Shader.SCREEN_VERTEX_SHADER="\n\t\t\tprecision highp float;\n\t\t\tattribute vec3 a_vertex;\n\t\t\tattribute vec2 a_coord;\n\t\t\tvarying vec2 v_coord;\n\t\t\tvoid main() { \n\t\t\t\tv_coord = a_coord; \n\t\t\t\tgl_Position = vec4(a_coord * 2.0 - 1.0, 0.0, 1.0); \n\t\t\t}\n\t\t\t";Shader.SCREEN_FRAGMENT_SHADER="\n\t\t\tprecision highp float;\n\t\t\tuniform sampler2D u_texture;\n\t\t\tvarying vec2 v_coord;\n\t\t\tvoid main() {\n\t\t\t\tgl_FragColor = texture2D(u_texture, v_coord);\n\t\t\t}\n\t\t\t";
Shader.SCREEN_FRAGMENT_FX="\n\t\t\tprecision highp float;\n\t\t\tuniform sampler2D u_texture;\n\t\t\tvarying vec2 v_coord;\n\t\t\t#ifdef FX_UNIFORMS\n\t\t\t\tFX_UNIFORMS\n\t\t\t#endif\n\t\t\tvoid main() {\n\t\t\t\tvec2 uv = v_coord;\n\t\t\t\tvec4 color = texture2D(u_texture, uv);\n\t\t\t\t#ifdef FX_CODE\n\t\t\t\t\tFX_CODE ;\n\t\t\t\t#endif\n\t\t\t\tgl_FragColor = color;\n\t\t\t}\n\t\t\t";Shader.SCREEN_COLORED_FRAGMENT_SHADER="\n\t\t\tprecision highp float;\n\t\t\tuniform sampler2D u_texture;\n\t\t\tuniform vec4 u_color;\n\t\t\tvarying vec2 v_coord;\n\t\t\tvoid main() {\n\t\t\t\tgl_FragColor = u_color * texture2D(u_texture, v_coord);\n\t\t\t}\n\t\t\t";
Shader.BLEND_FRAGMENT_SHADER="\n\t\t\tprecision highp float;\n\t\t\tuniform sampler2D u_texture;\n\t\t\tuniform sampler2D u_texture2;\n\t\t\tuniform float u_factor;\n\t\t\tvarying vec2 v_coord;\n\t\t\tvoid main() {\n\t\t\t\tgl_FragColor = mix( texture2D(u_texture, v_coord), texture2D(u_texture2, v_coord), u_factor);\n\t\t\t}\n\t\t\t";Shader.QUAD_VERTEX_SHADER="\n\t\t\tprecision highp float;\n\t\t\tattribute vec3 a_vertex;\n\t\t\tattribute vec2 a_coord;\n\t\t\tvarying vec2 v_coord;\n\t\t\tuniform vec2 u_position;\n\t\t\tuniform vec2 u_size;\n\t\t\tuniform vec2 u_viewport;\n\t\t\tuniform mat3 u_transform;\n\t\t\tvoid main() { \n\t\t\t\tvec3 pos = vec3(u_position + vec2(a_coord.x,1.0 - a_coord.y)  * u_size, 1.0);\n\t\t\t\tv_coord = a_coord; \n\t\t\t\tpos = u_transform * pos;\n\t\t\t\tpos.z = 0.0;\n\t\t\t\t//normalize\n\t\t\t\tpos.x = (2.0 * pos.x / u_viewport.x) - 1.0;\n\t\t\t\tpos.y = -((2.0 * pos.y / u_viewport.y) - 1.0);\n\t\t\t\tgl_Position = vec4(pos, 1.0); \n\t\t\t}\n\t\t\t";
Shader.QUAD_FRAGMENT_SHADER="\n\t\t\tprecision highp float;\n\t\t\tuniform sampler2D u_texture;\n\t\t\tuniform vec4 u_color;\n\t\t\tvarying vec2 v_coord;\n\t\t\tvoid main() {\n\t\t\t\tgl_FragColor = u_color * texture2D(u_texture, v_coord);\n\t\t\t}\n\t\t\t";Shader.QUAD2_FRAGMENT_SHADER="\n\t\t\tprecision highp float;\n\t\t\tuniform sampler2D u_texture;\n\t\t\tuniform vec4 u_color;\n\t\t\tuniform vec4 u_texture_area;\n\t\t\tvarying vec2 v_coord;\n\t\t\tvoid main() {\n\t\t\t    vec2 uv = vec2( mix(u_texture_area.x, u_texture_area.z, v_coord.x), 1.0 - mix(u_texture_area.w, u_texture_area.y, v_coord.y) );\n\t\t\t\tgl_FragColor = u_color * texture2D(u_texture, uv);\n\t\t\t}\n\t\t\t";
Shader.PRIMITIVE2D_VERTEX_SHADER="\n\t\t\tprecision highp float;\n\t\t\tattribute vec3 a_vertex;\n\t\t\tuniform vec2 u_viewport;\n\t\t\tuniform mat3 u_transform;\n\t\t\tvoid main() { \n\t\t\t\tvec3 pos = a_vertex;\n\t\t\t\tpos = u_transform * pos;\n\t\t\t\tpos.z = 0.0;\n\t\t\t\t//normalize\n\t\t\t\tpos.x = (2.0 * pos.x / u_viewport.x) - 1.0;\n\t\t\t\tpos.y = -((2.0 * pos.y / u_viewport.y) - 1.0);\n\t\t\t\tgl_Position = vec4(pos, 1.0); \n\t\t\t}\n\t\t\t";Shader.FLAT_VERTEX_SHADER="\n\t\t\tprecision highp float;\n\t\t\tattribute vec3 a_vertex;\n\t\t\tuniform mat4 u_mvp;\n\t\t\tvoid main() { \n\t\t\t\tgl_Position = u_mvp * vec4(a_vertex,1.0); \n\t\t\t}\n\t\t\t";
Shader.FLAT_FRAGMENT_SHADER="\n\t\t\tprecision highp float;\n\t\t\tuniform vec4 u_color;\n\t\t\tvoid main() {\n\t\t\t\tgl_FragColor = u_color;\n\t\t\t}\n\t\t\t";Shader.SCREEN_FLAT_FRAGMENT_SHADER=Shader.FLAT_FRAGMENT_SHADER;Shader.createFX=function(a,b,c){a=g.Shader.removeComments(a,!0);a={FX_CODE:a,FX_UNIFORMS:b||""};if(!c)return new g.Shader(g.Shader.SCREEN_VERTEX_SHADER,g.Shader.SCREEN_FRAGMENT_FX,a);c.updateShader(g.Shader.SCREEN_VERTEX_SHADER,g.Shader.SCREEN_FRAGMENT_FX,a);return c};Shader.replaceCodeUsingContext=
function(a,b){return a.replace(/\{\{[a-zA-Z0-9_]*\}\}/g,function(a){a=a.replace(/[\{\}]/g,"");return b[a]||""})};Shader.removeComments=function(a,b){if(!a)return"";a=a.replace(/(\/\*([^*]|[\r\n]|(\*+([^*\/]|[\r\n])))*\*+\/)|(\/\/.*)/g,"");for(var c=a.split("\n"),d=[],f=0;f<c.length;++f){var k=c[f],g=k.indexOf("//");-1!=g&&(k=c[f].substr(0,g));k=k.trim();k.length&&d.push(k)}return d.join(b?"":"\n")};Shader.prototype.toViewport=function(a){var b=g.Mesh.getScreenQuad();a&&this.uniforms(a);this.draw(b)};
Shader.getScreenShader=function(a){a=a||t.gl;var b=a.shaders[":screen"];if(b)return b;b=a.shaders[":screen"]=new g.Shader(Shader.SCREEN_VERTEX_SHADER,Shader.SCREEN_FRAGMENT_SHADER);return b.uniforms({u_texture:0})};Shader.getFlatScreenShader=function(a){a=a||t.gl;var b=a.shaders[":flat_screen"];if(b)return b;b=a.shaders[":flat_screen"]=new g.Shader(Shader.SCREEN_VERTEX_SHADER,Shader.FLAT_FRAGMENT_SHADER);return b.uniforms({u_color:[1,1,1,1]})};Shader.getColoredScreenShader=function(a){a=a||t.gl;var b=
a.shaders[":colored_screen"];if(b)return b;b=a.shaders[":colored_screen"]=new g.Shader(Shader.SCREEN_VERTEX_SHADER,Shader.SCREEN_COLORED_FRAGMENT_SHADER);return b.uniforms({u_texture:0,u_color:vec4.fromValues(1,1,1,1)})};Shader.getQuadShader=function(a){a=a||t.gl;var b=a.shaders[":quad"];return b?b:a.shaders[":quad"]=new g.Shader(Shader.QUAD_VERTEX_SHADER,Shader.QUAD_FRAGMENT_SHADER)};Shader.getPartialQuadShader=function(a){a=a||t.gl;var b=a.shaders[":quad2"];return b?b:a.shaders[":quad2"]=new g.Shader(Shader.QUAD_VERTEX_SHADER,
Shader.QUAD2_FRAGMENT_SHADER)};Shader.getBlendShader=function(a){a=a||t.gl;var b=a.shaders[":blend"];return b?b:a.shaders[":blend"]=new g.Shader(Shader.SCREEN_VERTEX_SHADER,Shader.BLEND_FRAGMENT_SHADER)};Shader.getBlurShader=function(a){a=a||t.gl;var b=a.shaders[":blur"];if(b)return b;b=new g.Shader(Shader.SCREEN_VERTEX_SHADER,"\n\t\t\tprecision highp float;\n\t\t\tvarying vec2 v_coord;\n\t\t\tuniform sampler2D u_texture;\n\t\t\tuniform vec2 u_offset;\n\t\t\tuniform float u_intensity;\n\t\t\tvoid main() {\n\t\t\t   vec4 sum = vec4(0.0);\n\t\t\t   sum += texture2D(u_texture, v_coord + u_offset * -4.0) * 0.05/0.98;\n\t\t\t   sum += texture2D(u_texture, v_coord + u_offset * -3.0) * 0.09/0.98;\n\t\t\t   sum += texture2D(u_texture, v_coord + u_offset * -2.0) * 0.12/0.98;\n\t\t\t   sum += texture2D(u_texture, v_coord + u_offset * -1.0) * 0.15/0.98;\n\t\t\t   sum += texture2D(u_texture, v_coord) * 0.16/0.98;\n\t\t\t   sum += texture2D(u_texture, v_coord + u_offset * 4.0) * 0.05/0.98;\n\t\t\t   sum += texture2D(u_texture, v_coord + u_offset * 3.0) * 0.09/0.98;\n\t\t\t   sum += texture2D(u_texture, v_coord + u_offset * 2.0) * 0.12/0.98;\n\t\t\t   sum += texture2D(u_texture, v_coord + u_offset * 1.0) * 0.15/0.98;\n\t\t\t   gl_FragColor = u_intensity * sum;\n\t\t\t}\n\t\t\t");
return a.shaders[":blur"]=b};Shader.getCopyDepthShader=function(a){a=a||t.gl;var b=a.shaders[":copy_depth"];if(b)return b;b=new g.Shader(Shader.SCREEN_VERTEX_SHADER,"\n\t\t\t#extension GL_EXT_frag_depth : enable\n\t\t\tprecision highp float;\n\t\t\tvarying vec2 v_coord;\n\t\t\tuniform sampler2D u_texture;\n\t\t\tvoid main() {\n\t\t\t   gl_FragDepthEXT = texture2D( u_texture, v_coord ).x;\n\t\t\t   gl_FragColor = vec4(1.0);\n\t\t\t}\n\t\t\t");return a.shaders[":copy_depth"]=b};Shader.getCubemapShowShader=
function(a){a=a||t.gl;var b=a.shaders[":show_cubemap"];if(b)return b;b=new g.Shader(Shader.DEFAULT_VERTEX_SHADER,"\n\t\t\tprecision highp float;\n\t\t\tvarying vec3 v_normal;\n\t\t\tuniform samplerCube u_texture;\n\t\t\tvoid main() {\n\t\t\t   gl_FragColor = textureCube( u_texture, v_normal );\n\t\t\t}\n\t\t\t");b.uniforms({u_texture:0});return a.shaders[":show_cubemap"]=b};Shader.getPolarToCubemapShader=function(a){a=a||t.gl;var b=a.shaders[":polar_to_cubemap"];if(b)return b;b=new g.Shader(Shader.SCREEN_VERTEX_SHADER,
"\n\t\t\tprecision highp float;\n\t\t\tvarying vec2 v_coord;\n\t\t\tuniform sampler2D u_texture;\n\t\t\tuniform mat3 u_rotation;\n\t\t\tvoid main() {\n\t\t\t\tvec2 uv = vec2( v_coord.x, 1.0 - v_coord.y );\n\t\t\t\tvec3 dir = normalize( vec3( uv - vec2(0.5), 0.5 ));\n\t\t\t\tdir = u_rotation * dir;\n\t\t\t\tfloat u = atan(dir.x,dir.z) / 6.28318531;\n\t\t\t\tfloat v = (asin(dir.y) / 1.57079633) * 0.5 + 0.5;\n\t\t\t\tu = mod(u,1.0);\n\t\t\t\tv = mod(v,1.0);\n\t\t\t   gl_FragColor = texture2D( u_texture, vec2(u,v) );\n\t\t\t}\n\t\t\t");
return a.shaders[":polar_to_cubemap"]=b};Shader.getCubemapCopyShader=function(a){a=a||t.gl;var b=a.shaders[":copy_cubemap"];if(b)return b;b=new g.Shader(Shader.SCREEN_VERTEX_SHADER,"\n\t\t\tprecision highp float;\n\t\t\tvarying vec2 v_coord;\n\t\t\tuniform samplerCube u_texture;\n\t\t\tuniform mat3 u_rotation;\n\t\t\tvoid main() {\n\t\t\t\tvec2 uv = vec2( v_coord.x, 1.0 - v_coord.y );\n\t\t\t\tvec3 dir = vec3( uv - vec2(0.5), 0.5 );\n\t\t\t\tdir = u_rotation * dir;\n\t\t\t   gl_FragColor = textureCube( u_texture, dir );\n\t\t\t}\n\t\t\t");
return a.shaders[":copy_cubemap"]=b};Shader.getCubemapBlurShader=function(a){a=a||t.gl;var b=a.shaders[":blur_cubemap"];if(b)return b;b=new g.Shader(Shader.SCREEN_VERTEX_SHADER,"\n\t\t\t#ifndef NUM_SAMPLES\n\t\t\t\t#define NUM_SAMPLES 4\n\t\t\t#endif\n\t\t\t\n\t\t\tprecision highp float;\n\t\t\tvarying vec2 v_coord;\n\t\t\tuniform samplerCube u_texture;\n\t\t\tuniform mat3 u_rotation;\n\t\t\tuniform vec2 u_offset;\n\t\t\tuniform float u_intensity;\n\t\t\tvoid main() {\n\t\t\t\tvec4 sum = vec4(0.0);\n\t\t\t\tvec2 uv = vec2( v_coord.x, 1.0 - v_coord.y ) - vec2(0.5);\n\t\t\t\tvec3 dir = vec3(0.0);\n\t\t\t\tvec4 color = vec4(0.0);\n\t\t\t\tfor( int x = -2; x <= 2; x++ )\n\t\t\t\t{\n\t\t\t\t\tfor( int y = -2; y <= 2; y++ )\n\t\t\t\t\t{\n\t\t\t\t\t\tdir.xy = uv + vec2( u_offset.x * float(x), u_offset.y * float(y)) * 0.5;\n\t\t\t\t\t\tdir.z = 0.5;\n\t\t\t\t\t\tdir = u_rotation * dir;\n\t\t\t\t\t\tcolor = textureCube( u_texture, dir );\n\t\t\t\t\t\tcolor.xyz = color.xyz * color.xyz;/*linearize*/\n\t\t\t\t\t\tsum += color;\n\t\t\t\t\t}\n\t\t\t\t}\n\t\t\t\tsum /= 25.0;\n\t\t\t   gl_FragColor = vec4( sqrt( sum.xyz ), sum.w ) ;\n\t\t\t}\n\t\t\t");
return a.shaders[":blur_cubemap"]=b};Shader.FXAA_FUNC="\n\tuniform vec2 u_viewportSize;\n\tuniform vec2 u_iViewportSize;\n\t#define FXAA_REDUCE_MIN   (1.0/ 128.0)\n\t#define FXAA_REDUCE_MUL   (1.0 / 8.0)\n\t#define FXAA_SPAN_MAX     8.0\n\t\n\t/* from mitsuhiko/webgl-meincraft based on the code on geeks3d.com */\n\t/* fragCoord MUST BE IN PIXELS */\n\tvec4 applyFXAA(sampler2D tex, vec2 fragCoord)\n\t{\n\t\tvec4 color = vec4(0.0);\n\t\t/*vec2 u_iViewportSize = vec2(1.0 / u_viewportSize.x, 1.0 / u_viewportSize.y);*/\n\t\tvec3 rgbNW = texture2D(tex, (fragCoord + vec2(-1.0, -1.0)) * u_iViewportSize).xyz;\n\t\tvec3 rgbNE = texture2D(tex, (fragCoord + vec2(1.0, -1.0)) * u_iViewportSize).xyz;\n\t\tvec3 rgbSW = texture2D(tex, (fragCoord + vec2(-1.0, 1.0)) * u_iViewportSize).xyz;\n\t\tvec3 rgbSE = texture2D(tex, (fragCoord + vec2(1.0, 1.0)) * u_iViewportSize).xyz;\n\t\tvec3 rgbM  = texture2D(tex, fragCoord  * u_iViewportSize).xyz;\n\t\tvec3 luma = vec3(0.299, 0.587, 0.114);\n\t\tfloat lumaNW = dot(rgbNW, luma);\n\t\tfloat lumaNE = dot(rgbNE, luma);\n\t\tfloat lumaSW = dot(rgbSW, luma);\n\t\tfloat lumaSE = dot(rgbSE, luma);\n\t\tfloat lumaM  = dot(rgbM,  luma);\n\t\tfloat lumaMin = min(lumaM, min(min(lumaNW, lumaNE), min(lumaSW, lumaSE)));\n\t\tfloat lumaMax = max(lumaM, max(max(lumaNW, lumaNE), max(lumaSW, lumaSE)));\n\t\t\n\t\tvec2 dir;\n\t\tdir.x = -((lumaNW + lumaNE) - (lumaSW + lumaSE));\n\t\tdir.y =  ((lumaNW + lumaSW) - (lumaNE + lumaSE));\n\t\t\n\t\tfloat dirReduce = max((lumaNW + lumaNE + lumaSW + lumaSE) * (0.25 * FXAA_REDUCE_MUL), FXAA_REDUCE_MIN);\n\t\t\n\t\tfloat rcpDirMin = 1.0 / (min(abs(dir.x), abs(dir.y)) + dirReduce);\n\t\tdir = min(vec2(FXAA_SPAN_MAX, FXAA_SPAN_MAX), max(vec2(-FXAA_SPAN_MAX, -FXAA_SPAN_MAX), dir * rcpDirMin)) * u_iViewportSize;\n\t\t\n\t\tvec3 rgbA = 0.5 * (texture2D(tex, fragCoord * u_iViewportSize + dir * (1.0 / 3.0 - 0.5)).xyz + \n\t\t\ttexture2D(tex, fragCoord * u_iViewportSize + dir * (2.0 / 3.0 - 0.5)).xyz);\n\t\tvec3 rgbB = rgbA * 0.5 + 0.25 * (texture2D(tex, fragCoord * u_iViewportSize + dir * -0.5).xyz + \n\t\t\ttexture2D(tex, fragCoord * u_iViewportSize + dir * 0.5).xyz);\n\t\t\n\t\t//return vec4(rgbA,1.0);\n\t\tfloat lumaB = dot(rgbB, luma);\n\t\tif ((lumaB < lumaMin) || (lumaB > lumaMax))\n\t\t\tcolor = vec4(rgbA, 1.0);\n\t\telse\n\t\t\tcolor = vec4(rgbB, 1.0);\n\t\treturn color;\n\t}\n";
Shader.getFXAAShader=function(a){a=a||t.gl;var b=a.shaders[":fxaa"];if(b)return b;var b=new g.Shader(Shader.SCREEN_VERTEX_SHADER,"\n\t\t\tprecision highp float;\n\t\t\tvarying vec2 v_coord;\n\t\t\tuniform sampler2D u_texture;\n\t\t\t"+Shader.FXAA_FUNC+"\n\t\t\t\n\t\t\tvoid main() {\n\t\t\t   gl_FragColor = applyFXAA( u_texture, v_coord * u_viewportSize) ;\n\t\t\t}\n\t\t\t"),c=vec2.fromValues(a.viewport_data[2],a.viewport_data[3]),d=vec2.fromValues(1/a.viewport_data[2],1/a.viewport_data[3]);b.setup=
function(){c[0]=a.viewport_data[2];c[1]=a.viewport_data[3];d[0]=1/a.viewport_data[2];d[1]=1/a.viewport_data[3];this.uniforms({u_viewportSize:c,u_iViewportSize:d})};return a.shaders[":fxaa"]=b};Shader.getFlatShader=function(a){a=a||t.gl;var b=a.shaders[":flat"];if(b)return b;b=new g.Shader(Shader.FLAT_VERTEX_SHADER,Shader.FLAT_FRAGMENT_SHADER);b.uniforms({u_color:[1,1,1,1]});return a.shaders[":flat"]=b};g.create=function(a){function b(a){if(!l.ignore_events){var c=l.mouse.buttons;g.augmentEvent(a,
f);a.eventType=a.eventType||a.type;var d=getTime();p.dragging=a.dragging;p.position[0]=a.canvasx;p.position[1]=a.canvasy;p.x=a.canvasx;p.y=a.canvasy;p.mousex=a.mousex;p.mousey=a.mousey;p.canvasx=a.canvasx;p.canvasy=a.canvasy;p.clientx=a.mousex;p.clienty=a.mousey;p.buttons=a.buttons;p.left_button=!!(p.buttons&g.LEFT_MOUSE_BUTTON_MASK);p.middle_button=!!(p.buttons&g.MIDDLE_MOUSE_BUTTON_MASK);p.right_button=!!(p.buttons&g.RIGHT_MOUSE_BUTTON_MASK);if("mousedown"==a.eventType){0==c&&(f.removeEventListener("mousemove",
b),c=f.ownerDocument,c.addEventListener("mousemove",b),c.addEventListener("mouseup",b));n=d;if(l.onmousedown)l.onmousedown(a);y.trigger(l,"mousedown")}else if("mousemove"==a.eventType){if(l.onmousemove)l.onmousemove(a);y.trigger(l,"mousemove",a)}else if("mouseup"==a.eventType){0==l.mouse.buttons&&(f.addEventListener("mousemove",b),c=f.ownerDocument,c.removeEventListener("mousemove",b),c.removeEventListener("mouseup",b));a.click_time=d-n;if(l.onmouseup)l.onmouseup(a);y.trigger(l,"mouseup",a)}else if("mousewheel"==
a.eventType||"wheel"==a.eventType||"DOMMouseScroll"==a.eventType){a.eventType="mousewheel";a.wheel="wheel"==a.type?-a.deltaY:null!=a.wheelDeltaY?a.wheelDeltaY:-60*a.detail;a.delta=void 0!==a.wheelDelta?a.wheelDelta/40:a.deltaY?-a.deltaY/3:0;if(l.onmousewheel)l.onmousewheel(a);y.trigger(l,"mousewheel",a)}else if("dragstart"==a.eventType){if(l.ondragstart)l.ondragstart(a);y.trigger(l,"dragstart",a)}if(l.onmouse)l.onmouse(a);if(!a.skip_preventDefault)return"mousemove"!=a.eventType&&a.stopPropagation(),
a.preventDefault(),!1}}function c(a){var b=a.changedTouches,c=b[0],d="";if(!(l.ontouch&&!0===l.ontouch(a)||!0===y.trigger(l,a.type,a)||!r||a.touches.length&&a.changedTouches[0].identifier!==a.touches[0].identifier||1<b)){switch(a.type){case "touchstart":d="mousedown";break;case "touchmove":d="mousemove";break;case "touchend":d="mouseup";break;default:return}b=document.createEvent("MouseEvent");b.initMouseEvent(d,!0,!0,window,1,c.screenX,c.screenY,c.clientX,c.clientY,!1,!1,!1,!1,0,null);b.originalEvent=
b;b.is_touch=!0;c.target.dispatchEvent(b);a.preventDefault()}}function d(a){a.eventType=a.type;l.ongesture&&!1===l.ongesture(a)||!1!==y.trigger(l,a.type,a)&&a.preventDefault()}a=a||{};var f=null;if(a.canvas)if("string"==typeof a.canvas){if(f=document.getElementById(a.canvas),!f)throw"Canvas element not found: "+a.canvas;}else f=a.canvas;else{var k=null;a.container&&(k=a.container.constructor===String?document.querySelector(a.container):a.container);if(k&&!a.width){var q=k.getBoundingClientRect();
a.width=q.width;a.height=q.height}f=createCanvas(a.width||800,a.height||600);k&&k.appendChild(f)}"alpha"in a||(a.alpha=!1);var l=null,k=null;2==a.version?k=["webgl2","experimental-webgl2"]:1==a.version||void 0===a.version?k=["webgl","experimental-webgl"]:0===a.version&&(k=["webgl2","experimental-webgl2","webgl","experimental-webgl"]);if(!k)throw"Incorrect WebGL version, must be 1 or 2";a={alpha:void 0===a.alpha?!0:a.alpha,depth:void 0===a.depth?!0:a.depth,stencil:void 0===a.stencil?!0:a.stencil,antialias:void 0===
a.antialias?!0:a.antialias,premultipliedAlpha:void 0===a.premultipliedAlpha?!0:a.premultipliedAlpha,preserveDrawingBuffer:void 0===a.preserveDrawingBuffer?!0:a.preserveDrawingBuffer};for(q=0;q<k.length;++q){try{l=f.getContext(k[q],a)}catch(m){}if(l)break}if(!l){if(f.getContext("webgl"))throw"WebGL supported but not with those parameters";throw"WebGL not supported";}l.webgl_version="WebGL2RenderingContext"===l.constructor.name?2:1;t.gl=l;f.is_webgl=!0;f.gl=l;l.context_id=this.last_context_id++;l.extensions=
{};l.extensions.OES_standard_derivatives=l.derivatives_supported=l.getExtension("OES_standard_derivatives")||!1;l.extensions.WEBGL_depth_texture=l.getExtension("WEBGL_depth_texture")||l.getExtension("WEBKIT_WEBGL_depth_texture")||l.getExtension("MOZ_WEBGL_depth_texture");l.extensions.OES_element_index_uint=l.getExtension("OES_element_index_uint");l.extensions.WEBGL_draw_buffers=l.getExtension("WEBGL_draw_buffers");l.extensions.EXT_shader_texture_lod=l.getExtension("EXT_shader_texture_lod");l.extensions.EXT_sRGB=
l.getExtension("EXT_sRGB");l.extensions.EXT_texture_filter_anisotropic=l.getExtension("EXT_texture_filter_anisotropic")||l.getExtension("WEBKIT_EXT_texture_filter_anisotropic")||l.getExtension("MOZ_EXT_texture_filter_anisotropic");l.extensions.EXT_frag_depth=l.getExtension("EXT_frag_depth")||l.getExtension("WEBKIT_EXT_frag_depth")||l.getExtension("MOZ_EXT_frag_depth");l.extensions.WEBGL_lose_context=l.getExtension("WEBGL_lose_context")||l.getExtension("WEBKIT_WEBGL_lose_context")||l.getExtension("MOZ_WEBGL_lose_context");
l.extensions.ANGLE_instanced_arrays=l.getExtension("ANGLE_instanced_arrays");l.extensions.disjoint_timer_query=l.getExtension("EXT_disjoint_timer_query");l.extensions.OES_texture_float_linear=l.getExtension("OES_texture_float_linear");l.extensions.OES_texture_float_linear&&(l.extensions.OES_texture_float=l.getExtension("OES_texture_float"));l.extensions.EXT_color_buffer_float=l.getExtension("EXT_color_buffer_float");l.extensions.OES_texture_half_float_linear=l.getExtension("OES_texture_half_float_linear");
l.extensions.OES_texture_half_float_linear&&(l.extensions.OES_texture_half_float=l.getExtension("OES_texture_half_float"));l.HIGH_PRECISION_FORMAT=1==l.webgl_version?l.extensions.OES_texture_half_float?g.HALF_FLOAT_OES:l.extensions.OES_texture_float?g.FLOAT:g.UNSIGNED_BYTE:g.HALF_FLOAT_OES;l.max_texture_units=l.getParameter(l.MAX_TEXTURE_IMAGE_UNITS);l._viewport_func?console.warn("Creating LiteGL context over the same canvas twice"):(l._viewport_func=l.viewport,l.viewport_data=new Float32Array([0,
0,l.canvas.width,l.canvas.height]),l.viewport=function(a,b,c,d){var f=this.viewport_data;f[0]=a|0;f[1]=b|0;f[2]=c|0;f[3]=d|0;this._viewport_func(a,b,c,d)},l.getViewport=function(a){return a?(a[0]=l.viewport_data[0],a[1]=l.viewport_data[1],a[2]=l.viewport_data[2],a[3]=l.viewport_data[3],a):new Float32Array(l.viewport_data)},l.setViewport=function(a,b){l.viewport_data.set(a);b&&(l.viewport_data[1]=this.drawingBufferHeight-a[1]-a[3]);this._viewport_func(a[0],l.viewport_data[1],a[2],a[3])});if(!g.reverse)for(q in g.reverse=
{},l)l[q]&&l[q].constructor===Number&&(g.reverse[l[q]]=q);if("undefined"==typeof glMatrix)throw"glMatrix not found, LiteGL requires glMatrix to be included";var n=0;l.shaders={};l.textures={};l.meshes={};l.draw_calls=0;l.makeCurrent=function(){t.gl=this};l.execute=function(a){var b=t.gl;t.gl=this;a();t.gl=b};l.animate=function(a){function b(){if(!l.destroyed){f._requestFrame_id=c(b);var a=getTime(),g=0.001*(a-d);f.mouse&&(f.mouse.last_buttons=k);k=f.mouse.buttons;if(f.onupdate)f.onupdate(g);y.trigger(f,
"update",g);f.ondraw&&(g=t.gl,t.gl=f,f.ondraw(),y.trigger(f,"draw"),t.gl=g);d=a}}if(!1===a)t.cancelAnimationFrame(this._requestFrame_id),this._requestFrame_id=null;else{var c=t.requestAnimationFrame,d=getTime(),f=this,k=0;this._requestFrame_id=c(b)}};l.destroy=function(){v&&(document.removeEventListener("keydown",v),document.removeEventListener("keyup",v));this.canvas.parentNode&&this.canvas.parentNode.removeChild(this.canvas);this.destroyed=!0;t.gl==this&&(t.gl=null)};var p=l.mouse={buttons:0,last_buttons:0,
left_button:!1,middle_button:!1,right_button:!1,position:new Float32Array(2),x:0,y:0,deltax:0,deltay:0,clientx:0,clienty:0,isInsideRect:function(a,b,c,d,f){var k=this.y;f&&(k=l.canvas.height-k);return this.x>a&&this.x<a+c&&k>b&&k<b+d?!0:!1},isButtonPressed:function(a){if(a==g.LEFT_MOUSE_BUTTON)return this.buttons&g.LEFT_MOUSE_BUTTON_MASK;if(a==g.MIDDLE_MOUSE_BUTTON)return this.buttons&g.MIDDLE_MOUSE_BUTTON_MASK;if(a==g.RIGHT_MOUSE_BUTTON)return this.buttons&g.RIGHT_MOUSE_BUTTON_MASK},wasButtonPressed:function(a){var b=
0;a==g.LEFT_MOUSE_BUTTON?b=g.LEFT_MOUSE_BUTTON_MASK:a==g.MIDDLE_MOUSE_BUTTON?b=g.MIDDLE_MOUSE_BUTTON_MASK:a==g.RIGHT_MOUSE_BUTTON&&(b=g.RIGHT_MOUSE_BUTTON_MASK);return this.buttons&b&&!(this.last_buttons&b)}};l.captureMouse=function(a,c){f.addEventListener("mousedown",b);f.addEventListener("mousemove",b);f.addEventListener("dragstart",b);a&&(f.addEventListener("mousewheel",b,!1),f.addEventListener("wheel",b,!1));f.addEventListener("contextmenu",function(a){a.preventDefault();return!1});c&&this.captureTouch(!0)};
var r=!1;l.captureTouch=function(a){r=a;f.addEventListener("touchstart",c,!0);f.addEventListener("touchmove",c,!0);f.addEventListener("touchend",c,!0);f.addEventListener("touchcancel",c,!0);f.addEventListener("gesturestart",d);f.addEventListener("gesturechange",d);f.addEventListener("gestureend",d)};l.keys={};var v=null;l.captureKeys=function(a,b){function c(b){var d=a;b.eventType=b.type;var f=b.target.nodeName.toLowerCase();if("input"!==f&&"textarea"!==f&&"select"!==f){b.character=String.fromCharCode(b.keyCode).toLowerCase();
var f=!1,k=g.mapKeyCode(b.keyCode);k||(k=b.character);b.altKey||b.ctrlKey||b.metaKey||(k&&(l.keys[k]="keydown"==b.type),f=l.keys[b.keyCode],l.keys[b.keyCode]="keydown"==b.type);if(f!=l.keys[b.keyCode]){if("keydown"==b.type&&l.onkeydown)l.onkeydown(b);else if("keyup"==b.type&&l.onkeyup)l.onkeyup(b);y.trigger(l,b.type,b)}if(l.onkey)l.onkey(b);d&&(b.isChar||g.blockable_keys[b.keyIdentifier||b.key])&&b.preventDefault()}}v||(l.keys={},document.addEventListener("keydown",c),document.addEventListener("keyup",
c),v=c)};l.gamepads=null;l.captureGamepads=function(){var a=navigator.getGamepads||navigator.webkitGetGamepads||navigator.mozGetGamepads;a&&(this.gamepads=a.call(navigator))};l.getGamepads=function(a){var b=navigator.getGamepads||navigator.webkitGetGamepads||navigator.mozGetGamepads;if(b){b=b.call(navigator);this.gamepads||(this.gamepads=[]);for(var c=0;4>c;c++){var d=b[c];if(d&&!a){var f=d,k=f.xbox||{axes:[],buttons:{},hat:""};k.axes.lx=f.axes[0];k.axes.ly=f.axes[1];k.axes.rx=f.axes[2];k.axes.ry=
f.axes[3];k.axes.triggers=f.axes[4];for(var g=0;g<f.buttons.length;g++)switch(g){case 0:k.buttons.a=f.buttons[g].pressed;break;case 1:k.buttons.b=f.buttons[g].pressed;break;case 2:k.buttons.x=f.buttons[g].pressed;break;case 3:k.buttons.y=f.buttons[g].pressed;break;case 4:k.buttons.lb=f.buttons[g].pressed;break;case 5:k.buttons.rb=f.buttons[g].pressed;break;case 6:k.buttons.lt=f.buttons[g].pressed;break;case 7:k.buttons.rt=f.buttons[g].pressed;break;case 8:k.buttons.back=f.buttons[g].pressed;break;
case 9:k.buttons.start=f.buttons[g].pressed;break;case 10:k.buttons.ls=f.buttons[g].pressed;break;case 11:k.buttons.rs=f.buttons[g].pressed;break;case 12:f.buttons[g].pressed&&(k.hat+="up");break;case 13:f.buttons[g].pressed&&(k.hat+="down");break;case 14:f.buttons[g].pressed&&(k.hat+="left");break;case 15:f.buttons[g].pressed&&(k.hat+="right");break;case 16:k.buttons.home=f.buttons[g].pressed}f.xbox=k}if(d&&!d.prev_buttons){d.prev_buttons=new Uint8Array(32);f=new CustomEvent("gamepadconnected");
f.eventType=f.type;f.gamepad=d;if(this.ongamepadconnected)this.ongamepadconnected(f);y.trigger(l,"gamepadconnected",f)}if(d)for(k=0;k<d.buttons.length;++k){g=d.buttons[k];g.was_pressed=!1;if(g.pressed&&!d.prev_buttons[k]){g.was_pressed=!0;f=new CustomEvent("gamepadButtonDown");f.eventType=f.type;f.button=g;f.which=k;f.gamepad=d;if(l.onbuttondown)l.onbuttondown(f);y.trigger(l,"buttondown",f)}else if(!g.pressed&&d.prev_buttons[k]){f=new CustomEvent("gamepadButtonUp");f.eventType=f.type;f.button=g;f.which=
k;f.gamepad=d;if(l.onbuttondown)l.onbuttondown(f);y.trigger(l,"buttonup",f)}d.prev_buttons[k]=g.pressed?1:0}}return this.gamepads=b}};l.fullscreen=function(){var a=this.canvas;a.requestFullScreen?a.requestFullScreen():a.webkitRequestFullScreen?a.webkitRequestFullScreen():a.mozRequestFullScreen?a.mozRequestFullScreen():console.error("Fullscreen not supported")};l.snapshot=function(a,b,c,d,f){var k=createCanvas(c,d),g=k.getContext("2d"),q=g.getImageData(0,0,k.width,k.height),m=new Uint8Array(c*d*4);
l.readPixels(a,b,k.width,k.height,l.RGBA,l.UNSIGNED_BYTE,m);q.data.set(m);g.putImageData(q,0,0);if(f)return k;a=createCanvas(c,d);g=a.getContext("2d");g.translate(0,d);g.scale(1,-1);g.drawImage(k,0,0);return a};var u={};l.loadTexture=function(a,b,c){if(this.textures[a])return this.textures[a];if(u[a])return null;var d=new Image;d.url=a;d.onload=function(){var a=g.Texture.fromImage(this,b);a.img=this;l.textures[this.url]=a;delete u[this.url];c&&c(a)};d.src=a;u[a]=!0;return null};l.drawTexture=function(){var a=
mat3.create(),b=vec2.create(),c=vec2.create(),d=vec4.create(),f=vec4.fromValues(1,1,1,1),k=vec2.create(),g={u_texture:0,u_position:b,u_color:f,u_size:c,u_texture_area:d,u_viewport:k,u_transform:a};return function(a,f,q,m,n,p,r,s,v,u,t){b[0]=f;b[1]=q;void 0===m&&(m=a.width);void 0===n&&(n=a.height);c[0]=m;c[1]=n;void 0===p&&(p=0);void 0===r&&(r=0);void 0===s&&(s=a.width);void 0===v&&(v=a.height);d[0]=p/a.width;d[1]=r/a.height;d[2]=(p+s)/a.width;d[3]=(r+v)/a.height;k[0]=this.viewport_data[2];k[1]=this.viewport_data[3];
u=u||Shader.getPartialQuadShader(this);f=Mesh.getScreenQuad(this);a.bind(0);u.uniforms(g);t&&u.uniforms(t);u.draw(f,l.TRIANGLES)}}();l.canvas.addEventListener("webglcontextlost",function(a){a.preventDefault();l.context_lost=!0;if(l.onlosecontext)l.onlosecontext(a)},!1);l.reset=function(){l.viewport(0,0,this.canvas.width,this.canvas.height);l.disable(l.BLEND);l.disable(l.CULL_FACE);l.disable(l.DEPTH_TEST);l.frontFace(l.CCW);l._current_texture_drawto=null;l._current_fbo_color=null;l._current_fbo_depth=
null};l.dump=function(){console.log("userAgent: ",navigator.userAgent);console.log("Supported extensions:");var a=l.getSupportedExtensions();console.log(a.join(","));a="VENDOR VERSION MAX_VERTEX_ATTRIBS MAX_VARYING_VECTORS MAX_VERTEX_UNIFORM_VECTORS MAX_VERTEX_TEXTURE_IMAGE_UNITS MAX_FRAGMENT_UNIFORM_VECTORS MAX_TEXTURE_SIZE MAX_TEXTURE_IMAGE_UNITS".split(" ");console.log("WebGL info:");for(var b in a)console.log(" * "+a[b]+": "+l.getParameter(l[a[b]]));console.log("*************************************************")};
l.reset();return l};g.mapKeyCode=function(a){return{8:"BACKSPACE",9:"TAB",13:"ENTER",16:"SHIFT",17:"CTRL",27:"ESCAPE",32:"SPACE",37:"LEFT",38:"UP",39:"RIGHT",40:"DOWN"}[a]||(65<=a&&90>=a?String.fromCharCode(a):null)};g.dragging=!1;g.last_pos=[0,0];g.augmentEvent=function(a,b){var c=null;b=b||a.target||gl.canvas;c=b.getBoundingClientRect();a.mousex=a.clientX-c.left;a.mousey=a.clientY-c.top;a.canvasx=a.mousex;a.canvasy=c.height-a.mousey;a.deltax=0;a.deltay=0;"mousedown"==a.type?this.dragging=!0:"mousemove"!=
a.type&&"mouseup"==a.type&&0==a.buttons&&(this.dragging=!1);void 0===a.movementX||g.isMobile()?(a.deltax=a.mousex-this.last_pos[0],a.deltay=a.mousey-this.last_pos[1]):(a.deltax=a.movementX,a.deltay=a.movementY);this.last_pos[0]=a.mousex;this.last_pos[1]=a.mousey;a.dragging=this.dragging;a.leftButton=!!(gl.mouse.buttons&g.LEFT_MOUSE_BUTTON_MASK);a.middleButton=!!(gl.mouse.buttons&g.MIDDLE_MOUSE_BUTTON_MASK);a.rightButton=!!(gl.mouse.buttons&g.RIGHT_MOUSE_BUTTON_MASK);a.buttons_mask=0;a.leftButton&&
(a.buttons_mask=1);a.middleButton&&(a.buttons_mask|=2);a.rightButton&&(a.buttons_mask|=4);a.isButtonPressed=function(a){return this.buttons_mask&1<<a}};g.isMobile=function(){return void 0!==this.mobile?this.mobile:t.navigator?navigator.userAgent.match(/iPhone/i)||navigator.userAgent.match(/iPod/i)||navigator.userAgent.match(/iPad/i)||navigator.userAgent.match(/SamsungBrowser/i)||navigator.userAgent.match(/Mobile\ VR/i)||navigator.userAgent.match(/Android/i)?this.mobile=!0:this.mobile=!1:this.mobile=
!1};var y=t.LEvent=g.LEvent={bind:function(a,b,c,d){if(!a)throw"cannot bind event to null";if(!c)throw"cannot bind to null callback";if(a.constructor===String)throw"cannot bind event to a string";var f=a.__levents;f||(Object.defineProperty(a,"__levents",{value:{},enumerable:!1}),f=a.__levents);f.hasOwnProperty(b)?f[b].push([c,d]):f[b]=[[c,d]];if(a.onLEventBinded)a.onLEventBinded(b,c,d)},unbind:function(a,b,c,d){if(!a)throw"cannot unbind event to null";if(!c)throw"cannot unbind from null callback";
if(a.constructor===String)throw"cannot bind event to a string";var f=a.__levents;if(f&&f.hasOwnProperty(b)){for(var k=0,g=f[b].length;k<g;++k){var l=f[b][k];if(l[0]===c&&l[1]===d){f[b].splice(k,1);break}}0==f[b].length&&delete f[b];if(a.onLEventUnbinded)a.onLEventUnbinded(b,c,d)}},unbindAll:function(a,b,c){if(!a)throw"cannot unbind events in null";var d=a.__levents;if(d){if(a.onLEventUnbindAll)a.onLEventUnbindAll(b,c);if(b)for(var f in d){a=d[f];for(var k=a.length-1;0<=k;--k)a[k][1]!=b||c&&c!==a[k][0]||
a.splice(k,1)}else delete a.__levents}},unbindAllEvent:function(a,b){if(!a)throw"cannot unbind events in null";var c=a.__levents;if(c&&(delete c[b],a.onLEventUnbindAll))a.onLEventUnbindAll(b,target_instance,callback)},isBind:function(a,b,c,d){if(!a)throw"LEvent cannot have null as instance";if(a=a.__levents){if(!a.hasOwnProperty(b))return!1;for(var f=0,k=a[b].length;f<k;++f){var g=a[b][f];if(g[0]===c&&g[1]===d)return!0}return!1}},hasBind:function(a,b){if(!a)throw"LEvent cannot have null as instance";
var c=a.__levents;return c&&c.hasOwnProperty(b)&&c[b].length?!0:!1},hasBindTo:function(a,b){if(!a)throw"LEvent cannot have null as instance";var c=a.__levents;if(!c)return!1;for(var d in c)for(var f=c[d],k=0;k<f.length;++k)if(f[k][1]===b)return!0;return!1},trigger:function(a,b,c,d,f){if(!a)throw"cannot trigger event from null";if(a.constructor===String)throw"cannot bind event to a string";a=a.__levents;if(!a||!a.hasOwnProperty(b))return!1;a=a[b];if(d)for(d=a.length-1;0<=d;--d){var k=a[d];if(f){if(k&&
!0===k[0].apply(k[1],c))return!0}else if(k&&!0===k[0].call(k[1],b,c))return!0}else{d=0;for(var g=a.length;d<g;++d)if(k=a[d],f){if(k&&!0===k[0].apply(k[1],c))return!0}else if(k&&!0===k[0].call(k[1],b,c))return!0}return!1},triggerArray:function(a,b,c,d,f){for(var k=!1,g=0,l=a.length;g<l;++g){var m=a[g];if(!m)throw"cannot trigger event from null";if(m.constructor===String)throw"cannot bind event to a string";if((m=m.__levents)&&m.hasOwnProperty(b))if(d)for(var n=m[b].length-1;0<=n;--n){var p=m[b][n];
if(f){if(!0===p[0].apply(p[1],c)){k=!0;break}}else if(!0===p[0].call(p[1],b,c)){k=!0;break}}else for(var n=0,r=m[b].length;n<r;++n)if(p=m[b][n],f){if(!0===p[0].apply(p[1],c)){k=!0;break}}else if(!0===p[0].call(p[1],b,c)){k=!0;break}}return k},extendObject:function(a){a.bind=function(a,c,d){return y.bind(this,a,c,d)};a.trigger=function(a,c){return y.trigger(this,a,c)};a.unbind=function(a,c,d){return y.unbind(this,a,c,instance)};a.unbindAll=function(a,c){return y.unbindAll(this,a,c)}},extendClass:function(a){this.extendObject(a.prototype)}};
t.CLIP_INSIDE=g.CLIP_INSIDE=0;t.CLIP_OUTSIDE=g.CLIP_OUTSIDE=1;t.CLIP_OVERLAP=g.CLIP_OVERLAP=2;t.geo={createPlane:function(a,b){return new Float32Array([b[0],b[1],b[2],-vec3.dot(a,b)])},distancePointToPlane:function(a,b){return(vec3.dot(a,b)+b[3])/Math.sqrt(b[0]*b[0]+b[1]*b[1]+b[2]*b[2])},distance2PointToPlane:function(a,b){return(vec3.dot(a,b)+b[3])/(b[0]*b[0]+b[1]*b[1]+b[2]*b[2])},projectPointOnLine:function(a,b,c,d){d=d||vec3.create();a=vec3.fromValues(a[0]-b[0],a[1]-b[1],a[2]-b[2]);c=vec3.fromValues(c[0]-
b[0],c[1]-b[1],c[2]-b[2]);a=vec3.dot(a,c)/vec3.dot(c,c);d[0]=b[0]+a[0]*c[0];d[1]=b[1]+a[1]*c[1];d[2]=b[2]+a[2]*c[2];return d},project2DPointOnLine:function(a,b,c,d){d=d||vec2.create();a=vec2.fromValues(a[0]-b[0],a[1]-b[1]);c=vec2.fromValues(c[0]-b[0],c[1]-b[1]);a=vec2.dot(a,c)/vec2.dot(c,c);d[0]=b[0]+a[0]*c[0];d[1]=b[1]+a[1]*c[1];return d},projectPointOnPlane:function(a,b,c,d){d=d||vec3.create();b=vec3.subtract(vec3.create(),a,b);b=vec3.dot(b,c);return vec3.subtract(d,a,vec3.scale(vec3.create(),c,
b))},reflectPointInPlane:function(a,b,c){b=-(-1*(b[0]*c[0]+b[1]*c[1]+b[2]*c[2])+c[0]*a[0]+c[1]*a[1]+c[2]*a[2])/(c[0]*c[0]+c[1]*c[1]+c[2]*c[2]);return vec3.fromValues(a[0]+b*c[0]*2,a[1]+b*c[1]*2,a[2]+b*c[2]*2)},testRayPlane:function(a,b,c,d,f){c=vec3.dot(c,d)-vec3.dot(d,a);d=vec3.dot(d,b);if(Math.abs(d)<EPSILON)return!1;d=c/d;if(0>d)return!1;f&&vec3.add(f,a,vec3.scale(f,b,d));return!0},testSegmentPlane:function(){var a=vec3.create();return function(b,c,d,f,k){d=vec3.dot(d,f)-vec3.dot(f,b);c=vec3.sub(a,
c,b);f=vec3.dot(f,c);if(Math.abs(f)<EPSILON)return!1;f=d/f;if(0>f||1<f)return!1;k&&vec3.add(k,b,vec3.scale(k,c,f));return!0}}(),testRaySphere:function(){var a=vec3.create();return function(b,c,d,f,k,g){var l=vec3.subtract(a,b,d),m=c[0]*c[0]+c[1]*c[1]+c[2]*c[2];d=2*l[0]*c[0]+2*l[1]*c[1]+2*l[2]*c[2];f=d*d-4*m*(l[0]*l[0]+l[1]*l[1]+l[2]*l[2]-f*f);if(0>f)return!1;if(k){f=Math.sqrt(f);l=1/(2*m);m=(-d+f)*l;d=(-d-f)*l;d=m<d?m:d;if(void 0!==g&&d>g)return!1;vec3.add(k,b,vec3.scale(k,c,d))}return!0}}(),testRayCylinder:function(a,
b,c,d,f,k){var g=vec3.clone(a);a=vec3.add(vec3.create(),a,vec3.scale(vec3.create(),b,1E5));var l=0;b=vec3.subtract(vec3.create(),d,c);var m=vec3.subtract(vec3.create(),g,c);c=vec3.subtract(vec3.create(),a,g);d=vec3.dot(m,b);a=vec3.dot(c,b);b=vec3.dot(b,b);if(0>d&&0>d+a||d>b&&d+a>b)return!1;var n=vec3.dot(c,c),p=vec3.dot(m,c),l=b*n-a*a;f=vec3.dot(m,m)-f*f;var r=b*f-d*d;if(Math.abs(l)<EPSILON){if(0<r)return!1;k&&vec3.add(k,g,vec3.scale(k,c,0>d?-p/n:d>b?(a-p)/n:0));return!0}m=b*p-a*d;r=m*m-l*r;if(0>
r)return!1;l=(-m-Math.sqrt(r))/l;if(0>l||1<l)return!1;if(0>d+l*a){if(0>=a)return!1;l=-d/a;k&&vec3.add(k,g,vec3.scale(k,c,l));return 0>=f+2*l*(p+l*n)}if(d+l*a>b){if(0<=a)return!1;l=(b-d)/a;k&&vec3.add(k,g,vec3.scale(k,c,l));return 0>=f+b-2*d+l*(2*(p-a)+l*n)}k&&vec3.add(k,g,vec3.scale(k,c,l));return!0},testRayBox:function(){var a=new Float32Array(3),b=new Float32Array(3),c=new Float32Array(3);return function(d,f,k,g,l,m){m=m||Number.MAX_VALUE;var n=!0,p=0;a.fill(0);c.fill(0);b.fill(0);for(p=0;3>p;++p)d[p]<
k[p]?(a[p]=1,b[p]=k[p],n=!1):d[p]>g[p]?(a[p]=0,b[p]=g[p],n=!1):a[p]=2;if(n)return l&&vec3.copy(l,d),!0;for(p=0;3>p;++p)c[p]=2!=a[p]&&0!=f[p]?(b[p]-d[p])/f[p]:-1;n=0;for(p=1;3>p;p++)c[n]<c[p]&&(n=p);if(0>c[n]||c[n]>m)return!1;for(p=0;3>p;++p)if(n!=p){m=d[p]+c[n]*f[p];if(m<k[p]||m>g[p])return!1;l&&(l[p]=m)}else l&&(l[p]=b[p]);return!0}}(),testRayBBox:function(){var a=mat4.create(),b=vec3.create(),c=vec3.create();return function(d,f,k,g,l,m,n){if(!d||!f||!k)throw"parameters missing";g&&(mat4.invert(a,
g),vec3.add(b,d,f),d=vec3.transformMat4(c,d,a),vec3.transformMat4(b,b,a),vec3.sub(b,b,d),f=vec3.normalize(b,b));d=this.testRayBox(d,f,k.subarray(6,9),k.subarray(9,12),l,m);!n&&g&&l&&vec3.transformMat4(l,l,g);return d}}(),testPointBBox:function(a,b){return a[0]<b[6]||a[0]>b[9]||a[1]<b[7]||a[0]>b[10]||a[2]<b[8]||a[0]>b[11]?!1:!0},testBBoxBBox:function(a,b){if(Math.abs(b[0]-a[0])>a[3]+b[3]||Math.abs(b[1]-a[1])>a[4]+b[4]||Math.abs(b[2]-a[2])>a[5]+b[5])return!1;var c=BBox.getMin(b);geo.testPointBBox(c,
a)&&(c=BBox.getMax(b),geo.testPointBBox(c,a));return!0},testSphereBBox:function(a,b,c){for(var d=0,f=BBox.getMin(c),k=BBox.getMax(c),g=0;3>g;++g)a[g]<f[g]?(c=a[g]-f[g],d+=c*c):a[g]>k[g]&&(c=a[g]-k[g],d+=c*c);return d<=b*b?!0:!1},closestPointBetweenLines:function(a,b,c,d,f,k){b=vec3.subtract(vec3.create(),b,a);d=vec3.subtract(vec3.create(),d,c);var g=vec3.subtract(vec3.create(),a,c),l=vec3.dot(b,b),m=vec3.dot(b,d),n=vec3.dot(d,d),p=vec3.dot(b,g),r=vec3.dot(d,g),v=l*n-m*m,u;v<EPSILON?(u=0,l=m>n?p/m:
r/n):(u=(m*r-n*p)/v,l=(l*r-m*p)/v);f&&vec3.add(f,a,vec3.scale(vec3.create(),b,u));k&&vec3.add(k,c,vec3.scale(vec3.create(),d,l));a=vec3.add(vec3.create(),g,vec3.subtract(vec3.create(),vec3.scale(vec3.create(),b,u),vec3.scale(vec3.create(),d,l)));return vec3.length(a)},extractPlanes:function(a,b){function c(a){var c=b.subarray(a,a+3),c=vec3.length(c);0!==c&&(c=1/c,b[a]*=c,b[a+1]*=c,b[a+2]*=c,b[a+3]*=c)}b=b||new Float32Array(24);b.set([a[3]-a[0],a[7]-a[4],a[11]-a[8],a[15]-a[12]],0);c(0);b.set([a[3]+
a[0],a[7]+a[4],a[11]+a[8],a[15]+a[12]],4);c(4);b.set([a[3]+a[1],a[7]+a[5],a[11]+a[9],a[15]+a[13]],8);c(8);b.set([a[3]-a[1],a[7]-a[5],a[11]-a[9],a[15]-a[13]],12);c(12);b.set([a[3]-a[2],a[7]-a[6],a[11]-a[10],a[15]-a[14]],16);c(16);b.set([a[3]+a[2],a[7]+a[6],a[11]+a[10],a[15]+a[14]],20);c(20);return b},frustumTestBox:function(a,b){var c=0,d=0,c=planeBoxOverlap(a.subarray(0,4),b);if(c==CLIP_OUTSIDE)return CLIP_OUTSIDE;d+=c;c=planeBoxOverlap(a.subarray(4,8),b);if(c==CLIP_OUTSIDE)return CLIP_OUTSIDE;d+=
c;c=planeBoxOverlap(a.subarray(8,12),b);if(c==CLIP_OUTSIDE)return CLIP_OUTSIDE;d+=c;c=planeBoxOverlap(a.subarray(12,16),b);if(c==CLIP_OUTSIDE)return CLIP_OUTSIDE;d+=c;c=planeBoxOverlap(a.subarray(16,20),b);if(c==CLIP_OUTSIDE)return CLIP_OUTSIDE;d+=c;c=planeBoxOverlap(a.subarray(20,24),b);return c==CLIP_OUTSIDE?CLIP_OUTSIDE:0==d+c?CLIP_INSIDE:CLIP_OVERLAP},frustumTestSphere:function(a,b,c){var d,f=!1;d=distanceToPlane(a.subarray(0,4),b);if(d<-c)return CLIP_OUTSIDE;d>=-c&&d<=c&&(f=!0);d=distanceToPlane(a.subarray(4,
8),b);if(d<-c)return CLIP_OUTSIDE;d>=-c&&d<=c&&(f=!0);d=distanceToPlane(a.subarray(8,12),b);if(d<-c)return CLIP_OUTSIDE;d>=-c&&d<=c&&(f=!0);d=distanceToPlane(a.subarray(12,16),b);if(d<-c)return CLIP_OUTSIDE;d>=-c&&d<=c&&(f=!0);d=distanceToPlane(a.subarray(16,20),b);if(d<-c)return CLIP_OUTSIDE;d>=-c&&d<=c&&(f=!0);d=distanceToPlane(a.subarray(20,24),b);if(d<-c)return CLIP_OUTSIDE;d>=-c&&d<=c&&(f=!0);return f?CLIP_OVERLAP:CLIP_INSIDE},testPoint2DInPolygon:function(a,b){for(var c=!1,d=-1,f=a.length,k=
f-1;++d<f;k=d)(a[d][1]<=b[1]&&b[1]<a[k][1]||a[k][1]<=b[1]&&b[1]<a[d][1])&&b[0]<(a[k][0]-a[d][0])*(b[1]-a[d][1])/(a[k][1]-a[d][1])+a[d][0]&&(c=!c);return c}};t.BBox=g.BBox={center:0,halfsize:3,min:6,max:9,radius:12,data_length:13,corners:[vec3.fromValues(1,1,1),vec3.fromValues(1,1,-1),vec3.fromValues(1,-1,1),vec3.fromValues(1,-1,-1),vec3.fromValues(-1,1,1),vec3.fromValues(-1,1,-1),vec3.fromValues(-1,-1,1),vec3.fromValues(-1,-1,-1)],create:function(){return new Float32Array(13)},clone:function(a){return new Float32Array(a)},
copy:function(a,b){a.set(b);return a},fromPoint:function(a){var b=this.create();b.set(a,0);b.set(a,6);b.set(a,9);return b},fromMinMax:function(a,b){var c=this.create();this.setMinMax(c,a,b);return c},fromCenterHalfsize:function(a,b){var c=this.create();this.setCenterHalfsize(c,a,b);return c},fromPoints:function(a){var b=this.create();this.setFromPoints(b,a);return b},setFromPoints:function(a,b){var c=a.subarray(6,9),d=a.subarray(9,12);c[0]=b[0];c[1]=b[1];c[2]=b[2];d.set(c);for(var f=3,k=b.length;f<
k;f+=3){var g=b[f],l=b[f+1],m=b[f+2];g<c[0]?c[0]=g:g>d[0]&&(d[0]=g);l<c[1]?c[1]=l:l>d[1]&&(d[1]=l);m<c[2]?c[2]=m:m>d[2]&&(d[2]=m)}a[0]=0.5*(c[0]+d[0]);a[1]=0.5*(c[1]+d[1]);a[2]=0.5*(c[2]+d[2]);a[3]=d[0]-a[0];a[4]=d[1]-a[1];a[5]=d[2]-a[2];a[12]=Math.sqrt(a[3]*a[3]+a[4]*a[4]+a[5]*a[5]);return a},setMinMax:function(a,b,c){a[6]=b[0];a[7]=b[1];a[8]=b[2];a[9]=c[0];a[10]=c[1];a[11]=c[2];var d=a.subarray(3,6);vec3.sub(d,c,b);vec3.scale(d,d,0.5);a[0]=c[0]-d[0];a[1]=c[1]-d[1];a[2]=c[2]-d[2];a[12]=vec3.length(a.subarray(3,
6));return a},setCenterHalfsize:function(a,b,c,d){a[0]=b[0];a[1]=b[1];a[2]=b[2];a[3]=c[0];a[4]=c[1];a[5]=c[2];a[6]=a[0]-a[3];a[7]=a[1]-a[4];a[8]=a[2]-a[5];a[9]=a[0]+a[3];a[10]=a[1]+a[4];a[11]=a[2]+a[5];a[12]=d?d:vec3.length(c);return a},transformMat4:function(){for(var a=0,b=0,c=0,d=new Float32Array(24),f=[],k=0;24>k;k+=3)f.push(d.subarray(k,k+3));return function(k,g,m){var n=g[0],p=g[1],r=g[2];a=g[3];b=g[4];c=g[5];g=this.corners;for(var v=0;8>v;++v){var u=g[v],s=f[v];s[0]=a*u[0]+n;s[1]=b*u[1]+p;
s[2]=c*u[2]+r;mat4.multiplyVec3(s,m,s)}return this.setFromPoints(k,d)}}(),getCorners:function(a,b){var c=a.subarray(3,6),d=null;b?(b.set(this.corners),d=b):d=new Float32Array(this.corners);for(var f=0;8>f;++f){var k=d.subarray(3*f,3*f+3);vec3.multiply(k,c,k);vec3.add(k,k,a)}return d},merge:function(a,b,c){var d=a.subarray(6,9),f=a.subarray(9,12);vec3.min(d,b.subarray(6,9),c.subarray(6,9));vec3.max(f,b.subarray(9,12),c.subarray(9,12));return BBox.setMinMax(a,d,f)},extendToPoint:function(a,b){b[0]<
a[6]?a[6]=b[0]:b[0]>a[9]&&(a[9]=b[0]);b[1]<a[7]?a[7]=b[1]:b[1]>a[10]&&(a[10]=b[1]);b[2]<a[8]?a[8]=b[2]:b[2]>a[11]&&(a[11]=b[2]);var c=a.subarray(6,9),d=a.subarray(9,12),c=vec3.add(a.subarray(0,3),c,d);vec3.scale(c,c,0.5);vec3.subtract(a.subarray(3,6),d,c);a[12]=vec3.length(a.subarray(3,6));return a},clampPoint:function(a,b,c){a[0]=Math.clamp(c[0],b[0]-b[3],b[0]+b[3]);a[1]=Math.clamp(c[1],b[1]-b[4],b[1]+b[4]);a[2]=Math.clamp(c[2],b[2]-b[5],b[2]+b[5])},isPointInside:function(a,b){return a[0]-a[3]>b[0]||
a[1]-a[4]>b[1]||a[2]-a[5]>b[2]||a[0]+a[3]<b[0]||a[1]+a[4]<b[1]||a[2]+a[5]<b[2]?!1:!0},getCenter:function(a){return a.subarray(0,3)},getHalfsize:function(a){return a.subarray(3,6)},getMin:function(a){return a.subarray(6,9)},getMax:function(a){return a.subarray(9,12)},getRadius:function(a){return a[12]}};t.distanceToPlane=g.distanceToPlane=function(a,b){return vec3.dot(a,b)+a[3]};t.planeBoxOverlap=g.planeBoxOverlap=function(a,b){var c=a[3],d=Math.abs(b[3]*a[0])+Math.abs(b[4]*a[1])+Math.abs(b[5]*a[2]),
c=vec3.dot(a,b)+c;return c<=-d?CLIP_OUTSIDE:c<=d?CLIP_OVERLAP:CLIP_INSIDE};t.Octree=g.Octree=function(a,b,c){this.root=null;this.total_nodes=this.total_depth=0;a&&(this.buildFromMesh(a,b,c),this.total_nodes=this.trim())};Octree.MAX_NODE_TRIANGLES_RATIO=0.1;Octree.MAX_OCTREE_DEPTH=8;Octree.OCTREE_MARGIN_RATIO=0.01;Octree.OCTREE_MIN_MARGIN=0.1;Octree.NEAREST=0;Octree.FIRST=1;Octree.ALL=2;Octree.prototype.buildFromMesh=function(a,b,c){this.total_nodes=this.total_depth=0;b=b||0;var d=a.getBuffer("vertices").data;
if(a=a.getIndexBuffer("triangles"))a=a.data;c||(c=a?a.length:d.length/3);var f=null;this.root=f=a?this.computeAABBFromIndices(d,a,b,c):this.computeAABB(d);this.total_nodes=1;this.total_triangles=a?a.length/3:d.length/9;this.max_node_triangles=this.total_triangles*Octree.MAX_NODE_TRIANGLES_RATIO;var k=vec3.create();vec3.scale(k,f.size,Octree.OCTREE_MARGIN_RATIO);k[0]<Octree.OCTREE_MIN_MARGIN&&(k[0]=Octree.OCTREE_MIN_MARGIN);k[1]<Octree.OCTREE_MIN_MARGIN&&(k[1]=Octree.OCTREE_MIN_MARGIN);k[2]<Octree.OCTREE_MIN_MARGIN&&
(k[2]=Octree.OCTREE_MIN_MARGIN);vec3.sub(f.min,f.min,k);vec3.add(f.max,f.max,k);f.faces=[];f.inside=0;k=b+c;if(a)for(;b<k;b+=3){var g=new Float32Array([d[3*a[b]],d[3*a[b]+1],d[3*a[b]+2],d[3*a[b+1]],d[3*a[b+1]+1],d[3*a[b+1]+2],d[3*a[b+2]],d[3*a[b+2]+1],d[3*a[b+2]+2],b/3]);this.addToNode(g,f,0)}else for(b*=3;b<3*c;b+=9)g=new Float32Array(10),g.set(d.subarray(b,b+9)),g[9]=b/9,this.addToNode(g,f,0);return f};Octree.prototype.addToNode=function(a,b,c){b.inside+=1;if(b.c){var d=this.computeAABB(a),f=!1,
k;for(k in b.c){var g=b.c[k];if(Octree.isInsideAABB(d,g)){this.addToNode(a,g,c+1);f=!0;break}}f||(null==b.faces&&(b.faces=[]),b.faces.push(a))}else if(null==b.faces&&(b.faces=[]),b.faces.push(a),b.faces.length>this.max_node_triangles&&c<Octree.MAX_OCTREE_DEPTH){this.splitNode(b);this.total_depth<c+1&&(this.total_depth=c+1);var l=b.faces.concat();b.faces=null;for(k in l){a=l[k];var d=this.computeAABB(a),f=!1,m;for(m in b.c)if(g=b.c[m],Octree.isInsideAABB(d,g)){this.addToNode(a,g,c+1);f=!0;break}f||
(null==b.faces&&(b.faces=[]),b.faces.push(a))}}};Octree.prototype.octree_pos_ref=[[0,0,0],[0,0,1],[0,1,0],[0,1,1],[1,0,0],[1,0,1],[1,1,0],[1,1,1]];Octree.prototype.splitNode=function(a){a.c=[];var b=[0.5*(a.max[0]-a.min[0]),0.5*(a.max[1]-a.min[1]),0.5*(a.max[2]-a.min[2])],c;for(c in this.octree_pos_ref){var d=this.octree_pos_ref[c],f={};this.total_nodes+=1;f.min=[a.min[0]+b[0]*d[0],a.min[1]+b[1]*d[1],a.min[2]+b[2]*d[2]];f.max=[f.min[0]+b[0],f.min[1]+b[1],f.min[2]+b[2]];f.faces=null;f.inside=0;a.c.push(f)}};
Octree.prototype.computeAABB=function(a){for(var b=new Float32Array([a[0],a[1],a[2]]),c=new Float32Array([a[0],a[1],a[2]]),d=0;d<a.length;d+=3)for(var f=0;3>f;f++)b[f]>a[d+f]&&(b[f]=a[d+f]),c[f]<a[d+f]&&(c[f]=a[d+f]);return{min:b,max:c,size:vec3.sub(vec3.create(),c,b)}};Octree.prototype.computeAABBFromIndices=function(a,b,c,d){c=c||0;d=d||b.length;for(var f=b[c],k=new Float32Array([a[3*f],a[3*f+1],a[3*f+2]]),g=new Float32Array([a[3*f],a[3*f+1],a[3*f+2]]),l=c+1;l<c+d;++l)for(var f=3*b[l],m=0;3>m;m++)k[m]>
a[f+m]&&(k[m]=a[f+m]),g[m]<a[f+m]&&(g[m]=a[f+m]);return{min:k,max:g,size:vec3.sub(vec3.create(),g,k)}};Octree.prototype.trim=function(a){a=a||this.root;if(!a.c)return 1;for(var b=1,c=[],d=a.c,f=0;f<d.length;++f)d[f].inside&&(c.push(d[f]),b+=this.trim(d[f]));a.c=c;return b};Octree.prototype.testRay=function(){var a=vec3.create(),b=vec3.create(),c=vec3.create(),d=vec3.create();return function(f,k,g,l,m,n){n=n||Octree.NEAREST;if(!this.root)throw"Error: octree not build";a.set(f);b.set(k);c.set(this.root.min);
d.set(this.root.max);g=Octree.hitTestBox(a,b,c,d);if(!g)return null;g=Octree.testRayInNode(this.root,a,b,m,n);if(null==g)return null;if(n==Octree.ALL)return g;k=vec3.scale(vec3.create(),k,g.t);vec3.add(k,k,f);g.pos=k;return g}}();Octree.testRayInNode=function(a,b,c,d,f){var k=null,g=null;if(a.faces)for(var l=0,m=a.faces.length;l<m;++l){var n=a.faces[l],k=Octree.hitTestTriangle(b,c,n.subarray(0,3),n.subarray(3,6),n.subarray(6,9),d);if(null!=k){if(f==Octree.FIRST)return k;f==Octree.ALL?(g||(g=[]),g.push(k)):
(k.face=n,g?g.mergeWith(k):g=k)}}var m=vec3.create(),n=vec3.create(),p;if(a.c)for(l=0;l<a.c.length;++l)if(p=a.c[l],m.set(p.min),n.set(p.max),k=Octree.hitTestBox(b,c,m,n),null!=k&&!(f!=Octree.ALL&&g&&k.t>g.t)&&(k=Octree.testRayInNode(p,b,c,d,f),null!=k)){if(f==Octree.FIRST)return k;f==Octree.ALL?(g||(g=[]),g.push(k)):g?g.mergeWith(k):g=k}return g};Octree.prototype.testSphere=function(a,b){a=vec3.clone(a);if(!this.root)throw"Error: octree not build";var c=b*b;return Octree.testSphereBox(a,c,vec3.clone(this.root.min),
vec3.clone(this.root.max))?Octree.testSphereInNode(this.root,a,c):!1};Octree.testSphereInNode=function(a,b,c){if(a.faces)for(var d=0,f=a.faces.length;d<f;++d){var k=a.faces[d];if(Octree.testSphereTriangle(b,c,k.subarray(0,3),k.subarray(3,6),k.subarray(6,9)))return!0}var f=vec3.create(),k=vec3.create(),g;if(a.c)for(d=0;d<a.c.length;++d)if(g=a.c[d],f.set(g.min),k.set(g.max),Octree.testSphereBox(b,c,f,k)&&Octree.testSphereInNode(g,b,c))return!0;return!1};Octree.isInsideAABB=function(a,b){return a.min[0]<
b.min[0]||a.min[1]<b.min[1]||a.min[2]<b.min[2]||a.max[0]>b.max[0]||a.max[1]>b.max[1]||a.max[2]>b.max[2]?!1:!0};Octree.hitTestBox=function(){var a=vec3.create(),b=vec3.create(),c=vec3.create(),d=vec3.create(),f=vec3.create(),k=vec3.create(),g=vec3.fromValues(1E-6,1E-6,1E-6);return function(l,m,n,p){vec3.subtract(a,n,l);vec3.subtract(b,p,l);if(0>vec3.maxValue(a)&&0<vec3.minValue(b))return new HitTest(0,l,m);c[0]=1/m[0];c[1]=1/m[1];c[2]=1/m[2];vec3.multiply(a,a,c);vec3.multiply(b,b,c);vec3.min(d,a,b);
vec3.max(f,a,b);var r=vec3.maxValue(d),v=vec3.minValue(f);return 0<r&&r<v?(l=vec3.add(vec3.create(),vec3.scale(k,m,r),l),vec3.add(n,n,g),vec3.subtract(n,n,g),new HitTest(r,l,vec3.fromValues((l[0]>p[0])-(l[0]<n[0]),(l[1]>p[1])-(l[1]<n[1]),(l[2]>p[2])-(l[2]<n[2])))):null}}();Octree.hitTestTriangle=function(){var a=vec3.create(),b=vec3.create(),c=vec3.create(),d=vec3.create();return function(f,k,g,l,m,n){vec3.subtract(a,l,g);vec3.subtract(b,m,g);l=vec3.cross(vec3.create(),a,b);vec3.normalize(l,l);if(!n&&
0<vec3.dot(l,k))return null;n=vec3.dot(l,vec3.subtract(d,g,f))/vec3.dot(l,k);if(0<n){k=vec3.scale(vec3.create(),k,n);vec3.add(k,k,f);vec3.subtract(c,k,g);f=vec3.dot(b,b);g=vec3.dot(b,a);m=vec3.dot(b,c);var p=vec3.dot(a,a),r=vec3.dot(a,c),v=f*p-g*g,p=(p*m-g*r)/v;f=(f*r-g*m)/v;if(0<=p&&0<=f&&1>=p+f)return new HitTest(n,k,l)}return null}}();Octree.testSphereTriangle=function(){var a=vec3.create(),b=vec3.create(),c=vec3.create(),d=vec3.create(),f=vec3.create(),k=vec3.create(),g=vec3.create(),l=vec3.create();
return function(m,n,p,r,v){vec3.sub(a,p,m);vec3.sub(b,r,m);vec3.sub(c,v,m);vec3.sub(d,b,a);vec3.sub(f,c,a);vec3.cross(l,d,f);m=vec3.dot(a,l);p=vec3.dot(l,l);m=m*m>n*p;var u=vec3.dot(a,a),s=vec3.dot(a,b),t=vec3.dot(a,c),w=vec3.dot(b,b),y=vec3.dot(b,c),z=vec3.dot(c,c);p=u>n&s>u&t>u;r=w>n&s>w&y>w;v=z>n&t>z&y>z;var u=s-u,s=y-w,C=t-z;vec3.sub(k,c,b);vec3.sub(g,a,c);w=vec3.dot(d,d);z=vec3.dot(k,k);t=vec3.dot(g,g);y=vec3.scale(vec3.create(),a,w);vec3.sub(y,y,vec3.scale(vec3.create(),d,u));u=vec3.scale(vec3.create(),
b,z);vec3.sub(u,u,vec3.scale(vec3.create(),k,s));s=vec3.scale(vec3.create(),c,t);vec3.sub(s,s,vec3.scale(vec3.create(),g,C));var J=vec3.scale(vec3.create(),c,w),J=vec3.sub(J,J,y),B=vec3.scale(vec3.create(),a,z),B=vec3.sub(B,B,u),C=vec3.scale(vec3.create(),b,t),C=vec3.sub(C,C,s),w=vec3.dot(y,y)>n*w*w&0<vec3.dot(y,J),z=vec3.dot(u,u)>n*z*z&0<vec3.dot(u,B);n=vec3.dot(s,s)>n*t*t&0<vec3.dot(s,C);return!(m|p|r|v|w|z|n)}}();Octree.testSphereBox=function(a,b,c,d){for(var f,k=0,g=0;3>g;++g)a[g]<c[g]?(f=a[g]-
c[g],k+=f*f):a[g]>d[g]&&(f=a[g]-d[g],k+=f*f);return k<=b?!0:!1};t.HitTest=g.HitTest=function(a,b,c){this.t=arguments.length?a:Number.MAX_VALUE;this.hit=b;this.normal=c;this.face=null};HitTest.prototype={mergeWith:function(a){0<a.t&&a.t<this.t&&(this.t=a.t,this.hit=a.hit,this.normal=a.normal,this.face=a.face)}};t.Ray=g.Ray=function(a,b){this.origin=vec3.create();this.direction=vec3.create();this.collision_point=vec3.create();a&&this.origin.set(a);b&&this.direction.set(b)};Ray.prototype.testPlane=function(a,
b){return geo.testRayPlane(this.origin,this.direction,a,b,this.collision_point)};Ray.prototype.testSphere=function(a,b,c){return geo.testRaySphere(this.origin,this.direction,a,b,this.collision_point,c)};t.Raytracer=g.Raytracer=function(a,b){this.viewport=vec4.create();this.ray00=vec3.create();this.ray10=vec3.create();this.ray01=vec3.create();this.ray11=vec3.create();this.eye=vec3.create();this.setup(a,b)};Raytracer.prototype.setup=function(a,b){b=b||gl.viewport_data;this.viewport.set(b);var c=b[0],
d=c+b[2],f=b[1],g=f+b[3];vec3.set(this.ray00,c,f,1);vec3.set(this.ray10,d,f,1);vec3.set(this.ray01,c,g,1);vec3.set(this.ray11,d,g,1);vec3.unproject(this.ray00,this.ray00,a,b);vec3.unproject(this.ray10,this.ray10,a,b);vec3.unproject(this.ray01,this.ray01,a,b);vec3.unproject(this.ray11,this.ray11,a,b);c=this.eye;vec3.unproject(c,c,a,b);vec3.subtract(this.ray00,this.ray00,c);vec3.subtract(this.ray10,this.ray10,c);vec3.subtract(this.ray01,this.ray01,c);vec3.subtract(this.ray11,this.ray11,c)};Raytracer.prototype.getRayForPixel=
function(){var a=vec3.create(),b=vec3.create();return function(c,d,f){f=f||vec3.create();c=(c-this.viewport[0])/this.viewport[2];d=1-(d-this.viewport[1])/this.viewport[3];vec3.lerp(a,this.ray00,this.ray10,c);vec3.lerp(b,this.ray01,this.ray11,c);vec3.lerp(f,a,b,d);return vec3.normalize(f,f)}}();var W=mat4.create();Raytracer.hitTestBox=function(a,b,c,d,f){var g=new Float32Array(30);f&&(f=mat4.invert(W,f),a=mat4.multiplyVec3(g.subarray(3,6),f,a),b=mat4.rotateVec3(g.subarray(6,9),f,b));var q=vec3.subtract(g.subarray(9,
12),c,a);vec3.divide(q,q,b);var l=vec3.subtract(g.subarray(12,15),d,a);vec3.divide(l,l,b);f=vec3.min(g.subarray(15,18),q,l);q=vec3.max(g.subarray(18,21),q,l);f=vec3.maxValue(f);q=vec3.minValue(q);return 0<f&&f<=q?(b=vec3.scale(g.subarray(21,24),b,f),vec3.add(b,a,b),vec3.addValue(g.subarray(24,27),c,1E-6),vec3.subValue(g.subarray(27,30),d,1E-6),new HitTest(f,b,vec3.fromValues((b[0]>d[0])-(b[0]<c[0]),(b[1]>d[1])-(b[1]<c[1]),(b[2]>d[2])-(b[2]<c[2])))):null};Raytracer.hitTestSphere=function(a,b,c,d){var f=
vec3.subtract(vec3.create(),a,c),g=vec3.dot(b,b),q=2*vec3.dot(b,f),f=vec3.dot(f,f)-d*d,f=q*q-4*g*f;return 0<f?(g=(-q-Math.sqrt(f))/(2*g),a=vec3.add(vec3.create(),a,vec3.scale(vec3.create(),b,g)),new HitTest(g,a,vec3.scale(vec3.create(),vec3.subtract(vec3.create(),a,c),1/d))):null};Raytracer.hitTestTriangle=function(a,b,c,d,f){var g=vec3.subtract(vec3.create(),d,c),q=vec3.subtract(vec3.create(),f,c);f=vec3.cross(vec3.create(),g,q);vec3.normalize(f,f);d=vec3.dot(f,vec3.subtract(vec3.create(),c,a))/
vec3.dot(f,b);if(0<d){a=vec3.add(vec3.create(),a,vec3.scale(vec3.create(),b,d));var l=vec3.subtract(vec3.create(),a,c);c=vec3.dot(q,q);b=vec3.dot(q,g);var q=vec3.dot(q,l),m=vec3.dot(g,g),g=vec3.dot(g,l),l=c*m-b*b,m=(m*q-b*g)/l,g=(c*g-b*q)/l;if(0<=m&&0<=g&&1>=m+g)return new HitTest(d,a,f)}return null};Mesh.parseOBJ=function(a,b){function c(a){var b,c,d,f=!1;if(-1==a.indexOf("-")){var g=w.get(a);if(void 0!==g)return g}else f=!0;d||(d=a.split("/"));if(1==d.length)d=c=b=parseInt(d[0]);else if(2==d.length)b=
parseInt(d[0]),c=parseInt(d[1]),d=b;else if(3==d.length)b=parseInt(d[0]),c=parseInt(d[1]),d=parseInt(d[2]);else return console.log("Problem parsing: unknown number of values per face"),-1;0>b&&(b=q.length/3+b+1);0>d&&(d=l.length/2+d+1);0>c&&(c=m.length/2+c+1);if(f&&(a=b+"/"+c+"/"+d,g=w.get(a),void 0!==g))return g;b-=1;c-=1;d-=1;n.push(q[3*b+0],q[3*b+1],q[3*b+2]);m.length&&r.push(m[2*c+0],m[2*c+1]);l.length&&p.push(l[3*d+0],l[3*d+1],l[3*d+2]);g=y;w.set(a,g);++y;return g}function d(a){a={name:a||"",
material:"",start:-1,length:-1,indices:[]};t.push(a);return a}function f(a){if(!x.material)return x.material=a+k,u[a]=x;var b=u[a];b||(b=d(s+"_"+a),b.material=a+k,u[a]=b);return x=b}b=b||{};var k=b.matextension||"",q=[],l=[],m=[],n=[],p=[],r=[],t=[],u={},s=null,x=d(),w=new Map,y=0,z=1;b.scale&&(z=b.scale);for(var C={v:1,vt:2,vn:3,f:4,g:5,o:6,usemtl:7,mtllib:8},B,F,K,P=a.split("\n"),R=P.length,I=0;I<R;++I){var A=P[I],A=A.replace(/[ \t]+/g," ").replace(/\s\s*$/,"");if("\\"==A[A.length-1])var I=I+1,
D=P[I].replace(/[ \t]+/g," ").replace(/\s\s*$/,""),A=(A.substr(0,A.length-1)+D).replace(/[ \t]+/g," ").replace(/\s\s*$/,"");if("#"!=A[0]&&""!=A)switch(D=A.split(" "),A=C[D[0]],3>=A&&(B=parseFloat(D[1]),F=parseFloat(D[2]),2!=A&&(K=parseFloat(D[3]))),A){case 1:B*=z;F*=z;K*=z;q.push(B,F,K);break;case 2:m.push(B,F);break;case 3:l.push(B,F,K);break;case 4:if(4>D.length)continue;for(var E=[],A=1;A<D.length;++A)E.push(c(D[A]));x.indices.push(E[0],E[1],E[2]);for(A=2;A<E.length-1;++A)x.indices.push(E[0],E[A],
E[A+1]);break;case 5:case 6:s=A=D[1];x.name?(u={},x=d(A)):x.name=A;break;case 7:f(D[1])}}C=[];B=0;z=[];for(A=0;A<t.length;++A)x=t[A],x.indices&&(x.start=B,x.length=x.indices.length,C=C.concat(x.indices),delete x.indices,B+=x.length,z.push(x));t=z;z={};if(!q.length)return console.error("mesh without vertices"),null;if(b.flip_normals&&p.length)for(l=p,A=0;A<l.length;++A)l[A]*=-1;z.vertices=new Float32Array(n);p.length&&(z.normals=new Float32Array(p));r.length&&(z.coords=new Float32Array(r));C&&0<C.length&&
(z.triangles=new (65536<B?Uint32Array:Uint16Array)(C));z.bounding=g.Mesh.computeBoundingBox(z.vertices);C={};1<t.length&&(C.groups=t);z.info=C;if(!z.bounding)return console.log("empty mesh"),null;if(b.only_data)return z;C=null;return C=Mesh.load(z,null,b.mesh)};Mesh.parsers.obj=Mesh.parseOBJ;Mesh.encoders.obj=function(a,b){var c=a.getBuffer("vertices");if(!c)return null;var d=[];d.push("# Generated with liteGL.js by Javi Agenjo\n");for(var f=c.data,g=0;g<f.length;g+=3)d.push("v "+f[g].toFixed(4)+
" "+f[g+1].toFixed(4)+" "+f[g+2].toFixed(4));if(c=a.getBuffer("normals"))for(d.push(""),c=c.data,g=0;g<c.length;g+=3)d.push("vn "+c[g].toFixed(4)+" "+c[g+1].toFixed(4)+" "+c[g+2].toFixed(4));if(c=a.getBuffer("coords"))for(d.push(""),c=c.data,g=0;g<c.length;g+=2)d.push("vt "+c[g].toFixed(4)+" "+c[g+1].toFixed(4)+"  0.0000");c=a.info.groups;if(g=a.getIndexBuffer("triangles")){f=g.data;c&&c.length||(c=[{start:0,length:f.length,name:"mesh"}]);for(var q=0;q<c.length;++q){g=c[q];d.push("g "+g.name);var l=
g.material||"mat_"+q;-1!=l.indexOf(".json")&&(l=l.substr(0,l.indexOf(".json")));d.push("usemtl "+l);for(var l=g.start,m=l+g.length,g=l;g<m;g+=3)d.push("f "+(f[g]+1)+"/"+(f[g]+1)+"/"+(f[g]+1)+" "+(f[g+1]+1)+"/"+(f[g+1]+1)+"/"+(f[g+1]+1)+" "+(f[g+2]+1)+"/"+(f[g+2]+1)+"/"+(f[g+2]+1))}}else for(c&&c.length||(c=[{start:0,length:f.length/3,name:"mesh"}]),q=0;q<c.length;++q)for(g=c[q],d.push("g "+g.name),d.push("usemtl "+(g.material||"mat_"+q)),l=g.start,m=l+g.length,g=l;g<m;g+=3)d.push("f "+(g+1)+"/"+(g+
1)+"/"+(g+1)+" "+(g+2)+"/"+(g+2)+"/"+(g+2)+" "+(g+3)+"/"+(g+3)+"/"+(g+3));return d.join("\n")};Mesh.parsers.mesh=function(a,b){for(var c={},d=a.split("\n"),f=0;f<d.length;++f){var g=d[f],q=g[0],g=g.substr(1).split(","),l=g[0];if("-"==q){for(var m=new Float32Array(Number(g[1])),q=0;q<m.length;++q)m[q]=Number(g[q+2]);c[l]=m}else if("*"==q){m=65536<Number(g[1])?new Uint32Array(Number(g[1])):new Uint16Array(Number(g[1]));for(q=0;q<m.length;++q)m[q]=Number(g[q+2]);c[l]=m}else if("@"==q)if("bones"==l){l=
[];m=Number(g[1]);for(q=0;q<m;++q){var n=g.slice(3+17*q,3+17*(q+1)-1).map(Number);l.push([g[2+17*q],n])}c.bones=l}else if("bind_matrix"==l)c.bind_matrix=g.slice(1,17).map(Number);else{if("groups"==l)for(c.info={groups:[]},l=Number(g[1]),q=0;q<l;++q)c.info.groups.push({name:g[2+4*q],material:g[4*q+3],start:Number(g[4*q+4]),length:Number(g[4*q+5])})}else console.warn("type unknown: "+g[0])}if(b.only_data)return c;d=null;d=Mesh.load(c,null,b.mesh);d.updateBoundingBox();return d};Mesh.encoders.mesh=function(a,
b){var c=[],d;for(d in a.vertexBuffers){var f=a.vertexBuffers[d],f=["-"+d,f.data.length,f.data,typedArrayToArray(f.data)];c.push(f.join(","))}for(d in a.indexBuffers)f=a.indexBuffers[d],f=["*"+d,f.data.length,f.data,typedArrayToArray(f.data)],c.push(f.join(","));a.bounding&&c.push(["@bounding",typedArrayToArray(a.bounding.subarray(0,6))].join());if(a.info&&a.info.groups){d=[];for(f=0;f<a.info.groups.length;++f){var g=a.info.groups[f];d.push(g.name,g.material,g.start,g.length)}c.push(["@groups",a.info.groups.length].concat(d).join(","))}a.bones&&
c.push(["@bones",a.bones.length,a.bones.flat()].join());a.bind_matrix&&c.push(["@bind_matrix",typedArrayToArray(a.bind_matrix)].join());return c.join("\n")};t.WBin&&(t.WBin.classes.Mesh=Mesh);Mesh.binary_file_formats.wbin=!0;Mesh.parsers.wbin=Mesh.fromBinary=function(a,b){if(!t.WBin)throw"To use binary meshes you need to install WBin.js from https://github.com/jagenjo/litescene.js/blob/master/src/utils/wbin.js ";b=b||{};var c=null,c=a.constructor==ArrayBuffer?WBin.load(a,!0):a;c.info||console.warn("This WBin doesn't seem to contain a mesh. Classname: ",
c["@classname"]);c.format&&g.Mesh.decompress(c);var d={};if(c.vertex_buffers)for(var f in c.vertex_buffers)d[c.vertex_buffers[f]]=c[c.vertex_buffers[f]];else c.vertices&&(d.vertices=c.vertices),c.normals&&(d.normals=c.normals),c.coords&&(d.coords=c.coords),c.weights&&(d.weights=c.weights),c.bone_indices&&(d.bone_indices=c.bone_indices);var k={};if(c.index_buffers)for(f in c.index_buffers)k[c.index_buffers[f]]=c[c.index_buffers[f]];else c.triangles&&(k.triangles=c.triangles),c.wireframe&&(k.wireframe=
c.wireframe);d={vertex_buffers:d,index_buffers:k,bounding:c.bounding,info:c.info};if(c.bones){d.bones=c.bones;for(f=0;f<d.bones.length;++f)d.bones[f][1]=mat4.clone(d.bones[f][1]);c.bind_matrix&&(d.bind_matrix=mat4.clone(c.bind_matrix))}c.morph_targets&&(d.morph_targets=c.morph_targets);if(b.only_data)return d;c=b.mesh||new g.Mesh;c.configure(d);return c};Mesh.encoders.wbin=function(a,b){return a.toBinary(b)};Mesh.prototype.toBinary=function(a){if(!t.WBin)throw"to use Mesh.toBinary you need to have WBin included. Check the repository for wbin.js";
this.info||(this.info={});a={object_class:"Mesh",info:this.info,groups:this.groups};if(this.bones){for(var b=[],c=0;c<this.bones.length;++c)b.push([this.bones[c][0],mat4.toArray(this.bones[c][1])]);a.bones=b;this.bind_matrix&&(a.bind_matrix=this.bind_matrix)}this.bounding||this.updateBoundingBox();a.bounding=this.bounding;var b=[],d=[];for(c in this.vertexBuffers){var f=this.vertexBuffers[c];a[f.name]=f.data;b.push(f.name);"vertices"==f.name&&(a.info.num_vertices=f.data.length/3)}for(c in this.indexBuffers)f=
this.indexBuffers[c],a[c]=f.data,d.push(c);a.vertex_buffers=b;a.index_buffers=d;g.Mesh.enable_wbin_compression&&g.Mesh.compress(a);return WBin.create(a,"Mesh")};Mesh.compress=function(a,b){b=b||"bounding_compressed";a.format={type:b};var c=Mesh.compressors[b];if(!c)throw"compression format not supported:"+b;return c(a)};Mesh.decompress=function(a){if(a.format){var b=Mesh.decompressors[a.format.type];if(!b)throw"decompression format not supported:"+a.format.type;return b(a)}};Mesh.compressors.bounding_compressed=
function(a){if(!a.vertex_buffers)throw"buffers not found";for(var b=BBox.getMin(a.bounding),c=BBox.getMax(a.bounding),d=vec3.sub(vec3.create(),c,b),f=a.vertices,g=new Uint16Array(f.length),c=0;c<f.length;c+=3)g[c]=(f[c]-b[0])/d[0]*65535,g[c+1]=(f[c+1]-b[1])/d[1]*65535,g[c+2]=(f[c+2]-b[2])/d[2]*65535;a.vertices=g;if(a.normals){d=a.normals;b=new Uint8Array(d.length);f=b.constructor==Uint8Array?255:65535;for(c=0;c<d.length;c+=3)b[c]=(0.5*d[c]+0.5)*f,b[c+1]=(0.5*d[c+1]+0.5)*f,b[c+2]=(0.5*d[c+2]+0.5)*
f;a.normals=b}if(a.coords){b=a.coords;f=[1E4,1E4,-1E4,-1E4];for(c=0;c<b.length;c+=2)d=b[c],f[0]>d?f[0]=d:f[2]<d&&(f[2]=d),d=b[c+1],f[1]>d?f[1]=d:f[3]<d&&(f[3]=d);a.format.uvs_bounding=f;g=new Uint16Array(b.length);d=[f[2]-f[0],f[3]-f[1]];for(c=0;c<b.length;c+=2)g[c]=(b[c]-f[0])/d[0]*65535,g[c+1]=(b[c+1]-f[1])/d[1]*65535;a.coords=g}if(a.weights){d=a.weights;b=new Uint16Array(d.length);f=b.constructor==Uint8Array?255:65535;for(c=0;c<d.length;c+=4)b[c]=d[c]*f,b[c+1]=d[c+1]*f,b[c+2]=d[c+2]*f,b[c+3]=d[c+
3]*f;a.weights=b}};Mesh.decompressors.bounding_compressed=function(a){var b=a.bounding;if(!b)throw"error in mesh decompressing data: bounding not found, cannot use the bounding decompression.";for(var c=BBox.getMin(b),b=BBox.getMax(b),d=vec3.sub(vec3.create(),b,c),f=a.format,g=1/255,q=1/65535,l=a.vertices,m=new Float32Array(l.length),b=0,n=l.length;b<n;b+=3)m[b]=l[b]*q*d[0]+c[0],m[b+1]=l[b+1]*q*d[1]+c[1],m[b+2]=l[b+2]*q*d[2]+c[2];a.vertices=m;if(a.normals&&a.normals.constructor!=Float32Array){d=a.normals;
c=new Float32Array(d.length);l=d.constructor==Uint8Array?g:q;b=0;for(n=d.length;b<n;b+=3)c[b]=d[b]*l*2-1,c[b+1]=d[b+1]*l*2-1,c[b+2]=d[b+2]*l*2-1,m=c.subarray(b,b+3),vec3.normalize(m,m);a.normals=c}if(a.coords&&f.uvs_bounding&&a.coords.constructor!=Float32Array){c=a.coords;f=f.uvs_bounding;d=[f[2]-f[0],f[3]-f[1]];l=new Float32Array(c.length);b=0;for(n=c.length;b<n;b+=2)l[b]=c[b]*q*d[0]+f[0],l[b+1]=c[b+1]*q*d[1]+f[1];a.coords=l}if(a.weights&&a.weights.constructor!=Float32Array){f=a.weights;d=new Float32Array(f.length);
g=f.constructor==Uint8Array?g:q;b=0;for(n=f.length;b<n;b+=4)d[b]=f[b]*g,d[b+1]=f[b+1]*g,d[b+2]=f[b+2]*g,d[b+3]=f[b+3]*g;a.weights=d}}})("undefined"!=typeof window?window:"undefined"!=typeof self?self:global);
'use strict';(function(p){function a(c){if(this.constructor!==b.SceneNode)throw"You must use new to create RD.SceneNode";this._ctor();c&&this.configure(c)}function f(c){this.type=b.Camera.PERSPECTIVE;this._position=vec3.fromValues(0,100,100);this._target=vec3.fromValues(0,0,0);this._up=vec3.fromValues(0,1,0);this._near=0.1;this._far=1E4;this._aspect=1;this._fov=45;this._frustum_size=50;this.flip_y=!1;this.view_texel_grid=null;this._view_matrix=mat4.create();this._projection_matrix=mat4.create();this._viewprojection_matrix=
mat4.create();this._model_matrix=mat4.create();this._autoupdate_matrices=!0;this._must_update_matrix=!1;this._top=vec3.create();this._right=vec3.create();this._front=vec3.create();this.uniforms={u_view_matrix:this._view_matrix,u_projection_matrix:this._projection_matrix,u_viewprojection_matrix:this._viewprojection_matrix,u_camera_front:this._front,u_camera_position:this._position,u_camera_planes:vec2.fromValues(0.1,1E3)};c&&this.configure(c);this.updateMatrices()}function g(){this._root=new b.SceneNode;
this._root.flags.no_transform=!0;this._root._scene=this;this._nodes_by_id={};this._nodes=[];this._to_destroy=[];this.frame=this.time=0}function e(c){this._color=vec4.fromValues(1,1,1,1);this.shader_name=null;this.uniforms={u_color:this._color};this.textures={};this.primitive=GL.TRIANGLES;this.blend_mode=b.BLEND_NONE;this.flags={two_sided:!1,depth_test:!0,depth_write:!0};c&&this.configure(c)}function h(c,r){r=r||{};var b=this.gl=this.context=c;if(!b||!b.enable)throw"litegl GL context not found.";c!=
p.gl&&b.makeCurrent();this.point_size=5;this.sort_by_priority=!0;this.reverse_normals=this.sort_by_distance=!1;this.assets_folder="";this._view_matrix=mat4.create();this._projection_matrix=mat4.create();this._viewprojection_matrix=mat4.create();this._mvp_matrix=mat4.create();this._model_matrix=mat4.create();this._texture_matrix=mat3.create();this._color=vec4.fromValues(1,1,1,1);this._viewprojection2D_matrix=mat4.create();this._nodes=[];this._uniforms={u_view:this._view_matrix,u_viewprojection:this._viewprojection_matrix,
u_model:this._model_matrix,u_mvp:this._mvp_matrix,u_global_alpha_clip:0,u_color:this._color,u_texture_matrix:this._texture_matrix};p.gl=this.gl;this.canvas=b.canvas;this.assets_folder=r.assets_folder||"";this.autoload_assets=void 0!==r.autoload_assets?r.autoload_assets:!0;this.default_texture_settings={wrap:b.REPEAT,minFilter:b.LINEAR_MIPMAP_LINEAR,magFilter:b.LINEAR};this.default_cubemap_settings={minFilter:b.LINEAR_MIPMAP_LINEAR,magFilter:b.LINEAR,is_cross:1};this.meshes.plane=GL.Mesh.plane({size:1});
this.meshes.planeXZ=GL.Mesh.plane({size:1,xz:!0});this.meshes.cube=GL.Mesh.cube({size:1,wireframe:!0});this.meshes.sphere=GL.Mesh.sphere({size:1,subdivisions:32,wireframe:!0});this.meshes.grid=GL.Mesh.grid({size:10});this.textures.notfound=this.default_texture=new GL.Texture(1,1,{filter:b.NEAREST,pixel_data:new Uint8Array([0,0,0,255])});this.textures.white=this.default_texture=new GL.Texture(1,1,{filter:b.NEAREST,pixel_data:new Uint8Array([255,255,255,255])});this.num_assets_loading=0;this.assets_loading=
{};this.assets_not_found={};this.draw_calls=this.frame=0;this.createShaders();r.shaders_file&&this.loadShaders(r.shaders_file,null,r.shaders_macros)}function q(c,r){this.origin=vec3.create();this.direction=vec3.create();this.collision_point=vec3.create();c&&this.origin.set(c);r&&this.direction.set(r)}function l(c){this._ctor();c&&this.configure(c)}function s(c){this._ctor();c&&this.configure(c)}function k(c){a.prototype._ctor.call(this,c);this._ctor();c&&this.configure(c)}function d(c,r){return vec3.dot(c,
r)+c[3]}function m(c,r,b){var a=c[3],d=Math.abs(b[0]*c[0]),e=Math.abs(b[1]*c[1]);b=Math.abs(b[2]*c[2]);d=d+e+b;c=vec3.dot(c,r)+a;return c<=-d?x:c<=d?E:D}var b=p.RD={version:0.5};b.ZERO=vec3.fromValues(0,0,0);b.ONE=vec3.fromValues(1,1,1);b.RIGHT=vec3.fromValues(1,0,0);b.LEFT=vec3.fromValues(-1,0,0);b.UP=vec3.fromValues(0,1,0);b.DOWN=vec3.fromValues(0,-1,0);b.FRONT=vec3.fromValues(0,0,-1);b.BACK=vec3.fromValues(0,0,1);b.FRONT2D=vec2.fromValues(0,1);b.WHITE=vec3.fromValues(1,1,1);b.BLACK=vec3.fromValues(0,
0,0);b.IDENTITY=mat4.create();b.ONES4=vec4.fromValues(1,1,1,1);b.CENTER=0;b.TOP_LEFT=1;b.TOP_RIGHT=2;b.BOTTOM_LEFT=3;b.BOTTOM_RIGHT=4;b.TOP_CENTER=5;b.BOTTOM_CENTER=6;b.PRIORITY_BACKGROUND=30;b.PRIORITY_OPAQUE=20;b.PRIORITY_ALPHA=10;b.PRIORITY_HUD=0;b.BLEND_NONE=0;b.BLEND_ALPHA=1;b.BLEND_ADD=2;b.BLEND_MULTIPLY=3;b.NO_BILLBOARD=0;b.BILLBOARD_SPHERIC=1;b.BILLBOARD_PARALLEL_SPHERIC=2;b.BILLBOARD_CYLINDRIC=3;b.BILLBOARD_PARALLEL_CYLINDRIC=4;b.UNKNOWN=0;b.NUMBER=b.SCALAR=1;b.VEC2=2;b.VEC3=3;b.VEC4=4;b.QUAT=
5;b.MAT3=6;b.TRANS10=7;b.MAT4=8;b.TYPES={NUMBER:b.NUMBER,SCALAR:b.NUMBER,VEC2:b.VEC2,VEC3:b.VEC3,VEC4:b.VEC4,QUAT:b.QUAT,MAT3:b.MAT3,TRANS10:b.TRANS10,MAT4:b.MAT4};b.TYPES_SIZE=[0,1,2,3,4,4,9,10,16];b.NO_INTERPOLATION=0;b.LINEAR=1;b.CUBIC=2;var n=b.DEG2RAD=0.0174532925;b.RAD2DEG=57.295779578552306;b.Materials={};b.Images={};b.setup=function(c){c=c||{};if(b.configuration)throw"already called setup";b.configuration=c};var y=0;"undefined"==typeof extendClass&&(p.extendClass=function(c,r){for(var b in r)c.hasOwnProperty(b)||
(c[b]=r[b]);if(r.prototype){var a=Object.getOwnPropertyNames(r.prototype);for(b=0;b<a.length;++b){var d=a[b];c.prototype.hasOwnProperty(d)||(r.prototype.__lookupGetter__(d)?c.prototype.__defineGetter__(d,r.prototype.__lookupGetter__(d)):c.prototype[d]=r.prototype[d],r.prototype.__lookupSetter__(d)&&c.prototype.__defineSetter__(d,r.prototype.__lookupSetter__(d)))}}c.hasOwnProperty("superclass")||Object.defineProperty(c,"superclass",{get:function(){return r},enumerable:!1})});var t=mat4.create(),B=
mat3.create(),v=mat4.create(),w=vec2.create(),u=vec3.create(),z=vec3.create();vec4.create();var A=quat.create();b.SceneNode=a;a.prototype._ctor=function(){this._uid=y++;this._id=null;this._transform=new Float32Array(10);this._position=this._transform.subarray(0,3);this._rotation=this._transform.subarray(3,7);this._scale=this._transform.subarray(7,10);quat.identity(this._rotation);this._scale.set(b.ONE);this._local_matrix=mat4.create();this._global_matrix=mat4.create();this._must_update_matrix=!1;
this.bounding_box=null;this.render_priority=b.PRIORITY_OPAQUE;this.blend_mode=b.BLEND_NONE;this.layers=3;this._color=vec4.fromValues(1,1,1,1);this._uniforms={u_color:this._color,u_color_texture:0};this.primitive=GL.TRIANGLES;this.primitives=[];this._instances=this.draw_range=null;this.onRender||(this.onRender=null);this.onShaderUniforms||(this.onShaderUniforms=null);this.mesh=this.shader=null;this.textures={};this.flags={visible:!0,collides:!0};this.children=[]};a.ctor=a.prototype._ctor;a.prototype.clone=
function(c){var r=new this.constructor,b;for(b in this)if("_"!=b[0])if("children"==b){if(c)for(var a=0;a<this.children.length;++a)r.addChild(this.children[a].clone(c))}else a=this[b],void 0!==a&&(null===a?r[b]=null:a.constructor===Object?r[b]=GL.cloneObject(a):a.constructor===Array?r[b]=a.concat():r[b]!==a&&(r[b]=a));return r};Object.defineProperty(a.prototype,"id",{get:function(){return this._id},set:function(c){this._scene?console.error("Cannot change id of a node already in a scene."):this._id=
c},enumerable:!0});Object.defineProperty(a.prototype,"uniforms",{get:function(){return this._uniforms},set:function(c){GL.cloneObject(c,this._uniforms);this._uniforms.u_color=this._color},enumerable:!0});Object.defineProperty(a.prototype,"position",{get:function(){return this._position},set:function(c){this._position.set(c);this._must_update_matrix=!0},enumerable:!0});Object.defineProperty(a.prototype,"x",{get:function(){return this._position[0]},set:function(c){this._position[0]=c;this._must_update_matrix=
!0},enumerable:!0});Object.defineProperty(a.prototype,"y",{get:function(){return this._position[1]},set:function(c){this._position[1]=c;this._must_update_matrix=!0},enumerable:!0});Object.defineProperty(a.prototype,"z",{get:function(){return this._position[2]},set:function(c){this._position[2]=c;this._must_update_matrix=!0},enumerable:!0});Object.defineProperty(a.prototype,"rotation",{get:function(){return this._rotation},set:function(c){this._rotation.set(c);this._must_update_matrix=!0},enumerable:!0});
Object.defineProperty(a.prototype,"scaling",{get:function(){return this._scale},set:function(c){c.constructor===Number?this._scale[0]=this._scale[1]=this._scale[2]=c:this._scale.set(c);this._must_update_matrix=!0},enumerable:!0});Object.defineProperty(a.prototype,"transform",{get:function(){return this._transform},set:function(c){this._transform.set(c);this._must_update_matrix=!0},enumerable:!0});Object.defineProperty(a.prototype,"pivot",{get:function(){return this._pivot},set:function(c){this._must_update_matrix=
!0;c?(this._pivot||(this._pivot=vec3.create()),this._pivot.set(c),this.flags.pivot=!0):(this._pivot=null,this.flags.pivot=!1)},enumerable:!0});Object.defineProperty(a.prototype,"color",{get:function(){return this._color},set:function(c){this._color.set(c)},enumerable:!0});Object.defineProperty(a.prototype,"opacity",{get:function(){return this._color[3]},set:function(c){this._color[3]=c},enumerable:!0});Object.defineProperty(a.prototype,"visible",{get:function(){return this.flags.visible},set:function(c){this.flags.visible=
c},enumerable:!0});Object.defineProperty(a.prototype,"texture",{get:function(){return this.textures.color},set:function(c){this.textures.color=c},enumerable:!1});Object.defineProperty(a.prototype,"scene",{get:function(){return this._scene},set:function(c){throw"cannot set scene, you must use addChild in its parent node";},enumerable:!1});Object.defineProperty(a.prototype,"parentNode",{get:function(){return this._parent},set:function(c){throw"Cannot set parentNode of SceneNode";},enumerable:!1});a.prototype.addChild=
function(c,r){function b(c,r){if(c._scene&&c._scene!=r){var a=c._scene._nodes.indexOf(c);-1!=a&&c._scene._nodes.splice(a,1);c.id&&c._scene._nodes_by_id[c.id]==c&&delete c._scene._nodes_by_id[c.id]}if(c._scene=r)r._nodes.push(c),c.id&&r&&(r._nodes_by_id[c.id]=c);if(c.children)for(var a=0,d=c.children.length;a<d;a++){var e=c.children[a];e._scene!=r&&b(e,r)}}if(c._parent)throw"addChild: Cannot add a child with a parent, remove from parent first";c._parent=this;r&&c.fromMatrix(c._global_matrix);this.children||
(this.children=[]);this.children.push(c);this._scene!=c._scene&&b(c,this._scene)};a.prototype.removeChild=function(c,r){function b(c){if(c._scene){c.id&&c._scene._nodes_by_id[c.id]==c&&delete c._scene._nodes_by_id[c.id];var r=c._scene._nodes.indexOf(c);-1!=r&&c._scene._nodes.splice(r,1)}c._scene=null;for(var r=0,a=c.children.length;r<a;r++)b(c.children[r])}if(c._parent!=this)throw"removeChild: Not its children";if(this.children){var a=this.children.indexOf(c);if(-1==a)throw"removeChild: impossible, should be children";
this.children.splice(a,1);c._parent=null;r&&c.fromMatrix(c._global_matrix);b(c)}};a.prototype.removeAllChildren=function(){if(this.children)for(;this.children.length;)this.removeChild(this.children[0])};a.prototype.clear=function(){if(this.children)for(;this.children.length;)this.removeChild(this.children[this.children.length-1])};a.prototype.setChildIndex=function(c,r){if(this.children){var b=this.children.indexOf(c);-1!=b&&(this.children.splice(b,1),this.children.splice(r,0,c))}};a.prototype.getAllChildren=
function(c){c=c||[];if(!this.children)return c;for(var r=0,b=this.children.length;r<b;r++){var a=this.children[r];c.push(a);a.getAllChildren(c)}return c};a.prototype.getVisibleChildren=function(c,r){c=c||[];void 0===r&&(r=255);if(!this.children||!1===this.flags.visible)return c;for(var b=0,a=this.children.length;b<a;b++){var d=this.children[b];d.layers&r&&c.push(d);d.getVisibleChildren(c,r)}return c};a.prototype.serialize=function(){var c={position:[this._position[0],this._position[1],this._position[2]],
rotation:[this._rotation[0],this._rotation[1],this._rotation[2],this._rotation[3]],scale:[this._scale[0],this._scale[1],this._scale[2]],children:[]};this.name&&(c.name=this.name);this.primitives&&this.primitives.length&&(c.primitives=this.primitives.concat());this.mesh&&(c.mesh=this.mesh);this.material&&(c.material=this.material);null!=this.submesh&&(c.submesh=this.submesh);this.extra&&(c.extra=this.extra);if(this.onSerialize)this.onSerialize(c);if(this.children)for(var r=0,b=this.children.length;r<
b;r++)c.children.push(this.children[r].serialize());return c};a.prototype.configure=function(c){var r=null,a;for(a in c){switch(a){case "children":continue;case "uniforms":for(var d in c.uniforms)this.uniforms[d]=c.uniforms[d];continue;case "texture":this[a]=c[a];continue;case "flags":for(d in c.flags)this.flags[d]=c.flags[d];continue;case "scale":case "scaling":this.scale(c[a]);continue;case "tiling":isNumber(c[a])?this.setTextureTiling(c[a],c[a]):this.setTextureTiling(c[a][0],c[a][1],c[a][2],c[a][3]);
continue;case "mesh":case "primitives":case "material":case "ref":case "draw_range":case "submesh":this[a]=c[a];continue;case "parent":r=c[a]}var e=this[a];void 0!==e&&(e&&e.constructor===Float32Array?e.set(c[a]):this[a]=c[a])}this._must_update_matrix=!0;this.updateGlobalMatrix();if(c.children)for(this.removeAllChildren(),a=0;a<c.children.length;++a)d=new b.SceneNode,d.configure(c.children[a]),this.addChild(d);r&&(this.parentNode?console.error("This node already has a parent"):r.addChild(this))};
a.prototype.setMesh=function(c){c?"string"==typeof c?this.mesh=c:this._mesh=c:this.mesh=null};a.prototype.setTexture=function(c,r){r?"string"==typeof r&&(this.textures[c]=r):this.textures[c]=null};a.prototype.resetTransform=function(){this._position.set(b.ZERO);quat.identity(this._rotation);this._scale.set(b.ONE);this._must_update_matrix=!0};a.prototype.translate=function(c){vec3.add(this._position,this._position,c);this._must_update_matrix=!0};a.prototype.rotate=function(c,r,b){quat.setAxisAngle(A,
r,c);b?quat.multiply(this._rotation,A,this._rotation):quat.multiply(this._rotation,this._rotation,A);this._must_update_matrix=!0};a.prototype.rotateQuat=function(c,r){r?quat.multiply(this._rotation,c,this._rotation):quat.multiply(this._rotation,this._rotation,c);this._must_update_matrix=!0};a.prototype.scale=function(c){c.constructor===Number?(u[0]=u[1]=u[2]=c,vec3.mul(this._scale,this._scale,u)):vec3.mul(this._scale,this._scale,c);this._must_update_matrix=!0};a.prototype.setPivot=function(c){this.pivot=
c};a.prototype.setTextureTiling=function(c,r,b,a){this.texture_matrix||(this.texture_matrix=mat3.create(),this._uniforms.u_texture_matrix=this.texture_matrix);b=b||0;a=a||0;this.shader||(this.shader="texture_transform");mat3.identity(this.texture_matrix);mat3.translate(this.texture_matrix,this.texture_matrix,[b,a]);mat3.scale(this.texture_matrix,this.texture_matrix,[c,r])};a.prototype.getLocalMatrix=function(c){this._must_update_matrix&&this.updateLocalMatrix();return c?(c.set(this._global_matrix),
c):this._local_matrix};a.prototype.getGlobalMatrix=function(c){this.updateGlobalMatrix();return c?(c.set(this._global_matrix),c):this._global_matrix};a.prototype.getGlobalRotation=function(c){c=c||vec4.create();quat.identity(c);for(var b=this,a=this._scene?this._scene._root:null;b!=a;)quat.multiply(c,b._rotation,c),b=b._parent;return c};a.prototype.updateLocalMatrix=function(){var c=this._local_matrix;this._must_update_matrix=!1;mat4.identity(c);this.flags.no_transform||(this.flags.pivot&&this._pivot&&
(c[12]=this._pivot[0],c[13]=this._pivot[1],c[14]=this._pivot[2]),mat4.translate(c,c,this._position),mat4.fromQuat(v,this._rotation),mat4.multiply(c,c,v),mat4.scale(c,c,this._scale),this.flags.pivot&&this._pivot&&mat4.translate(c,c,[-this._pivot[0],-this._pivot[1],-this._pivot[2]]))};a.prototype.updateGlobalMatrix=function(c,b){var a=null;this._must_update_matrix&&!this.flags.no_transform&&this.updateLocalMatrix();this._parent&&this._parent._transform&&!0!==this._parent.flags.no_transform?(a=c?this._parent._global_matrix:
this._parent.getGlobalMatrix(),this.flags.no_transform?this._global_matrix.set(a):mat4.multiply(this._global_matrix,a,this._local_matrix)):this._global_matrix.set(this._local_matrix);if(b)for(a=0;a<this.children.length;a++)this.children[a].updateGlobalMatrix(!0,b)};a.prototype.updateMatrices=function(c){this.updateLocalMatrix();this.updateGlobalMatrix(c)};a.prototype.fromMatrix=function(c,r){if(r&&this._parent&&this._parent._transform){mat4.copy(this._global_matrix,c);var a=this._parent.getGlobalMatrix();
mat4.invert(a,a);c=mat4.multiply(this._local_matrix,a,c)}a=mat4.clone(c);mat4.multiplyVec3(this._position,a,[0,0,0]);var d=vec3.create();this._scale[0]=vec3.length(mat4.rotateVec3(d,a,b.RIGHT));this._scale[1]=vec3.length(mat4.rotateVec3(d,a,b.UP));this._scale[2]=vec3.length(mat4.rotateVec3(d,a,b.BACK));a=mat3.fromMat4(B,a);quat.fromMat3AndQuat(this._rotation,a);c!=this._local_matrix&&mat4.copy(this._local_matrix,c);this._must_update_matrix=!1};a.prototype.getLocalPoint=function(c,b){b=b||vec3.create();
this._must_update_matrix&&this.updateLocalMatrix();return vec3.transformMat4(b,c,this._local_matrix)};a.prototype.getLocalVector=function(c,b){b=b||vec3.create();return vec3.transformQuat(b,c,this._rotation)};a.prototype.getGlobalPosition=function(c,r){c=c||vec3.create();if(r)return vec3.transformMat4(c,b.ZERO,this._global_matrix);if(!this._parent||!this._parent._transform)return c.set(this._position),c;var a=this.getGlobalMatrix();return vec3.transformMat4(c,b.ZERO,a)};a.prototype.getGlobalPoint=
function(c,b){b=b||vec3.create();var a=this.getGlobalMatrix();return vec3.transformMat4(b,c,a)};a.prototype.localToGlobal=a.prototype.getGlobalPoint;a.prototype.globalToLocal=function(c,b){b=b||vec3.create();var a=this.getGlobalMatrix();mat4.invert(v,a);return vec3.transformMat4(b,c,v)};a.prototype.getGlobalVector=function(c,b){b=b||vec3.create();var a=this.getGlobalRotation(A);return vec3.transformQuat(b,c,a)};a.prototype.getDistanceTo=function(c){var b=this.getGlobalMatrix();return vec3.distance(c,
b.subarray(12,15))};a.prototype.findNode=function(c){for(var b=0,a=this.children.length;b<a;b++){var d=this.children[b];if(d.id==c||(d=d.findNode(c)))return d}return null};a.prototype.findNodeByName=function(c){for(var b=0,a=this.children.length;b<a;b++){var d=this.children[b];if(d.name==c||(d=d.findNodeByName(c)))return d}return null};a.prototype.findNodesByFilter=function(c,b,a){void 0===b&&(b=255);a=a||[];for(var d=0,e=this.children.length;d<e;d++){var n=this.children[d];n.layer&b&&(c&&!c(n)||
a.push(n),n.findNodesByFilter(c,b,a))}return a};a.prototype.propagate=function(c,b){for(var a=0,d=this.children.length;a<d;a++){var e=this.children[a];e&&(e[c]&&e[c].apply(e,b),e.children&&e.children.length&&e.propagate(c,b))}};a.prototype.loadTextConfig=function(c,r){GL.request(c,null,function(c){c=b.parseTextConfig(c);r&&r(c)},alert)};a.prototype.destroy=function(c){!this.scene||c?this._parent&&this._parent.removeChild(this):this.scene._to_destroy.push(this)};a.prototype.updateBoundingBox=function(c){var b=
this._global_matrix,a=gl.meshes[this.mesh],d=null;a&&(d=a.getBoundingBox(),this.bounding_box||(this.bounding_box=BBox.create()),d=BBox.transformMat4(this.bounding_box,d,b));if(c||!this.children||0==this.children.length)return d;for(c=0;c<this.children.length;++c)if(b=this.children[c].updateBoundingBox())d||(d=this.bounding_box=BBox.create()),BBox.merge(d,d,b);return d};a.prototype.testRay=function(){var c=vec3.create(),b=vec3.create();vec3.create();vec3.create();vec3.create();mat4.create();mat4.create();
return function(a,d,e,n,k,h){e=void 0===e?Number.MAX_VALUE:e;void 0===n&&(n=255);d=d||vec3.create();void 0!==g._ray_tested_objects&&g._ray_tested_objects++;var m=null,f=null;this.layers&n&&!this.flags.ignore_collisions&&this.mesh&&(f=this.testRayWithMesh(a,c,e,n,k,h));f&&(h=vec3.distance(a.origin,c),h<e&&(e=h,d.set(c),m=this));if(!this.children&&!this.children.length)return m;for(f=0;f<this.children.length;++f){var t=this.children[f].testRay(a,b,e,n,k);t&&(h=vec3.distance(a.origin,b),h<e&&(e=h,d.set(c),
m=t))}return m}}();a.prototype.testRayWithMesh=function(){var c=vec3.create(),b=vec3.create(),d=vec3.create(),e=mat4.create();return function(n,k,h,m,f,t){if(!this.mesh)return!1;var l=gl.meshes[this.mesh];if(!l)return!1;var y=null==this.submesh?-1:this.submesh,q=this._global_matrix;mat4.invert(e,q);vec3.transformMat4(c,n.origin,e);vec3.add(d,n.origin,n.direction);vec3.transformMat4(d,d,e);vec3.sub(b,d,c);vec3.normalize(b,b);if(this.primitives&&t)for(t=0;t<this.primitives.length;++t)a.testRayMesh(n,
c,b,l,this.primitives[t].index,k,h,m,f,!0);else return a.testRayMesh(n,c,b,q,l,y,k,h,m,f,this.flags.two_sided)}}();a.testRayMesh=function(c,b,a,d,e,n,k,h,m,f,t){h=void 0===h?Number.MAX_VALUE:h;var l=null;m=null;-1==n?(l=e.getBoundingBox(),m=e):(m=e.info.groups[n],l=m.bounding,l||(e.computeGroupsBoundingBoxes(),l=m.bounding));if(!l)return!1;h||(h=1E7);if(!geo.testRayBBox(b,a,l,null,u))return!1;vec3.transformMat4(k,u,d);n=vec3.distance(c.origin,k);if(n>h)return!1;if(!f)return!0;m._octree||(m._octree=
m==e?new GL.Octree(e):new GL.Octree(e,m.start,m.length));b=m._octree.testRay(b,a,0,h,t);if(!b)return!1;k.set(b.hit);vec3.transformMat4(k,k,d);n=vec3.distance(c.origin,k);return n>h?!1:!0};a.prototype.setRangeFromSubmesh=function(c){if(void 0!==c&&this.mesh){var b=gl.meshes[this.mesh];if(b&&b.info&&b.info.groups){if(c.constructor===String){for(var a=0;a<b.info.groups.length;++a)if(b.info.groups[a].name==c){c=a;break}if(a===b.info.groups.length)return!1}if(c=b.info.groups[c])this.draw_range[0]=c.start,
this.draw_range[1]=c.length}else console.warn("you cannot set the submesh_id while the mesh is not yet loaded")}else this.draw_range=null};a.prototype.findNodesInSphere=function(c,b,a,d){void 0===a&&(a=255);d=d||[];for(var e=0;e<this.children.length;++e){var n=this.children[e];n.layers&a&&(n.getGlobalPosition(u,!0),vec3.distance(u,c)<=b&&d.push(n));n.children.length&&n.findNodesInSphere(c,b,a,d)}return d};b.Camera=f;f.PERSPECTIVE=1;f.ORTHOGRAPHIC=2;f.prototype.configure=function(c){null!=c.type&&
(this.type=c.type);c.position&&this._position.set(c.position);c.target&&this._target.set(c.target);c.up&&this._up.set(c.up);c.near&&(this.near=c.near);c.far&&(this.far=c.far);c.fov&&(this.fov=c.fov);c.aspect&&(this.aspect=c.aspect)};f.prototype.serialize=function(){return{type:this.type,position:[this.position[0],this.position[1],this.position[2]],target:[this.target[0],this.target[1],this.target[2]],up:this.up,fov:this.fov,near:this.near,far:this.far,aspect:this.aspect}};Object.defineProperty(f.prototype,
"position",{get:function(){return this._position},set:function(c){this._position.set(c);this._must_update_matrix=!0},enumerable:!1});Object.defineProperty(f.prototype,"target",{get:function(){return this._target},set:function(c){this._target.set(c);this._must_update_matrix=!0},enumerable:!1});Object.defineProperty(f.prototype,"up",{get:function(){return this._up},set:function(c){this._up.set(c);this._must_update_matrix=!0},enumerable:!1});Object.defineProperty(f.prototype,"fov",{get:function(){return this._fov},
set:function(c){this._fov=c;this._must_update_matrix=!0},enumerable:!1});Object.defineProperty(f.prototype,"aspect",{get:function(){return this._aspect},set:function(c){this._aspect=c;this._must_update_matrix=!0},enumerable:!1});Object.defineProperty(f.prototype,"frustum_size",{get:function(){return this._frustum_size},set:function(c){this._frustum_size=c;this._must_update_matrix=!0},enumerable:!1});Object.defineProperty(f.prototype,"near",{get:function(){return this._near},set:function(c){this._near=
this.uniforms.u_camera_planes[0]=c;this._must_update_matrix=!0},enumerable:!1});Object.defineProperty(f.prototype,"far",{get:function(){return this._far},set:function(c){this._far=this.uniforms.u_camera_planes[1]=c;this._must_update_matrix=!0},enumerable:!1});Object.defineProperty(f.prototype,"view_matrix",{get:function(){return this._view_matrix},set:function(c){this._view_matrix.set(c);mat4.multiply(this._viewprojection_matrix,this._projection_matrix,this._view_matrix)},enumerable:!1});Object.defineProperty(f.prototype,
"projection_matrix",{get:function(){return this._projection_matrix},set:function(c){this._projection_matrix.set(c);mat4.multiply(this._viewprojection_matrix,this._projection_matrix,this._view_matrix)},enumerable:!1});Object.defineProperty(f.prototype,"viewprojection_matrix",{get:function(){return this._viewprojection_matrix},set:function(c){this._viewprojection_matrix.set(c)},enumerable:!1});f.prototype.perspective=function(c,b,a,d){this.type=f.PERSPECTIVE;this._fov=c;this._aspect=b;this._near=a;
this._far=d;this._must_update_matrix=!0};f.prototype.orthographic=function(c,b,a,d){this.type=f.ORTHOGRAPHIC;this._frustum_size=c;1<arguments.lenth&&(this._near=b,this._far=a,this._aspect=d||1);this._must_update_matrix=!0};f.prototype.lookAt=function(c,b,a){vec3.copy(this._position,c);vec3.copy(this._target,b);vec3.copy(this._up,a);this._must_update_matrix=!0};f.prototype.updateMatrices=function(c){if(this._autoupdate_matrices||c)if(this.type==f.ORTHOGRAPHIC?this.frustum_size.constructor===Number?
mat4.ortho(this._projection_matrix,-this.frustum_size*this._aspect,this.frustum_size*this._aspect,-this._frustum_size,this._frustum_size,this._near,this._far):this.frustum_size.length&&mat4.ortho(this._projection_matrix,this.frustum_size[0],this.frustum_size[1],this.frustum_size[2],this.frustum_size[3],3<this.frustum_size.length?this.frustum_size[4]:this._near,4<this.frustum_size.length?this.frustum_size[5]:this._far):mat4.perspective(this._projection_matrix,this._fov*n,this._aspect,this._near,this._far),
this.flip_y&&mat4.scale(this._projection_matrix,this._projection_matrix,[1,-1,1]),mat4.lookAt(this._view_matrix,this._position,this._target,this._up),this.view_texel_grid&&this.type==f.ORTHOGRAPHIC){c=2*(this.frustum_size.constructor===Number?this.frustum_size*this._aspect:this.frustum_size[0])/this.view_texel_grid[0];var a=2*(this.frustum_size.constructor===Number?this.frustum_size:this.frustum_size[1])/this.view_texel_grid[1];this._view_matrix[12]=Math.floor(this._view_matrix[12]/c)*c;this._view_matrix[13]=
Math.floor(this._view_matrix[13]/a)*a}this.is_reflection&&mat4.scale(this._view_matrix,this._view_matrix,[1,-1,1]);mat4.multiply(this._viewprojection_matrix,this._projection_matrix,this._view_matrix);mat4.invert(this._model_matrix,this._view_matrix);this._must_update_matrix=!1;mat4.rotateVec3(this._right,this._model_matrix,b.RIGHT);mat4.rotateVec3(this._top,this._model_matrix,b.UP);mat4.rotateVec3(this._front,this._model_matrix,b.FRONT);this.distance=vec3.distance(this._position,this._target);this.uniforms.u_camera_planes[0]=
this._near;this.uniforms.u_camera_planes[1]=this._far};f.prototype.getModel=function(c){c=c||mat4.create();mat4.invert(this._model_matrix,this._view_matrix);mat4.copy(c,this._model_matrix);return c};f.prototype.updateVectors=function(c){var a=vec3.subtract(u,this._target,this._position),a=vec3.length(a);mat4.multiplyVec3(this._position,c,b.ZERO);mat4.multiplyVec3(this._target,c,[0,0,-a]);mat4.rotateVec3(this._up,c,b.UP)};f.prototype.getLocalVector=function(c,b){this._must_update_matrix&&this.updateMatrices();
return mat4.rotateVec3(b||vec3.create(),this._model_matrix,c)};f.prototype.getLocalPoint=function(c,b){this._must_update_matrix&&this.updateMatrices();return vec3.transformMat4(b||vec3.create(),c,this._model_matrix)};f.prototype.getFront=function(c){c=c||vec3.create();vec3.subtract(c,this._target,this._position);vec3.normalize(c,c);return c};f.prototype.move=function(c,b){void 0!==b&&(vec3.scale(u,c,b),c=u);vec3.add(this._target,this._target,c);vec3.add(this._position,this._position,c);this._must_update_matrix=
!0};f.prototype.moveLocal=function(c,b){this._must_update_matrix&&this.updateMatrices();var a=mat4.rotateVec3(u,this._model_matrix,c);void 0!==b&&vec3.scale(a,a,b);vec3.add(this._target,this._target,a);vec3.add(this._position,this._position,a);this._must_update_matrix=!0};f.prototype.rotate=function(c,b){var a=quat.setAxisAngle(A,b,c),d=vec3.subtract(u,this._target,this._position);vec3.transformQuat(d,d,a);vec3.add(this._target,this._position,d);this._must_update_matrix=!0};f.prototype.rotateLocal=
function(c,b){this._must_update_matrix&&this.updateMatrices();var a=mat4.rotateVec3(z,this._model_matrix,b),a=quat.setAxisAngle(A,a,c),d=vec3.subtract(u,this._target,this._position);vec3.transformQuat(d,d,a);vec3.add(this._target,this._position,d);this._must_update_matrix=!0};f.prototype.orbit=function(c,b,a,d){if(!b)throw"RD: orbit axis missing";a=a||this._target;d&&(this._must_update_matrix&&this.updateMatrices(),b=mat4.rotateVec3(z,this._model_matrix,b));c=quat.setAxisAngle(A,b,c);b=vec3.subtract(u,
this._position,this._target);vec3.transformQuat(b,b,c);vec3.add(this._position,a,b);this._must_update_matrix=!0};f.prototype.orbitDistanceFactor=function(c,b){b=b||this._target;var a=vec3.subtract(u,this._position,b);vec3.scale(a,a,c);vec3.add(this._position,b,a);this._must_update_matrix=!0};f.prototype.project=function(c,b,a){a=a||vec3.create();b=b||gl.viewport_data;this._must_update_matrix&&this.updateMatrices();mat4.projectVec3(a,this._viewprojection_matrix,c);a[0]=a[0]*b[2]+b[0];a[1]=a[1]*b[3]+
b[1];return a};f.prototype.unproject=function(c,b,a){b=b||gl.viewport_data;this._must_update_matrix&&this.updateMatrices();return vec3.unproject(a||vec3.create(),c,this._viewprojection_matrix,b)};f.prototype.getRay=function(c,a,d,e){if(void 0===c||void 0===a)throw"RD.Camera.getRay requires x and y parameters";d=d||gl.viewport_data;e||(e=new b.Ray);this._must_update_matrix&&this.updateMatrices();var n=e.origin;vec3.set(n,c,a,0);this.type==b.Camera.ORTHOGRAPHIC?vec3.unproject(n,n,this._viewprojection_matrix,
d):vec3.copy(n,this.position);var k=e.direction;vec3.set(k,c,a,1);vec3.unproject(k,k,this._viewprojection_matrix,d);vec3.sub(k,k,n);vec3.normalize(k,k);return e};f.prototype.getRayPlaneCollision=function(c,b,a,d,e,n){e=e||vec3.create();c=this.getRay(c,b,n);return geo.testRayPlane(c.origin,c.direction,a,d,e)?e:null};f.controller_keys={forward:"UP",back:"DOWN",left:"LEFT",right:"RIGHT"};f.prototype.applyController=function(c,a,d){d=d||10;c&&(gl.keys[f.controller_keys.forward]?this.moveLocal(vec3.scale(u,
b.FRONT,c*d)):gl.keys[f.controller_keys.back]&&this.moveLocal(vec3.scale(u,b.BACK,c*d)),gl.keys[f.controller_keys.left]?this.moveLocal(vec3.scale(u,b.LEFT,c*d)):gl.keys[f.controller_keys.right]&&this.moveLocal(vec3.scale(u,b.RIGHT,c*d)));a&&(a.deltax&&this.rotate(-0.005*a.deltax,b.UP),a.deltay&&this.rotateLocal(-0.005*a.deltay,b.RIGHT))};f.prototype.lerp=function(c,b){vec3.lerp(this._position,this._position,c._position,b);vec3.lerp(this._target,this._target,c._target,b);vec3.lerp(this._up,this._up,
c._up,b);this._fov=this._fov*(1-b)+c._fov*b;this._near=this._near*(1-b)+c._near*b;this._far=this._far*(1-b)+c._far*b;this._frustum_size.constructor===Number&&(this._frustum_size=this._frustum_size*(1-b)+c._frustum_sizer*b);this._must_update_matrix=!0};f.prototype.orientMatrixToCamera=function(c){c.set(this._right,0);c.set(this._top,4);c.set(this._front,8)};f.prototype.extractPlanes=function(){function c(c){var b=a.subarray(c,c+3),b=vec3.length(b);0!==!b&&(b=1/b,a[c]*=b,a[c+1]*=b,a[c+2]*=b,a[c+3]*=
b)}var b=this._viewprojection_matrix,a=this._planes_data||new Float32Array(24);a.set([b[3]-b[0],b[7]-b[4],b[11]-b[8],b[15]-b[12]],0);c(0);a.set([b[3]+b[0],b[7]+b[4],b[11]+b[8],b[15]+b[12]],4);c(4);a.set([b[3]+b[1],b[7]+b[5],b[11]+b[9],b[15]+b[13]],8);c(8);a.set([b[3]-b[1],b[7]-b[5],b[11]-b[9],b[15]-b[13]],12);c(12);a.set([b[3]-b[2],b[7]-b[6],b[11]-b[10],b[15]-b[14]],16);c(16);a.set([b[3]+b[2],b[7]+b[6],b[11]+b[10],b[15]+b[14]],20);c(20);this._planes_data=a;this._frustrum_planes||(this._frustrum_planes=
[a.subarray(0,4),a.subarray(4,8),a.subarray(8,12),a.subarray(12,16),a.subarray(16,20),a.subarray(20,24)])};var D=b.CLIP_INSIDE=0,x=b.CLIP_OUTSIDE=1,E=b.CLIP_OVERLAP=2;f.prototype.testMesh=function(){if(p.BBox){var c=BBox.create(),b=c.subarray(0,3),a=c.subarray(3,6);return function(d,e){var n=d.bounding;if(!n)return D;BBox.transformMat4(c,n,e);return this.testBox(b,a)}}}();f.prototype.testBox=function(c,b){this._frustrum_planes||this.extractPlanes();var a=this._frustrum_planes,d=0,e=0,d=m(a[0],c,b);
if(d==x)return x;e+=d;d=m(a[1],c,b);if(d==x)return x;e+=d;d=m(a[2],c,b);if(d==x)return x;e+=d;d=m(a[3],c,b);if(d==x)return x;e+=d;d=m(a[4],c,b);if(d==x)return x;e+=d;d=m(a[5],c,b);return d==x?x:0==e+d?D:E};f.prototype.testSphere=function(c,b){this._frustrum_planes||this.extractPlanes();var a=this._frustrum_planes,e,n=!1;e=d(a[0],c);if(e<-b)return x;e>=-b&&e<=b&&(n=!0);e=d(a[1],c);if(e<-b)return x;e>=-b&&e<=b&&(n=!0);e=d(a[2],c);if(e<-b)return x;e>=-b&&e<=b&&(n=!0);e=d(a[3],c);if(e<-b)return x;e>=
-b&&e<=b&&(n=!0);e=d(a[4],c);if(e<-b)return x;e>=-b&&e<=b&&(n=!0);e=d(a[5],c);if(e<-b)return x;e>=-b&&e<=b&&(n=!0);return n?E:D};b.Scene=g;g.prototype.clear=function(){this._root=new b.SceneNode;this._root._scene=this;this._nodes.length=0;this._nodes_by_id={};this.time=0};g.prototype.getNodeById=function(c){return this._nodes_by_id[c]};g.prototype.findNodesInBBox=function(c,b,a){void 0===b&&(b=255);a=a||[];for(var d=0;d<this.nodes.length;++d){var e=this.nodes[d];e.bounding_box&&e.layers&b&&geo.testBBoxBBox(e.bounding_box,
c)&&a.push(e)}return a};g.prototype.update=function(c){this.time+=c;this._root.propagate("update",[c]);this.destroyPendingNodes()};g.prototype.destroyPendingNodes=function(c){if(this._to_destroy.length)for(c=null;c=this._to_destroy.pop();)c._parent&&c._parent.removeChild(c)};Object.defineProperty(g.prototype,"root",{get:function(){return this._root},set:function(c){throw"Cannot set root of scene";},enumerable:!1});g.prototype.testRay=function(c,a,d,e,n){b.Scene._ray_tested_objects=0;a||(a=u);return this.root.testRay(c,
a,d,void 0===e?255:e,n)};g.prototype.fromJSON=function(c){this.root.clear();this.root.configure(c)};g.prototype.toJSON=function(c){function b(d,e){if(c){if(!c(d,e))return!1}else{if(!d.flags.no_transform){e.position=typedArrayToArray(d.position);if(0!=d.rotation[0]||0!=d.rotation[1]||0!=d.rotation[2]||1!=d.rotation[3])e.rotation=typedArrayToArray(d.rotation);if(1!=d.scaling[0]||1!=d.scaling[1]||1!=d.scaling[2])e.scaling=typedArrayToArray(d.scaling)}d.id&&(e.id=d.id);d.ref=e.ref=a++;d.mesh&&(e.mesh=
d.mesh);null!=d.submesh&&(e.submesh=d.submesh);d.draw_range&&(e.draw_range=d.draw_range.concat());d.material&&(e.material=d.material);d.shader&&(e.shader=d.shader);if(1!=d.color[0]||1!=d.color[1]||1!=d.color[2]||1!=d.color[3])e.color=typedArrayToArray(d.color);0<Object.values(d.textures).filter(function(c){return c})&&(e.shader=d.shader);d.extra&&(e.extra=d.extra);e.layers=d.layers;e.flags=d.flags}if(!d.children.length)return!0;for(var n=[],k=0;k<d.children.length;++k){var h={};b(d.children[k],h)&&
n.push(h)}n.length&&(e.children=n);return!0}c&&c.constructor!==Function&&(c=null);var a=0,d={};b(this.root,d);return d};e.default_shader_name="texture";Object.defineProperty(e.prototype,"color",{set:function(c){this._color.set(c)},get:function(){return this._color},enumerable:!0});Object.defineProperty(e.prototype,"opacity",{get:function(){return this._color[3]},set:function(c){this._color[3]=c},enumerable:!0});e.prototype.configure=function(c){for(var b in c)this[b]=c[b]};e.prototype.render=function(c,
a,d,e,n){var k=gl.shaders[this.shader_name||c.default_shader_name||b.Material.default_shader_name];k||(k=this.textures.color||this.textures.albedo?c._texture_shader:c._flat_shader);var h=0,m=null,f;for(f in this.textures){var t=this.textures[f];if(t){t.constructor===Object&&(t=t.texture);var l="u_"+f+"_texture";if(!k||k.samplers[l])m=gl.textures[t],m||(c.autoload_assets&&-1!=t.indexOf(".")&&c.loadTexture(t,c.default_texture_settings),m=gl.textures.white),this.uniforms[l]=m.bind(h++)}}c.enableItemFlags(this);
c._uniforms.u_model.set(a);k.uniforms(c._uniforms);k.uniforms(this.uniforms);a=null;null!=n&&d.info&&d.info.groups&&d.info.groups[n]&&(a=d.info.groups[n]);a?k.drawRange(d,this.primitive,a.start,a.length,e):k.draw(d,this.primitive,e);c.disableItemFlags(this);c.draw_calls+=1};b.Material=e;b.Renderer=h;Object.defineProperty(h.prototype,"color",{set:function(c){this._color.set(c)},get:function(){return this._color},enumerable:!0});h.prototype.setDataFolder=function(c){c?(this.assets_folder=c,"/"!=this.assets_folder.substr(-1)&&
(this.assets_folder+="/")):this.assets_folder=""};h.prototype.clear=function(c){c?this.gl.clearColor(c[0],c[1],c[2],3<=c.length?c[3]:1):this.gl.clearColor(0,0,0,0);this.gl.clear(gl.COLOR_BUFFER_BIT|gl.DEPTH_BUFFER_BIT)};h._sort_by_dist_func=function(c,b){return b._distance-c._distance};h._sort_by_priority_func=function(c,b){return b.render_priority-c.render_priority};h._sort_by_priority_and_dist_func=function(c,b){var a=b.render_priority-c.render_priority;return 0!=a?a:b._distance-c._distance};h.prototype.render=
function(c,a,d,e){void 0===e&&(e=255);if(!c)throw"Renderer.render: scene not provided";if(this._current_scene)throw this._current_scene=null,"Cannot render an scene while rendering an scene";a=a||c.camera;if(!a)throw"Renderer.render: camera not provided";p.gl=this.gl;this._nodes.length=0;d||c._root.getVisibleChildren(this._nodes,e);d=d||this._nodes;if(d.length){this.enableCamera(a);this.enable2DView();this._state=[];this._meshes_missing=0;this._current_scene=c;this._uniforms.u_time=c.time;this.sort_by_distance&&
d.forEach(function(c){c._distance=c.getDistanceTo(a._position)});var n=this;d=d.filter(function(c){return!c.mustRender||!1!=c.mustRender(n,a)});this.sort_by_distance&&this.sort_by_priority?d.sort(b.Renderer._sort_by_priority_and_dist_func):this.sort_by_priority?d.sort(b.Renderer._sort_by_priority_func):this.sort_by_distance&&d.sort(b.Renderer._sort_by_dist_func);if(this.onPreRender)this.onPreRender(a);c._root.preRender&&c._root.preRender(this,a);if(this.pipeline)this.pipeline.render(d,a,c);else{for(var k=
0;k<d.length;++k){var h=d[k];h.updateGlobalMatrix(!0);if(this.onPreRenderNode)this.onPreRenderNode(h,a);h.preRender&&h.preRender(this,a)}for(k=0;k<d.length;++k)h=d[k],h.flags.was_rendered=!1,!1!==h.flags.visible&&h.layers&e&&(!this.mustRenderNode||!1!==this.mustRenderNode(h,a))&&(h.flags.was_rendered=!0,this.setModelMatrix(h._global_matrix),h.render?h.render(this,a):this.renderNode(h,a));c._root.postRender&&c._root.postRender(this,a);for(k=0;k<d.length;++k)if(h=d[k],h.postRender&&h.postRender(this,
a),this.onPostRenderNode)this.onPostRenderNode(h,a)}if(this.onPostRender)this.onPostRender(a);c.frame++;this.frame++;this._current_scene=null}else c.frame++,this.frame++};h.prototype.enableCamera=function(c){this._camera=c;c.updateMatrices();c.extractPlanes();this._view_matrix.set(c._view_matrix);this._projection_matrix.set(c._projection_matrix);this._viewprojection_matrix.set(c._viewprojection_matrix);this._uniforms.u_camera_position=c.position};h.prototype.enable2DView=function(){mat4.ortho(this._viewprojection2D_matrix,
0,gl.viewport_data[2],0,gl.viewport_data[3],-1,1)};h.prototype.saveState=function(){this.state.push({camera:this._camera,nodes:this._nodes})};h.prototype.restoreState=function(){var c=this.state.pop(),b=this.camera=c.camera;this._view_matrix.set(b._view_matrix);this._projection_matrix.set(b._projection_matrix);this._viewprojection_matrix.set(b._viewprojection_matrix);this._uniforms.u_camera_position=b.position;this._nodes=c.nodes};h.prototype.setModelMatrix=function(c){this._model_matrix.set(c);mat4.multiply(this._mvp_matrix,
this._viewprojection_matrix,c)};h.prototype.setGlobalUniforms=function(c){for(var b in c)this._uniforms[b]&&this._uniforms[b].set?this._uniforms[b].set(c[b]):this._uniforms[b]=c[b]};var C={u_model:null};h.prototype.renderNode=function(c,a){var d=null;c._mesh?d=c._mesh:c.mesh&&(d=gl.meshes[c.mesh],d||(this._meshes_missing++,this.autoload_assets&&-1!=c.mesh.indexOf(".")&&this.loadMesh(c.mesh)));if(c.primitives&&c.primitives.length){if(d)for(var e=0;e<c.primitives.length;++e){var n=b.Materials[c.primitives[e].material];
n&&this.renderMeshWithMaterial(c._global_matrix,d,n,"triangles",e)}}else{if(c.material&&(n=b.Materials[c.material])){if(n.render){this.renderMeshWithMaterial(c._global_matrix,d,n,c.indices,c.submesh);return}c.color=n.color}if(d){n=!1;c._instances&&(1<gl.webgl_version||gl.extensions.ANGLE_instanced_arrays)&&(n=!0);var k=null,h=c.shader;this.on_getShader&&(k=this.on_getShader(c,a));!k&&c.shader&&(k=gl.shaders[h]);this.shader_overwrite&&(k=gl.shaders[this.shader_overwrite]);k||(k=c.textures.color?this._texture_shader:
this._flat_shader);n&&!k.attributes.u_model&&(n=!1);var h=0,m=null;for(e in c.textures){var f=c.textures[e];if(f){f.constructor===Object&&(f=f.texture);var t="u_"+e+"_texture";if(!k||k.samplers[t])m=gl.textures[f],m||(this.autoload_assets&&-1!=f.indexOf(".")&&this.loadTexture(f,this.default_texture_settings),m=gl.textures.white),c.flags.pixelated?(m.bind(0),gl.texParameteri(gl.TEXTURE_2D,gl.TEXTURE_MAG_FILTER,gl.NEAREST),gl.texParameteri(gl.TEXTURE_2D,gl.TEXTURE_MIN_FILTER,gl.NEAREST)):!1===c.flags.pixelated&&
(m.bind(0),gl.texParameteri(gl.TEXTURE_2D,gl.TEXTURE_MAG_FILTER,gl.LINEAR),gl.texParameteri(gl.TEXTURE_2D,gl.TEXTURE_MIN_FILTER,gl.LINEAR_MIPMAP_LINEAR)),c._uniforms[t]=m.bind(h++)}}this.ignore_flags||this.enableItemFlags(c);if(c.onRender)c.onRender(this,a,k);k.uniforms(this._uniforms);this.skip_node_uniforms||k.uniforms(c._uniforms);if(c.onShaderUniforms)c.onShaderUniforms(this,k);if(this.onNodeShaderUniforms)this.onNodeShaderUniforms(this,k,c);e=null;null!=c.submesh&&d.info&&d.info.groups&&d.info.groups[c.submesh]&&
(e=d.info.groups[c.submesh]);n?(C.u_model=c._instances,e?k.drawInstanced(d,void 0===c.primitive?gl.TRIANGLES:c.primitive,c.indices,C,e.start,e.length):c.draw_range?k.drawInstanced(d,void 0===c.primitive?gl.TRIANGLES:c.primitive,c.indices,C,c.draw_range[0],c.draw_range[1]):k.drawInstanced(d,void 0===c.primitive?gl.TRIANGLES:c.primitive,c.indices,C)):e?k.drawRange(d,void 0===c.primitive?gl.TRIANGLES:c.primitive,e.start,e.length,c.indices):c.draw_range?k.drawRange(d,void 0===c.primitive?gl.TRIANGLES:
c.primitive,c.draw_range[0],c.draw_range[1],c.indices):k.draw(d,void 0===c.primitive?gl.TRIANGLES:c.primitive,c.indices);this.ignore_flags||this.disableItemFlags(c);this.draw_calls+=1}else if(c.onRender)c.onRender(this,a)}};h.prototype.renderMesh=function(c,a,d,e,n,k,h,m){a&&(e&&this._uniforms.u_color.set(e),c||(c=b.IDENTITY),this._uniforms.u_model.set(c),n||(n=d?gl.shaders.texture:gl.shaders.flat),d&&(this._uniforms.u_texture=d.bind(0)),n.uniforms(this._uniforms),n.draw(a,void 0===k?gl.TRIANGLES:
k,h),this.draw_calls+=1)};h.prototype.renderMeshWithMaterial=function(c,b,a,d,e){a.render&&a.render(this,c,b,d,e)};h.prototype.renderBounding=function(c,b){if(c){var a=this._uniforms.u_model,d=c._bounding,e=d.subarray(3,6);mat4.translate(a,b,d.subarray(0,3));mat4.scale(a,a,[2*e[0],2*e[1],2*e[2]]);this.renderMesh(a,gl.meshes.cube,null,[1,1,0,1],null,gl.LINES,"wireframe")}};h.prototype.enableItemFlags=function(c){var a=c.flags.flip_normals;this.reverse_normals&&(a=!a);gl.frontFace(a?gl.CW:gl.CCW);gl[!1===
c.flags.depth_test?"disable":"enable"](gl.DEPTH_TEST);!1===c.flags.depth_write&&gl.depthMask(!1);gl[!0===c.flags.two_sided?"disable":"enable"](gl.CULL_FACE);if(c.blend_mode!==b.BLEND_NONE)switch(gl.enable(gl.BLEND),c.blend_mode){case b.BLEND_ALPHA:gl.blendFunc(gl.SRC_ALPHA,gl.ONE_MINUS_SRC_ALPHA);break;case b.BLEND_ADD:gl.blendFunc(gl.SRC_ALPHA,gl.ONE);break;case b.BLEND_MULTIPLY:gl.blendFunc(gl.DST_COLOR,gl.ONE_MINUS_SRC_ALPHA)}else gl.disable(gl.BLEND);"BLEND"==c.alphaMode&&(gl.enable(gl.BLEND),
gl.blendFunc(gl.SRC_ALPHA,gl.ONE_MINUS_SRC_ALPHA),gl.depthMask(!1))};h.prototype.disableItemFlags=function(c){c.flags.flip_normals&&gl.frontFace(gl.CCW);!1===c.flags.depth_test&&gl.enable(gl.DEPTH_TEST);c.blend_mode!==b.BLEND_NONE&&gl.disable(gl.BLEND);c.flags.two_sided&&gl.disable(gl.CULL_FACE);!1===c.flags.depth_write&&gl.depthMask(!0);"BLEND"==c.alphaMode&&(gl.depthMask(!0),gl.disable(gl.BLEND))};h.prototype.setPointSize=function(c){this.point_size=c;gl.shaders.point.uniforms({u_pointSize:this.point_size})};
b.Renderer.prototype.renderPoints=function(c,a,d,e,n,k,h){if(!c||c.constructor!==Float32Array)throw"RD.renderPoints only accepts Float32Array";n||(n=this.shaders._points,n||(n=this.shaders._points=new GL.Shader(b.points_vs_shader,b.points_fs_shader),n.uniforms({u_texture:0,u_atlas:1,u_pointSize:1})));k=k||1;var m=1024;e=e||c.length/3;var f=null,t=null,l=this._points_mesh;e>c.length/3&&(e=c.length/3);!l||c.length>3*m?(e>m&&(m=GL.Texture.nextPOT(e)),f=new Float32Array(3*m),t=new Float32Array(4*m),l=
this._points_mesh=GL.Mesh.load({vertices:f,extra4:t})):(f=this._points_mesh.getBuffer("vertices").data,t=this._points_mesh.getBuffer("extra4").data);f.set(f.length>c.length?c:c.subarray(0,f.length));a?t.set(t.length>a.length?a:a.subarray(0,t.length)):t.fill&&t.fill(0);l.upload(GL.DYNAMIC_STREAM);n.setUniform("u_color",this._color);n.setUniform("u_pointSize",k);n.setUniform("u_camera_perspective",d._projection_matrix[5]);n.setUniform("u_viewport",gl.viewport_data);n.setUniform("u_viewprojection",d._viewprojection_matrix);
n.drawRange(l,void 0!==h?h:GL.POINTS,0,e);return l};b.points_vs_shader="\nprecision highp float;\nattribute vec3 a_vertex;\nattribute vec4 a_extra4;\nvarying vec3 v_pos;\nvarying vec4 v_extra4;\nuniform mat4 u_viewprojection;\nuniform vec4 u_viewport;\nuniform float u_camera_perspective;\nuniform float u_pointSize;\n\nfloat computePointSize( float radius, float w )\n{\n\tif(radius < 0.0)\n\t\treturn -radius;\n\treturn u_viewport.w * u_camera_perspective * radius / w;\n}\n\nvoid main() {\n\tv_pos = a_vertex;\n\tv_extra4 = a_extra4;\n\tgl_Position = u_viewprojection * vec4(v_pos,1.0);\n\tgl_PointSize = computePointSize( u_pointSize, gl_Position.w );\n}\n";
b.points_fs_shader="\nprecision highp float;\nuniform vec4 u_color;\n\nvoid main() {\n\tgl_FragColor = u_color;\n}\n";h.prototype.loadMesh=function(c,b){if(!c)return console.error("loadMesh: Cannot load null name");if(!this.assets_loading[c]&&!this.assets_not_found[c]){var a=this.meshes[c];if(a)return b&&b(a),a;var d=this,a=c;-1==a.indexOf("://")&&(a=this.assets_folder+c);a=GL.Mesh.fromURL(a,function(a){a?d.meshes[c]=a:(d.assets_not_found[c]=!0,delete d.meshes[c]);d.num_assets_loading--;delete d.assets_loading[c];
b&&b(a,c)});this.assets_loading[c]=a;this.num_assets_loading++;return this.meshes[c]=a}};h.prototype.loadTexture=function(c,b,a){function d(b){k.debug&&console.log(" + texture loaded: "+c);b?k.textures[e]=b:k.assets_not_found[c]=!0;a&&a(b,e);k.num_assets_loading--;delete k.assets_loading[c];if(k.on_texture_load)k.on_texture_load(b,e)}if(!c)return console.error("loadTexture: Cannot load null name");if(!this.assets_loading[c]&&!this.assets_not_found[c]){var e=c;b&&(b.name&&(e=b.name),b.preview&&(e=
b.preview));var n=this.textures[e];if(n&&!n.is_preview)return a&&a(n),n;var k=this,n=c;-1==n.indexOf("://")&&(n=this.assets_folder+c);var h=null,h=-1!=c.indexOf("CUBEMAP")?GL.Texture.cubemapFromURL(n,this.default_cubemap_settings,d):GL.Texture.fromURL(n,b,d);b&&b.preview&&(h.is_preview=!0);this.assets_loading[c]=h;this.num_assets_loading++;return this.textures[e]=h}};h.prototype.loadTextureAtlas=function(c,b,a){"string"==typeof c&&(c=JSON.parse(c));var d=this;-1==b.indexOf("://")&&(b=this.assets_folder+
b);GL.Texture.fromURL(b,null,function(b){var e=c.files;d.textures[":atlas"]=b;for(var n in e)if(!d.textures[n]||d.textures[n].is_preview){var k=e[n],h=new GL.Texture(c.size,c.size,{wrap:gl.REPEAT,filter:gl.LINEAR});h.drawTo(function(){b.gl.drawTexture(b,0,0,c.size,c.size,k.x,k.y,k.width||c.size,k.height||c.size)});h.is_preview=!0;d.textures[n]=h}a&&a(e)})};h.prototype.loadShaders=function(c,b,a){var d=this;-1==c.indexOf("://")&&(c=this.assets_folder+c);c+="?nocache="+Math.random();this.loading_shaders=
!0;GL.loadFileAtlas(c,function(c){d.compileShadersFromAtlas(c,a);d.loading_shaders=!1;b&&b(c)})};h.prototype.compileShadersFromAtlas=function(c,b){var a=c.shaders;if(a){for(var d in c)c[d]=GL.Shader.expandImports(c[d],c);a=a.split("\n");for(d=0;d<a.length;++d){var e=a[d].trim().split(" "),n=e[0].trim();if("//"!=n.substr(0,2)){var k=c[e[1]],h=c[e[2]],m=null,f={};if(3<e.length)for(var t=3;t<e.length;++t)if("#"==e[t][0])f[e[t].substr(1)]=!0;else{m=e.slice(t).join(" ");break}if(!f.WEBGL1||1==gl.webgl_version)if(!f.WEBGL2||
2==gl.webgl_version){e[1]&&"@"==e[1][0]&&(f=e[1].substr(1)+"_VERTEX_SHADER",GL.Shader[f]&&(k=GL.Shader[f]));e[2]&&"@"==e[2][0]&&(f=e[2].substr(1)+"_FRAGMENT_SHADER",GL.Shader[f]&&(h=GL.Shader[f]));if(m)try{m=JSON.parse(m)}catch(l){console.error("Error in shader macros: ",n,m,l)}if(m&&b){var f={},y;for(y in m)f[y]=m[y];for(y in b)f[y]=b[y];m=f}else b&&(m=b);try{k&&h?this.shaders[n]?this.shaders[n].updateShader(k,h,m):this.shaders[n]=new GL.Shader(k,h,m):console.warn("Shader subfile not found: ",e[1],
e[2])}catch(q){GL.Shader.dumpErrorToConsole(q,k,h)}}}}}else console.warn("No 'shaders' found in shaders file atlas, check documentation")};h.prototype.setShadersFromFile=function(c){c=GL.processFileAtlas(c);this.compileShadersFromAtlas(c)};h.cubemap_info=[{front:[1,0,0],up:[0,-1,0]},{front:[-1,0,0],up:[0,-1,0]},{front:[0,1,0],up:[0,0,1]},{front:[0,-1,0],up:[0,0,-1]},{front:[0,0,1],up:[0,-1,0]},{front:[0,0,-1],up:[0,-1,0]}];h.prototype.renderToCubemap=function(c,a,d,e,n,k,m){var f=h.cubemap_camera;
f||(h.cubemap_camera=f=new b.Camera);f.perspective(90,1,k||0.1,m||1E3);var t=vec3.create(),l=this;c.drawTo(function(c,b){var k=h.cubemap_info[b];vec3.add(t,d,k.front);f.lookAt(d,t,k.up);l.clear();l.render(a,f,e,n)});return c};h.prototype.drawSphere3D=function(c,b,a){gl.meshes.sphere||(gl.meshes.sphere=GL.Mesh.sphere({slices:32}));var d=gl.shaders.flat;d.setUniform("u_color",a);d.setUniform("u_viewprojection",this._viewprojection_matrix);mat4.identity(v);mat4.translate(v,v,c);mat4.scale(v,v,[b,b,b]);
d.setUniform("u_model",v);d.draw(gl.meshes.sphere);this.draw_calls+=1};h.prototype.drawCircle2D=function(c,b,a,d,e){gl.meshes.circle||(gl.meshes.circle=GL.Mesh.circle({radius:1,slices:32}));gl.meshes.ring||(gl.meshes.ring=GL.Mesh.ring({radius:1,thickness:0.02,slices:64}));var n=gl.shaders.flat;n.setUniform("u_color",d);n.setUniform("u_viewprojection",this._viewprojection2D_matrix);mat4.identity(v);mat4.translate(v,v,[c,b,0]);mat4.scale(v,v,[2*a,2*a,2*a]);n.setUniform("u_model",v);n.draw(gl.meshes[e?
"circle":"ring"]);this.draw_calls+=1};h.prototype.drawLine2D=function(c,a,d,e,n,k,h){var m=gl.meshes.plane;h=h||gl.shaders.flat;h.setUniform("u_color",k);h.setUniform("u_viewprojection",this._viewprojection2D_matrix);var f=d-c,t=e-a;k=Math.atan2(f,t);f=Math.sqrt(f*f+t*t);n/=2;mat4.identity(v);mat4.translate(v,v,[0.5*(c+d),0.5*(a+e),0]);mat4.rotate(v,v,k,b.FRONT);c=n;mat4.scale(v,v,[c,f,c]);h.setUniform("u_model",v);h.draw(m);this.draw_calls+=1};b.sortByDistance=function(c,b){c.forEach(function(c){c._distance=
c.getDistanceTo(b)});c.sort(function(c,b){return b._distance-c._distance})};b.noBlending=function(c){return c.blend_mode===b.BLEND_NONE};b.generateTextureAtlas=function(c,b,a,d,e){b=b||1024;a=a||1024;d=d||64;var n=0,k;for(k in c)n++;gl.disable(gl.DEPTH_TEST);gl.disable(gl.CULL_FACE);gl.disable(gl.BLEND);var n=new GL.Texture(b,a),h={width:b,height:a,size:d,files:{}},m=0,f=0,t={};n.drawTo(function(){for(var n in c)if(":"!=n[0]&&"white"!=n&&"black"!=n&&"notfound"!=n){var k=c[n];if(!k.is_preview&&k.texture_type==
gl.TEXTURE_2D){if(e){var l=k.toBase64().hashCode();if(t[l]){h.files[n]=h.files[t[l]];continue}t[l]=n}h.files[n]={x:m,y:f};k.renderQuad(m,f,d,d);m+=d;if(m==b&&(m=0,f+=d,f==a)){console.warn("Atlas too small, some textures wont be stored.");break}}}});n.info=h;console.log(h);return n};h.prototype.computeResourcesLoaded=function(c){var b=0,a;for(a in c){var d=c[a],e=this.textures[d];e&&!1===e.ready||(d=this.meshes[d])&&!1===d.ready||(e||d)&&b++}return b};Object.defineProperty(h.prototype,"meshes",{get:function(){return this.gl.meshes},
set:function(c){},enumerable:!0});Object.defineProperty(h.prototype,"textures",{get:function(){return this.gl.textures},set:function(c){},enumerable:!0});Object.defineProperty(h.prototype,"shaders",{get:function(){return this.gl.shaders},set:function(c){},enumerable:!0});h.prototype.addMesh=function(c,b){b.gl!=this.gl&&(b=b.cloneShared(this.gl));this.gl.meshes[c]=b};b.Renderer=h;b.Ray=q;q.prototype.testPlane=function(c,b){return geo.testRayPlane(this.origin,this.direction,c,b,this.collision_point)};
q.prototype.testSphere=function(c,b,a){return geo.testRaySphere(this.origin,this.direction,c,b,this.collision_point,a)};q.prototype.closestPointOnRay=function(c,b,a){a=a||vec3.create();var d=vec3.create();vec3.add(d,this.origin,this.direction);var e=vec3.create();vec3.add(e,c,b);geo.closestPointBetweenLines(this.origin,d,c,e,null,a);return a};b.Factory=function(c,a,d){c=b.Factory.templates[c];var e=new b.SceneNode;c&&e.configure(c);a&&(a.constructor===b.Scene?a.root:a).addChild(e);d&&e.configure(d);
return e};b.Factory.templates={grid:{mesh:"grid",primitive:1,color:[0.5,0.5,0.5,0.5],blend_mode:b.BLEND_ALPHA},mesh:{shader:"phong"},sphere:{mesh:"sphere",shader:"phong"},floor:{mesh:"planeXZ",scaling:10,shader:"phong"}};l.prototype._ctor=function(){a.prototype._ctor.call(this);this.vertices=[];this.normals=[];this.coords=[];this.indices=[];this._vertices_data=new Float32Array(3072);this._indices_data=this._coords_data=this._normals_data=null;this._total_indices=this._total=0;this._mesh=GL.Mesh.load({vertices:this._vertices_data})};
l.prototype.updateVertices=function(c){c&&(this.vertices=c);this._total=this.vertices.length;this._vertices_data.length<this.vertices.length&&(this._vertices_data=new Float32Array(2*this.vertices.length),this._mesh.getBuffer("vertices").data=this._vertices_data);this._vertices_data.set(this.vertices);this._mesh.getBuffer("vertices").upload(GL.STREAM_DRAW)};l.prototype.updateNormals=function(c){c&&(this.normals=c);if(!this._normals_data||this._normals_data.length<this.normals.length)this._normals_data=
new Float32Array(2*this.normals.length),this._mesh.getBuffer("normals")||this._mesh.createVertexBuffer("normals",null,3,this._normals_data,GL.STREAM_DRAW);this._normals_data.set(this.normals);this._mesh.getBuffer("normals").upload(GL.STREAM_DRAW)};l.prototype.updateCoords=function(c){c&&(this.coords=c);if(!this._coords_data||this._coords_data.length<this.normals.length)this._coords_data=new Float32Array(2*this.coords.length),this._mesh.getBuffer("coords")||this._mesh.createVertexBuffer("coords",null,
2,this._coords_data,GL.STREAM_DRAW);this._coords_data.set(this.coords);this._mesh.getBuffer("coords").upload(GL.STREAM_DRAW)};l.prototype.updateIndices=function(c){c&&(this.indices=c);if(!this._indices_data||this._indices_data.length<this.indices.length)this._indices_data=new Float32Array(2*this.indices.length),this._mesh.getIndexBuffer("triangles")||this._mesh.createIndicesBuffer("triangles",this._indices_data,GL.STREAM_DRAW);this._indices_data.set(this.indices);this._mesh.getIndexBuffer("triangles").upload(GL.STREAM_DRAW);
this._total_indices=c.length};l.prototype.render=function(c,b){if(this._total){var a=c.shaders[this.shader||"flat"];if(a){c.setModelMatrix(this._global_matrix);var d=this._mesh,e=this._total_indices?this._total_indices:this._total/3;c.enableItemFlags(this);a.uniforms(c._uniforms).uniforms(this._uniforms).drawRange(d,void 0===this.primitive?GL.TRIANGLES:this.primitive,0,e,this._total_indices?"triangles":null);c.disableItemFlags(this)}}};extendClass(l,a);b.DynamicMeshNode=l;s.prototype._ctor=function(){a.prototype._ctor.call(this);
this.mesh="plane";this.size=vec2.fromValues(0,0);this.sprite_pivot=b.TOP_LEFT;this.blend_mode=b.BLEND_ALPHA;this.flags.two_sided=!0;this.flags.flipX=!1;this.flags.flipY=!1;this.flags.pixelated=!1;this.shader="texture_transform";this._angle=0;this.frame=null;this.frames={};this.texture_matrix=mat3.create();this._uniforms.u_texture_matrix=this.texture_matrix};Object.defineProperty(s.prototype,"angle",{get:function(){return this._angle},set:function(c){this._angle=c;quat.setAxisAngle(this._rotation,
b.FRONT,this._angle*n);this._must_update_matrix=!0},enumerable:!0});s.prototype.setSize=function(c,b){this.size[0]=c;this.size[1]=b};s.createFrames=function(c,b,a){a=a||{};var d;c.constructor!=Number?(num_columns=c[0],d=c[1]):d=num_columns=c;var e=c=0,n=1/num_columns,k=1/d;d*=num_columns;if(!b){b=[];for(var h=0;h<d;++h)b.push(String(h))}for(h=0;h<b.length&&!(a[b[h]]={pos:[c,e],size:[n,k],normalized:!0},c+=n,1<=c&&(c=0,e+=k),1<=e);++h);return a};s.prototype.createFrames=function(b,a){s.createFrames(b,
a,this.frames)};s.prototype.addFrame=function(b,a,d,e,n,k){this.frames[b]={pos:vec2.fromValues(a,d),size:vec2.fromValues(e,n),normalized:!!k}};s.prototype.updateTextureMatrix=function(b){mat3.identity(this.texture_matrix);if(!this.texture)return!1;var a=b.textures[this.texture];if(!a&&b.autoload_assets){var d=this;-1!=this.texture.indexOf(".")&&b.loadTexture(this.texture,b.default_texture_settings,function(b){b&&0==d.size[0]&&0==d.size[0]&&d.setSize(b.width,b.height)});a=gl.textures.white}if(!a)return!1;
b=this.texture_matrix;var e=this.current_frame=this.frames[this.frame];if(null!==this.frame&&!e)return!1;if(!e)return this.flags.flipX&&(w[0]=this.flags.flipX?1:0,w[1]=0,mat3.translate(b,b,w),w[0]=this.flags.flipX?-1:1,w[1]=1,mat3.scale(b,b,w)),!0;if(e.normalized)w[0]=this.flags.flipX?e.pos[0]+e.size[0]:e.pos[0],w[1]=1-e.pos[1]-e.size[1],mat3.translate(b,b,w),w[0]=e.size[0]*(this.flags.flipX?-1:1),w[1]=e.size[1];else{var n=a.height;w[0]=(this.flags.flipX?e.pos[0]+e.size[0]:e.pos[0])/a.width;w[1]=
(n-e.pos[1]-e.size[1])/n;mat3.translate(b,b,w);w[0]=e.size[0]*(this.flags.flipX?-1:1)/a.width;w[1]=e.size[1]/a.height}mat3.scale(b,b,w);return!0};s.prototype.render=function(c,a){if(this.texture&&this.updateTextureMatrix(c)){var d=c.textures[this.texture];if(d){this.flags.pixelated&&(d.bind(0),gl.texParameteri(gl.TEXTURE_2D,gl.TEXTURE_MAG_FILTER,this.flags.pixelated?gl.NEAREST:gl.LINEAR),gl.texParameteri(gl.TEXTURE_2D,gl.TEXTURE_MIN_FILTER,this.flags.pixelated?gl.NEAREST_MIPMAP_NEAREST:gl.LINEAR_MIPMAP_LINEAR));
this.billboard_mode&&b.orientNodeToCamera(this.billboard_mode,this,a,c);0==this.size[0]&&!1!==d.ready&&(this.size[0]=d.width);0==this.size[1]&&!1!==d.ready&&(this.size[1]=d.height);var d=this.size,e=0,n=0;v.set(this._global_matrix);var k=!1;this.current_frame&&this.current_frame.size&&(d=this.current_frame.size,k=this.current_frame.normalized);if(this.sprite_pivot){switch(this.sprite_pivot){case b.TOP_LEFT:e=0.5;n=-0.5;break;case b.TOP_CENTER:n=-0.5;break;case b.TOP_RIGHT:e=-0.5;break;case b.BOTTOM_LEFT:n=
e=0.5;break;case b.BOTTOM_CENTER:n=0.5;break;case b.BOTTOM_RIGHT:e=-0.5,n=0.5}mat4.translate(v,v,[e*d[0],n*d[1],0])}mat4.scale(v,v,[d[0]*(k?this.size[0]:1),d[1]*(k?this.size[1]:1),1]);c.setModelMatrix(v);c.renderNode(this,c,a)}}};extendClass(s,a);b.Sprite=s;k.prototype._ctor=function(){this.mesh="cube";this.shader="skybox";this.scaling=[10,10,10];this.flags.depth_test=!1;this.flags.two_sided=!0};k.prototype.render=function(b,a){this.position=a.position;this.updateGlobalMatrix(!0);b.setModelMatrix(this._global_matrix);
b.renderNode(this,a)};extendClass(k,a);b.Skybox=k;b.parseTextConfig=function(b){function a(b,c){for(var e=d.shift();e;)if(0==e.trim().length)e=d.shift();else{for(var n=0;"\t"==e[n]&&n<e.length;)n++;if(n<c)break;var k={children:[]};try{var h=e.trim();-1!=h.indexOf(":")&&(h="{"+h+"}");var m=new Function("return "+h);k.data=m()}catch(f){console.error(f)}n>=c&&(b&&b.children.push(k),e=a(k,n+1))}return e}var d=b.split("\n");b={data:"",children:[]};a(b,0);return b};h.prototype.createShaders=function(){var c=
this._vertex_shader="\t\t\t\tprecision highp float;\n\t\t\t\tattribute vec3 a_vertex;\n\t\t\t\tattribute vec3 a_normal;\n\t\t\t\tattribute vec2 a_coord;\n\t\t\t\tvarying vec3 v_pos;\n\t\t\t\tvarying vec3 v_normal;\n\t\t\t\tvarying vec2 v_coord;\n\t\t\t\t#ifdef INSTANCING\n\t\t\t\t\tattribute mat4 u_model;\n\t\t\t\t#else\n\t\t\t\t\tuniform mat4 u_model;\n\t\t\t\t#endif\n\t\t\t\tuniform mat4 u_viewprojection;\n\t\t\t\tvoid main() {\n\t\t\t\t\tv_pos = (u_model * vec4(a_vertex,1.0)).xyz;\n\t\t\t\t\tv_normal = (u_model * vec4(a_normal,0.0)).xyz;\n\t\t\t\t\tv_coord = a_coord;\n\t\t\t\t\tgl_Position = u_viewprojection * vec4( v_pos , 1.0 );\n\t\t\t\t\tgl_PointSize = 2.0;\n\t\t\t\t}\t\t\t\t",
a="\t\t\t\tprecision highp float;\t\t\t\tuniform vec4 u_color;\t\t\t\tvoid main() {\t\t\t\t  gl_FragColor = u_color;\t\t\t\t}\t";gl.shaders.flat=this._flat_shader=new GL.Shader(c,a);gl.shaders.flat_instancing=this._flat_instancing_shader=new GL.Shader(c,a,{INSTANCING:""});this._point_shader=new GL.Shader("\t\t\t\tprecision highp float;\t\t\t\tattribute vec3 a_vertex;\t\t\t\tuniform mat4 u_mvp;\t\t\t\tuniform float u_pointSize;\t\t\t\tvoid main() {\t\t\t\t\tgl_PointSize = u_pointSize;\t\t\t\t\tgl_Position = u_mvp * vec4(a_vertex,1.0);\t\t\t\t}\t\t\t\t",
"\t\t\t\tprecision highp float;\t\t\t\tuniform vec4 u_color;\t\t\t\tvoid main() {\t\t\t\t  if( distance( gl_PointCoord, vec2(0.5)) > 0.5)\t\t\t\t     discard;\t\t\t\t  gl_FragColor = u_color;\t\t\t\t}\t\t\t");gl.shaders.point=this._point_shader;this._color_shader=new GL.Shader("\t\tprecision highp float;\t\tattribute vec3 a_vertex;\t\tattribute vec4 a_color;\t\tvarying vec4 v_color;\t\tuniform vec4 u_color;\t\tuniform mat4 u_mvp;\t\tvoid main() {\t\t\tv_color = a_color * u_color;\t\t\tgl_Position = u_mvp * vec4(a_vertex,1.0);\t\t\tgl_PointSize = 5.0;\t\t}\t\t",
"\t\tprecision highp float;\t\tvarying vec4 v_color;\t\tvoid main() {\t\t  gl_FragColor = v_color;\t\t}\t");gl.shaders.color=this._color_shader;a="\t\tprecision highp float;\t\tvarying vec2 v_coord;\t\tuniform vec4 u_color;\t\tuniform sampler2D u_color_texture;\t\tuniform float u_global_alpha_clip;\t\tvoid main() {\t\t\tvec4 color = u_color * texture2D(u_color_texture, v_coord);\n\t\t\tif(color.w < u_global_alpha_clip)\n\t\t\t\tdiscard;\n\t\t\tgl_FragColor = color;\t\t}\t";gl.shaders.texture=this._texture_shader=
new GL.Shader(c,a);gl.shaders.texture_instancing=this._texture_instancing_shader=new GL.Shader(c,a,{INSTANCING:""});this._texture_transform_shader=new GL.Shader("\t\tprecision highp float;\n\t\tattribute vec3 a_vertex;\n\t\tattribute vec2 a_coord;\n\t\tvarying vec2 v_coord;\n\t\tuniform mat4 u_mvp;\n\t\tuniform mat3 u_texture_matrix;\n\t\tvoid main() {\n\t\t\tv_coord = (u_texture_matrix * vec3(a_coord,1.0)).xy;\n\t\t\tgl_Position = u_mvp * vec4(a_vertex,1.0);\n\t\t\tgl_PointSize = 5.0;\n\t\t}\n\t\t",
"\n\t\tprecision highp float;\n\t\tvarying vec2 v_coord;\n\t\tuniform vec4 u_color;\n\t\tuniform float u_global_alpha_clip;\n\t\tuniform sampler2D u_color_texture;\n\t\tvoid main() {\n\t\t\tvec4 color = u_color * texture2D(u_color_texture, v_coord);\n\t\t\tif(color.w < u_global_alpha_clip)\n\t\t\t\tdiscard;\n\t\t\tgl_FragColor = color;\n\t\t}\t");gl.shaders.texture_transform=this._texture_transform_shader;this._phong_uniforms={u_ambient:vec3.create(),u_light_vector:vec3.fromValues(0.5442,0.6385,0.544),
u_light_color:b.WHITE};a=this._fragment_shader="\t\t\tprecision highp float;\n\t\t\tvarying vec3 v_normal;\n\t\t\tvarying vec2 v_coord;\n\t\t\tuniform vec3 u_ambient;\n\t\t\tuniform vec3 u_light_color;\n\t\t\tuniform vec3 u_light_vector;\n\t\t\tuniform vec4 u_color;\n\t\t\t#ifdef TEXTURED\n\t\t\t\tuniform sampler2D u_color_texture;\n\t\t\t#endif\n\t\t\t#ifdef UNIFORMS\n\t\t\t\tUNIFORMS\n\t\t\t#endif\n\t\t\tvoid main() {\n\t\t\t\tvec4 color = u_color;\n\t\t\t\t#ifdef TEXTURED\n\t\t\t\t\tcolor *= texture2D( u_color_texture, v_coord );\n\t\t\t\t#endif\n\t\t\t\tvec3 N = normalize(v_normal);\n\t\t\t\tfloat NdotL = max(0.0, dot(u_light_vector,N));\n\t\t\t\t#ifdef EXTRA\n\t\t\t\t\tEXTRA\n\t\t\t\t#endif\n\t\t\t\tgl_FragColor = color * (vec4(u_ambient,1.0) + NdotL * vec4(u_light_color,1.0));\n\t\t\t}\t";
gl.shaders.phong=this._phong_shader=new GL.Shader(c,a);this._phong_shader._uniforms=this._phong_uniforms;this._phong_shader.uniforms(this._phong_uniforms);gl.shaders.phong_instancing=this._phong_instancing_shader=new GL.Shader(c,a,{INSTANCING:""});this._phong_instancing_shader._uniforms=this._phong_uniforms;this._phong_instancing_shader.uniforms(this._phong_uniforms);gl.shaders.textured_phong=this._textured_phong_shader=new GL.Shader(c,a,{TEXTURED:""});this._textured_phong_shader.uniforms(this._phong_uniforms);
gl.shaders.textured_phong_instancing=this._textured_phong_instancing_shader=new GL.Shader(c,a,{INSTANCING:"",TEXTURED:""});this._textured_phong_instancing_shader.uniforms(this._phong_uniforms);gl.shaders.normal=this._normal_shader=new GL.Shader(c,"\t\t\tprecision highp float;\n\t\t\tvarying vec3 v_normal;\n\t\t\tvoid main() {\n\t\t\t\tgl_FragColor = vec4( normalize(v_normal),1.0);\n\t\t\t}\t");gl.shaders.uvs=this._uvs_shader=new GL.Shader(c,"\t\t\tprecision highp float;\n\t\t\tvarying vec2 v_coord;\n\t\t\tvoid main() {\n\t\t\t\tgl_FragColor = vec4(v_coord,0.0,1.0);\n\t\t\t}\t")};
b.orientNodeToCamera=function(c,a,d,e){if(c){if(c==b.BILLBOARD_CYLINDRIC||c==b.BILLBOARD_PARALLEL_CYLINDRIC){var n=null;c==b.BILLBOARD_CYLINDRIC?(n=a.getGlobalPosition(z),vec3.sub(u,d._position,n),w[0]=u[0],w[1]=u[2]):(w[0]=d._front[0],w[1]=d._front[2]);c=vec2.computeSignedAngle(w,b.FRONT2D);isNaN(c)||(mat4.rotateY(v,t,-c),a._global_matrix.set(v),mat4.setTranslation(a._global_matrix,a._position),mat4.scale(a._global_matrix,a._global_matrix,a._scale))}else c==b.BILLBOARD_PARALLEL_SPHERIC?(a._global_matrix.set(d._model_matrix),
mat4.setTranslation(a._global_matrix,a._position)):(mat4.lookAt(a._global_matrix,a._position,d.position,b.UP),mat4.invert(a._global_matrix,a._global_matrix)),mat4.scale(a._global_matrix,a._global_matrix,a._scale);e.setModelMatrix(a._global_matrix)}};b.readPixels=function(b,a){var d=new Image;d.src=b;d.onload=function(){var b=document.createElement("canvas");b.width=this.width;b.height=this.height;var c=b.getContext("2d");c.drawImage(this,0,0);b=c.getImageData(0,0,b.width,b.height);a(b,this)}};"undefined"==
typeof GL&&(mat4.rotateVec3=function(b,a,d){var e=d[0],n=d[1];d=d[2];b[0]=a[0]*e+a[4]*n+a[8]*d;b[1]=a[1]*e+a[5]*n+a[9]*d;b[2]=a[2]*e+a[6]*n+a[10]*d;return b},mat4.projectVec3=function(b,a,d){var e=d[0],n=d[1];d=d[2];var k=a[1]*e+a[5]*n+a[9]*d+a[13],h=a[2]*e+a[6]*n+a[10]*d+a[14],m=a[3]*e+a[7]*n+a[11]*d+a[15];b[0]=((a[0]*e+a[4]*n+a[8]*d+a[12])/m+1)/2;b[1]=(k/m+1)/2;b[2]=(h/m+1)/2;return b})})("undefined"!=typeof window?window:"undefined"!=typeof self?self:global);
(function(p){function a(){this._ctor();this.points=[];this.max_points=1E3;this.draw_range=[0,3*this.max_points];this.shader="pointcloud";this.textures={color:"white"};this.blend_mode=RD.BLEND_ALPHA;this.flags.depth_write=!1;this.render_priority=RD.PRIORITY_ALPHA;this.num_textures=1;this.points_size=100;this._uniforms={u_pointSize:this.points_size,u_texture_info:vec2.fromValues(1,1)};this.primitive=gl.POINTS;this._vertices=new Float32Array(3*this.max_points);this._extra=new Float32Array(3*this.max_points);
this._meshes={};this._last_point_id=this._accumulated_time=0}function f(){this._ctor();this.particles=[];this.max_particles=1E3;this.draw_range=[0,3*this.max_particles];this.shader="particles";this.textures={color:"white"};this.blend_mode=RD.BLEND_ALPHA;this.flags.depth_write=!1;this.render_priority=RD.PRIORITY_ALPHA;this.num_textures=1;this.particles_size=100;this.particles_life=this.particles_per_second=5;this.particles_damping=0.5;this.particles_acceleration=vec3.create();this.velocity_variation=
this.particles_end_scale=this.particles_start_scale=1;this.emissor_direction=vec3.fromValues(0,1,0);this._uniforms={u_pointSize:this.particle_size,u_scaleStartEnd:vec2.fromValues(1,1),u_texture_info:vec2.fromValues(1,1)};this.primitive=gl.POINTS;this._vertices=new Float32Array(3*this.max_particles);this._extra=new Float32Array(3*this.max_particles);this._meshes={};this._last_particle_id=this._accumulated_time=0}function g(){this._ctor()}function e(a){this._ctor();a&&this.configure(a)}extendClass(a,
RD.SceneNode);RD.PointCloud=a;a.prototype.render=function(e,f){if(0!=this.points.length){this.updateVertices();var l=this._meshes[e.gl.context_id];l||(l=new GL.Mesh(void 0,void 0,e.gl),this._vertices_buffer=l.createVertexBuffer("vertices",null,3,this._vertices,gl.DYNAMIC_DRAW),this._extra_buffer=l.createVertexBuffer("extra3",null,3,this._extra,gl.DYNAMIC_DRAW));this._mesh=l;this._vertices_buffer.uploadRange(0,12*this.points.length);this._extra_buffer.uploadRange(0,12*this.points.length);l=gl.shaders[this.shader];
l||(l=gl.shaders.pointcloud)||(gl.shaders.pointcloud=new GL.Shader(a._vertex_shader,a._pixel_shader));this.draw_range[1]=this.points.length;l=gl.getViewport();this._uniforms.u_pointSize=this.points_size/(gl.canvas.width/l[2]);this._uniforms.u_color=this.color;0<this.num_textures?(this._uniforms.u_texture_info[0]=1/this.num_textures,this._uniforms.u_texture_info[1]=this.num_textures*this.num_textures):this._uniforms.u_texture_info[0]=0;this.ignore_transform&&(mat4.identity(e._model_matrix),e._mvp_matrix.set(e._viewprojection_matrix));
e.renderNode(this,e,f)}};a.prototype.updateVertices=function(a){if(a=this.points.length)for(var e=this._vertices,f=this._extra,g=0,k=this.num_textures*this.num_textures,d=0;d<a;d++){var m=this.points[d];e.set(m.pos?m.pos:m,g);f[g]=1;f[g+1]=1;1<k&&(f[g+2]=m.tex);g+=3}};a._vertex_shader="\t\t\tprecision highp float;\t\t\tattribute vec3 a_vertex;\t\t\tattribute vec3 a_extra3;\t\t\tvarying vec2 v_coord;\t\t\tvarying vec4 v_color;\t\t\tvarying vec3 v_position;\t\t\tuniform vec3 u_camera_position;\t\t\tuniform mat4 u_mvp;\t\t\tuniform mat4 u_model;\t\t\tuniform vec4 u_color;\t\t\tuniform float u_pointSize;\t\t\tuniform vec2 u_texture_info;\t\t\tvoid main() {\n\t\t\t\tv_color = u_color;\n\t\t\t\tv_color.a *= a_extra3.y;\n\t\t\t\tv_coord.x = (a_extra3.z * u_texture_info.y) * u_texture_info.x;\n\t\t\t\tv_coord.y = abs(floor(v_coord.x) * u_texture_info.x);\n\t\t\t\tv_coord.x = fract(v_coord.x);\n\t\t\t\tgl_Position = u_mvp * vec4(a_vertex,1.0);\n\t\t\t\tv_position = (u_model * vec4(a_vertex,1.0)).xyz;\n\t\t\t\tfloat dist = distance( u_camera_position, v_position );\n\t\t\t\tgl_PointSize = 10.0 * u_pointSize / dist;\n\t\t\t}\t\t\t";
a._pixel_shader="\t\t\tprecision highp float;\t\t\tvarying vec4 v_color;\t\t\tvarying vec2 v_coord;\t\t\tvarying vec3 v_position;\t\t\tuniform sampler2D u_color_texture;\t\t\tuniform vec2 u_texture_info;\t\t\tvoid main() {\t\t\t  vec2 uv = vec2(v_coord.x + gl_PointCoord.x * u_texture_info.x, v_coord.y + (1.0 - gl_PointCoord.y) * u_texture_info.x );\n\t\t\t  vec4 color = texture2D( u_color_texture, uv );\n\t\t\t  color.xyz *= v_color.xyz;\n\t\t\t  #ifdef USE_PROCESS_COLOR\n\t\t\t\tUSE_PROCESS_COLOR\n\t\t\t  #endif\n\t\t\t  gl_FragColor = vec4( color.xyz, color.a * v_color.a );\n\t\t\t}\t\t";
extendClass(f,RD.SceneNode);RD.ParticlesEmissor=f;f.prototype.update=function(a){var e=this.particles.length,f=this.particles_damping,g=this.particles_acceleration,k=vec3.length(g);if(e){for(var d=[],m=0;m<e;m++){var b=this.particles[m];vec3.scaleAndAdd(b.pos,b.pos,b.vel,a);k&&vec3.scaleAndAdd(b.vel,b.vel,g,a);f&&vec3.scaleAndAdd(b.vel,b.vel,b.vel,-a*f);b.ttl-=a;0<b.ttl&&d.push(b)}this.particles=d}e=this.getGlobalPosition();f=this.emissor_direction;g=this.particles_life;k=this.num_textures*this.num_textures;
d=this.velocity_variation;if(0<this.particles_per_second)for(a=this.particles_per_second*(a+this._accumulated_time),this._accumulated_time=(a-Math.floor(a))/this.particles_per_second,a=Math.floor(a),m=0;m<a&&!(this.particles.length>=this.max_particles);m++)f=vec3.clone(f),f[0]+=0.5*Math.random()*d,f[2]+=0.5*Math.random()*d,this.particles.push({id:this._last_particle_id++,tex:Math.floor(Math.random()*k)/k,pos:vec3.clone(e),vel:f,ttl:g})};f.prototype.render=function(a,e){if(0!=this.particles.length){this.updateVertices();
var l=this._meshes[a.gl.context_id];l||(l=new GL.Mesh(void 0,void 0,a.gl),this._vertices_buffer=l.createVertexBuffer("vertices",null,3,this._vertices,gl.DYNAMIC_DRAW),this._extra_buffer=l.createVertexBuffer("extra3",null,3,this._extra,gl.DYNAMIC_DRAW));this._mesh=l;this._vertices_buffer.uploadRange(0,12*this.particles.length);this._extra_buffer.uploadRange(0,12*this.particles.length);l=gl.shaders[this.shader];l||(l=gl.shaders.particles)||(gl.shaders.particles=new GL.Shader(f._vertex_shader,f._pixel_shader));
this.draw_range[1]=this.particles.length;l=gl.getViewport();this._uniforms.u_pointSize=this.particles_size/(gl.canvas.width/l[2]);this._uniforms.u_color=this.color;this._uniforms.u_texture_info[0]=1/this.num_textures;this._uniforms.u_texture_info[1]=this.num_textures*this.num_textures;this._uniforms.u_scaleStartEnd[0]=this.particles_start_scale;this._uniforms.u_scaleStartEnd[1]=this.particles_end_scale;mat4.identity(a._model_matrix);a._mvp_matrix.set(a._viewprojection_matrix);a.renderNode(this,a,
e)}};f.prototype.updateVertices=function(a){if(a=this.particles.length)for(var e=this._vertices,f=this._extra,g=0,k=this.particles_life,d=this.num_textures*this.num_textures,m=0;m<a;m++){var b=this.particles[m];e.set(b.pos,g);f[g]=1;f[g+1]=b.ttl/k;1<d&&(f[g+2]=b.tex);g+=3}};f._vertex_shader="\t\t\tprecision highp float;\t\t\tattribute vec3 a_vertex;\t\t\tattribute vec3 a_extra3;\t\t\tvarying vec2 v_coord;\t\t\tvarying vec4 v_color;\t\t\tvarying vec3 v_position;\t\t\tuniform vec3 u_camera_position;\t\t\tuniform mat4 u_mvp;\t\t\tuniform mat4 u_model;\t\t\tuniform vec4 u_color;\t\t\tuniform float u_pointSize;\t\t\tuniform vec2 u_texture_info;\t\t\tuniform vec2 u_scaleStartEnd;\t\t\tvoid main() {\n\t\t\t\tv_color = u_color;\n\t\t\t\tv_color.a *= a_extra3.y;\n\t\t\t\tv_coord.x = (a_extra3.z * u_texture_info.y) * u_texture_info.x;\n\t\t\t\tv_coord.y = floor(v_coord.x) * u_texture_info.x;\n\t\t\t\tv_coord.x = fract(v_coord.x);\n\t\t\t\tgl_Position = u_mvp * vec4(a_vertex,1.0);\n\t\t\t\tv_position = (u_model * vec4(a_vertex,1.0)).xyz;\n\t\t\t\tfloat dist = distance( u_camera_position, v_position );\n\t\t\t\tgl_PointSize = mix(u_scaleStartEnd.y, u_scaleStartEnd.x, a_extra3.y) * 10.0 * u_pointSize / dist;\n\t\t\t}\t\t\t";
f._pixel_shader="\t\t\tprecision highp float;\t\t\tvarying vec4 v_color;\t\t\tvarying vec2 v_coord;\t\t\tvarying vec3 v_position;\t\t\tuniform sampler2D u_color_texture;\t\t\tuniform vec2 u_texture_info;\t\t\tvoid main() {\t\t\t  vec4 color = texture2D( u_color_texture, v_coord + vec2(gl_PointCoord.x,1.0 - gl_PointCoord.y) * u_texture_info.x );\n\t\t\t  color.xyz *= v_color.xyz;\n\t\t\t  #ifdef USE_PROCESS_COLOR\n\t\t\t\tUSE_PROCESS_COLOR\n\t\t\t  #endif\n\t\t\t  gl_FragColor = vec4( color.xyz, color.a * v_color.a );\n\t\t\t}\t\t";
extendClass(g,RD.SceneNode);RD.Billboard=g;g.SPHERIC=1;g.PARALLEL_SPHERIC=2;g.CYLINDRIC=3;g.PARALLEL_CYLINDRIC=4;g.prototype._ctor=function(){this.billboard_mode=g.SPHERIC;this.auto_orient=!0;RD.SceneNode.prototype._ctor.call(this)};g.prototype.render=function(a,e){!1!==this.flags.visible&&(this.auto_orient&&RD.orientNodeToCamera(this.billboard_mode,this,e,a),a.renderNode(this,a,e))};e.prototype._ctor=function(){RD.SceneNode.prototype._ctor.call(this);this.size=1;this._atlas_size=vec2.fromValues(1,
1);this.max_sprites=1024;this.positions=new Float32Array(3*this.max_sprites);this.sprite_info=new Float32Array(4*this.max_sprites);this.index=0;this.shader=null;this.use_points=!1;this.mode=e.CYLINDRICAL;this.must_update_buffers=!0};RD.SpritesBatch=e;e.XY=0;e.XZ=1;e.CYLINDRICAL=2;e.SPHERICAL=3;e.FLAT=4;Object.defineProperty(e.prototype,"atlas_size",{get:function(){return this._atlas_size},set:function(a){this._atlas_size.set(a)}});e.prototype.clear=function(){this.index=0};e.prototype.add=function(a,
e,f,g,k){if(this.max_sprites<=this.index)console.warn("too many sprites in batch, increase size");else{var d=this.index;this.index+=1;this.positions.set(a,3*d);2==a.length&&(this.positions[3*d+2]=0);a=4*d;this.sprite_info[a]=e||0;this.sprite_info[a+1]=f?1:0;this.sprite_info[a+2]=null==g?1:g;this.sprite_info[a+3]=k||0;this.must_update_buffers=!0}};e.prototype.addData=function(a,e){if(this.max_sprites<=this.index)console.warn("too many sprites in batch, increase size");else{var f=this.index;this.index+=
1;this.positions.set(a,3*f);this.sprite_info.set(e,4*f);this.must_update_buffers=!0}};e.prototype.render=function(a,e){if(this.texture){var f=a.textures[this.texture];f&&this.flags.pixelated&&(f.bind(0),gl.texParameteri(gl.TEXTURE_2D,gl.TEXTURE_MAG_FILTER,this.flags.pixelated?gl.NEAREST:gl.LINEAR),gl.texParameteri(gl.TEXTURE_2D,gl.TEXTURE_MIN_FILTER,this.flags.pixelated?gl.NEAREST_MIPMAP_NEAREST:gl.LINEAR_MIPMAP_LINEAR));this.renderSprites(f,e,this.size,this.atlas_size,this.color,this.mode)}};e.prototype.renderSprites=
function(a,f,l,g,k,d){if(this.index){var m=gl.shaders[this.shader];m||(m=gl.shaders[this.use_points?"point_sprites":"quad_sprites"]);m||(m=this.use_points?gl.shaders.point_sprites=new GL.Shader(e.point_sprites_vertex_shader,e.point_sprites_fragment_shader):gl.shaders.quad_sprites=new GL.Shader(e.quad_sprites_vertex_shader,e.quad_sprites_fragment_shader));d=d||0;if(this.use_points)m.uniforms(GFX.scene_renderer._uniforms),m.setUniform("u_pointSize",l),m.setUniform("u_atlas",g),m.setUniform("u_texture",
a.bind(0)),RD.renderPoints(this.positions,this.sprite_info,f,this.index,m);else{if(!this.vertex_buffer_data){this.vertex_buffer_data=new Float32Array(12*this.max_sprites);this.extra4_buffer_data=new Float32Array(16*this.max_sprites);for(var b=new Int8Array(8*this.max_sprites),n=new Int8Array([-1,1,1,1,-1,-1,1,-1]),y=0;y<b.length;y+=8)b.set(n,y);for(var n=new Int16Array([0,2,1,1,2,3]),t=new Uint16Array(6*this.max_sprites),y=0;y<t.length;++y)t[y]=n[y%6]+4*Math.floor(y/6);this.vertex_buffer=new GL.Buffer(gl.ARRAY_BUFFER,
this.vertex_buffer_data,3,gl.DYNAMIC_DRAW);this.extra4_buffer=new GL.Buffer(gl.ARRAY_BUFFER,this.extra4_buffer_data,4,gl.DYNAMIC_DRAW);this.extra2_buffer=new GL.Buffer(gl.ARRAY_BUFFER,b,2,gl.STATIC_DRAW);this.indices_buffer=new GL.Buffer(gl.ELEMENT_ARRAY_BUFFER,t,1,gl.STATIC_DRAW)}if(this.must_update_buffers){b=this.vertex_buffer_data;n=this.extra4_buffer_data;t=Math.min(this.index,this.positions.length/3);for(y=0;y<t;++y){var B=3*y,v=this.positions.subarray(B,B+3);b.set(v,4*B);b.set(v,4*B+3);b.set(v,
4*B+6);b.set(v,4*B+9);B=4*y;v=this.sprite_info.subarray(B,B+4);n.set(v,4*B);n.set(v,4*B+4);n.set(v,4*B+8);n.set(v,4*B+12)}this.vertex_buffer.uploadRange(0,48*this.index);this.extra4_buffer.uploadRange(0,64*this.index);this.must_update_buffers=!1}g=a.width/g[0]/(a.height/g[1]);y=RD.UP;b=RD.RIGHT;switch(d){case RD.SpritesBatch.SPHERICAL:y=f.getLocalVector(RD.UP);case RD.SpritesBatch.CYLINDRICAL:b=f.getLocalVector(RD.RIGHT);break;case RD.SpritesBatch.FLAT:y=f.getLocalVector(RD.FRONT);b=f.getLocalVector(RD.RIGHT);
break;case RD.SpritesBatch.XZ:y=RD.FRONT}m.bind();m.setUniform("u_model",RD.IDENTITY);m.setUniform("u_viewprojection",f._viewprojection_matrix);m.setUniform("u_color",k||RD.ONES4);m.setUniform("u_size",[l,l/g]);m.setUniform("u_top",y);m.setUniform("u_right",b);m.setUniform("u_atlas",this._atlas_size);m.setUniform("u_texture",a.bind(0));m.setUniform("u_itexsize",[1/a.width,1/a.height]);m.setUniform("u_viewport",gl.viewport_data);a=m.attributes.a_vertex;f=m.attributes.a_extra4;m=m.attributes.a_extra2;
this.vertex_buffer.bind(a);this.extra4_buffer.bind(f);this.extra2_buffer.bind(m);gl.bindBuffer(gl.ELEMENT_ARRAY_BUFFER,this.indices_buffer.buffer);gl.drawElements(gl.TRIANGLES,6*this.index,gl.UNSIGNED_SHORT,0);gl.bindBuffer(gl.ELEMENT_ARRAY_BUFFER,null);this.vertex_buffer.unbind(a);this.extra4_buffer.unbind(f);this.extra2_buffer.unbind(m)}}};extendClass(e,RD.SceneNode);e.quad_sprites_vertex_shader="\nprecision highp float;\nattribute vec3 a_vertex;\nattribute vec4 a_extra4; //frame,flipx,scale,extranum\nattribute vec2 a_extra2;//expanse direction\nvarying vec3 v_pos;\nvarying vec2 v_uv;\nvarying vec4 v_color;\nuniform mat4 u_model;\nuniform mat4 u_viewprojection;\nuniform vec4 u_viewport;\nuniform vec2 u_size;\nuniform vec3 u_top;\nuniform vec3 u_right;\nuniform vec4 u_color;\nuniform vec2 u_atlas;\nuniform vec2 u_itexsize;\n\nvoid main() {\n\tvec3 vertex = a_vertex + a_extra4.z * u_size.y * u_top * a_extra2.y + a_extra4.z * u_size.x * u_right * a_extra2.x;\n\tvec2 uv = a_extra2;\n\tif( a_extra4.y != 0.0) //flip X\n\t\tuv.x *= -1.0;\n\tuv.x *= 1.0 - u_itexsize.x;\n\tuv.y *= -1.0;\n\tuv = uv * 0.5 + vec2(0.5);\n\t\n\tvec2 i_atlas = vec2(1.0) / u_atlas; \n\tfloat frame = a_extra4.x;\n\tfloat frame_x = mod( frame, u_atlas.x );\n\tfloat frame_y = floor( frame * i_atlas.x );\n\tuv.x = (uv.x + frame_x) * i_atlas.x;\n\tuv.y += frame_y;\n\tuv.y = 1.0 - uv.y * i_atlas.y;\n\tv_uv = uv;\n\tv_pos = (u_model * vec4(vertex,1.0)).xyz;\n\tgl_Position = u_viewprojection * vec4(v_pos,1.0);\n\t//gl_Position.x = floor(gl_Position.x * u_viewport.z * 1.0) / (u_viewport.z * 1.0);\n\t//gl_Position.y = floor(gl_Position.y * u_viewport.w * 1.0) / (u_viewport.w * 1.0);\n}\n\n";
e.quad_sprites_fragment_shader="\nprecision highp float;\nprecision mediump int;\n\nvarying vec3 v_pos;\nvarying vec2 v_uv;\nuniform vec4 u_color;\nuniform sampler2D u_texture;\n\nvoid main() {\n\tvec4 color = texture2D( u_texture, v_uv );\n\tif(color.a < 0.1)\n\t\tdiscard;\n\tcolor *= u_color;\n\tgl_FragColor = color;\n}\n";e.point_sprites_vertex_shader="\nprecision highp float;\nattribute vec3 a_vertex;\nattribute vec4 a_extra4;\nvarying vec3 v_pos;\nvarying vec3 v_wPos;\nvarying vec4 v_extra4;\nuniform mat4 u_model;\nuniform mat4 u_mvp;\nuniform vec4 u_viewport;\nuniform float u_camera_perspective;\nuniform float u_pointSize;\n\nfloat computePointSize( float radius, float w )\n{\n\tif(radius < 0.0)\n\t\treturn -radius;\n\treturn u_viewport.w * u_camera_perspective * radius / w;\n}\n\nvoid main() {\n\tvec3 vertex = a_vertex;\t\n\tv_pos = vertex;\n\tv_wPos = (u_model * vec4(vertex,1.0)).xyz;\n\tv_extra4 = a_extra4;\n\tgl_Position = u_mvp * vec4(vertex,1.0);\n\tgl_Position.x = floor(gl_Position.x * u_viewport.z) / u_viewport.z;\n\tgl_Position.y = floor(gl_Position.y * u_viewport.w) / u_viewport.w;\n\tgl_PointSize = computePointSize( u_pointSize * u_extra4.z, gl_Position.w );\n}\n";
e.point_sprites_fragment_shader="\nprecision highp float;\nvarying vec3 v_pos;\nvarying vec3 v_wPos;\nvarying vec4 v_extra4; //id,flip,scale,extra\nuniform float u_atlas;\n\nuniform sampler2D u_texture;\n\nvoid main() {\n\tfloat i_atlas = 1.0 / u_atlas;\n\tfloat frame = v_extra4.x;\n\tfloat x = frame * i_atlas;\n\tfloat y = floor(x);\n\tx = (x - y);\n\ty = y / u_atlas;\n\tif( v_extra4.y > 0.0 ) //must flip in x\n\t\tx -= gl_PointCoord.x * i_atlas - i_atlas;\n\telse\n\t\tx += gl_PointCoord.x * i_atlas;\n\t\n\tvec2 uv = vec2( x, 1.0 - (y + gl_PointCoord.y / u_atlas) );\n\tvec4 color = texture2D( u_texture, uv );\n\tif(color.a < 0.1)\n\t\tdiscard;\n\tgl_FragColor = color;\n}\n"})("undefined"!=
typeof window?window:"undefined"!=typeof self?self:global);
(function(p){function a(b){this._ctor();b&&this.configure(b);this.render_priority=0;this.targets=null;this.size=150;this.mode=a.DEFAULT;this.layers=255;this.grid_size=0;this.allow_duplicating=!0;this.shader="flat";this._last=vec3.create();b={x:a.XAXIS_COLOR,y:a.YAXIS_COLOR,z:a.ZAXIS_COLOR};var d="drag movex movey movez movexy movexz moveyz scalex scaley scalez scalexy scaleyz scalexz rotatex rotatey rotatez rotatefront rotate scale".split(" ");this.actions={};for(var e in d){var k=d[e],f={mask:255,
pos:vec3.create(),pos2D:vec3.create(),radius:0.15,visible:!1,flag:a[k.toUpperCase()]};0==k.indexOf("move")&&(f.move=!0);0==k.indexOf("rotate")&&(f.rotate=!0);0==k.indexOf("scale")&&(f.scale=!0);f.color=b[k[k.length-1]];if(f.move||f.rotate)f.cursor="crosshair";this.actions[k]=f}this.actions.scalex.axis=this.actions.rotatex.axis=this.actions.movex.axis=vec3.fromValues(1,0,0);this.actions.scaley.axis=this.actions.rotatey.axis=this.actions.movey.axis=vec3.fromValues(0,1,0);this.actions.scalez.axis=this.actions.rotatez.axis=
this.actions.movez.axis=vec3.fromValues(0,0,1);this.actions.movexy.normal=this.actions.scalexy.normal=vec3.fromValues(0,0,1);this.actions.movexz.normal=this.actions.scalexz.normal=vec3.fromValues(0,1,0);this.actions.moveyz.normal=this.actions.scaleyz.normal=vec3.fromValues(1,0,0);this.actions.movexy.radius=this.actions.movexz.radius=this.actions.moveyz.radius=0.1;this.actions.scalexy.radius=this.actions.scalexz.radius=this.actions.scaleyz.radius=0.1;this.actions.drag.cursor="move";this.actions.scale.cursor=
"row-resize";this.click_model=mat4.create();this.click_transform=new Float32Array(10);this.click_pos=vec3.create();this.click_2D=vec3.create();this.click_2D2=vec3.create();this.click_2D_norm=vec3.create();this.center_2D=vec3.create();this.click_dist=1}a.MOVEX=1;a.MOVEY=2;a.MOVEZ=4;a.MOVEXY=8;a.MOVEXZ=16;a.MOVEYZ=32;a.ROTATEX=64;a.ROTATEY=128;a.ROTATEZ=256;a.SCALEX=512;a.SCALEY=1024;a.SCALEZ=2048;a.SCALEXY=4096;a.SCALEYZ=8192;a.SCALEXZ=16384;a.SCALE=32768;a.DRAG=65536;a.ROTATE=131072;a.ROTATEFRONT=
262144;a.MOVEAXIS=a.MOVEX|a.MOVEY|a.MOVEZ;a.MOVEPLANAR=a.MOVEXY|a.MOVEXZ|a.MOVEYZ;a.MOVEALL=a.DRAG|a.MOVEAXIS|a.MOVEPLANAR;a.PLANAR=a.MOVEX|a.MOVEZ|a.MOVEXZ|a.ROTATEY|a.SCALE;a.ROTATEALL=a.ROTATEX|a.ROTATEY|a.ROTATEZ|a.ROTATEFRONT;a.SCALEALL=a.SCALE|a.SCALEX|a.SCALEY|a.SCALEZ|a.SCALEXY|a.SCALEYZ|a.SCALEXZ;a.MOVEROTATESCALE=a.MOVEAXIS|a.MOVEPLANAR|a.ROTATEALL|a.SCALE;a.ALL=a.MOVEAXIS|a.MOVEPLANAR|a.ROTATEALL|a.SCALEALL;a.DEFAULT=a.PLANAR;p=mat4.create();var f=mat4.create(),g=mat4.create();mat4.create();
mat4.create();mat4.create();var e=mat4.create(),h=mat4.create();mat4.create();var q=vec3.create(),l=vec3.create(),s=vec3.create(),k=vec4.create();vec4.create();mat4.translate(p,p,[1.1,0,0]);mat4.rotate(p,p,90*DEG2RAD,[0,0,-1]);mat4.translate(f,f,[0,1.1,0]);mat4.translate(g,g,[0,0,1.1]);mat4.rotate(g,g,90*DEG2RAD,[1,0,0]);p=mat4.create();mat4.scale(p,p,[-1,-1,-1]);a.full_viewport=null;var d=mat4.create(),m=mat4.create();a.XAXIS_COLOR=[0.901,0.247,0.349,1];a.YAXIS_COLOR=[0.55,0.81,0.11,1];a.ZAXIS_COLOR=
[0.23,0.57,0.93,1];a.XYAXIS_COLOR=[0.9,0.7,0.23,0.75];a.XZAXIS_COLOR=[0.6,0.4,0.7,0.75];a.YZAXIS_COLOR=[0.39,0.69,0.52,0.75];a.SPHERE_COLOR=[0.8,0.8,0.8,0.4];a.RING_COLOR=[0.5,0.5,0.5,1];a.INNERSPHERE_COLOR=[0.6,0.6,0.6,1];a.SELECTED_COLOR=[1,1,1,1];a.NOAXIS_COLOR=[0.901,0.247,0.749,1];a.STATIC_SPHERE_COLOR=[0.1,0.1,0.1,0.3];a.prototype.isTarget=function(b){return-1!=this.targets.indexOf(b)};a.prototype.setTargets=function(b,a){if(b&&b.constructor!==Array)throw"nodes must be an Array";b&&0!=b.length?
(a&&this.targets&&(b=this.targets.concat(b)),this.targets=b=b.filter(function(a,d){return b.indexOf(a)===d}),this.resetTransform(),this.position=this.computeCenter(this.targets)):a||(this.targets=null)};a.prototype.computeCenter=function(b){if((b=b||this.targets)&&b.length){for(var a=null,d=0;d<b.length;++d){var e=b[d];e.layers&this.layers&&(e=e.getGlobalPosition(),a?vec3.add(a,a,e):a=e)}if(!a)return[0,0,0];vec3.scale(a,a,1/b.length);return a}};a.prototype.updateGizmo=function(){this.targets&&(0==
this.targets.length?this.transform=this.targets[0].transform:(this.resetTransform(),1==this.targets.length&&this.coord_system?this.transform=this.targets[0].transform:this.position=this.computeCenter(this.targets)))};a.prototype.updateTargets=function(){if(this.targets)for(var b=this.getGlobalMatrix(mat4.create()),a=0;a<this.targets.length;++a){var d=this.targets[a];d.layers&this.layers&&d.fromMatrix(b,!0)}};a.prototype.saveTargetTransforms=function(){if(this.targets){this.target_tranforms=[];for(var b=
0;b<this.targets.length;++b){var a=this.targets[b];a.layers&this.layers&&(this.target_tranforms[b]=new Float32Array(a.transform))}}};a.prototype.restoreTargetTransforms=function(){if(this.target_tranforms&&this.targets&&this.target_tranforms.length==this.targets.length)for(var b=0;b<this.targets.length;++b){var a=this.targets[b];a.layers&this.layers&&(a.transform=this.target_tranforms[b])}};a.prototype.removeTargetsFromScene=function(){if(this.targets){for(var b=0;b<this.targets.length;++b){var a=
this.targets[b];a.layers&this.layers&&a.parentNode&&a.parentNode.removeChild(a)}this.targets=null}};a.prototype.getTargetBaseNodes=function(){function b(a){return-1!=d.indexOf(a)?!0:a.parentNode?b(a.parentNode):!1}if(!this.targets||!this.targets.length)return null;for(var a=[],d=this.targets,e=0;e<d.length;++e){var k=d[e];k.layers&this.layers&&(b(k.parentNode)||a.push(k))}return a};a.prototype.applyTransformToTarget=function(b){var a=this.getGlobalMatrix(mat4.create()),d=mat4.invert(mat4.create(),
a),e=mat4.create(),k=this.getTargetBaseNodes();if(k){for(var f=0;f<k.length;++f){var m=k[f];m.getGlobalMatrix(e);mat4.multiply(e,d,e);mat4.multiply(e,b,e);mat4.multiply(e,a,e);m.fromMatrix(e,!0);m.position=this.applySnap(m.position);if(this.grid_size){var h=quat.toEuler(vec3.create(),m.rotation);h[0]=15*Math.round(h[0]*RAD2DEG/15)*DEG2RAD;h[1]=15*Math.round(h[1]*RAD2DEG/15)*DEG2RAD;h[2]=15*Math.round(h[2]*RAD2DEG/15)*DEG2RAD;quat.fromEuler(m.rotation,h)}}mat4.multiply(e,a,b);this.fromMatrix(e);this.scaling=
[1,1,1];this.updateGizmo()}};a.prototype.applyTranslation=function(b){var a=mat4.create();mat4.translate(a,a,b);this.applyTransformToTarget(a)};a.prototype.applyRotation=function(b,a){var d=mat4.create();mat4.rotate(d,d,b,a);this.applyTransformToTarget(d)};a.prototype.applyScale=function(b){b.constructor===Number&&(b=[b,b,b]);var a=mat4.create();mat4.scale(a,a,b);this.applyTransformToTarget(a)};a.prototype.applySnap=function(b){if(!this.grid_size)return b;b[0]=Math.round(b[0]/this.grid_size)*this.grid_size;
b[1]=Math.round(b[1]/this.grid_size)*this.grid_size;b[2]=Math.round(b[2]/this.grid_size)*this.grid_size;return b};a.prototype.setColor=function(b){if(this.targets)for(var a=0;a<this.targets.length;++a){var d=this.targets[a];d.layers&this.layers&&(d.color=b)}};a.prototype.cloneTargets=function(){if(this.allow_duplicating&&(!this.onDuplicateTargets||!this.onDuplicateTargets(this.targets))){for(var a=[],d=0;d<this.targets.length;++d){var e=this.targets[d];if(e.layers&this.layers){var k=e.clone(!0);e.parentNode.addChild(k);
a.push(e)}}return this.targets=a}};a.prototype.onMouse=function(a){if(this._camera&&this.targets&&!1!==this.visible){var d=this._camera,e=d.getFront(),k=[a.canvasx,a.canvasy],f=d.getRay(k[0],k[1]),m=this.position,h=vec3.sub(vec3.create(),m,d.position);vec3.normalize(h,h);var g=this._selected_action,l=this.actions[g],q=this._global_matrix;d.project(m,null,this.center_2D);if("mousedown"==a.type){if(this.click_2D[0]=this.click_2D2[0]=k[0],this.click_2D[1]=this.click_2D2[0]=k[1],a.is_touch&&this.testMouseOver(a),
g=this._selected_action=this._hover_action,l=this.actions[g]){if(l.move&&l.axis){var p=vec3.clone(l.axis);mat4.rotateVec3(p,q,p);vec3.normalize(p,p);this._last=f.closestPointOnRay(m,p);a.shiftKey&&this.cloneTargets()}else l.move&&l.normal&&(f.testPlane(m,l.normal)&&(this.click_pos=f.collision_point),a.shiftKey&&this.cloneTargets());"drag"==g&&(f.testPlane(m,e),this._last=f.collision_point,a.shiftKey&&this.cloneTargets());"rotatefront"==g?(vec2.sub(this.click_2D,this.click_2D,this.center_2D),vec2.normalize(this.click_2D,
this.click_2D),this.click_2D_norm.set(this.click_2D),vec2.scaleAndAdd(this.click_2D,this.center_2D,this.click_2D,0.5*this.size),this.click_2D2.set(this.click_2D)):l.rotate&&(l.axis?(a=mat4.rotateVec3(vec3.create(),q,l.axis),f.testPlane(m,a)&&(vec3.sub(this.click_pos,f.collision_point,m),vec3.normalize(this.click_pos,this.click_pos),m=vec3.scaleAndAdd(vec3.create(),m,this.click_pos,this.current_size),this.current_2D=this.click_2D=d.project(m))):f.testSphere(m,this.current_size)&&(this._last=f.collision_point,
vec3.sub(this.click_pos,f.collision_point,m),vec3.normalize(this.click_pos,this.click_pos),this.click_axis=vec3.cross(this.click_axis||vec3.create(),h,this.click_pos)));this.click_model.set(q);this.click_transform.set(this.transform);this.click_dist=vec3.distance(this.click_2D,this.center_2D);this.saveTargetTransforms()}}else if("mousemove"==a.type)if(a.dragging&&this._selected_action){if("rotatefront"==g)return m=vec2.sub(vec3.create(),k,this.center_2D),vec2.normalize(m,m),l=this.click_2D_norm,vec2.scaleAndAdd(this.click_2D2,
this.center_2D,m,0.5*this.size),m=Math.atan2(m[0],m[1]),l=Math.atan2(l[0],l[1]),m-=l,a.shiftKey&&(m=2*Math.PI*Math.ceil(36*m/(2*Math.PI))/36),m&&(this.restoreTargetTransforms(),this.applyRotation(m,h)),!0;if(l.rotate)return l.axis?(a=mat4.rotateVec3(vec3.create(),q,l.axis),f.testPlane(m,a)&&(g=vec3.sub(vec3.create(),f.collision_point,m),vec3.normalize(g,g),m=vec3.scaleAndAdd(vec3.create(),m,g,this.current_size),this.current_2D=d.project(m),d=Math.clamp(vec3.dot(g,this.click_pos),-1,1),m=Math.acos(d),
g=vec3.cross(vec3.create(),g,this.click_pos),vec3.normalize(g,g),d=vec3.dot(a,g),0<d&&(m*=-1),this.restoreTargetTransforms(),this.applyRotation(m,l.axis))):(p=vec3.cross(vec3.create(),h,this.click_pos),m=0.01*(vec2.dist(this.center_2D,k)-this.click_dist),l=vec2.sub(vec2.create(),this.center_2D,k),a=vec2.sub(vec2.create(),this.center_2D,this.click_2D),0>vec2.dot(l,a)&&(m=-m),console.log(m),this.restoreTargetTransforms(),this.applyRotation(m,p),this.click_axis=p),!0;h=null;if(l.move&&l.normal)f.testPlane(m,
l.normal)&&(l=f.collision_point,this.applySnap(l),h=vec3.sub(vec3.create(),l,this.click_pos),this.click_pos=l);else if(l.move||l.scale){if("scale"==g||l.scale&&a.ctrlKey)return l=1+0.01*(k[1]-this.click_2D[1]),this.applyScale(l),this.click_2D[0]=k[0],this.click_2D[1]=k[1],!0;if("scalexy"==g||"scalexz"==g||"scaleyz"==g){l=1+0.01*(k[1]-this.click_2D[1]);switch(g){case "scalexy":this.applyScale([l,l,1]);break;case "scaleyz":this.applyScale([1,l,l]);break;case "scalexz":this.applyScale([l,1,l])}this.click_2D[0]=
k[0];this.click_2D[1]=k[1];return!0}p=vec3.clone(l.axis);mat4.rotateVec3(p,q,p);vec3.normalize(p,p);a=f.closestPointOnRay(m,p);if(l.scale)return l=vec2.distance(k,this.center_2D),a=l/this.click_dist,"scalex"==g?this.applyScale([a,1,1]):"scaley"==g?this.applyScale([1,a,1]):"scalez"==g&&this.applyScale([1,1,a]),this.click_dist=l,!0;this.applySnap(a);h=vec3.sub(vec3.create(),a,this._last);this._last=a}"drag"==g&&(f.testPlane(m,this._camera.getFront()),a=f.collision_point,this.applySnap(a),h=vec3.sub(vec3.create(),
a,this._last),this._last=a);if(h)return this.applyTranslation(h),!0}else this.testMouseOver(a);else if("mouseup"==a.type){if(this.saveTargetTransforms(),this._selected_action)return this._selected_action=null,this.render(this._last_renderer,this._last_camera),this.testMouseOver(a),this.updateGizmo(),!0}else if("wheel"==a.type){if("scale"==this._selected_action)return l=1+2E-4*a.wheel,this.applyScale(l),!0;if("drag"==this._selected_action)return h=vec3.sub(vec3.create(),m,d.position),l=1+2E-4*a.wheel,
vec3.scaleAndAdd(h,d.position,h,l),vec3.sub(h,h,m),this.applyTranslation(h),this._last=m,!0}return!1}};a.prototype.testMouseOver=function(b){this._hover_action=null;var d=[b.canvasx,b.canvasy],e=1E5;b=null;for(var k in this.actions){var f=this.actions[k];if(f.visible){var m=vec2.distance(f.pos2D,d);m<f.radius*this.size&&m<e&&(e=m,b=k)}}b||(k=vec2.distance(this.center_2D,d),this.actions.rotatefront.visible&&10>Math.abs(k-0.5*this.size)?b="rotatefront":this.mode&a.ROTATE&&k<0.5*this.size&&(b="rotate"));
return this._hover_action=b};a.prototype.cancel=function(){this._selected_action&&(this._selected_action=null,this.restoreTargetTransforms())};a.prototype.render=function(b,n){this._last_renderer=b;this._last_camera=n;for(var f in this.actions)this.actions[f].visible=!1;if(this.targets&&this.targets.length&&!1!==this.visible){gl.meshes.cone||(gl.meshes.circle=GL.Mesh.circle({radius:1}),gl.meshes.cylinder=GL.Mesh.cylinder({radius:0.02,height:1}),gl.meshes.cone=GL.Mesh.cone({radius:0.1,height:0.25}),
gl.meshes.torus=GL.Mesh.torus({outerradius:1,innerradius:0.02,outerslices:64,innerslices:8}),gl.meshes.quartertorus=GL.Mesh.torus({angle:0.5*Math.PI,outerradius:1,innerradius:0.02,outerslices:64,innerslices:8}),gl.meshes.halftorus=GL.Mesh.torus({angle:Math.PI,outerradius:1,innerradius:0.02,outerslices:64,innerslices:8}));f=gl.meshes.torus;var m=n.getFront(),g=n.getLocalVector(RD.UP);n.getLocalVector(RD.RIGHT);var p=this._position;k.set(p);k[3]=1;var w=n._projection_matrix[5];this.updateMatrices();
e.set(this._global_matrix);var u=vec3.sub(vec3.create(),p,n.position);vec3.normalize(u,u);this._camera=n;this._unitary_model=e;var z=this._hover_action,A=this._selected_action;A&&(z=A);var D=A?this.actions[A]:null,x=this.mode;mat4.rotateVec3(l,e,RD.RIGHT);mat4.rotateVec3(s,e,RD.UP);mat4.rotateVec3(q,e,RD.FRONT);vec3.normalize(l,l);vec3.normalize(s,s);vec3.normalize(q,q);mat4.fromTranslationFrontTop(h,p,m,g);vec4.transformMat4(k,k,n._viewprojection_matrix);this.current_size=g=gl.canvas.width/gl.canvas.height*
this.size*k[3]/(gl.canvas.width*w);mat4.scale(e,e,[g,g,g]);mat4.scale(h,h,[g,g,g]);var g=vec3.dot(u,l),w=vec3.dot(u,s),E=vec3.dot(u,q),C=vec3.dot(m,RD.RIGHT),c=vec3.dot(m,RD.UP),r=vec3.dot(m,RD.FRONT);this._camera.project(p,[0,0,gl.canvas.width,gl.canvas.height],this.center_2D);gl.disable(gl.DEPTH_TEST);gl.disable(gl.BLEND);gl.disable(gl.CULL_FACE);gl.blendFunc(gl.SRC_ALPHA,gl.ONE_MINUS_SRC_ALPHA);u=gl.shaders[this.shader];u.uniforms(b._uniforms);u.uniforms(n.uniforms);u.uniforms(this.uniforms);if("movex"==
A)mat4.rotateZ(d,e,-Math.PI/2),this.drawAxis(d,a.XAXIS_COLOR);else if("movey"==A)this.drawAxis(e,a.YAXIS_COLOR);else if("movez"==A)mat4.rotateX(d,e,-Math.PI/2),this.drawAxis(d,a.ZAXIS_COLOR);else if("drag"==A)b.drawCircle2D(this.center_2D[0],this.center_2D[1],2,a.XAXIS_COLOR,!0);else if(D&&D.normal)d.set(e),"movexz"==A?mat4.rotateX(d,e,Math.PI/2):"moveyz"==A&&mat4.rotateY(d,e,Math.PI/2),mat4.scale(d,d,[100,100,100]),u.setUniform("u_model",d),u.setUniform("u_color",[0.1,0.1,0.1,0.4]),gl.enable(gl.BLEND),
gl.enable(gl.DEPTH_TEST),u.draw(gl.meshes.plane),gl.disable(gl.BLEND),gl.disable(gl.DEPTH_TEST);else{if("rotatefront"==A)mat4.rotateX(d,h,Math.PI/2),u.setUniform("u_model",d),u.draw(f),b.drawCircle2D(this.click_2D[0],this.click_2D[1],2,a.XAXIS_COLOR,!0),b.drawCircle2D(this.click_2D2[0],this.click_2D2[1],2,a.XAXIS_COLOR,!0),b.drawCircle2D(this.center_2D[0],this.center_2D[1],2,a.XAXIS_COLOR,!0),b.drawLine2D(this.click_2D[0],this.click_2D[1],this.center_2D[0],this.center_2D[1],4,a.XAXIS_COLOR),b.drawLine2D(this.click_2D2[0],
this.click_2D2[1],this.center_2D[0],this.center_2D[1],4,a.XAXIS_COLOR);else{if("rotate"==A){this.click_axis&&(mat4.fromTranslationFrontTop(d,p,m,this.click_axis),mat4.scale(d,d,[this.current_size,this.current_size,this.current_size]),this.drawAxis(d,a.NOAXIS_COLOR));this.drawRotateSphere(e,a.SPHERE_COLOR);b.drawCircle2D(this.click_2D[0],this.click_2D[1],2,a.NOAXIS_COLOR,!0);return}if(D&&D.rotate){m=D.color||a.XAXIS_COLOR;"rotatex"==A?mat4.rotateZ(d,e,Math.PI/2):"rotatey"==A?mat4.rotateY(d,e,Math.PI/
2):"rotatez"==A&&mat4.rotateX(d,e,Math.PI/2);u.setUniform("u_model",d);u.setUniform("u_color",m);u.draw(f);b.drawCircle2D(this.center_2D[0],this.center_2D[1],2,m,!0);b.drawCircle2D(this.click_2D[0],this.click_2D[1],2,m,!0);b.drawLine2D(this.click_2D[0],this.click_2D[1],this.center_2D[0],this.center_2D[1],4,m);b.drawCircle2D(this.current_2D[0],this.current_2D[1],2,m,!0);b.drawLine2D(this.current_2D[0],this.current_2D[1],this.center_2D[0],this.center_2D[1],4,m);return}}"scale"==A?(b.drawCircle2D(this.center_2D[0],
this.click_2D[1],2,a.INNERSPHERE_COLOR,!0),b.drawCircle2D(this.center_2D[0],this.center_2D[1],2,a.INNERSPHERE_COLOR,!0),b.drawLine2D(this.center_2D[0],this.click_2D[1],this.center_2D[0],this.center_2D[1],4,a.INNERSPHERE_COLOR)):(this.drawRotateSphere(e,a.STATIC_SPHERE_COLOR),x&a.ROTATE&&"rotate"==z&&this.drawRotateSphere(e,a.SPHERE_COLOR),x&a.ROTATEFRONT&&(mat4.rotateX(d,h,Math.PI/2),u.setUniform("u_model",d),u.setUniform("u_color","rotatefront"==z?a.SELECTED_COLOR:a.RING_COLOR),u.draw(f),this.actions.rotatefront.visible=
!0),0.1<Math.abs(g)&&x&a.ROTATEX&&(mat4.rotateZ(d,e,Math.PI/2),0>r&&mat4.rotateX(d,d,Math.PI),0>c&&mat4.rotateY(d,d,Math.PI/2),this.drawRotator(d,"rotatex"==z?a.SELECTED_COLOR:a.XAXIS_COLOR,"rotatex")),0.1<Math.abs(w)&&x&a.ROTATEY&&(d.set(e),0<C&&0>r?mat4.rotateY(d,d,-Math.PI/2):0>C&&0>r?mat4.rotateY(d,d,Math.PI):0>C&&0<r&&mat4.rotateY(d,d,Math.PI/2),this.drawRotator(d,"rotatey"==z?a.SELECTED_COLOR:a.YAXIS_COLOR,"rotatey")),0.1<Math.abs(E)&&x&a.ROTATEZ&&(d.set(e),mat4.rotateX(d,d,Math.PI/2),0<C&&
0>c?mat4.rotateY(d,d,-Math.PI/2):0>C&&0>c?mat4.rotateY(d,d,Math.PI):0>C&&0<c&&mat4.rotateY(d,d,Math.PI/2),this.drawRotator(d,"rotatez"==z?a.SELECTED_COLOR:a.ZAXIS_COLOR,"rotatez")),0.95>Math.abs(g)&&(mat4.rotateZ(d,e,0>C?-Math.PI/2:Math.PI/2),x&a.MOVEX&&this.drawArrow(d,"movex"==z?a.SELECTED_COLOR:a.XAXIS_COLOR,"movex"),x&a.SCALEX&&this.drawScale(d,"scalex"==z?a.SELECTED_COLOR:a.XAXIS_COLOR,"scalex")),0.95>Math.abs(w)&&(0<c?mat4.rotateZ(d,e,Math.PI):d.set(e),x&a.MOVEY&&this.drawArrow(d,"movey"==z?
a.SELECTED_COLOR:a.YAXIS_COLOR,"movey"),x&a.SCALEY&&this.drawScale(d,"scaley"==z?a.SELECTED_COLOR:a.YAXIS_COLOR,"scaley")),0.95>Math.abs(E)&&(mat4.rotateX(d,e,0>r?-Math.PI/2:Math.PI/2),x&a.MOVEZ&&this.drawArrow(d,"movez"==z?a.SELECTED_COLOR:a.ZAXIS_COLOR,"movez"),x&a.SCALEZ&&this.drawScale(d,"scalez"==z?a.SELECTED_COLOR:a.ZAXIS_COLOR,"scalez")),0.2<Math.abs(E)&&(x&a.MOVEXY||x&a.SCALEXY)&&(mat4.translate(d,e,[0.45*(0>g?1:-1),0.45*(0>w?1:-1),0]),x&a.MOVEXY?this.drawFlat(d,"movexy"==z?a.SELECTED_COLOR:
a.XYAXIS_COLOR,"movexy"):this.drawFlat(d,"scalexy"==z?a.SELECTED_COLOR:a.XYAXIS_COLOR,"scalexy","circle")),0.2<Math.abs(w)&&(x&a.MOVEXZ||x&a.SCALEXZ)&&(mat4.rotateX(d,e,Math.PI/2),mat4.translate(d,d,[0.45*(0>g?1:-1),0.45*(0>E?-1:1),0]),x&a.MOVEXZ?this.drawFlat(d,"movexz"==z?a.SELECTED_COLOR:a.XZAXIS_COLOR,"movexz"):this.drawFlat(d,"scalexz"==z?a.SELECTED_COLOR:a.XZAXIS_COLOR,"scalexz","circle")),0.2<Math.abs(g)&&(x&a.MOVEYZ||x&a.SCALEYZ)&&(mat4.rotateY(d,e,Math.PI/2),mat4.translate(d,d,[0.45*(0>E?
1:-1),0.45*(0>w?1:-1),0]),x&a.MOVEYZ?this.drawFlat(d,"moveyz"==z?a.SELECTED_COLOR:a.YZAXIS_COLOR,"moveyz"):this.drawFlat(d,"scaleyz"==z?a.SELECTED_COLOR:a.YZAXIS_COLOR,"scaleyz","circle")),x&a.DRAG&&this.drawInnerSphere(e,"drag"),x&a.SCALE&&this.drawInnerSphere(e,"scale"),gl.enable(gl.DEPTH_TEST))}}};a.prototype.drawArrow=function(b,d,e){var k=gl.shaders[this.shader],f=gl.meshes.cone,h=gl.meshes.cylinder,l=this._hover_action;mat4.translate(m,b,[0,1.1,0]);k.setUniform("u_model",m);k.setUniform("u_color",
l==e?a.SELECTED_COLOR:d);k.draw(f);this.mode==a.MOVEALL?(mat4.translate(m,m,[0,-0.4,0]),mat4.scale(m,m,[1,1,1])):(mat4.translate(m,m,[0,-0.15,0]),mat4.scale(m,m,[1,0.5,1]));k.setUniform("u_model",m);k.draw(h);this.toScreen(m,e,[0,0.6,0])};a.prototype.drawAxis=function(a,d){var e=gl.shaders[this.shader],k=gl.meshes.sphere;mat4.scale(m,a,[0.01,100,0.01]);e.setUniform("u_model",m);gl.enable(gl.DEPTH_TEST);gl.enable(gl.BLEND);gl.blendFunc(gl.SRC_ALPHA,gl.ONE_MINUS_SRC_ALPHA);gl.depthMask(!1);e.setUniform("u_color",
[d[0],d[1],d[2],0.2]);gl.depthFunc(gl.GREATER);e.draw(k);gl.depthFunc(gl.LESS);gl.disable(gl.BLEND);e.setUniform("u_color",d);e.draw(k);gl.depthMask(!0);gl.disable(gl.DEPTH_TEST);this.drawInnerSphere(a)};a.prototype.drawFlat=function(a,e,k,f){f=gl.meshes[f||"plane"];var m=gl.shaders[this.shader];mat4.scale(d,a,[0.25,0.25,0.25]);m.setUniform("u_color",e);m.setUniform("u_model",d);gl.enable(gl.BLEND);m.draw(f);gl.disable(gl.BLEND);this.toScreen(d,k)};a.prototype.drawRotator=function(a,e,k){var f=gl.meshes.quartertorus,
m=gl.shaders[this.shader];mat4.scale(d,a,[0.9,0.9,0.9]);m.setUniform("u_color",e);m.setUniform("u_model",d);m.draw(f);this.toScreen(d,k,[-0.75,0,0.75])};a.prototype.drawScale=function(b,e,k){var f=gl.meshes.cylinder,m=gl.meshes.sphere,h=gl.shaders[this.shader];h.setUniform("u_color",e);this.mode==a.SCALEALL?(mat4.translate(d,b,[0,0.5,0]),mat4.scale(d,d,[1,1,1])):(mat4.translate(d,b,[0,0.25,0]),mat4.scale(d,d,[1,0.5,1]));h.setUniform("u_model",d);h.draw(f);mat4.translate(d,b,[0,0.4,0]);this.mode==
a.SCALEALL?mat4.scale(d,d,[0.1,0.1,0.1]):mat4.scale(d,d,[0.1,0.2,0.1]);h.setUniform("u_model",d);h.draw(m);this.toScreen(d,k)};a.prototype.drawRotateSphere=function(a,e){var k=gl.shaders[this.shader],f=gl.meshes.sphere;gl.enable(gl.BLEND);gl.blendFunc(gl.SRC_ALPHA,gl.ONE_MINUS_SRC_ALPHA);mat4.scale(d,a,[0.9,0.9,0.9]);k.setUniform("u_model",d);k.setUniform("u_color",e);k.draw(f);gl.disable(gl.BLEND)};a.prototype.drawInnerSphere=function(b,e){var k=gl.shaders[this.shader],f=gl.meshes.sphere,m=this._hover_action;
mat4.scale(d,b,[0.1,0.1,0.1]);k.setUniform("u_model",d);k.setUniform("u_color",m==e?a.SELECTED_COLOR:a.INNERSPHERE_COLOR);k.draw(f);"drag"==e&&(mat4.scale(d,b,[0.07,0.07,0.07]),k.setUniform("u_model",d),k.setUniform("u_color",m==e?a.INNERSPHERE_COLOR:[0,0,0,1]),k.draw(f));e&&this.toScreen(d,e)};a.prototype.renderOutline=function(a,d,e,k){if((k=k||this.targets)&&k.length){var f=this.layers;k=k.filter(function(a){return a.layers&f});var m=gl.viewport_data[2],h=gl.viewport_data[3];this._selection_buffer&&
this._selection_buffer.width==m&&this._selection_buffer.height==h||(this._selection_buffer=new GL.Texture(m,h,{magFilter:gl.NEAREST}));var l=this.shader;this._selection_buffer.drawTo(function(){gl.clearColor(0,0,0,1);gl.clear(gl.COLOR_BUFFER_BIT|gl.DEPTH_BUFFER_BIT);a.shader_overwrite=l;var f=a.onNodeShaderUniforms;a.onNodeShaderUniforms=function(a,b){b.setUniform("u_color",[1,1,1,1])};a.render(d,e,k);a.shader_overwrite=null;a.onNodeShaderUniforms=f});var g=gl.shaders.outline;g||(g=gl.shaders.outline=
GL.Shader.createFX("\t\t\tvec3 colorU = texture2D(u_texture, uv - vec2(0.0,u_res.y)).xyz;\n\t\t\tvec3 colorUL = texture2D(u_texture, uv - u_res).xyz;\n\t\t\tvec3 colorUR = texture2D(u_texture, uv + vec2(u_res.x,-u_res.y)).xyz;\n\t\t\tvec3 colorL = texture2D(u_texture, uv - vec2(u_res.x,0.0)).xyz;\n\t\t\tvec3 colorDL = texture2D(u_texture, uv - vec2(u_res.x,-u_res.y)).xyz;\n\t\t\tvec3 outline = abs(color.xyz - colorU) * 0.3 + abs(color.xyz - colorL) * 0.3;\n\t\t\toutline += (abs(color.xyz - colorUL) + abs(color.xyz - colorDL) + abs(color.xyz - colorUR)) * 0.1;\n\t\t\tcolor = vec4( clamp(outline,vec3(0.0),vec3(1.0)),1.0 );\n\t\t",
"uniform vec2 u_res;\n"));gl.blendFunc(gl.ONE,gl.ONE);gl.enable(gl.BLEND);gl.disable(gl.DEPTH_TEST);this._selection_buffer.toViewport(g,{u_color:[1,1,1,1],u_res:[1/m,1/h]});gl.disable(gl.BLEND);gl.enable(gl.DEPTH_TEST)}};a.prototype.renderCameraGizmo=function(a,d){this.drawInnerSphere};a.prototype.toScreen=function(b,d,e){d=this.actions[d];mat4.multiplyVec3(d.pos,b,e||[0,0,0]);this._camera.project(d.pos,a.full_viewport,d.pos2D);d.visible=!0};extendClass(a,RD.SceneNode);RD.Gizmo=a})(this);
RD.GLTF={BYTE:5120,UNSIGNED_BYTE:5121,SHORT:5122,UNSIGNED_SHORT:5123,UNSIGNED_INT:5125,FLOAT:5126,JSON_CHUNK:1313821514,BINARY_CHUNK:5130562,numComponents:{SCALAR:1,VEC2:2,VEC3:3,VEC4:4,MAT4:16},rename_animation_properties:{translation:"position",scale:"scaling"},flip_uv:!0,prefabs:{},texture_options:{format:GL.RGBA,magFilter:GL.LINEAR,minFilter:GL.LINEAR_MIPMAP_LINEAR,wrap:GL.REPEAT},load:function(p,a,f){function g(a){function b(b){var d=this.buffer;d.data=b;d.dataview=new Uint8Array(b);b.byteLength!=
d.byteLength&&console.warn("gltf binary doesnt match json size hint");a.length?g(a):e()}var d=a.pop(),k=l+"/"+d.uri;console.log(" - loading "+d.uri+" ...");"data:"==d.uri.substr(0,5)?(k=_base64ToArrayBuffer(d.uri.substr(37)),b.call({buffer:d},k)):fetch(k).then(function(a){return a.arrayBuffer()}).then(b.bind({buffer:d}))}function e(){console.log("parsing gltf ...");h.filename=q;h.folder=l;h.url=p;var d=RD.GLTF.parse(h);RD.GLTF.prefabs[p]=d.serialize();a&&a(d)}var h=null,q="",l="";if(p.constructor===
String)l=p.split("/"),q=l.pop(),f=f||q.split(".").pop().toLowerCase(),l=l.join("/"),console.log("loading gltf json..."),fetch(p).then(function(a){return"gltf"==f?a.json():a.arrayBuffer()}).then(function(a){"gltf"==f?(h=a,console.log("loading gltf binaries..."),g(h.buffers.concat())):"glb"==f&&(h=RD.GLTF.parseGLB(a))&&e()});else{var s=p;console.log(s);p=q=s.main;var k=s[q];if("glb"==k.extension)(h=RD.GLTF.parseGLB(k.data))&&e();else{h=k.data;for(k=0;k<h.buffers.length;++k){var d=h.buffers[k];"data:"==
d.uri.substr(0,5)?d.data=_base64ToArrayBuffer(d.uri.substr(37)):d.data=s[d.uri].data;d.dataview=new Uint8Array(d.data)}e()}}},parseGLB:function(p){var a=new Uint8Array(p),f=new DataView(p);if(1179937895!=f.getUint32(0,!0))return console.error("incorrect gltf header"),null;var g=f.getUint32(4,!0);console.log("GLTF Version: "+g);f.getUint32(8,!0);for(var g=12,e=null,h=0;g<a.length;){var q=f.getUint32(g,!0),l=f.getUint32(g+4,!0),s=p.slice(g+8,g+8+q),g=g+(8+q);if(l==RD.GLTF.JSON_CHUNK){if(!("TextDecoder"in
window))throw"Sorry, this browser does not support TextDecoder...";e=(new TextDecoder("utf-8")).decode(s);e=JSON.parse(e)}else l==RD.GLTF.BINARY_CHUNK?(q=e.buffers[h],q.data=s,q.dataview=new Uint8Array(s),p.byteLength!=q.byteLength&&console.warn("gltf binary doesnt match json size hint"),h++):console.warn("gltf unknown chunk type: ","0x"+l.toString(16))}return e},parse:function(p){console.log(p);var a=null,f={};1<p.scenes.length&&console.warn("gltf importer only supports one scene per file, skipping the rest");
var g=p.scenes[p.scene].nodes,a=null;1<g.length&&(a=new RD.SceneNode,a.name="root");for(var e=0;e<g.length;++e)if(!g[e].node){var h=RD.GLTF.parseNode(null,e,p);a||(a=h);1<g.length&&a.addChild(h);h.id=p.url.replace(/\//gi,"_")+"::node_"+e;f[h.id]=f[e]=h}if(p.animations&&p.animations.length)if(RD.Animation)for(a.animations=[],e=0;e<p.animations.length;++e){if(g=this.parseAnimation(e,p,f))RD.Animations[g.name]=g,a.animations.push(g)}else console.error("you must include rendeer-animation.js to allow animations");
return a},parseNode:function(p,a,f){var g=f.nodes[a];p=p||new RD.SceneNode;for(var e in g){var h=g[e];switch(e){case "name":p.name=h;break;case "translation":p.position=h;break;case "rotation":p.rotation=h;break;case "scale":p.scaling=h;break;case "matrix":p.fromMatrix(h);break;case "mesh":if(h=RD.GLTF.parseMesh(h,f)){p.mesh=h.name;p.primitives=[];for(var q=0;q<h.info.groups.length;++q){var l=h.info.groups[q],s=this.parseMaterial(l.material,f);p.primitives.push({index:q,material:s.name,mode:l.mode})}}break;
case "skin":p.skin=this.parseSkin(h,f);break;case "children":if(h.length)for(q=0;q<h.length;++q)l=RD.GLTF.parseNode(null,h[q],f),p.addChild(l);break;default:console.log("feature skipped",q)}}g.name||(g.name=p.name="node_"+a);return p},parseMesh:function(p,a){for(var f=a.meshes[p],g=gl.meshes,e=[],h=[],q=0,l=0;l<f.primitives.length;++l){var s=this.parsePrimitive(f,l,a);s.start=q;q+=s.length;h.push(s);var k={vertexBuffers:{},indexBuffers:{}},d;for(d in s.buffers)"indices"==d||"triangles"==d?k.indexBuffers[d]=
{data:s.buffers[d]}:k.vertexBuffers[d]={data:s.buffers[d]};e.push({mesh:k})}q=null;1<e.length?q=GL.Mesh.mergeMeshes(e):(l=e[0].mesh,q=new GL.Mesh(l.vertexBuffers,l.indexBuffers),q.info&&l.info&&(q.info=l.info));for(l=0;l<f.primitives.length;++l)(e=q.info.groups[l])||(q.info.groups[l]=e={}),s=f.primitives[l],e.material=s.material,e.mode=s.mode,e.start=h[l].start,e.length=h[l].length;q.name=f.name||"mesh_"+p;q.updateBoundingBox();q.computeGroupsBoundingBoxes();return g[q.name]=q},parsePrimitive:function(p,
a,f){var g={buffers:{}},e=g.buffers;p=p.primitives[a];if(p.extensions)throw"mesh data is compressed, this importer does not support it yet";null==!p.attributes.POSITION?console.warn("gltf mesh without positions"):e.vertices=this.parseAccessor(p.attributes.POSITION,f);null!=p.attributes.NORMAL&&(e.normals=this.parseAccessor(p.attributes.NORMAL,f));null!=p.attributes.TEXCOORD_0&&(e.coords=this.parseAccessor(p.attributes.TEXCOORD_0,f,this.flip_uv));null!=p.attributes.TEXCOORD_1&&(e.coords1=this.parseAccessor(p.attributes.TEXCOORD_1,
f,this.flip_uv));null!=p.attributes.WEIGHTS_0&&(e.weights=this.parseAccessor(p.attributes.WEIGHTS_0,f));null!=p.attributes.JOINTS_0&&(e.bones=this.parseAccessor(p.attributes.JOINTS_0,f));null!=p.indices&&(e.triangles=this.parseAccessor(p.indices,f));g.mode=p.mode;g.material=p.material;g.start=0;g.length=e.triangles?e.triangles.length:e.vertices.length/3;return g},parseAccessor:function(p,a,f){var g=a.accessors[p];if(!g)return console.warn("gltf accessor not found"),null;p=this.numComponents[g.type];
if(!p)return console.warn("gltf accessor of unknown type:",g.type),null;var e=g.count*p;switch(g.componentType){case RD.GLTF.FLOAT:databuffer=new Float32Array(e);break;case RD.GLTF.UNSIGNED_INT:databuffer=new Uint32Array(e);break;case RD.GLTF.SHORT:databuffer=new Int16Array(e);break;case RD.GLTF.UNSIGNED_SHORT:databuffer=new Uint16Array(e);break;case RD.GLTF.BYTE:databuffer=new Int8Array(e);break;case RD.GLTF.UNSIGNED_BYTE:databuffer=new Uint8Array(e);break;default:console.warn("gltf accessor of unsupported type: ",
g.componentType),databuffer=new Float32Array(e)}e=a.bufferViews[g.bufferView];if(!e)return console.warn("gltf bufferView not found"),null;var h=a.buffers[e.buffer];if(!h||!h.data)return console.warn("gltf buffer not found or data not loaded"),null;if(e.byteStride&&e.byteStride!=p*databuffer.BYTES_PER_ELEMENT)return console.warn("gltf buffer data is not tightly packed, not supported"),null;a=new Uint8Array(databuffer.buffer);null==e.byteOffset&&(e.byteOffset=0);g=e.byteOffset+(g.byteOffset||0);g=h.dataview.subarray(g,
g+a.length);a.set(g);if(f)for(f=1;f<databuffer.length;f+=p)databuffer[f]=1-databuffer[f];return databuffer},parseMaterial:function(p,a){var f=a.materials[p];if(!f)return console.warn("gltf material not found"),null;var g=RD.Materials[f.name];if(g)return g;g=new RD.Material;g.name=f.name;null!=f.alphaMode&&(g.alphaMode=f.alphaMode);g.alphaCutoff=null!=f.alphaCutoff?f.alphaCutoff:0.5;null!=f.doubleSided&&(g.flags.two_sided=f.doubleSided);f.pbrMetallicRoughness&&(g.model="pbrMetallicRoughness",g.color.set([1,
1,1]),g.opacity=1,g.metallicFactor=1,g.roughnessFactor=1,null!=f.pbrMetallicRoughness.baseColorFactor&&(g.color=f.pbrMetallicRoughness.baseColorFactor),f.pbrMetallicRoughness.baseColorTexture&&(g.textures.albedo=this.parseTexture(f.pbrMetallicRoughness.baseColorTexture,a)),null!=f.pbrMetallicRoughness.metallicFactor&&(g.metallicFactor=f.pbrMetallicRoughness.metallicFactor),null!=f.pbrMetallicRoughness.roughnessFactor&&(g.roughnessFactor=f.pbrMetallicRoughness.roughnessFactor),f.pbrMetallicRoughness.metallicRoughnessTexture&&
(g.textures.metallicRoughness=this.parseTexture(f.pbrMetallicRoughness.metallicRoughnessTexture,a)));f.occlusionTexture&&(g.textures.occlusion=this.parseTexture(f.occlusionTexture,a));f.normalTexture&&(g.textures.normal=this.parseTexture(f.normalTexture,a));f.emissiveTexture&&(g.textures.emissive=this.parseTexture(f.emissiveTexture,a));f.emissiveFactor&&(g.emissive=f.emissiveFactor);return RD.Materials[g.name]=g},parseTexture:function(p,a){var f=a.textures[p.index];if(!f)return console.warn("gltf texture not found"),
null;var g=a.images[f.source],e="",h=null;g.uri?(h=g.uri,h.split(".").pop()):(h=a.url.replace(/[\/\.\:]/gi,"_")+"_image_"+p.index,e=g.mimeType?g.mimeType.split("/").pop():"png",h+="."+e);if(gl.textures[h])return h;var q={};if(g.uri){var l=g.uri;if("data:"==l.substr(0,5)){var s=g.uri.indexOf(","),k=g.uri.substr(5,s),e=k.split("/").pop().toLowerCase(),h=a.folder+"/"+l+"image_"+p.index+"."+e,e=_base64ToArrayBuffer(g.uri.substr(s+1)),g=URL.createObjectURL(new Blob([e],{type:k})),g=GL.Texture.fromURL(g,
this.texture_options);g.name=h;gl.textures[h]=g}else q.filename=a.folder+"/"+l}else null!=g.bufferView&&(k=a.bufferViews[g.bufferView],null==k.byteOffset&&(k.byteOffset=0),e=a.buffers[k.buffer].data.slice(k.byteOffset,k.byteOffset+k.byteLength),g=URL.createObjectURL(new Blob([e],{type:g.mimeType})),g=GL.Texture.fromURL(g,this.texture_options),g.name=h,gl.textures[h]=g);q.texture=h;null!=f.sampler&&(f=a.samplers[f.sampler],null!=f.magFilter&&(q.magFilter=f.magFilter),null!=f.minFilter&&(q.minFilter=
f.minFilter));p.texCoord&&(q.uv_channel=p.texCoord);return q},parseSkin:function(p,a){var f=a.skins[p],g={};g.skeleton_root=a.nodes[f.skeleton].name;g.bindMatrices=this.splitBuffer(this.parseAccessor(f.inverseBindMatrices,a),16);g.joints=[];for(var e=0;e<f.joints.length;++e)g.joints.push(a.nodes[f.joints[e]].id);return g},splitBuffer:function(p,a){for(var f=p.length,g=[],e=0;e<f;e+=a)g.push(new p.constructor(p.subarray(e,e+a)));return g},parseAnimation:function(p,a,f){f=a.animations[p];var g=new RD.Animation;
g.name=f.name||"anim_"+p;for(var e=p=0;e<f.channels.length;++e){var h=new RD.Animation.Track,q=f.channels[e],l=f.samplers[q.sampler];h.target_node=a.nodes[q.target.node].name;h.target_property=q.target.path.toLowerCase();if(q=this.rename_animation_properties[h.target_property])h.target_property=q;var q=this.parseAccessor(l.input,a),s=this.parseAccessor(l.output,a),k=a.accessors[l.output].type,l=RD.TYPES[k];l==RD.VEC4&&"rotation"==h.target_property&&(l=RD.QUAT);h.type=l;var d=RD.TYPES_SIZE[l];if(d){for(var k=
s.length/d,m=new Float32Array((1+d)*k),b=0;b<k;++b){m[b*(1+d)]=q[b];var n=s.subarray(b,b+d);l==RD.QUAT&&quat.identity(n,n);m.set(n,b*(1+d)+1)}h.data=m;h.packed_data=!0;p=Math.max(p,q[q.length-1]);g.addTrack(h)}else console.warn("gltf unknown type:",k)}g.duration=p;return g},loadFromFiles:function(p,a){function f(d){var b=d.target.result,k=this.extension;if("gltf"==k)b=JSON.parse(b),g.main=this.filename;else if("glb"==k)g.main=this.filename;else if("bin"==k)q.push(this.filename);else if("jpeg"==k||
"jpg"==k||"png"==k)d=URL.createObjectURL(new Blob([b],{type:d.target.mimeType})),k=GL.Texture.fromURL(d,{wrap:gl.REPEAT,extension:k}),k.name=this.filename,gl.textures[k.name]=k;g[this.filename]={filename:this.filename,data:b,extension:this.extension};e--;0==e&&(g.binaries=q,h.load(g,function(b){a&&a(b)}))}for(var g={},e=p.length,h=this,q=[],l=0;l<p.length;++l){var s=p[l],k=new FileReader,d=s.name.split("."),d=d[d.length-1].toLowerCase();k.onload=f;k.filename=s.name;k.extension=d;"gltf"==d?k.readAsText(s):
k.readAsArrayBuffer(s)}}};function _base64ToArrayBuffer(p){p=window.atob(p);for(var a=p.length,f=new Uint8Array(a),g=0;g<a;g++)f[g]=p.charCodeAt(g);return f.buffer}
(function(p){function a(e){this.renderer=e;e.pipeline=this;this.mode=a.FORWARD;this.fbo=null;this.bgcolor=vec4.fromValues(0.1,0.1,0.1,1);this.environment_sh_coeffs=this.environment_texture=null;this.environment_rotation=180;this.quality=this.resolution_factor=this.exposure=this.environment_factor=1;this.use_rendertexture=this.test_visibility=!0;this.fx=null;this.global_uniforms={u_brdf_texture:0,u_exposure:this.exposure,u_SpecularEnvSampler_texture:1,u_skybox_mipCount:5,u_skybox_info:[this.environment_rotation,
this.environment_factor]};this.material_uniforms={u_albedo:vec3.fromValues(1,1,1),u_roughness:1,u_metalness:1,u_alpha:1,u_alpha_cutoff:0,u_tintColor:vec3.fromValues(1,1,1),u_normalFactor:1,u_metallicRough:!1,u_reflectance:0.1,u_maps_info:new Int8Array(8),u_clearCoat:0,u_clearCoatRoughness:0.5,u_isAnisotropic:!1,u_anisotropy:0.5,u_anisotropy_direction:vec3.fromValues(0,0,1)};this.sampler_uniforms={};this.fx_uniforms={u_viewportSize:vec2.create(),u_iViewportSize:vec2.create()};this.final_fbo=this.final_texture=
null;this.render_calls=[];this.num_render_calls=0}function f(){this.name="";this.id=-1;this.model=this.mesh=null;this.index_buffer_name="triangles";this.group_index=-1;this.node=this.material=null;this._render_priority=0}var g=p.RD;a.FORWARD=1;a.DEFERRED=2;a.maps="albedo metallicRoughness occlusion normal emissive opacity displacement".split(" ");a.prototype.render=function(e,f,g){this.fillGlobalUniforms();this.mode==a.FORWARD?this.renderForward(e,f,g):this.mode==a.DEFERRED&&this.renderDeferred(e,
f,g)};a.prototype.fillGlobalUniforms=function(){var a=this.getBRDFIntegratorTexture();a&&a.bind(0);this.environment_texture&&this.environment_texture.bind(1);this.environment_sh_coeffs?(this.global_uniforms.u_useDiffuseSH=!0,this.global_uniforms.u_sh_coeffs=this.environment_sh_coeffs):this.global_uniforms.u_useDiffuseSH=!1;this.global_uniforms.u_skybox_info[0]=this.environment_rotation*DEG2RAD;this.global_uniforms.u_skybox_info[1]=this.environment_factor;this.global_uniforms.u_exposure=this.exposure};
a.prototype.renderForward=function(e,f,g){g=Math.floor(gl.viewport_data[2]*this.resolution_factor);var l=Math.floor(gl.viewport_data[3]*this.resolution_factor);this.use_rendertexture&&(this.final_texture&&this.final_texture.width==g&&this.final_texture.height==l||(this.final_texture=new GL.Texture(g,l,{format:gl.RGBA,type:gl.HIGH_PRECISION_FORMAT}),this.final_fbo?this.final_fbo.setTextures([this.final_texture]):this.final_fbo=new GL.FBO([this.final_texture])),this.final_fbo.bind(0));gl.clearColor(this.bgcolor[0],
this.bgcolor[1],this.bgcolor[2],this.bgcolor[3]);gl.clear(gl.COLOR_BUFFER_BIT|gl.DEPTH_BUFFER_BIT);this.environment_texture&&this.renderSkybox(f);if(this.onRenderOpaque)this.onRenderOpaque(this,renderer,f);this.resetRenderCallsPool();for(g=0;g<e.length;++g)this.getNodeRenderCalls(e[g],f);e=this.render_calls.slice(0,this.num_render_calls);for(g=0;g<e.length;++g)e[g].computeRenderPriority(f._position);e=e.sort(a.rc_sort_function);for(g=0;g<e.length;++g)l=e[g],this.renderMeshWithMaterial(l.model,l.mesh,
l.material,l.index_buffer_name,l.group_index);if(this.onRenderAlpha)this.onRenderAlpha(this,this.renderer,f);if(this.onRenderGizmos)this.onRenderGizmos(this,this.renderer,f);this.use_rendertexture&&(this.final_fbo.unbind(0),gl.disable(GL.BLEND),gl.disable(GL.DEPTH_TEST),this.fx&&this.fx.applyFX(this.final_texture,this.final_texture),this.fx_uniforms.u_viewportSize[0]=this.final_texture.width,this.fx_uniforms.u_viewportSize[1]=this.final_texture.height,this.fx_uniforms.u_iViewportSize[0]=1/this.final_texture.width,
this.fx_uniforms.u_iViewportSize[1]=1/this.final_texture.height,this.final_texture.toViewport(gl.shaders.tonemapper,this.fx_uniforms))};a.prototype.getNodeRenderCalls=function(e,f){var p=null;if(e._mesh)p=e._mesh;else if(e.mesh&&(p=gl.meshes[e.mesh],!p))return;e.updateGlobalMatrix(!0);if(p){if(this.test_visibility){a.temp_bbox||(a.temp_bbox=BBox.create(),a.aabb_center=BBox.getCenter(a.temp_bbox),a.aabb_halfsize=BBox.getHalfsize(a.temp_bbox));BBox.transformMat4(a.temp_bbox,p.getBoundingBox(),e._global_matrix);
if(f.testBox(a.aabb_center,a.aabb_halfsize)==g.CLIP_OUTSIDE)return;e._last_rendered_frame=this.renderer.frame}if(e.primitives&&e.primitives.length)for(var l=0;l<e.primitives.length;++l){var s=g.Materials[e.primitives[l].material];if(s){var k=this.getRenderCallFromPool();k.material=s;k.model=e._global_matrix;k.mesh=p;k.group_index=l;k.node=e}}else e.material&&(s=g.Materials[e.material])&&(k=this.getRenderCallFromPool(),k.material=s,k.model=e._global_matrix,k.mesh=p,k.group_index=-1,k.node=e)}};a.rc_sort_function=
function(a,f){return f._render_priority-a._render_priority};a.prototype.renderMeshWithMaterial=function(e,f,g,l,p){var k=this.renderer,d=null,m=this.material_uniforms,b=this.sampler_uniforms;m.u_albedo=g.color.subarray(0,3);m.u_emissive=g.emissive;d=null;"pbrMetallicRoughness"==g.model&&this.quality?(d="pbr",m.u_metalness=g.metallicFactor,m.u_roughness=g.roughnessFactor,m.u_metallicRough=Boolean(g.textures.metallicRoughness)):d="nopbr";if(d=gl.shaders[this.overwrite_shader_name||d]){m.u_alpha=g.opacity;
m.u_alpha_cutoff=-1;for(var n=2,y=m.u_maps_info,t=0;t<a.maps.length;++t){var B=a.maps[t];y[t]=-1;var v=g.textures[B];if(v&&(v.constructor===Object&&(v=v.texture),v&&(B="u_"+B+"_texture",!d||d.samplers[B]))){var w=gl.textures[v];w||(k.autoload_assets&&-1!=v.indexOf(".")&&k.loadTexture(v,k.default_texture_settings),w=gl.textures.white);b[B]=w.bind(n++);y[t]=0}}k.enableItemFlags(g);"BLEND"==g.alphaMode?(gl.enable(gl.BLEND),g.additive?gl.blendFunc(gl.SRC_ALPHA,gl.ONE):gl.blendFunc(gl.SRC_ALPHA,gl.ONE_MINUS_SRC_ALPHA),
gl.depthMask(!1)):"MASK"==g.alphaMode?m.u_alpha_cutoff=g.alphaCutoff:gl.disable(gl.BLEND);k._uniforms.u_model.set(e);d.uniforms(k._uniforms);d.uniforms(this.global_uniforms);d.uniforms(m);d.uniforms(b);e=null;null!=p&&f.info&&f.info.groups&&f.info.groups[p]&&(e=f.info.groups[p]);e?d.drawRange(f,g.primitive,e.start,e.length,l):d.draw(f,g.primitive,l);k.disableItemFlags(g);gl.depthMask(!0)}};a.prototype.renderDeferred=function(a,f){};a.prototype.prepareBuffers=function(a){};a.prototype.renderToGBuffers=
function(a,f){};a.prototype.renderFinalPass=function(a,f){};a.prototype.applyPostFX=function(){};a.prototype.getRenderCallFromPool=function(){if(this.num_render_calls<this.render_calls.length){var a=this.render_calls[this.num_render_calls];this.num_render_calls++;return a}a=new g.RenderCall;a.id=this.num_render_calls;this.render_calls.push(a);this.num_render_calls++;return a};a.prototype.resetRenderCallsPool=function(){this.num_render_calls=0};a.prototype.renderSkybox=function(a){var f=gl.meshes.cube,
g=gl.shaders[this.overwrite_shader_name||"skybox"];if(g){gl.disable(gl.CULL_FACE);gl.disable(gl.DEPTH_TEST);var l=this.renderer._model_matrix;mat4.identity(l);mat4.translate(l,l,a.position);mat4.scale(l,l,[10,10,10]);this.renderer.setModelMatrix(l);g.uniforms(this.renderer._uniforms);g.uniforms({u_color_texture:this.environment_texture.bind(0),u_is_rgbe:!1,u_mipmap_offset:0,u_rotation:this.environment_rotation*DEG2RAD,u_camera_position:a.position});g.draw(f,GL.TRIANGLES)}};a.prototype.loadEnvironment=
function(a,f){var g=this;HDRE.load(a,function(a){g.environment_sh_coeffs=a.shs?a.shs:null;if(a=HDRE.toTexture(a))g.environment_texture=a;f&&f(a)})};a.prototype.captureEnvironment=function(a,f,g){g=g||256;this.capture_environment_texture||(this.capture_environment_texture=new GL.Texture(g,g,{format:gl.RGBA,type:GL.UNSIGNED_BYTE,minFilter:gl.LINEAR_MIPMAP_LINEAR,texture_type:GL.TEXTURE_CUBE_MAP}));var l=this.use_rendertexture;this.use_rendertexture=!1;this.renderer.renderToCubemap(this.capture_environment_texture,
a,f);this.use_rendertexture=l;this.capture_environment_texture.bind(0);gl.generateMipmap(this.capture_environment_texture.texture_type);this.environment_texture||(this.environment_texture=new GL.Texture(g,g,{format:gl.RGBA,type:GL.UNSIGNED_BYTE,minFilter:gl.LINEAR_MIPMAP_LINEAR,texture_type:GL.TEXTURE_CUBE_MAP}));this.capture_environment_texture.copyTo(this.environment_texture)};a.prototype.getBRDFIntegratorTexture=function(a){if(gl.textures.brdf_integrator)return gl.textures.brdf_integrator;var f=
gl.textures.brdf_integrator=new GL.Texture(128,128,{type:gl.FLOAT,texture_type:gl.TEXTURE_2D,filter:gl.LINEAR});if(a)return fetch(a).then(function(a){return a.arrayBuffer()}).then(function(a){f.uploadData(new Float32Array(a),{no_flip:!0})}),f;var g=gl.shaders.brdf_integrator;if(g){var l=gl.textures.hammersley_sample_texture;l||(l=this.createHammersleySampleTexture());f.drawTo(function(a){l&&l.bind(0);g.uniforms({u_hammersley_sample_texture:0}).draw(GL.Mesh.getScreenQuad(),gl.TRIANGLES);l&&l.unbind()});
return f}};a.prototype.createHammersleySampleTexture=function(a){a=a||8192;for(var f=3*a,g=new Float32Array(f),l=0;l<f;l+=3){var p=2*Math.radical_inverse(l)*Math.PI;g[l]=Math.cos(p);g[l+1]=Math.sin(p);g[l+2]=0}a=new GL.Texture(a,1,{pixel_data:g,type:GL.FLOAT,format:GL.RGB});return gl.textures.hammersley_sample_texture=a};Math.radical_inverse=function(a){for(var f=0,g=0.5;a;g*=0.5,a>>=1)a&1&&(f+=g);return f};f.prototype.computeRenderPriority=function(a){this.name=this.node.name;var f=this.mesh.getBoundingBox();
f&&(this._render_priority=0.001*vec3.distance(a,f),"BLEND"==this.material.alphaMode&&(this._render_priority-=100))};g.PBRPipeline=a;g.RenderCall=f})(this);
(function(p){function a(){this.intensity=1;this._color=vec3.fromValues(0.9,0.9,0.9);this._position=vec3.fromValues(10,20,5);this._target=vec3.create();this._vector=vec3.create();this.camera=new RD.Camera;this._castShadows=!1;this.shadowmap={texture:null,resolution:2048,bias:5E-6,uniforms:{u_shadowmap_matrix:this.camera._viewprojection_matrix,u_shadowmap_texture:4,u_shadowbias:1E-5}};this.uniforms={u_light_position:this._position,u_light_color:vec3.create(),u_light_vector:this._vector};this.flags=
{skip_shadows:!1}}Object.defineProperty(a.prototype,"color",{set:function(a){this._color.set(a)},get:function(){return this._color},enumerable:!0});Object.defineProperty(a.prototype,"castShadows",{set:function(a){a?this.enableShadows():this.disableShadows()},get:function(){return this._castShadows},enumerable:!0});a.DEFAULT_SHADOWMAP_RESOLUTION=2048;a.prototype.updateData=function(){vec3.sub(this._vector,this._target,this._position);vec3.normalize(this._vector,this._vector)};a.prototype.setUniforms=
function(a){this.shadowmap.uniforms.u_shadowbias=this.shadowmap.bias;this.uniforms.u_light_color.set(this._color);vec3.scale(this.uniforms.u_light_color,this.uniforms.u_light_color,this.intensity);a.uniforms(this.uniforms);a.uniforms(this.shadowmap.uniforms);this._castShadows&&this.shadowmap.texture.bind(this.shadowmap.uniforms.u_shadowmap_texture)};a.prototype.lookAt=function(a,g,e){this._position.set(a);this._target.set(g);this.camera.lookAt(a,g,e);this.updateData()};a.prototype.setView=function(a,
g,e){this.camera.orthographic(a,g,e,1);this.updateData()};a.prototype.followCamera=function(a,g){var e=g||5,h=vec3.scaleAndAdd(vec3.create(),a.target,this._vector,-g);this.lookAt(h,a.target,a.up);this.camera.orthographic(e,0.01,3*e,1);this.camera.updateMatrices()};a.prototype.enableShadows=function(){this._castShadows=!0;var f=this.shadowmap.resolution||a.DEFAULT_SHADOWMAP_RESOLUTION;this.shadowmap.texture&&this.shadowmap.texture.width==f||(this.shadowmap.texture=new GL.Texture(f,f,{format:gl.DEPTH_COMPONENT,
type:gl.UNSIGNED_INT,filter:gl.NEAREST}),this.shadowmap.fbo=new GL.FBO(null,this.shadowmap.texture))};a.prototype.disableShadows=function(){this._castShadows=!1;this.shadowmap.texture=null;this.shadowmap.fbo=null};a.prototype.generateShadowmap=function(a,g,e){if(this.castShadows){if(!this.shadowmap.fbo)throw"no shadowmap fbo";a.generating_shadowmap=!0;this.shadowmap.fbo.bind();gl.clear(gl.DEPTH_BUFFER_BIT);a.shader_overwrite="flat";if(g.constructor===Array)for(var h=0;h<g.length;++h)a.render(g[h],
this.camera,null,e||255);else a.render(g,this.camera,null,e||255);a.shader_overwrite=null;this.shadowmap.fbo.unbind();a.generating_shadowmap=!1;this.shadowmap.texture.bind(4)}};a.prototype.renderNode=function(a,g){gl.meshes.cylinder_light||(gl.meshes.cylinder_light=GL.Mesh.cylinder({radius:0.02,height:1}),gl.meshes.cone_light=GL.Mesh.cone({radius:0.1,height:0.25}))};RD.Light=a})(this);
(function(p){function a(){this.name="";this.tracks=[];this.duration=2}function f(){this.target_property=this.target_node="";this.type=l.SCALAR;this.data=[];this.packed_data=!1}function g(a,d,e){return a*(1-e)+d*e}function e(){this.bones=[];this.global_bone_matrices=[];this.bones_by_name=new Map}function h(){this.name="";this.model=mat4.create();this.parent=-1;this.num_children=this.layer=0;this.children=new Int8Array(16)}function q(){this.skeleton=new e;this.num_keyframes=this.num_animated_bones=
this.samples_per_second=this.duration=0;this.bones_map=new Uint8Array(64);this.keyframes=null}var l=p.RD;l.Animations={};a.prototype.addTrack=function(a){this.tracks.push(a)};a.prototype.applyAnimation=function(a,d,e){for(var b=0;b<this.tracks.length;++b)this.tracks[b].applyTrack(a,d,e)};l.Animation=a;a.Track=f;f.prototype.addKeyframe=function(a,d,e){1<l.TYPES_SIZE[this.type]&&(d=new Float32Array(d));for(var b=0;b<this.data.length;++b)if(!(this.data[b][0]<a))return this.data[b][0]!=a||e?this.data.splice(b,
0,[a,d]):this.data[b][1]=d,b;this.data.push([a,d]);return this.data.length-1};f.prototype.getKeyframe=function(a){if(0>a||a>=this.data.length)return console.warn("keyframe index out of bounds"),null;var d=l.TYPES_SIZE[this.type];return this.packed_data?(a*=1+d,a>this.data.length-d?null:[this.data[a],this.data.subarray(a+1,a+d+1)]):this.data[a]};f.prototype.findTimeIndex=function(a){var d=this.data;if(!d||0==d.length)return-1;var e=l.TYPES_SIZE[this.type];if(this.packed_data){var e=e+1,b=d.length/
e,f=0,g=0,h=b;if(0==b)return-1;if(1==b)return 0;if(d[(h-1)*e]<a)return h-1;for(;h>=f;){g=0.5*(h+f)|0;b=d[g*e];if(b==a)break;if(f==h-1)return f;b<a?f=g:h=g}return g}b=d.length;g=f=0;h=b;if(0==b)return-1;if(1==b)return 0;if(d[h-1][0]<a)return h-1;for(;h>=f;){g=0.5*(h+f)|0;b=d[g][0];if(b==a)break;if(f==h-1)return f;b<a?f=g:h=g}return g};f.prototype.getSample=function(a,d,e){return this.data&&0!==this.data.length?this.packed_data?this.getSamplePacked(a,d,e):this.getSampleUnpacked(a,d,e):void 0};f.prototype.getSampleUnpacked=
function(a,d,e){var b=l.TYPES_SIZE[this.type];a=Math.clamp(a,0,this.data[this.data.length-1][0]);var f=this.findTimeIndex(a);-1===f&&(f=0);var g=f,h=f+1,p=this.data,b=l.TYPES_SIZE[this.type];if(!d||1==p.length||h==p.length||0==g&&this.data[0][0]>a)return this.data[f][1];g=p[g];h=p[h];a=(h[0]-a)/(h[0]-g[0]);1<b&&(e=e||this._result,e&&e.length==b||(e=this._result=new Float32Array(b)));if(d===l.LINEAR)return 1==b?g[1]*a+h[1]*(1-a):l.interpolateLinear(g[1],h[1],a,e,this.type,b,this);if(d===l.CUBIC){d=
0<f?p[f-1]:g;f=f<p.length-2?p[f+2]:h;if(1===b)return l.EvaluateHermiteSpline(g[1],h[1],d[1],f[1],1-a);e=l.EvaluateHermiteSplineVector(g[1],h[1],d[1],f[1],1-a,e);this.type==l.QUAT?(quat.slerp(e,h[1],g[1],a),quat.normalize(e,e)):this.type==l.TRANS10&&(b=e.subarray(3,7),g=g[1].subarray(3,7),h=h[1].subarray(3,7),quat.slerp(b,h,g,a),quat.normalize(b,b));return e}return null};f.prototype.getSamplePacked=function(a,d,e){if(!this.data.length)return null;var b=l.TYPES_SIZE[this.type];a=Math.clamp(a,0,this.data[this.data.length-
b-1]);var f=this.findTimeIndex(a);-1==f&&(f=0);var g=b+1,h=f,p=f+1,q=this.data,s=q.length/g;if(!d||1==s||p==s||0==h&&this.data[0]>a)return this.getKeyframe(f)[1];1<b&&(e=e||this._result,e&&e.length==b||(e=this._result=new Float32Array(b)));var u=q.subarray(h*g,(h+1)*g),h=q.subarray(p*g,(p+1)*g);a=(h[0]-a)/(h[0]-u[0]);if(d===l.LINEAR){if(1==b)return u[1]*a+h[1]*(1-a);g=u.subarray(1,b+1);h=h.subarray(1,b+1);return l.interpolateLinear(g,h,a,e,this.type,b,this)}if(d===l.CUBIC){if(0===b)return u[1];d=
0<f?q.subarray((f-1)*g,f*g):u;p=p<s-1?q.subarray((p+1)*g,(p+2)*g):h;if(1===b)return l.EvaluateHermiteSpline(u[1],h[1],d[1],p[1],1-a);b=u.subarray(1,g);h=h.subarray(1,g);e=l.EvaluateHermiteSplineVector(b,h,d.subarray(1,g),p.subarray(1,g),1-a,e);this.type==l.QUAT?(quat.slerp(e,h,b,a),quat.normalize(e,e)):this.type==l.TRANS10&&(g=e.subarray(3,7),b=b.subarray(3,7),h=h.subarray(3,7),quat.slerp(g,h,b,a),quat.normalize(g,g));return e}return null};f.prototype.applyTrack=function(a,d,e){d=this.getSample(d,
e);e=null;(e=a.name==this.target_node?a:a.findNodeByName(this.target_node))&&(e[this.target_property]=d);return d};l.interpolateLinear=function(a,d,e,b,f,g,h){if(1==g)return a*e+d*(1-e);b=b||h._result;b&&b.length==g||(b=h._result=new Float32Array(g));switch(f){case l.QUAT:quat.slerp(b,d,a,e);quat.normalize(b,b);break;case l.TRANS10:for(f=0;3>f;f++)b[f]=a[f]*e+d[f]*(1-e);for(f=7;10>f;f++)b[f]=a[f]*e+d[f]*(1-e);a=a.subarray(3,7);d=d.subarray(3,7);g=b.subarray(3,7);quat.slerp(g,d,a,e);quat.normalize(g,
g);break;default:for(f=0;f<g;f++)b[f]=a[f]*e+d[f]*(1-e)}return b};l.EvaluateHermiteSpline=function(a,d,e,b,f){var g=f*f,h=g*f;return(2*h-3*g+1)*a+(-2*h+3*g)*d+(h-2*g+f)*(d-e)+(h-g)*(b-a)};l.EvaluateHermiteSplineVector=function(a,d,e,b,f,g){g=g||new Float32Array(g.length);var h=f*f,l=h*f,p=2*l-3*h+1,q=-2*l+3*h;f=l-2*h+f;for(var h=l-h,l=0,s=g.length;l<s;++l)g[l]=p*a[l]+q*d[l]+f*(d[l]-e[l])+h*(b[l]-a[l]);return g};Math.lerp||(Math.lerp=g);l.Skeleton=e;h.prototype.serialize=function(){return{name:this.name,
model:typedArrayToArray(this.model),parent:this.parent,layer:this.layer,children:this.num_children?typedArrayToArray(this.children.subarray(0,this.num_children)):null}};h.prototype.configure=function(a){this.name=a.name;this.model.set(a.model);this.parent=a.parent;this.layer=a.layer;this.num_children=0;a.children&&(this.children.set(a.children),this.num_children=a.children.constructor===Array?a.children.length:a.num_children)};h.prototype.copyFrom=h.prototype.configure;e.Bone=h;e.prototype.applyTransformToBones=
function(a,d){var e=this.getBone(a);e&&mat4.multiply(e.model,e.model,d)};e.prototype.getBone=function(a){return this.bones[this.bones_by_name.get(a)]};e.identity=mat4.create();e.prototype.getBoneMatrix=function(a,d){void 0===d&&(d=!0);var f=this.bones_by_name.get(a);return void 0===f?e.identity:d?this.bones[f].model:this.global_bone_matrices[f]};e.temp_mat4=mat4.create();e.temp_mat43=e.temp_mat4.subarray(0,12);e.prototype.computeFinalBoneMatrices=function(a,d,f){if(!this.bones.length||!d||!d.bones)return a||
[];this.updateGlobalMatrices();var b=f?12*d.bones.length:16*d.bones.length;a&&a.length==b||(a=new Float32Array(b));if(f){var g=e.temp_mat4,g=e.temp_mat43;for(f=0;f<d.bones.length;++f)b=d.bones[f],mat4.multiply(temp_mat4,this.getBoneMatrix(b[0],!1),b[1]),mat4.transpose(temp_mat4,temp_mat4),a.set(g,12*f)}else for(f=0;f<d.bones.length;++f)b=d.bones[f],g=a.subarray(16*f,16*f+16),mat4.multiply(g,this.getBoneMatrix(b[0],!1),b[1]);return a};e.prototype.computeFinalBoneMatricesAsArray=function(a,d,e){if(!this.bones.length||
!d||!d.bones)return a||[];this.updateGlobalMatrices();a=a||[];a.length=d.bones.length;for(var b=0;b<d.bones.length;++b){var f=d.bones[b];a[b]||(a[b]=mat4.create());var g=a[b];mat4.multiply(g,this.getBoneMatrix(f[0],!1),f[1]);d.bind_matrix&&mat4.multiply(g,g,d.bind_matrix);e&&mat4.multiply(g,e,g)}return a};e.prototype.updateGlobalMatrices=function(){var a=this.bones;if(a.length){var d=this.bones.length;this.global_bone_matrices[0].set(a[0].model);for(var e=1;e<d;++e){var b=a[e];mat4.multiply(this.global_bone_matrices[e],
this.global_bone_matrices[b.parent],b.model)}}};e.prototype.assignLayer=function(a,d){};e.prototype.getVertices=function(){if(!this.bones.length)return null;var a=6*(this.bones.length-1);this._vertices&&this._vertices.length==a||(this._vertices=new Float32Array(a));for(var a=this._vertices,d=0;d<this.bones.length-1;++d){var e=this.global_bone_matrices[this.bones[d+1].parent],b=this.global_bone_matrices[d+1],f=a.subarray(6*d,6*d+3),g=a.subarray(6*d+3,6*d+6);mat4.getTranslation(f,b);mat4.getTranslation(g,
e)}return a};e.prototype.resizeBones=function(a){if(this.bones.length!=a)if(this.bones.length>a)this.bones.length=a,this.global_bone_matrices.length=a;else{var d=this.bones.length;for(this.bones.length=a;d<a;++d)this.bones[d]=new h,this.global_bone_matrices[d]=mat4.create()}};e.prototype.copyFrom=function(a){this.resizeBones(a.bones.length);for(var d=0;d<a.bones.length;++d)this.bones[d].copyFrom(a.bones[d]),this.global_bone_matrices[d].set(a.global_bone_matrices[d]);this.bones_by_name=new Map(a.bones_by_name)};
e.prototype.serialize=function(){for(var a={bones:[],bone_names:{}},d=0;d<this.bones.length;++d)a.bones.push(this.bones[d].serialize());return a};e.prototype.configure=function(a){this.resizeBones(a.bones.length);a.bones_by_name?this.bones_by_name=new Map(a.bones_by_name):this.bones_by_name.clear();for(var d=0;d<a.bones.length;++d)this.bones[d].copyFrom(a.bones[d]),a.global_bone_matrices?this.global_bone_matrices[d].set(a.global_bone_matrices[d]):this.bones_by_name[this.bones[d].name]=d};var s=vec3.create();
e.blend=function(a,d,f,b,g,h){if(a.bones.length!=d.bones.length)console.error("skeleton must contain the same number of bones");else{f=Math.clamp(f,0,1);if(255==g){if(0==f){if(b==a)return;b.copyFrom(a);return}if(1==f){b.copyFrom(d);return}}if(b!=a){b.bones.length=a.bones.length;for(g=0;g<b.bones.length;++g)(d=b.bones[g])||(d=new e.Bone),d.copyFrom(a.bones[g]);b.bones_by_name=new Map(a.bones_by_name)}for(g=0;g<b.bones.length;++g){for(var l=b.bones[g],p=a.bones[g],q=d.bones[g],w=0;16>w;++w)l.model[w]=
Math.lerp(p.model[w],q.model[w],f);if(!h)for(l=l.model,w=0;3>w;++w)s[0]=l[0+w],s[1]=l[4+w],s[2]=l[8+w],vec3.normalize(s,s),l[0+w]=s[0],l[4+w]=s[1],l[8+w]=s[2]}}};e.shader_code="\n\tattribute vec4 a_bone_indices;\n\tattribute vec4 a_weights;\n\tuniform mat4 u_bones[64];\n\tvoid computeSkinning(inout vec3 vertex, inout vec3 normal)\n\t{\n\t\tvec4 v = vec4(vertex,1.0);\n\t\tvertex = (u_bones[int(a_bone_indices.x)] * a_weights.x * v + \n\t\t\t\tu_bones[int(a_bone_indices.y)] * a_weights.y * v + \n\t\t\t\tu_bones[int(a_bone_indices.z)] * a_weights.z * v + \n\t\t\t\tu_bones[int(a_bone_indices.w)] * a_weights.w * v).xyz;\n\t\tvec4 N = vec4(normal,0.0);\n\t\tnormal =\t(u_bones[int(a_bone_indices.x)] * a_weights.x * N + \n\t\t\t\tu_bones[int(a_bone_indices.y)] * a_weights.y * N + \n\t\t\t\tu_bones[int(a_bone_indices.z)] * a_weights.z * N + \n\t\t\t\tu_bones[int(a_bone_indices.w)] * a_weights.w * N).xyz;\n\t\tnormal = normalize(normal);\n\t}\n";
l.SkeletalAnimation=q;q.prototype.load=function(a,d){var e=this;return HttpRequest(a,null,function(a){e.fromData(a);d&&d(e)})};q.prototype.assignTime=function(a,d,e,b){if(this.duration){d||void 0===d?(a%=this.duration,0>a&&(a=this.duration+a)):a=Math.clamp(a,0,this.duration-1/this.samples_per_second);void 0===e&&(e=!0);a*=this.samples_per_second;var f=Math.floor(a),h=(f+1)%this.num_keyframes,f=f%this.num_keyframes;a-=Math.floor(a);d=this.num_animated_bones;b=16*d;for(var f=f*b,h=h*b,l=this.skeleton,
p=this.keyframes,q=this.bones_map,s=0;s<d;++s){var u=l.bones[q[s]];b=16*s;if(e)for(var z=0;16>z;++z)u.model[z]=g(p[f+b+z],p[h+b+z],a);else u.model.set(p.subarray(f+b,f+b+16))}}};q.prototype.resize=function(a,d){this.num_keyframes=a;this.num_animated_bones=d;this.keyframes=new Float32Array(a*d*16)};q.prototype.fromData=function(a){a=a.split("\n");var d=a[0].split(",");this.duration=Number(d[0]);this.samples_per_second=Number(d[1]);this.num_keyframes=Number(d[2]);this.skeleton.resizeBones(Number(d[3]));
for(var d=0,e=1;e<a.length;++e){var b=a[e],f=b[0],b=b.substr(1).split(",");if("B"==f){var g=Number(b[0]),h=this.skeleton.bones[g];h.name=b[1];h.parent=Number(b[2]);for(f=0;16>f;++f)h.model[f]=Number(b[3+f]);-1!=h.parent&&(b=this.skeleton.bones[h.parent],16<=b.num_children?console.warn("too many child bones, max is 16"):b.children[b.num_children++]=g);this.skeleton.bones_by_name.set(h.name,g)}else if("@"==f){this.num_animated_bones=Number(b[0]);for(f=0;f<this.num_animated_bones;++f)this.bones_map[f]=
Number(b[f+1]);this.resize(this.num_keyframes,this.num_animated_bones)}else if("K"==f){g=d*this.num_animated_bones*16;f=0;for(h=16*this.num_animated_bones;f<h;++f)this.keyframes[g+f]=Number(b[f+1]);d++}else break}this.assignTime(0,!1,!1)};q.prototype.toData=function(){console.error("no toData in Skeletal Animation");return""}})("undefined"!=typeof window?window:"undefined"!=typeof self?self:global);
